static const char file_id[] = "BDFSelect.pl";
// .cc file generated from BDFSelect.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "BDFSelect.h"

const char *star_nm_BDFSelect = "BDFSelect";

const char* BDFSelect :: className() const {return star_nm_BDFSelect;}

ISA_FUNC(BDFSelect,BDFStar);

Block* BDFSelect :: makeNew() const { LOG_NEW; return new BDFSelect;}

BDFSelect::BDFSelect ()
{
	setDescriptor("If the value on the \"control\" line is nonzero, N particles (from the\nparameter N) from \"trueInput\" are copied to the output; otherwise, \nN particles from \"falseInput\" are copied to the output.");
	addState(N.setState("N",this,"1","Number of data particles to move per execution"));
	addPort(trueInput.setPort("trueInput",this,ANYTYPE));
	addPort(falseInput.setPort("falseInput",this,ANYTYPE));
	falseInput.inheritTypeFrom(trueInput);
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(trueInput);


}

void BDFSelect::setup() {
# line 41 "BDFSelect.pl"
int n = N;
		trueInput.setBDFParams(n,control,BDF_TRUE,n-1);
		falseInput.setBDFParams(n,control,BDF_FALSE,n-1);
		output.setBDFParams(n,0,BDF_NONE,n-1);
}

void BDFSelect::go() {
# line 47 "BDFSelect.pl"
// read control value, and route input to output
		// depending on it.
		PortHole& input = *(int(control%0) ? &trueInput : &falseInput);
		for (int i = int(N)-1; i >= 0; i--)
			output%i = input%i;
}

// prototype instance for known block list
static BDFSelect proto;
static RegisterBlock registerBlock(proto,"Select");
