static const char file_id[] = "BDFSwitch.pl";
// .cc file generated from BDFSwitch.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "BDFSwitch.h"

const char *star_nm_BDFSwitch = "BDFSwitch";

const char* BDFSwitch :: className() const {return star_nm_BDFSwitch;}

ISA_FUNC(BDFSwitch,BDFStar);

Block* BDFSwitch :: makeNew() const { LOG_NEW; return new BDFSwitch;}

BDFSwitch::BDFSwitch ()
{
	setDescriptor("Switch input particles to one of two outputs, depending on\nthe value of the control input.  The parameter N gives the\nnumber of particles read in one firing.  If the particle read\nfrom the control input is TRUE, then the values are written\nto \"trueOutput\"; otherwise they are written to \"falseOutput\".");
	addState(N.setState("N",this,"1","Number of data particles to move per execution"));
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(trueOutput.setPort("trueOutput",this,ANYTYPE));
	trueOutput.inheritTypeFrom(input);
	addPort(falseOutput.setPort("falseOutput",this,ANYTYPE));
	falseOutput.inheritTypeFrom(input);


}

void BDFSwitch::setup() {
# line 43 "BDFSwitch.pl"
int n = N;
		input.setBDFParams(n, 0, BDF_NONE, n-1);
		trueOutput.setBDFParams(n, control, BDF_TRUE, n-1);
		falseOutput.setBDFParams(n, control, BDF_FALSE, n-1);
}

void BDFSwitch::go() {
# line 49 "BDFSwitch.pl"
// read control value, and route input
		// to output depending on it.
		PortHole& out = *(int(control%0) ? &trueOutput : &falseOutput);
		for (int i = int(N)-1; i >= 0; i--)
			out%i = input%i;
}

// prototype instance for known block list
static BDFSwitch proto;
static RegisterBlock registerBlock(proto,"Switch");
