.EQ
delim off
.EN
.\" documentation file generated from AnyCGPeekPoke.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "PeekPoke"
.SD
Nondeterminate communication link, splices in a peek/poke pair
.SE
.LO "CG Star Directory"
.DM AnyCG AnyCGStar
.SV 1.6 "2/22/96"
.AL "Jose Luis Pino"
.IH
.NE
\fIinput\fR (ANYTYPE)
.PE
.OH
.NE
\fIoutput\fR (ANYTYPE)
.PE
.SH
.NE
\fIPoke_procId\fR (IntState): assigned processor id for poke - must be manually assigned.
.DF "1"
.NE
\fIblockSize\fR (IntState): number of tokens to be transfered per firing.
.DF "1"
.NE
\fIupdateRate\fR (IntState): Update the link at most every 'updateRate' schedule iterations.
.DF "1"
.ET
.EQ
delim $$
.EN
.LD
This star allows for peek/poke communications as was described in, currently
this is only supported in multitargets.
.pp
J.L. Pino, T.M. Parks and E.A. Lee, "Mapping Multiple Independent Synchronous
Dataflow Graphs onto Heterogeneous Multiprocessors," \fIProc. of IEEE Asilomar
Conf. on Signals, Systems, and Computers\fR, Pacific Grove, CA,
Oct. 31 - Nov. 2, 1994.
<http://ptolemy.eecs.berkeley.edu/papers/hierStaticSched-asilomar-95>
.pp
The peek/poke facilities implement only a limited part of the
functionality described in the Asilomar paper.
.pp
The first two user settable states are the \fIPoke_procId\fR and
\fIPeek_procId\fR.  These must be set to the processor id where the poke
actor and peek actor are to be mapped to.
.pp
The next user settable state is \fIblockSize\fR.  With this state a
peek/poke link can transfer \fIblockSize\fR number of consequtive
samples.
.pp
The final user settable state is \fIupdateRate\fR.  This state can be
considered as a nondeterminate downsample factor for the link.
The link will be updated at most once every \fIupdateRate\fR number of
iterations of one of the two disconnected SDF graphs.  The side which
this effects is determined by the specific peek/poke implementation.
.ES
