.EQ
delim off
.EN
.\" documentation file generated from CG56Chop.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, an disclaimer of warranty provisions.
.NA "Chop"
.SD
On each execution, this star reads a block of "nread" particles
and writes them to the output with the given offset.  The number of
particles written is given by "nwrite".  The output block contains
all or part of the input block, depending on "offset" and "nwrite".
The "offset" specifies where in the output block the first (oldest)
particle in the input block will lie.  If "offset" is positive,
then the first "offset" output particles will be either particles
consumed on previous firings (if "use_past_inputs" parameter is YES),
or zero (otherwise).  If "offset" is negative, then the first "offset"
input particles will be discarded.
.SE
.LO "CG56 main library"
.DM CG56 CG56Star
.SV 1.4 "3/10/96"
.AL "Luis Javier Gutierrez and Edward A. Lee"
.IH
.NE
\fIinput\fR (ANYTYPE)
.PE
.OH
.NE
\fIoutput\fR (ANYTYPE)
.PE
.SH
.NE
\fInread\fR (IntState): Number of particles read.
.DF "128"
.NE
\fInwrite\fR (IntState): Number of particles written.
.DF "64"
.NE
\fIoffset\fR (IntState): start output block relative to start of input block.
.DF "0"
.NE
\fIuse_past_inputs\fR (IntState): if offset > 0, specify whether to use previously read inputs
(otherwise use zeros).
.DF "YES"
.NE
\fIpast_inputs\fR (IntArrayState): internal state
.DF "0"
.ET
.EQ
delim $$
.EN
.LD
See the explanation of the SDFChop star.
.ES
