.EQ
delim off
.EN
.\" documentation file generated from CG56DivByInt.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "DivByInt"
.SD
This is an amplifier.  The integer output is the integer input
divided by the integer "divisor".
.SE
.LO "CG56 main library"
.DM CG56 CG56Star
.SV 1.4 "4/8/96"
.AL "Brian L. Evans"
.IH
.NE
\fIinput\fR (int)
.PE
.OH
.NE
\fIoutput\fR (int)
.PE
.SH
.NE
\fIdivisor\fR (IntState): Inverse of the gain of the amplifier.
.DF "2"
.NE
\fIgain\fR (FixState): Inverse of the gain of the amplifier.
.DF "0.5"
.ET
.EQ
delim $$
.EN
.LD
This star computes the inverse of the \fIdivisor\fR state as a fixed-point
number and then generates code that uses integer-fix multiplication
to compute the dividend.  For values of \fIdivisor\fR greater than 10,
additional code is generated to ensure that the integer division is correct.
.pp
There is no easy way to implement integer division on the Motorola 56000.
If we used fixed-point division, then the execution time would explode.
Even integer division by two cannot be implemented as an arithmetic
shift right (asr) because in that case, -1 divided by 2 would still be -1.
.ES
