.EQ
delim off
.EN
.\" documentation file generated from CG56HostASrc.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "HostASrc"
.SD
Asynchronous source.
.SE
.LO "CG56 library"
.DM CG56 CG56Star
.SV 1.11 "1/1/96"
.AL "Kennard White"
.OH
.NE
\fIoutput\fR (FIX)
.PE
.SH
.NE
\fIlabel\fR (StringState): Label for widget on host.
.DF "Label"
.NE
\fIvalue\fR (FixState): Value to output.
.DF "0"
.ET
.EQ
delim $$
.EN
.LD
This is a source star (like the
.c Const
star).
The value(s) output by the star may be changed asynchronously by
the host via the host port.
This is intended as a base star for derivation; a derived star would provide
some host-specific interface to this star.
The \fIlabel\fR parameter is not directly used by the star; it is for the
convenience of derived stars.
.UH IMPLEMENTATION
.pp
Since we may be followed by an up sampling operation, there may be
an arbitrary number of memory locations corresponding to our output.
Since we cannot expect the host to update all of these values, we
cannot apply the trick used by the
.c Const
star to eliminate runtime code in all cases.
More work must be done to identify the safe cases.
.PP
On each firing of the star, the \fIvalue\fR state is output.
The host may modify the \fIvalue\fR state asynchronously.
Currently, the value state is referenced by explicit memory location; however,
we might want to generate a symbolic name.
Currently, only scalars may be output (not waveforms).
This should be improved.
.SA
CG56HostSlider and
CG56HostButton.
.ES
