.EQ
delim off
.EN
.\" documentation file generated from CG56LMSRx.pl by ptlang
.\" Copyright (c) 1991-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "LMSRx"
.SD
Complex LMS filter.
.SE
.LO "CG56 library"
.DM CG56 CG56Star
.SV 1.11 "3/7/96"
.AL "Kennard White (ported from Gabriel)"
.AC "Gabriel version by Steve How and Maureen O'Reilly"
.IH
.NE
\fIinput_r\fR (FIX)
.NE
\fIinput_i\fR (FIX)
.NE
\fIerror_r\fR (FIX)
.NE
\fIerror_i\fR (FIX)
.PE
.OH
.NE
\fIoutput_r\fR (FIX)
.NE
\fIoutput_i\fR (FIX)
.PE
.SH
.NE
\fIinit_taps_r\fR (FixArrayState)

.NE
\fIinit_taps_i\fR (FixArrayState)

.NE
\fInumTaps\fR (IntState)
.DF "0"
.NE
\fIstep_size\fR (FixState)
.DF "0.01"
.NE
\fIerror_delay\fR (IntState)
.DF "1"
.NE
\fIdecimation\fR (IntState)
.DF "1"
.NE
\fIfooPhase\fR (IntState): "I wish I knew."
.DF "0"
.NE
\fIlast_tap_min\fR (FixState)
.DF "0.0"
.NE
\fIcoef_table\fR (FixArrayState)
.DF "0.0"
.NE
\fIdelay_line\fR (FixArrayState)
.DF "0.0"
.NE
\fIdelayPtr\fR (IntState)
.DF "0"
.ET
.EQ
delim $$
.EN
.LD
For this complex LMS filter star,
the number of initial coefficients specify the order.
.EQ
y = c' * x
c[n+1] = c[n] + (step_size)(x)(e')
.EN
where $x$ = input, $c$ = coefficients, $y$ = output, $e$ = error
(desired output - actual output), and ' represents the complex conjugate.
Default \fIstep_size\fR is 0.01
The parameter \fIerror_delay\fR must specify the total delay between
the filter output and the error input, and
\fIlast_tap_min\fR constrains the minimum magnitude of both
the real and imaginary parts of the last tap.
Default coefficients give a 7th-order filter, with the middle real
tap equal to 0.5 and all other taps zero.
.ES
