.EQ
delim off
.EN
.\" documentation file generated from CG56SSISkew.pl by ptlang
.\" Copyright (c) 1991-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "SSISkew"
.SD
Interface to the 56001 SSI's port with timing-skew capability.
.SE
.LO "CG56 library"
.DM CG56 CG56SSI
.SV 1.8 "3/7/96"
.AL "Kennard White"
.IH
.NE
\fIerror\fR (FIX)
.PE
.SH
.NE
\fIinternalAccum\fR (IntState): "Boolean: internal or external accumulator."
.DF "YES"
.NE
\fIaccum\fR (FixState): Accumulation of error skew.
.DF "0.5"
.ET
.EQ
delim $$
.EN
.LD
This derived star adds an additional \fIerror\fR input used to control
the skew.
The error value is added to an internal accumulator.

When the accumulator underfows 0.0, we conceptually slow down the timing clock.
The output (recv) sample will be a repeat, and the input (xmit) sample will
be dropped.
This is implemented by not adjusting the internal queue pointers.

When the accumulator overflow 0.0, we conceptually speed up the timing clock.
The current output (recv) sample will be skipped and the next sample
will be returned.
The input (xmit) sample will be transmitted twice.
This is implemented by accessing the queues twice.

Note: the timing clock discussed above is with reference to the recv signal.
More sophisticated applications will probably want to control skewing
of input and output independently; this would require the SSI star to
be operating in dual-buffer mode.

When the parameter \fIinternalAccum\fR is false, it is assumed that
the \fIerror input\fR is the output from an
.c SSISkew
star.
A positive value is treated as an overflow, and a negative value is treated
an underflow.
.SA
SSI.
.ES
