.EQ
delim off
.EN
.\" documentation file generated from CG56WaveForm.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "WaveForm"
.SD
A value of values is repeated at the output with period period, zero-padding
or truncating to period if necessary.
Setting period to 0 (default) outputs the value once.
The default value is 0.1 0.2 0.3 0.4.
.SE
.LO "CG56 signal sources library"
.DM CG56 CG56Star
.SV 1.14 "01/01/96"
.AL "Chih-Tsung Huang, ported from Gabriel"
.OH
.NE
\fIoutput\fR (fix)
.PE
.SH
.NE
\fIvalue\fR (FixArrayState): One period of the output waveform.
.DF "0.1 0.2 0.3 0.4"
.NE
\fIhaltAtEnd\fR (IntState): Halt the run at the end of the given data.
.DF "NO"
.NE
\fIperiodic\fR (IntState): Output is periodic if "YES" (nonzero).
.DF "YES"
.NE
\fIperiod\fR (IntState): If greater than zero, gives the period of the waveform
.DF "0"
.NE
\fIX\fR (IntState): internal
.DF "0"
.NE
\fIfirstVal\fR (FixState): first value of value
.DF "0.1"
.NE
\fIvalueLen\fR (IntState): number of values in value.
.DF "4"
.NE
\fIdataCirc\fR (IntState): pointer
.DF "0"
.ET
.EQ
delim $$
.EN
.LD
You can get periodic signals with any period, and can halt a simulation
at the end of the given waveform.
The following table summarizes the capabilities:
.TS
center, box;
l l l l.
haltAtEnd	periodic	period	operation
_
NO	YES	0	Period is the length of the waveform.
NO	YES	N > 0	Period is N.
NO	NO	anything	Output the waveform once, then zeros.
.TE
The first line of the table gives the default settings.
.PP
This star may be used to read a file by simply setting "value" to
something of the form "< filename".
The file will be read completely and its contents stored in an array.
The size of the array is currently limited to 20,000 samples.
.IE "waveform from file"
.IE "reading from a file"
.IE "halting a simulation"
.ES
