static const char file_id[] = "CG56Allpass.pl";
// .cc file generated from CG56Allpass.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Allpass.h"

const char *star_nm_CG56Allpass = "CG56Allpass";

const char* CG56Allpass :: className() const {return star_nm_CG56Allpass;}

ISA_FUNC(CG56Allpass,CG56Star);

Block* CG56Allpass :: makeNew() const { LOG_NEW; return new CG56Allpass;}

CodeBlock CG56Allpass :: block (
# line 58 "CG56Allpass.pl"
"; initialize allpass\n"
"; pointer to internal buffer\n"
"        org     $ref(delayBufStart)\n"
"        dc      $addr(delayBuf)\n"
"        org     p:\n");

CodeBlock CG56Allpass :: std (
# line 65 "CG56Allpass.pl"
"        move    $ref(input),b\n"
"        move    $ref(delayBufStart),r0\n"
"        move    #>$val(delay)-1,m0\n"
"        move    $ref(polezero),x0\n"
"        move    y:(r0),y0\n"
"        mac     -x0,y0,b        y0,a\n"
"        move    b,x1    b,y:(r0)+\n"
"        mac     x0,x1,a\n"
"        move    a,$ref(output)\n"
"        move    r0,$ref(delayBufStart)\n");

CG56Allpass::CG56Allpass ()
{
	setDescriptor("Allpass filter");
	addPort(input.setPort("input",this,FIX));
	addPort(polezero.setPort("polezero",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(delay.setState("delay",this,"10","delay value"));
	addState(delayBuf.setState("delayBuf",this,"0","buffer",
# line 48 "CG56Allpass.pl"
A_CIRC|A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(delayBufStart.setState("delayBufStart",this,"0","pointer to the buffer",
# line 55 "CG56Allpass.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));


}

int CG56Allpass::myExecTime() {
# line 87 "CG56Allpass.pl"
return 16;
}

void CG56Allpass::initCode() {
# line 81 "CG56Allpass.pl"
addCode(block);
}

void CG56Allpass::setup() {
# line 78 "CG56Allpass.pl"
delayBuf.resize(delay);
}

void CG56Allpass::go() {
# line 84 "CG56Allpass.pl"
addCode(std);
}

// prototype instance for known block list
static CG56Allpass proto;
static RegisterBlock registerBlock(proto,"Allpass");
