static const char file_id[] = "CG56Biquad.pl";
// .cc file generated from CG56Biquad.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Biquad.h"

const char *star_nm_CG56Biquad = "CG56Biquad";

const char* CG56Biquad :: className() const {return star_nm_CG56Biquad;}

ISA_FUNC(CG56Biquad,CG56Star);

Block* CG56Biquad :: makeNew() const { LOG_NEW; return new CG56Biquad;}

CodeBlock CG56Biquad :: std (
# line 61 "CG56Biquad.pl"
"	move	#$addr(d1),r0\n"
"	move	#$addr(state),r5\n"
"	move	$ref(input),a\n"
"	rnd	a		x:(r0)+,x0	y:(r5)+,y0\n"
"	mac	-x0,y0,a	x:(r0)+,x0	y:(r5),y1\n"
"	mac	-x0,y1,a	x:(r0)+,x0	y0,y:(r5)-\n"
"	mac	x0,y0,a		x:(r0)+,x0	a,y:(r5)\n"
"	mac	x0,y1,a\n"
"	move	a,$ref(output)\n");

CG56Biquad::CG56Biquad ()
{
	setDescriptor("This star generates code for a second order IIR filter (a \"biquad\").\nTransfer function: (1 + n1*z^(-1) + n2*z^(-2))/(1 + d1*z^(-1) + d2*z^(-2))\nWith the default parameters, there is a pole at z=0.5 +/- j0.5, and no zero.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(d1.setState("d1",this,"-1.0","d1",
# line 33 "CG56Biquad.pl"
A_ROM|A_XMEM|A_CONSEC));
	addState(d2.setState("d2",this,"-0.5","d2",
# line 39 "CG56Biquad.pl"
A_ROM|A_XMEM|A_CONSEC));
	addState(n1.setState("n1",this,"0.0","n1",
# line 45 "CG56Biquad.pl"
A_ROM|A_XMEM|A_CONSEC));
	addState(n2.setState("n2",this,"0.0","n2",
# line 51 "CG56Biquad.pl"
A_ROM|A_XMEM));
	addState(state.setState("state",this,"0.0[2]","Filter states",
# line 58 "CG56Biquad.pl"
A_RAM|A_YMEM|A_NONSETTABLE|A_NONCONSTANT));


}

int CG56Biquad::myExecTime() {
# line 72 "CG56Biquad.pl"
return 9;
}

void CG56Biquad::go() {
# line 74 "CG56Biquad.pl"
addCode(std);
}

// prototype instance for known block list
static CG56Biquad proto;
static RegisterBlock registerBlock(proto,"Biquad");
