static const char file_id[] = "CG56Comb.pl";
// .cc file generated from CG56Comb.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Comb.h"

const char *star_nm_CG56Comb = "CG56Comb";

const char* CG56Comb :: className() const {return star_nm_CG56Comb;}

ISA_FUNC(CG56Comb,CG56Star);

Block* CG56Comb :: makeNew() const { LOG_NEW; return new CG56Comb;}

CodeBlock CG56Comb :: block (
# line 80 "CG56Comb.pl"
"; initialize comb\n"
"; pointer to internal buffer\n"
"	org	$ref(delayBufStart)\n"
"  	dc	$addr(delayBuf)\n"
"   	org 	p:\n");

CodeBlock CG56Comb :: std (
# line 87 "CG56Comb.pl"
"        move    $ref(input),b\n"
"        move    $ref(delayBufStart),r0\n"
"        move    #>$val(delay)-1,m0\n"
"        move    y:(r0),a\n"
"; go ahead and output the result\n"
"        move    a,$ref(output)\n"
"; oldest data sample is now in a. filter it with the LPF\n"
"        move    $ref(state),y0\n"
"        move    #>$val(pole),x0\n"
"        mac     x0,y0,a\n"
"; store the state\n"
"        move    a,$ref(state)  a,x0\n"
"; multiply it by the feedback constant, which is time*(1-pole)\n"
"        move    $ref(time),y0\n"
"        mpy     x0,y0,a #>$val(X),y0\n"
"        move    a,x0\n"
"        mac     x0,y0,b\n"
"        move    b,y:(r0)+\n"
"        move    r0,$ref(delayBufStart)\n"
"        move    m1,m0\n"
"\n");

CG56Comb::CG56Comb ()
{
	setDescriptor("Comb filter");
	addPort(input.setPort("input",this,FIX));
	addPort(time.setPort("time",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(state.setState("state",this,"0.0","internal",
# line 44 "CG56Comb.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM));
	addState(delayBuf.setState("delayBuf",this,"0","buffer",
# line 51 "CG56Comb.pl"
A_CIRC|A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(delayBufStart.setState("delayBufStart",this,"0","pointer to the buffer",
# line 58 "CG56Comb.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(delay.setState("delay",this,"10","maximum delay"));
	addState(pole.setState("pole",this,"0.5","value of pole"));
	addState(X.setState("X",this,"ONE","internal state",
# line 77 "CG56Comb.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

int CG56Comb::myExecTime() {
# line 122 "CG56Comb.pl"
return 26;
}

void CG56Comb::initCode() {
# line 114 "CG56Comb.pl"
addCode(block);
}

void CG56Comb::setup() {
# line 111 "CG56Comb.pl"
delayBuf.resize(delay);
}

void CG56Comb::go() {
# line 117 "CG56Comb.pl"
X=1.0-pole.asDouble();
                addCode(std);
}

// prototype instance for known block list
static CG56Comb proto;
static RegisterBlock registerBlock(proto,"Comb");
