static const char file_id[] = "CG56FFTCx.pl";
// .cc file generated from CG56FFTCx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56FFTCx.h"

const char *star_nm_CG56FFTCx = "CG56FFTCx";

const char* CG56FFTCx :: className() const {return star_nm_CG56FFTCx;}

ISA_FUNC(CG56FFTCx,CG56Star);

Block* CG56FFTCx :: makeNew() const { LOG_NEW; return new CG56FFTCx;}

CodeBlock CG56FFTCx :: dofft (
# line 84 "CG56FFTCx.pl"
"; Perform the FFT\n"
"	fftr2a	$val(order),$addr(input),$addr(twdfct)\n"
"\n"
"; Copy data into output buffers and bit reverse\n"
"	move	#$val(halfOrder),n6\n"
"	move	#$addr(input),r6\n"
";	m6 is already set to 0 by fft macro\n"
"	move	#$addr(output),r0\n"
"	do	#$val(order),$label(FFTLoop)\n"
"	move	L:(r6)+n6,x\n"
"	move	x,L:(r0)+\n"
"$label(FFTLoop)\n"
"	move	m0,m6\n");

CG56FFTCx::CG56FFTCx ()
{
	setDescriptor("");
	addPort(input.setPort("input",this,COMPLEX));
	input.setAttributes(
# line 20 "CG56FFTCx.pl"
A_CIRC);
	addPort(output.setPort("output",this,COMPLEX));
	addState(order.setState("order",this,"128","FFT order, must be a power of 2"));
	addState(direction.setState("direction",this,"1.0","Forward (1.0) or Reverse (-1.0)FFT."));
	addState(twdfct.setState("twdfct",this,"","twdfct",
# line 41 "CG56FFTCx.pl"
A_RAM|A_CONSTANT|A_NONSETTABLE|A_SYMMETRIC|A_NOINIT|A_CIRC));
	addState(halfOrder.setState("halfOrder",this,"64","halfOrder",
# line 46 "CG56FFTCx.pl"
A_CONSTANT|A_NONSETTABLE));


}

void CG56FFTCx::initCode() {
# line 55 "CG56FFTCx.pl"
halfOrder.setInitValue(order/2);
	if (addCode("; Include FFT macro","code","FFT_Macro")) {
		char *expandedName =
			expandPathName("$PTOLEMY/lib/cg56/fftr2a.asm");
		StringList macro = "	include '";
		macro << expandedName;
		macro << "'\n";
		addCode(macro);
		delete [] expandedName;
	}
	StringList twcos, twsin;
	for(int i = 0; i < int(halfOrder); i++) {
		double dtwcos,dtwsin;
		dtwcos = -1*cos (i*2.0*M_PI/double( (int (order))));
		dtwsin = double(direction)* -1* 
		  sin(i*2.0*M_PI/double(int(order)));
		twcos << "	dc	"<< dtwcos << "\n";
		twsin << "	dc	"<< dtwsin << "\n";
	}
	addCode(";Twiddle factors\n");
	addCode("	org     x:$addr(twdfct)\n");
	addCode(twcos);
	addCode("	org	y:$addr(twdfct)\n");
	addCode(twsin);
	addCode("	org	p:\n");
}

void CG56FFTCx::setup() {
# line 50 "CG56FFTCx.pl"
twdfct.resize(order/2);
	input.setSDFParams(order,order-1);
	output.setSDFParams(order,order-1);
}

void CG56FFTCx::go() {
# line 82 "CG56FFTCx.pl"
addCode(dofft);
}

// prototype instance for known block list
static CG56FFTCx proto;
static RegisterBlock registerBlock(proto,"FFTCx");
