static const char file_id[] = "CG56GoertzelPower.pl";
// .cc file generated from CG56GoertzelPower.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56GoertzelPower.h"

const char *star_nm_CG56GoertzelPower = "CG56GoertzelPower";

const char* CG56GoertzelPower :: className() const {return star_nm_CG56GoertzelPower;}

ISA_FUNC(CG56GoertzelPower,CG56GoertzelBase);

Block* CG56GoertzelPower :: makeNew() const { LOG_NEW; return new CG56GoertzelPower;}

CodeBlock CG56GoertzelPower :: result (
# line 40 "CG56GoertzelPower.pl"
"; Compute the power of last filter output zz* = Re(z)^2 + Im(z)^2,\n"
"; where x0 = Re(z) and b = Im(z)\n"
"	mpyr	x0,x0,a		b,y0\n"
"	macr	y0,y0,a\n"
"	move	a,$ref(output)\n");

CG56GoertzelPower::CG56GoertzelPower ()
{
	setDescriptor("First-order recursive computation of the power of the kth coefficient of\nan N-point DFT using Goertzel's algorithm.\nThis form is used in touchtone decoding.");
	addPort(output.setPort("output",this,FIX));


}

int CG56GoertzelPower::myExecTime() {
# line 57 "CG56GoertzelPower.pl"
return (3 + CG56GoertzelBase::myExecTime());
}

void CG56GoertzelPower::go() {
# line 48 "CG56GoertzelPower.pl"
// Run the Goertzel second-order IIR filter
		// real coeff. stored in x0, imaginary coeff. stored in b
		CG56GoertzelBase::go();

		// Compute the (real-valued) power of last (complex) sample
		addCode(result);
}

// prototype instance for known block list
static CG56GoertzelPower proto;
static RegisterBlock registerBlock(proto,"GoertzelPower");
