static const char file_id[] = "CG56LMS.pl";
// .cc file generated from CG56LMS.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56LMS.h"

const char *star_nm_CG56LMS = "CG56LMS";

const char* CG56LMS :: className() const {return star_nm_CG56LMS;}

ISA_FUNC(CG56LMS,CG56Star);

Block* CG56LMS :: makeNew() const { LOG_NEW; return new CG56LMS;}

CodeBlock CG56LMS :: std (
# line 130 "CG56LMS.pl"
"	; initialize address registers for coef and delayLine\n"
"         move    #$addr(coef)+$val(coefLen)-1,r3\n"
"; insert here\n"
"        move    $ref(delayLineStart),r5            ; delayLine\n"
"        move    #$val(Y),m5\n"
"                                  ; first adapt coefficients.\n"
"                                  ; multiply the error by the stepSize --> x0\n"
"        move    #$val(stepSize),x1\n"
"        move    $ref(error),x0\n"
"        mpyr    x0,x1,a\n"
"        move    a,x0\n"
"        move    x:(r3),b        y:(r5)+,y0\n");

CodeBlock CG56LMS :: loop (
# line 145 "CG56LMS.pl"
"        do      #$val(loopVal),$label(endloop)\n"
"        macr    x0,y0,b\n"
"        move    b,x:(r3)-\n"
"        move    x:(r3),b        y:(r5)+,y0\n"
"$label(endloop)\n");

CodeBlock CG56LMS :: noloop (
# line 153 "CG56LMS.pl"
"        macr    x0,y0,b\n"
"        move    b,x:(r3)-\n"
"        move    x:(r3),b        y:(r5)+,y0\n");

CodeBlock CG56LMS :: cont (
# line 158 "CG56LMS.pl"
"        macr    x0,y0,b\n"
"        move    b,x:(r3)\n"
"; move current inputs into delayLine.\n"
"        move    #$addr(input),r0\n"
"        move    $ref(delayLineStart),r5\n");

CodeBlock CG56LMS :: decimationGreaterthanOne (
# line 166 "CG56LMS.pl"
"        do      #$val(decimation),$label(decimationloop)\n"
"        move    x:(r0)+,y1\n"
"        move    y1,y:(r5)+\n"
"$label(decimationloop)\n");

CodeBlock CG56LMS :: decimationOne (
# line 173 "CG56LMS.pl"
"        move    x:(r0)+,y1\n"
"        move    y1,y:(r5)+\n");

CodeBlock CG56LMS :: cont1 (
# line 178 "CG56LMS.pl"
"; update delayLine pointer.\n"
"        move    r5,$ref(delayLineStart)          ;oldest sample pointer\n"
"                                            ; now compute output.\n"
"        lua     (r5)-,r5\n"
"        nop\n"
"        clr     a               x:(r3)+,x0      y:(r5)-,y0\n");

CodeBlock CG56LMS :: loop1 (
# line 187 "CG56LMS.pl"
"        do      #$val(loopVal),$label(loop1)\n"
"        mac     x0,y0,a         x:(r3)+,x0      y:(r5)-,y0\n"
"$label(loop1)\n");

CodeBlock CG56LMS :: noloop1 (
# line 193 "CG56LMS.pl"
"        mac     x0,y0,a         x:(r3)+,x0      y:(r5)-,y0\n");

CodeBlock CG56LMS :: end (
# line 197 "CG56LMS.pl"
"        macr    x0,y0,a\n"
"        move    a,$ref(output)\n"
"        move    m7,m5\n");

CodeBlock CG56LMS :: makeblock (
# line 203 "CG56LMS.pl"
"; delayLine memory\n"
"        org     $ref(delayLine)\n"
"        bsc     $val(delayLineSize),0\n"
"        org     p:\n");

CodeBlock CG56LMS :: delaystart (
# line 210 "CG56LMS.pl"
"; pointer to delay line into memory\n"
"        org     $ref(delayLineStart)\n"
"        dc      $addr(delayLine)\n"
"        org     p:\n");

CG56LMS::CG56LMS ()
{
	setDescriptor("Least mean square (LMS) adaptive filter.");
	addPort(output.setPort("output",this,FIX));
	addPort(input.setPort("input",this,FIX));
	addPort(error.setPort("error",this,FIX));
	addState(stepSize.setState("stepSize",this,"0.01","specifies the rate of adaptation"));
	addState(errorDelay.setState("errorDelay",this,"1","specifies the relative delay between the output samples and the input\nerror samples."));
	addState(decimation.setState("decimation",this,"1","number of input samples consumed before firing."));
	addState(coef.setState("coef",this,"-4.0609e-2 -1.6280e-3 1.7853e-1 3.7665e-1 3.7665e-1 1.7853e-1 -1.6280e-3 -4.0609e-2","internal",
# line 82 "CG56LMS.pl"
A_NONCONSTANT|A_XMEM));
	addState(coefLen.setState("coefLen",this,"8","number of coef.",
# line 89 "CG56LMS.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(Y.setState("Y",this,"0","internal",
# line 97 "CG56LMS.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(loopVal.setState("loopVal",this,"0","internal",
# line 105 "CG56LMS.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(delayLine.setState("delayLine",this,"0","internal",
# line 113 "CG56LMS.pl"
A_CIRC|A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(delayLineStart.setState("delayLineStart",this,"0","internal",
# line 120 "CG56LMS.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(delayLineSize.setState("delayLineSize",this,"0","internal",
# line 127 "CG56LMS.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

int CG56LMS::myExecTime() {
# line 275 "CG56LMS.pl"
if (int(coefLen)<=2) {
                   if (int(decimation)<=1)
                         return (17+int(coefLen)*4+int(decimation)*2);
                   else
                         return (20+int(coefLen)*4+int(decimation)*2);
              }
              else {
                   if (int(decimation) <=1)
                         return (23+int(coefLen)*4+int(decimation)*2);
                   else
           	         return (26+int(coefLen)*4+int(decimation)*2);
	      }
}

void CG56LMS::initCode() {
# line 242 "CG56LMS.pl"
CheckParameterValues();
	        addCode(makeblock);
                addCode(delaystart);
}

void CG56LMS::setup() {
# line 217 "CG56LMS.pl"
// FIXME: Parameters are not always resolved properly
		// before setup but should be.  For now, check parameters
		// in initCode method.
		// CheckParameterValues();

		coefLen = coef.size();
		delayLineSize = int(errorDelay) - 1;
		delayLineSize = int(coefLen) +
				int(decimation)*int(delayLineSize);
		delayLine.resize(int(delayLineSize));
		input.setSDFParams(int(decimation),int(decimation)-1);
}

void CG56LMS::go() {
# line 247 "CG56LMS.pl"
Y = int(errorDelay)-1;
                Y = int(coefLen) - 1 + int(decimation)*int(Y);

	        addCode(std);

        	if (int(coefLen) > 2) {
	            loopVal = int(coefLen) - 1;    
	            addCode(loop);
		}
		else addCode(noloop);

	        addCode(cont);
      	
		if ( int(decimation) > 1)
	            addCode(decimationGreaterthanOne);
		else
	            addCode(decimationOne);
	    
	        addCode(cont1);

		if ( int(coefLen) > 2)
        	     addCode(loop1);
		else
        	     addCode(noloop1);
	     
	        addCode(end);
}


void CG56LMS::CheckParameterValues ()
{
# line 234 "CG56LMS.pl"
if (int(decimation) <= 0) {
        	    Error::abortRun(*this,
				    "Decimation must be greater than 0.");
		    return;
		}
}


// prototype instance for known block list
static CG56LMS proto;
static RegisterBlock registerBlock(proto,"LMS");
