static const char file_id[] = "CG56LMSGanged.pl";
// .cc file generated from CG56LMSGanged.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56LMSGanged.h"

const char *star_nm_CG56LMSGanged = "CG56LMSGanged";

const char* CG56LMSGanged :: className() const {return star_nm_CG56LMSGanged;}

ISA_FUNC(CG56LMSGanged,CG56Star);

Block* CG56LMSGanged :: makeNew() const { LOG_NEW; return new CG56LMSGanged;}

CodeBlock CG56LMSGanged :: init (
# line 102 "CG56LMSGanged.pl"
"; delayLineAdp memory\n"
"        org     $ref(delayLineAdp)\n"
"        bsc     $size(delayLineAdp),0\n"
"        org     p:\n"
"\n"
"; pointer to adapt delay line into memory\n"
"        org     $ref(delayLineAdpStart)\n"
"        dc      $addr(delayLineAdp)\n"
"        org     p:\n"
"    \n"
"; delayLineFIR memory\n"
"        org     $ref(delayLineFIR)\n"
"        bsc     $size(delayLineFIR),0\n"
"        org     p:\n"
"      \n"
"; pointer to FIR delay line into memory\n"
"        org     $ref(delayLineFIRStart)\n"
"        dc      $addr(delayLineFIR)\n"
"        org     p:\n");

CodeBlock CG56LMSGanged :: first (
# line 124 "CG56LMSGanged.pl"
"        move    #$size(coef)+$val(errorDelay)-2,m5\n");

CodeBlock CG56LMSGanged :: errorDelayGtOne (
# line 127 "CG56LMSGanged.pl"
"        move    #$val(errorDelay)-1,n5\n");

CodeBlock CG56LMSGanged :: main (
# line 130 "CG56LMSGanged.pl"
"        move    #$val(stepSize),x1\n"
"        move    $ref(error),x0\n"
"; load the address of the oldest sample into r5\n"
"        move    $ref(delayLineAdpStart),r5\n"
"; load the address of the last coefficient into r3\n"
"        move    #$addr(coef)+$size(coef)-1,r3\n"
"; multiply the error by the stepSize\n"
"        mpyr    x0,x1,a         y:(r5)+,y0\n"
"        move    a,x0\n"
"        move    x:(r3),b\n");

CodeBlock CG56LMSGanged :: coefLenTwo (
# line 142 "CG56LMSGanged.pl"
"        do      #$size(coef)-2,$label(loop)\n"
"        macr    x0,y0,b\n"
"        move    b,x:(r3)-\n"
"        move    x:(r3),b        y:(r5)+,y0\n"
"$label(loop)\n"
"        move    $ref(coef),a\n"
"        macr    x0,y0,b         y:(r5)+,y0\n");

CodeBlock CG56LMSGanged :: std (
# line 151 "CG56LMSGanged.pl"
"        macr    x0,y0,b\n"
"        move    b,x:(r3)-\n"
"        move    x:(r3),b        y:(r5)+,y0\n"
"        move    $ref(coef),a\n"
"        macr    x0,y0,b         y:(r5)+,y0\n");

CodeBlock CG56LMSGanged :: adjust (
# line 158 "CG56LMSGanged.pl"
"        move    (r5)+n5         ; to handle error delay\n");

CodeBlock CG56LMSGanged :: cont (
# line 161 "CG56LMSGanged.pl"
"        move    $ref(inputAdapt),y1        ;fetch input\n"
"        macr    x0,y0,a         b,x:(r3)-\n"
"        move    a,x:(r3)        y1,y:(r5)+\n"
"        move    r5,$ref(delayLineAdpStart) ;oldest sample pointer\n"
"; now compute output.\n");

CodeBlock CG56LMSGanged :: cont1 (
# line 168 "CG56LMSGanged.pl"
"        move    #$addr(coef)+$size(coef)-1,r3\n"
"        clr     a\n"
"        move    x:(r3)-,x0      y:(r5)+,y0\n"
"        do      #$size(coef)-1,$label(loop1)\n"
"        mac     x0,y0,a         x:(r3)-,x0      y:(r5)+,y0\n"
"$label(loop1)\n"
"        macr    x0,y0,a\n"
"        move    a,$ref(outputAdapt)\n"
"; compute output of parallel fir filter\n"
"        move    #$size(coef)-2,m5\n"
"        move    $ref(delayLineFIRStart),r5\n"
"        move    #$addr(coef)+$size(coef)-1,r3\n"
"        clr     a\n"
"        move    x:(r3)-,x0      y:(r5)+,y0\n"
"        do      #$size(coef)-2,$label(loop3)\n"
"        mac     x0,y0,a         x:(r3)-,x0      y:(r5)+,y0\n"
"$label(loop3)\n"
"        move    $ref(inputFIR),y1\n"
"        macr    x0,y0,a         x:(r3),x0\n"
"        macr    x0,y1,a         y1,y:(r5)+\n"
"        move    a,$ref(outputFIR)\n"
"        move    r5,$ref(delayLineFIRStart)\n"
"        move    m7,m5\n");

CG56LMSGanged::CG56LMSGanged ()
{
	setDescriptor("Ganged least mean square (LMS) adaptive filter.");
	addPort(inputFIR.setPort("inputFIR",this,FIX));
	addPort(inputAdapt.setPort("inputAdapt",this,FIX));
	addPort(error.setPort("error",this,FIX));
	addPort(outputFIR.setPort("outputFIR",this,FIX));
	addPort(outputAdapt.setPort("outputAdapt",this,FIX));
	addState(stepSize.setState("stepSize",this,"0.01","specifies the rate of adaptation"));
	addState(errorDelay.setState("errorDelay",this,"1","specifies the relative delay between the output samples and the input\nerror samples."));
	addState(decimation.setState("decimation",this,"1","number of input samples consumed before firing.",
# line 65 "CG56LMSGanged.pl"
A_NONSETTABLE));
	addState(coef.setState("coef",this,"-4.0609e-2 -1.6280e-3 1.7853e-1 3.7665e-1 3.7665e-1 1.7853e-1 -1.6280e-3 -4.0609e-2","internal",
# line 72 "CG56LMSGanged.pl"
A_NONCONSTANT|A_XMEM));
	addState(delayLineAdp.setState("delayLineAdp",this,"0","internal",
# line 79 "CG56LMSGanged.pl"
A_CIRC|A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(delayLineAdpStart.setState("delayLineAdpStart",this,"0","internal",
# line 86 "CG56LMSGanged.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(delayLineFIR.setState("delayLineFIR",this,"0","internal",
# line 93 "CG56LMSGanged.pl"
A_CIRC|A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(delayLineFIRStart.setState("delayLineFIRStart",this,"0","internal",
# line 100 "CG56LMSGanged.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));


}

int CG56LMSGanged::myExecTime() {
# line 221 "CG56LMSGanged.pl"
if(int(errorDelay)>1)
	           return 33+5 * coef.size();
              else
                   return 30+5 * coef.size();
}

void CG56LMSGanged::initCode() {
# line 199 "CG56LMSGanged.pl"
addCode(init);
}

void CG56LMSGanged::setup() {
# line 195 "CG56LMSGanged.pl"
delayLineAdp.resize(errorDelay - 1 + coef.size());
		delayLineFIR.resize(coef.size()-1);
}

void CG56LMSGanged::go() {
# line 202 "CG56LMSGanged.pl"
addCode(first);
		if (errorDelay>1) addCode(errorDelayGtOne);
                addCode(main);
		if (coef.size()>2)
	             addCode(coefLenTwo);
		else
	             addCode(std);
// need to adjust r5 if errorDelay is greater than one.
		if (errorDelay>1) addCode(adjust);
                addCode(cont);
// assume r5 is pointing to the oldest sample in the delay line
// but if errorDelay is greater than one, we don't want to point
// to the oldest		
		if (errorDelay>1) addCode(adjust);
// make r3 point to the last tap value
                addCode(cont1);
}

// prototype instance for known block list
static CG56LMSGanged proto;
static RegisterBlock registerBlock(proto,"LMSGanged");
