static const char file_id[] = "CG56LMSOscDet.pl";
// .cc file generated from CG56LMSOscDet.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56LMSOscDet.h"

const char *star_nm_CG56LMSOscDet = "CG56LMSOscDet";

const char* CG56LMSOscDet :: className() const {return star_nm_CG56LMSOscDet;}

ISA_FUNC(CG56LMSOscDet,CG56FIR);

Block* CG56LMSOscDet :: makeNew() const { LOG_NEW; return new CG56LMSOscDet;}

const char* CG56LMSOscDet :: oscDetCode(int index) {
# line 135 "CG56LMSOscDet.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"; Compute update of the middle tap, tap[1], according to\n"
"; tap[1] = taps[1] - 4 * mu * e * xnMinus1;\n"
"; Update the estimate of cos(w) = -tap[1]/2\n"
";\n"
"; Register usage:\n"
"; x0 = x[n - " << (index) << "] = input signal delayed by " << (index) << " sample(s)\n"
"; x1 = e[n - " << (index) << "] = error signal delayed by one sample\n"
"; y0 = mu = LMS step size\n"
"; y1 = -mu e[n - " << (index) << "] x[n - " << (index) << "]\n"
"; a = intermediate computations and the final value of updated tap\n"
"; b = initial value of tap to update\n"
"	move	#$val(stepSize),y0			; y0 = LMS step size\n"
"	move	$ref(error),x1			; e[n - " << (index) << "] error value\n"
"	mpyr	x1,y0,a		$ref(input," << (index) << "),x0	; x0 = x[n-" << (index) << "] input value\n"
"	move	a,y0			; x0 = tap value to update\n"
"	mpyr	-y0,x0,a	y:$addr(taps)+1,b	; a = -mu e[n-" << (index) << "] x[n-" << (index) << "]\n"
"	asl	a			; a = -2 mu e[n-" << (index) << "] x[n-" << (index) << "]\n"
"	addl	b,a			; a = tap - 4 mu e[n-" << (index) << "] x[n-" << (index) << "]\n"
"	move	a,y:$addr(taps)+1		; save updated tap\n"
"	asr	a			; compute cos(w) = -tap/2\n"
"	neg	a\n"
"	move	a,$ref(cosOmega)		; save cos(w)\n";
	return (const char*)_str_;
}

CG56LMSOscDet::CG56LMSOscDet ()
{
	setDescriptor("This filter tries to lock onto the strongest sinusoidal component in\nthe input signal, and outputs the current estimate of the cosine\nof the frequency of the strongest component.  It is a three-tap\nLeast-Mean Square (LMS) filter whose first and third coefficients are\nfixed at one.  The second coefficient is adapted.  It is a normalized\nversion of the Direct Adaptive Frequency Estimation Technique.");
	addPort(error.setPort("error",this,FIX));
	addPort(cosOmega.setPort("cosOmega",this,FIX));
	addState(stepSize.setState("stepSize",this,"0.01","Adaptation step size."));
	addState(errorDelay.setState("errorDelay",this,"1","Delay in the update loop."));
	addState(initialOmega.setState("initialOmega",this,"PI/4","The initial guess at the angle being estimated in radians."));

# line 92 "CG56LMSOscDet.pl"
// taps state: not constant, length three, and not settable
		taps.clearAttributes(A_CONSTANT);
		taps.clearAttributes(A_SETTABLE);

		// decimation is not supported
		decimation.clearAttributes(A_SETTABLE);
		decimationPhase.clearAttributes(A_SETTABLE);
}

int CG56LMSOscDet::myExecTime() {
# line 176 "CG56LMSOscDet.pl"
return 11 + CG56FIR::myExecTime();
}

void CG56LMSOscDet::setup() {
# line 118 "CG56LMSOscDet.pl"
// FIXME: Parameters are not always resolved properly
		// before setup but should be.  For now, check parameters
		// in go method.
		// CheckParameterValues();

		// we don't support decimation: make sure that it's 1
		decimation = 1;

		// initialize the taps of the three-tap LMS FIR filter
		taps.resize(3);
		taps[0] =  1.0;
		taps[1] = -2.0 * cos(double(initialOmega));
		taps[2] =  1.0;

		// call the LMS FIR filter setup method
		CG56FIR :: setup();
}

void CG56LMSOscDet::go() {
# line 160 "CG56LMSOscDet.pl"
CheckParameterValues();

		// 1. Since we don't support decimation,
		//    index = int(errorDelay) + 1, a constant
		int index = int(errorDelay)*int(decimation) + 
			    int(decimationPhase) + 1;

		// 2. Update the middle tap and compute the estimate
		//    of cos(w) = -tap/2
		addCode(oscDetCode(index));

		// 3. Run the FIR filter
		CG56FIR :: go();
}


void CG56LMSOscDet::CheckParameterValues ()
{
# line 105 "CG56LMSOscDet.pl"
if ( double(stepSize) <= 0.0 ) {
		    Error::abortRun(*this,
				    "The step size must be positive");
		    return;
		}
		if ( int(errorDelay) < 0 ) {
		    Error::abortRun(*this,
				    "The error delay must be non-negative");
		    return;
		}
}


// prototype instance for known block list
static CG56LMSOscDet proto;
static RegisterBlock registerBlock(proto,"LMSOscDet");
