static const char file_id[] = "CG56LMSRx.pl";
// .cc file generated from CG56LMSRx.pl by ptlang
/*
Copyright (c) 1991-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56LMSRx.h"

const char *star_nm_CG56LMSRx = "CG56LMSRx";

const char* CG56LMSRx :: className() const {return star_nm_CG56LMSRx;}

ISA_FUNC(CG56LMSRx,CG56Star);

Block* CG56LMSRx :: makeNew() const { LOG_NEW; return new CG56LMSRx;}

CodeBlock CG56LMSRx :: cbExample (
# line 178 "CG56LMSRx.pl"
";	decimation (e.g. =3)\n"
";	time ->\n"
";	x0	x1	x2	|  x0	 x1	x2\n"
";	e	no_info	no_info	|  e	 n/i	n/i\n"
";			lms_out	|		lms_out\n"
";	note: total delay between e_in and the last x(decimation-1) =\n"
";	      (* error_delay  decimation)\n"
";	      where error_delay is delay in feedback loop\n");

CodeBlock CG56LMSRx :: cbInit (
# line 189 "CG56LMSRx.pl"
"	org	$ref(delayPtr)\n"
"	dc	$addr(delay_line)\n"
"	org	x:$addr(delay_line)\n"
"	bsc	$size(delay_line),0.0\n"
"	org	y:$addr(delay_line)\n"
"	bsc	$size(delay_line),0.0\n"
"	org	p:\n");

CodeBlock CG56LMSRx :: cbHeader (
# line 199 "CG56LMSRx.pl"
"	; step_size:	$val(step_size)\n"
"	; error_delay:	$val(error_delay)\n"
"	; decimation:	$val(decimation)\n"
"	; last_tap_min:	$val(last_tap_min)\n");

CodeBlock CG56LMSRx :: cbSetup (
# line 206 "CG56LMSRx.pl"
"	; initialize address registers\n"
"	move	#$val(numTaps)-1+$val(fooPhase),m1 ; delay_line: oldest sample\n"
"	move	$ref(delayPtr),r1\n"
"	move	#-(1+$val(fooPhase)),n1\n"
"	move	#$val(numTaps)-1,m4\n"
"	move	#$addr(coef_table),r4			; coef_table\n");

CodeBlock CG56LMSRx :: cbUpdateTaps (
# line 215 "CG56LMSRx.pl"
"	; UPDATE TAPS\n"
"	lua	(r1)+n1,r1\n"
"	move	$ref(error_i),x1\n"
"	move	$ref(step_size),y1\n"
"	mpyr	x1,y1,b\n"
"	move	$ref(error_r),x1\n"
"	mpyr	x1,y1,a		b,y1		x:(r1),x0\n"
"	move			a,x1		y:(r4),b\n"
"        ; Now (error * step_size) =  x1 + jy1\n"
"\n"
"        ; Do re(updated_coef)-->a    im(updated_coef)-->b\n"
"	mac	-x0,y1,b			y:(r1)-,y0\n"
"	macr	 x1,y0,b	x:(r4),a\n"
"\n"
"	; going into loop - (accounting for decimation)\n"
"	;	x0+jy0	=	in@total_error_delay\n"
"	;	a	=	re(old_coef0)\n"
"	;	b	=	im(updated_coef0)\n"
"	;	r4	->	coef0\n"
"	;	r1	->	in@(total_error_delay+1)\n"
"\n"
"	IF $val(numTaps)>2\n"
"	  .LOOP	#$val(numTaps)-1\n"
"	    mac		 x0,x1,a	b,y:(r4)+\n"
"	    macr	 y0,y1,a	y:(r4)-,b	x:(r1),x0\n"
"	    mac		-x0,y1,b	a,x:(r4)+	y:(r1)-,y0\n"
"	    macr	 x1,y0,b	x:(r4),a\n"
"	  .ENDL\n"
"	ENDIF\n"
"\n"
"	; coming out of loop -\n"
"	;	b	=	im(updated_coef_N-1)\n"
"	;	x0+jy0	=	in@error_delay\n"
"	;	r1	->	messed-up\n"
"	;	r4	->	coef_N-1\n");

CodeBlock CG56LMSRx :: cbStoreLastTap (
# line 253 "CG56LMSRx.pl"
"	mac	 x0,x1,a	b,y:(r4)\n"
"	macr	 y0,y1,a\n"
"	move			a,x:(r4)+\n");

CodeBlock CG56LMSRx :: cbLastTapConstrait (
# line 259 "CG56LMSRx.pl"
"	; update last tap only if its magnitude exceeds last_tap_min\n"
"	; last_tap_min --> x1\n"
"	; re(updated_coef)-->x0, im(updated_coef)-->y0\n"
"	mac	x0,x1,a		#$val(last_tap_min),x1\n"
"	macr	y0,y1,a		b,y0\n"
"	abs	b		a,x0\n"
"	cmp	x1,b\n"
"	jlt	$label(small_imag)	;jump if im(updated_coef) too small\n"
"	move	y0,y:(r4)\n"
"$label(small_imag)\n"
"	abs	a\n"
"	cmp	x1,a\n"
"	jlt	$label(small_real)	;jump if re(updated_coef) too small\n"
"	move	x0,x:(r4)\n"
"$label(small_real)\n"
"	lua	(r4)+,r4\n");

CodeBlock CG56LMSRx :: cbUpdateDelayLine (
# line 278 "CG56LMSRx.pl"
"	; UPDATE DELAY LINE\n"
"	; MOVE CURRENT INPUTS INTO DELAY_LINE\n"
"	move	$ref(delayPtr),r1\n"
"	move	#$addr(input_r),r0\n"
"	move	#$addr(input_i),r5\n"
"	IF	$val(decimation)>1\n"
"	  .LOOP	#$val(decimation)\n"
"	ENDIF\n"
"	  move	x:(r0)+,x1\n"
"	  move	x:(r5)+,x0\n"
"	  move	x,l:(r1)+\n"
"	IF	$val(decimation)>1\n"
"	  .ENDL\n"
"	ENDIF\n"
"\n"
"	; update delay_line pointer\n"
"	move	r1,$ref(delayPtr)\n");

CodeBlock CG56LMSRx :: cbInnerProduct (
# line 298 "CG56LMSRx.pl"
"	; COMPUTE INNER PRODUCT\n"
"        ; COMPUTE FILTER OUTPUT\n"
"	lua	(r1)-,r1\n"
"	nop\n"
"	clr	a		y:(r4),y1	x:(r1),x0\n"
"	clr	b		x:(r4)+,x1	y:(r1)-,y0\n"
"	mac	-y1,x0,b\n"
"	mac	 x1,y0,b\n"
"\n"
"	; going into loop -\n"
"	;	x1+jy1	=	coef0\n"
"	;	x0+jy0	=	in@0 (first new sample)\n"
"	;	r1	->	in@-1\n"
"	;	r4	->	coef1\n"
"\n"
"	IF	$val(numTaps)>2\n"
"	  .LOOP	#$val(numTaps)-1\n"
"	ENDIF\n"
"	  mac	x0,x1,a\n"
"	  mac	y0,y1,a		y:(r4),y1	x:(r1),x0\n"
"	  mac	-y1,x0,b	x:(r4)+,x1	y:(r1)-,y0\n"
"	  mac	x1,y0,b\n"
"	IF	$val(numTaps)>2\n"
"	  .ENDL\n"
"	ENDIF\n"
"\n"
"	mac	x0,x1,a		b,$ref(output_i)\n"
"	mac	y0,y1,a\n"
"	move	a,$ref(output_r)\n"
"	move	m7,m1\n"
"	move	m7,m4\n");

CG56LMSRx::CG56LMSRx ()
{
	setDescriptor("Complex LMS filter.");
	addPort(input_r.setPort("input_r",this,FIX));
	addPort(input_i.setPort("input_i",this,FIX));
	addPort(error_r.setPort("error_r",this,FIX));
	addPort(error_i.setPort("error_i",this,FIX));
	addPort(output_r.setPort("output_r",this,FIX));
	addPort(output_i.setPort("output_i",this,FIX));
	addState(init_taps_r.setState("init_taps_r",this,"","init_taps_r"));
	addState(init_taps_i.setState("init_taps_i",this,"","init_taps_i"));
	addState(numTaps.setState("numTaps",this,"0","numTaps",
# line 68 "CG56LMSRx.pl"
A_CONSTANT|A_NONSETTABLE));
	addState(step_size.setState("step_size",this,"0.01","step_size",
# line 74 "CG56LMSRx.pl"
A_NONCONSTANT|A_SETTABLE|A_YMEM));
	addState(error_delay.setState("error_delay",this,"1","error_delay"));
	addState(decimation.setState("decimation",this,"1","decimation"));
	addState(fooPhase.setState("fooPhase",this,"0","\"I wish I knew.\"",
# line 91 "CG56LMSRx.pl"
A_CONSTANT|A_NONSETTABLE));
	addState(last_tap_min.setState("last_tap_min",this,"0.0","last_tap_min"));
	addState(coef_table.setState("coef_table",this,"0.0","coef_table",
# line 102 "CG56LMSRx.pl"
A_SYMMETRIC|A_RAM|A_CIRC|A_NONCONSTANT|A_NONSETTABLE|A_NOINIT));
	addState(delay_line.setState("delay_line",this,"0.0","delay_line",
# line 108 "CG56LMSRx.pl"
A_SYMMETRIC|A_RAM|A_CIRC|A_NONCONSTANT|A_NONSETTABLE|A_NOINIT));
	addState(delayPtr.setState("delayPtr",this,"0","delayPtr",
# line 114 "CG56LMSRx.pl"
A_YMEM|A_NONCONSTANT|A_NONSETTABLE|A_NOINIT));


}

int CG56LMSRx::myExecTime() {
# line 162 "CG56LMSRx.pl"
int coretime = 8 * int(numTaps) + 3 * int(decimation) + 28;

	if ( last_tap_min.asDouble() > 0.0 ) {
	    coretime += 14;
	}

	if ( int(numTaps) <= 2 ) {
	    coretime += int(decimation) <= 1 ? 0 : 3;
	}
	else {
	    coretime += int(decimation) <= 1 ? 6 : 9;
	}

	return coretime;
}

void CG56LMSRx::initCode() {
# line 130 "CG56LMSRx.pl"
addCode(cbInit);
	int k = 0;
	addCode("	org	x:$addr(coef_table)\n");
	for ( k=0; k < numTaps; k++) {
	    char buf[100];
	    sprintf(buf, "	dc	%.15f\n", double(init_taps_r[k]));
	    addCode(buf);
	}
	addCode("	org	y:$addr(coef_table)\n");
	for ( k=0; k < numTaps; k++) {
	    char buf[100];
	    sprintf(buf, "	dc	%.15f\n", double(init_taps_i[k]));
	    addCode(buf);
	}
	addCode("	org	p:\n");
}

void CG56LMSRx::setup() {
# line 117 "CG56LMSRx.pl"
int d = int(decimation);
	input_r.setSDFParams( d, d-1);
	input_i.setSDFParams( d, d-1);
	numTaps = init_taps_r.size();
	if ( numTaps <= 0 || numTaps != init_taps_i.size() ) {
	    Error::abortRun(*this,"Initial tap lists invalid");
	    return;
	}
	coef_table.resize(numTaps);
	fooPhase = int(decimation) * (int(error_delay)-1);
	delay_line.resize(numTaps+int(fooPhase));
}

void CG56LMSRx::go() {
# line 147 "CG56LMSRx.pl"
addCode(cbHeader);
	addCode(cbSetup);
	addCode(cbUpdateTaps);

	if (last_tap_min.asDouble() > 0.0) {
    	    addCode(cbLastTapConstrait);
	} else {
    	    addCode(cbStoreLastTap);
	}

	addCode(cbUpdateDelayLine);
	addCode(cbInnerProduct);
}

// prototype instance for known block list
static CG56LMSRx proto;
static RegisterBlock registerBlock(proto,"LMSRx");
