static const char file_id[] = "CG56RaisedCos.pl";
// .cc file generated from CG56RaisedCos.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56RaisedCos.h"

const char *star_nm_CG56RaisedCos = "CG56RaisedCos";

const char* CG56RaisedCos :: className() const {return star_nm_CG56RaisedCos;}

ISA_FUNC(CG56RaisedCos,CG56FIR);

Block* CG56RaisedCos :: makeNew() const { LOG_NEW; return new CG56RaisedCos;}

# line 27 "CG56RaisedCos.pl"
static double rcos (int t, int T, double excess) {
			const double DELTA = 1.0e-7;
			if (t == 0) return 1.0;
			double x = (double)t/(double)T;
			double s = sin (M_PI * x) / (M_PI * x);
			x *= excess;
			double den = 1.0 - 4 * x * x;
			if (den > -DELTA && den < DELTA) return s * M_PI/4.0;
			return s * cos (M_PI * x) / den;
		}

CG56RaisedCos::CG56RaisedCos ()
{
	setDescriptor("An FIR filter with a magnitude frequency response shaped\nlike the standard raised cosine used in digital communications.\nSee the SDFRaisdCos star for more information.");
	addState(N.setState("N",this,"64","Number of taps"));
	addState(P.setState("P",this,"16","Distance from center to first zero crossing"));
	addState(excessBW.setState("excessBW",this,"1.0","Excess bandwidth, between 0 and 1"));

# line 57 "CG56RaisedCos.pl"
// taps are no longer constant or settable
		taps.clearAttributes(A_CONSTANT|A_SETTABLE);
		// fix interpolation default
		interpolation.setInitValue("16");
		// make decimation parameters invisible
		decimation.clearAttributes(A_SETTABLE);

		// XXX: DONT do this...not implemented in CG56FIR
		// XXX: decimationPhase.clearAttributes(A_SETTABLE);
}

void CG56RaisedCos::setup() {
# line 68 "CG56RaisedCos.pl"
taps.resize (N);
		int center = int(N)/2;
		double maxval = CG56_ONE;
		for (int i = 0; i < int(N); i++) {
			double coef = rcos(i - center, P, excessBW);
			if ( coef > maxval )	coef = maxval;
			if ( coef < -1 )	coef = -1;
			taps[i] = coef;
			// cerr << "Tap %d" << coef << "\n";
		}
		CG56FIR :: setup();
}

// prototype instance for known block list
static CG56RaisedCos proto;
static RegisterBlock registerBlock(proto,"RaisedCos");
