static const char file_id[] = "CG56Sinc.pl";
// .cc file generated from CG56Sinc.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, an ddisclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Sinc.h"

const char *star_nm_CG56Sinc = "CG56Sinc";

const char* CG56Sinc :: className() const {return star_nm_CG56Sinc;}

ISA_FUNC(CG56Sinc,CG56Star);

Block* CG56Sinc :: makeNew() const { LOG_NEW; return new CG56Sinc;}

CodeBlock CG56Sinc :: sinc (
# line 55 "CG56Sinc.pl"
"; sin(x)/x = a + x^2 (b + c x^2)\n"
"	move	$ref(input),x0\n"
"	move	$ref(b),b                ; B=b\n"
"	mpy	x0,x0,a     $ref(c),x1   ; A=x^2  X1=c\n"
"	move	a,y0                     ; Y0=x^2\n"
"	mac	x1,y0,b     $ref(a),a    ; B=b+cx^2  A=a\n"
"	move	b,x0                     ; X0=b+cx^2\n"
"	macr	y0,x0,a                  ; A=a+x^2(b+cx^2)\n"
"	asl	a\n"
"	move	a,$ref(output)           \n");

CG56Sinc::CG56Sinc ()
{
	setDescriptor("Sinc function using a polynomial approximation.  Input range of [-1,1)\nis scaled by pi.  Output is sin(pi*input)/(pi*input).");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(a.setState("a",this,"0.5","internal state",
# line 39 "CG56Sinc.pl"
A_YMEM|A_NONSETTABLE|A_CONSTANT));
	addState(b.setState("b",this,"-0.822467034","internal state",
# line 46 "CG56Sinc.pl"
A_YMEM|A_NONSETTABLE|A_NONCONSTANT));
	addState(c.setState("c",this,"0.405871213","internal state",
# line 53 "CG56Sinc.pl"
A_YMEM|A_NONSETTABLE|A_NONCONSTANT));


}

int CG56Sinc::myExecTime() {
# line 71 "CG56Sinc.pl"
return 9;
}

void CG56Sinc::go() {
# line 68 "CG56Sinc.pl"
addCode(sinc);
}

// prototype instance for known block list
static CG56Sinc proto;
static RegisterBlock registerBlock(proto,"Sinc");
