static const char file_id[] = "CG56Add.pl";
// .cc file generated from CG56Add.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Add.h"

const char *star_nm_CG56Add = "CG56Add";

const char* CG56Add :: className() const {return star_nm_CG56Add;}

ISA_FUNC(CG56Add,CG56Star);

Block* CG56Add :: makeNew() const { LOG_NEW; return new CG56Add;}

CodeBlock CG56Add :: std (
# line 34 "CG56Add.pl"
"	move	$ref(input#1),x0	; 1st input -> x0\n"
"	move	$ref(input#2),a		; 2nd input -> a\n");

CodeBlock CG56Add :: sat (
# line 38 "CG56Add.pl"
"	add	x0,a\n"
"	move	a,$ref(output)		; this move saturates\n");

CodeBlock CG56Add :: nosat (
# line 42 "CG56Add.pl"
"	add	x0,a\n"
"	move	a1,$ref(output)		; this move clips\n");

CodeBlock CG56Add :: one (
# line 46 "CG56Add.pl"
"	move	$ref(input#1),x0	; just move data from in to out\n"
"	move	x0,$ref(output)\n");

CG56Add::CG56Add ()
{
	setDescriptor("Add any number of inputs, producing an output.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(saturation.setState("saturation",this,"YES","If true, use saturation arithmetic"));

# line 32 "CG56Add.pl"
noInternalState();
}

int CG56Add::myExecTime() {
# line 66 "CG56Add.pl"
if (input.numberPorts() == 1) return 2;
		else return input.numberPorts() + 2;
}

void CG56Add::go() {
# line 51 "CG56Add.pl"
if (input.numberPorts() == 1) {
			addCode(one);
			return;
		}
		addCode(std);
		for (int i = 3; i <= input.numberPorts(); i++) {
			char buf[80];
			sprintf (buf, "\tadd\tx0,a\t$ref(input#%d),x0",i);
			addCode(CodeBlock(buf));
		}
		if (int(saturation))
			addCode(sat);
		else addCode(nosat);
}

// prototype instance for known block list
static CG56Add proto;
static RegisterBlock registerBlock(proto,"Add");
