static const char file_id[] = "CG56ChopVarOffset.pl";
// .cc file generated from CG56ChopVarOffset.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, an disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56ChopVarOffset.h"

const char *star_nm_CG56ChopVarOffset = "CG56ChopVarOffset";

const char* CG56ChopVarOffset :: className() const {return star_nm_CG56ChopVarOffset;}

ISA_FUNC(CG56ChopVarOffset,CG56Chop);

Block* CG56ChopVarOffset :: makeNew() const { LOG_NEW; return new CG56ChopVarOffset;}

CodeBlock CG56ChopVarOffset :: initRange (
# line 44 "CG56ChopVarOffset.pl"
"; Register usage:\n"
"; a  = temporary data\n"
"; b  = # of 0's to pad at end\n"
"; x0 = # of 0's to pad at beginning\n"
"; x1 = # of inputs written to output\n"
"; y1 = temporary data\n"
"; r0 = address of first input written to output\n"
"; n0 = # of inputs to skip\n"
"; r5 = address of first output\n"
"; if offset < 0 and |offset| > nread no inputs will be written\n"
"	move	$ref(offsetCntrl),a\n"
"	move	#0,x0\n"
"	move	$ref(nread),x1			; x1 = nread\n"
"	neg	a	a,b		; a = -offset  b = offset\n"
"	tst	a	$ref(nwrite),y0\n"
"	tlt	x0,a			; if offset > 0 a=0 \n"
"	tgt	x0,b			; if offset < 0 b=0 \n"
"	cmp	x1,a			; check num of inputs to skip > nread;\n"
"	tgt	x1,a			; if so, num of inputs to skip = nread\n"
"	cmp	y0,b	a,y1		; check padding > nwrite\n"
"	tgt	y0,b			; if so, padding = nwrite\n"
"	move	b,x0\n"
"	move	x1,b\n"
"; b = # of inputs that can be read = nread - num of inputs to skip\n"
"; a = number of outputs that weren't padded with 0's(i.e writable)\n"
"	sub	y1,b	y1,n0\n"
"	move	$ref(nwrite),a\n"
"	sub	x0,a	(r0)+n0\n"
"	cmp	b,a\n"
"; x1 = # of inputs to read; a = # inputs to read + # of padding 0's\n"
"	tge	b,a			; a = # inputs to read\n"
"	add	x0,a	a,x1\n"
"; b = nwrite - # inputs to read - # of padding 0's = # of padding 0's at end	\n"
"	move	$ref(nwrite),b\n"
"	sub	a,b	#$addr(output),r5\n");

CodeBlock CG56ChopVarOffset :: chop (
# line 82 "CG56ChopVarOffset.pl"
"; avoid looping by 0 because 0 means to loop 65536 times\n"
"	clr	a				; a = 0\n"
"	cmp	x0,a	b,y0\n"
"	jge	$label(skip_initial_padding)\n"
"	rep	x0\n"
"	move	a,$mem(output):(r5)+			; insert 0's\n"
"$label(skip_initial_padding)\n"
"	cmp	x1,a\n"
"	jge	$label(skip_copying_input_to_output)\n"
"	do	x1,$label(skip_copying_input_to_output)\n"
"	move	$mem(input):(r0)+,y1\n"
"	move	y1,$mem(output):(r5)+\n"
"$label(skip_copying_input_to_output)\n"
"	cmp	y0,a\n"
"	jge	$label(skip_padding_at_end)\n"
"	rep	y0\n"
"	move	a,$mem(output):(r5)+\n"
"$label(skip_padding_at_end)\n");

CG56ChopVarOffset::CG56ChopVarOffset ()
{
	setDescriptor("This star has the same functionality as the Chop star except now the\noffset parameter is determined at run time through a control input.");
	addPort(offsetCntrl.setPort("offsetCntrl",this,INT));

# line 26 "CG56ChopVarOffset.pl"
offset.setAttributes(A_NONCONSTANT | A_NONSETTABLE);
		// nread and nwrite need to be allocated in memory.
		// one can't use move #$val(nwrite),{x0,a,b} since this
		// puts an 8-bit constant (the value of nwrite) into the
		// 8 MOST significant bits of {x0,a,b}. move $ref(nwrite),x0 
		// does the right thing.
		nread.setAttributes(A_CONSTANT|A_YMEM);
		nwrite.setAttributes(A_CONSTANT|A_YMEM);
		use_past_inputs.setAttributes(A_NONCONSTANT|A_NONSETTABLE);
		use_past_inputs = FALSE;
}

int CG56ChopVarOffset::myExecTime() {
# line 104 "CG56ChopVarOffset.pl"
// can't determine the execution time since the offset is variable
	// return the time to do condition checking(which is fixed) +
	// time to execute chop assuming no padding is done and (nwrite)
	// inputs are written
		return 21 + 20 + 2*int(nwrite);
}

void CG56ChopVarOffset::go() {
# line 40 "CG56ChopVarOffset.pl"
addCode(initRange);
		addCode(chop);
}

// prototype instance for known block list
static CG56ChopVarOffset proto;
static RegisterBlock registerBlock(proto,"ChopVarOffset");
