static const char file_id[] = "CG56CircToLin.pl";
// .cc file generated from CG56CircToLin.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56CircToLin.h"

const char *star_nm_CG56CircToLin = "CG56CircToLin";

const char* CG56CircToLin :: className() const {return star_nm_CG56CircToLin;}

ISA_FUNC(CG56CircToLin,CG56Star);

Block* CG56CircToLin :: makeNew() const { LOG_NEW; return new CG56CircToLin;}

CodeBlock CG56CircToLin :: init (
# line 78 "CG56CircToLin.pl"
"	move	#>$addr(input),x0\n"
"	move	x0,$ref(ptr)\n");

CodeBlock CG56CircToLin :: setupC (
# line 83 "CG56CircToLin.pl"
"	move	$ref(ptr),r0\n"
"	move	#$size(input)-1,m0\n"
"	nop			; can't read from circbuf right away\n");

const char* CG56CircToLin :: oneReal(int i, char* xmemLoc) {
# line 89 "CG56CircToLin.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	move	x:" << (xmemLoc) << ",x0\n"
"	move	x0,$ref(output," << (i) << ")\n";
	return (const char*)_str_;
}

const char* CG56CircToLin :: oneComplex(int i, char* xmemLoc) {
# line 94 "CG56CircToLin.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	move	L:" << (xmemLoc) << ",x\n"
"	move	x,L:$addr(output," << (i) << ")\n";
	return (const char*)_str_;
}

CodeBlock CG56CircToLin :: restore (
# line 99 "CG56CircToLin.pl"
"	move	r0,$ref(ptr)\n"
"	move	m7,m0\n");

CG56CircToLin::CG56CircToLin ()
{
	setDescriptor("Copy data from a circular buffer to a linear buffer.\nIf N is zero (the default), the number of samples transferred per execution\nequals the number of samples read per execution by the star that reads\nfrom the output.");
	addPort(input.setPort("input",this,ANYTYPE));
	input.setAttributes(
# line 31 "CG56CircToLin.pl"
P_CIRC);
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(N.setState("N",this,"0","number to transfer per execution"));
	addState(ptr.setState("ptr",this,"0","storage for pointer register (internal)",
# line 59 "CG56CircToLin.pl"
A_YMEM|A_NOINIT|A_NONSETTABLE));


}

int CG56CircToLin::myExecTime() {
# line 75 "CG56CircToLin.pl"
return 4+2*n;
}

void CG56CircToLin::initCode() {
# line 61 "CG56CircToLin.pl"
addCode(init);
}

void CG56CircToLin::setup() {
# line 47 "CG56CircToLin.pl"
n = int(N);
	if (n == 0) {
	    n = output.far()->numXfer();
	}
	input.setSDFParams(n,n-1);
	output.setSDFParams(n,n-1);
}

void CG56CircToLin::go() {
# line 63 "CG56CircToLin.pl"
if (input.bufSize()>1) addCode(setupC);
	for (int j = 0; j < n; j++) {
	    if (input.resolvedType() == COMPLEX)
		addCode(oneComplex
			(j,input.bufSize()==1?"$addr(input)":"(r0)+"));
	    else
		addCode(oneReal(j,input.bufSize()==1?"$addr(input)":"(r0)+"));
	}
	if (input.bufSize()>1) addCode(restore);
}

// prototype instance for known block list
static CG56CircToLin proto;
static RegisterBlock registerBlock(proto,"CircToLin");
