static const char file_id[] = "CG56Commutator.pl";
// .cc file generated from CG56Commutator.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Commutator.h"

const char *star_nm_CG56Commutator = "CG56Commutator";

const char* CG56Commutator :: className() const {return star_nm_CG56Commutator;}

ISA_FUNC(CG56Commutator,CG56Star);

Block* CG56Commutator :: makeNew() const { LOG_NEW; return new CG56Commutator;}

CodeBlock CG56Commutator :: loadOutputAddress (
# line 49 "CG56Commutator.pl"
"        move    #>$addr(output),r1\n");

const char* CG56Commutator :: moveBlock(int inputNum) {
# line 52 "CG56Commutator.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"" << (int(blockSize)!= 1 ? "\tdo\t#$val(blockSize),$label(txBlock)\n":"") << "        move    $ref(input#" << (inputNum) << "),a\n"
"        move    a,$mem(output):(r1)+" << (int(blockSize)!= 1 ? "\n$label(txBlock)":"") << "\n";
	return (const char*)_str_;
}

CG56Commutator::CG56Commutator ()
{
	setDescriptor("Interleaves the two input signals.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));

# line 47 "CG56Commutator.pl"
noInternalState();
}

int CG56Commutator::myExecTime() {
# line 66 "CG56Commutator.pl"
return (2*(int(input.numberPorts()))+1) ;
}

void CG56Commutator::setup() {
# line 41 "CG56Commutator.pl"
int n = input.numberPorts();
		int bs = int(blockSize);
		input.setSDFParams(bs,bs-1);
		output.setSDFParams(n*bs,n*bs-1);
}

void CG56Commutator::go() {
# line 60 "CG56Commutator.pl"
addCode(loadOutputAddress);
                for (int i = 1; i <= input.numberPorts(); i++) {
                        addCode(moveBlock(i));
                }
}

// prototype instance for known block list
static CG56Commutator proto;
static RegisterBlock registerBlock(proto,"Commutator");
