static const char file_id[] = "CG56Cut.pl";
// .cc file generated from CG56Cut.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Cut.h"

const char *star_nm_CG56Cut = "CG56Cut";

const char* CG56Cut :: className() const {return star_nm_CG56Cut;}

ISA_FUNC(CG56Cut,CG56Star);

Block* CG56Cut :: makeNew() const { LOG_NEW; return new CG56Cut;}

CodeBlock CG56Cut :: main (
# line 67 "CG56Cut.pl"
"        move    #$addr(input,offset),r0\n"
"        move    #$addr(output),r1\n");

CodeBlock CG56Cut :: write (
# line 71 "CG56Cut.pl"
"        do      #$val(nwrite),$label(loop)\n"
"        move    $mem(input):(r0)+,a\n"
"        move    $mem(output),x:(r1)+\n"
"$label(loop)\n");

CG56Cut::CG56Cut ()
{
	setDescriptor("On each execution, this star reads a block of \"nread\" samples (default 128)\nand writes \"nwrite\" of these samples (default 64), skipping the first\n\"offset\" samples (default 0).  It is an error if nwrite + offset > nread.\nIf nwrite > nread, then the output consists of overlapping windows,\nand hence \"offset\" must be negative.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(nread.setState("nread",this,"128","Number of particles read."));
	addState(nwrite.setState("nwrite",this,"64","Number of particles written."));
	addState(offset.setState("offset",this,"0","Position of output block relative to input block."));


}

int CG56Cut::myExecTime() {
# line 82 "CG56Cut.pl"
return 4 + 2*int(nwrite);
}

void CG56Cut::setup() {
# line 59 "CG56Cut.pl"
if (int(nwrite) + int(offset) > int(nread)) {
			Error::abortRun(*this,
			   "nwrite + offset cannot be greater than nread");
			return;
		}
		input.setSDFParams(int(nread),int(nread)-int(offset)-1);
		output.setSDFParams(int(nwrite),int(nwrite)-1);
}

void CG56Cut::go() {
# line 78 "CG56Cut.pl"
addCode(main);
		if(int(nwrite) > 0) addCode(write);
}

// prototype instance for known block list
static CG56Cut proto;
static RegisterBlock registerBlock(proto,"Cut");
