static const char file_id[] = "CG56Delay.pl";
// .cc file generated from CG56Delay.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Delay.h"

const char *star_nm_CG56Delay = "CG56Delay";

const char* CG56Delay :: className() const {return star_nm_CG56Delay;}

ISA_FUNC(CG56Delay,CG56Star);

Block* CG56Delay :: makeNew() const { LOG_NEW; return new CG56Delay;}

CodeBlock CG56Delay :: block (
# line 46 "CG56Delay.pl"
"; initialize delay star\n"
"; pointer to internal buffer\n"
"	org	$ref(delayBufStart)\n"
"  	dc	$addr(delayBuf)\n"
"   	org 	p:\n");

CodeBlock CG56Delay :: one (
# line 53 "CG56Delay.pl"
"        move    $ref(delayBufStart),r0\n"
"        move    $ref(input),x1\n"
"        move    y:(r0),y0\n"
"        move    x1,y:(r0)\n"
"        move    y0,$ref(output)\n");

CodeBlock CG56Delay :: std (
# line 60 "CG56Delay.pl"
"        move    $ref(input),x1\n"
"        move    $ref(delayBufStart),r0\n"
"        move    #$val(totalDelay)-1,m0\n"
"        move    y:(r0),y0\n"
"        move    x1,y:(r0)+\n"
"        move    r0,$ref(delayBufStart)\n"
"        move    y0,$ref(output)\n"
"        move    #-1,m0\n");

CodeBlock CG56Delay :: zero (
# line 70 "CG56Delay.pl"
"	move	$ref(input),a\n"
"	move	a,$ref(output)\n");

CG56Delay::CG56Delay ()
{
	setDescriptor("A delay star of an integer number of time units.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(delayBuf.setState("delayBuf",this,"0","buffer",
# line 31 "CG56Delay.pl"
A_CIRC|A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(delayBufStart.setState("delayBufStart",this,"0","pointer to the buffer",
# line 38 "CG56Delay.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(totalDelay.setState("totalDelay",this,"10","maximum delay"));


}

int CG56Delay::myExecTime() {
# line 90 "CG56Delay.pl"
if (totalDelay==0) return 2;
		else if (totalDelay==1) return 5;
		else return 8;
}

void CG56Delay::initCode() {
# line 78 "CG56Delay.pl"
addCode(block);
}

void CG56Delay::setup() {
# line 75 "CG56Delay.pl"
delayBuf.resize(totalDelay);
}

void CG56Delay::go() {
# line 81 "CG56Delay.pl"
if(totalDelay==0)
		     addCode(zero);
                else if(totalDelay==1)
	             addCode(one);
		else     
                     addCode(std);
}

// prototype instance for known block list
static CG56Delay proto;
static RegisterBlock registerBlock(proto,"Delay");
