static const char file_id[] = "CG56DivByInt.pl";
// .cc file generated from CG56DivByInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56DivByInt.h"

const char *star_nm_CG56DivByInt = "CG56DivByInt";

const char* CG56DivByInt :: className() const {return star_nm_CG56DivByInt;}

ISA_FUNC(CG56DivByInt,CG56Star);

Block* CG56DivByInt :: makeNew() const { LOG_NEW; return new CG56DivByInt;}

CodeBlock CG56DivByInt :: readInputAndMultiplier (
# line 94 "CG56DivByInt.pl"
"	move	$ref(input),x1			; x1 = input\n"
"	move	$ref(gain),x0			; x0 = 1/divisor = gain\n");

CodeBlock CG56DivByInt :: copyInput (
# line 98 "CG56DivByInt.pl"
"	move	$ref(input),x1			; copy input to output\n"
"	move	x1,$ref(output)\n");

CodeBlock CG56DivByInt :: multiplyFixAndInt (
# line 102 "CG56DivByInt.pl"
"	mpy 	x0,x1,a			; multiply/truncate\n");

CodeBlock CG56DivByInt :: testResult (
# line 105 "CG56DivByInt.pl"
"; Register usage: x0 = divisor, x1 = input, y0 = dividend, y1 = -1\n"
"	clr	b	#$val(divisor),x0	a,y0\n"
"	mpy	x0,y0,a			; integer multiplication\n"
"	asr	a\n"
"	cmp	x1,a	#$$FF,y1\n"
"	tlt	y1,b\n"
"	add	b,a\n"
"	move	a0,$ref(output)\n");

CodeBlock CG56DivByInt :: writeOutput (
# line 115 "CG56DivByInt.pl"
"	move	a,$ref(output)\n");

# line 50 "CG56DivByInt.pl"
#define	CG56DIVBYINT_POSTTEST() \
	((int(divisor) < -10) || (int(divisor) > 10))

CG56DivByInt::CG56DivByInt ()
{
	setDescriptor("This is an amplifier.  The integer output is the integer input\ndivided by the integer \"divisor\".");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(divisor.setState("divisor",this,"2","Inverse of the gain of the amplifier."));
	addState(gain.setState("gain",this,"0.5","Inverse of the gain of the amplifier.",
# line 47 "CG56DivByInt.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM));


}

int CG56DivByInt::myExecTime() {
# line 138 "CG56DivByInt.pl"
if ( CG56DIVBYINT_POSTTEST() ) return 10;
		return 4;
}

void CG56DivByInt::setup() {
# line 54 "CG56DivByInt.pl"
// Avoid dividing by zero
		if ( int(divisor) == 0 ) {
		     Error::abortRun(*this, "divisor cannot be zero");
		     return;
		}

		// Find the absolute value and sign of divisor
		int thedivisor = int(divisor);
		int negdivisor = ( thedivisor < 0 );
		if ( negdivisor ) thedivisor = -thedivisor;

		// Integers are 24 bits (1 sign bit + 23 bits)
		int largest56int = 16777215;		// 2^24 - 1
		if ( thedivisor > largest56int ) {
		     Error::abortRun(*this, "divisor is larger than the ",
				     "24-bit representation allows");
		     return;
		}

		// Compute gain as 1/divisor and truncate to 23 bits
		double gain56 = 1.0/double(thedivisor);
		double adjgain56 = double(int(largest56int * gain56)) /
				   double(largest56int);

		// Check if gain56 is too low or too high by one bit
		// We always want divisor/divisor to equal 1 and
		// (divisor - 1)/divisor = 0
		double absdivisord = double(thedivisor);
		double smallest56fix = 1.1920928955078125e-7;	// 2^(-23)
		double threshold = 1.0 + smallest56fix;
		if (adjgain56 * absdivisord > threshold) {
		    adjgain56 -= smallest56fix;
		}
		if (adjgain56 * absdivisord < 1.0) {
		    adjgain56 += smallest56fix;
		}

		if ( negdivisor ) adjgain56 = -adjgain56;
		gain = adjgain56;
}

void CG56DivByInt::go() {
# line 119 "CG56DivByInt.pl"
StringList header = "; Divide input by ";
		header << int(divisor) << "\n";
		addCode(header);

		if ( int(divisor) == 1 ) {
		    addCode(copyInput);
		}
		else {
		    addCode(readInputAndMultiplier);
		    addCode(multiplyFixAndInt);
		    if ( CG56DIVBYINT_POSTTEST() ) {
			addCode(testResult);
		    }
		    else {
		    	addCode(writeOutput);
		    }
		}
}

// prototype instance for known block list
static CG56DivByInt proto;
static RegisterBlock registerBlock(proto,"DivByInt");
