static const char file_id[] = "CG56Gain.pl";
// .cc file generated from CG56Gain.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Gain.h"

const char *star_nm_CG56Gain = "CG56Gain";

const char* CG56Gain :: className() const {return star_nm_CG56Gain;}

ISA_FUNC(CG56Gain,CG56Star);

Block* CG56Gain :: makeNew() const { LOG_NEW; return new CG56Gain;}

CodeBlock CG56Gain :: cbStd (
# line 49 "CG56Gain.pl"
"	move	$ref(input),x1\n"
"	move	#$val(gain),y1\n"
"	mpyr	x1,y1,a\n"
"	move	a,$ref(output)\n");

CodeBlock CG56Gain :: cbZero (
# line 55 "CG56Gain.pl"
"	clr	a\n"
"	move	a,$ref(output)\n");

CodeBlock CG56Gain :: cbNeg (
# line 59 "CG56Gain.pl"
"	move	$ref(input),a\n"
"	neg	a\n"
"	move	a,$ref(output)\n");

CG56Gain::CG56Gain ()
{
	setDescriptor("The output is set to the input multiplied by a gain term.\nThe gain must be in the interval [-1,1].");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(gain.setState("gain",this,"0.5","Gain value"));

# line 30 "CG56Gain.pl"
noInternalState();
}

int CG56Gain::myExecTime() {
# line 33 "CG56Gain.pl"
return identity ? 0 : 5;
}

void CG56Gain::setup() {
# line 26 "CG56Gain.pl"
identity = (gain.asDouble() >= CG56_ONE);
		if (identity) forkInit(input,output);
}

void CG56Gain::go() {
# line 65 "CG56Gain.pl"
if (identity) {
		    ;
		} else if (gain.asDouble()==0.0) {
		    addCode(cbZero);
		} else if (gain.asDouble()==-1.0) {
		    addCode(cbNeg);
	 	} else {
		    addCode(cbStd);
		}
}

// prototype instance for known block list
static CG56Gain proto;
static RegisterBlock registerBlock(proto,"Gain");
