static const char file_id[] = "CG56GainInt.pl";
// .cc file generated from CG56GainInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56GainInt.h"

const char *star_nm_CG56GainInt = "CG56GainInt";

const char* CG56GainInt :: className() const {return star_nm_CG56GainInt;}

ISA_FUNC(CG56GainInt,CG56Star);

Block* CG56GainInt :: makeNew() const { LOG_NEW; return new CG56GainInt;}

CodeBlock CG56GainInt :: cbNeg (
# line 46 "CG56GainInt.pl"
"	move	$ref(input),a			; input\n"
"	neg	a			; negate input\n"
"	move	a,$ref(output)\n");

CodeBlock CG56GainInt :: cbZero (
# line 51 "CG56GainInt.pl"
"	clr	a				; gain of 0\n"
"	move	a,$ref(output)\n");

CodeBlock CG56GainInt :: cbOne (
# line 55 "CG56GainInt.pl"
"; A gain of one has been removed from the system\n");

CodeBlock CG56GainInt :: cbTwo (
# line 58 "CG56GainInt.pl"
"	move	$ref(input),a			; input\n"
"	asl	a				; multiply by 2\n"
"	move	a,$ref(output)\n");

CodeBlock CG56GainInt :: cbThree (
# line 63 "CG56GainInt.pl"
"	move	$ref(input),a			; input\n"
"	asl	a	a,x0		; multiply by 3: 2*input + input \n"
"	add	x0,a\n"
"	move	a,$ref(output)\n");

CodeBlock CG56GainInt :: cbFour (
# line 69 "CG56GainInt.pl"
"	move	$ref(input),a			; input\n"
"	asl	a			; multiply by 4\n"
"	asl	a\n"
"	move	a,$ref(output)\n");

CodeBlock CG56GainInt :: cbFive (
# line 75 "CG56GainInt.pl"
"	move	$ref(input),a			; input\n"
"	asl	a	a,b		; multiply by 5: 4*input + input\n"
"	addl	b,a\n"
"	move	a,$ref(output)\n");

CodeBlock CG56GainInt :: cbStd (
# line 81 "CG56GainInt.pl"
"	move	$ref(input),x1			; input\n"
"	move	#$val(gain),y1			; gain\n"
"	mpy	x1,y1,a\n"
"	asr	a			; adjust for integer multiplication\n"
"	move	a0,$ref(output)\n");

CG56GainInt::CG56GainInt ()
{
	setDescriptor("The output is set to the input multiplied by a gain term.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(gain.setState("gain",this,"2","Gain value"));

# line 40 "CG56GainInt.pl"
noInternalState();
}

int CG56GainInt::myExecTime() {
# line 117 "CG56GainInt.pl"
int pairOfIntervals = 0;
		switch(int(gain)) {
		  case -1:
		    pairOfIntervals = 3;
		    break;
		  case 0:
		    pairOfIntervals = 2;
		    break;
		  case 1:
		    pairOfIntervals = 0;
		    break;
		  case 2:
		    pairOfIntervals = 3;
		    break;
		  case 3:
		  case 4:
		  case 5:
		    pairOfIntervals = 4;
		    break;
		  default:
		    pairOfIntervals = 5;
		    break;
		}
		return pairOfIntervals;
}

void CG56GainInt::setup() {
# line 43 "CG56GainInt.pl"
identity = (int(gain) == 1);
		if (identity) forkInit(input,output);
}

void CG56GainInt::go() {
# line 89 "CG56GainInt.pl"
switch(int(gain)) {
		  case -1:
		    addCode(cbNeg);
		    break;
		  case 0:
		    addCode(cbZero);
		    break;
		  case 1:
		    addCode(cbOne);
		    break;
		  case 2:
		    addCode(cbTwo);
		    break;
		  case 3:
		    addCode(cbThree);
		    break;
		  case 4:
		    addCode(cbFour);
		    break;
		  case 5:
		    addCode(cbFive);
		    break;
		  default:
		    addCode(cbStd);
		    break;
		}
}

// prototype instance for known block list
static CG56GainInt proto;
static RegisterBlock registerBlock(proto,"GainInt");
