static const char file_id[] = "CG56HostAOut.pl";
// .cc file generated from CG56HostAOut.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56HostAOut.h"

const char *star_nm_CG56HostAOut = "CG56HostAOut";

const char* CG56HostAOut :: className() const {return star_nm_CG56HostAOut;}

ISA_FUNC(CG56HostAOut,CG56Star);

Block* CG56HostAOut :: makeNew() const { LOG_NEW; return new CG56HostAOut;}

CodeBlock CG56HostAOut :: cbAioDirect (
# line 95 "CG56HostAOut.pl"
"aio_graph $ref(input,0) $fullname() {$val(label)} $val(blockSize) $val(mode) - $val(yMin) $val(yMax) $val(xMin) $val(xMax)\n");

CodeBlock CG56HostAOut :: cbAioHostLock (
# line 98 "CG56HostAOut.pl"
"aio_graph $ref(buffer,0) $fullname() {$val(label)} $val(blockSize) $val(mode) $ref(bufLock) $val(yMin) $val(yMax) $val(xMin) $val(xMax)\n");

CodeBlock CG56HostAOut :: cbCopy (
# line 101 "CG56HostAOut.pl"
"	move	#$addr(bufLock),r2\n"
"	move	#$addr(input),r0	; copy entire {input} into {buffer}\n"
"	move	#$addr(buffer),r1\n"
"	jset	#0,x:(r2),$label(skip)\n"
"	.LOOP	#$val(blockSize)\n"
"	  move	x:(r0)+,x0\n"
"	  move	x0,y:(r1)+\n"
"	.ENDL\n"
"	bset	#0,x:(r2)\n"
"$label(skip)		\n"
"	nop				; jumps to end MUST have nop (loopsched)\n");

CG56HostAOut::CG56HostAOut ()
{
	setDescriptor("Asynchronous host output.");
	addPort(input.setPort("input",this,FIX));
	addState(label.setState("label",this,"Label","Label for graph on host."));
	addState(blockSize.setState("blockSize",this,"1","Number of samples per block."));
	addState(mode.setState("mode",this,"DIRECT","Communication mode: one-of DIRECT or HOSTLOCK."));
	addState(bufLock.setState("bufLock",this,"0","Semaphore for buffer locking.",
# line 44 "CG56HostAOut.pl"
A_NONCONSTANT|A_NONSETTABLE|A_XMEM));
	addState(buffer.setState("buffer",this,"","Buffer which host reads sample from.",
# line 50 "CG56HostAOut.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(yMin.setState("yMin",this,"-1.0","\"Host mapping of -1 for sample(s).\""));
	addState(yMax.setState("yMax",this,"1.0","\"Host mapping of +1 for sample(s).\""));
	addState(xMin.setState("xMin",this,"-1.0","\"Host x-axis mapping of first sample in block.\""));
	addState(xMax.setState("xMax",this,"1.0","\"Host x-axis mapping of (last+1) sample in block.\""));


}

int CG56HostAOut::myExecTime() {
# line 123 "CG56HostAOut.pl"
return 1;
}

void CG56HostAOut::initCode() {
# line 115 "CG56HostAOut.pl"
addCode( doCopyB ? cbAioHostLock : cbAioDirect, "aioCmds");
}

void CG56HostAOut::setup() {
# line 80 "CG56HostAOut.pl"
input.setSDFParams(int(blockSize),int(blockSize)-1);
	doCopyB = FALSE;
	const char *m = mode;
	/*IF*/ if ( strcmp(m,"DIRECT")==0 ) {
	    buffer.resize(0);
	    buffer.clearAttributes(A_YMEM);
	} else if ( strcmp(m,"HOSTLOCK")==0 ) {
	    buffer.resize(int(blockSize));
	    buffer.setAttributes(A_YMEM);
	    doCopyB = TRUE;
	} else {
	    Error::abortRun(*this,"Invalid mode");
	    return;
	}
}

void CG56HostAOut::go() {
# line 118 "CG56HostAOut.pl"
if ( doCopyB ) {
	    addCode(cbCopy);
	}
}

// prototype instance for known block list
static CG56HostAOut proto;
static RegisterBlock registerBlock(proto,"HostAOut");
