static const char file_id[] = "CG56HostButton.pl";
// .cc file generated from CG56HostButton.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56HostButton.h"

const char *star_nm_CG56HostButton = "CG56HostButton";

const char* CG56HostButton :: className() const {return star_nm_CG56HostButton;}

ISA_FUNC(CG56HostButton,CG56HostASrc);

Block* CG56HostButton :: makeNew() const { LOG_NEW; return new CG56HostButton;}

CodeBlock CG56HostButton :: cbButtonAio (
# line 73 "CG56HostButton.pl"
"$val(canonicalWidget) $ref(value) $fullname() {$val(label)} $val(offVal) $val(onVal) $val(initiallyOn)\n");

CodeBlock CG56HostButton :: cbInitValue (
# line 76 "CG56HostButton.pl"
"	org	$ref(value)\n"
"	dc	$val(initValStr)\n"
"	org	p:\n");

CG56HostButton::CG56HostButton ()
{
	setDescriptor("Graphical two-valued input source.");
	addState(buttonType.setState("buttonType",this,"pushbutton","Type of button: pushbutton, checkbutton."));
	addState(canonicalWidget.setState("canonicalWidget",this,"xxx","Canonical form of widget name.",
# line 46 "CG56HostButton.pl"
A_NONSETTABLE));
	addState(offVal.setState("offVal",this,"0.0","\"Value to output when button off/not pressed (either FIX or INT).\""));
	addState(onVal.setState("onVal",this,"1.0","\"Value to output when button on/pressed (either FIX or INT).\""));
	addState(initiallyOn.setState("initiallyOn",this,"0","\"Boolean: Initial state is on? (checkbutton only)\""));
	addState(initValStr.setState("initValStr",this,"0","\"String form of initial value.\"",
# line 71 "CG56HostButton.pl"
A_NONSETTABLE));


}

void CG56HostButton::initCode() {
# line 100 "CG56HostButton.pl"
addCode(cbButtonAio,"aioCmds");
    	addCode(cbInitValue);
}

void CG56HostButton::setup() {
# line 82 "CG56HostButton.pl"
const char *wn = buttonType;
	/*IF*/ if ( strcmp(wn,"pushbutton")==0 
		 || strcmp(wn,"commandbutton")==0 ) {
	    canonicalWidget = "aio_pushbutton";
	    initiallyOn = 0; // param not really used
	    initValStr = (const char*) offVal;
	} else if ( strcmp(wn,"checkbutton")==0 ) {
	    canonicalWidget = "aio_checkbutton";
	    initiallyOn = int(initiallyOn) ? 1 : 0;
	    initValStr = int(initiallyOn) 
	      ? (const char*) onVal : (const char*) offVal;
	} else {
	    Error::abortRun(*this,"Unknown button type.");
	    return;
	}
	value.setAttributes(A_NOINIT);
}

// prototype instance for known block list
static CG56HostButton proto;
static RegisterBlock registerBlock(proto,"HostButton");
