static const char file_id[] = "CG56HostOut.pl";
// .cc file generated from CG56HostOut.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56HostOut.h"

const char *star_nm_CG56HostOut = "CG56HostOut";

const char* CG56HostOut :: className() const {return star_nm_CG56HostOut;}

ISA_FUNC(CG56HostOut,CG56Star);

Block* CG56HostOut :: makeNew() const { LOG_NEW; return new CG56HostOut;}

CodeBlock CG56HostOut :: cbSingleBlocking (
# line 70 "CG56HostOut.pl"
"$label(wait)\n"
"	jclr	#m_htde,x:m_hsr,$label(wait)\n"
"	jclr	#0,x:m_pbddr,$label(wait)\n"
"	movep	$ref(input),x:m_htx\n");

CodeBlock CG56HostOut :: cbSingleNonBlocking (
# line 76 "CG56HostOut.pl"
"	jclr	#m_htde,x:m_hsr,$label(skip)\n"
"	jclr	#0,x:m_pbddr,$label(slip)\n"
"	movep	$ref(input),x:m_htx\n"
"$label(skip)\n");

CodeBlock CG56HostOut :: cbMultiNonBlocking (
# line 82 "CG56HostOut.pl"
"	jclr	#m_htde,x:m_hsr,$label(skip)\n"
"	jclr	#0,x:m_pbddr,$label(skip)\n"
"	move	#$addr(input),r0\n"
"	.LOOP	#$val(samplesOutput)\n"
"$label(wait)\n"
"	jclr	#m_htde,x:m_hsr,$label(wait)\n"
"	jclr	#0,x:m_pbddr,$label(wait)\n"
"	movep	x:(r0)+,x:m_htx\n"
"	.ENDL\n"
"	nop\n"
"$label(skip)\n");

CodeBlock CG56HostOut :: cbMultiBlocking (
# line 95 "CG56HostOut.pl"
"	move	#$addr(input),r0\n"
"	.LOOP	#$val(samplesOutput)\n"
"$label(wait)\n"
"	jclr	#m_htde,x:m_hsr,$label(wait)\n"
"	jclr	#0,x:m_pbddr,$label(wait)\n"
"	movep	x:(r0)+,x:m_htx\n"
"	.ENDL\n"
"	nop\n");

CG56HostOut::CG56HostOut ()
{
	setDescriptor("Synchronous host port output.");
	addPort(input.setPort("input",this,FIX));
	addState(samplesConsumed.setState("samplesConsumed",this,"1","Number of samples consumed."));
	addState(samplesOutput.setState("samplesOutput",this,"1","Number of samples transferred to host."));
	addState(blockOnHost.setState("blockOnHost",this,"YES","Boolean: wait until host ready?"));
	addState(command.setState("command",this,"",""));


}

int CG56HostOut::myExecTime() {
# line 122 "CG56HostOut.pl"
return 2;
}

void CG56HostOut::initCode() {
# line 65 "CG56HostOut.pl"
const char* p=command;
		StringList cmd;
		cmd << command << "\n";
		if (p[0] != 0) addCode(command,"shellCmds");
}

void CG56HostOut::setup() {
# line 62 "CG56HostOut.pl"
input.setSDFParams(int(samplesConsumed),int(samplesConsumed)-1);
}

void CG56HostOut::go() {
# line 106 "CG56HostOut.pl"
if (int(samplesConsumed)==1) {
			if ( int(blockOnHost) ) {
				addCode(cbSingleBlocking);
			} else {
				addCode(cbSingleNonBlocking);
			}
		} else {
			if ( int(blockOnHost) ) {
				addCode(cbMultiBlocking);
			} else {
				addCode(cbMultiNonBlocking);
			}
		}
}

// prototype instance for known block list
static CG56HostOut proto;
static RegisterBlock registerBlock(proto,"HostOut");
