static const char file_id[] = "CG56HostSldr.pl";
// .cc file generated from CG56HostSldr.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56HostSldr.h"

const char *star_nm_CG56HostSldr = "CG56HostSldr";

const char* CG56HostSldr :: className() const {return star_nm_CG56HostSldr;}

ISA_FUNC(CG56HostSldr,CG56HostASrc);

Block* CG56HostSldr :: makeNew() const { LOG_NEW; return new CG56HostSldr;}

CodeBlock CG56HostSldr :: cbSliderAio (
# line 82 "CG56HostSldr.pl"
"aio_slider $ref(value) $fullname() \"$val(label)\" $val(hostMin) $val(hostMax) $val(hostInitVal) $val(dspMin) $val(dspMax) \"$val(scale)\"\n");

CG56HostSldr::CG56HostSldr ()
{
	setDescriptor("Graphical host slider for asynchronous input source.");
	addState(hostMin.setState("hostMin",this,"-1","Host minimum value."));
	addState(hostMax.setState("hostMax",this,"1","Host maximum value."));
	addState(hostInitVal.setState("hostInitVal",this,"0","Initial value."));
	addState(dspMin.setState("dspMin",this,"-1","DSP minimum value."));
	addState(dspMax.setState("dspMax",this,"1","DSP maximum value."));
	addState(scale.setState("scale",this,"linear","\"type of scale(mapping)\"."));


}

void CG56HostSldr::initCode() {
# line 108 "CG56HostSldr.pl"
addCode(cbSliderAio,"aioCmds");
}

void CG56HostSldr::setup() {
# line 86 "CG56HostSldr.pl"
double hlo = double(hostMin), hhi = double(hostMax);
	double dlo = dspMin.asDouble(),  dhi = dspMax.asDouble();
	double hinit = double(hostInitVal), dinit;
	if ( hlo == hhi ) {
	    Error::abortRun(*this,"Host range most be nonempty.");
	    return;
	}
	if ( hinit < min(hlo,hhi) || hinit > max(hlo,hhi) ) {
	    Error::abortRun(*this,"Host initial value is out-of-range");
	    return;
	}
	double fRatio = (dhi-dlo)/(hhi-hlo);
	dinit = (hinit-hlo)*fRatio + dlo;
	if ( dinit < -1.0 || dinit > 1.0 ) {
	    Error::abortRun(*this,"Dsp initial value is out-of-range");
	    return;
	}
	if ( dinit > CG56_ONE )
	    dinit = CG56_ONE;
	value = dinit;
}

// prototype instance for known block list
static CG56HostSldr proto;
static RegisterBlock registerBlock(proto,"HostSldr");
