static const char file_id[] = "CG56HostSldrGX.pl";
// .cc file generated from CG56HostSldrGX.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56HostSldrGX.h"
#include "StringState.h"
#include "CGTarget.h"
#include "StringList.h"

const char *star_nm_CG56HostSldrGX = "CG56HostSldrGX";

const char* CG56HostSldrGX :: className() const {return star_nm_CG56HostSldrGX;}

ISA_FUNC(CG56HostSldrGX,CG56Star);

Block* CG56HostSldrGX :: makeNew() const { LOG_NEW; return new CG56HostSldrGX;}

CodeBlock CG56HostSldrGX :: aio (
# line 93 "CG56HostSldrGX.pl"
"slider $starSymbol(SLIDER) $fullname() $val(hostMin) $val(hostMax) $val(hostInitialValue) $val(dspMin) $val(dspMax) $val(scale) \"$val(description)\"\n");

CodeBlock CG56HostSldrGX :: orgout (
# line 97 "CG56HostSldrGX.pl"
"	org	$ref(output)\n"
"$starSymbol(SLIDER)\n"
"	dc	$val(initVal)\n"
"	org	p:\n");

CodeBlock CG56HostSldrGX :: orgval (
# line 104 "CG56HostSldrGX.pl"
"	org	$ref(value)\n"
"$starSymbol(SLIDER)\n"
"	dc	$val(initVal)\n"
"	org	p:\n");

CodeBlock CG56HostSldrGX :: done (
# line 111 "CG56HostSldrGX.pl"
"	move	$ref(value),x0		; move value to output\n"
"	move	x0,$ref(output)\n");

CG56HostSldrGX::CG56HostSldrGX ()
{
	setDescriptor("Host port Slider");
	addPort(output.setPort("output",this,FIX));
	addState(description.setState("description",this,"Slider","put a description"));
	addState(hostMin.setState("hostMin",this,"0","minimum"));
	addState(hostMax.setState("hostMax",this,"100","maximum"));
	addState(hostInitialValue.setState("hostInitialValue",this,"0","initial value"));
	addState(dspMin.setState("dspMin",this,"0.0","minimum"));
	addState(dspMax.setState("dspMax",this,"ONE","maximum"));
	addState(scale.setState("scale",this,"linear","type of scaler"));
	addState(value.setState("value",this,"0","internal",
# line 77 "CG56HostSldrGX.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(initVal.setState("initVal",this,"0","internal",
# line 84 "CG56HostSldrGX.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(initValdB.setState("initValdB",this,"0","internal",
# line 91 "CG56HostSldrGX.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

int CG56HostSldrGX::myExecTime() {
# line 159 "CG56HostSldrGX.pl"
return 1;
}

void CG56HostSldrGX::initCode() {
# line 121 "CG56HostSldrGX.pl"
StringList cmd, base;
		base << *((StringState*) cgTarget()->stateWithName("file"));
		cmd << "gxslider -t " <<  base << " " << base << ".lod "
		    << base << ".aio " << "\n";
		addCode(cmd,"shellCmds","Slider");
		addCode(aio,"aioCmds");
		int t1 = hostInitialValue - hostMin;
		int hrange = hostMax - hostMin;
		double drange = dspMax.asDouble() - dspMin.asDouble();
		double ival = double(t1) / hrange * drange + dspMin.asDouble();
		initVal = ival;
		initValdB= pow(10.0, ival / 20.0);

		const char* p=scale;
		switch(*p) {
			case 'l': case 'L':	// linear
				break;
			case 'd': case 'D':	//dB
				initVal=initValdB;
				break;
			default:
				Error::abortRun(*this, "string must be linear or db");
			return;
	}
		if(1) 
			addCode(orgout);
		else 
			addCode(orgval);
}

void CG56HostSldrGX::setup() {
# line 117 "CG56HostSldrGX.pl"
if (1) output.setAttributes(P_NOINIT);
}

void CG56HostSldrGX::go() {
# line 152 "CG56HostSldrGX.pl"
if (1)
			return; // no runtime code;
		else
			addCode(done);
}

// prototype instance for known block list
static CG56HostSldrGX proto;
static RegisterBlock registerBlock(proto,"HostSldrGX");
