static const char file_id[] = "CG56IntToBits.pl";
// .cc file generated from CG56IntToBits.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
	All rights reserved.
	See the file $PTOLEMY/copyright for copyright notice,
	limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56IntToBits.h"

const char *star_nm_CG56IntToBits = "CG56IntToBits";

const char* CG56IntToBits :: className() const {return star_nm_CG56IntToBits;}

ISA_FUNC(CG56IntToBits,CG56Star);

Block* CG56IntToBits :: makeNew() const { LOG_NEW; return new CG56IntToBits;}

CodeBlock CG56IntToBits :: readNwrite (
# line 42 "CG56IntToBits.pl"
"	move    #>($addr(output)+$val(nBits)-1),r0\n"
"	move    $ref(input),a1\n"
"	move	#>1,x0\n"
"        do      #$val(nBits),$label(decompress)\n"
"	clr	b\n"
"        lsr     a\n"
"	tcs     x0,b\n"
"	move	b,x:(r0)-\n"
"$label(decompress)\n");

CG56IntToBits::CG56IntToBits ()
{
	setDescriptor("Read the least significant nBits bits from an integer input,\nand output the bits as integers serially on the output,\nmost significant bit first.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(nBits.setState("nBits",this,"23","Number of bits to place in one word"));

# line 33 "CG56IntToBits.pl"
noInternalState();
}

int CG56IntToBits::myExecTime() {
# line 57 "CG56IntToBits.pl"
return int(nBits)*3;
}

void CG56IntToBits::setup() {
# line 36 "CG56IntToBits.pl"
if (int(nBits) > 23) {
	    Error::abortRun(*this,"nBits needs to be less than 24");
	    return;
	}
	output.setSDFParams(int(nBits),int(nBits)-1);
}

void CG56IntToBits::go() {
# line 54 "CG56IntToBits.pl"
addCode(readNwrite);
}

// prototype instance for known block list
static CG56IntToBits proto;
static RegisterBlock registerBlock(proto,"IntToBits");
