static const char file_id[] = "CG56Intgrtr.pl";
// .cc file generated from CG56Intgrtr.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Intgrtr.h"

const char *star_nm_CG56Intgrtr = "CG56Intgrtr";

const char* CG56Intgrtr :: className() const {return star_nm_CG56Intgrtr;}

ISA_FUNC(CG56Intgrtr,CG56Star);

Block* CG56Intgrtr :: makeNew() const { LOG_NEW; return new CG56Intgrtr;}

CodeBlock CG56Intgrtr :: cbSetup (
# line 70 "CG56Intgrtr.pl"
"	move	$ref(input),a\n"
"	move	$ref(sum),y0\n");

CodeBlock CG56Intgrtr :: cbCoreReset (
# line 74 "CG56Intgrtr.pl"
"	IF	$val(unityGainB)\n"
"	  add	y0,a	#$val(initialValue),y0\n"
"	ELSE\n"
"	  move	#$val(feedbackGain),x0\n"
"	  macr	x0,y0,a	#$val(initialValue),y0\n"
"	ENDIF\n"
"	tes	y0,a	 ; If the Extension bit is set, replace with init value\n"
" 	move	a,$ref(output)\n"
"	move	a,$ref(sum)\n");

CodeBlock CG56Intgrtr :: cbCoreSat (
# line 86 "CG56Intgrtr.pl"
"	IF	$val(unityGainB)\n"
"	  add	y0,a\n"
"	ELSE\n"
"	  move	#$val(feedbackGain),x0\n"
"	  macr	x0,y0,a\n"
"	ENDIF\n"
"	move	a,$ref(output)\n"
"	move	a,$ref(sum)\n");

CodeBlock CG56Intgrtr :: cbCoreWrap (
# line 97 "CG56Intgrtr.pl"
"	IF	$val(unityGainB)\n"
"	  add	y0,a\n"
"	ELSE\n"
"	  move	#$val(feedbackGain),x0\n"
"	  macr	x0,y0,a\n"
"	ENDIF\n"
"	move	a1,$ref(output)\n"
"	move	a1,$ref(sum)\n");

CG56Intgrtr::CG56Intgrtr ()
{
	setDescriptor("An integrator with leakage and limits.  With the default parameters,\ninput samples are simply accumulated, and the running sum is the\noutput.  If there is an overflow, the integrator will wrap around.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(feedbackGain.setState("feedbackGain",this,"ONE","The gain on the feedback path."));
	addState(unityGainB.setState("unityGainB",this,"0","\"Boolean: is the feedbackGain unity?\"",
# line 46 "CG56Intgrtr.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(onOverflow.setState("onOverflow",this,"wrap around","On overflow, either wrap around, saturate or reset."));
	addState(initialValue.setState("initialValue",this,"0","Value at time zero and also reset value if used."));
	addState(sum.setState("sum",this,"0","An internal state.",
# line 65 "CG56Intgrtr.pl"
A_NONSETTABLE|A_YMEM|A_NONCONSTANT));


}

int CG56Intgrtr::myExecTime() {
# line 131 "CG56Intgrtr.pl"
const char *p = onOverflow;
	if (p[0]=='r') return 11;
	else return 9;
}

void CG56Intgrtr::setup() {
# line 109 "CG56Intgrtr.pl"
sum = initialValue;
	unityGainB = (feedbackGain.asDouble() >= CG56_ONE);
}

void CG56Intgrtr::go() {
# line 113 "CG56Intgrtr.pl"
addCode(cbSetup);
	const char *p = onOverflow;
	switch (p[0]) {
	case('r'):		//Reset on overflow
		addCode(cbCoreReset);
		break;
	case('s'):		//Saturate on overflow
		addCode(cbCoreSat);
		break;
	case('w'):		//Wrap around on overflow
		addCode(cbCoreWrap);
		break;
	default:
		Error::abortRun(*this,"Unrecognized onOverflow option in CG56Intgrtr.");
		break;
	}
}

// prototype instance for known block list
static CG56Intgrtr proto;
static RegisterBlock registerBlock(proto,"Intgrtr");
