static const char file_id[] = "CG56LinToCirc.pl";
// .cc file generated from CG56LinToCirc.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56LinToCirc.h"

const char *star_nm_CG56LinToCirc = "CG56LinToCirc";

const char* CG56LinToCirc :: className() const {return star_nm_CG56LinToCirc;}

ISA_FUNC(CG56LinToCirc,CG56Star);

Block* CG56LinToCirc :: makeNew() const { LOG_NEW; return new CG56LinToCirc;}

CodeBlock CG56LinToCirc :: init (
# line 75 "CG56LinToCirc.pl"
"	move	#>$addr(output),x0\n"
"	move	x0,$ref(ptr)\n");

CodeBlock CG56LinToCirc :: setupC (
# line 80 "CG56LinToCirc.pl"
"	move	#$size(output)-1,m0\n"
"	move	$ref(ptr),r0\n");

const char* CG56LinToCirc :: oneReal(int i, char* xmemLoc) {
# line 85 "CG56LinToCirc.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	move	$ref(input," << (i) << "),x0\n"
"	move	x0,x:" << (xmemLoc) << "\n";
	return (const char*)_str_;
}

const char* CG56LinToCirc :: oneComplex(int i, char* xmemLoc) {
# line 90 "CG56LinToCirc.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	move	L:$addr(input," << (i) << "),x\n"
"	move	x,L:" << (xmemLoc) << "\n";
	return (const char*)_str_;
}

CodeBlock CG56LinToCirc :: restore (
# line 95 "CG56LinToCirc.pl"
"	move	r0,$ref(ptr)\n"
"	move	m7,m0\n");

CG56LinToCirc::CG56LinToCirc ()
{
	setDescriptor("Copy data from a linear buffer to a circular buffer.  If N is zero (default),\nthe number transferred per execution equals the number written per execution\nby the star that feeds the input.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.setAttributes(
# line 33 "CG56LinToCirc.pl"
P_CIRC);
	output.inheritTypeFrom(input);
	addState(N.setState("N",this,"0","number to transfer per execution"));
	addState(ptr.setState("ptr",this,"0","storage for pointer register",
# line 46 "CG56LinToCirc.pl"
A_YMEM|A_NOINIT|A_NONSETTABLE));


}

int CG56LinToCirc::myExecTime() {
# line 72 "CG56LinToCirc.pl"
return 4+2*n;
}

void CG56LinToCirc::initCode() {
# line 58 "CG56LinToCirc.pl"
addCode(init);
}

void CG56LinToCirc::setup() {
# line 52 "CG56LinToCirc.pl"
n = int(N);
	if (n == 0)
	    n = input.far()->numXfer();
	input.setSDFParams(n,n-1);
	output.setSDFParams(n,n-1);
}

void CG56LinToCirc::go() {
# line 60 "CG56LinToCirc.pl"
if (output.bufSize()>1) addCode(setupC);
	for (int j = 0; j < n; j++) {
	    if (input.resolvedType() == COMPLEX)
		addCode(oneComplex
			(j,output.bufSize()==1?"$addr(output)":"(r0)+"));
	    else
		addCode(oneReal(j,output.bufSize()==1?"$addr(output)":"(r0)+"));
	}
	if (output.bufSize()>1) addCode(restore);
}

// prototype instance for known block list
static CG56LinToCirc proto;
static RegisterBlock registerBlock(proto,"LinToCirc");
