static const char file_id[] = "CG56Logic.pl";
// .cc file generated from CG56Logic.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Logic.h"

const char *star_nm_CG56Logic = "CG56Logic";

const char* CG56Logic :: className() const {return star_nm_CG56Logic;}

ISA_FUNC(CG56Logic,CG56Star);

Block* CG56Logic :: makeNew() const { LOG_NEW; return new CG56Logic;}

CodeBlock CG56Logic :: inverter (
# line 90 "CG56Logic.pl"
"	clr	b	$ref(input#1),a		; b = 0, a = input#1\n"
"	tst	a	#$$01,y1	; test a, set y1 = 1\n"
"	teq	y1,b			; if a = 0, then b = y1 = 1\n"
"	move	b,$ref(output)			; output = b\n");

CodeBlock CG56Logic :: copyInput (
# line 97 "CG56Logic.pl"
"	move	$ref(input#1),a		; copy input to output\n"
"	move	a,$ref(ouput)\n");

CodeBlock CG56Logic :: twoInputAnd (
# line 104 "CG56Logic.pl"
"	move	$ref(input#1),x0		; x0 = input#1\n"
"	move	$ref(input#2),x1		; x1 = input#2\n"
"	mpy	x1,x0,a		#255,y0	; a = x0 * x1 and y0 = TRUE\n"
"	tst	a			; test a\n"
"	tne	y0,a			; if (a != 0) a = TRUE\n");

CodeBlock CG56Logic :: prepareAndLoop (
# line 114 "CG56Logic.pl"
"	move	#<$addr(input#1)+1,r0		; r0 = input block address + 1\n"
"	clr	b	$ref(input#1),a		; a = input#1\n"
"	move    b,y0			; y0 = FALSE\n"
"	tst	a	x:(r0)+,b\n");

const char* CG56Logic :: logicAndOpAndLoad(int numinputs) {
# line 121 "CG56Logic.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	do	#" << (numinputs) << "-1,$label(AndLoop)\n"
"	teq	y0,a			; if previous = 0, then a = FALSE\n"
"	tst	b	x:(r0)+,b	; test previous and load next input\n"
"$label(AndLoop)\n"
"	teq	y0,a			; if previous = 0, then a = FALSE\n";
	return (const char*)_str_;
}

CodeBlock CG56Logic :: logicOrOp (
# line 129 "CG56Logic.pl"
"	or	x0,a\n");

const char* CG56Logic :: logicOrOpAndLoad(int i) {
# line 133 "CG56Logic.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	or	x0,a	$ref(input#" << (i) << "),x0\n";
	return (const char*)_str_;
}

CodeBlock CG56Logic :: beginXor (
# line 137 "CG56Logic.pl"
"	move	#<$addr(input#1)+1,r0		; r0 = pointer into input block\n"
"	clr	a	$ref(input#1),b		; a contains result\n");

const char* CG56Logic :: logicXorOpAndLoad(int numinputs) {
# line 142 "CG56Logic.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	do	#" << (numinputs) << "-1,$label(Xor)\n"
"	not	a	a,y0		; save a in y0 and invert a\n"
"	tst	b	x:(r0)+,b	; test input and read next input\n"
"	teq	y0,a			; restore a if input != 0\n"
"$label(Xor)\n";
	return (const char*)_str_;
}

CodeBlock CG56Logic :: endXor (
# line 150 "CG56Logic.pl"
"	not	a	a,y0		; save a in y0 and invert a\n"
"	tst	b			; test input and read next input\n"
"	teq	y0,a			; restore a if input != 0\n");

const char* CG56Logic :: loadAccumulator(int i) {
# line 158 "CG56Logic.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	move	$ref(input#" << (i) << "),a			; read input#" << (i) << " to accumulator a\n";
	return (const char*)_str_;
}

const char* CG56Logic :: loadx0(int i) {
# line 162 "CG56Logic.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	move	$ref(input#" << (i) << "),x0			; read input#" << (i) << " to register x0\n";
	return (const char*)_str_;
}

CodeBlock CG56Logic :: invertAccumulator (
# line 166 "CG56Logic.pl"
"	clr	b			; b = FALSE\n"
"	tst	a	#255,x0		; x0 = TRUE\n"
"	teq	x0,a			; if (a == FALSE) a = x0\n"
"	tne	b,a			; if (a != FALSE) a = FALSE\n");

CodeBlock CG56Logic :: saveResult (
# line 173 "CG56Logic.pl"
"	move    a,$ref(output)\n");

# line 56 "CG56Logic.pl"
#define NOTID 0
#define ANDID 1
#define NANDID 2
#define ORID 3
#define NORID 4
#define XORID 5
#define XNORID 6

CG56Logic::CG56Logic ()
{
	setDescriptor("This star applies a logical operation to any number of inputs.\nThe inputs are integers interpreted as Boolean values,\nwhere zero means FALSE and a nonzero value means TRUE.\nThe logical operations supported are {NOT AND NAND OR NOR XOR XNOR}.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(logic.setState("logic",this,"AND","The test logic: one of NOT AND NAND OR NOR XOR or XNOR."));

# line 68 "CG56Logic.pl"
noInternalState();
		test = NOTID;
}

int CG56Logic::myExecTime() {
# line 241 "CG56Logic.pl"
int numinputs = input.numberPorts();

		// Time to read one input and write one output
		int pairsOfCycles = 2;

		switch( pairsOfCycles ) {
		  case NOTID:
		    pairsOfCycles += 2;
		    break;

		  case NANDID:
		    pairsOfCycles += 4;
		    // fall through
		  case ANDID:
		    if (numinputs == 2) pairsOfCycles += 5;
		    else if (pairsOfCycles > 2) pairsOfCycles += 2*numinputs+2;
		    break;

		  case NORID:
		    pairsOfCycles += 4;
		    // fall through
		  case ORID:
		    pairsOfCycles += numinputs;
		    break;

		  case XNORID:
		    pairsOfCycles += 4;
		    // fall through
		  case XORID:
		    pairsOfCycles += 3*numinputs;
		    break;
		}

		return pairsOfCycles;
}

void CG56Logic::setup() {
# line 72 "CG56Logic.pl"
const char* cn = logic;
		if ( strcasecmp(cn, "NOT") == 0) {
		    test = NOTID;
		    if (input.numberPorts() > 1)
			Error::abortRun(*this,
			    "NOT operation can only have one input");
		}
		else if ( strcasecmp(cn, "AND") == 0 ) test = ANDID;
		else if ( strcasecmp(cn, "NAND") == 0 ) test = NANDID;
		else if ( strcasecmp(cn, "OR") == 0 ) test = ORID;
		else if ( strcasecmp(cn, "NOR") == 0 ) test = NORID;
		else if ( strcasecmp(cn, "XOR") == 0 ) test = XORID;
		else if ( strcasecmp(cn, "XNOR") == 0 ) test = XNORID;
		else Error::abortRun(*this, "Unrecognized test.");
}

void CG56Logic::go() {
# line 178 "CG56Logic.pl"
int numinputs = input.numberPorts();
		const char* cn = logic;
		StringList header = "; Boolean ";
		header << cn << " for " << input.numberPorts() << " inputs";

		// The inverter (not) star is the simplest case
		if ( numinputs == 1 ) {
			addCode(header);
			if ( test == NOTID || test == NANDID ||
			     test == NORID || test == XNORID ) {
				addCode(inverter);
			}
			else {
				addCode(copyInput);
			}
			return;
		}

		// For the other stars, we loop through the inputs
		int i = 1;
		header << " using ";

		switch( test ) {
		    case ANDID:
		    case NANDID:
			header << "integer multiplication";
			addCode(header);
			if ( numinputs == 2 ) {
				addCode(twoInputAnd);
			}
			else {
				addCode(prepareAndLoop);
				addCode(logicAndOpAndLoad(numinputs));
			}
			break;
		    case ORID:
		    case NORID:
			header << "positive logic";
			addCode(header);
			addCode(loadAccumulator(1));
			addCode(loadx0(2));
			for (i = 3; i < numinputs; i++ ) {
				addCode(logicOrOpAndLoad(i));
			}
			addCode(logicOrOp);
			break;
		    case XORID:
		    case XNORID:
			header << "positive logic";
			addCode(header);
			addCode(beginXor);
			addCode(logicXorOpAndLoad(numinputs));
			addCode(endXor);
			break;
		}

		// Compute final result, adjusting for positive/negative logic
		if (test == NANDID || test == NORID || test == XNORID ) {
			addCode(invertAccumulator);
		}
		addCode(saveResult);
}

// prototype instance for known block list
static CG56Logic proto;
static RegisterBlock registerBlock(proto,"Logic");
