static const char file_id[] = "CG56LookupTbl.pl";
// .cc file generated from CG56LookupTbl.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56LookupTbl.h"

const char *star_nm_CG56LookupTbl = "CG56LookupTbl";

const char* CG56LookupTbl :: className() const {return star_nm_CG56LookupTbl;}

ISA_FUNC(CG56LookupTbl,CG56Star);

Block* CG56LookupTbl :: makeNew() const { LOG_NEW; return new CG56LookupTbl;}

CodeBlock CG56LookupTbl :: addblockinit (
# line 136 "CG56LookupTbl.pl"
"; initialize for added value\n"
"        org     $ref(addedVal)\n"
"        dc      $val(addedVal)\n"
"        org     p:\n");

CodeBlock CG56LookupTbl :: none (
# line 142 "CG56LookupTbl.pl"
"        move            $ref(input),x1  ;Lookup\n"
"        move            #>$val(coefNum),y1\n"
"        mpy   x1,y1,a           ;w/o interp.\n"
"        add   y1,a\n"
"        asr   a         #>$addr(coef),n0\n"
"        move            a,r0\n"
"        nop\n"
"        move            y:(r0+n0),a\n"
"        move            a,$ref(output)\n");

CodeBlock CG56LookupTbl :: other (
# line 153 "CG56LookupTbl.pl"
"        move            $ref(input),x1  ;Lookup\n"
"        move            #>$val(coefNum),y1\n"
"        mpy   x1,y1,a           ;w/ interp.\n"
"        add   y1,a      #<$$80,b         ;-1\n"
"        asr   a         #>$addr(coef),y1\n"
"        add   y1,a      a0,b1\n"
"        asr   b         a,r0\n"
"        move            #<$$40,a         ;.5\n"
"        addl  b,a       y:(r0)+,y1  b,x1\n"
"        mpy  -x1,y1,a   y:(r0),y1   a,x1\n"
"        macr +x1,y1,a\n"
"        move            a,$ref(output)\n");

CG56LookupTbl::CG56LookupTbl ()
{
	setDescriptor("Table Lookup");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(interpolation.setState("interpolation",this,"linear","interpolation"));
	addState(tableType.setState("tableType",this,"periodic","type of table used."));
	addState(coef.setState("coef",this,"-0.5 0.5","values stored in file.",
# line 87 "CG56LookupTbl.pl"
A_YMEM|A_CONSEC));
	addState(addedVal.setState("addedVal",this,"0","internal",
# line 94 "CG56LookupTbl.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(coefNum.setState("coefNum",this,"2","Number of coefficients.",
# line 101 "CG56LookupTbl.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

int CG56LookupTbl::myExecTime() {
# line 168 "CG56LookupTbl.pl"
const char* i = interpolation;  
                if (i[0]=='n' || i[0]=='N')
	            return 14;
                else
	            return 16;
}

void CG56LookupTbl::initCode() {
# line 107 "CG56LookupTbl.pl"
const char* p=tableType;
        const char* r = interpolation;
                if(r[0]=='l' || r[0]=='L') {
                          switch (p[4]) {
	                  case 'o': case 'O':      // periodic
                               addedVal=coef[0];
  		               break;
	     	          case 't': case 'T':      // limited
			       addedVal=coef[coefNum-1];
		               break;
                          case 'a': case 'A':      // linear
                               addedVal=2*coef[coefNum-1]-coef[coefNum-2];
                               break;
            	          }
                          addCode(addblockinit);
		}
}

void CG56LookupTbl::setup() {
# line 104 "CG56LookupTbl.pl"
coefNum=coef.size();
}

void CG56LookupTbl::go() {
# line 125 "CG56LookupTbl.pl"
const char* q = interpolation;
		switch (q[0]) {
		case 'n': case 'N':    	// none
			addCode(none);
			break;
		default:
			addCode(other);
			return;
	        }
}

// prototype instance for known block list
static CG56LookupTbl proto;
static RegisterBlock registerBlock(proto,"LookupTbl");
