static const char file_id[] = "CG56MaxMin.pl";
// .cc file generated from CG56MaxMin.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56MaxMin.h"

const char *star_nm_CG56MaxMin = "CG56MaxMin";

const char* CG56MaxMin :: className() const {return star_nm_CG56MaxMin;}

ISA_FUNC(CG56MaxMin,CG56Star);

Block* CG56MaxMin :: makeNew() const { LOG_NEW; return new CG56MaxMin;}

CodeBlock CG56MaxMin :: main (
# line 66 "CG56MaxMin.pl"
"; Register usage:\n"
"; r0 = address of the input values\n"
"; r1 = index of current input value\n"
"; r2 = index of min/max value\n"
"; a = current input value\n"
"	clr	b\n"
"	move	b,r1\n"
"	move	#<$addr(input),r0\n"
"	move	b,r2\n"
"	move	x:(r0)+,a\n"
"	do	#$val(N)-1,$starSymbol(end)\n"
"	move	x:(r0)+,x1\n");

CodeBlock CG56MaxMin :: cmpMagYes (
# line 80 "CG56MaxMin.pl"
"	cmpm	x1,a	(r1)+\n");

CodeBlock CG56MaxMin :: cmpMagNo (
# line 83 "CG56MaxMin.pl"
"	cmp	x1,a	(r1)+\n");

CodeBlock CG56MaxMin :: maxcont (
# line 86 "CG56MaxMin.pl"
"	tlt	x1,a	r1,r2\n"
"$starSymbol(end)\n");

CodeBlock CG56MaxMin :: mincont (
# line 90 "CG56MaxMin.pl"
"	tgt	x1,a	r1,r2	; if x1 < a, move x1 into a and r1 into r2\n"
"$starSymbol(end)\n");

CodeBlock CG56MaxMin :: one (
# line 94 "CG56MaxMin.pl"
"	move	$ref(input),a\n");

CodeBlock CG56MaxMin :: outMagYes (
# line 97 "CG56MaxMin.pl"
"	abs	a\n");

CodeBlock CG56MaxMin :: out (
# line 100 "CG56MaxMin.pl"
"	move	a,$ref(output)\n"
"	move	r2,$ref(index)\n");

CG56MaxMin::CG56MaxMin ()
{
	setDescriptor("Finds maximum or minimum value");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addPort(index.setPort("index",this,INT));
	addState(N.setState("N",this,"10","default samples"));
	addState(MAX.setState("MAX",this,"YES","output maximum value else minimum is the output"));
	addState(compareMagnitude.setState("compareMagnitude",this,"NO","default is not to compare magnitude"));
	addState(outputMagnitude.setState("outputMagnitude",this,"NO","default is not to output magnitude"));


}

int CG56MaxMin::myExecTime() {
# line 127 "CG56MaxMin.pl"
if (int(N) > 10)
			return (6*(int(N)-1))+7;
		else
			return 3;
}

void CG56MaxMin::setup() {
# line 62 "CG56MaxMin.pl"
noInternalState();
		input.setSDFParams(int(N),int(N)-1);
}

void CG56MaxMin::go() {
# line 105 "CG56MaxMin.pl"
if (int(N) > 1) {
			addCode(main);
			if (int(compareMagnitude))
				addCode(cmpMagYes);
			else
				addCode(cmpMagNo);
			if (int(MAX))
				addCode(maxcont);
			else
				addCode(mincont);				
		}
		else
			addCode(one);

		if (int(outputMagnitude)) {
			addCode(outMagYes);
		}
			
		addCode(out);
}

// prototype instance for known block list
static CG56MaxMin proto;
static RegisterBlock registerBlock(proto,"MaxMin");
