static const char file_id[] = "CG56ModuloInt.pl";
// .cc file generated from CG56ModuloInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56ModuloInt.h"

const char *star_nm_CG56ModuloInt = "CG56ModuloInt";

const char* CG56ModuloInt :: className() const {return star_nm_CG56ModuloInt;}

ISA_FUNC(CG56ModuloInt,CG56Star);

Block* CG56ModuloInt :: makeNew() const { LOG_NEW; return new CG56ModuloInt;}

CodeBlock CG56ModuloInt :: powerOfTwo (
# line 41 "CG56ModuloInt.pl"
"	move	$ref(input),a\n"
"	move	$ref(powerOfTwoMask),x0\n"
"	and	x0,a\n"
"	move	a,$ref(output)\n");

CG56ModuloInt::CG56ModuloInt ()
{
	setDescriptor("The output is equal to the remainder after dividing the\ninteger input by the integer \"modulo\" parameter.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(modulo.setState("modulo",this,"10","The modulo parameter"));
	addState(powerOfTwoMask.setState("powerOfTwoMask",this,"1","Invisible parameter of the mask to implement integer modulo arithmetic\nby powers of two.",
# line 39 "CG56ModuloInt.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM));


}

void CG56ModuloInt::setup() {
# line 48 "CG56ModuloInt.pl"
if ( int(modulo) <= 0 ) {
		    Error::abortRun(*this,
				    "The modulo parameter must be positive");
		    return;
		}

		// convert the modulo parameter to a mask
		// stop at 15 unsigned bits
		int regValue = 0x02;		// 2, 4, 8, ...
		int mask = 0x01;		// 1, 3, 7, ...
		int modValue = int(modulo);
		for (int i = 1; i < 16; i++) {
		    if ( modValue == regValue ) break;
		    mask = (mask << 1) | 0x01;
		    regValue <<= 1;
		}

		if ( i == 16 ) {
		    Error::abortRun(*this,
				    "The modulo parameter must be positive");
		    return;
		}

		powerOfTwoMask = mask;
}

void CG56ModuloInt::go() {
# line 74 "CG56ModuloInt.pl"
addCode(powerOfTwo);
}

// prototype instance for known block list
static CG56ModuloInt proto;
static RegisterBlock registerBlock(proto,"ModuloInt");
