static const char file_id[] = "CG56MpyRx.pl";
// .cc file generated from CG56MpyRx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56MpyRx.h"

const char *star_nm_CG56MpyRx = "CG56MpyRx";

const char* CG56MpyRx :: className() const {return star_nm_CG56MpyRx;}

ISA_FUNC(CG56MpyRx,CG56Star);

Block* CG56MpyRx :: makeNew() const { LOG_NEW; return new CG56MpyRx;}

CodeBlock CG56MpyRx :: cbZero (
# line 46 "CG56MpyRx.pl"
"	clr	a\n"
"	move	a,$ref(output)\n");

CodeBlock CG56MpyRx :: cbTwoInput (
# line 50 "CG56MpyRx.pl"
"	move			$ref(input_r#1),x0\n"
"	move			$ref(input_r#2),y0\n"
"	mpyr	x0,y0,a		$ref(input_i#1),x1\n"
"	mpyr	x1,y0,b		$ref(input_i#2),y1\n"
"	macr	-x1,y1,a\n"
"	macr	x0,y1,b		a,$ref(output_r)\n"
"	move			b,$ref(output_i)\n");

CG56MpyRx::CG56MpyRx ()
{
	setDescriptor("Multiply any number of rectangular complex inputs, producing an output.");
	addPort(input_r.setPort("input_r",this,FIX));
	addPort(input_i.setPort("input_i",this,FIX));
	addPort(output_r.setPort("output_r",this,FIX));
	addPort(output_i.setPort("output_i",this,FIX));
	addState(inputNum.setState("inputNum",this,"0","input#()",
# line 41 "CG56MpyRx.pl"
A_NONCONSTANT|A_NONSETTABLE));

# line 44 "CG56MpyRx.pl"
noInternalState();
}

int CG56MpyRx::myExecTime() {
# line 109 "CG56MpyRx.pl"
return runtime;
}

void CG56MpyRx::setup() {
# line 63 "CG56MpyRx.pl"
int n = input_r.numberPorts();
	if ( n != input_i.numberPorts() ) {
	    Error::abortRun(*this,"must have same number of real & imag input ports");
	    return;
	}
	switch ( n ) {
	case 0:
	    runtime = 2;
	    break;
	case 1:
            {    
	    char buf[256];
	    sprintf( buf, "input_r#%d", 1); // this is absurd
	    CGPortHole *pr = (CGPortHole*) genPortWithName( buf);
	    forkInit( *pr, output_r);
	    sprintf( buf, "input_i#%d", 1); // this is absurd
	    CGPortHole *pi = (CGPortHole*) genPortWithName( buf);
	    forkInit( *pi, output_i);
	    runtime = 0;
	    break;
	    }
	case 2:
	    runtime = 7;
	    break;
	default:
	    Error::abortRun(*this,"more than two inputs not implemented yet");
	    return;
	}
}

void CG56MpyRx::go() {
# line 93 "CG56MpyRx.pl"
int n = input_r.numberPorts();
	switch ( n ) {
	case 0:
	    addCode(cbZero);
	    break;
	case 1:
	    ; /* fork'd */
	    break;
	case 2:
	    addCode(cbTwoInput);
	    break;
	default:
	    ; // NOT IMP
	}
}

// prototype instance for known block list
static CG56MpyRx proto;
static RegisterBlock registerBlock(proto,"MpyRx");
