static const char file_id[] = "CG56Mux.pl";
// .cc file generated from CG56Mux.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Mux.h"

const char *star_nm_CG56Mux = "CG56Mux";

const char* CG56Mux :: className() const {return star_nm_CG56Mux;}

ISA_FUNC(CG56Mux,CG56Star);

Block* CG56Mux :: makeNew() const { LOG_NEW; return new CG56Mux;}

CodeBlock CG56Mux :: cbCopyScalor (
# line 130 "CG56Mux.pl"
"	move	#$addr(ptrvec),r0\n"
"	move	$ref(control),n0\n"
"	nop\n"
"	move	x:(r0+n0),r2\n"
"	nop	\n"
"	move	$mem(input#1):(r2),a\n"
"	move	a,$ref(output)\n");

CodeBlock CG56Mux :: cbCopyBlock (
# line 139 "CG56Mux.pl"
"	move	#$addr(ptrvec),r0\n"
"	move	$ref(control),n0\n"
"	move	#$addr(output),r3\n"
"	move	x:(r0+n0),r2\n"
"	IF	$val(useModuloB)\n"
"	  move	y:(r0+n0),m2	; for scalars m2=0=fft, but doesnt matter\n"
"	ENDIF\n"
"	.LOOP	#$val(blockSize)\n"
"	  move	$mem(input#1):(r2)+,a\n"
"	  move	a,x:(r3)+\n"
"	.ENDL\n"
"	nop\n");

CodeBlock CG56Mux :: cbAdvancePtr (
# line 155 "CG56Mux.pl"
"	; advance ptr for input#$val(curinput)\n"
"	IF	$val(useModuloB)\n"
"	  move	#$size(input#curinput)-1,m2\n"
"	ENDIF\n"
"	move	x:$addr(ptrvec,curinput)-1,r2\n"
"	rep	#$val(blockSize)\n"
"	  move	(r2)+\n"
"	move	r2,x:$addr(ptrvec,curinput)-1\n");

CG56Mux::CG56Mux ()
{
	setDescriptor("Multiplexes any number of inputs onto one output stream.");
	addPort(input.setPort("input",this,ANYTYPE));
	input.setAttributes(
# line 49 "CG56Mux.pl"
P_CIRC);
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));
	addState(useCircular.setState("useCircular",this,"1","\"Boolean: use circular addressing on inputs.\""));
	addState(ptrvec.setState("ptrvec",this,"","\"Array of pointers to inputs (x:) and lengths (y:).\"",
# line 76 "CG56Mux.pl"
A_NONSETTABLE|A_SYMMETRIC|A_RAM|A_NOINIT));
	addState(curinput.setState("curinput",this,"0","\"Current input within go() loop.\"",
# line 83 "CG56Mux.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(useModuloB.setState("useModuloB",this,"0","\"True if any input is not scalar.\"",
# line 90 "CG56Mux.pl"
A_NONSETTABLE|A_NONCONSTANT));


}

void CG56Mux::initCode() {
# line 105 "CG56Mux.pl"
char buf[100];
	int i, np = input.numberPorts();

	int allScalorB = TRUE;
	MPHIter portiter(input);
	for (i=0; i < np; i++) {
	    AsmPortHole *port = (AsmPortHole*) portiter++;
	    if ( port->bufSize() != 1 )
		allScalorB = FALSE;
	}
	useModuloB = int(useCircular) && ! allScalorB;

	addCode("\torg	x:$addr(ptrvec)\n");
	for (i=0; i < np; i++) {
	    sprintf( buf, "\tdc\t$addr(input#%d)\n", i+1);
	    addCode(buf);
	}
	addCode("\torg	y:$addr(ptrvec)\n");
	for ( i=0; i < np; i++) {
	    // There is a weirdness with scalar inputs: see cbCopy below
	    sprintf( buf, "\tdc\t$size(input#%d)-1\n", i+1);
	    addCode(buf);
	}
	addCode("\torg	p:\n");
}

void CG56Mux::setup() {
# line 93 "CG56Mux.pl"
output.setSDFParams(int(blockSize),int(blockSize)-1);
	input.setSDFParams(int(blockSize),int(blockSize)-1);
	if ( int(useCircular) ) {
	    input.setAttributes(P_CIRC);
	} else {
	    input.setAttributes(P_NONCIRC);
	}

	int np = input.numberPorts();
	ptrvec.resize(np);
}

void CG56Mux::go() {
# line 166 "CG56Mux.pl"
if ( int(blockSize) == 1 )	addCode(cbCopyScalor);
	else				addCode(cbCopyBlock);
	
	if ( int(useCircular) ) {
	    int np = input.numberPorts();
	    MPHIter portiter(input);
	    for (int i=0; i < np; i++) {
		AsmPortHole *port = (AsmPortHole*) portiter++;
		if ( port->bufSize() != int(blockSize) ) {
		    // The test above also catchs the bufSize==1 problem
		    curinput = i+1;
		    addCode(cbAdvancePtr);
		}
	    }
	}
	if ( int(useModuloB) ) {
	    addCode("	move	m7,m2");
	}
}

// prototype instance for known block list
static CG56Mux proto;
static RegisterBlock registerBlock(proto,"Mux");
