static const char file_id[] = "CG56Pad.pl";
// .cc file generated from CG56Pad.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Pad.h"

const char *star_nm_CG56Pad = "CG56Pad";

const char* CG56Pad :: className() const {return star_nm_CG56Pad;}

ISA_FUNC(CG56Pad,CG56Star);

Block* CG56Pad :: makeNew() const { LOG_NEW; return new CG56Pad;}

CodeBlock CG56Pad :: main (
# line 63 "CG56Pad.pl"
"        move    #<$addr(input),r0\n"
"        move    #<$addr(output),r1\n");

CodeBlock CG56Pad :: off (
# line 68 "CG56Pad.pl"
"        move    #$val(fill),a\n"
"        rep     #$val(offset)\n"
"        move    a,x:(r1)+\n");

CodeBlock CG56Pad :: read (
# line 74 "CG56Pad.pl"
"        do      #$val(nread),$label(rloop)\n"
"        move    x:(r0)+,a\n"
"        move    a,x:(r1)+\n"
"$label(rloop)\n");

CodeBlock CG56Pad :: write (
# line 81 "CG56Pad.pl"
"        move    #$val(fill),a\n"
"        rep     #$val(nwrite)-$val(nread)-$val(offset)\n"
"        move    a,x:(r1)+\n");

CG56Pad::CG56Pad ()
{
	setDescriptor("Fix pad\nOn each execution, reads a block of \"nread\" samples (default 128) and writes\na block of \"nwrite\" samples (default 256).  The first \"offset\" samples\n(default 0) have value \"fill\" (default 0.0), the next \"nread\" outputs\nsamples have values taken from the inputs, and last \"nwrite\" -\n\"nread\" - \"offset\" samples have value \"fill\" again.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(nread.setState("nread",this,"128","Number of particles read."));
	addState(nwrite.setState("nwrite",this,"256","Number of particles written."));
	addState(offset.setState("offset",this,"0","Number of leading fill particles in each output block."));
	addState(fill.setState("fill",this,"0.0","Value of fill particles."));


}

int CG56Pad::myExecTime() {
# line 106 "CG56Pad.pl"
int cost = 4;
		if (offset > 0) cost += 2 + int(offset);
		if (nread > 0) cost += 2 + 2 * int(nread);
		if (nwrite > nread + offset)
			cost += 2 + int (nwrite) - int (nread) - int (offset);
		return cost;
}

void CG56Pad::setup() {
# line 88 "CG56Pad.pl"
input.setSDFParams(int (nread), int (nread) - 1);
		output.setSDFParams(int (nwrite), int (nwrite) - 1);

		if (nread + offset > nwrite) {
		Error::	abortRun(*this, ": nread + offset > nwrite.");
			return;
		}
}

void CG56Pad::go() {
# line 97 "CG56Pad.pl"
addCode(main);
		if (offset > 0)
			addCode(off);
		if (nread > 0)
			addCode(read);
		if (nwrite > nread + offset)
			addCode(write);
}

// prototype instance for known block list
static CG56Pad proto;
static RegisterBlock registerBlock(proto,"Pad");
