static const char file_id[] = "CG56Pulse.pl";
// .cc file generated from CG56Pulse.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Pulse.h"

const char *star_nm_CG56Pulse = "CG56Pulse";

const char* CG56Pulse :: className() const {return star_nm_CG56Pulse;}

ISA_FUNC(CG56Pulse,CG56Star);

Block* CG56Pulse :: makeNew() const { LOG_NEW; return new CG56Pulse;}

CodeBlock CG56Pulse :: std (
# line 59 "CG56Pulse.pl"
"        clr     a       $ref(counter),b\n"
"        move    $ref(trigger),a1       ; leave rest of A clear\n"
"        tst     a       #1,a1\n"
"        tne     a,b             ; start counter\n"
"        tst     b       #$val(offVal),x0 ; OFF may be short immediate\n"
"        jeq     <$label(cont)\n"
"        add     a,b     #$val(maxDuration),a1 ; MAX may be short\n"
"        move    $ref(duration),x1        a,y1\n"
"        mac     x1,y1,a         ; compute duration\n"
"        asr     a\n"
"        rnd     a       #$val(onVal),x0  ; ON may be short immediate\n"
"        cmp     a,b     #0,a1\n"
"        tgt     a,b             ; reset counter\n"
"        move    b,$ref(counter)\n"
"$label(cont)\n"
"        move    x0,$ref(output)\n");

CG56Pulse::CG56Pulse ()
{
	setDescriptor("Pulse generator");
	addPort(trigger.setPort("trigger",this,FIX));
	addPort(duration.setPort("duration",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(counter.setState("counter",this,"0.0","internal",
# line 39 "CG56Pulse.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM));
	addState(onVal.setState("onVal",this,"ONE","maximum val"));
	addState(offVal.setState("offVal",this,"0.0","minimum"));
	addState(maxDuration.setState("maxDuration",this,"10","maximum Duration"));


}

int CG56Pulse::myExecTime() {
# line 82 "CG56Pulse.pl"
return 21;
}

void CG56Pulse::go() {
# line 78 "CG56Pulse.pl"
addCode(std);
}

// prototype instance for known block list
static CG56Pulse proto;
static RegisterBlock registerBlock(proto,"Pulse");
