static const char file_id[] = "CG56Quant.pl";
// .cc file generated from CG56Quant.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Quant.h"

const char *star_nm_CG56Quant = "CG56Quant";

const char* CG56Quant :: className() const {return star_nm_CG56Quant;}

ISA_FUNC(CG56Quant,CG56Star);

Block* CG56Quant :: makeNew() const { LOG_NEW; return new CG56Quant;}

CodeBlock CG56Quant :: main (
# line 61 "CG56Quant.pl"
"; Register usage\n"
"; r0 = pointer into the array of thresholds\n"
"; r4 = pointer into the array of threshold levels\n"
"; a = current threshold\n"
"; b = current threshold level\n"
"; x0 = input value\n"
"        move    #<$addr(thresholds),r0\n"
"        move    #>$addr(levels),r4\n"
"	move	$ref(input),x0		; read input (and let r4 settle)\n"
"        move    x:(r0)+,a	y:(r4)+,b\n"
"        do      #$val(X)-1,$label(lab)		; begin loop\n"
"        cmp	x0,a\n"
"        jlt	$label(again)\n"
"        enddo				; jump out of loop\n"
"        jmp     $label(term)			; b is right threshold level\n"
"$label(again)\n"
"        move    x:(r0)+,a    y:(r4)+,b\n"
"$label(lab)				; end loop\n"
"        cmp	x0,a			; if input > threshold, then\n"
"	jge	$label(term)\n"
"	move    y:(r4)+,b\n"
"$label(term)\n"
"        move    b,$ref(output)		; output threshold level\n");

CodeBlock CG56Quant :: oneThreshold (
# line 87 "CG56Quant.pl"
"; Register usage\n"
"; a = threshold			x0 = input\n"
"; b = first level value		y0 = second level value\n"
"	move	$ref(thresholds),a\n"
"	move	$ref(levels),b\n"
"        move    $ref(input),x0\n"
"	cmp	x0,a	$ref(levels)+1,y0	; compare input to threshold\n"
"	tge	y0,b		; if input >= threshold, update threshold\n"
"        move    b,$ref(output)\n");

CG56Quant::CG56Quant ()
{
	setDescriptor("The star quantizes the input to one of N+1 possible output levels\nusing N thresholds.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(thresholds.setState("thresholds",this,"0.1 0.2 0.3 0.4","threshold file",
# line 41 "CG56Quant.pl"
A_NONCONSTANT|A_XMEM));
	addState(levels.setState("levels",this,"0.05 0.15 0.25 0.35 0.45","levels file",
# line 48 "CG56Quant.pl"
A_NONCONSTANT|A_YMEM));
	addState(X.setState("X",this,"4","internal",
# line 55 "CG56Quant.pl"
A_NONCONSTANT|A_NONSETTABLE));

# line 58 "CG56Quant.pl"
noInternalState();
}

int CG56Quant::myExecTime() {
# line 121 "CG56Quant.pl"
if ( thresholds.size() == 1 ) return 6;
	        return 11 + 4*int(thresholds.size());
}

void CG56Quant::setup() {
# line 100 "CG56Quant.pl"
int n = thresholds.size();

                if (levels.size() == 0) {       // set to default: 0, 1, 2...
                        levels.resize(n + 1);
                        for (int i = 0; i <= n; i++)
                                levels[i] = i;
                }
                else if (levels.size() != n+1) {
                        Error::abortRun (*this,
                              "must have one more level than thresholds");
                }
}

void CG56Quant::go() {
# line 113 "CG56Quant.pl"
X=thresholds.size();

                 if (thresholds.size()>1) 
                     addCode(main);
		 else
	             addCode(oneThreshold);
}

// prototype instance for known block list
static CG56Quant proto;
static RegisterBlock registerBlock(proto,"Quant");
