static const char file_id[] = "CG56QuantIdx.pl";
// .cc file generated from CG56QuantIdx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56QuantIdx.h"

const char *star_nm_CG56QuantIdx = "CG56QuantIdx";

const char* CG56QuantIdx :: className() const {return star_nm_CG56QuantIdx;}

ISA_FUNC(CG56QuantIdx,CG56Quant);

Block* CG56QuantIdx :: makeNew() const { LOG_NEW; return new CG56QuantIdx;}

CodeBlock CG56QuantIdx :: outputStepNumber (
# line 25 "CG56QuantIdx.pl"
"; Register usage\n"
"; x0 = address of threshold levels block\n"
"; r4 = one address beyond threshold level used (leftover from above)\n"
"; The quantization level index is r4 - 1 - x0 = r4 - (x0 + 1)\n"
"	move	#>$addr(levels)+1,x0\n"
"	move	r4,a\n"
"	sub	x0,a			; compute threshold level index\n"
"	move	a,$ref(stepNumber)\n");

CodeBlock CG56QuantIdx :: oneThreshold (
# line 36 "CG56QuantIdx.pl"
"; Register usage\n"
"; a = threshold                 x0 = input\n"
"; b = first level value         y0 = second level value\n"
"; r4 contains the value one\n"
"; r5 contains the index of the threshold, 0 or 1\n"
"	clr	b	move	$ref(thresholds),a\n"
"	move    $ref(input),x0	b,r4\n"
"	move	$ref(levels),b	b,r0	(r4)+\n"
"	cmp     x0,a    $ref(levels)+1,y0	; if input >= threshold, then\n"
"	tge     y0,b	r4,r0		; update threshold\n"
"	move    b,$ref(output)\n"
"	move	r0,$ref(stepNumber)\n");

CG56QuantIdx::CG56QuantIdx ()
{
	setDescriptor("The star quantizes the input to one of N+1 possible output levels\nusing N thresholds.  It also outputs the index of the quantization\nlevel used.  See the Quant star for more information.");
	addPort(stepNumber.setPort("stepNumber",this,INT));


}

int CG56QuantIdx::myExecTime() {
# line 64 "CG56QuantIdx.pl"
if ( thresholds.size() == 1 ) return 7;
	        return 4 + CG56Quant::myExecTime();
}

void CG56QuantIdx::go() {
# line 54 "CG56QuantIdx.pl"
if ( thresholds.size() == 1 ) {
		    addCode(oneThreshold);
		}
		else {
		    CG56Quant :: go();
		    addCode(outputStepNumber);
		}
}

// prototype instance for known block list
static CG56QuantIdx proto;
static RegisterBlock registerBlock(proto,"QuantIdx");
