static const char file_id[] = "CG56QuantRange.pl";
// .cc file generated from CG56QuantRange.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56QuantRange.h"

const char *star_nm_CG56QuantRange = "CG56QuantRange";

const char* CG56QuantRange :: className() const {return star_nm_CG56QuantRange;}

ISA_FUNC(CG56QuantRange,CG56Star);

Block* CG56QuantRange :: makeNew() const { LOG_NEW; return new CG56QuantRange;}

const char* CG56QuantRange :: manyThresholds(int numThresholds) {
# line 57 "CG56QuantRange.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	move	#<$addr(thresholds),r0\n"
"	move	#<$addr(levels),r4\n"
"        move    $ref(input),x0\n"
"	move	$ref(range),x1\n"
"	move 	x:(r0)+,y0\n"
"        do      #" << (numThresholds) << ",$label(end)\n"
"	mpy	x1,y0,a		y:(r4)+,y1\n"
"        cmp	x0,a		x:(r0)+,y0\n"
"        jgt     $label(break)\n"
"	jmp 	$label(continue)\n"
"$label(break)\n"
"        enddo\n"
"	jmp	$label(done)\n"
"$label(continue)\n"
"	nop\n"
"$label(end)\n"
"	move	y:(r4)+,y1\n"
"$label(done)\n"
"	mpy	x1,y1,b\n"
"        move    b,$ref(output)\n";
	return (const char*)_str_;
}

CodeBlock CG56QuantRange :: oneThreshold (
# line 80 "CG56QuantRange.pl"
"	move	$ref(range),x1\n"
"        move    $ref(thresholds),y0\n"
"	mpy	x1,y0,a		#<$addr(levels),r4\n"
"        move    $ref(input),x0\n"
"	cmp	x0,a		y:(r4)+,y1\n"
"	jgt     $label(done)\n"
"	move	y:(r4)+,y1\n"
"$label(done)\n"
"	mpy	x1,y1,b\n"
"        move    b,$ref(output)\n");

CG56QuantRange::CG56QuantRange ()
{
	setDescriptor("The star quantizes the input to one of N+1 possible output levels\nusing N thresholds.");
	addPort(input.setPort("input",this,FIX));
	addPort(range.setPort("range",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(thresholds.setState("thresholds",this,"0","threshold values",
# line 44 "CG56QuantRange.pl"
A_NONCONSTANT|A_XMEM));
	addState(levels.setState("levels",this,"-0.5 0.5","levels values",
# line 51 "CG56QuantRange.pl"
A_NONCONSTANT|A_YMEM));

# line 54 "CG56QuantRange.pl"
noInternalState();
}

int CG56QuantRange::myExecTime() {
# line 105 "CG56QuantRange.pl"
return 7+4*int(thresholds.size());
}

void CG56QuantRange::setup() {
# line 94 "CG56QuantRange.pl"
if(levels.size() != thresholds.size()+1)
	    Error::abortRun
		(*this,": Must have 1 more level than threshold to quantize.");
}

void CG56QuantRange::go() {
# line 100 "CG56QuantRange.pl"
if(thresholds.size()>1) addCode(manyThresholds(thresholds.size()));
	else addCode(oneThreshold);
}

// prototype instance for known block list
static CG56QuantRange proto;
static RegisterBlock registerBlock(proto,"QuantRange");
