static const char file_id[] = "CG56RampInt.pl";
// .cc file generated from CG56RampInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, an ddisclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56RampInt.h"

const char *star_nm_CG56RampInt = "CG56RampInt";

const char* CG56RampInt :: className() const {return star_nm_CG56RampInt;}

ISA_FUNC(CG56RampInt,CG56Star);

Block* CG56RampInt :: makeNew() const { LOG_NEW; return new CG56RampInt;}

CodeBlock CG56RampInt :: init (
# line 63 "CG56RampInt.pl"
"	move	$ref(sum),a		; a holds the last sum\n"
"	move	$ref(step),x0		; x0 is the step\n"
"; can't use move #$val(step),x0 because move immediate instructions\n"
"; load 8 bit # in 8 most significant bits of X0 so if step is 8 \n"
"; X0 will be 10000..0 instead of 0...01000\n");

CodeBlock CG56RampInt :: add (
# line 70 "CG56RampInt.pl"
"	add	x0,a	a,$ref(output)		; output last sum\n");

CodeBlock CG56RampInt :: no_saturate (
# line 73 "CG56RampInt.pl"
"	move	a1,$ref(sum)\n");

CodeBlock CG56RampInt :: saturate (
# line 76 "CG56RampInt.pl"
"	move	a,$ref(sum)\n");

CG56RampInt::CG56RampInt ()
{
	setDescriptor("Integer Ramp Generator");
	addPort(output.setPort("output",this,INT));
	addState(step.setState("step",this,"1","Increment from one sample to the next",
# line 28 "CG56RampInt.pl"
A_YMEM|A_CONSTANT));
	addState(value.setState("value",this,"0","initial value output by RampInt",
# line 35 "CG56RampInt.pl"
A_YMEM|A_CONSTANT));
	addState(saturation.setState("saturation",this,"YES","if set to YES uses saturation arithmetic"));
	addState(sum.setState("sum",this,"0","internal accumulator",
# line 48 "CG56RampInt.pl"
A_NONSETTABLE|A_YMEM|A_NONCONSTANT));


}

int CG56RampInt::myExecTime() {
# line 81 "CG56RampInt.pl"
return 4;
}

void CG56RampInt::setup() {
# line 51 "CG56RampInt.pl"
sum = int(value);
}

void CG56RampInt::go() {
# line 54 "CG56RampInt.pl"
addCode(init);
		addCode(add);
		if (int(saturation)) {
			addCode(saturate);
		}
		else {
			addCode(no_saturate);
		}
}

// prototype instance for known block list
static CG56RampInt proto;
static RegisterBlock registerBlock(proto,"RampInt");
