static const char file_id[] = "CG56Rect.pl";
// .cc file generated from CG56Rect.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Rect.h"

const char *star_nm_CG56Rect = "CG56Rect";

const char* CG56Rect :: className() const {return star_nm_CG56Rect;}

ISA_FUNC(CG56Rect,CG56Star);

Block* CG56Rect :: makeNew() const { LOG_NEW; return new CG56Rect;}

CodeBlock CG56Rect :: sendOutput (
# line 45 "CG56Rect.pl"
"; Register usage:\n"
"; x0 = 0\n"
"; x1 = count\n"
"; y1 = height\n"
"; a = output value\n"
"; b = width\n"
"	clr	b	$ref(count),x1		; a = 0, x1 = count, b = 0\n"
"	clr	a	#$val(width),b1		; b1 = width\n"
"	move	a,x0	$ref(height),y1		; x0 = 0, y1 = height\n"
"	cmp	x1,b	#1,b1		; if (count < width)\n"
"	tgt	y1,a			; then a = height\n"
"	move	a,$ref(output)			; output = a\n");

CodeBlock CG56Rect :: updateCounter (
# line 60 "CG56Rect.pl"
"; a = period\n"
"; b = updated count\n"
"	add	x1,b			; b = count + 1\n"
"	move	#$val(period),a1		; a = period\n"
"	cmp	a,b			; if (period <= count)\n"
"	tge	x0,b			; then b = 0\n"
"	move	b,$ref(count)			; count = b\n");

CG56Rect::CG56Rect ()
{
	setDescriptor("Rectangular Pulse Generator");
	addPort(output.setPort("output",this,FIX));
	addState(height.setState("height",this,"ONE","height of rectangular pulse",
# line 23 "CG56Rect.pl"
A_YMEM));
	addState(width.setState("width",this,"1","width of rectangular pulse"));
	addState(period.setState("period",this,"10","period of pulse"));
	addState(count.setState("count",this,"0","internal counting state",
# line 42 "CG56Rect.pl"
A_YMEM|A_NONCONSTANT|A_NONSETTABLE));


}

int CG56Rect::myExecTime() {
# line 90 "CG56Rect.pl"
return 11;
}

void CG56Rect::setup() {
# line 71 "CG56Rect.pl"
int w = int(width);
		int p = int(period);

		if (w < 1) {
			Error::abortRun(*this, "Invalid width value.");
		}
		else if (p < 1) {
			Error::abortRun(*this, "Invalid period value.");
		}
		else if (p <= w) {
			Error::abortRun(*this,
					"Period must be greater than width");
		}
}

void CG56Rect::go() {
# line 86 "CG56Rect.pl"
addCode(sendOutput);
		addCode(updateCounter);
}

// prototype instance for known block list
static CG56Rect proto;
static RegisterBlock registerBlock(proto,"Rect");
