static const char file_id[] = "CG56Repeat.pl";
// .cc file generated from CG56Repeat.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Repeat.h"

const char *star_nm_CG56Repeat = "CG56Repeat";

const char* CG56Repeat :: className() const {return star_nm_CG56Repeat;}

ISA_FUNC(CG56Repeat,CG56Star);

Block* CG56Repeat :: makeNew() const { LOG_NEW; return new CG56Repeat;}

CodeBlock CG56Repeat :: cbOnce (
# line 42 "CG56Repeat.pl"
"    	move	$ref(input),a\n"
"    	move	a,$ref(output)\n");

CodeBlock CG56Repeat :: cbRepLoop (
# line 46 "CG56Repeat.pl"
"    	move	#$addr(output),r1\n"
"    	move	$ref(input),a\n"
"    	rep	#$val(numTimes)\n"
"    	  move	a,$mem(output):(r1)+\n");

CodeBlock CG56Repeat :: cbDoLoop (
# line 52 "CG56Repeat.pl"
"    	move	#$addr(output),r1\n"
"    	move	$ref(input),a\n"
"    	.LOOP	#$val(numTimes)\n"
"    	  move	a,$mem(output):(r1)+\n"
"	.ENDL\n"
"	nop\n");

CG56Repeat::CG56Repeat ()
{
	setDescriptor("Repeats each input sample the specified number of times.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(numTimes.setState("numTimes",this,"2","Repetition factor."));


}

int CG56Repeat::myExecTime() {
# line 72 "CG56Repeat.pl"
return int(numTimes)+4;
}

void CG56Repeat::setup() {
# line 39 "CG56Repeat.pl"
output.setSDFParams(int(numTimes),int(numTimes)-1);
}

void CG56Repeat::go() {
# line 62 "CG56Repeat.pl"
/*IF*/ if ( int(numTimes) == 1 ) {
	    addCode(cbOnce);	// should fork buf instead
	} else if ( int(numTimes) <= 100 ) {
	    addCode(cbRepLoop);
	} else {
	    addCode(cbDoLoop);
	}
}

// prototype instance for known block list
static CG56Repeat proto;
static RegisterBlock registerBlock(proto,"Repeat");
