static const char file_id[] = "CG56Rotate.pl";
// .cc file generated from CG56Rotate.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Rotate.h"

const char *star_nm_CG56Rotate = "CG56Rotate";

const char* CG56Rotate :: className() const {return star_nm_CG56Rotate;}

ISA_FUNC(CG56Rotate,CG56Star);

Block* CG56Rotate :: makeNew() const { LOG_NEW; return new CG56Rotate;}

CodeBlock CG56Rotate :: greater (
# line 55 "CG56Rotate.pl"
"; effective rotation: $val(rotate)\n"
"        move    #<$addr2(input,rotate),r0\n"
"        move    #<$addr(output),r1\n"
"        do      #$val(length)-$val(rotate),$label(lab2)\n"
"        move    $mem(input):(r0)+,a\n"
"        move    a,$mem(output):(r1)+\n"
"$label(lab2)\n"
"        move    #<$addr(input),r0\n"
"        do      #$val(rotate),$label(lab3)\n"
"        move    $mem(input):(r0)+,a\n"
"        move    a,$mem(outpu):(r1)+\n"
"$label(lab3)\n");

CodeBlock CG56Rotate :: other (
# line 69 "CG56Rotate.pl"
"        move    #<$addr(input),r0\n"
"        move    #<$addr(output),r1\n"
"        do      #$val(length),$label(lab4)\n"
"        move    $mem(input):(r0)+,a\n"
"        move    a,$mem(outpu):(r1)+\n"
"$label(lab4)\n");

CodeBlock CG56Rotate :: one (
# line 77 "CG56Rotate.pl"
"        move    $ref(input),a\n"
"        move    a,$ref(output)\n");

CG56Rotate::CG56Rotate ()
{
	setDescriptor("Rotate a block of input data");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(rotation.setState("rotation",this,"0","amount of shift to right (negative) or left (positive)"));
	addState(length.setState("length",this,"16","length of input data"));
	addState(rotate.setState("rotate",this,"0","length of input data",
# line 52 "CG56Rotate.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

int CG56Rotate::myExecTime() {
# line 105 "CG56Rotate.pl"
if (length > 1 && rotation == 0)
			return 4 + 2 * int (length);
		else if (length == 1)
			return 2;
		else
			return 7 + 4 * int (length);
}

void CG56Rotate::setup() {
# line 83 "CG56Rotate.pl"
input.setSDFParams(int(length),int(length)-1);
                output.setSDFParams(int(length),int(length)-1);
}

void CG56Rotate::go() {
# line 87 "CG56Rotate.pl"
int             i = rotation;

		if (i > length || -i > length)
		Error::abortRun(*this, ": Number of rotations > block length.");

		rotate = rotation;

		if (rotation < 0)
			rotate = (int)length + (int)rotation;

		if (rotate > 0 && length > 1)
			addCode(greater);
		else if (length > 1)
			addCode(other);
		else
			addCode(one);
}

// prototype instance for known block list
static CG56Rotate proto;
static RegisterBlock registerBlock(proto,"Rotate");
