static const char file_id[] = "CG56SSI.pl";
// .cc file generated from CG56SSI.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56SSI.h"

const char *star_nm_CG56SSI = "CG56SSI";

const char* CG56SSI :: className() const {return star_nm_CG56SSI;}

ISA_FUNC(CG56SSI,CG56Star);

Block* CG56SSI :: makeNew() const { LOG_NEW; return new CG56SSI;}

CodeBlock CG56SSI :: ssiInit (
# line 293 "CG56SSI.pl"
"	movep	#$val(cra),x:m_cra\n"
"	movep	#$val(crb),x:m_crb\n"
"; Configure Port C pins 8-5 as SSI pins\n"
"        bset    #8,x:m_pcc		; STD\n"
"        bset    #7,x:m_pcc		; SRD\n"
"        bset    #6,x:m_pcc		; SCK (bit clock)\n"
"        bset    #5,x:m_pcc		; SC2 (frame clock)\n"
"; Configure Port C pins 2-0 as raw data pins (normally SCI)\n"
"        bclr    #2,x:m_pcc\n"
"        bclr    #1,x:m_pcc\n"
"        bclr    #0,x:m_pcc\n"
"        bset    #2,x:m_pcddr		; as outputs\n"
"        bset    #1,x:m_pcddr\n"
"        bset    #0,x:m_pcddr\n");

CodeBlock CG56SSI :: enableInterupts (
# line 309 "CG56SSI.pl"
"        bset    #m_ssl0,x:m_ipr		; set SSI IPL 2\n"
"        bset    #m_ssl1,x:m_ipr\n"
"        bset    #m_srie,x:m_crb         ; enable SSI rx interrupts\n");

CodeBlock CG56SSI :: abortyes (
# line 315 "CG56SSI.pl"
"; Polling version\n"
"; Check for receiver overrun error\n"
"        jclr    #m_roe,x:m_sr,$label(cont)\n"
"        move    #$$123062,y0\n"
"        jmp     ERROR\n"
"$label(cont)\n");

CodeBlock CG56SSI :: polling (
# line 324 "CG56SSI.pl"
"; Process Channel One\n"
"        jclr    #m_rdf,x:m_sr,*\n"
"        movep   x:m_rx,x0\n"
"        move    x0,$ref(output1)\n"
"        move    $ref(input1),x0\n"
"        movep   x0,x:m_tx\n"
"; Process Channel Two\n"
"        jclr    #m_rdf,x:m_sr,*\n"
"        movep   x:m_rx,x0\n"
"        move    x0,$ref(output2)\n"
"        move    $ref(input2),x0\n"
"        movep   x0,x:m_tx\n");

CodeBlock CG56SSI :: interruptInit (
# line 339 "CG56SSI.pl"
"$starSymbol(ssi)_savereg	equ	$addr(saveReg)\n"
"$starSymbol(ssi)_buflen		equ	$val(bufLen)\n"
"$starSymbol(ssi)_buffer		equ	$addr(buffer)\n"
"$starSymbol(ssi)_recv_sptr	equ	$addr(recvStarPtr)\n"
"$starSymbol(ssi)_recv_iptr	equ	$addr(recvIntrPtr)\n"
"$starSymbol(ssi)_xmit_sptr	equ	$addr(xmitStarPtr)\n"
"$starSymbol(ssi)_xmit_iptr	equ	$addr(xmitIntrPtr)\n"
"$starSymbol(ssi)_dualbuf	equ	$val(dualbufFlag)\n"
"\n"
"; Initialize all the pointers to the right place.\n"
"; Note that recv&xmit bufs are at the same add but recv in x: and xmit in y:\n"
"        org     $ref(recvStarPtr)\n"
"        dc      $starSymbol(ssi)_buffer\n"
"        org     $ref(recvIntrPtr)\n"
"        dc      $starSymbol(ssi)_buffer\n"
"        org     $ref(xmitStarPtr)\n"
"        dc      $starSymbol(ssi)_buffer\n"
"        org     $ref(xmitIntrPtr)\n"
"        dc      $starSymbol(ssi)_buffer\n"
"        org     p:\n"
"    \n"
"        move    #$starSymbol(ssi)_buffer,r0\n"
"	.LOOP	#$starSymbol(ssi)_buflen\n"
"          bset    #0,x:(r0)	; empty recv buf by setting  bit 0\n"
"          bclr    #0,y:(r0)+	; fill  xmit buf by clearing bit 0\n"
"	.ENDL\n");

CodeBlock CG56SSI :: interruptRecvDataVec (
# line 367 "CG56SSI.pl"
"; SSI receive data interrupt vector\n"
"        org     p:i_ssird\n"
"        jsr     $starSymbol(ssi)_intr\n");

CodeBlock CG56SSI :: interruptRecvExcptVec (
# line 372 "CG56SSI.pl"
"; SSI receive data w/ exception interrupt vector\n"
"; XXX: this is wrong!!!\n"
"        org     p:i_ssirde\n"
"        jsr     $starSymbol(ssi)_intr\n");

CodeBlock CG56SSI :: intrLoadM0 (
# line 385 "CG56SSI.pl"
"	move    #$starSymbol(ssi)_buflen-1,m0\n");

CodeBlock CG56SSI :: intrRestoreM0 (
# line 388 "CG56SSI.pl"
"	move    m7,m0\n");

CodeBlock CG56SSI :: intrLoadRecvPtr (
# line 391 "CG56SSI.pl"
"	move    x:$starSymbol(ssi)_recv_sptr,r0\n"
"	nop\n");

CodeBlock CG56SSI :: intrSaveRecvPtr (
# line 395 "CG56SSI.pl"
"	move    r0,x:$starSymbol(ssi)_recv_sptr\n");

CodeBlock CG56SSI :: intrGetRecvY0 (
# line 398 "CG56SSI.pl"
"        jset    #0,x:(r0),*		; Wait for slot to have data\n"
"        move    x:(r0),y0               ; Get sample from buffer\n"
"	IF	$val(dualbufFlag)\n"
"          bset    #0,x:(r0)+              ; Mark slot as empty\n"
"	ENDIF\n");

CodeBlock CG56SSI :: intrGetRecv1 (
# line 405 "CG56SSI.pl"
"        move    y0,$ref(output1)\n"
"	IF	$val(savePrevOut)\n"
"	  move	  y0,$ref(prevOut1)\n"
"	ENDIF\n");

CodeBlock CG56SSI :: intrGetRecv2 (
# line 411 "CG56SSI.pl"
"        move    y0,$ref(output2)\n"
"	IF	$val(savePrevOut)\n"
"	  move	  y0,$ref(prevOut2)\n"
"	ENDIF\n");

CodeBlock CG56SSI :: intrLoadXmitPtr (
# line 418 "CG56SSI.pl"
"	move    x:$starSymbol(ssi)_xmit_sptr,r0\n");

CodeBlock CG56SSI :: intrSaveXmitPtr (
# line 421 "CG56SSI.pl"
"	move    r0,x:$starSymbol(ssi)_xmit_sptr\n");

CodeBlock CG56SSI :: intrPutXmit1 (
# line 424 "CG56SSI.pl"
"	move    $ref(input1),y0\n");

CodeBlock CG56SSI :: intrPutXmit2 (
# line 427 "CG56SSI.pl"
"	move    $ref(input2),y0\n");

CodeBlock CG56SSI :: intrPutXmitY0 (
# line 430 "CG56SSI.pl"
"	IF $val(dualbufFlag)\n"
"          jclr    #0,y:(r0),*		; Wait for slot to be empty\n"
"	ENDIF\n"
"        move    y0,y:(r0)               ; Put data there\n"
"	IF $val(dualbufFlag)\n"
"          bclr    #0,y:(r0)+              ; Mark slot as full\n"
"	ELSE\n"
"          bset    #0,x:(r0)+              ; Mark slot as empty\n"
"	ENDIF\n");

CodeBlock CG56SSI :: ihdlPreserveRegs (
# line 502 "CG56SSI.pl"
"; Interrupt handler for $fullname()\n"
"$starSymbol(ssi)_intr\n"
"        move    y0,x:$starSymbol(ssi)_savereg+0      ; Save y0, r0, m0\n"
"        move    r0,x:$starSymbol(ssi)_savereg+1\n"
"        move    m0,x:$starSymbol(ssi)_savereg+2\n"
"        move    #$starSymbol(ssi)_buflen-1,m0\n");

CodeBlock CG56SSI :: ihdlRestoreRegs (
# line 510 "CG56SSI.pl"
"        move    x:$starSymbol(ssi)_savereg+0,y0      ; Restore y0, r0, m0\n"
"        move    x:$starSymbol(ssi)_savereg+1,r0\n"
"        move    x:$starSymbol(ssi)_savereg+2,m0\n"
"	rti\n");

CodeBlock CG56SSI :: ihdlSymmetricBuffer (
# line 517 "CG56SSI.pl"
"        move    x:$starSymbol(ssi)_recv_iptr,r0	; recv pointer\n"
"        move    x:m_rx,y0\n"
"        jset    #0,x:(r0),$label(doRecv)	; make sure recv slot empty\n"
"	IF	$val(intrAbort)\n"
"          move	#$$123064,y0			; its full...abort\n"
"          jmp	ERROR\n"
"	ELSE\n"
"	  ; just drop recv sample in y0\n"
"	  move	y:-(r0),y0		; go back two (stereo): prev tx sample\n"
"	  move	y:-(r0),y0\n"
"	  move	$ref(missCnt),r0\n"
"	  move	y0,x:m_tx\n"
"	  move	(r0)+\n"
"	  move	r0,$ref(missCnt)\n"
"	  jmp	$label(done)\n"
"	ENDIF\n"
"$label(doRecv)\n"
"        move    y0,x:(r0)\n"
"        move    y:(r0),y0\n"
"        bclr    #0,x:(r0)+			; mark slot as used\n"
"        move    y0,x:m_tx\n"
"        move    r0,x:$starSymbol(ssi)_recv_iptr	; save updated pointer\n"
"$label(done)\n");

CodeBlock CG56SSI :: ihdlDualBuffer (
# line 543 "CG56SSI.pl"
"        move    x:$starSymbol(ssi)_recv_iptr,r0	; recv pointer\n"
"        move    x:m_rx,y0\n"
"        jset    #0,x:(r0),$label(doRecv)	; error if slot already used\n"
"	IF	$val(intrAbort)\n"
"          move    #$$123062,y0\n"
"          jmp     ERROR\n"
"	ELSE\n"
"	  jmp	  $label(rx_done)\n"
"	ENDIF\n"
"$label(doRecv)\n"
"        move    y0,x:(r0)\n"
"        bclr    #0,x:(r0)+			; mark slot as used\n"
"        move    r0,x:$starSymbol(ssi)_recv_iptr	; save updated pointer\n"
"$label(rx_done)\n"
"        move    x:$starSymbol(ssi)_xmit_iptr,r0	; xmit pointer\n"
"        nop\n"
"        jclr    #0,y:(r0),$label(doXmit)	; error if slot empty\n"
"	IF	$val(intrAbort)\n"
"          move	#$$123063,y0\n"
"          jmp	ERROR\n"
"	ELSE\n"
"	  move	y:-(r0),y0		; go back two (stereo): prev tx sample\n"
"	  move	y:-(r0),y0\n"
"	  move	$ref(missCnt),r0\n"
"	  move	y0,x:m_tx\n"
"	  move	(r0)+\n"
"	  move	r0,$ref(missCnt)\n"
"	  jmp	$label(tx_done)\n"
"	ENDIF\n"
"$label(doXmit)\n"
"        move    y:(r0),y0\n"
"        bset    #0,y:(r0)+              ; Mark location as empty\n"
"        move    r0,x:$starSymbol(ssi)_xmit_iptr    ; Save updated pointer\n"
"        move    y0,x:m_tx\n"
"$label(tx_done)\n");

CG56SSI::CG56SSI ()
{
	setDescriptor("A generic input/output star the DSP56001 SSI port.");
	addPort(input1.setPort("input1",this,FIX));
	addPort(input2.setPort("input2",this,FIX));
	addPort(output1.setPort("output1",this,FIX));
	addPort(output2.setPort("output2",this,FIX));
	addState(hardware.setState("hardware",this,"PROPORT","Name of physical hardware attached to SSI."));
	addState(symmetricBuffers.setState("symmetricBuffers",this,"YES","If TRUE use symmetric queuing, else use dual buffering."));
	addState(queueSize.setState("queueSize",this,"4","Length of interrupt queue (0==>polling)."));
	addState(abortOnRealTimeError.setState("abortOnRealTimeError",this,"YES","If TRUE, abort on real time violation."));
	addState(cra.setState("cra",this,"0","Port C SSI control register A (custom hardware only)."));
	addState(crb.setState("crb",this,"0","Port C SSI control register B (custom hardware only)."));
	addState(bufLen.setState("bufLen",this,"4","internal",
# line 194 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(intrAbort.setState("intrAbort",this,"1","Integer form of abortOnRealTimeError (for macros).",
# line 200 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(dualbufFlag.setState("dualbufFlag",this,"0","state version of !doSymmetric",
# line 208 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(missCnt.setState("missCnt",this,"0","Count of missed interrupt samples.",
# line 215 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT|A_YMEM));
	addState(buffer.setState("buffer",this,"0","internal",
# line 222 "CG56SSI.pl"
A_CIRC|A_NONSETTABLE|A_NONCONSTANT|A_SYMMETRIC|A_RAM|A_NOINIT));
	addState(recvStarPtr.setState("recvStarPtr",this,"0","internal",
# line 229 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT|A_XMEM|A_NOINIT));
	addState(xmitStarPtr.setState("xmitStarPtr",this,"0","internal",
# line 236 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT|A_XMEM|A_NOINIT));
	addState(recvIntrPtr.setState("recvIntrPtr",this,"0","internal",
# line 243 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT|A_XMEM|A_NOINIT));
	addState(xmitIntrPtr.setState("xmitIntrPtr",this,"0","internal",
# line 250 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT|A_XMEM|A_NOINIT));
	addState(saveReg.setState("saveReg",this,"0","internal",
# line 257 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT|A_XMEM|A_NOINIT));
	addState(savePrevOut.setState("savePrevOut",this,"0","Boolean flag indicating to save previous output values.",
# line 264 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(prevOut1.setState("prevOut1",this,"0","Copy of previous output#1 sample.",
# line 271 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT|A_XMEM|A_NOINIT));
	addState(prevOut2.setState("prevOut2",this,"0","Copy of previous output#2 sample.",
# line 278 "CG56SSI.pl"
A_NONSETTABLE|A_NONCONSTANT|A_XMEM|A_NOINIT));

# line 290 "CG56SSI.pl"
doRecv1 = doRecv2 = TRUE;
	doXmit1 = doXmit2 = TRUE;
}

int CG56SSI::myExecTime() {
# line 646 "CG56SSI.pl"
return doIntr ? 73 : 21;
}

void CG56SSI::initCode() {
# line 618 "CG56SSI.pl"
if ( ! doIntr ) {
	    addCode(ssiInit);
	} else {
	    addProcedure(ihdlPreserveRegs);
	    if ( doSymmetric ) {
		addProcedure(ihdlSymmetricBuffer);
	    } else {
		addProcedure(ihdlDualBuffer);
	    }
	    addProcedure(ihdlRestoreRegs);

	    addCode(interruptInit);
	    genInterruptCode(interruptRecvDataVec);
	    genInterruptCode(interruptRecvExcptVec);
	    addCode(ssiInit);
	    addCode(enableInterupts);
	}
}

void CG56SSI::setup() {
# line 589 "CG56SSI.pl"
saveReg.resize(3);

	doSymmetric = int(symmetricBuffers);
	dualbufFlag = !doSymmetric;


	doIntr = reps() > 1;
	if ( int(queueSize) != 0 )
	    doIntr = TRUE;

	doErrAbort = int(abortOnRealTimeError);
	intrAbort = doErrAbort ? 1 : 0;
	
	bufLen = 0;
	if ( doIntr ) {
	    bufLen = int(queueSize);
	    if ( bufLen>=0 ) {
		if ( bufLen < reps() )
		    bufLen = reps();
	    } else {
		bufLen = 0 - bufLen;
	    }
	    if ( (doRecv1||doXmit1) && (doRecv2||doXmit2) ) 
		bufLen = int(bufLen) * 2;
	}
	buffer.resize(bufLen);
	config_hardware();
}

void CG56SSI::go() {
# line 637 "CG56SSI.pl"
if ( ! doIntr ) {
	    if ( doErrAbort )
		addCode(abortyes);
	    addCode(polling);
	} else {
	    go_intr();
	}
}


void CG56SSI::go_intr_port (const char *port)
{
# line 444 "CG56SSI.pl"
/*IF*/ if ( strcmp(port,"xmit1")==0 ) {
		addCode(intrPutXmit1);
		addCode(intrPutXmitY0);
	    } else if ( strcmp(port,"xmit2")==0 ) {
		addCode(intrPutXmit2);
		addCode(intrPutXmitY0);
	    } else if ( strcmp(port,"recv1")==0 ) {
		addCode(intrGetRecvY0);
		addCode(intrGetRecv1);
	    } else if ( strcmp(port,"recv2")==0 ) {
		addCode(intrGetRecvY0);
		addCode(intrGetRecv2);
	    } else {
		Error::abortRun(*this,": invalid port");
	    }
}


void CG56SSI::go_intr ()
{
# line 465 "CG56SSI.pl"
addCode(intrLoadM0);
	    if ( doSymmetric ) {
		addCode(intrLoadRecvPtr);
		if ( doRecv1 || doXmit1 ) {
		    go_intr_port("recv1");
		    go_intr_port("xmit1");
		}
		if ( doRecv2 || doXmit2 ) {
		    go_intr_port("recv2");
		    go_intr_port("xmit2");
		}
		addCode(intrSaveRecvPtr);
	    } else {
		if ( doRecv1 || doRecv2 ) {
		    addCode(intrLoadRecvPtr);
		    if ( doRecv1 )		go_intr_port("recv1");
		    if ( doRecv2 )		go_intr_port("recv2");
		    addCode(intrSaveRecvPtr);
		}
		if ( doXmit1 || doXmit2 ) {
		    addCode(intrLoadXmitPtr);
		    if ( doXmit1 )		go_intr_port("xmit1");
		    if ( doXmit2 )		go_intr_port("xmit2");
		    addCode(intrSaveXmitPtr);
		}
	    }
	    addCode(intrRestoreM0);
}


void CG56SSI::config_hardware ()
{
# line 652 "CG56SSI.pl"
// Configure the control registers based on hardware type.
// The relevant registers and a quick summary of the bits:
//	PCC (x:m_pcc)
//	    bits 0-2: SCI (but used by proport) pin functions/enables
//	    bits 5-3: SSI aux. pin functions/enables 
//	    bits 8-6: SSI core pin functions/enables
//	PCDDR (x:m_pcddr)
//	    data direction for PCC when in parallel data-mode
//	PCD (x:m_pcd)
//	    data bits for PCC when in parallel data-mode
// 	CRA (x:m_cra)
//	    bits 7-0 (PM7-0): crystal clock to bit rate
//	    bits 12-8 (DC4-0): words per frame
//	    bits 14-13 (WL1-0): bits per word
//	    bit  15 (PSR): aux. to PM.
//	CRB (x:m_crb)
//	    bits 1-0 (OF1-): output flags
//	    bits 5-2 (SCKD,SCD2-0): pin directions;
//	    bit 6 (SHFD): shift dir
//	    bit 8-7 (fsl0,1): sync length;	bit 9 (syn): sync rec&xmit
//	    bit 10 (gck): gated clock;		bit 11 (mod): mode network
//	    bit 15-11 (rie,tie,re,te): interrupt enables and function enables

	    /*IF*/ if ( strcasecmp(hardware,"custom")==0 ) {
		;
	    } else if ( strcasecmp(hardware,"proport")==0 ) {
		cra = 0x4100; // 16-bit words, 2 words/frame
		crb = 0x3A00;
		  // frame-sync=00 ==> word-len pulse (50% duty cycle)
		  // sync rx&tx, not gated, network mode, enable rx&tx
	    } else if ( strcasecmp(hardware,"digimic")==0 ) {
		// the "Ariel" Digital Microphone is a receive only
		// device.  However, it doesn't hurt
		// to send it data...it will just be dropped.
		// The baud rate can be selected similarly as to the proport,
		// but the conversion table is different.
		cra = 0x4100; // 16-bit words, 2 words/frame
		crb = 0x3A00;
		  // frame-sync=00 ==> word-len pulse (50% duty cycle)
		  // sync rx&tx, not gated, network mode, enable rx&tx
	    } else if ( strcasecmp(hardware,"magnavox")==0 ) {
		cra = 0x4000; // 16-bit words, 1 word/frame
		crb = 0x3300;
		  // frame-sync=10 ==> 1-bit pulse width
		  // sync rx&tx, not gated, normal mode, enable rx&tx
	    } else {
		Error::abortRun(*this,"Unknown hardware");
	    }
}


// prototype instance for known block list
static CG56SSI proto;
static RegisterBlock registerBlock(proto,"SSI");
