#ifndef _CG56SSI_h
#define _CG56SSI_h 1
// header file generated from CG56SSI.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */
#include "CG56Star.h"
#include <stream.h>
#include "IntState.h"
#include "StringState.h"
#include "FixState.h"
#include "FixArrayState.h"

class CG56SSI : public CG56Star
{
public:
	CG56SSI();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	static CodeBlock ssiInit;
	static CodeBlock enableInterupts;
	static CodeBlock abortyes;
	static CodeBlock polling;
	static CodeBlock interruptInit;
	static CodeBlock interruptRecvDataVec;
	static CodeBlock interruptRecvExcptVec;
	static CodeBlock intrLoadM0;
	static CodeBlock intrRestoreM0;
	static CodeBlock intrLoadRecvPtr;
	static CodeBlock intrSaveRecvPtr;
	static CodeBlock intrGetRecvY0;
	static CodeBlock intrGetRecv1;
	static CodeBlock intrGetRecv2;
	static CodeBlock intrLoadXmitPtr;
	static CodeBlock intrSaveXmitPtr;
	static CodeBlock intrPutXmit1;
	static CodeBlock intrPutXmit2;
	static CodeBlock intrPutXmitY0;
	static CodeBlock ihdlPreserveRegs;
	static CodeBlock ihdlRestoreRegs;
	static CodeBlock ihdlSymmetricBuffer;
	static CodeBlock ihdlDualBuffer;
	/* virtual */ int myExecTime();
	/* virtual */ void initCode();
	InCG56Port input1;
	InCG56Port input2;
	OutCG56Port output1;
	OutCG56Port output2;

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	StringState hardware;
	IntState symmetricBuffers;
	IntState queueSize;
	IntState abortOnRealTimeError;
	IntState cra;
	IntState crb;
	IntState bufLen;
	IntState intrAbort;
	IntState dualbufFlag;
	IntState missCnt;
	FixArrayState buffer;
	IntState recvStarPtr;
	IntState xmitStarPtr;
	IntState recvIntrPtr;
	IntState xmitIntrPtr;
	FixArrayState saveReg;
	IntState savePrevOut;
	FixState prevOut1;
	FixState prevOut2;
# line 281 "CG56SSI.pl"
int	doIntr;
	int	doErrAbort;
	int	doSymmetric;
	int	doRecv1;
	int	doRecv2;
	int	doXmit1;
	int	doXmit2;
	void go_intr_port (const char *port);
	void go_intr ();
	void config_hardware ();

};
#endif
