static const char file_id[] = "CG56SSISkew.pl";
// .cc file generated from CG56SSISkew.pl by ptlang
/*
Copyright (c) 1991-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56SSISkew.h"

const char *star_nm_CG56SSISkew = "CG56SSISkew";

const char* CG56SSISkew :: className() const {return star_nm_CG56SSISkew;}

ISA_FUNC(CG56SSISkew,CG56SSI);

Block* CG56SSISkew :: makeNew() const { LOG_NEW; return new CG56SSISkew;}

CodeBlock CG56SSISkew :: cbSkewTop_external (
# line 80 "CG56SSISkew.pl"
"	move	$ref(error),a\n"
"	tst	a\n"
"	.IF	<MI>			; minus (underflow 0.0)\n"
"	IF	$val(savePrevOut)\n"
"	  move	$ref(prevOut1),y0\n"
"	  move	y0,$ref(output1)\n"
"	  move	$ref(prevOut2),y0\n"
"	  move	y0,$ref(output2)\n"
"	ENDIF\n"
"	.ELSE\n"
"	jeq	$label(normal)		; ext. clear\n"
"	.LOOP	#2			; ext. set (overflow 1.0)\n"
"$label(normal)\n");

CodeBlock CG56SSISkew :: cbSkewTop_internal (
# line 95 "CG56SSISkew.pl"
"	move	$ref(accum),a\n"
"	move	$ref(error),x0\n"
"	add	x0,a	#0.5,y0\n"
"	move	a1,$ref(accum)\n"
"	.IF	<MI>			; minus (underflow 0.0)\n"
";	bchg	#0,x:m_pcd		; flip SCI RXD\n"
"	move	y0,$ref(accum)\n"
"	IF	$val(savePrevOut)\n"
"	  move	$ref(prevOut1),y0\n"
"	  move	y0,$ref(output1)\n"
"	  move	$ref(prevOut2),y0\n"
"	  move	y0,$ref(output2)\n"
"	ENDIF\n"
"	.ELSE\n"
"	jec	$label(normal)		; ext. clear\n"
";	bchg	#1,x:m_pcd		; flip SCI TXD\n"
"	move	y0,$ref(accum)\n"
"	.LOOP	#2			; ext. set (overflow 1.0)\n"
"$label(normal)\n");

CodeBlock CG56SSISkew :: cbSkewBot (
# line 116 "CG56SSISkew.pl"
"	.ENDL\n"
"	.ENDI\n"
"	nop				; required!!!\n");

CG56SSISkew::CG56SSISkew ()
{
	setDescriptor("Interface to the 56001 SSI's port with timing-skew capability.");
	addPort(error.setPort("error",this,FIX));
	addState(internalAccum.setState("internalAccum",this,"YES","\"Boolean: internal or external accumulator.\""));
	addState(accum.setState("accum",this,"0.5","Accumulation of error skew.",
# line 59 "CG56SSISkew.pl"
A_NONSETTABLE|A_NONCONSTANT|A_XMEM));

# line 62 "CG56SSISkew.pl"
;
}

void CG56SSISkew::initCode() {
# line 72 "CG56SSISkew.pl"
if ( output1.bufSize() != 1 || output2.bufSize() != 1 ) {
	    // if the bufSize is greater than 1, then subsequent firings
	    // will have the output port in different locations,
	    // and thus we cant assume the old value is already there.
	    savePrevOut = 1;
	}
	CG56SSI::initCode();
}

void CG56SSISkew::setup() {
# line 66 "CG56SSISkew.pl"
if ( int(queueSize) == 0 ) {
	    queueSize = 1;	// force interrupts
	}
	CG56SSI::setup();
}

void CG56SSISkew::go() {
# line 122 "CG56SSISkew.pl"
if ( int(internalAccum) ) {
	    addCode(cbSkewTop_internal);
	} else {
	    addCode(cbSkewTop_external);
	}
	CG56SSI::go();
	addCode(cbSkewBot);
}

// prototype instance for known block list
static CG56SSISkew proto;
static RegisterBlock registerBlock(proto,"SSISkew");
