static const char file_id[] = "CG56Shifter.pl";
// .cc file generated from CG56Shifter.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Shifter.h"

const char *star_nm_CG56Shifter = "CG56Shifter";

const char* CG56Shifter :: className() const {return star_nm_CG56Shifter;}

ISA_FUNC(CG56Shifter,CG56Star);

Block* CG56Shifter :: makeNew() const { LOG_NEW; return new CG56Shifter;}

CodeBlock CG56Shifter :: cbLoad (
# line 59 "CG56Shifter.pl"
"        move    $ref(input),a\n");

CodeBlock CG56Shifter :: cbShifts (
# line 62 "CG56Shifter.pl"
"	IF	$val(absShifts)>=1\n"
"          rep     #$val(absShifts)\n"
"	ENDIF\n"
"\n"
"	IF	$val(leftShifts)>0\n"
"          asl     a\n"
"	ELSE\n"
"          asr     a\n"
"	ENDIF\n");

CodeBlock CG56Shifter :: cbSaveSat (
# line 73 "CG56Shifter.pl"
"	move	a,$ref(output)\n");

CodeBlock CG56Shifter :: cbSaveNosat (
# line 76 "CG56Shifter.pl"
"	move	a1,$ref(output)\n");

CG56Shifter::CG56Shifter ()
{
	setDescriptor("Hard shifter.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(leftShifts.setState("leftShifts",this,"1","Number of left shifts."));
	addState(absShifts.setState("absShifts",this,"0","Absolute value of number of bit shifts.",
# line 39 "CG56Shifter.pl"
A_NONSETTABLE));
	addState(saturation.setState("saturation",this,"YES","If true, use saturation arithmetic"));

# line 48 "CG56Shifter.pl"
noInternalState();
}

int CG56Shifter::myExecTime() {
# line 88 "CG56Shifter.pl"
return int(absShifts) + 3;
}

void CG56Shifter::setup() {
# line 54 "CG56Shifter.pl"
int scnt = int(leftShifts);
	absShifts = scnt >= 0 ? scnt : - scnt;
	const char *str = saturation;
	doSat = str[0]=='Y' || str[0]=='y';
}

void CG56Shifter::go() {
# line 80 "CG56Shifter.pl"
addCode(cbLoad);
	if ( int(absShifts)!=0 ) {
	    addCode(cbShifts);
	}
	if ( doSat )		addCode(cbSaveSat);
	else			addCode(cbSaveNosat);
}

// prototype instance for known block list
static CG56Shifter proto;
static RegisterBlock registerBlock(proto,"Shifter");
