static const char file_id[] = "CG56Sin.pl";
// .cc file generated from CG56Sin.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Sin.h"

const char *star_nm_CG56Sin = "CG56Sin";

const char* CG56Sin :: className() const {return star_nm_CG56Sin;}

ISA_FUNC(CG56Sin,CG56Star);

Block* CG56Sin :: makeNew() const { LOG_NEW; return new CG56Sin;}

CodeBlock CG56Sin :: cbPrepare (
# line 49 "CG56Sin.pl"
"	move    $ref(input),x0\n"
"; shift input 16 bits to the right and round --> a\n"
"        move    #>$$000080,x1\n"
"        mpyr    x0,x1,a		#>$val(phaseOffset),y1\n"
";	add phase shift\n"
"	add	y1,a		#>$$0000ff,x0\n"
"; mask address bits --> r1\n"
"        and     x0,a            #>$$000100,x1\n"
"        or      x1,a\n"
"        move    a1,r1\n");

CodeBlock CG56Sin :: cbTempTables (
# line 61 "CG56Sin.pl"
"; set DE=1 in OMR, to access sine tables\n"
"; we use to play pipeline tricks with turning the sine tables on and off.\n"
"; However, this isnt safe in the presence of interrupts, so we just eat\n"
"; the nop.\n"
"        ori     #$$04,omr	; turn on table  -- NOTE THE 1 CYCLE TIME LAG\n"
"	nop\n"
"        move    y:(r1),b	; read the table\n"
"        andi    #$$fb,omr	; turn off table -- NOTE THE 1 CYCLE TIME LAG\n"
"	nop\n"
"        move    b1,$ref(output)\n");

CodeBlock CG56Sin :: cbPermTables (
# line 74 "CG56Sin.pl"
"; We assume that DE=1 in OMR always, so no need to turn it on\n"
"        move    y:(r1),b	; read the table\n"
"        move    b1,$ref(output)\n");

# line 80 "CG56Sin.pl"
// fn to round to nearest int.  Done this way because
		// truncation of negative values to integers is machine
		// dependent in C/C++.
		inline int round(double x) {
			return (x >= 0) ? int(x+0.5) : -int(0.5-x);
		}

CG56Sin::CG56Sin ()
{
	setDescriptor("Sine function calculated by table lookup.  Input range of [-1,1) is scaled\nby pi.  Output is sin(pi*input).");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(phase.setState("phase",this,"0","\"Additive phase relative to the sin() function.\""));
	addState(phaseOffset.setState("phaseOffset",this,"0","\"Munged form of phase.\"",
# line 44 "CG56Sin.pl"
A_NONSETTABLE));

# line 47 "CG56Sin.pl"
noInternalState();
}

int CG56Sin::myExecTime() {
# line 103 "CG56Sin.pl"
return 10;
}

void CG56Sin::setup() {
# line 88 "CG56Sin.pl"
double ph = double(phase);
		if ( ph < 0 ) {
			int n = (int) floor(-ph / 360.0);
			ph += 360.0 * (n+1);
		} else if ( ph >= 360.0 ) {
			int n = (int) floor(ph / 360.0);
			ph -= 360.0 * n;
		}
		phaseOffset = round(ph/360.0*256.0);
}

void CG56Sin::go() {
# line 99 "CG56Sin.pl"
addCode(cbPrepare);
		addCode(cbTempTables);
}

// prototype instance for known block list
static CG56Sin proto;
static RegisterBlock registerBlock(proto,"Sin");
