static const char file_id[] = "CG56Skew.pl";
// .cc file generated from CG56Skew.pl by ptlang
/*
Copyright (c) 1991-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Skew.h"

const char *star_nm_CG56Skew = "CG56Skew";

const char* CG56Skew :: className() const {return star_nm_CG56Skew;}

ISA_FUNC(CG56Skew,CG56Star);

Block* CG56Skew :: makeNew() const { LOG_NEW; return new CG56Skew;}

CodeBlock CG56Skew :: cbSkew (
# line 48 "CG56Skew.pl"
"	move	$ref(accum),a\n"
"	clr	b	$ref(error),x0\n"
"	add	x0,a	#0.5,x1\n"
"	move	#$val(overflowVal),y1\n"
"	move	#$val(underflowVal),y0\n"
"	tes	x1,a\n"
"	tes	y1,b\n"
"	tmi	x1,a\n"
"	tmi	y0,b\n"
"	move	a1,$ref(accum)\n"
"	move	b1,$ref(output)\n");

CG56Skew::CG56Skew ()
{
	setDescriptor("Generic skewing star.");
	addPort(error.setPort("error",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(accum.setState("accum",this,"0.5","Accumulation of error skew.",
# line 34 "CG56Skew.pl"
A_NONSETTABLE|A_NONCONSTANT|A_XMEM));
	addState(underflowVal.setState("underflowVal",this,"-0.9","Value to output on underflow."));
	addState(overflowVal.setState("overflowVal",this,"0.9","Value to output on overflow."));


}

void CG56Skew::go() {
# line 62 "CG56Skew.pl"
addCode(cbSkew);
}

// prototype instance for known block list
static CG56Skew proto;
static RegisterBlock registerBlock(proto,"Skew");
