static const char file_id[] = "CG56SubInt.pl";
// .cc file generated from CG56SubInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56SubInt.h"

const char *star_nm_CG56SubInt = "CG56SubInt";

const char* CG56SubInt :: className() const {return star_nm_CG56SubInt;}

ISA_FUNC(CG56SubInt,CG56Star);

Block* CG56SubInt :: makeNew() const { LOG_NEW; return new CG56SubInt;}

CodeBlock CG56SubInt :: subtract (
# line 32 "CG56SubInt.pl"
"	move	$ref(pos),a\n"
"	move	$ref(neg#1),x0\n"
"	sub	x0,a\n");

CodeBlock CG56SubInt :: startOp (
# line 37 "CG56SubInt.pl"
"	move	$addr(neg),r0\n"
"	move	$ref(pos),a\n"
"	move	(r0)+,x0\n");

const char* CG56SubInt :: repeat(int n) {
# line 42 "CG56SubInt.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	rep	#" << (n) << "\n";
	return (const char*)_str_;
}

CodeBlock CG56SubInt :: doOp (
# line 45 "CG56SubInt.pl"
"	sub	x0,a	(r0)+,x0\n");

CodeBlock CG56SubInt :: finalDifference (
# line 48 "CG56SubInt.pl"
"	sub	x0,a\n");

CodeBlock CG56SubInt :: saveResult (
# line 51 "CG56SubInt.pl"
"	move	a,$ref(output)\n");

# line 30 "CG56SubInt.pl"
#define	CG56_REPEAT_THRESHOLD 3

CG56SubInt::CG56SubInt ()
{
	setDescriptor("Output the \"pos\" input minus all \"neg\" inputs.");
	addPort(pos.setPort("pos",this,INT));
	addPort(neg.setPort("neg",this,INT));
	addPort(output.setPort("output",this,INT));

# line 27 "CG56SubInt.pl"
noInternalState();
}

int CG56SubInt::myExecTime() {
# line 77 "CG56SubInt.pl"
int instructionCycles = 0;
	int numNegInputs = neg.numberPorts();
	int numRepeats = numNegInputs - 1;

	if ( numNegInputs == 1 )
	    instructionCycles = 4;
	else if ( numRepeats > CG56_REPEAT_THRESHOLD )
	    instructionCycles = 4 + 2 + 1 + numRepeats;
	else
	    instructionCycles = 4 + 1 + numRepeats;

	return neg.numberPorts() + 6;
}

void CG56SubInt::go() {
# line 55 "CG56SubInt.pl"
int numNegInputs = neg.numberPorts();
	int numRepeats = numNegInputs - 1;

	if ( numNegInputs == 1 ) {
	    addCode(subtract);
	}
	else {
	    addCode(startOp);
	    // It takes 2 instruction cycles to set up the repeat loop
	    if ( numRepeats > CG56_REPEAT_THRESHOLD ) {
		addCode(repeat(numRepeats));
		addCode(doOp); 
	    }
	    else {
		for (int i = 1; i <= numRepeats; i++)
		    addCode(doOp); 
	    }
	    addCode(finalDifference);	
	}
	addCode(saveResult);
}

// prototype instance for known block list
static CG56SubInt proto;
static RegisterBlock registerBlock(proto,"SubInt");
