static const char file_id[] = "CG56TableInt.pl";
// .cc file generated from CG56TableInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56TableInt.h"

const char *star_nm_CG56TableInt = "CG56TableInt";

const char* CG56TableInt :: className() const {return star_nm_CG56TableInt;}

ISA_FUNC(CG56TableInt,CG56Star);

Block* CG56TableInt :: makeNew() const { LOG_NEW; return new CG56TableInt;}

CodeBlock CG56TableInt :: readIdx (
# line 48 "CG56TableInt.pl"
"	move	#>$addr(values),r0			; table address in y memory\n"
"	move	$ref(input),n0			; table index\n"
"	nop				; account for pipelining delay\n");

CodeBlock CG56TableInt :: check (
# line 53 "CG56TableInt.pl"
"; There is no check to make sure that the index is in bounds\n");

CodeBlock CG56TableInt :: lookup (
# line 56 "CG56TableInt.pl"
"	move	y:(r0+n0),x0		; read table value (2 instructions)\n"
"	move	x0,$ref(output)			; write table value to output\n");

CG56TableInt::CG56TableInt ()
{
	setDescriptor("Implements an integer-valued lookup table.  The \"values\" state contains the\nvalues to output; its first element is element zero.  An error occurs if\nan out of bounds value is received.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(values.setState("values",this,"-1 1","table of values to output",
# line 34 "CG56TableInt.pl"
A_YMEM|A_CONSEC));
	addState(runTimeCheck.setState("runTimeCheck",this,"YES","If YES, check range of index at runtime, else omit.\nThis is currently not supported in the CG56 domain."));

# line 46 "CG56TableInt.pl"
noInternalState();
}

int CG56TableInt::myExecTime() {
# line 66 "CG56TableInt.pl"
return 6;
}

void CG56TableInt::go() {
# line 61 "CG56TableInt.pl"
addCode(readIdx);
		if (int(runTimeCheck)) addCode(check);
		addCode(lookup);
}

// prototype instance for known block list
static CG56TableInt proto;
static RegisterBlock registerBlock(proto,"TableInt");
