static const char file_id[] = "CG56Test.pl";
// .cc file generated from CG56Test.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Test.h"

const char *star_nm_CG56Test = "CG56Test";

const char* CG56Test :: className() const {return star_nm_CG56Test;}

ISA_FUNC(CG56Test,CG56Star);

Block* CG56Test :: makeNew() const { LOG_NEW; return new CG56Test;}

CodeBlock CG56Test :: data (
# line 120 "CG56Test.pl"
"; Test star: a = upper input and x0 = lower input\n"
"	clr	b	$ref(lower),x0\n"
"	move	$ref(upper),a\n");

CodeBlock CG56Test :: dataAndPrevResult (
# line 126 "CG56Test.pl"
"; Test star: a = upper input, x0 = lower input, and y0 = previous result\n"
"	clr	b	$ref(lower),x0	$ref(prevResult),y0\n"
"	move	$ref(upper),a\n");

CodeBlock CG56Test :: equalTest (
# line 134 "CG56Test.pl"
"	cmp	x0,a	#$$FF,a		; test a - x0 and set a = TRUE\n"
"	tne	b,a			; if lower != upper then a = FALSE\n");

CodeBlock CG56Test :: notEqualTest (
# line 138 "CG56Test.pl"
"	sub	x0,a			; test a - x0 which returns a Boolean\n");

CodeBlock CG56Test :: greaterThan (
# line 141 "CG56Test.pl"
"	cmp	x0,a	#$$FF,a		; test a - x0 and set a = TRUE\n"
"	tle	b,a			; if upper <= lower, then a = FALSE\n");

CodeBlock CG56Test :: greaterEqual (
# line 145 "CG56Test.pl"
"	cmp	x0,a	#$$FF,a		; test a - x0 and set a = TRUE\n"
"	tlt	b,a			; if upper < lower, then a = FALSE\n");

CodeBlock CG56Test :: crossings (
# line 152 "CG56Test.pl"
"; compare previous and current results, and save current result\n"
"	sub	y0,a	a,$ref(prevResult)\n");

CodeBlock CG56Test :: saveResult (
# line 158 "CG56Test.pl"
"	move	a,$ref(output)\n");

# line 80 "CG56Test.pl"
#define EQID 0
#define NEID 1
#define GTID 2
#define GEID 3

CG56Test::CG56Test ()
{
	setDescriptor("This star compares its two inputs \"upper\" and \"lower\".\nThe test \"condition\" can be any one of {EQ NE GT GE},\nor equivalently any one of {== != > >=},\nwhose elements represent the binary operations of equals, not equals,\ngreater than, and greater than or equals, respectively.\n\nIf the \"crossingsOnly\" parameter is TRUE, then the output is TRUE only\nwhen the outcome of the test changes from TRUE to FALSE\nor FALSE to TRUE.\nIn this case, the first output is always TRUE.");
	addPort(upper.setPort("upper",this,FIX));
	addPort(lower.setPort("lower",this,FIX));
	addPort(output.setPort("output",this,INT));
	addState(condition.setState("condition",this,"EQ","The test condition, i.e, one of EQ, NE, LT, or LE."));
	addState(crossingsOnly.setState("crossingsOnly",this,"FALSE","If TRUE, outputs are TRUE only when the sense of the test changes."));
	addState(prevResult.setState("prevResult",this,"-1","Initial value indicates that prevResult has not yet gotten the result of a\ntest.  This ensures that the first test result will always be TRUE.",
# line 74 "CG56Test.pl"
A_NONCONSTANT|A_NONSETTABLE));

# line 86 "CG56Test.pl"
test = EQID;
}

int CG56Test::myExecTime() {
# line 193 "CG56Test.pl"
// FIXME. Estimates of execution time are given in pairs of
		// oscillator cycles because that's the way it was done in
		// Gabriel: they simply counted the number of instructions.

		// Time to read in the two inputs and write out one result
		int pairsOfCycles = 3;
		// Add number of pairs of cycles
		if ( int(crossingsOnly) ) pairsOfCycles++;
		switch (test) {
		    case EQID:
			pairsOfCycles += 2;
			break;
		    case NEID:
			pairsOfCycles += 1;
			break;
		    case GTID:
			pairsOfCycles += 2;
			break;
		    case GEID:
			pairsOfCycles += 2;
			break;
		}
		return pairsOfCycles;
}

void CG56Test::setup() {
# line 89 "CG56Test.pl"
const char* cn = condition;
		if ( strcasecmp(cn, "EQ") == 0) test = EQID;
		else if ( strcasecmp(cn, "NE") == 0 ) test = NEID;
		else if ( strcasecmp(cn, "GT") == 0 ) test = GTID;
		else if ( strcasecmp(cn, "GE") == 0 ) test = GEID;
		else if ( strcasecmp(cn, "==") == 0 ) test = EQID;
		else if ( strcasecmp(cn, "!=") == 0 ) test = NEID;
		else if ( strcasecmp(cn, ">") == 0 ) test = GTID;
		else if ( strcasecmp(cn, ">=") == 0 ) test = GEID;
		else Error::abortRun(*this, "Unrecognized test.");

		// This state has radically different behavior
		// depending on the setting of crossingsOnly
		if ( int(crossingsOnly) ) {
			// FIXME: need to declare internal state
			prevResult.setAttributes(A_YMEM);
		}
		else {
			// FIXME: need to declare no internal state
			prevResult.clearAttributes(A_YMEM);
		}
}

void CG56Test::go() {
# line 163 "CG56Test.pl"
StringList header = "; Testing if upper ";
		header << (const char*)condition << " lower\n";
		addCode(header);

		if ( int(crossingsOnly) ) addCode(dataAndPrevResult);
		else addCode(data);

		// Evaluate test, leaving the result in accumulator a
		switch (test) {
		    case EQID:
			addCode(equalTest);
			break;
		    case NEID:
			addCode(notEqualTest);
			break;
		    case GTID:
			addCode(greaterThan);
			break;
		    case GEID:
			addCode(greaterEqual);
			break;
		}

		if ( int(crossingsOnly) ) {
		    addCode(crossings);
		}

		addCode(saveResult);
}

// prototype instance for known block list
static CG56Test proto;
static RegisterBlock registerBlock(proto,"Test");
