static const char file_id[] = "CG56Tone.pl";
// .cc file generated from CG56Tone.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56Tone.h"

const char *star_nm_CG56Tone = "CG56Tone";

const char* CG56Tone :: className() const {return star_nm_CG56Tone;}

ISA_FUNC(CG56Tone,CG56Star);

Block* CG56Tone :: makeNew() const { LOG_NEW; return new CG56Tone;}

CodeBlock CG56Tone :: std (
# line 79 "CG56Tone.pl"
"	move	$ref(state2),x1\n"
"	move	$ref(state1),a\n"
"	move	#$val(X),x0\n"
"	mac	-x1,x0,a	x1,$ref(output)\n"
"	neg	a\n"
"	mac	x1,x0,a		x1,$ref(state1)\n"
"	move	a,$ref(state2)\n");

CG56Tone::CG56Tone ()
{
	setDescriptor("Sine or cosine function using second order oscillator");
	addPort(output.setPort("output",this,FIX));
	addState(amplitude.setState("amplitude",this,".5","amplitude of sine/cosine wave"));
	addState(frequency.setState("frequency",this,".02","frequency, relative to the sampling frequency"));
	addState(calcType.setState("calcType",this,"sin","calculation type (sin or cos)"));
	addState(state1.setState("state1",this,"0","internal",
# line 42 "CG56Tone.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM));
	addState(state2.setState("state2",this,"0","internal",
# line 49 "CG56Tone.pl"
A_NONCONSTANT|A_NONSETTABLE|A_XMEM));
	addState(X.setState("X",this,"0","internal",
# line 56 "CG56Tone.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

int CG56Tone::myExecTime() {
# line 78 "CG56Tone.pl"
return 7;
}

void CG56Tone::setup() {
# line 59 "CG56Tone.pl"
// maximum fixed point value
		double twoPiF = 2.0 * M_PI * frequency.asDouble();
		X = cos(twoPiF);
		const char* p = calcType;
		switch (*p) {
		case 's':	// sine
			state1 = 0.0;
			state2 = amplitude.asDouble() * sin(twoPiF);
			break;
		case 'c':	// cosine
			state1 = amplitude;
			state2 = amplitude.asDouble() * cos(twoPiF);
			break;
		default:
			Error::abortRun(*this, "calcType must be sin or cos");
			return;
		}
}

void CG56Tone::go() {
# line 77 "CG56Tone.pl"
addCode(std);
}

// prototype instance for known block list
static CG56Tone proto;
static RegisterBlock registerBlock(proto,"Tone");
