static const char file_id[] = "CG56UpSample.pl";
// .cc file generated from CG56UpSample.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56UpSample.h"

const char *star_nm_CG56UpSample = "CG56UpSample";

const char* CG56UpSample :: className() const {return star_nm_CG56UpSample;}

ISA_FUNC(CG56UpSample,CG56Star);

Block* CG56UpSample :: makeNew() const { LOG_NEW; return new CG56UpSample;}

CodeBlock CG56UpSample :: initfill (
# line 52 "CG56UpSample.pl"
"	move	#$addr(output),r1\n"
"	move	#$val(fill),a\n");

CodeBlock CG56UpSample :: repeatcode (
# line 56 "CG56UpSample.pl"
"	rep	#$size(output)\n");

CodeBlock CG56UpSample :: fillcode (
# line 59 "CG56UpSample.pl"
"	move	a,$mem(output):(r1)+\n");

CodeBlock CG56UpSample :: sendsample (
# line 67 "CG56UpSample.pl"
"	move	$ref(input),a\n"
"	move	a,$ref2(output,phase)\n");

CG56UpSample::CG56UpSample ()
{
	setDescriptor("Upsample by a factor (default 2), filling with fill (default 0.0).  The\n\"phase\" tells where to put the sample in an output block.  The default\nis to output it first (phase = 0). The maximum phase is \"factor\" - 1.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(factor.setState("factor",this,"2","Number of samples produced.",
# line 31 "CG56UpSample.pl"
A_SETTABLE));
	addState(phase.setState("phase",this,"0","Where to put the input in the output block.",
# line 38 "CG56UpSample.pl"
A_SETTABLE));
	addState(fill.setState("fill",this,"0.0","Value to fill the output block.",
# line 45 "CG56UpSample.pl"
A_SETTABLE));


}

int CG56UpSample::myExecTime() {
# line 75 "CG56UpSample.pl"
return 1;
}

void CG56UpSample::initCode() {
# line 63 "CG56UpSample.pl"
addCode (initfill);
		if (factor > 1) addCode(repeatcode);
		addCode(fillcode);
}

void CG56UpSample::setup() {
# line 48 "CG56UpSample.pl"
output.setSDFParams(int(factor),int(factor)-1);
		if (int(phase) >= int(factor))
			Error::abortRun(*this, ": phase must be < factor");
}

void CG56UpSample::go() {
# line 72 "CG56UpSample.pl"
addCode(sendsample);
}

// prototype instance for known block list
static CG56UpSample proto;
static RegisterBlock registerBlock(proto,"UpSample");
