static const char file_id[] = "CG56VarDelay.pl";
// .cc file generated from CG56VarDelay.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56VarDelay.h"

const char *star_nm_CG56VarDelay = "CG56VarDelay";

const char* CG56VarDelay :: className() const {return star_nm_CG56VarDelay;}

ISA_FUNC(CG56VarDelay,CG56Star);

Block* CG56VarDelay :: makeNew() const { LOG_NEW; return new CG56VarDelay;}

CodeBlock CG56VarDelay :: block (
# line 50 "CG56VarDelay.pl"
"; initialize varDelay\n"
"; pointer to internal buffer\n"
"	org	$ref(bufStart)\n"
"  	dc	$addr(buf)\n"
"   	org 	p:\n");

CodeBlock CG56VarDelay :: std (
# line 57 "CG56VarDelay.pl"
"        movec   #$val(maxDelay),m0         ; MAX may be short immediate\n"
"        move    $ref(bufStart),r0\n"
"        clr     a       $ref(input),y0\n"
"        movec   m0,a1\n"
"        move    a,x1    y0,y:(r0)+\n"
"        move    $ref(control),y1\n"
"        mac     x1,y1,a r0,$ref(bufStart)\n"
"        asr     a       (r0)-\n"
"        clr     b       (r0)-\n"
"        move    a1,n0           ; offset\n"
"        move    a0,b1           ; remainder\n"
"        asr     b       #<0.5,a\n"
"        rnd     b       (r0)-n0 ; linear interpolation\n"
"        subl    b,a     y:(r0)+,y1      b,x1    ; a=1-b\n"
"        mpy     x1,y1,a y:(r0),y1       a,x1\n"
"        macr    x1,y1,a\n"
"        move    a,$ref(output)\n"
"        movec   m1,m0           ; restore m0\n");

CG56VarDelay::CG56VarDelay ()
{
	setDescriptor("A variable delay with linear interpolation.");
	addPort(input.setPort("input",this,FIX));
	addPort(control.setPort("control",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(buf.setState("buf",this,"0","buffer",
# line 35 "CG56VarDelay.pl"
A_CIRC|A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(bufStart.setState("bufStart",this,"0","pointer to the buffer",
# line 42 "CG56VarDelay.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));
	addState(maxDelay.setState("maxDelay",this,"10","maximum delay"));


}

int CG56VarDelay::myExecTime() {
# line 88 "CG56VarDelay.pl"
return 19;
}

void CG56VarDelay::initCode() {
# line 81 "CG56VarDelay.pl"
addCode(block);
}

void CG56VarDelay::setup() {
# line 78 "CG56VarDelay.pl"
buf.resize(maxDelay+1);
}

void CG56VarDelay::go() {
# line 84 "CG56VarDelay.pl"
addCode(std);
}

// prototype instance for known block list
static CG56VarDelay proto;
static RegisterBlock registerBlock(proto,"VarDelay");
