static const char file_id[] = "CG56VarQuasar.pl";
// .cc file generated from CG56VarQuasar.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56VarQuasar.h"

const char *star_nm_CG56VarQuasar = "CG56VarQuasar";

const char* CG56VarQuasar :: className() const {return star_nm_CG56VarQuasar;}

ISA_FUNC(CG56VarQuasar,CG56Star);

Block* CG56VarQuasar :: makeNew() const { LOG_NEW; return new CG56VarQuasar;}

CodeBlock CG56VarQuasar :: std (
# line 49 "CG56VarQuasar.pl"
"        clr     a       $ref(dataCount),b\n"
"        move    #$val(dataLen),a1         ; len may be SHORT\n"
"        cmp     a,b     #<0.0,a ; output = zero\n"
"        jge     <$label(output)\n"
"        move    #$addr(data),r0        ; base may be SHORT\n"
"        move    b,n0\n"
"        nop                     ; wait for n0\n"
"        move    y:(r0+n0),a1    ; output = next sample\n"
"$label(output)\n"
"        move    a1,$ref(output)\n"
"        move    #1,a1\n"
"        add     a,b     $ref(N),a1  ; increment counter\n"
"        tst     a\n"
"        jeq     <$label(cont)\n"
"        cmp     a,b     #<0.0,a\n"
"        tge     a,b             ; reset counter\n"
"$label(cont)\n"
"        move    b,$ref(dataCount)\n");

CG56VarQuasar::CG56VarQuasar ()
{
	setDescriptor("A sequence of values is repeated at the output with period N, zero-padding\nor truncating to N if necessary.\nA value of 0 for N outputs an aperiodic sequence.");
	addPort(N.setPort("N",this,INT));
	addPort(output.setPort("output",this,FIX));
	addState(data.setState("data",this,"0.1 0.2 0.3 0.4","list of values.",
# line 32 "CG56VarQuasar.pl"
A_NONCONSTANT|A_YMEM));
	addState(dataCount.setState("dataCount",this,"0","keep track number of data",
# line 39 "CG56VarQuasar.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM));
	addState(dataLen.setState("dataLen",this,"0","length of data (internal)",
# line 46 "CG56VarQuasar.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

int CG56VarQuasar::myExecTime() {
# line 79 "CG56VarQuasar.pl"
return 20;
}

void CG56VarQuasar::setup() {
# line 71 "CG56VarQuasar.pl"
dataLen=data.size();
}

void CG56VarQuasar::go() {
# line 75 "CG56VarQuasar.pl"
addCode(std);
}

// prototype instance for known block list
static CG56VarQuasar proto;
static RegisterBlock registerBlock(proto,"VarQuasar");
