static const char file_id[] = "CG56WaveForm.pl";
// .cc file generated from CG56WaveForm.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CG56WaveForm.h"
#include "Scheduler.h"

const char *star_nm_CG56WaveForm = "CG56WaveForm";

const char* CG56WaveForm :: className() const {return star_nm_CG56WaveForm;}

ISA_FUNC(CG56WaveForm,CG56Star);

Block* CG56WaveForm :: makeNew() const { LOG_NEW; return new CG56WaveForm;}

CodeBlock CG56WaveForm :: org (
# line 103 "CG56WaveForm.pl"
"; initialization of DC block\n"
"        org     $ref(output)\n");

CodeBlock CG56WaveForm :: dc (
# line 107 "CG56WaveForm.pl"
"        dc      $val(firstVal)\n");

CodeBlock CG56WaveForm :: orgp (
# line 110 "CG56WaveForm.pl"
"        org     p:\n");

CodeBlock CG56WaveForm :: impulse (
# line 113 "CG56WaveForm.pl"
"; impulse\n"
"        clr     b       $ref(value),a\n"
"        move    a,$ref(output)\n"
"        move    b,$ref(value)\n");

CodeBlock CG56WaveForm :: aperiodic (
# line 119 "CG56WaveForm.pl"
"; aperiodic value\n"
"        move    $ref(dataCirc),r0\n"
"        move    #$val(X),m0\n"
"        clr     b       y:(r0),a\n"
"        move    b,y:(r0)+\n"
"        move    a,$ref(output)\n"
"        move    r0,$ref(dataCirc)\n"
"        move    m7,m0\n");

CodeBlock CG56WaveForm :: periodperiodicSequence (
# line 129 "CG56WaveForm.pl"
"; period periodic value\n"
"        move    $ref(dataCirc),r0\n"
"        move    #$val(X),m0\n"
"        nop\n"
"        move    y:(r0)+,a\n"
"        move    a,$ref(output)\n"
"        move    r0,$ref(dataCirc)\n"
"        move    m7,m0\n");

CodeBlock CG56WaveForm :: zeroPaddedSequence (
# line 139 "CG56WaveForm.pl"
"; Zero padded value\n"
"        move    #>$val(valueLen),x1\n"
"        move    $ref(dataCirc),b\n"
"        move    #$addr(value),n0\n"
"        cmp     x1,b    b,r0\n"
"        jlt     $label(l29)\n"
"; #samples output > valueLen -- output zero as sample value\n"
"        clr     a       #>$val(X),x1\n"
"        move    a,$ref(output)\n"
"        cmp     x1,b    (r0)+\n"
"        jlt     $label(l30)\n"
"; end of period -- reset counter\n"
"        move    a,$ref(dataCirc)\n"
"        jmp     $label(l28)\n"
"$label(l29)\n"
"; output value from data value as sample value\n"
"        move    y:(r0+n0),a\n"
"        move    (r0)+\n"
"        move    a,$ref(output)\n"
"$label(l30)\n"
"; store incremented counter\n"
"        move    r0,$ref(dataCirc)  \n"
"$label(l28)\n");

CodeBlock CG56WaveForm :: makeblock (
# line 165 "CG56WaveForm.pl"
"; output sample count\n"
"	org	$ref(dataCirc)\n"
"       	bsc	1,0\n"
"	org	p:\n");

CodeBlock CG56WaveForm :: initDataCirc (
# line 172 "CG56WaveForm.pl"
"; initialization of dataCirc\n"
"        org     $ref(dataCirc)\n"
"        dc      $addr(value)\n"
"        org     p:\n");

CG56WaveForm::CG56WaveForm ()
{
	setDescriptor("A value of values is repeated at the output with period period, zero-padding\nor truncating to period if necessary.\nSetting period to 0 (default) outputs the value once.\nThe default value is 0.1 0.2 0.3 0.4.");
	addPort(output.setPort("output",this,FIX));
	addState(value.setState("value",this,"0.1 0.2 0.3 0.4","One period of the output waveform.",
# line 54 "CG56WaveForm.pl"
A_CIRC|A_NONCONSTANT|A_YMEM));
	addState(haltAtEnd.setState("haltAtEnd",this,"NO","Halt the run at the end of the given data."));
	addState(periodic.setState("periodic",this,"YES","Output is periodic if \"YES\" (nonzero)."));
	addState(period.setState("period",this,"0","If greater than zero, gives the period of the waveform"));
	addState(X.setState("X",this,"0","internal",
# line 79 "CG56WaveForm.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(firstVal.setState("firstVal",this,"0.1","first value of value",
# line 86 "CG56WaveForm.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(valueLen.setState("valueLen",this,"4","number of values in value.",
# line 93 "CG56WaveForm.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(dataCirc.setState("dataCirc",this,"0","pointer",
# line 100 "CG56WaveForm.pl"
A_NONCONSTANT|A_NONSETTABLE|A_YMEM|A_NOINIT));


}

int CG56WaveForm::myExecTime() {
# line 240 "CG56WaveForm.pl"
if (int (period) == 0)
			if (int (valueLen) == 1)
				return 3;
			else
				return 9;
		if (int (period) == 1)
			return 0;
		if (int (period) <= int (valueLen))
			return 9;
		return 19;
}

void CG56WaveForm::initCode() {
# line 194 "CG56WaveForm.pl"
if (period == 1) {
			//special case, reproduce DC star.
				addCode(org);
			for (int i = 0; i < output.bufSize(); i++)
				addCode(dc);
			addCode(orgp);
		}
		if (period != 1) {
			if ((period == 0 && valueLen > 1) ||
			   (period != 0 && period <= valueLen)) {
				addCode(initDataCirc);
			} else {
				if (period > valueLen)
					addCode(makeblock);
			}
		}
}

void CG56WaveForm::setup() {
# line 180 "CG56WaveForm.pl"
firstVal = value[0];
		valueLen = value.size();
		if (!(int (haltAtEnd)) &&int (periodic) && period == 0)
			period = valueLen;
		if (!(int (haltAtEnd)) &&!(int (periodic)))
			period = 0;
		if (period == 1) 
			output.setAttributes(P_NOINIT);
		if ((period > valueLen) || (period == 0))
			value.resize(int (valueLen));
		else
			value.resize(int (period));
}

void CG56WaveForm::go() {
# line 212 "CG56WaveForm.pl"
if (int(haltAtEnd))
                        Scheduler::requestHalt();
		if (period == 1)
			return;
		//special case, output stored at compile time.
			if (period == 0) {
			if (valueLen == 1)
				addCode(impulse);
			//output impulse.
				else {
				X = valueLen - 1;
				addCode(aperiodic);
				//output general aperiodic value.
			}
		}
		if (period <= valueLen && period != 1 && period != 0) {
			//output periodic value-- use first period values.
				X = period - 1;
			addCode(periodperiodicSequence);
		}
		if (period > valueLen && period != 1 && period != 0) {
			//output periodic value-- zero padded.
				X = period - 1;
			addCode(zeroPaddedSequence);
		}
}

// prototype instance for known block list
static CG56WaveForm proto;
static RegisterBlock registerBlock(proto,"WaveForm");
