static const char file_id[] = "CGCXBase.pl";
// .cc file generated from CGCXBase.pl by ptlang
/*
Copyright (c) 1993-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCXBase.h"
#include <stdio.h>
#include "compat.h"

const char *star_nm_CGCXBase = "CGCXBase";

const char* CGCXBase :: className() const {return star_nm_CGCXBase;}

ISA_FUNC(CGCXBase,CGCStar);

Block* CGCXBase :: makeNew() const { LOG_NEW; return new CGCXBase;}

const char* CGCXBase :: downloadCode(const char* s56path) {
# line 28 "CGCXBase.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    /* open the DSP */\n"
"    if (($val(S56XFilePrefix)_dsp = qckAttach(\"/dev/s56dsp\", NULL, 0)) == NULL) {\n"
"	char message[1024];\n"
"	sprintf(message,\"%s: %s\",\"Could not access the S-56X Card\",\n"
"		strerror(errno));\n"
"	EXIT_CGC(message);\n"
"    }\n"
"\n"
"    /* boot the moniter */\n"
"    if (qckBoot($val(S56XFilePrefix)_dsp,\"" << (s56path) << "/lib/qckMon.lod\")==-1) {\n"
"	char message[1024];\n"
"	sprintf(message,\"%s: %s\",qckErrString,strerror(errno));\n"
"	EXIT_CGC(message);\n"
"    }\n"
"\n"
"    /* load the application */\n"
"    if (qckLoad($val(S56XFilePrefix)_dsp,\"" << (cgTarget()->destDirectory) << "/$val(S56XFilePrefix).lod\") == -1) {\n"
"	char message[1024];\n"
"	sprintf(message,\"%s: %s\",qckErrString,strerror(errno));\n"
"	EXIT_CGC(message);\n"
"    }\n";
	return (const char*)_str_;
}

CodeBlock CGCXBase :: signalSOL2 (
# line 52 "CGCXBase.pl"
"{\n"
"    int sig = SIGUSR1;\n"
"    if (ioctl($val(S56XFilePrefix)_dsp->fd,DspSetAsyncSig, &sig) == -1) {\n"
"	char message[1024];\n"
"	sprintf(message,\"%s: %s\",\n"
"		\"Setting of interrupt process pointer to S56X driver failed\",\n"
"		strerror(errno));\n"
"	EXIT_CGC(message);\n"
"    }\n"
"}\n");

CodeBlock CGCXBase :: startDSP (
# line 65 "CGCXBase.pl"
"    if (qckJsr($val(S56XFilePrefix)_dsp,\"START\") == -1) {\n"
"	char message[1024];\n"
"	sprintf(message,\"%s: %s\",qckErrString,strerror(errno));\n"
"	EXIT_CGC(message);\n"
"    }\n");

CGCXBase::CGCXBase ()
{
	setDescriptor("Base star from  CGC <-> S56X IPC");
	addState(S56XFilePrefix.setState("S56XFilePrefix",this,"","S56XFilePrefix"));


}

void CGCXBase::wrapup() {
# line 99 "CGCXBase.pl"
addMainInit(startDSP,"s56start");
	addCode("qckDetach($val(S56XFilePrefix)_dsp);$val(S56XFilePrefix)_dsp=0;\n","mainClose","qckDetach");
}

void CGCXBase::initCode() {
# line 74 "CGCXBase.pl"
addInclude("<errno.h>");
	addInclude("<unistd.h>");
        addCompileOption("-I$S56DSP/include");
        addLinkOption("-L$S56DSP/lib -l$QCKMON");
	addInclude("<sys/types.h>");
	addInclude("<sys/uio.h>");
	addInclude("<signal.h>");
	addInclude("<s56dspUser.h>");
	addInclude("<qckMon.h>");
	addInclude("<stdio.h>");
	addGlobal("    QckMon* $val(S56XFilePrefix)_dsp;","dsp");
	// We do this here so that all the stars can do their initialization
	// before starting the DSP
       	char *s56path = getenv("S56DSP");
	int newmemory = FALSE;
	if (s56path == NULL) {
	    s56path = expandPathName("$PTOLEMY/vendors/s56dsp");
	    newmemory = TRUE;
	}
	addMainInit(downloadCode(s56path),"s56load");
	addMainInit(signalSOL2,"s56signal");
	if ( newmemory) delete [] s56path;
}

// prototype instance for known block list
static CGCXBase proto;
static RegisterBlock registerBlock(proto,"XBase");
