static const char file_id[] = "CGCXPeek.pl";
// .cc file generated from CGCXPeek.pl by ptlang
/*
Copyright (c) 1994-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCXPeek.h"

const char *star_nm_CGCXPeek = "CGCXPeek";

const char* CGCXPeek :: className() const {return star_nm_CGCXPeek;}

ISA_FUNC(CGCXPeek,CGCXAsynchComm);

Block* CGCXPeek :: makeNew() const { LOG_NEW; return new CGCXPeek;}

const char* CGCXPeek :: receiveToken() {
# line 22 "CGCXPeek.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    int value;\n"
"    fix fixValue;\n"
"    char* pValue = (char*) &value;\n"
"    pValue++;\n"
"    if ((value = qckPeek($val(S56XFilePrefix)_dsp,\"$val(VariableName)\")) == -1) { \n"
"	fprintf(stderr, \"$val(VariableName): Receive Data Failed\\n\", qckErrString);\n"
"	exit(1);\n"
"    }\n"
"    memset(fixValue,0,sizeof(fixValue));\n"
"    memcpy(fixValue,pValue,3);\n"
"    " << (command) << ";\n";
	return (const char*)_str_;
}

const char* CGCXPeek :: receiveBlock() {
# line 36 "CGCXPeek.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    if ( $starSymbol(bufStart) == 0) {\n"
"	int value[$val(blockSize)+1];\n"
"	int i;\n"
"	int offset;\n"
"	if ( qckGetBlkItem($val(S56XFilePrefix)_dsp,$starSymbol(s56xBuffer),value,$val(blockSize)+1) == -1) { \n"
"	    fprintf(stderr,\"$val(VariableName): Receive Data Failed\\n\", qckErrString);\n"
"	    exit(1);\n"
"	}\n"
"	offset = value[$val(blockSize)] - $starSymbol(bufferAddr);\n"
"	for(i=0;i<$val(blockSize);i++) {\n"
"	    fix fixValue;\n"
"	    char* pValue = (char*) &value[offset++%$val(blockSize)];\n"
"	    pValue++;\n"
"	    memset(fixValue,0,sizeof(fixValue));\n"
"	    memcpy(fixValue,pValue,3);\n"
"	    " << (command) << "\n"
"	}\n"
"    }\n";
	return (const char*)_str_;
}

CodeBlock CGCXPeek :: resetBufferStart (
# line 58 "CGCXPeek.pl"
"    if ($starSymbol(bufStart) >= $val(blockSize)) $starSymbol(bufStart) = 0;\n");

CGCXPeek::CGCXPeek ()
{
	setDescriptor("Receive data asynchronously from S56X to CGC");
	addPort(output.setPort("output",this,ANYTYPE));


}

void CGCXPeek::setup() {
# line 67 "CGCXPeek.pl"
int farXfer = output.far()->numXfer();
    if (!(int)blockSize%farXfer) output.setSDFParams(farXfer,farXfer-1);

    txType = output.resolvedType();

    StringList outVar;
    if ((int)blockSize > 1)
	outVar << (txType==FIX?"24,1,":"") << "$starSymbol(buffer)[i]";
    else
	outVar << "$ref(output)";

    command.initialize();
    if (txType == INT) {
	command << outVar << " = FIX_Fix2Int(24,24,fixValue);";
    }
    else if (txType == FIX) {
	command << "FIX_Assign(" << outVar << ",24,1,fixValue);"; 
	Precision cg56Fix(24,1);
	output.setPrecision(cg56Fix);
    }
    else if (txType == FLOAT) {
	command << outVar << " = FIX_Fix2Double(24,1,fixValue);";
    }
    else {
	Error::abortRun(*this,"Incompatible type, ",output.resolvedType());
	return;
    }
    CGCXAsynchComm::setup();
}

void CGCXPeek::go() {
# line 98 "CGCXPeek.pl"
if (blockSize > 1) {
	StringList code;
	StringList readBufferCommand;
	StringList refOutput;

	if (output.numXfer() > 1) {
	    refOutput = "$ref(output,i)";
	    readBufferCommand << "{\n\tint i;\n\tfor(i = 0;i < "
			      << output.numXfer() << ";i++) {\n";
	}
	else {
	    refOutput = "$ref(output)";
	}

	if (txType==FIX)
	    readBufferCommand
		<< "\tFIX_Assign(" << refOutput
		<< ",24,1,$starSymbol(buffer)[$starSymbol(bufStart)++]);\n";
	else
	    readBufferCommand
		<< "\t" << refOutput
		<< " = $starSymbol(buffer)[$starSymbol(bufStart)++];\n";
	if (output.numXfer() > 1) readBufferCommand << "}\n";

	code << receiveBlock() << readBufferCommand << resetBufferStart;
	addCode(code);
    }
    else {
	addCode(receiveToken());
    }
}

// prototype instance for known block list
static CGCXPeek proto;
static RegisterBlock registerBlock(proto,"XPeek");
