static const char file_id[] = "CGCXPoke.pl";
// .cc file generated from CGCXPoke.pl by ptlang
/*
Copyright (c) 1994-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCXPoke.h"

const char *star_nm_CGCXPoke = "CGCXPoke";

const char* CGCXPoke :: className() const {return star_nm_CGCXPoke;}

ISA_FUNC(CGCXPoke,CGCXAsynchComm);

Block* CGCXPoke :: makeNew() const { LOG_NEW; return new CGCXPoke;}

CodeBlock CGCXPoke :: intSend (
# line 31 "CGCXPoke.pl"
"    fix fixValue,dspWord;\n"
"    memcpy(fixValue,&$ref(input),sizeof(int));\n"
"    FIX_Assign(24,24,dspWord,sizeof(int)*8,sizeof(int)*8,fixValue);\n");

CodeBlock CGCXPoke :: floatSend (
# line 37 "CGCXPoke.pl"
"    fix dspWord;\n"
"    FIX_DoubleAssign(24,1,dspWord,$ref(input));\n");

CodeBlock CGCXPoke :: fixSend (
# line 42 "CGCXPoke.pl"
"    fix dspWord;\n"
"    FIX_Assign(24,1,dspWord,$ref(input));\n");

const char* CGCXPoke :: sendData() {
# line 47 "CGCXPoke.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    if (FIX_Compare(24,1,dspWord,$ref(buffer))) {\n"
"	int value;\n"
"	char* pValue = (char*) &value;\n"
"	memcpy(++pValue,dspWord,3);\n"
"	if (qckPoke($val(S56XFilePrefix)_dsp,\"$val(VariableName)\",value) == -1) { \n"
"	    fprintf(stderr, \"$val(VariableName):Send Data Failed\\n\", qckErrString);\n"
"	    exit(1);\n"
"	}\n"
"	FIX_Assign($ref(buffer),24,1,dspWord);\n"
"    }\n";
	return (const char*)_str_;
}

CGCXPoke::CGCXPoke ()
{
	setDescriptor("Send data asynchronously from CGC to S56X");
	addPort(input.setPort("input",this,ANYTYPE));
	addState(buffer.setState("buffer",this,"0","buffer",
# line 28 "CGCXPoke.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void CGCXPoke::setup() {
# line 61 "CGCXPoke.pl"
int farXfer = input.far()->numXfer();
    if (!(int)blockSize%farXfer) input.setSDFParams(farXfer,farXfer-1);
    if ((int) blockSize > 1) {
	Error::abortRun(*this," does not support blockSizes > 1");
	return;
    }
    txType = input.resolvedType();
    Precision cg56Fix(24,1);
    buffer.setPrecision(cg56Fix);
    if (input.resolvedType() == FIX)
	input.setPrecision(cg56Fix);
    CGCXAsynchComm::setup();
}

void CGCXPoke::go() {
# line 76 "CGCXPoke.pl"
StringList code;
    if (txType == INT)
	code << intSend;
    else if (txType == FIX)
	code << fixSend;
    else if (txType == FLOAT)
	code << floatSend;
    else {
	Error::abortRun(*this,"Incompatible type, ",input.resolvedType());
	return;
    }
    code << sendData();
    addCode(updateLink(code));
}

// prototype instance for known block list
static CGCXPoke proto;
static RegisterBlock registerBlock(proto,"XPoke");
