static const char file_id[] = "CGCXReceive.pl";
// .cc file generated from CGCXReceive.pl by ptlang
/*
Copyright (c) 1993-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCXReceive.h"

const char *star_nm_CGCXReceive = "CGCXReceive";

const char* CGCXReceive :: className() const {return star_nm_CGCXReceive;}

ISA_FUNC(CGCXReceive,CGCXSynchComm);

Block* CGCXReceive :: makeNew() const { LOG_NEW; return new CGCXReceive;}

const char* CGCXReceive :: poll() {
# line 23 "CGCXReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    int i, semaphoreMask = 1<<" << (pairNumber%24) << ";\n"
"    int count = S56X_MAX_POLL;\n"
"    /* wait for dsp buffer to be full */\n"
"    while ( ! $val(S56XFilePrefix)_hostSemaphores[" << (pairNumber) << "] && --count);\n"
"    $val(S56XFilePrefix)_hostSemaphores[" << (pairNumber) << "]=0;\n"
"    if (count == 0) EXIT_CGC(\"The S-56X board is failing to send data.  Is there another process still attached to the DSP?\");\n";
	return (const char*)_str_;
}

const char* CGCXReceive :: receiveData(const char* command, int numXfer, const char* type) {
# line 32 "CGCXReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"{\n"
"    int value[" << (numXfer) << "];\n"
"#if " << (numXfer-1) << "   \n"
"    if (qckGetBlkItem($val(S56XFilePrefix)_dsp,$starSymbol(s56xBuffer)" << (type) << ",value," << (numXfer) << ") == -1)\n"
"#else\n"
"    if ((value[0]=qckPeekItem($val(S56XFilePrefix)_dsp,$starSymbol(s56xBuffer)" << (type) << ")) == -1)\n"
"#endif\n"
"    {\n"
"	char buffer[128];\n"
"	sprintf(buffer, \"Receive Data Failed, Pair " << (pairNumber) << ": %s\",\n"
"		qckErrString);\n"
"	EXIT_CGC(buffer);\n"
"    }\n"
"    for (i=0;i<" << (numXfer) << ";i++) {\n"
"	fix fixValue;\n"
"	char* pValue;\n"
"	pValue = (char*) &value[" << (numXfer) << "-1-i];\n"
"	pValue++;\n"
"	memset(fixValue,0,sizeof(fixValue));\n"
"	memcpy(fixValue,pValue,3);\n"
"	" << (command) << ";\n"
"    }\n"
"}\n";
	return (const char*)_str_;
}

const char* CGCXReceive :: updateSemaphore() {
# line 58 "CGCXReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    $val(S56XFilePrefix)_s56xSemaphores[" << (pairNumber/24) << "] &= ~semaphoreMask;\n"
"    if (qckPutY($val(S56XFilePrefix)_dsp,$val(S56XFilePrefix)_semaphorePtr+" << (pairNumber/24) << ",$val(S56XFilePrefix)_s56xSemaphores[" << (pairNumber/24) << "]) == -1) { \n"
"	char buffer[128];\n"
"	sprintf(buffer, \"Semaphore update failed, Pair " << (pairNumber) << ": %s\", \n"
"		qckErrString);\n"
"	EXIT_CGC(buffer);\n"
"    }\n";
	return (const char*)_str_;
}

CGCXReceive::CGCXReceive ()
{
	setDescriptor("Receive data synchronously from S56X to CGC");
	addPort(output.setPort("output",this,ANYTYPE));


}

void CGCXReceive::setup() {
# line 69 "CGCXReceive.pl"
resolvedType = output.setResolvedType();
    if (resolvedType == FIX) {
	Precision cg56Fix(24,1);
	output.setPrecision(cg56Fix);
    }
    numXfer = output.numXfer();
    CGCXSynchComm::setup();
}

void CGCXReceive::go() {
# line 79 "CGCXReceive.pl"
addCode(poll());
    const char* intReceive = "$ref(output,i) = FIX_Fix2Int(24,24,fixValue)";
    const char* fixReceive = "FIX_Assign($ref(output,i),24,1,fixValue)";
    const char* floatReceive = "$ref(output,i)=FIX_Fix2Double(24,1,fixValue)";
    const char* realReceive = 
        "$ref(output,i).real=FIX_Fix2Double(24,1,fixValue)";
    const char* imagReceive = 
        "$ref(output,i).imag=FIX_Fix2Double(24,1,fixValue)";
    if (resolvedType == INT) 
	addCode(receiveData(intReceive,output.numXfer(),""));
    else if (resolvedType == FIX) 
	addCode(receiveData(fixReceive,output.numXfer(),""));
    else if (resolvedType == FLOAT) 
	addCode(receiveData(floatReceive,output.numXfer(),""));
    else if (resolvedType == COMPLEX) {
	addCode(receiveData(realReceive,output.numXfer(),"_REAL"));
	addCode(receiveData(imagReceive,output.numXfer(),"_IMAG"));
    }
    else {
	Error::abortRun(*this,output.resolvedType()," not supported");
    }
    addCode(updateSemaphore());
}

// prototype instance for known block list
static CGCXReceive proto;
static RegisterBlock registerBlock(proto,"XReceive");
