static const char file_id[] = "CGCXSend.pl";
// .cc file generated from CGCXSend.pl by ptlang
/*
Copyright (c) 1993-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCXSend.h"

const char *star_nm_CGCXSend = "CGCXSend";

const char* CGCXSend :: className() const {return star_nm_CGCXSend;}

ISA_FUNC(CGCXSend,CGCXSynchComm);

Block* CGCXSend :: makeNew() const { LOG_NEW; return new CGCXSend;}

const char* CGCXSend :: intSend(int numXfer) {
# line 25 "CGCXSend.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"{\n"
"    fix fixValue;\n"
"    memcpy(fixValue,&$ref(input" << (numXfer>1?",i":"") << "),sizeof(int));\n"
"    FIX_Assign(24,24,dspWord,sizeof(int)*8,sizeof(int)*8,fixValue);\n"
"}\n";
	return (const char*)_str_;
}

const char* CGCXSend :: floatSend(int numXfer,const char* type) {
# line 33 "CGCXSend.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    FIX_DoubleAssign(24,1,dspWord,$ref(input" << (numXfer>1?",i":"") << ")" << (type) << ");\n";
	return (const char*)_str_;
}

const char* CGCXSend :: fixSend(int numXfer) {
# line 37 "CGCXSend.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    FIX_Assign(24,1,dspWord,$ref(input" << (numXfer>1?",i":"") << "));\n";
	return (const char*)_str_;
}

const char* CGCXSend :: poll() {
# line 41 "CGCXSend.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    int i,semaphoreMask = 1<<" << (pairNumber%24) << ";\n"
"    int count = S56X_MAX_POLL;\n"
"    /* wait for dsp buffer to be empty */\n"
"    while ($val(S56XFilePrefix)_hostSemaphores[" << (pairNumber) << "] && --count);\n"
"    $val(S56XFilePrefix)_hostSemaphores[" << (pairNumber) << "]=1;\n"
"    if (count == 0) EXIT_CGC(\"The S-56X buffer# " << (pairNumber) << " is still empty.  The S-56X board is failing to receive data.  Is there another process still attached to the DSP?\");\n";
	return (const char*)_str_;
}

const char* CGCXSend :: sendData(const char* command,int numXfer, const char* type) {
# line 50 "CGCXSend.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"{\n"
"    int value[" << (numXfer) << "];\n"
"    for(i = 0 ; i<" << (numXfer) << " ; i ++) {\n"
"	char* pValue;\n"
"	fix dspWord;\n"
"        pValue = (char*) &value[" << (numXfer) << "-1-i];\n"
"" << (command) << "\n"
"        memcpy(++pValue,dspWord,3);\n"
"    }\n"
"#if " << (numXfer-1) << "\n"
"    if (qckPutBlkItem($val(S56XFilePrefix)_dsp,value,$starSymbol(s56xBuffer)" << (type) << "," << (numXfer) << ") == -1)\n"
"#else\n"
"    if (qckPokeItem($val(S56XFilePrefix)_dsp,$starSymbol(s56xBuffer)" << (type) << ",value[0]) == -1)\n"
"#endif\n"
"    {\n"
"	char buffer[128];\n"
"	sprintf(buffer,\n"
"		\"Send Data Failed, Pair " << (pairNumber) << ": %s\", qckErrString);\n"
"	EXIT_CGC(buffer);\n"
"    }\n"
"}\n";
	return (const char*)_str_;
}

const char* CGCXSend :: updateSemaphore() {
# line 74 "CGCXSend.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    $val(S56XFilePrefix)_s56xSemaphores[" << (pairNumber/24) << "] |= semaphoreMask;\n"
"    if (qckPutY($val(S56XFilePrefix)_dsp,$val(S56XFilePrefix)_semaphorePtr+" << (pairNumber/24) << ",$val(S56XFilePrefix)_s56xSemaphores[" << (pairNumber/24) << "]) == -1) { \n"
"	char buffer[128];\n"
"	sprintf(buffer, \"Semaphore update failed, Pair " << (pairNumber) << ": %s\", qckErrString);\n"
"	EXIT_CGC(buffer);\n"
"    }\n";
	return (const char*)_str_;
}

CGCXSend::CGCXSend ()
{
	setDescriptor("Send data synchronously from CGC to S56X");
	addPort(input.setPort("input",this,ANYTYPE));


}

void CGCXSend::setup() {
# line 84 "CGCXSend.pl"
resolvedType = input.setResolvedType();
    if (resolvedType == FIX) {
	Precision cg56Fix(24,1);
	input.setPrecision(cg56Fix);
    }
    numXfer = input.numXfer();
    CGCXSynchComm::setup();
}

void CGCXSend::go() {
# line 94 "CGCXSend.pl"
addCode(poll());
    StringList command;
    StringList realOrImag;
    realOrImag = " ";
    if (input.resolvedType() == INT)
	command << intSend(input.numXfer());
    else if (input.resolvedType() == FIX)
	command << fixSend(input.numXfer());
    else if (input.resolvedType() == FLOAT)
	command << floatSend(input.numXfer(),"");
    else if (input.resolvedType() == COMPLEX) {
	command << floatSend(input.numXfer(),".real");
	realOrImag = "_REAL";
	addCode(sendData(command,input.numXfer(),realOrImag));
	command = floatSend(input.numXfer(),".imag");
	realOrImag = "_IMAG";
    }
    else {
	Error::abortRun(*this,input.resolvedType()," not supported");
	return;
    }
    addCode(sendData(command,input.numXfer(),realOrImag));
    addCode(updateSemaphore());
}

// prototype instance for known block list
static CGCXSend proto;
static RegisterBlock registerBlock(proto,"XSend");
