static const char file_id[] = "CGCXSynchComm.pl";
// .cc file generated from CGCXSynchComm.pl by ptlang
/*
Copyright (c) 1993-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCXSynchComm.h"
#include <stdio.h>
#include "compat.h"

const char *star_nm_CGCXSynchComm = "CGCXSynchComm";

const char* CGCXSynchComm :: className() const {return star_nm_CGCXSynchComm;}

ISA_FUNC(CGCXSynchComm,CGCXBase);

Block* CGCXSynchComm :: makeNew() const { LOG_NEW; return new CGCXSynchComm;}

CodeBlock CGCXSynchComm :: s56xInterrupt (
# line 32 "CGCXSynchComm.pl"
"\n"
"#ifdef __cplusplus\n"
"    static void $val(S56XFilePrefix)_s56xSignal(int) \n"
"#else\n"
"    static void $val(S56XFilePrefix)_s56xSignal(sig) \n"
"        int sig;\n"
"#endif\n"
"    {\n"
"	/* The memory location y:@currentBuffer contains the pairNumber \n"
"	   of send/receive buffer that just changed state, we store\n"
"	   that it is ready to process in the global array\n"
"	   $val(S56XFilePrefix)_s56xSemaphores\n"
"	   */\n"
"	int buffer;\n"
"	if (!$val(S56XFilePrefix)_dsp) return;\n"
"	if ((buffer = qckGetY($val(S56XFilePrefix)_dsp,\n"
"			      $val(S56XFilePrefix)_currentBuffer)-1) < 0) {\n"
"	    char buffer[128];\n"
"	    sprintf(buffer,\"S56X Buffer Status Update Failed: %s\",\n"
"		    qckErrString);\n"
"	    EXIT_CGC(buffer);\n"
"	}\n"
"	$val(S56XFilePrefix)_s56xSemaphores[buffer/24] =\n"
" 	    qckGetY($val(S56XFilePrefix)_dsp,\n"
"                    $val(S56XFilePrefix)_semaphorePtr+buffer/24);\n"
"	$val(S56XFilePrefix)_hostSemaphores[buffer] =\n"
"            !$val(S56XFilePrefix)_hostSemaphores[buffer];\n"
"	if (qckPutY($val(S56XFilePrefix)_dsp,\n"
"                    $val(S56XFilePrefix)_currentBuffer,0) == -1) { \n"
"	    char buffer[128];\n"
"	    sprintf(buffer, \"S56X Interrupt Reset Failed: %s\", \n"
"		    qckErrString);\n"
"	    EXIT_CGC(buffer);\n"
"	}\n"
"    } /* end $val(S56XFilePrefix)_s56xSignal interrupt */\n");

const char* CGCXSynchComm :: s56xSemaphoresInit(int size) {
# line 70 "CGCXSynchComm.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"    {\n"
"	int i;\n"
"	for (i = 0 ; i < " << (size/24 + 1) << " ; i++)\n"
"	    /* all buffers empty */\n"
"	    $val(S56XFilePrefix)_s56xSemaphores[i] = 0;\n"
"	for (i = 0 ; i < " << (size) << " ; i++)\n"
"	    $val(S56XFilePrefix)_hostSemaphores[i] = 0;\n"
"    }\n";
	return (const char*)_str_;
}

const char* CGCXSynchComm :: loadDSPSymbols(const char* varName,const char* type) {
# line 81 "CGCXSynchComm.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	if (($starSymbol(s56xBuffer)" << (type) << " =\n"
"             qckItem($val(S56XFilePrefix)_dsp,\"" << (varName) << "" << (type) << "\")) == 0)\n"
"	    EXIT_CGC(\"CGCXSynchComm " << (varName) << "" << (type) << " address resolution failed\");\n";
	return (const char*)_str_;
}

CodeBlock CGCXSynchComm :: loadSemaphoreItem (
# line 87 "CGCXSynchComm.pl"
"	if (($val(S56XFilePrefix)_s56xSemaphore = qckItem($val(S56XFilePrefix)_dsp,\"PTOLEMY_S56X_SEM\")) \n"
"	    == 0)\n"
"	    EXIT_CGC(\"CGCXSynchComm semaphore address resolution failed\");\n"
"	$val(S56XFilePrefix)_semaphorePtr = \n"
"	    QckAddr($val(S56XFilePrefix)_s56xSemaphore);\n"
"	if (($val(S56XFilePrefix)_s56xCurrentBuffer =\n"
"             qckItem($val(S56XFilePrefix)_dsp,\"PTOLEMY_S56X_BUF\")) == 0)\n"
"	    EXIT_CGC(\"CGCXSynchComm current buffer address resolution failed\");\n"
"	$val(S56XFilePrefix)_currentBuffer = \n"
"	    QckAddr($val(S56XFilePrefix)_s56xCurrentBuffer);\n");

CodeBlock CGCXSynchComm :: sigsetUSR1 (
# line 100 "CGCXSynchComm.pl"
"    { \n"
"	struct sigaction pt_alarm_action;\n"
"	sigset(SIGUSR1,$val(S56XFilePrefix)_s56xSignal);\n"
"	sigaction(SIGUSR1, 0, &pt_alarm_action);\n"
"	pt_alarm_action.sa_flags |= SA_RESTART;\n"
"	sigaction(SIGUSR1, &pt_alarm_action, 0);\n"
"    }\n");

const char* CGCXSynchComm :: semaphoreDeclaration(int count) {
# line 110 "CGCXSynchComm.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	/* We have a pair of redundant semaphore arrays.  The first\n"
"	   version keeps the semaphore as bits in a word.  The second\n"
"	   version keeps each semaphore as a separate integer.  This is\n"
"	   done for polling efficiency on the workstation */\n"
"	int $val(S56XFilePrefix)_s56xSemaphores[" << (count/24 + 1) << "];\n"
"	volatile int $val(S56XFilePrefix)_hostSemaphores[" << (count) << "];\n";
	return (const char*)_str_;
}

CGCXSynchComm::CGCXSynchComm ()
{
	setDescriptor("Base star for Synchronous CGC <-> S56X IPC");


}

void CGCXSynchComm::initCode() {
# line 120 "CGCXSynchComm.pl"
addMainInit(s56xSemaphoresInit(*commCount),"s56xSemaphoresInit");
	CGCXBase::initCode();
	addMainInit(sigsetUSR1,"s56x_sigset");
	addMainInit("	$val(S56XFilePrefix)_dsp->intr=sbusMemHostIntr;","s56x_dspintr");
        addMainInit(loadSemaphoreItem,"s56x_sem_item");

        if (resolvedType == COMPLEX) {
	    addDeclaration("QckItem $starSymbol(s56xBuffer)_REAL;\n");
	    addDeclaration("QckItem $starSymbol(s56xBuffer)_IMAG;\n");
            addMainInit(loadDSPSymbols(s56xSide->bufferName(),"_REAL"));
            addMainInit(loadDSPSymbols(s56xSide->bufferName(),"_IMAG"));
        }
        else {
	    addDeclaration("QckItem $starSymbol(s56xBuffer);\n");
            addMainInit(loadDSPSymbols(s56xSide->bufferName(),""));
        }

        addDeclaration("QckItem $val(S56XFilePrefix)_s56xSemaphore;\n"
		       "QckItem $val(S56XFilePrefix)_s56xCurrentBuffer;\n");
	addGlobal("unsigned int $val(S56XFilePrefix)_semaphorePtr;\n"
		  "unsigned int $val(S56XFilePrefix)_currentBuffer;\n",
		  "s56xSemaphorePtr");
	addGlobal(semaphoreDeclaration(*commCount),"s56xSemaphores");
        addGlobal("#define S56X_MAX_POLL 10000000","S56X_MAX_POLL");
	addGlobal(s56xInterrupt,"s56xInterrupt");
}

// prototype instance for known block list
static CGCXSynchComm proto;
static RegisterBlock registerBlock(proto,"XSynchComm");
