.EQ
delim off
.EN
.\" documentation file generated from CGCChop.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Chop"
.SD
On each execution, this star reads a block of "nread" samples (default 128)
and writes "nwrite" of these samples (default 64), skipping the first
"offset" samples (default 0).  It is an error if nwrite + offset > nread.
If nwrite > nread, then the output consists of overlapping windows,
and hence "offset" must be negative.
.SE
.LO "CGC main library"
.DM CGC CGCStar
.SV 1.3 "2/27/96"
.AL "S. Ha"
.IH
.NE
\fIinput\fR (ANYTYPE)
.PE
.OH
.NE
\fIoutput\fR (ANYTYPE)
.PE
.SH
.NE
\fInread\fR (IntState): Number of particles read.
.DF "128"
.NE
\fInwrite\fR (IntState): Number of particles written.
.DF "64"
.NE
\fIoffset\fR (IntState): Position of output block relative to input block.
.DF "0"
.NE
\fIuse_past_inputs\fR (IntState): If offset > 0, specify whether to use previously read inputs
(otherwise use zeros).
.DF "YES"
.NE
\fIhiLim\fR (IntState): Lower limit on the indexing from the input to the output buffer
.DF "0"
.NE
\fIinidx\fR (IntState): Current index into the output buffer
.DF "0"
.NE
\fIloLim\fR (IntState): Lower limit on the indexing from the input to the output buffer
.DF "0"
.ET
.EQ
delim $$
.EN
.LD
This star reads a block of particles of any type, and writes a block
of particles that somehow overlaps the input block.
The number of input particles consumed is given by \fInread\fR,
and the number of output particles produced is given by \fInwrite\fR.
The \fIoffset\fR parameter (default 0) specifies where the output
block should start, relative to the beginning of the input block.
To avoid trying to read samples that have not yet been consumed,
it is required that $nwrite ~+~ offset ~<=~ nread$.
Hence, if $nwrite ~>~ nread$, \fIoffset\fR must be negative,
and the output consists of overlapping blocks input particles.
.ES
