.EQ
delim off
.EN
.\" documentation file generated from CGCGoertzel.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Goertzel"
.SD
Second-order recursive computation of the kth coefficient of an
N-point DFT using Goertzel's algorithm.
.SE
.LO "CGC main library"
.DM CGC CGCGoertzelBase
.SV 1.1 "1/29/96"
.AL "Brian L. Evans"
.OH
.NE
\fIoutput\fR (complex)
.PE
.SH
.NE
\fInegWnReal\fR (FloatState): internal state for the storage of the negative of the real part of the
twiddle factor, which is a function of k and N
.DF "0.0"
.NE
\fInegWnImag\fR (FloatState): internal state for the storage of the imaginary part of the twiddle factor,
which is a function of k and N
.DF "0.0"
.ET
.EQ
delim $$
.EN
.LD
.lp
This two-pole, one-zero IIR filter has a transfer function of
.EQ
{1 ~-~ {W sub N} sup k z sup -1} over
{1 ~-~ 2 cos ( {2 pi} over {N} k ) z sup -1 ~+~ sup -2} ~.
.EN
.ID "Goertzel's algorithm"
This filter is a biquad filter with
.sp 0.5
.(l
n0 = 1
n1 = -Wn = exp(j 2 pi k / N)
n2 = 0
d1 = -2 cos(2 pi k / N)
d2 = 1
.)l
.sp 0.5
The Goertzel's implementation takes the simpler forms of n0, n2, and d2
into account, and computes n1 and d1 from the parameters k and N.
It is implemented in direct form II.
.ID "Oppenheim, A. V."
.ID "Schafer, R. W."
.UH REFERENCES
.ip [1]
A. V. Oppenheim and R. W. Schafer, \fIDiscrete-Time Signal Processing\fR,
Prentice-Hall: Englewood Cliffs, NJ, 1989.
.ES
