.EQ
delim off
.EN
.\" documentation file generated from CGCPcwzLinear.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "PcwzLinear"
.SD
This star implements a piecewise linear mapping from the
input to the output.  The mapping is given by a sequence
of (x,y) pairs, which specify the breakpoints in the function.
The sequence of x values must be increasing. The function
implemented by the star can be represented by drawing straight
lines between the (x,y) pairs, in sequence.  The default
mapping is the "tent" map, in which inputs between -1.0
and 0.0 are linearly mapped into the range -1.0 to 1.0.
Inputs between 0.0 and 1.0 are mapped into the same range,
but with the opposite slope, 1.0 to -1.0. If the input is
outside the range specified in the "x" values of the breakpoints,
then the appropriate extreme value will be used for the output.
Thus, for the default map, if the input is -2.0, the output
will be -1.0.  If the input is +2.0, the output will again be -1.0.
.SE
.LO "CGC main library"
.DM CGC CGCStar
.SV 1.3 "1/29/96"
.AL "E. A. Lee"
.IH
.NE
\fIinput\fR (float)
.PE
.OH
.NE
\fIoutput\fR (float)
.PE
.SH
.NE
\fIbreakpoints\fR (ComplexArrayState): "Endpoints and breakpoints in the mapping"
.DF "(-1.0, -1.0) (0.0, 1.0) (1.0, -1.0)"
.ET
.EQ
delim $$
.EN
.LD
.Id "table lookup"
.Id "piecewise linear map"
.Id "tent map"
.Id "linear map"
.ES
