static const char file_id[] = "CGCAddFix.pl";
// .cc file generated from CGCAddFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCAddFix.h"

const char *star_nm_CGCAddFix = "CGCAddFix";

const char* CGCAddFix :: className() const {return star_nm_CGCAddFix;}

ISA_FUNC(CGCAddFix,CGCFix);

Block* CGCAddFix :: makeNew() const { LOG_NEW; return new CGCAddFix;}

CGCAddFix::CGCAddFix ()
{
	setDescriptor("Output the sum of the fixed-point inputs as a fixed-point value.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag that indicates whether or not to keep the precision of the arriving\nparticles as is:  YES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the input in bits.\nThe input particles are only cast to this precision if the\nparameter \"ArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits and precision of the accumulation.\nWhen the value of the accumulation extends outside of the precision,\nthe output is set to its maximum value (or minimum for negative\nmagnitudes)."));
	addState(index.setState("index",this,"1","index for multiple input trace",
# line 60 "CGCAddFix.pl"
A_NONSETTABLE|A_NONCONSTANT));

# line 64 "CGCAddFix.pl"
noInternalState();
}

void CGCAddFix::setup() {
# line 68 "CGCAddFix.pl"
CGCFix::setup();

                if (!int(ArrivingPrecision))
		    input.setPrecision(InputPrecision);

		output.setPrecision(OutputPrecision);
}

void CGCAddFix::go() {
# line 77 "CGCAddFix.pl"
// insert code to clear overflow flag
		CGCFix::clearOverflow();

		// avoid FIX_Assign if possible
		if (input.numberPorts() == 2)
	{ StringList _str_; _str_ << 
"	FIX_Add($ref(output), $ref(input#1),$ref(input#2));\n"
;
	 addCode(_str_); }

		else {
			// initialize sum
	{ StringList _str_; _str_ << 
"	FIX_Assign($ref(output),$ref(input#1));\n"
;
	 addCode(_str_); }

			for (int i=2; i <= input.numberPorts(); i++) {
			    index = i;
	{ StringList _str_; _str_ << 
"	FIX_Add($ref(output), $ref(output),$ref(input#index));\n"
;
	 addCode(_str_); }
			}
		}

		// insert code to test overflow flag
		CGCFix::checkOverflow();
}

// prototype instance for known block list
static CGCAddFix proto;
static RegisterBlock registerBlock(proto,"AddFix");
