static const char file_id[] = "CGCBitsToInt.pl";
// .cc file generated from CGCBitsToInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
	All rights reserved.
	See the file $PTOLEMY/copyright for copyright notice,
	limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCBitsToInt.h"

const char *star_nm_CGCBitsToInt = "CGCBitsToInt";

const char* CGCBitsToInt :: className() const {return star_nm_CGCBitsToInt;}

ISA_FUNC(CGCBitsToInt,CGCStar);

Block* CGCBitsToInt :: makeNew() const { LOG_NEW; return new CGCBitsToInt;}

CodeBlock CGCBitsToInt :: readNwrite (
# line 55 "CGCBitsToInt.pl"
"	int i;\n"
"	int word = 0;\n"
"	for(i=$val(nBits)-1;i>=0;i--) {\n"
"	    /* shift new bits into the shift register */\n"
"	    word <<= 1;\n"
"	    if ($ref(input,i)) word += 1;\n"
"	}\n"
"	$ref(output) = word;\n");

CGCBitsToInt::CGCBitsToInt ()
{
	setDescriptor("The integer input sequence is interpreted as a bit stream in which any nonzero\nvalue is interpreted as to mean a 'one' bit.\nThis star consumes \"nBits\" successive bits from the input,\npacks them into an integer, and outputs the resulting integer.\nThe first received bit becomes the most significant bit of the output.\nIf \"nBits\" is smaller than the wordsize minus one, then the\noutput integer will always be non-negative.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(nBits.setState("nBits",this,"4","number of bits read per execution"));

# line 39 "CGCBitsToInt.pl"
noInternalState();
}

int CGCBitsToInt::myExecTime() {
# line 69 "CGCBitsToInt.pl"
return int(nBits)*2;
}

void CGCBitsToInt::setup() {
# line 42 "CGCBitsToInt.pl"
/* Need (int) cast on sizeof to eliminate gcc warning */
	if (int(nBits) > (int)sizeof(int)*8) {
	    StringList message = "nBits needs to be less than";
	    message << (unsigned int)(sizeof(int)*8);
	    Error::abortRun(*this,message);
	    return;
	}
	if (int(nBits) < 0) {
	    Error::abortRun(*this, "nBits must be positive");
	    return;
	}
	input.setSDFParams(int(nBits),int(nBits)-1);
}

void CGCBitsToInt::go() {
# line 66 "CGCBitsToInt.pl"
addCode(readNwrite);
}

// prototype instance for known block list
static CGCBitsToInt proto;
static RegisterBlock registerBlock(proto,"BitsToInt");
