static const char file_id[] = "CGCBusFork.pl";
// .cc file generated from CGCBusFork.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCBusFork.h"

const char *star_nm_CGCBusFork = "CGCBusFork";

const char* CGCBusFork :: className() const {return star_nm_CGCBusFork;}

ISA_FUNC(CGCBusFork,CGCStar);

Block* CGCBusFork :: makeNew() const { LOG_NEW; return new CGCBusFork;}

CGCBusFork::CGCBusFork ()
{
	setDescriptor("Copy particles from an input bus to each output bus.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(outputA.setPort("outputA",this,ANYTYPE));
	outputA.inheritTypeFrom(input);
	addPort(outputB.setPort("outputB",this,ANYTYPE));
	outputB.inheritTypeFrom(input);
	addState(ix.setState("ix",this,"1","index for multiple input trace",
# line 36 "CGCBusFork.pl"
A_NONSETTABLE|A_NONCONSTANT));

# line 48 "CGCBusFork.pl"
noInternalState();
}

int CGCBusFork::myExecTime() {
# line 51 "CGCBusFork.pl"
// Alert: rough estimate
	  return input.numberPorts();
}

void CGCBusFork::begin() {
# line 41 "CGCBusFork.pl"
if (input.numberPorts() != outputA.numberPorts() ||
	      input.numberPorts() != outputB.numberPorts()) {
	    Error::abortRun(*this, "Bus widths don't match");
	    return;
	  }
}

void CGCBusFork::go() {
# line 55 "CGCBusFork.pl"
MPHIter nextin(input), nextoutA(outputA), nextoutB(outputB);
	  PortHole *in, *outA, *outB;
	  ix = 0;
	  while (((in = nextin++) != 0) &&
		 ((outA = nextoutA++) != 0) &&
		 ((outB = nextoutB++) != 0)) {
	    ix = ix+1;
	    addCode("\t$ref(outputA#ix) = $ref(outputB#ix) = $ref(input#ix);");
	  }
}

// prototype instance for known block list
static CGCBusFork proto;
static RegisterBlock registerBlock(proto,"BusFork");
