static const char file_id[] = "CGCChop.pl";
// .cc file generated from CGCChop.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCChop.h"

const char *star_nm_CGCChop = "CGCChop";

const char* CGCChop :: className() const {return star_nm_CGCChop;}

ISA_FUNC(CGCChop,CGCStar);

Block* CGCChop :: makeNew() const { LOG_NEW; return new CGCChop;}

CodeBlock CGCChop :: decl (
# line 136 "CGCChop.pl"
"	int i;\n");

CodeBlock CGCChop :: out (
# line 139 "CGCChop.pl"
"	for (i = 0; i < $val(nwrite); i++) {\n"
"	    if (i > hiLim || i < loLim) {\n"
"		$ref(output,i) = 0;\n"
"	    }\n"
"	    else {\n"
"		$ref(output,i) = $ref(input,inputIndex);\n"
"		inputIndex++;\n"
"            }\n"
"        }\n");

CGCChop::CGCChop ()
{
	setDescriptor("On each execution, this star reads a block of \"nread\" samples (default 128)\nand writes \"nwrite\" of these samples (default 64), skipping the first\n\"offset\" samples (default 0).  It is an error if nwrite + offset > nread.\nIf nwrite > nread, then the output consists of overlapping windows,\nand hence \"offset\" must be negative.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(nread.setState("nread",this,"128","Number of particles read."));
	addState(nwrite.setState("nwrite",this,"64","Number of particles written."));
	addState(offset.setState("offset",this,"0","Position of output block relative to input block."));
	addState(use_past_inputs.setState("use_past_inputs",this,"YES","If offset > 0, specify whether to use previously read inputs\n(otherwise use zeros)."));
	addState(hiLim.setState("hiLim",this,"0","Lower limit on the indexing from the input to the output buffer",
# line 74 "CGCChop.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(inidx.setState("inidx",this,"0","Current index into the output buffer",
# line 81 "CGCChop.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(loLim.setState("loLim",this,"0","Lower limit on the indexing from the input to the output buffer",
# line 90 "CGCChop.pl"
A_NONSETTABLE|A_NONCONSTANT));

# line 93 "CGCChop.pl"
noInternalState();
}

int CGCChop::myExecTime() {
# line 161 "CGCChop.pl"
computeRange();
		return int(nwrite) + 2 * (int(hiLim) - int(loLim));
}

void CGCChop::setup() {
# line 117 "CGCChop.pl"
if (int(nread) <= 0) {
                    Error::abortRun(*this, "The number of samples to read ",
                                    "must be positive");
                    return;
                }
                if (int(nwrite) <= 0) {
                    Error::abortRun(*this, "The number of samples to write ",
                                    "must be positive");
                    return;
                }

                if (int(use_past_inputs))
		    input.setSDFParams(int(nread),int(nread)+int(offset)-1);
		else
		    input.setSDFParams(int(nread),int(nread)-1);

		output.setSDFParams(int(nwrite),int(nwrite)-1);
		computeRange();
}

void CGCChop::go() {
# line 151 "CGCChop.pl"
StringList moreDeclarations = "\tint ";
		moreDeclarations << "hiLim = " << int(hiLim) << ", "
				 << "inputIndex = " << int(inidx) << ", "
				 << "loLim = " << int(loLim) << ";\n";

		addCode(decl);
		addCode(moreDeclarations);
		addCode(out);
}


void CGCChop::computeRange ()
{
# line 101 "CGCChop.pl"
// Compute the range of output indexes that come from inputs
                // This method is called in the setup() method for the Chop
                // star, and in the go method for ChopVarOffset because
                // it resets the offset parameter
                hiLim = int(nwrite) - int(offset) - 1;
                if (int(hiLim) >= int(nwrite)) hiLim = int(nwrite) - 1;
                else if (int(use_past_inputs)) hiLim = int(nwrite) - 1;

                loLim = int(nwrite) - int(nread) - int(offset);
                if (int(loLim) < 0) loLim = 0;

                inidx = int(nread) - int(nwrite) + int(offset);
                if (int(inidx) < 0) inidx = 0;
}


// prototype instance for known block list
static CGCChop proto;
static RegisterBlock registerBlock(proto,"Chop");
