static const char file_id[] = "CGCCopy.pl";
// .cc file generated from CGCCopy.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCCopy.h"

const char *star_nm_CGCCopy = "CGCCopy";

const char* CGCCopy :: className() const {return star_nm_CGCCopy;}

ISA_FUNC(CGCCopy,CGCStar);

Block* CGCCopy :: makeNew() const { LOG_NEW; return new CGCCopy;}

CodeBlock CGCCopy :: floatBody (
# line 40 "CGCCopy.pl"
"	int i;\n"
"	for (i = 0; i < $val(numSample); i++) {\n"
"		$ref(output, i) = $ref(input, i);\n"
"	}\n");

CodeBlock CGCCopy :: complexBody (
# line 46 "CGCCopy.pl"
"	int i = 0;\n"
"	for ( ; i < $val(numSample); i++) {\n"
"		$ref(output, i).real = $ref(input, i).real;\n"
"		$ref(output, i).imag = $ref(input, i).imag;\n"
"	}\n");

CGCCopy::CGCCopy ()
{
	setDescriptor("copy input to output");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(numSample.setState("numSample",this,"1","number of samples to be copied"));

# line 29 "CGCCopy.pl"
noInternalState();
}

int CGCCopy::myExecTime() {
# line 60 "CGCCopy.pl"
if (strcmp(input.resolvedType(), "COMPLEX") == 0) 
			return 2 * int(numSample);
		else
			return int(numSample);
}

void CGCCopy::initCode() {
# line 38 "CGCCopy.pl"
numSample = output.numXfer();
}

void CGCCopy::setup() {
# line 32 "CGCCopy.pl"
if (int(numSample) > 1) {
			input.setSDFParams(int(numSample));
			output.setSDFParams(int(numSample));
		}
}

void CGCCopy::go() {
# line 54 "CGCCopy.pl"
if (strcmp(input.resolvedType(), "COMPLEX") == 0) 
			addCode(complexBody);
		else
			addCode(floatBody);
}

// prototype instance for known block list
static CGCCopy proto;
static RegisterBlock registerBlock(proto,"Copy");
