static const char file_id[] = "CGCCxToFix.pl";
// .cc file generated from CGCCxToFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCCxToFix.h"

const char *star_nm_CGCCxToFix = "CGCCxToFix";

const char* CGCCxToFix :: className() const {return star_nm_CGCCxToFix;}

ISA_FUNC(CGCCxToFix,CGCFix);

Block* CGCCxToFix :: makeNew() const { LOG_NEW; return new CGCCxToFix;}

CGCCxToFix::CGCCxToFix ()
{
	setDescriptor("Convert a complex input to a fixed-point output.");
	addPort(input.setPort("input",this,COMPLEX));
	addPort(output.setPort("output",this,FIX));
	addState(numSample.setState("numSample",this,"1","number of samples to be copied"));
	addState(OutputPrecision.setState("OutputPrecision",this,"","Precision of the output in bits or empty if unspecified.\nThe absolute value of the complex number is computed and then converted to\nthis precision.\nIf the converted value cannot be represented by the number of bits specified\nin the precision parameter, then the output is set to its maximum value (or\nminimum for negative magnitudes)."));


}

void CGCCxToFix::initCode() {
# line 71 "CGCCxToFix.pl"
numSample = output.numXfer();
		addInclude("<math.h>");
}

void CGCCxToFix::begin() {
# line 62 "CGCCxToFix.pl"
// if the precision for the output port is not defined
		// - neither by this nor the successor star -, the actual
		// precision is determined at runtime

		if (!output.precision().isValid())
			output.setAttributes(A_VARPREC);
}

void CGCCxToFix::setup() {
# line 52 "CGCCxToFix.pl"
CGCFix::setup();

		if (int(numSample) > 1) {
			input.setSDFParams(int(numSample));
			output.setSDFParams(int(numSample));
		}
		output.setPrecision(OutputPrecision);
}

void CGCCxToFix::go() {
# line 76 "CGCCxToFix.pl"
// insert code to clear overflow flag
		CGCFix::clearOverflow();

	{ StringList _str_; _str_ << 
"     {	int i = 0;\n"
"	double p, q;\n"
"	for (; i < $val(numSample); i++) {\n"
"		p = $ref(input, i).real;\n"
"		q = $ref(input, i).imag;\n"
"		p = sqrt(p*p+q*q);\n"
;
	 addCode(_str_); }

	    if (output.attributes() & AB_VARPREC)
	{ StringList _str_; _str_ << 
"		FIX_SetPrecisionFromDouble($precision(output),p);\n"
;
	 addCode(_str_); }

	{ StringList _str_; _str_ << 
"		FIX_DoubleAssign($ref(output,i),p);\n"
"     } }\n"
;
	 addCode(_str_); }

		// insert code to test overflow flag
		CGCFix::checkOverflow();
}

// prototype instance for known block list
static CGCCxToFix proto;
static RegisterBlock registerBlock(proto,"CxToFix");
