static const char file_id[] = "CGCCxToFloat.pl";
// .cc file generated from CGCCxToFloat.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCCxToFloat.h"

const char *star_nm_CGCCxToFloat = "CGCCxToFloat";

const char* CGCCxToFloat :: className() const {return star_nm_CGCCxToFloat;}

ISA_FUNC(CGCCxToFloat,CGCStar);

Block* CGCCxToFloat :: makeNew() const { LOG_NEW; return new CGCCxToFloat;}

CodeBlock CGCCxToFloat :: body (
# line 41 "CGCCxToFloat.pl"
"	int i = 0;\n"
"	double p, q;\n"
"	for ( ; i < $val(numSample); i++) {\n"
"		p = $ref(input, i).real;\n"
"		q = $ref(input, i).imag;\n"
"		$ref(output, i) = sqrt(p*p + q*q);\n"
"	}\n");

CGCCxToFloat::CGCCxToFloat ()
{
	setDescriptor("type conversion from complex to float/int");
	addPort(input.setPort("input",this,COMPLEX));
	addPort(output.setPort("output",this,FLOAT));
	addState(numSample.setState("numSample",this,"1","number of samples to be copied"));

# line 29 "CGCCxToFloat.pl"
noInternalState();
}

int CGCCxToFloat::myExecTime() {
# line 54 "CGCCxToFloat.pl"
return int(numSample) * 200;
}

void CGCCxToFloat::initCode() {
# line 38 "CGCCxToFloat.pl"
numSample = output.numXfer();
		addInclude("<math.h>");
}

void CGCCxToFloat::setup() {
# line 32 "CGCCxToFloat.pl"
if (int(numSample) > 1) {
			input.setSDFParams(int(numSample));
			output.setSDFParams(int(numSample));
		}
}

void CGCCxToFloat::go() {
# line 51 "CGCCxToFloat.pl"
addCode(body);
}

// prototype instance for known block list
static CGCCxToFloat proto;
static RegisterBlock registerBlock(proto,"CxToFloat");
