static const char file_id[] = "CGCDTMFPostTest.pl";
// .cc file generated from CGCDTMFPostTest.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCDTMFPostTest.h"

const char *star_nm_CGCDTMFPostTest = "CGCDTMFPostTest";

const char* CGCDTMFPostTest :: className() const {return star_nm_CGCDTMFPostTest;}

ISA_FUNC(CGCDTMFPostTest,CGCStar);

Block* CGCDTMFPostTest :: makeNew() const { LOG_NEW; return new CGCDTMFPostTest;}

CodeBlock CGCDTMFPostTest :: decl (
# line 78 "CGCDTMFPostTest.pl"
"		int retval = 0;\n"
"		int inputValue = $val(initialLastInput);\n"
"		int lastValue = $ref(last);\n"
"\n");

CodeBlock CGCDTMFPostTest :: test (
# line 84 "CGCDTMFPostTest.pl"
"		/* if the current input is valid, then compare it with the\n"
"		   last and second-to-last valid inputs; else, return FALSE */\n"
"		if ( $ref(valid) ) {\n"
"		  inputValue = $ref(input);\n"
"		  retval = ( inputValue == lastValue &&\n"
"		             lastValue != $ref(secondToLast) );\n"
"		}\n"
"\n"
"		/* Update the last and second-to-last input storage */\n"
"		$ref(secondToLast) = lastValue;\n"
"		$ref(last) = inputValue;\n");

CodeBlock CGCDTMFPostTest :: sendOutput (
# line 97 "CGCDTMFPostTest.pl"
"\n"
"		$ref(output) = retval;\n");

CGCDTMFPostTest::CGCDTMFPostTest ()
{
	setDescriptor("Returns whether or not a valid dual-tone modulated-frequency has\nbeen correctly detected based on the last three detection results.");
	addPort(input.setPort("input",this,INT));
	addPort(valid.setPort("valid",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(initialLastInput.setState("initialLastInput",this,"-1","The value to assign to last and secondToLast internal states, which hold the\nprevious two valid inputs.  For the purposes of DTMF detection, it is\nset to an integer that does not represent a DTMF digit."));
	addState(last.setState("last",this,"-1","internal state to store the last valid integer",
# line 63 "CGCDTMFPostTest.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(secondToLast.setState("secondToLast",this,"-1","internal state to store the second-to-last valid integer",
# line 72 "CGCDTMFPostTest.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void CGCDTMFPostTest::setup() {
# line 75 "CGCDTMFPostTest.pl"
last = int(initialLastInput);
		secondToLast = int(initialLastInput);
}

void CGCDTMFPostTest::go() {
# line 102 "CGCDTMFPostTest.pl"
addCode(decl);
		addCode(test);
		addCode(sendOutput);
}

// prototype instance for known block list
static CGCDTMFPostTest proto;
static RegisterBlock registerBlock(proto,"DTMFPostTest");
