static const char file_id[] = "CGCDeMux.pl";
// .cc file generated from CGCDeMux.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCDeMux.h"

const char *star_nm_CGCDeMux = "CGCDeMux";

const char* CGCDeMux :: className() const {return star_nm_CGCDeMux;}

ISA_FUNC(CGCDeMux,CGCStar);

Block* CGCDeMux :: makeNew() const { LOG_NEW; return new CGCDeMux;}

CGCDeMux::CGCDeMux ()
{
	setDescriptor("Demultiplexes one input onto any number of output streams.\nThe star consumes B particles from the input, where B is the blockSize.\nThese B particles are copied to exactly one output,\ndetermined by the \"control\" input.  The other outputs get a zero of the\nappropriate type.\n\nIntegers from 0 through N-1 are accepted at the \"control\"\ninput, where N is the number of outputs.  If the control input is\noutside this range, all outputs get zero.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));

# line 46 "CGCDeMux.pl"
noInternalState();
}

int CGCDeMux::myExecTime() {
# line 67 "CGCDeMux.pl"
return (output.numberPorts()+1) * int(blockSize) + 1;
}

void CGCDeMux::setup() {
# line 49 "CGCDeMux.pl"
input.setSDFParams(int(blockSize),int(blockSize)-1);
		output.setSDFParams(int(blockSize),int(blockSize)-1);
}

void CGCDeMux::go() {
# line 53 "CGCDeMux.pl"
StringList out;
	    out << "\tint n,j;\n\tn = $ref(control);\n";
	    out << "\tfor(j = $val(blockSize)-1; j >= 0; j--) {\n";

	    for (int i = 0; i < output.numberPorts(); i++) {
		out << "\t\tif (n == " << i << ")\n";
		out << "\t\t\t$ref(output#" << i+1 << ",j) = $ref(input,j);\n";
		out << "\t\t else\n";
		out << "\t\t\t$ref(output#" << i+1 << ",j) = 0;\n";
	    }
	    out << "\t}\n";
	    addCode(out);
}

// prototype instance for known block list
static CGCDeMux proto;
static RegisterBlock registerBlock(proto,"DeMux");
