static const char file_id[] = "CGCDeScrambler.pl";
// .cc file generated from CGCDeScrambler.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCDeScrambler.h"

const char *star_nm_CGCDeScrambler = "CGCDeScrambler";

const char* CGCDeScrambler :: className() const {return star_nm_CGCDeScrambler;}

ISA_FUNC(CGCDeScrambler,CGCStar);

Block* CGCDeScrambler :: makeNew() const { LOG_NEW; return new CGCDeScrambler;}

CodeBlock CGCDeScrambler :: descramble (
# line 63 "CGCDeScrambler.pl"
"	  int reg, masked, parity;\n"
"	  reg = $ref(shiftReg) << 1;\n"
"	  /* put the input in the low order bit */\n"
"	  reg += ($ref(input) != 0);\n"
"	  masked = $val(polynomial) & reg;\n"
"	  /* Now we need to find the parity of \"masked\". */\n"
"	  parity = 0;\n"
"	  /* Calculate the parity of the masked word */\n"
"	  while (masked > 0) {\n"
"	    parity = parity ^ (masked & 1);\n"
"	    masked = masked >> 1;\n"
"	  }\n"
"	  $ref(output) = parity;\n"
"	  $ref(shiftReg) = reg;\n");

CGCDeScrambler::CGCDeScrambler ()
{
	setDescriptor("Descramble the input bit sequence using a feedback shift register.\nThe taps of the feedback shift register are given by the \"polynomial\"\nparameter.  This is a self-synchronizing descrambler that will exactly\nreverse the operation of the Scrambler star if the polynomials are the same.\nThe low order bit of the polynomial should always be set. For more information,\nsee the documentation for the SDF Scrambler star and Lee and Messerschmitt,\nDigital Communication, Second Edition, Kluwer Academic Publishers, 1994,\npp 595-603.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(polynomial.setState("polynomial",this,"0440001","generator polynomial for the maximal length shift register"));
	addState(shiftReg.setState("shiftReg",this,"0","the shift register"));


}

void CGCDeScrambler::setup() {
# line 53 "CGCDeScrambler.pl"
// Should check that generator polynomial does not exceed 31 bits. How?
	  // To avoid sign extension problems, the hob must be zero
	  if (int(polynomial) < 0) {
	    Error::abortRun(*this,"Sorry, polynomials of order higher than 31 are not supported");
	    return;
	  }
	  if (!(int(polynomial) & 1)) {
	    Error::warn(*this,"The low-order bit of the polynomial is not set. Input will have no effect");
	  }
}

void CGCDeScrambler::go() {
# line 80 "CGCDeScrambler.pl"
addCode(descramble);
}

// prototype instance for known block list
static CGCDeScrambler proto;
static RegisterBlock registerBlock(proto,"DeScrambler");
