static const char file_id[] = "CGCExpr.pl";
// .cc file generated from CGCExpr.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCExpr.h"

const char *star_nm_CGCExpr = "CGCExpr";

const char* CGCExpr :: className() const {return star_nm_CGCExpr;}

ISA_FUNC(CGCExpr,CGCStar);

Block* CGCExpr :: makeNew() const { LOG_NEW; return new CGCExpr;}

CGCExpr::CGCExpr ()
{
	setDescriptor("General expression evaluation.");
	addPort(in.setPort("in",this,FLOAT));
	addPort(out.setPort("out",this,FLOAT));
	addState(expr.setState("expr",this,"$ref(in#1)","Expression to evaulate."));
	addState(inDataType.setState("inDataType",this,"float","\"DataType of `in` porthole, one of [float,int,anytype,complex]\""));
	addState(outDataType.setState("outDataType",this,"float","\"DataType of `out` porthole, one of [float,int,complex,=in]\""));
	addState(include.setState("include",this,"<math.h>","List of necessary include files."));
	addState(runTime.setState("runTime",this,"2","execution time"));


}

int CGCExpr::myExecTime() {
# line 130 "CGCExpr.pl"
return int(runTime);
}

void CGCExpr::initCode() {
# line 117 "CGCExpr.pl"
for(int i = 0; i < include.size(); i++)
	    addInclude(include[i]);
}

void CGCExpr::setup() {
# line 68 "CGCExpr.pl"
const char* letter = inDataType;
	switch (letter[0]) {
	case 'F':
	case 'f':
	    in.setPort("in",this,FLOAT);
	    break;
	case 'I':
	case 'i':
	    in.setPort("in",this,INT);
	    break;
	case 'A':
	case 'a':
	    in.setPort("in",this,ANYTYPE);
	    break;
	case 'C':
	case 'c':
	    in.setPort("in",this,COMPLEX);
	    break;
	default:
	    Error::abortRun(*this,"CGC Expr does not support the type",
			    inDataType);
	    break;
	}
	letter = outDataType;
	switch (letter[0]) {
	case 'F':
	case 'f':
	    out.setPort("out",this,FLOAT);
	    break;
	case 'I':
	case 'i':
	    out.setPort("out",this,INT);
	    break;
	case '=':
	    out.inheritTypeFrom(in);
	    break;
	case 'C':
	case 'c':
	    out.setPort("out",this,COMPLEX);
	    break;
	default:
	    Error::abortRun(*this,"CGC Expr does not support the type",
			    outDataType);
	    break;
	}
}

void CGCExpr::go() {
# line 123 "CGCExpr.pl"
StringList code;
	code << "$ref(out) = " << expr << ";\n";
	addCode(code);
}

// prototype instance for known block list
static CGCExpr proto;
static RegisterBlock registerBlock(proto,"Expr");
