static const char file_id[] = "CGCFix.pl";
// .cc file generated from CGCFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCFix.h"

const char *star_nm_CGCFix = "CGCFix";

const char* CGCFix :: className() const {return star_nm_CGCFix;}

ISA_FUNC(CGCFix,CGCStar);

Block* CGCFix :: makeNew() const { LOG_NEW; return new CGCFix;}

const char* CGCFix :: report_overflow(const char* starName) {
# line 41 "CGCFix.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	if ($ref(ov_cnt)) {\n"
"		double percentage = (100.0*$ref(ov_cnt)) / ($ref(ck_cnt) ? $ref(ck_cnt):1.0);\n"
"		fprintf(stderr, \"star " << (starName) << ": experienced overflow in %d out of %d fixed-point calculations checked (%.1lf%%)\\n\",\n"
"			$ref(ov_cnt), $ref(ck_cnt), percentage);\n"
"	}\n";
	return (const char*)_str_;
}

CGCFix::CGCFix ()
{
	setDescriptor("Based star for the fixed-point stars in the CGC domain.");
	addState(ReportOverflow.setState("ReportOverflow",this,"NO","If non-zero, e.g. YES or TRUE, then after a simulation has finished,\nthe star will report the number of overflow errors if any occurred\nduring the simulation."));
	addState(ov_cnt.setState("ov_cnt",this,"0","counter for overflow errors",
# line 31 "CGCFix.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(ck_cnt.setState("ck_cnt",this,"0","counter for overflow check operations",
# line 38 "CGCFix.pl"
A_NONSETTABLE|A_NONCONSTANT));


}

void CGCFix::wrapup() {
# line 86 "CGCFix.pl"
if (int(ReportOverflow)) {
			StringList s = this->fullName();
			addCode(report_overflow((const char*)s));
		}
}

void CGCFix::setup() {
# line 80 "CGCFix.pl"
// do nothing
}


void CGCFix::clearOverflow ()
{
# line 58 "CGCFix.pl"
if ((int)ReportOverflow) {
				addCode("\tfix_overflow = 0;\n");
			}
}


void CGCFix::checkOverflow ()
{
# line 68 "CGCFix.pl"
if ((int)ReportOverflow) {
				addCode("\tif ($ref(ck_cnt)++, fix_overflow)\n");
				addCode("\t\t$ref(ov_cnt)++;\n");
			}
}


// prototype instance for known block list
static CGCFix proto;
static RegisterBlock registerBlock(proto,"Fix");
