static const char file_id[] = "CGCFixToCx.pl";
// .cc file generated from CGCFixToCx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCFixToCx.h"

const char *star_nm_CGCFixToCx = "CGCFixToCx";

const char* CGCFixToCx :: className() const {return star_nm_CGCFixToCx;}

ISA_FUNC(CGCFixToCx,CGCStar);

Block* CGCFixToCx :: makeNew() const { LOG_NEW; return new CGCFixToCx;}

CodeBlock CGCFixToCx :: body (
# line 43 "CGCFixToCx.pl"
"	int i = 0;\n"
"	for (; i < $val(numSample); i++) {\n"
"		$ref(output,i).real = FIX_Fix2Double($ref(input,i));\n"
"		$ref(output,i).imag = 0;\n"
"	}\n");

CGCFixToCx::CGCFixToCx ()
{
	setDescriptor("Convert a fixed-point input to a complex output.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,COMPLEX));
	addState(numSample.setState("numSample",this,"1","number of samples to be copied"));


}

void CGCFixToCx::initCode() {
# line 39 "CGCFixToCx.pl"
numSample = output.numXfer();
		addInclude("<math.h>");
}

void CGCFixToCx::setup() {
# line 32 "CGCFixToCx.pl"
if (int(numSample) > 1) {
			input.setSDFParams(int(numSample));
			output.setSDFParams(int(numSample));
		}
}

void CGCFixToCx::go() {
# line 51 "CGCFixToCx.pl"
addCode(body);
}

// prototype instance for known block list
static CGCFixToCx proto;
static RegisterBlock registerBlock(proto,"FixToCx");
