static const char file_id[] = "CGCFloatToCx.pl";
// .cc file generated from CGCFloatToCx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCFloatToCx.h"

const char *star_nm_CGCFloatToCx = "CGCFloatToCx";

const char* CGCFloatToCx :: className() const {return star_nm_CGCFloatToCx;}

ISA_FUNC(CGCFloatToCx,CGCStar);

Block* CGCFloatToCx :: makeNew() const { LOG_NEW; return new CGCFloatToCx;}

CodeBlock CGCFloatToCx :: body (
# line 40 "CGCFloatToCx.pl"
"	int i = 0;\n"
"	for ( ; i < $val(numSample); i++) {\n"
"		$ref(output, i).real = $ref(input, i);\n"
"		$ref(output, i).imag = 0;\n"
"	}\n");

CGCFloatToCx::CGCFloatToCx ()
{
	setDescriptor("type conversion from float/int to complex");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,COMPLEX));
	addState(numSample.setState("numSample",this,"1","number of samples to be converted"));

# line 29 "CGCFloatToCx.pl"
noInternalState();
}

int CGCFloatToCx::myExecTime() {
# line 51 "CGCFloatToCx.pl"
return 2 * int(numSample);
}

void CGCFloatToCx::initCode() {
# line 38 "CGCFloatToCx.pl"
numSample = output.numXfer();
}

void CGCFloatToCx::setup() {
# line 32 "CGCFloatToCx.pl"
if (int(numSample) > 1) {
			input.setSDFParams(int(numSample));
			output.setSDFParams(int(numSample));
		}
}

void CGCFloatToCx::go() {
# line 48 "CGCFloatToCx.pl"
addCode(body);
}

// prototype instance for known block list
static CGCFloatToCx proto;
static RegisterBlock registerBlock(proto,"FloatToCx");
