static const char file_id[] = "CGCFloatToFix.pl";
// .cc file generated from CGCFloatToFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCFloatToFix.h"

const char *star_nm_CGCFloatToFix = "CGCFloatToFix";

const char* CGCFloatToFix :: className() const {return star_nm_CGCFloatToFix;}

ISA_FUNC(CGCFloatToFix,CGCFix);

Block* CGCFloatToFix :: makeNew() const { LOG_NEW; return new CGCFloatToFix;}

CGCFloatToFix::CGCFloatToFix ()
{
	setDescriptor("Convert a floating-point input to an fixed-point output.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FIX));
	addState(OutputPrecision.setState("OutputPrecision",this,"","Precision of the output in bits or empty if unspecified.\nIf the value of the double cannot be represented by the number of bits\nspecified in the precision parameter, then the output is set to its maximum\nvalue (or minimum for negative magnitudes)."));


}

void CGCFloatToFix::begin() {
# line 48 "CGCFloatToFix.pl"
// if the precision for the output port is not defined
		// - neither by this nor the successor star -, the actual
		// precision is determined at runtime

		if (!output.precision().isValid())
			output.setAttributes(A_VARPREC);
}

void CGCFloatToFix::setup() {
# line 43 "CGCFloatToFix.pl"
CGCFix::setup();
		output.setPrecision(OutputPrecision);
}

void CGCFloatToFix::go() {
# line 57 "CGCFloatToFix.pl"
// insert code to clear overflow flag
		CGCFix::clearOverflow();

		if (output.attributes() & AB_VARPREC)
	{ StringList _str_; _str_ << 
"	FIX_SetPrecisionFromDouble($precision(output),$ref(input));\n"
;
	 addCode(_str_); }

	{ StringList _str_; _str_ << 
"	FIX_DoubleAssign($ref(output),$ref(input));\n"
;
	 addCode(_str_); }

		// insert code to test overflow flag
		CGCFix::checkOverflow();
}

// prototype instance for known block list
static CGCFloatToFix proto;
static RegisterBlock registerBlock(proto,"FloatToFix");
