static const char file_id[] = "CGCFloatToInt.pl";
// .cc file generated from CGCFloatToInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCFloatToInt.h"

const char *star_nm_CGCFloatToInt = "CGCFloatToInt";

const char* CGCFloatToInt :: className() const {return star_nm_CGCFloatToInt;}

ISA_FUNC(CGCFloatToInt,CGCStar);

Block* CGCFloatToInt :: makeNew() const { LOG_NEW; return new CGCFloatToInt;}

CodeBlock CGCFloatToInt :: body (
# line 40 "CGCFloatToInt.pl"
"	int i = 0;\n"
"	for (; i < $val(numSample); i++) {\n"
"		$ref(output, i) = (int) $ref(input, i);\n"
"	}\n");

CGCFloatToInt::CGCFloatToInt ()
{
	setDescriptor("type conversion from float to int");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,INT));
	addState(numSample.setState("numSample",this,"1","number of samples to be converted"));

# line 29 "CGCFloatToInt.pl"
noInternalState();
}

int CGCFloatToInt::myExecTime() {
# line 50 "CGCFloatToInt.pl"
return int(numSample);
}

void CGCFloatToInt::initCode() {
# line 38 "CGCFloatToInt.pl"
numSample = output.numXfer();
}

void CGCFloatToInt::setup() {
# line 32 "CGCFloatToInt.pl"
if (int(numSample) > 1) {
			input.setSDFParams(int(numSample));
			output.setSDFParams(int(numSample));
		}
}

void CGCFloatToInt::go() {
# line 47 "CGCFloatToInt.pl"
addCode(body);
}

// prototype instance for known block list
static CGCFloatToInt proto;
static RegisterBlock registerBlock(proto,"FloatToInt");
