static const char file_id[] = "CGCGAL.pl";
// .cc file generated from CGCGAL.pl by ptlang
/*
Copyright (c) 1992-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCGAL.h"

const char *star_nm_CGCGAL = "CGCGAL";

const char* CGCGAL :: className() const {return star_nm_CGCGAL;}

ISA_FUNC(CGCGAL,CGCStar);

Block* CGCGAL :: makeNew() const { LOG_NEW; return new CGCGAL;}

CodeBlock CGCGAL :: main (
# line 90 "CGCGAL.pl"
"	{\n"
"	    int m;\n"
"\n"
"	    /* Update forward errors. */\n"
"	    $ref(f,0) = $ref(input);\n"
"	    for(m = 1; m <= $val(order); m++)\n"
"	    {\n"
"	       $ref(f,m) = $ref(f,m-1) - $ref(k,m) * $ref(b,m-1);\n"
"	    }\n"
"\n"
"	    /* Update backward errors, reflection coefficients. */\n"
"	    for(m = $val(order); m > 0; m--)\n"
"	    {\n"
"		$ref(b,m) = $ref(b,m-1) - $ref(k,m)*$ref(f,m-1);\n"
"		$ref(e,m) *= 1.0 - $val(alpha);\n"
"		$ref(e,m) += $val(alpha) * ($ref(f,m-1)*$ref(f,m-1) + $ref(b,m-1)*$ref(b,m-1));\n"
"		if ($ref(e,m) != 0.0)\n"
"		{\n"
"		    $ref(k,m) += $val(alpha) * ($ref(f,m)*$ref(b,m-1) + $ref(b,m)*$ref(f,m-1)) / $ref(e,m);\n"
"		    if ($ref(k,m) > 1.0) $ref(k,m) = 1.0;\n"
"		    if ($ref(k,m) < -1.0) $ref(k,m) = -1.0;\n"
"		}\n"
"	    }\n"
"\n"
"	    $ref(b,0) = $ref(input);\n"
"	    $ref(residual) =  $ref(f,order);\n"
"	}\n");

CGCGAL::CGCGAL ()
{
	setDescriptor("Gradient Adaptive Lattice filter.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(residual.setPort("residual",this,FLOAT));
	addState(order.setState("order",this,"1","Lattice filter order."));
	addState(timeConstant.setState("timeConstant",this,"1.0","Adaptation time constant."));
	addState(alpha.setState("alpha",this,"0.0","Adaptation parameter.",
# line 50 "CGCGAL.pl"
A_NONSETTABLE));
	addState(k.setState("k",this,"0.0","Reflection coefficients.",
# line 59 "CGCGAL.pl"
A_NONCONSTANT | A_NONSETTABLE));
	addState(f.setState("f",this,"0.0 0.0","Forward prediction error.",
# line 68 "CGCGAL.pl"
A_NONCONSTANT | A_NONSETTABLE));
	addState(b.setState("b",this,"0.0 0.0","Backward prediction error.",
# line 77 "CGCGAL.pl"
A_NONCONSTANT | A_NONSETTABLE));
	addState(e.setState("e",this,"0.0 0.0","Error power estimate.",
# line 86 "CGCGAL.pl"
A_NONCONSTANT | A_NONSETTABLE));


}

void CGCGAL::setup() {
# line 122 "CGCGAL.pl"
k.resize(order+1);
	f.resize(order+1);
	b.resize(order+1);
	e.resize(order+1);
	alpha = 1.0 - ((timeConstant - 1.0) / (timeConstant + 1.0));
}

void CGCGAL::go() {
# line 131 "CGCGAL.pl"
addCode(main);
}

// prototype instance for known block list
static CGCGAL proto;
static RegisterBlock registerBlock(proto,"GAL");
