static const char file_id[] = "CGCGainFix.pl";
// .cc file generated from CGCGainFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCGainFix.h"

const char *star_nm_CGCGainFix = "CGCGainFix";

const char* CGCGainFix :: className() const {return star_nm_CGCGainFix;}

ISA_FUNC(CGCGainFix,CGCFix);

Block* CGCGainFix :: makeNew() const { LOG_NEW; return new CGCGainFix;}

CGCGainFix::CGCGainFix ()
{
	setDescriptor("This is an amplifier; the fixed-point output is the fixed-point input\nmultiplied by the \"gain\" (default 1.0).\nThe precision of \"gain\", the input, and the output can be specified in bits.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(gain.setState("gain",this,"1.0","Gain of the star."));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag indicated whether or not to use the arriving particles as they are:\nYES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the input in bits.  The input particles are only cast\nto this precision if the parameter \"ArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the arithmetic operation\non the inputs.\nWhen the value of the product extends outside of the precision,\nthe output is set to its maximum value (or minimum for negative magnitudes)."));

# line 78 "CGCGainFix.pl"
noInternalState();
}

void CGCGainFix::setup() {
# line 82 "CGCGainFix.pl"
CGCFix::setup();

                if (!int(ArrivingPrecision))
		    input.setPrecision(InputPrecision);
		output.setPrecision(OutputPrecision);
}

void CGCGainFix::go() {
# line 90 "CGCGainFix.pl"
// insert code to clear overflow flag
		CGCFix::clearOverflow();

	{ StringList _str_; _str_ << 
"	FIX_Mul($ref(output),$ref(input),$ref(gain));\n"
;
	 addCode(_str_); }

		// insert code to test overflow flag
		CGCFix::checkOverflow();
}

// prototype instance for known block list
static CGCGainFix proto;
static RegisterBlock registerBlock(proto,"GainFix");
