static const char file_id[] = "CGCGoertzel.pl";
// .cc file generated from CGCGoertzel.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCGoertzel.h"

const char *star_nm_CGCGoertzel = "CGCGoertzel";

const char* CGCGoertzel :: className() const {return star_nm_CGCGoertzel;}

ISA_FUNC(CGCGoertzel,CGCGoertzelBase);

Block* CGCGoertzel :: makeNew() const { LOG_NEW; return new CGCGoertzel;}

CodeBlock CGCGoertzel :: finalValue (
# line 77 "CGCGoertzel.pl"
"		$ref(output).real = $ref(state1) +\n"
"				    $ref(state2) * $ref(negWnReal);\n"
"		$ref(output).imag = $ref(state2) * $ref(negWnImag);\n");

CGCGoertzel::CGCGoertzel ()
{
	setDescriptor("Second-order recursive computation of the kth coefficient of an\nN-point DFT using Goertzel's algorithm.");
	addPort(output.setPort("output",this,COMPLEX));
	addState(negWnReal.setState("negWnReal",this,"0.0","internal state for the storage of the negative of the real part of the\ntwiddle factor, which is a function of k and N",
# line 58 "CGCGoertzel.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(negWnImag.setState("negWnImag",this,"0.0","internal state for the storage of the imaginary part of the twiddle factor,\nwhich is a function of k and N",
# line 68 "CGCGoertzel.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void CGCGoertzel::setup() {
# line 71 "CGCGoertzel.pl"
// check parameter values and compute theta
		CGCGoertzelBase::setup();

		negWnReal = -cos(theta);
		negWnImag = -sin(theta);
}

void CGCGoertzel::go() {
# line 83 "CGCGoertzel.pl"
// Discard all but the last sample
		CGCGoertzelBase::go();

		// Final value is function of the two real IIR state values
		addCode(finalValue);
}

// prototype instance for known block list
static CGCGoertzel proto;
static RegisterBlock registerBlock(proto,"Goertzel");
