static const char file_id[] = "CGCGoertzelPower.pl";
// .cc file generated from CGCGoertzelPower.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCGoertzelPower.h"

const char *star_nm_CGCGoertzelPower = "CGCGoertzelPower";

const char* CGCGoertzelPower :: className() const {return star_nm_CGCGoertzelPower;}

ISA_FUNC(CGCGoertzelPower,CGCGoertzelBase);

Block* CGCGoertzelPower :: makeNew() const { LOG_NEW; return new CGCGoertzelPower;}

CodeBlock CGCGoertzelPower :: finalValue (
# line 53 "CGCGoertzelPower.pl"
"		/* Compute z z* where z is the last ouput of Goertzel filter */\n"
"		$ref(output) = $ref(state1)*$ref(state1) -\n"
"			       $ref(state1)*$ref(state2)*$ref(d1) +\n"
"			       $ref(state2)*$ref(state2);\n");

CGCGoertzelPower::CGCGoertzelPower ()
{
	setDescriptor("Second-order recursive computation of the power of the kth coefficient of\nan N-point DFT using Goertzel's algorithm.\nThis form is used in touchtone decoding.");
	addPort(output.setPort("output",this,FLOAT));


}

void CGCGoertzelPower::go() {
# line 61 "CGCGoertzelPower.pl"
// Generate code for the Goertzel second-order IIR filter
		CGCGoertzelBase::go();

		// Compute the power of the kth DFT coefficient.
		// The output of the Goertzel filter is
		//   state1 - Wn*state2 =
		//       state1 - [state2*cos(theta) - j*state2*sin(theta)]
		// where Wn is the twiddle factor Wn = exp(-j theta), such
		// that theta = 2 pi k / N.
		// Power is complex number times its conjugate, z z*:
		//   z = state1 - [state2*cos(theta) - j*state2*sin(theta)]
		//   z = [state1 - state2*cos(theta)] - j [state2*sin(theta)]
		//   z z* = state1*state1 - 2*state1*state2*cos(theta) +
		//     state2*state2*cos^2(theta) + state2*state2*sin^2(theta)
		//   z z* = state1*state1 - state1*state2*2*cos(theta) +
		//          state2*state2
		// where 2*cos(theta) = d1, by definition in CGCGoertzelBase.
		addCode(finalValue);
}

// prototype instance for known block list
static CGCGoertzelPower proto;
static RegisterBlock registerBlock(proto,"GoertzelPower");
