static const char file_id[] = "CGCIIDGaussian.pl";
// .cc file generated from CGCIIDGaussian.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCIIDGaussian.h"

const char *star_nm_CGCIIDGaussian = "CGCIIDGaussian";

const char* CGCIIDGaussian :: className() const {return star_nm_CGCIIDGaussian;}

ISA_FUNC(CGCIIDGaussian,CGCStar);

Block* CGCIIDGaussian :: makeNew() const { LOG_NEW; return new CGCIIDGaussian;}

CodeBlock CGCIIDGaussian :: initSeed (
# line 51 "CGCIIDGaussian.pl"
"    srand48($val(seed));\n");

CodeBlock CGCIIDGaussian :: randomGen (
# line 55 "CGCIIDGaussian.pl"
"		int i;\n"
"		double sum = 0;\n"
"		for (i = 0; i < 27; i++) {\n"
"			sum += (drand48() - 0.5);\n"
"		}\n"
"		if ($val(var) != 1.0) sum *= sqrt($val(var));\n"
"		$ref(output) = sum * 2/3 + $val(mean);\n");

CGCIIDGaussian::CGCIIDGaussian ()
{
	setDescriptor("Generate pseudo-IID-Gaussian random variables.");
	addPort(output.setPort("output",this,FLOAT));
	addState(var.setState("var",this,"1.0","variance"));
	addState(mean.setState("mean",this,"0.0","mean"));
	addState(seed.setState("seed",this,"1","seed"));


}

int CGCIIDGaussian::myExecTime() {
# line 65 "CGCIIDGaussian.pl"
return 300;
}

void CGCIIDGaussian::initCode() {
# line 43 "CGCIIDGaussian.pl"
addGlobal("double drand48();\n");
		addCode(initSeed);
		addInclude("<math.h>");
}

void CGCIIDGaussian::go() {
# line 48 "CGCIIDGaussian.pl"
addCode(randomGen);
}

// prototype instance for known block list
static CGCIIDGaussian proto;
static RegisterBlock registerBlock(proto,"IIDGaussian");
