static const char file_id[] = "CGCImpulse.pl";
// .cc file generated from CGCImpulse.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCImpulse.h"

const char *star_nm_CGCImpulse = "CGCImpulse";

const char* CGCImpulse :: className() const {return star_nm_CGCImpulse;}

ISA_FUNC(CGCImpulse,CGCStar);

Block* CGCImpulse :: makeNew() const { LOG_NEW; return new CGCImpulse;}

CGCImpulse::CGCImpulse ()
{
	setDescriptor("Generate a stream of impulses of size \"level\" (default 1.0).\nThe period is given by \"period\" (default 0).\nIf period = 0 then only one impulse is generated.");
	addPort(output.setPort("output",this,FLOAT));
	addState(level.setState("level",this,"1.0","The height of the impulse."));
	addState(period.setState("period",this,"0","The period of the impulse train, 0 = aperiodic."));
	addState(numSample.setState("numSample",this,"1","number of samples to be generated in a single run"));
	addState(count.setState("count",this,"0","An internal state.",
# line 46 "CGCImpulse.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void CGCImpulse::go() {
# line 50 "CGCImpulse.pl"
	{ StringList _str_; _str_ << 
"		$ref(output) = ($ref(count) == 0) ? $val(level) : 0.0;\n"
"		++$ref(count);\n"
;
	 addCode(_str_); }
	     if (int(period) > 0) {
	{ StringList _str_; _str_ << 
"		if ($ref(count) >= $val(period))\n"
"		    $ref(count) = 0;\n"
;
	 addCode(_str_); }
	     }
}

// prototype instance for known block list
static CGCImpulse proto;
static RegisterBlock registerBlock(proto,"Impulse");
