static const char file_id[] = "CGCIntToBits.pl";
// .cc file generated from CGCIntToBits.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
	All rights reserved.
	See the file $PTOLEMY/copyright for copyright notice,
	limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCIntToBits.h"

const char *star_nm_CGCIntToBits = "CGCIntToBits";

const char* CGCIntToBits :: className() const {return star_nm_CGCIntToBits;}

ISA_FUNC(CGCIntToBits,CGCStar);

Block* CGCIntToBits :: makeNew() const { LOG_NEW; return new CGCIntToBits;}

CodeBlock CGCIntToBits :: readNwrite (
# line 51 "CGCIntToBits.pl"
"	int word;\n"
"	int i = 0;\n"
"	word = $ref(input);\n"
"	for(; i < $val(nBits); i++) {\n"
" 	    $ref(output,i) = (word & 1);\n"
"	    word >>= 1;\n"
"	}\n");

CGCIntToBits::CGCIntToBits ()
{
	setDescriptor("Read the least significant nBits bits from an integer input,\nand output the bits as integers serially on the output,\nmost significant bit first.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(nBits.setState("nBits",this,"4","Number of bits to place in one word"));

# line 35 "CGCIntToBits.pl"
noInternalState();
}

int CGCIntToBits::myExecTime() {
# line 64 "CGCIntToBits.pl"
return int(nBits)*2;
}

void CGCIntToBits::setup() {
# line 38 "CGCIntToBits.pl"
/* Need (int) cast on sizeof to eliminate gcc warning */
	if (int(nBits) > int(sizeof(int)*8)) {
	    StringList message = "nBits needs to be less than ";
	    message << (unsigned int)(sizeof(int)*8);
	    Error::abortRun(*this, message);
	    return;
	}
	if (int(nBits) < 0) {
	    Error::abortRun(*this, "nBits must be positive");
	    return;
	}
	output.setSDFParams(int(nBits),int(nBits)-1);
}

void CGCIntToBits::go() {
# line 61 "CGCIntToBits.pl"
addCode(readNwrite);
}

// prototype instance for known block list
static CGCIntToBits proto;
static RegisterBlock registerBlock(proto,"IntToBits");
