#ifndef _CGCIntegrator_h
#define _CGCIntegrator_h 1
// header file generated from CGCIntegrator.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */
#include "CGCStar.h"
#include "IntState.h"
#include "FloatState.h"

class CGCIntegrator : public CGCStar
{
public:
	CGCIntegrator();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	static CodeBlock declarations;
	static CodeBlock integrate;
	static CodeBlock limitWithSat;
	static CodeBlock limitWithoutSat;
	static CodeBlock write;
	/* virtual */ int myExecTime();
	/* virtual */ void initCode();
	InCGCPort data;
	InCGCPort reset;
	OutCGCPort output;

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	FloatState feedbackGain;
	FloatState top;
	FloatState bottom;
	IntState saturate;
	FloatState state;
# line 79 "CGCIntegrator.pl"
double spread;

};
#endif
