static const char file_id[] = "CGCLMSOscDet.pl";
// .cc file generated from CGCLMSOscDet.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCLMSOscDet.h"

const char *star_nm_CGCLMSOscDet = "CGCLMSOscDet";

const char* CGCLMSOscDet :: className() const {return star_nm_CGCLMSOscDet;}

ISA_FUNC(CGCLMSOscDet,CGCLMS);

Block* CGCLMSOscDet :: makeNew() const { LOG_NEW; return new CGCLMSOscDet;}

const char* CGCLMSOscDet :: updateSecondTap(int index) {
# line 90 "CGCLMSOscDet.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	/* 1. Update the second tap = -2 a1[k]\n"
"	      update:        a1[k] = a1[k] + 2 e[n] x[n-1]\n"
"	      second tap: -2 a1[k] = -2 a1[k] - 4 mu e[n] x[n-1]\n"
"	      new tap:      newtap = newtap - 4 mu e[n] x[n-1]   */\n"
"	double mu = $val(stepSize);\n"
"	double e = $ref(error);\n"
"	double xnMinus1 = $ref(signalIn," << (index) << ");\n"
"	double newSecondTap = $ref(taps,1) - 4 * mu * e * xnMinus1;\n"
"	$ref(taps,1) = newSecondTap;\n";
	return (const char*)_str_;
}

CodeBlock CGCLMSOscDet :: outputSecondTap (
# line 102 "CGCLMSOscDet.pl"
"	$ref(cosOmega) = -newSecondTap/2;\n");

CGCLMSOscDet::CGCLMSOscDet ()
{
	setDescriptor("This filter tries to lock onto the strongest sinusoidal component in\nthe input signal, and outputs the current estimate of the cosine\nof the frequency of the strongest component.  It is a three-tap\nLeast-Mean Square (LMS) filter whose first and third coefficients are\nfixed at one.  The second coefficient is adapted.  It is a normalized\nversion of the Direct Adaptive Frequency Estimation Technique.");
	addPort(cosOmega.setPort("cosOmega",this,FLOAT));
	addState(initialOmega.setState("initialOmega",this,"PI/4","The initial guess at the angle being estimated in radians."));

# line 68 "CGCLMSOscDet.pl"
// taps state: not constant, length three, and not settable
		taps.clearAttributes(A_CONSTANT);
		taps.clearAttributes(A_SETTABLE);

		// decimation is not supported
		decimation.clearAttributes(A_SETTABLE);
		decimationPhase.clearAttributes(A_SETTABLE);
}

void CGCLMSOscDet::setup() {
# line 77 "CGCLMSOscDet.pl"
// we don't support decimation: make sure that it's 1
		decimation = 1;

		// initialize the taps of the three-tap LMS FIR filter
		taps.resize(3);
		taps[0] =  1.0;
		taps[1] = -2.0 * cos(double(initialOmega));
		taps[2] =  1.0;

		// call the LMS FIR filter setup method
		CGCLMS :: setup();
}

void CGCLMSOscDet::go() {
# line 107 "CGCLMSOscDet.pl"
// 1. Update the second tap
		//    Since we don't support decimation,
		//    index = int(errorDelay) + 1, a constant
		int index = int(errorDelay)*int(decimation) +
			    int(decimationPhase) + 1;
		addCode(updateSecondTap(index));

		// 2. Compute the estimate of cos(w), a1
		addCode(outputSecondTap);

		// 3. Run the FIR filter
		CGCFIR :: go();
}

// prototype instance for known block list
static CGCLMSOscDet proto;
static RegisterBlock registerBlock(proto,"LMSOscDet");
