static const char file_id[] = "CGCLogic.pl";
// .cc file generated from CGCLogic.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCLogic.h"

const char *star_nm_CGCLogic = "CGCLogic";

const char* CGCLogic :: className() const {return star_nm_CGCLogic;}

ISA_FUNC(CGCLogic,CGCStar);

Block* CGCLogic :: makeNew() const { LOG_NEW; return new CGCLogic;}

const char* CGCLogic :: logicAndOp(int i) {
# line 86 "CGCLogic.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	result = result && $ref(input#" << (i) << ");\n";
	return (const char*)_str_;
}

const char* CGCLogic :: logicOrOp(int i) {
# line 90 "CGCLogic.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	result = result || $ref(input#" << (i) << ");\n";
	return (const char*)_str_;
}

const char* CGCLogic :: logicXorOp(int i) {
# line 94 "CGCLogic.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	if ( $ref(input#" << (i) << ") ) result = ! result;\n";
	return (const char*)_str_;
}

# line 55 "CGCLogic.pl"
#define NOTID 0
#define ANDID 1
#define NANDID 2
#define ORID 3
#define NORID 4
#define XORID 5
#define XNORID 6

CGCLogic::CGCLogic ()
{
	setDescriptor("This star applies a logical operation to any number of inputs.\nThe inputs are integers interpreted as Boolean values,\nwhere zero means FALSE and a nonzero value means TRUE.\nThe logical operations supported are {NOT AND NAND OR NOR XOR XNOR}.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(logic.setState("logic",this,"AND","The test logic: one of NOT AND NAND OR NOR XOR or XNOR."));

# line 67 "CGCLogic.pl"
noInternalState();
}

void CGCLogic::setup() {
# line 70 "CGCLogic.pl"
const char* cn = logic;
		if ( strcasecmp(cn, "NOT") == 0) {
		    test = NOTID;
		    if (input.numberPorts() > 1)
			Error::abortRun(*this,
			    "NOT operation can only have one input");
		}
		else if ( strcasecmp(cn, "AND") == 0 ) test = ANDID;
		else if ( strcasecmp(cn, "NAND") == 0 ) test = NANDID;
		else if ( strcasecmp(cn, "OR") == 0 ) test = ORID;
		else if ( strcasecmp(cn, "NOR") == 0 ) test = NORID;
		else if ( strcasecmp(cn, "XOR") == 0 ) test = XORID;
		else if ( strcasecmp(cn, "XNOR") == 0 ) test = XNORID;
		else Error::abortRun(*this, "Unrecognized test.");
}

void CGCLogic::go() {
# line 99 "CGCLogic.pl"
// The inverter (not) star is the simplest case
		if ( test == NOTID ) {
			addCode("\t$ref(output) = ! $ref(input#1);\n");
			return;
		}

		// Declare and initialize local variables i and result
		if ( test == ANDID || test == NANDID ) {
			addCode("\tint result = 1;\n");
		}
		else {
			addCode("\tint result = 0;\n");
		}

		// Generate the code that walks through the input values
		int i = 1;
		switch( test ) {
		  case ANDID:
		  case NANDID:
			for (i = 1; i <= input.numberPorts(); i++ ) {
			    addCode(logicAndOp(i));
			}
			break;
		  case ORID:
		  case NORID:
			for (i = 1; i <= input.numberPorts(); i++ ) {
			    addCode(logicOrOp(i));
			}
			break;
		  case XORID:
		  case XNORID:
			for (i = 1; i <= input.numberPorts(); i++ ) {
			    addCode(logicXorOp(i));
			    break;
			}
		}

		// Compute final result 
		StringList finalCode;
		if (test == NANDID || test == NORID || test == XNORID ) {
			finalCode << "\tresult = ! result;\n";
		}
		finalCode << "\t$ref(output) = result;\n";
		addCode(finalCode);
}

// prototype instance for known block list
static CGCLogic proto;
static RegisterBlock registerBlock(proto,"Logic");
