static const char file_id[] = "CGCMaxMin.pl";
// .cc file generated from CGCMaxMin.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCMaxMin.h"

const char *star_nm_CGCMaxMin = "CGCMaxMin";

const char* CGCMaxMin :: className() const {return star_nm_CGCMaxMin;}

ISA_FUNC(CGCMaxMin,CGCStar);

Block* CGCMaxMin :: makeNew() const { LOG_NEW; return new CGCMaxMin;}

CodeBlock CGCMaxMin :: macros (
# line 77 "CGCMaxMin.pl"
"#define FABS(a)	( ((a) > 0.0) ? (a) : -(a) )\n");

CodeBlock CGCMaxMin :: decl (
# line 81 "CGCMaxMin.pl"
"	double current, currentCmp, value, valueCmp;\n"
"	int i, minChangeFlag, valueIndex;\n"
"	int cmpMagFlag, maxflag;\n");

CodeBlock CGCMaxMin :: initData (
# line 87 "CGCMaxMin.pl"
"	cmpMagFlag = $val(compareMagnitude);\n"
"	maxflag = $val(MAX);\n"
"	i = $val(N) - 1;\n"
"	value = $ref(input,i);\n"
"	valueCmp = cmpMagFlag ? FABS(value) : value;\n"
"	valueIndex = i;\n");

CodeBlock CGCMaxMin :: compareData (
# line 96 "CGCMaxMin.pl"
"	while ( i-- > 0 ) {\n"
"		current = $ref(input,i);\n"
"		currentCmp = cmpMagFlag ? FABS(current) : current;\n"
"		minChangeFlag = ( currentCmp < valueCmp );\n"
"\n"
"		/* Logical exclusive OR between maxflag and minChangeFlag\n"
"		   but we cannot use the bitwise xor ^ */\n"
"		if ( (maxflag && !minChangeFlag) ||\n"
"		     (!maxflag && minChangeFlag) ) {\n"
"			value = current;\n"
"			valueCmp = currentCmp;\n"
"			valueIndex = i;\n"
"		}\n"
"	}\n");

CodeBlock CGCMaxMin :: outputValue (
# line 113 "CGCMaxMin.pl"
"	/* Output the value or the magnitude of the value */\n"
"	if ( $val(outputMagnitude) ) {\n"
"		if ( value < 0.0 ) value = -value;\n"
"	}\n"
"\n"
"	/* Send the maximum/minimum value to the output port */\n"
"	$ref(output) = value;\n"
"\n"
"	/* Adjust the index due to the LIFO nature of input data */\n"
"	$ref(index) = $val(N) - valueIndex - 1;\n");

CGCMaxMin::CGCMaxMin ()
{
	setDescriptor("Finds maximum or minimum, value or magnitude.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addPort(index.setPort("index",this,INT));
	addState(N.setState("N",this,"10","default samples"));
	addState(MAX.setState("MAX",this,"YES","output maximum value else minimum is the output"));
	addState(compareMagnitude.setState("compareMagnitude",this,"NO","default is not to compare magnitude"));
	addState(outputMagnitude.setState("outputMagnitude",this,"NO","default is not to output magnitude"));

# line 65 "CGCMaxMin.pl"
noInternalState();
}

void CGCMaxMin::setup() {
# line 69 "CGCMaxMin.pl"
if ( int(N) <= 0 ) {
		    Error::abortRun(*this,
				    "Number of samples, N, must be positive.");
		    return;
		}
		input.setSDFParams(int(N), int(N)-1);
}

void CGCMaxMin::go() {
# line 127 "CGCMaxMin.pl"
addCode(macros);
		addCode(decl);
		addCode(initData);
		addCode(compareData);
		addCode(outputValue);
}

// prototype instance for known block list
static CGCMaxMin proto;
static RegisterBlock registerBlock(proto,"MaxMin");
