static const char file_id[] = "CGCMpyFix.pl";
// .cc file generated from CGCMpyFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCMpyFix.h"

const char *star_nm_CGCMpyFix = "CGCMpyFix";

const char* CGCMpyFix :: className() const {return star_nm_CGCMpyFix;}

ISA_FUNC(CGCMpyFix,CGCFix);

Block* CGCMpyFix :: makeNew() const { LOG_NEW; return new CGCMpyFix;}

CGCMpyFix::CGCMpyFix ()
{
	setDescriptor("Output the product of the inputs, as a fixed-point value.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Indicates whether or not to keep the precision of the arriving particles\nas they are:  YES keeps the same precision, and NO casts the inputs\nto the precision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Sets the precision of the input in bits.\nThe input particles are only cast to this precision if the\nparameter \"ArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Sets the precision of the output in bits.\nThis is the precision that will hold the result of the product of the inputs.\nWhen the value of the product extends outside of the precision,\nthe output is set to its maximum value (or minimum for negative magnitudes)."));
	addState(index.setState("index",this,"1","index for multiple input trace",
# line 60 "CGCMpyFix.pl"
A_NONSETTABLE|A_NONCONSTANT));

# line 64 "CGCMpyFix.pl"
noInternalState();
}

void CGCMpyFix::setup() {
# line 68 "CGCMpyFix.pl"
CGCFix::setup();

                if (!int(ArrivingPrecision))
		    input.setPrecision(InputPrecision);
		output.setPrecision(OutputPrecision);
}

void CGCMpyFix::go() {
# line 76 "CGCMpyFix.pl"
// insert code to clear overflow flag
		CGCFix::clearOverflow();

		// avoid FIX_Assign if possible
		if (input.numberPorts() == 2)
	{ StringList _str_; _str_ << 
"	FIX_Mul($ref(output), $ref(input#1),$ref(input#2));\n"
;
	 addCode(_str_); }

		else {
			// initialize the product
	{ StringList _str_; _str_ << 
"	FIX_Assign($ref(output),$ref(input#1));\n"
;
	 addCode(_str_); }

			for (int i=2; i <= input.numberPorts(); i++) {
			    index = i;
	{ StringList _str_; _str_ << 
"	FIX_Mul($ref(output), $ref(output),$ref(input#index));\n"
;
	 addCode(_str_); }
			}
		}

		// insert code to test overflow flag
		CGCFix::checkOverflow();
}

// prototype instance for known block list
static CGCMpyFix proto;
static RegisterBlock registerBlock(proto,"MpyFix");
