static const char file_id[] = "CGCMux.pl";
// .cc file generated from CGCMux.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCMux.h"

const char *star_nm_CGCMux = "CGCMux";

const char* CGCMux :: className() const {return star_nm_CGCMux;}

ISA_FUNC(CGCMux,CGCStar);

Block* CGCMux :: makeNew() const { LOG_NEW; return new CGCMux;}

CGCMux::CGCMux ()
{
	setDescriptor("Multiplexes any number of inputs onto one output stream.\nB particles are consumed on each input, where B is the blockSize.\nBut only one of these blocks of particles is copied to the output.\nThe one copied is determined by the \"control\" input.\nIntegers from 0 through N-1 are accepted at the \"control\" input,\nwhere N is the number of inputs.  If the control input is outside\nthis range, an error is signaled.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));

# line 44 "CGCMux.pl"
noInternalState();
}

int CGCMux::myExecTime() {
# line 66 "CGCMux.pl"
/* worst case */
		return int(blockSize) + input.numberPorts();
}

void CGCMux::setup() {
# line 47 "CGCMux.pl"
output.setSDFParams(int(blockSize),int(blockSize)-1);
		input.setSDFParams(int(blockSize),int(blockSize)-1);
}

void CGCMux::go() {
# line 51 "CGCMux.pl"
StringList out;
	    out << "\tint n, j;\n\tn = $ref(control);\n";

	    for (int i = 0; i < input.numberPorts(); i++) {
		out << "\t";
		if (i > 0) out << "else ";
		out << "if (n == " << i << ") {\n";
		out << "\t\tfor (j = $val(blockSize)-1; j >= 0; j--) \n";
		out << "\t\t\t$ref(output,j) = $ref(input#" << i+1 << ",j);\n";
		out << "\t}\n";
	    }
	    out << "\telse \n\t\tprintf(\"invalid control input to Mux\");\n";
	    addCode(out);
}

// prototype instance for known block list
static CGCMux proto;
static RegisterBlock registerBlock(proto,"Mux");
