static const char file_id[] = "CGCPCMread.pl";
// .cc file generated from CGCPCMread.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCPCMread.h"

const char *star_nm_CGCPCMread = "CGCPCMread";

const char* CGCPCMread :: className() const {return star_nm_CGCPCMread;}

ISA_FUNC(CGCPCMread,CGCStar);

Block* CGCPCMread :: makeNew() const { LOG_NEW; return new CGCPCMread;}

CodeBlock CGCPCMread :: declarations (
# line 53 "CGCPCMread.pl"
"        int $starSymbol(file);\n"
"        unsigned char $starSymbol(buf)[$val(blockSize)];\n");

CodeBlock CGCPCMread :: sharedDeclarations (
# line 59 "CGCPCMread.pl"
"	int $sharedSymbol(PCMread,offset)[8] =\n"
"	    { 0, 33, 99, 231, 495, 1023, 2079, 4191 };\n"
"\n"
"	double $sharedSymbol(PCMread,convert)[256];\n");

CodeBlock CGCPCMread :: sharedProcedure (
# line 67 "CGCPCMread.pl"
"	/* Convert from mu-law PCM to floating point [-1.0,1.0]. */\n"
"	double $sharedSymbol(PCMread,muLawToLin)(byte)\n"
"	unsigned char byte;\n"
"	{\n"
"	    double x;\n"
"	    int exponent, mantissa, magnitude;\n"
"\n"
"	    byte = ~byte;\n"
"	    exponent = (byte >> 4) & 0x7;\n"
"	    mantissa = byte & 0xf;\n"
"	    magnitude = $sharedSymbol(PCMread,offset)[exponent] + (mantissa << (exponent+1));\n"
"	    x = magnitude / 8031.0;\n"
"	    if (byte & 0x80) x = -x;\n"
"\n"
"	    return x;\n"
"	}\n");

CodeBlock CGCPCMread :: sharedInit (
# line 87 "CGCPCMread.pl"
"	{\n"
"	    int i;\n"
"	    for (i = 0; i <= 0xff; i++)\n"
"		$sharedSymbol(PCMread,convert)[i] = $sharedSymbol(PCMread,muLawToLin)(i);\n"
"	}\n");

CodeBlock CGCPCMread :: openFile (
# line 96 "CGCPCMread.pl"
"	/* Open file for reading. */\n"
"	if (($starSymbol(file) = open(\"$val(fileName)\",O_RDONLY,0666)) == -1)\n"
"	{\n"
"		perror(\"$val(fileName)\");\n"
"		exit(1);\n"
"	}\n");

CodeBlock CGCPCMread :: noOpen (
# line 106 "CGCPCMread.pl"
"	/* Use standard input for reading. */\n"
"	$starSymbol(file) = 0;\n");

CodeBlock CGCPCMread :: read (
# line 112 "CGCPCMread.pl"
"	/* Read data from file. */\n"
"	if (read($starSymbol(file), $starSymbol(buf), $val(blockSize)) != $val(blockSize))\n"
"	{\n"
"	    perror(\"$val(fileName)\");\n"
"	    exit(1);\n"
"	}\n");

CodeBlock CGCPCMread :: convert (
# line 122 "CGCPCMread.pl"
"	{\n"
"	    int i;\n"
"	    for (i=0; i<$val(blockSize); i++)\n"
"		$ref(output,i) = $sharedSymbol(PCMread,convert)[$starSymbol(buf)[$val(blockSize)-1-i]];\n"
"	}\n");

CodeBlock CGCPCMread :: closeFile (
# line 131 "CGCPCMread.pl"
"        /* Close file. */\n"
"        if (close($starSymbol(file)) != 0)\n"
"        {\n"
"            perror(\"$val(fileName)\");\n"
"            exit(1);\n"
"        }\n");

CGCPCMread::CGCPCMread ()
{
	setDescriptor("Read mu-law PCM from a file and convert to linear floating point.\nThe file can be the audio port /dev/audio, if supported by the workstation.");
	addState(fileName.setState("fileName",this,"/dev/audio","Input file for PCM data.  If empty, use standard input."));
	addState(blockSize.setState("blockSize",this,"128","Number of samples to read."));
	addPort(output.setPort("output",this,FLOAT));


}

int CGCPCMread::myExecTime() {
# line 176 "CGCPCMread.pl"
return int(blockSize) * 14;
}

void CGCPCMread::wrapup() {
# line 171 "CGCPCMread.pl"
if (!standardInput) addCode(closeFile);
}

void CGCPCMread::initCode() {
# line 148 "CGCPCMread.pl"
addInclude("<math.h>");
	addDeclaration(declarations);
	if (addGlobal(sharedDeclarations,"$sharedSymbol(PCMread,PCMread)"))
	{
	    addProcedure(sharedProcedure);
	    addCode(sharedInit);
	}
	if (standardInput) addCode(noOpen);
	else
	{
	    addInclude("<fcntl.h>");
	    addCode(openFile);
	}
}

void CGCPCMread::setup() {
# line 142 "CGCPCMread.pl"
standardInput = (strcmp(fileName,"") == 0);
	output.setSDFParams(blockSize, blockSize-1);
}

void CGCPCMread::go() {
# line 165 "CGCPCMread.pl"
addCode(read);
	addCode(convert);
}

// prototype instance for known block list
static CGCPCMread proto;
static RegisterBlock registerBlock(proto,"PCMread");
