static const char file_id[] = "CGCPCMwrite.pl";
// .cc file generated from CGCPCMwrite.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCPCMwrite.h"

const char *star_nm_CGCPCMwrite = "CGCPCMwrite";

const char* CGCPCMwrite :: className() const {return star_nm_CGCPCMwrite;}

ISA_FUNC(CGCPCMwrite,CGCStar);

Block* CGCPCMwrite :: makeNew() const { LOG_NEW; return new CGCPCMwrite;}

CodeBlock CGCPCMwrite :: declarations (
# line 53 "CGCPCMwrite.pl"
"        int $starSymbol(file);\n"
"        unsigned char $starSymbol(buf)[$val(blockSize)];\n");

CodeBlock CGCPCMwrite :: sharedDeclarations (
# line 59 "CGCPCMwrite.pl"
"	int $sharedSymbol(PCMwrite,threshold)[8] =\n"
"		    { 0, 32, 96, 224, 480, 992, 2016, 4064 };\n"
"\n"
"	int $sharedSymbol(PCMwrite,exponent)[256] =\n"
"	    { 0,1,1,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,\n"
"	    5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,\n"
"	    6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,\n"
"	    6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,\n"
"	    7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,\n"
"	    7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,\n"
"	    7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,\n"
"	    7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7};\n");

CodeBlock CGCPCMwrite :: openFile (
# line 75 "CGCPCMwrite.pl"
"	/* Open file for writing. */\n"
"	if (($starSymbol(file) = open(\"$val(fileName)\",O_WRONLY|O_CREAT,0666)) == -1)\n"
"	{\n"
"		perror(\"$val(fileName)\");\n"
"		exit(1);\n"
"	}\n");

CodeBlock CGCPCMwrite :: noOpen (
# line 85 "CGCPCMwrite.pl"
"	/* Use standard output for writing. */\n"
"	$starSymbol(file) = 1;\n");

CodeBlock CGCPCMwrite :: convert (
# line 91 "CGCPCMwrite.pl"
"	/* Convert from floating point [-1.0,1.0] to mu-law PCM. */\n"
"	{\n"
"	    int i;\n"
"	    for(i=0; i<$val(blockSize); i++)\n"
"	    {\n"
"		int exponent, mantissa, magnitude;\n"
"		unsigned char byte;\n"
"\n"
"		magnitude = fabs($ref(input,i)) * 8031.0;\n"
"		if (magnitude > 8031) magnitude = 8031;\n"
"		exponent = $sharedSymbol(PCMwrite,exponent)[magnitude >> 5];\n"
"		mantissa = (magnitude-$sharedSymbol(PCMwrite,threshold)[exponent]) >> (exponent+1);\n"
"		byte = (exponent << 4) | mantissa;\n"
"		if ($ref(input,i) < 0.0) byte |= 0x80;\n"
"		$starSymbol(buf)[$val(blockSize)-1-i] = ~byte;\n"
"	    }\n"
"	}\n");

CodeBlock CGCPCMwrite :: write (
# line 112 "CGCPCMwrite.pl"
"	/* Write data to file. */\n"
"	if (write($starSymbol(file), $starSymbol(buf), $val(blockSize)) != $val(blockSize))\n"
"	{\n"
"	    perror(\"$val(fileName)\");\n"
"	    exit(1);\n"
"	}\n");

CodeBlock CGCPCMwrite :: closeFile (
# line 122 "CGCPCMwrite.pl"
"        /* Close file. */\n"
"        if (close($starSymbol(file)) != 0)\n"
"        {\n"
"            perror(\"$val(fileName)\");\n"
"            exit(1);\n"
"        }\n");

CGCPCMwrite::CGCPCMwrite ()
{
	setDescriptor("Convert input to mu-law PCM and write it to a file.\nThe file can be the audio port /dev/audio, if supported by the workstation.");
	addState(fileName.setState("fileName",this,"/dev/audio","Output file for PCM data.  If empty, use standard output."));
	addState(blockSize.setState("blockSize",this,"128","Number of samples to write."));
	addPort(input.setPort("input",this,FLOAT));


}

int CGCPCMwrite::myExecTime() {
# line 163 "CGCPCMwrite.pl"
return int(blockSize) * 19;
}

void CGCPCMwrite::wrapup() {
# line 158 "CGCPCMwrite.pl"
if (!standardOutput) addCode(closeFile);
}

void CGCPCMwrite::initCode() {
# line 139 "CGCPCMwrite.pl"
addInclude("<math.h>");
	addDeclaration(declarations);
	addGlobal(sharedDeclarations,"$sharedSymbol(PCMwrite,PCMwrite)");
	if (standardOutput) addCode(noOpen);
	else
	{
	    addInclude("<fcntl.h>");
	    addCode(openFile);
	}
}

void CGCPCMwrite::setup() {
# line 133 "CGCPCMwrite.pl"
standardOutput = (strcmp(fileName,"") == 0);
	input.setSDFParams(blockSize, blockSize-1);
}

void CGCPCMwrite::go() {
# line 152 "CGCPCMwrite.pl"
addCode(convert);
	addCode(write);
}

// prototype instance for known block list
static CGCPCMwrite proto;
static RegisterBlock registerBlock(proto,"PCMwrite");
