static const char file_id[] = "CGCPad.pl";
// .cc file generated from CGCPad.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCPad.h"

const char *star_nm_CGCPad = "CGCPad";

const char* CGCPad :: className() const {return star_nm_CGCPad;}

ISA_FUNC(CGCPad,CGCStar);

Block* CGCPad :: makeNew() const { LOG_NEW; return new CGCPad;}

CodeBlock CGCPad :: out (
# line 61 "CGCPad.pl"
"	int inidx, hiLim, loLim, i;\n"
"	inidx = $val(nread) - 1;\n"
"	hiLim = $val(nwrite) - $val(offset);\n"
"	loLim = hiLim - $val(nread);\n"
"	for (i = $val(nwrite) - 1; i >= 0; i--) {\n"
"		if (i >= hiLim || i < loLim) {\n"
"			$ref(output,i) = 0;\n"
"		} else {\n"
"			$ref(output,i) = $ref(input,inidx);\n"
"			inidx--;\n"
"		}\n"
"	}\n");

CGCPad::CGCPad ()
{
	setDescriptor("On each execution, reads a block of \"nread\" samples (default 128)\nand writes a block of \"nwrite\" samples (default 256), where\n\"nwrite\" >= \"nread\".  The samples may be of any type.\n\nThe first \"offset\" samples (default 0) have a zero value of the appropriate\ntype (messages of type DUMMY for message connections), the next \"nread\"\noutput samples have values taken from the inputs, and the remaining\n\"nwrite\" - \"nread\" - \"offset\" samples have value 0 again.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(nread.setState("nread",this,"128","Number of particles read."));
	addState(nwrite.setState("nwrite",this,"256","Number of particles written."));
	addState(offset.setState("offset",this,"0","Number of leading fill particles in each output block."));

# line 50 "CGCPad.pl"
noInternalState();
}

int CGCPad::myExecTime() {
# line 79 "CGCPad.pl"
return int(nwrite);
}

void CGCPad::setup() {
# line 53 "CGCPad.pl"
if (int(nwrite) < int(nread)) {
			Error::abortRun(*this,
			   ": nwrite cannot be less than nread");
			return;
		}
		input.setSDFParams(int(nread),int(nread)-1);
		output.setSDFParams(int(nwrite),int(nwrite)-1);
}

void CGCPad::go() {
# line 76 "CGCPad.pl"
addCode(out);
}

// prototype instance for known block list
static CGCPad proto;
static RegisterBlock registerBlock(proto,"Pad");
