static const char file_id[] = "CGCPcwzLinear.pl";
// .cc file generated from CGCPcwzLinear.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCPcwzLinear.h"

const char *star_nm_CGCPcwzLinear = "CGCPcwzLinear";

const char* CGCPcwzLinear :: className() const {return star_nm_CGCPcwzLinear;}

ISA_FUNC(CGCPcwzLinear,CGCStar);

Block* CGCPcwzLinear :: makeNew() const { LOG_NEW; return new CGCPcwzLinear;}

CodeBlock CGCPcwzLinear :: lookup (
# line 62 "CGCPcwzLinear.pl"
"	  double in, x1, x2, y1, y2;\n"
"	  int i, ind, sz;\n"
"	  in = $ref(input);\n"
"	  if (in < $ref(breakpoints,0).real) {\n"
"	    $ref(output) = $ref(breakpoints,0).imag;\n"
"	  } else {\n"
"	    ind = 0;\n"
"	    sz = $size(breakpoints);\n"
"	    for (i = 1; i < sz; i++) {\n"
"	      if (in < $ref(breakpoints,i).real) {\n"
"		x1 = $ref(breakpoints,i-1).real;\n"
"		y1 = $ref(breakpoints,i-1).imag;\n"
"		x2 = $ref(breakpoints,i).real;\n"
"		y2 = $ref(breakpoints,i).imag;\n"
"		$ref(output) = y1 + (y2 - y1)*(in - x1)/(x2 - x1);\n"
"		ind = 1;\n"
"		break;\n"
"	      }\n"
"	    }\n"
"	    if (!ind) {\n"
"	      sz--;\n"
"	      $ref(output) = $ref(breakpoints,sz).imag;\n"
"	    }\n"
"	  }\n");

CGCPcwzLinear::CGCPcwzLinear ()
{
	setDescriptor("This star implements a piecewise linear mapping from the\ninput to the output.  The mapping is given by a sequence\nof (x,y) pairs, which specify the breakpoints in the function.\nThe sequence of x values must be increasing. The function\nimplemented by the star can be represented by drawing straight\nlines between the (x,y) pairs, in sequence.  The default\nmapping is the \"tent\" map, in which inputs between -1.0\nand 0.0 are linearly mapped into the range -1.0 to 1.0.\nInputs between 0.0 and 1.0 are mapped into the same range,\nbut with the opposite slope, 1.0 to -1.0. If the input is\noutside the range specified in the \"x\" values of the breakpoints,\nthen the appropriate extreme value will be used for the output.\nThus, for the default map, if the input is -2.0, the output\nwill be -1.0.  If the input is +2.0, the output will again be -1.0.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(breakpoints.setState("breakpoints",this,"(-1.0, -1.0) (0.0, 1.0) (1.0, -1.0)","\"Endpoints and breakpoints in the mapping\""));


}

void CGCPcwzLinear::begin() {
# line 50 "CGCPcwzLinear.pl"
// Check to make sure that x values are increasing
	  double previous = breakpoints[0].real();
	  for(int i = 1; i < breakpoints.size(); i++) {
	    if (breakpoints[i].real() <= previous) {
	      Error::abortRun(*this,"Breakpoints are not increasing in x");
	      return;
	    } else {
	      previous = breakpoints[i].real();
	    }
	  }
}

void CGCPcwzLinear::go() {
# line 89 "CGCPcwzLinear.pl"
addCode(lookup);
}

// prototype instance for known block list
static CGCPcwzLinear proto;
static RegisterBlock registerBlock(proto,"PcwzLinear");
