static const char file_id[] = "CGCRampFix.pl";
// .cc file generated from CGCRampFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCRampFix.h"

const char *star_nm_CGCRampFix = "CGCRampFix";

const char* CGCRampFix :: className() const {return star_nm_CGCRampFix;}

ISA_FUNC(CGCRampFix,CGCFix);

Block* CGCRampFix :: makeNew() const { LOG_NEW; return new CGCRampFix;}

CGCRampFix::CGCRampFix ()
{
	setDescriptor("Generate a fixed-point ramp signal, starting at \"value\" (default 0.0)\nwith step size \"step\" (default 1.0).\nA precision and an initial value can be specified for a parameter by using\nthe notation ( <initial_value>, <precision> ).");
	addPort(output.setPort("output",this,FIX));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits and precision of the accumulation.\nWhen the value of the accumulation extends outside of the precision,\nthe output is set to its maximum value (or minimum for negative\nmagnitudes)."));
	addState(step.setState("step",this,"1.0","Increment from one sample to the next."));
	addState(value.setState("value",this,"0.0","Initial value output by the ramp.\nDuring simulation, this parameter holds the current value output by the ramp.\nThe precision of this state is the precision of the accumulation.",
# line 66 "CGCRampFix.pl"
A_SETTABLE|A_NONCONSTANT));
	addState(StepPrecision.setState("StepPrecision",this,"2.14","Precision of the step in bits."));
	addState(ValuePrecision.setState("ValuePrecision",this,"2.14","Precision of the value in bits."));


}

void CGCRampFix::setup() {
# line 83 "CGCRampFix.pl"
CGCFix::setup();
		// if the user specified an invalid precision string, the error
		// will be automatically reported in the initialize method of
		// class PrecisionState
		output.setPrecision(OutputPrecision);
		value.setPrecision(ValuePrecision);
		step.setPrecision(StepPrecision);
}

void CGCRampFix::go() {
# line 93 "CGCRampFix.pl"
// insert code to clear overflow flag
		CGCFix::clearOverflow();

	{ StringList _str_; _str_ << 
"	FIX_Assign($ref(output), $ref(value));\n"
"	FIX_Add($ref(value), $ref(value),$ref(step));\n"
;
	 addCode(_str_); }

		// insert code to test overflow flag
		CGCFix::checkOverflow();
}

// prototype instance for known block list
static CGCRampFix proto;
static RegisterBlock registerBlock(proto,"RampFix");
