static const char file_id[] = "CGCReciprocal.pl";
// .cc file generated from CGCReciprocal.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCReciprocal.h"

const char *star_nm_CGCReciprocal = "CGCReciprocal";

const char* CGCReciprocal :: className() const {return star_nm_CGCReciprocal;}

ISA_FUNC(CGCReciprocal,CGCStar);

Block* CGCReciprocal :: makeNew() const { LOG_NEW; return new CGCReciprocal;}

CodeBlock CGCReciprocal :: reciprocal (
# line 46 "CGCReciprocal.pl"
"	$ref(output) = 1/$ref(input);\n");

CodeBlock CGCReciprocal :: satrec (
# line 49 "CGCReciprocal.pl"
"	if($ref(input) == 0.0)\n"
"	    $ref(output) = $val(magLimit);\n"
"	else {\n"
"	    double t;\n"
"	    t = 1/$ref(input);\n"
"	    if (t>$val(magLimit))\n"
"		$ref(output) = $val(magLimit);\n"
"	    else if (t < - $val(magLimit))\n"
"		$ref(output) = - $val(magLimit);\n"
"	    else\n"
"		$ref(output) = t;\n"
"	}\n");

CGCReciprocal::CGCReciprocal ()
{
	setDescriptor("1/x, with an optional magnitude limit.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(magLimit.setState("magLimit",this,"0.0","If non-zero, limits the magnitude of the output."));

# line 36 "CGCReciprocal.pl"
// Indicate that there is no dynamically changing internal
		// state, so the star can be parallelized.
		noInternalState();
}

int CGCReciprocal::myExecTime() {
# line 64 "CGCReciprocal.pl"
/* based on CG96Reciprocal */
		if (double(magLimit) == 0.0) return 8;
		else return 12;
}

void CGCReciprocal::go() {
# line 41 "CGCReciprocal.pl"
if(double(magLimit) == 0.0)
		addCode(reciprocal);
	    else
		addCode(satrec);
}

// prototype instance for known block list
static CGCReciprocal proto;
static RegisterBlock registerBlock(proto,"Reciprocal");
