static const char file_id[] = "CGCRectFix.pl";
// .cc file generated from CGCRectFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCRectFix.h"

const char *star_nm_CGCRectFix = "CGCRectFix";

const char* CGCRectFix :: className() const {return star_nm_CGCRectFix;}

ISA_FUNC(CGCRectFix,CGCFix);

Block* CGCRectFix :: makeNew() const { LOG_NEW; return new CGCRectFix;}

CGCRectFix::CGCRectFix ()
{
	setDescriptor("Generate a fixed-point rectangular pulse of height \"height\" \n(default 1.0) and width \"width\" (default 8).\nIf \"period\" is greater than zero, then the pulse is repeated with the\ngiven period.");
	addPort(output.setPort("output",this,FIX));
	addState(height.setState("height",this,"1.0","Height of the rectangular pulse."));
	addState(width.setState("width",this,"8","Width of the rectangular pulse."));
	addState(period.setState("period",this,"0","If greater than zero, the period of the pulse stream.",
# line 42 "CGCRectFix.pl"
A_CONSTANT));
	addState(count.setState("count",this,"0","Internal counting state.",
# line 49 "CGCRectFix.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThe value of the \"height\" parameter is cast to this precision and then output.\nIf the value cannot be represented by this precision,\nthe output is set to its maximum value (or minimum for negative magnitudes)."));


}

void CGCRectFix::setup() {
# line 63 "CGCRectFix.pl"
CGCFix::setup();
		// if the user specified an invalid precision string, the error
		// will be automatically reported in the initialize method of
		// class PrecisionState
		output.setPrecision(OutputPrecision);
}

void CGCRectFix::go() {
# line 70 "CGCRectFix.pl"
	{ StringList _str_; _str_ << 
"	FIX_SetToZero($ref(output));\n"
;
	 addCode(_str_); }

	{ StringList _str_; _str_ << 
"	if ($ref(count) < $ref(width)) {\n"
;
	 addCode(_str_); }
		CGCFix::clearOverflow();
	{ StringList _str_; _str_ << 
"		FIX_Assign($ref(output),$ref(height));\n"
;
	 addCode(_str_); }
		CGCFix::checkOverflow();
	{ StringList _str_; _str_ << 
"	}\n"
"	$ref(count)++;\n"
"	if ($ref(period) > 0 && $ref(count) > $ref(period))\n"
"		$ref(count) = 0;"
;
	 addCode(_str_); }

}

// prototype instance for known block list
static CGCRectFix proto;
static RegisterBlock registerBlock(proto,"RectFix");
