static const char file_id[] = "CGCRectToPolar.pl";
// .cc file generated from CGCRectToPolar.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCRectToPolar.h"

const char *star_nm_CGCRectToPolar = "CGCRectToPolar";

const char* CGCRectToPolar :: className() const {return star_nm_CGCRectToPolar;}

ISA_FUNC(CGCRectToPolar,CGCStar);

Block* CGCRectToPolar :: makeNew() const { LOG_NEW; return new CGCRectToPolar;}

CodeBlock CGCRectToPolar :: body (
# line 39 "CGCRectToPolar.pl"
"	double xpart, ypart, m;\n"
"	xpart = $ref(x);\n"
"	ypart = $ref(y);\n"
"	m = sqrt(xpart*xpart + ypart*ypart);\n"
"	$ref(magnitude) = m;\n"
"	if (m == 0) $ref(phase) = 0;\n"
"	else $ref(phase) = atan2(ypart,xpart);\n");

CGCRectToPolar::CGCRectToPolar ()
{
	setDescriptor("Convert two numbers to magnitude and phase.\nThe phase output is in the range -PI to PI.");
	addPort(x.setPort("x",this,FLOAT));
	addPort(y.setPort("y",this,FLOAT));
	addPort(magnitude.setPort("magnitude",this,FLOAT));
	addPort(phase.setPort("phase",this,FLOAT));

# line 34 "CGCRectToPolar.pl"
noInternalState();
}

int CGCRectToPolar::myExecTime() {
# line 53 "CGCRectToPolar.pl"
return 200;	/* based on CG96 stars */
}

void CGCRectToPolar::initCode() {
# line 37 "CGCRectToPolar.pl"
addInclude("<math.h>");
}

void CGCRectToPolar::go() {
# line 50 "CGCRectToPolar.pl"
addCode(body);
}

// prototype instance for known block list
static CGCRectToPolar proto;
static RegisterBlock registerBlock(proto,"RectToPolar");
