static const char file_id[] = "CGCScrambler.pl";
// .cc file generated from CGCScrambler.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCScrambler.h"

const char *star_nm_CGCScrambler = "CGCScrambler";

const char* CGCScrambler :: className() const {return star_nm_CGCScrambler;}

ISA_FUNC(CGCScrambler,CGCStar);

Block* CGCScrambler :: makeNew() const { LOG_NEW; return new CGCScrambler;}

CodeBlock CGCScrambler :: scramble (
# line 147 "CGCScrambler.pl"
"	  int reg, masked, parity;\n"
"	  reg = $ref(shiftReg) << 1;\n"
"	  masked = $val(polynomial) & reg;\n"
"	  /* Now we need to find the parity of \"masked\". */\n"
"	  parity = 0;\n"
"	  /* Calculate the parity of the masked word */\n"
"	  while (masked > 0) {\n"
"	    parity = parity ^ (masked & 1);\n"
"	    masked = masked >> 1;\n"
"	  }\n"
"	  /* Exclusive-or with the input */\n"
"	  parity = parity ^ ($ref(input) != 0);\n"
"	  $ref(output) = parity;\n"
"	  /* Put the parity bit into the shift register */\n"
"	  $ref(shiftReg) = reg + parity;\n");

CGCScrambler::CGCScrambler ()
{
	setDescriptor("Scramble the input bit sequence using a feedback shift register.\nThe taps of the feedback shift register are given by the \"polynomial\"\nparameter, which should be a positive integer.  The n-th bit of this\ninteger indicates whether the n-th tap of the delay line is fed back.\nThe low-order bit is called the 0-th bit, and should always be set.\nThe next low-order bit indicates whether the output of the first delay\nshould be fed back, etc.  The default \"polynomial\" is an octal number\ndefining the V.22bis scrambler. For an explanation of scramblers, see\nLee and Messerschmitt, Digital Communication, Second Edition,\nKluwer Academic Publishers, 1994, pp 595-603.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(polynomial.setState("polynomial",this,"0440001","generator polynomial for the maximal length shift register"));
	addState(shiftReg.setState("shiftReg",this,"0","the shift register"));


}

void CGCScrambler::setup() {
# line 140 "CGCScrambler.pl"
// Should check that generator polynomial does not exceed 31 bits. How?
	  // To avoid sign extension problems, the hob must be zero
	  if (int(polynomial) < 0) {
	    Error::abortRun(*this,"Sorry, the polynomial must be a positive integer.");
	    return;
	  }
}

void CGCScrambler::go() {
# line 165 "CGCScrambler.pl"
addCode(scramble);
}

// prototype instance for known block list
static CGCScrambler proto;
static RegisterBlock registerBlock(proto,"Scrambler");
