static const char file_id[] = "CGCSelect.pl";
// .cc file generated from CGCSelect.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCSelect.h"

const char *star_nm_CGCSelect = "CGCSelect";

const char* CGCSelect :: className() const {return star_nm_CGCSelect;}

ISA_FUNC(CGCSelect,CGCStar);

Block* CGCSelect :: makeNew() const { LOG_NEW; return new CGCSelect;}

CGCSelect::CGCSelect ()
{
	setDescriptor("This star requires a BDF scheduler!\n\nIf the value on the 'control' line is nonzero, trueInput\nis copied to the output; otherwise, falseInput is.");
	addPort(trueInput.setPort("trueInput",this,ANYTYPE));
	addPort(falseInput.setPort("falseInput",this,ANYTYPE));
	falseInput.inheritTypeFrom(trueInput);
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(trueInput);


}

int CGCSelect::myExecTime() {
# line 61 "CGCSelect.pl"
return 0;
}

void CGCSelect::setup() {
# line 45 "CGCSelect.pl"
// all connected buffers must be size 1, for now.
		// need to check this.
		// FIXME: we can permit output to be > 1 by generating
		// a copy of the (shared) input buffer to the output.
		if (notone(output) || notone(trueInput) ||
		    notone(falseInput) || notone(control))
			Error::abortRun(*this,
		"Non-unity buffers connected to a Select not yet supported");
		else {
			// make all the buffers overlap.
			output.embed(trueInput,0);
			output.embed(falseInput,0);
			trueInput.setRelation(DF_TRUE,&control);
			falseInput.setRelation(DF_FALSE,&control);
		}
}


int CGCSelect::notone (CGCPortHole& port)
{
# line 40 "CGCSelect.pl"
return (port.numInitDelays() > 1 ||
				port.far()->numXfer() > 1);
}


// prototype instance for known block list
static CGCSelect proto;
static RegisterBlock registerBlock(proto,"Select");
