static const char file_id[] = "CGCSubFix.pl";
// .cc file generated from CGCSubFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCSubFix.h"

const char *star_nm_CGCSubFix = "CGCSubFix";

const char* CGCSubFix :: className() const {return star_nm_CGCSubFix;}

ISA_FUNC(CGCSubFix,CGCFix);

Block* CGCSubFix :: makeNew() const { LOG_NEW; return new CGCSubFix;}

CGCSubFix::CGCSubFix ()
{
	setDescriptor("Output as a fixed-point number the \"pos\" input minus all \"neg\" inputs.");
	addPort(pos.setPort("pos",this,FIX));
	addPort(neg.setPort("neg",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag indicating whether or not to use the precision of the arriving particles\n(the \"pos\" input and the \"neg\" inputs) as they are:  YES processes them\nunaltered, and NO casts them to the precision specified by the\nparameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the \"neg\" input in bits.\nThe input particles are only cast to this precision if the\nparameter \"ArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the difference\nof the inputs.\nWhen the value of the accumulation extends outside of the precision,\nthe output is set to its maximum value (or minimum for negative\nmagnitudes)."));
	addState(index.setState("index",this,"1","index for multiple input trace",
# line 69 "CGCSubFix.pl"
A_NONSETTABLE|A_NONCONSTANT));

# line 73 "CGCSubFix.pl"
noInternalState();
}

void CGCSubFix::setup() {
# line 77 "CGCSubFix.pl"
if (!int(ArrivingPrecision)) {
		    pos.setPrecision(InputPrecision);
		    neg.setPrecision(InputPrecision);
		}
		output.setPrecision(OutputPrecision);
}

void CGCSubFix::go() {
# line 85 "CGCSubFix.pl"
// insert code to clear overflow flag
		CGCFix::clearOverflow();

		// avoid FIX_Assign if possible
		if (neg.numberPorts() == 1)
	{ StringList _str_; _str_ << 
"	FIX_Sub($ref(output), $ref(pos),$ref(neg#1));\n"
;
	 addCode(_str_); }

		else {
			// initialize sum
	{ StringList _str_; _str_ << 
"	FIX_Assign($ref(output),$ref(pos));\n"
;
	 addCode(_str_); }

			for (int i=1; i <= neg.numberPorts(); i++) {
			    index = i;
	{ StringList _str_; _str_ << 
"	FIX_Sub($ref(output), $ref(output),$ref(neg#index));\n"
;
	 addCode(_str_); }
			}
		}

		// insert code to test overflow flag
		CGCFix::checkOverflow();
}

// prototype instance for known block list
static CGCSubFix proto;
static RegisterBlock registerBlock(proto,"SubFix");
