static const char file_id[] = "CGCSunSound.pl";
// .cc file generated from CGCSunSound.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCSunSound.h"
#include "compat.h"

const char *star_nm_CGCSunSound = "CGCSunSound";

const char* CGCSunSound :: className() const {return star_nm_CGCSunSound;}

ISA_FUNC(CGCSunSound,CGCPCMwrite);

Block* CGCSunSound :: makeNew() const { LOG_NEW; return new CGCSunSound;}

CodeBlock CGCSunSound :: declarations (
# line 37 "CGCSunSound.pl"
"        unsigned $starSymbol(count);\n");

CodeBlock CGCSunSound :: globals (
# line 41 "CGCSunSound.pl"
"	int $starSymbol(ctlfile);\n");

CodeBlock CGCSunSound :: openFile (
# line 45 "CGCSunSound.pl"
"	/* Open control device. */\n"
"	if (($starSymbol(ctlfile) = open(\"/dev/audioctl\",O_RDWR,0777)) == -1) {\n"
"		perror(\"/dev/audioctl\");\n"
"		exit(1);\n"
"	}\n"
"        $starSymbol(count) = 0;\n");

CodeBlock CGCSunSound :: closeFile (
# line 54 "CGCSunSound.pl"
"	/* Close control device. */\n"
"	if (close($starSymbol(ctlfile)) != 0) {\n"
"	    perror(\"/dev/audioctl\");\n"
"	    exit(1);\n"
"	}\n");

CodeBlock CGCSunSound :: sync (
# line 62 "CGCSunSound.pl"
"        {\n"
"        audio_info_t info;\n"
"	/* Wait for some samples to drain */\n"
"	do {\n"
"	    /* the cast below is to prevent warnings */\n"
"            ioctl($starSymbol(file), AUDIO_GETINFO, (caddr_t)(&info));\n"
"        } while ((int) ($starSymbol(count) - info.play.samples) > $val(aheadLimit));\n"
"        $starSymbol(count) += $val(blockSize);\n"
"        }\n");

CodeBlock CGCSunSound :: setvDef (
# line 74 "CGCSunSound.pl"
"        /* The following function should really be shared among */\n"
"        /* all instances of the star.  Moreover, the star should */\n"
"        /* request notification of changes in the I/O status, and */\n"
"        /* should adjust its slider accordingly. */\n"
"        static void $starSymbol(setv) () {\n"
"            audio_info_t info;\n"
"\n"
"            AUDIO_INITINFO(&info);\n"
"            info.play.gain = AUDIO_MAX_GAIN*$ref(volume)/100;\n"
"            ioctl($starSymbol(ctlfile), AUDIO_SETINFO, (caddr_t)(&info));\n"
"        }\n");

CGCSunSound::CGCSunSound ()
{
	setDescriptor("Convert input to mu-law PCM and write to the Sun audio port /dev/audio.\nThe input is expected to be in the range from -1.0 to 1.0.\nIf the \"aheadLimit\" parameter is non-negative, then it specifies\nthe maximum number of samples that the program will be allowed to compute\nahead of real-time.");
	addState(volume.setState("volume",this,"25","The volume of the audio output (percent of full volume).",
# line 27 "CGCSunSound.pl"
A_GLOBAL));
	addState(aheadLimit.setState("aheadLimit",this,"-1","If non-negative, the number of samples ahead that can computed."));


}

int CGCSunSound::myExecTime() {
# line 130 "CGCSunSound.pl"
return 100;  /* unreliable data */
}

void CGCSunSound::wrapup() {
# line 125 "CGCSunSound.pl"
CGCPCMwrite::wrapup();
	addCode(closeFile);
}

void CGCSunSound::initCode() {
# line 95 "CGCSunSound.pl"
CGCPCMwrite::initCode();

	addInclude("<unistd.h>");
	addInclude("<sys/ioctl.h>");
// FIXME: Hack alert: The following is not entirely satisfactory,
// since the generated code may not be compiled on the same platform
// that this star is compiled on, and Sun, unfortunately, decided to
// put this file in two different places on their two O/S's. 
#if defined(PTSUN4)  && !defined(PTSOL2_CFRONT)
	addInclude("<sun/audioio.h>");
#else
	addInclude("<sys/audioio.h>");
#endif
	addDeclaration(declarations);
        addGlobal(globals);

	addCode(openFile);
        addProcedure(setvDef);

        // update state volume
        addCode("$starSymbol(setv) ();\n");
}

void CGCSunSound::setup() {
# line 89 "CGCSunSound.pl"
fileName.clearAttributes(A_SETTABLE);
	CGCPCMwrite::setup();
}

void CGCSunSound::go() {
# line 119 "CGCSunSound.pl"
addCode(convert);
	if ((int)aheadLimit >= 0 ) addCode(sync);
	addCode(write);
}

// prototype instance for known block list
static CGCSunSound proto;
static RegisterBlock registerBlock(proto,"SunSound");
