static const char file_id[] = "CGCSwitch.pl";
// .cc file generated from CGCSwitch.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCSwitch.h"

const char *star_nm_CGCSwitch = "CGCSwitch";

const char* CGCSwitch :: className() const {return star_nm_CGCSwitch;}

ISA_FUNC(CGCSwitch,CGCStar);

Block* CGCSwitch :: makeNew() const { LOG_NEW; return new CGCSwitch;}

CGCSwitch::CGCSwitch ()
{
	setDescriptor("This star requires a BDF scheduler.\nSwitches input events to one of two outputs, depending on\nthe value of the control input.  If control is true, the\nvalue is written to trueOutput; otherwise it is written to\nfalseOutput.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(trueOutput.setPort("trueOutput",this,ANYTYPE));
	trueOutput.inheritTypeFrom(input);
	addPort(falseOutput.setPort("falseOutput",this,ANYTYPE));
	falseOutput.inheritTypeFrom(input);

# line 37 "CGCSwitch.pl"
trueOutput.setRelation(DF_TRUE, &control);
		falseOutput.setRelation(DF_FALSE, &control);
}

int CGCSwitch::myExecTime() {
# line 66 "CGCSwitch.pl"
return 0;
}

void CGCSwitch::setup() {
# line 50 "CGCSwitch.pl"
// all connected buffers must be size 1, for now.
		// need to check this.
		// FIXME: we can permit input to be > 1 by generating
		// a copy of the input buffer to the (shared) output.
		if (notone(input) || notone(trueOutput) ||
		    notone(falseOutput) || notone(control))
			Error::abortRun(*this,
		"Non-unity buffers connected to a switch not yet supported");
		else {
			// make all the buffers overlap.
			input.embed(trueOutput,0);
			input.embed(falseOutput,0);
			trueOutput.setRelation(DF_TRUE, &control);
			falseOutput.setRelation(DF_FALSE, &control);
		}
}


int CGCSwitch::notone (CGCPortHole& port)
{
# line 45 "CGCSwitch.pl"
return (port.numInitDelays() > 1 ||
				port.far()->numXfer() > 1);
}


// prototype instance for known block list
static CGCSwitch proto;
static RegisterBlock registerBlock(proto,"Switch");
