static const char file_id[] = "CGCTest.pl";
// .cc file generated from CGCTest.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCTest.h"

const char *star_nm_CGCTest = "CGCTest";

const char* CGCTest :: className() const {return star_nm_CGCTest;}

ISA_FUNC(CGCTest,CGCStar);

Block* CGCTest :: makeNew() const { LOG_NEW; return new CGCTest;}

CodeBlock CGCTest :: decl (
# line 99 "CGCTest.pl"
"		int result;\n");

CodeBlock CGCTest :: crossings (
# line 102 "CGCTest.pl"
"		$ref(output) = ( $ref(prevResult) != result );\n"
"		$ref(prevResult) = result;\n");

# line 79 "CGCTest.pl"
#define EQID "=="
#define NEID "!="
#define GTID ">"
#define GEID ">="

CGCTest::CGCTest ()
{
	setDescriptor("This star compares its two inputs \"upper\" and \"lower\".\nThe test \"condition\" can be any one of {EQ NE GT GE},\nor equivalently any one of {== != > >=},\nwhose elements represent the binary operations of equals, not equals,\ngreater than, and greater than or equals, respectively.\n\nIf the \"crossingsOnly\" parameter is TRUE, then the output is TRUE only\nwhen the outcome of the test changes from TRUE to FALSE\nor FALSE to TRUE.\nIn this case, the first output is always TRUE.");
	addPort(upper.setPort("upper",this,FLOAT));
	addPort(lower.setPort("lower",this,FLOAT));
	addPort(output.setPort("output",this,INT));
	addState(condition.setState("condition",this,"EQ","The test condition, i.e, one of EQ, NE, LT, or LE."));
	addState(crossingsOnly.setState("crossingsOnly",this,"FALSE","If TRUE, outputs are TRUE only when the sense of the test changes."));
	addState(prevResult.setState("prevResult",this,"-1","Initial value indicates that prevResult has not yet gotten the result of a\ntest.  This ensures that the first test result will always be TRUE.",
# line 73 "CGCTest.pl"
A_NONCONSTANT|A_NONSETTABLE));

# line 85 "CGCTest.pl"
noInternalState();
}

void CGCTest::setup() {
# line 88 "CGCTest.pl"
const char* cn = condition;
		if ( strcasecmp(cn, "EQ") == 0) test = EQID;
		else if ( strcasecmp(cn, "NE") == 0 ) test = NEID;
		else if ( strcasecmp(cn, "GT") == 0 ) test = GTID;
		else if ( strcasecmp(cn, "GE") == 0 ) test = GEID;
		else if ( strcasecmp(cn, "==") == 0 ) test = EQID;
		else if ( strcasecmp(cn, "!=") == 0 ) test = NEID;
		else if ( strcasecmp(cn, ">") == 0 ) test = GTID;
		else if ( strcasecmp(cn, ">=") == 0 ) test = GEID;
		else Error::abortRun(*this, "Unrecognized test.");
}

void CGCTest::go() {
# line 107 "CGCTest.pl"
StringList compare = "$ref(upper) ";
		compare << test << " $ref(lower);\n";

		if ( int(crossingsOnly) ) {
			addCode(decl);
			StringList setResult = "result = ";
			setResult << compare;
			addCode(setResult);
			addCode(crossings);
		}
		else {
			StringList simpleCode = "$ref(output) = ";
			simpleCode << compare;
			addCode(simpleCode);
		}
}

// prototype instance for known block list
static CGCTest proto;
static RegisterBlock registerBlock(proto,"Test");
