static const char file_id[] = "CGCTrainer.pl";
// .cc file generated from CGCTrainer.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCTrainer.h"

const char *star_nm_CGCTrainer = "CGCTrainer";

const char* CGCTrainer :: className() const {return star_nm_CGCTrainer;}

ISA_FUNC(CGCTrainer,CGCStar);

Block* CGCTrainer :: makeNew() const { LOG_NEW; return new CGCTrainer;}

CGCTrainer::CGCTrainer ()
{
	setDescriptor("Passes the \"train\" input to the output for the first \"trainLength\"\nsamples, then passes the \"decision\" input to the output.  Designed\nfor use in decision feedback equalizers, but can be used for other\npurposes.");
	addState(trainLength.setState("trainLength",this,"100","Number of training samples to use"));
	addPort(train.setPort("train",this,ANYTYPE));
	addPort(decision.setPort("decision",this,ANYTYPE));
	decision.inheritTypeFrom(train);
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(train);
	addState(count.setState("count",this,"0","local variable for counting inputs",
# line 46 "CGCTrainer.pl"
A_NONSETTABLE|A_NONCONSTANT));

# line 50 "CGCTrainer.pl"
noInternalState();
}

int CGCTrainer::myExecTime() {
# line 113 "CGCTrainer.pl"
return 1;
}

void CGCTrainer::begin() {
# line 58 "CGCTrainer.pl"
// handle precisions for fix types
		if (train.resolvedType() == FIX) {

			// if the precision for the output port is not defined
			// by the successor star, the precisions of the input
			// ports are passed through to the output ports

			if (!output.precision().isValid())
				output.setAttributes(A_VARPREC);
		}
}

void CGCTrainer::setup() {
# line 54 "CGCTrainer.pl"
count = 0;
}

void CGCTrainer::go() {
# line 71 "CGCTrainer.pl"
// check for fix types
		if (train.resolvedType() == FIX) {

			// if we use variable precision representation,
			// set the precision of the output port from
			// the source
			if (output.attributes() & AB_VARPREC) {

	{ StringList _str_; _str_ << 
"	if ($ref(count) < $val(trainLength)) {\n"
"		$precision(output).len  = FIX_GetLength($ref(train));\n"
"		$precision(output).intb = FIX_GetIntBits($ref(train));\n"
"		FIX_Assign($ref(output),$ref(train));\n"
"		$ref(count)++;\n"
"	} else {\n"
"		$precision(output).len  = FIX_GetLength($ref(decision));\n"
"		$precision(output).intb = FIX_GetIntBits($ref(decision));\n"
"		FIX_Assign($ref(output),$ref(decision));\n"
"	}\n"
;
	 addCode(_str_); }

			} else {

	{ StringList _str_; _str_ << 
"	if ($ref(count) < $val(trainLength)) {\n"
"		FIX_Assign($ref(output),$ref(train));\n"
"		$ref(count)++;\n"
"	} else {\n"
"		FIX_Assign($ref(output),$ref(decision));\n"
"	}\n"
;
	 addCode(_str_); }

			}

		} else {

	{ StringList _str_; _str_ << 
"	if ($ref(count) < $val(trainLength)) {\n"
"		$ref(output) = $ref(train);\n"
"		$ref(count)++;\n"
"	} else {\n"
"		$ref(output) = $ref(decision);\n"
"	}\n"
;
	 addCode(_str_); }

		}
}

// prototype instance for known block list
static CGCTrainer proto;
static RegisterBlock registerBlock(proto,"Trainer");
