static const char file_id[] = "CGCXMgraph.pl";
// .cc file generated from CGCXMgraph.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCXMgraph.h"
#include "Target.h"

const char *star_nm_CGCXMgraph = "CGCXMgraph";

const char* CGCXMgraph :: className() const {return star_nm_CGCXMgraph;}

ISA_FUNC(CGCXMgraph,CGCStar);

Block* CGCXMgraph :: makeNew() const { LOG_NEW; return new CGCXMgraph;}

CodeBlock CGCXMgraph :: err (
# line 123 "CGCXMgraph.pl"
"    {\n"
"        fprintf(stderr,\"ERROR: cannot open output file for Xgraph star.\\n\");\n"
"	exit(1);\n"
"    }\n");

CodeBlock CGCXMgraph :: closeFile (
# line 198 "CGCXMgraph.pl"
"    for (i = 0; i < $val(numIn); i++) fclose($starSymbol(fp)[i]);\n");

CGCXMgraph::CGCXMgraph ()
{
	setDescriptor("Generate a multi-signal plot with the pxgraph program.");
	addPort(input.setPort("input",this,FLOAT));
	addState(title.setState("title",this,"X graph","Title for the plot."));
	addState(saveFile.setState("saveFile",this,"","File name for saving plottable data."));
	addState(options.setState("options",this,"-bb -tk =800x400","Command line options for the pxgraph program."));
	addState(ignore.setState("ignore",this,"0","Number of initial values to ignore."));
	addState(xUnits.setState("xUnits",this,"1.0","For labeling, horizontal increment between samples."));
	addState(xInit.setState("xInit",this,"0.0","For labeling, horizontal value of the first sample."));
	addState(numIn.setState("numIn",this,"1","numIn",
# line 69 "CGCXMgraph.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(index.setState("index",this,"0.0","index",
# line 75 "CGCXMgraph.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(ix.setState("ix",this,"0","ix",
# line 81 "CGCXMgraph.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(iy.setState("iy",this,"0","iy",
# line 87 "CGCXMgraph.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(resources.setState("resources",this,"STDIO","resources"));
	addState(count.setState("count",this,"0","Samplecounter",
# line 99 "CGCXMgraph.pl"
A_NONSETTABLE|A_NONCONSTANT));


}

int CGCXMgraph::myExecTime() {
# line 263 "CGCXMgraph.pl"
return 6 * int(numIn) + 1;
}

void CGCXMgraph::wrapup() {
# line 203 "CGCXMgraph.pl"
addCode("    { int i;\n");

		// close the files
		addCode(closeFile);

		StringList cmd;
		cmd << "( ";

		// save File
		const char* sf = saveFile;
		if (sf != NULL && *sf != 0) {
			for (int i = 0; i<int(numIn); i++) {
				cmd << "/bin/cat ";
				cmd << target()->name(); 
				cmd << "_$starSymbol(temp)" << i << " >> ";
				cmd << sf << "; /bin/echo \"\" >> " << sf;
				cmd << "; ";
			}
		}

		cmd << "pxgraph ";

		// put title on command line

		const char* ttl = title;

		if (ttl && *ttl) {
			if (strchr(ttl,'\'')) {
				cmd << "-t \"" << ttl << "\" ";
			}
			else {
				cmd << "-t '" << ttl << "' ";
			}
		}

		const char* opt = options;

		// put options on the command line
		if (opt && *opt) {
			cmd << opt << " ";
		}

		// put file names
		for (int i = 0; i < int(numIn); i++) {
			cmd << target()->name() << "_$starSymbol(temp)";
			cmd << i << " ";
		}

		// remove temporary files
		for (i = 0; i < int(numIn); i++) {
			cmd << "; /bin/rm -f " << target()->name();
			cmd << "_$starSymbol(temp)" << i;
		}

		cmd << ") &";
		StringList out = "    system(\"";
		out << sanitizeString(cmd) << "\");\n    }\n";
		addCode(out);
}

void CGCXMgraph::initCode() {
# line 108 "CGCXMgraph.pl"
StringList s;
		s << "    FILE* $starSymbol(fp)[";
		s << input.numberPorts() << "];";
                addDeclaration(s);
                addInclude("<stdio.h>");
		for (int i = 0; i < input.numberPorts(); i++) {
			StringList w = "    if(!($starSymbol(fp)[";
			w << i <<  "] = fopen(\"";
			w << target()->name() << "_$starSymbol(temp)";
			w << i << "\",\"w\")))";
			addCode(w);
			addCode(err);
		}
}

void CGCXMgraph::setup() {
# line 103 "CGCXMgraph.pl"
index = xInit;
		numIn = input.numberPorts();
}

void CGCXMgraph::go() {
# line 188 "CGCXMgraph.pl"
	{ StringList _str_; _str_ << 
"	if (++$ref(count) >= $val(ignore)) {\n"
;
	 addCode(_str_); }
		for (int i = 1; i <= int(numIn); i++) {
			ix = i;
			iy = i - 1;
	{ StringList _str_; _str_ << 
"		fprintf($starSymbol(fp)[$val(iy)],\"%g %g\\n\",$ref(index),$ref(input#ix));\n"
;
	 addCode(_str_); }
		}
	{ StringList _str_; _str_ << 
"	}\n"
"	$ref(index) += $val(xUnits);"
;
	 addCode(_str_); }

}


const char* CGCXMgraph::sanitizeString (StringList s)
{
# line 142 "CGCXMgraph.pl"
// quick implementation of a string buffer
			static class Buffer {
			   public:
				Buffer()  { buf = NULL; vsize = psize = 0; }
			// omitting the destructor since GCC 2.5.8 reports an internal
			// compiler error
			//	~Buffer() { if (buf)  free(buf); }

				void initialize() {
				    if (buf)  free(buf), buf = NULL;
				    vsize = psize = 0;
				}

				void append(char c) {
				    if (vsize >= psize)
					    buf = (char*) (buf ? realloc(buf, psize += 1024)
							       : malloc(psize += 1024));
				    buf[vsize++] = c;
				}

				operator const char* ()
				{
				    if (vsize == 0 || buf[vsize-1])
					append('\0');
				    return buf;
				}
			   private:
				// the string buffer
				char* buf;
				// virtual/physical buffer size
				int vsize, psize;
			} buffer;

			buffer.initialize();
				
			for (const char* sp=s; *sp; sp++) {
			    if (*sp == '\"')
				    buffer.append('\\');
			    buffer.append(*sp);
			}
			return (const char*) buffer;
}


// prototype instance for known block list
static CGCXMgraph proto;
static RegisterBlock registerBlock(proto,"XMgraph");
