static const char file_id[] = "CGCXgraph.pl";
// .cc file generated from CGCXgraph.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCXgraph.h"
#include "Target.h"

const char *star_nm_CGCXgraph = "CGCXgraph";

const char* CGCXgraph :: className() const {return star_nm_CGCXgraph;}

ISA_FUNC(CGCXgraph,CGCStar);

Block* CGCXgraph :: makeNew() const { LOG_NEW; return new CGCXgraph;}

CodeBlock CGCXgraph :: err (
# line 102 "CGCXgraph.pl"
"    {\n"
"        fprintf(stderr,\"ERROR: cannot open output file for Xgraph star.\\n\");\n"
"	exit(1);\n"
"    }\n");

CodeBlock CGCXgraph :: closeFile (
# line 171 "CGCXgraph.pl"
"    fclose($starSymbol(fp));\n");

CGCXgraph::CGCXgraph ()
{
	setDescriptor("Generate a plot with the pxgraph program.");
	addPort(input.setPort("input",this,FLOAT));
	addState(title.setState("title",this,"X graph","Title for the plot."));
	addState(saveFile.setState("saveFile",this,"","File to save the input to the pxgraph program."));
	addState(options.setState("options",this,"-bb -tk =800x400","Command line options for pxgraph."));
	addState(ignore.setState("ignore",this,"0","Number of initial values to ignore."));
	addState(xUnits.setState("xUnits",this,"1.0","For labeling, horizontal increment between samples."));
	addState(xInit.setState("xInit",this,"0.0","For labeling, horizontal value of the first sample."));
	addState(index.setState("index",this,"0.0","index",
# line 72 "CGCXgraph.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(resources.setState("resources",this,"STDIO","Resources required by star."));
	addState(count.setState("count",this,"0","Samplecounter",
# line 85 "CGCXgraph.pl"
A_NONSETTABLE|A_NONCONSTANT));


}

int CGCXgraph::myExecTime() {
# line 226 "CGCXgraph.pl"
return 7;
}

void CGCXgraph::wrapup() {
# line 176 "CGCXgraph.pl"
// close the files
		addCode(closeFile);

		StringList cmd;
		cmd << "( ";

		// save File
		const char* sf = saveFile;
		if (sf != NULL && *sf != 0) {
			cmd << "/bin/cat ";
			cmd << target()->name(); 
			cmd << "_$starSymbol(temp)" << " >> ";
			cmd << sf << "; /bin/echo \"\" >> " << sf << "; ";
		}

		cmd << "pxgraph ";

		// put title on command line

		const char* ttl = title;

		if (ttl && *ttl) {
			if (strchr(ttl,'\'')) {
				cmd << "-t \"" << ttl << "\" ";
			}
			else {
				cmd << "-t '" << ttl << "' ";
			}
		}

		const char* opt = options;

		// put options on the command line
		if (opt && *opt) {
			cmd << opt << " ";
		}

		// put file name
		cmd << target()->name() << "_$starSymbol(temp)";

		// remove temporary files
		cmd << "; /bin/rm -f " << target()->name();
		cmd << "_$starSymbol(temp)";

		cmd << ") &";
		StringList out = "    system(\"";
		out << sanitizeString(cmd) << "\");\n";
		addCode(out);
}

void CGCXgraph::initCode() {
# line 93 "CGCXgraph.pl"
addDeclaration("    FILE* $starSymbol(fp);");
                addInclude("<stdio.h>");
		StringList w = "    if(!($starSymbol(fp) = fopen(\"";
		w << target()->name() << "_$starSymbol(temp)";
		w << "\",\"w\")))";
		addCode(w);
		addCode(err);
}

void CGCXgraph::setup() {
# line 90 "CGCXgraph.pl"
index = xInit;
}

void CGCXgraph::go() {
# line 166 "CGCXgraph.pl"
	{ StringList _str_; _str_ << 
"	if (++$ref(count) >= $val(ignore)) \n"
"		fprintf($starSymbol(fp),\"%g %g\\n\",$ref(index),$ref(input));\n"
"	$ref(index) += $val(xUnits);"
;
	 addCode(_str_); }

}


const char* CGCXgraph::sanitizeString (StringList s)
{
# line 121 "CGCXgraph.pl"
// quick implementation of a string buffer
			static class Buffer {
			   public:
				Buffer()  { buf = NULL; vsize = psize = 0; }
			// omitting the destructor since GCC 2.5.8 reports an internal
			// compiler error
			//	~Buffer() { if (buf)  free(buf); }

				void initialize() {
				    if (buf)  free(buf), buf = NULL;
				    vsize = psize = 0;
				}

				void append(char c) {
				    if (vsize >= psize)
					    buf = (char*) (buf ? realloc(buf, psize += 1024)
							       : malloc(psize += 1024));
				    buf[vsize++] = c;
				}

				operator const char* ()
				{
				    if (vsize == 0 || buf[vsize-1])
					append('\0');
				    return buf;
				}
			   private:
				// the string buffer
				char* buf;
				// virtual/physical buffer size
				int vsize, psize;
			} buffer;

			buffer.initialize();
				
			for (const char* sp=s; *sp; sp++) {
			    if (*sp == '\"')
				    buffer.append('\\');
			    buffer.append(*sp);
			}
			return (const char*) buffer;
}


// prototype instance for known block list
static CGCXgraph proto;
static RegisterBlock registerBlock(proto,"Xgraph");
