static const char file_id[] = "CGCLMSTkPlot.pl";
// .cc file generated from CGCLMSTkPlot.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCLMSTkPlot.h"

const char *star_nm_CGCLMSTkPlot = "CGCLMSTkPlot";

const char* CGCLMSTkPlot :: className() const {return star_nm_CGCLMSTkPlot;}

ISA_FUNC(CGCLMSTkPlot,CGCLMS);

Block* CGCLMSTkPlot :: makeNew() const { LOG_NEW; return new CGCLMSTkPlot;}

CodeBlock CGCLMSTkPlot :: updateDisplay (
# line 105 "CGCLMSTkPlot.pl"
"	    if ($starSymbol(invCount)++ >= $val(updateInterval)) {\n"
"		$starSymbol(invCount) = 0;\n"
"		if(ptkSetBarGraph(interp, &w,\n"
"			    \"$starSymbol(.bar)\",\n"
"			    &$starSymbol(taps_ptr),\n"
"			    1,\n"
"			    $val(tapSize),\n"
"			    $ref(fullScale),\n"
"			    -$ref(fullScale),\n"
"			    &$starSymbol(ids_ptr)) == 0)\n"
"		    errorReport(\"Cannot update bar graph.\");\n"
"	    }\n");

CodeBlock CGCLMSTkPlot :: makeGraph (
# line 119 "CGCLMSTkPlot.pl"
"	    Tcl_CreateCommand(interp, \"$starSymbol(.bar)rescale\",\n"
"			$starSymbol(rescale),\n"
"			(ClientData) 0, (void (*)()) NULL);\n"
"	    if(ptkMakeBarGraph(interp, &w,\n"
"			 \"$starSymbol(.bar)\",	/* name of top level window */\n"
"			 \"$val(identifier)\",	/* identifying string */\n"
"			 &$starSymbol(taps_ptr),/* data to be plotted */\n"
"			 1,			/* one trace only */\n"
"			 $val(tapSize),		/* number of data points */\n"
"			 $ref(fullScale),	/* top of scale */\n"
"			 -$ref(fullScale),	/* bottom of scale */\n"
"			 &$starSymbol(ids_ptr),	/* array to store item ids */\n"
"			 \"$val(geometry)\",	/* shape and position, window*/\n"
"			 $val(width),		/* width, in cm */\n"
"			 $val(height)) == 0)\n"
"		errorReport(\"Cannot create bar chart\");\n"
"	    $starSymbol(invCount) = 0;\n"
"	    Tcl_CreateCommand(interp, \"$starSymbol(.bar)redraw\",\n"
"			$starSymbol(redraw),\n"
"			(ClientData) 0, (void (*)()) NULL);\n");

CodeBlock CGCLMSTkPlot :: makeControls (
# line 141 "CGCLMSTkPlot.pl"
"	    makeButton(\"$starSymbol(.bar).middle\",	/* location of button */\n"
"		       \"$starSymbol(reset)\",		/* name of button */\n"
"		       \"Reset taps\",			/* identifier */\n"
"		       $starSymbol(reset));		/* callback procedure */\n"
"	    {\n"
"	    int position;\n"
"	    /* Compute slider position from parameters */\n"
"	    position = 0.5 + 100*($val(stepSize)\n"
"			- $val(stepSizeLow))/($val(stepSizeHigh)\n"
"			- $val(stepSizeLow));\n"
"\n"
"	    /* Make a slider for controlling the step size */\n"
"	    makeScale(\"$starSymbol(.bar).low\",	/* location of scale */\n"
"		      \"$starSymbol(scale)\",		/* name of scale */\n"
"		      \"Step size\",			/* identifier */\n"
"		      position,				/* initial position */\n"
"		      $starSymbol(setStep));		/* callback */\n"
"\n"
"	    /* set the initial step size display */\n"
"	    displaySliderValue(\"$starSymbol(.bar).low\",\n"
"			       \"$starSymbol(scale)\",\n"
"			       \"$val(stepSize)\");\n"
"	    }\n");

CodeBlock CGCLMSTkPlot :: copyTaps (
# line 166 "CGCLMSTkPlot.pl"
"	{\n"
"	    int i;\n"
"	    for (i=0; i<$val(tapSize); i++) {\n"
"		$starSymbol(backup)[i] = $ref(taps)[i];\n"
"	    }\n"
"	}\n");

CodeBlock CGCLMSTkPlot :: procDefs (
# line 174 "CGCLMSTkPlot.pl"
"	    static int\n"
"	    $starSymbol(redraw)(dummy, interp, argc, argv)\n"
"		ClientData dummy;		   /* Not used. */\n"
"		Tcl_Interp *interp;		 /* Current interpreter. */\n"
"		int argc;			   /* Number of arguments. */\n"
"		char **argv;			/* Argument strings. */\n"
"	    {\n"
"		if(ptkSetBarGraph(interp, &w,\n"
"			    \"$starSymbol(.bar)\",\n"
"			    &$starSymbol(taps_ptr),\n"
"			    1,\n"
"			    $val(tapSize),\n"
"			    $ref(fullScale),\n"
"			    -$ref(fullScale),\n"
"			    &$starSymbol(ids_ptr)) == 0)\n"
"		    errorReport(\"Cannot redraw bar graph\");\n"
"		return TCL_OK;\n"
"	    }\n"
"\n"
"	    static int\n"
"	    $starSymbol(reset)(dummy, interp, argc, argv)\n"
"		ClientData dummy;		   /* Not used. */\n"
"		Tcl_Interp *interp;		 /* Current interpreter. */\n"
"		int argc;			   /* Number of arguments. */\n"
"		char **argv;			/* Argument strings. */\n"
"	    {\n"
"		int i;\n"
"		for (i=0; i<$val(tapSize); i++) {\n"
"		    $ref(taps)[i] = $starSymbol(backup)[i];\n"
"		}\n"
"		$starSymbol(invCount) = 0;\n"
"		return $starSymbol(redraw) (dummy, interp, argc, argv);\n"
"	    }\n"
"\n"
"	    static int\n"
"	    $starSymbol(rescale)(dummy, interp, argc, argv)\n"
"		ClientData dummy;		   /* Not used. */\n"
"		Tcl_Interp *interp;		 /* Current interpreter. */\n"
"		int argc;			   /* Number of arguments. */\n"
"		char **argv;			/* Argument strings. */\n"
"	    {\n"
"		float temp;\n"
"		if(sscanf(argv[1], \"%4f\", &temp) != 1) {\n"
"		    Tcl_AppendResult(interp,\n"
"			\"Cannot reset full scale in bar graph\",(char*) NULL);\n"
"		    return TCL_ERROR;\n"
"		}\n"
"		$ref(fullScale) = $ref(fullScale) * temp;\n"
"		/* Return new full scale value to tcl */\n"
"		sprintf(interp->result, \"%f -%f\",\n"
"		    $ref(fullScale), $ref(fullScale));\n"
"		return TCL_OK;\n"
"	    }\n"
"\n"
"	    static int\n"
"	    $starSymbol(setStep)(dummy, interp, argc, argv)\n"
"		ClientData dummy;		   /* Not used. */\n"
"		Tcl_Interp *interp;		 /* Current interpreter. */\n"
"		int argc;			   /* Number of arguments. */\n"
"		char **argv;			/* Argument strings. */\n"
"	    {\n"
"		int position;\n"
"		static char buf[20];\n"
"\n"
"		if(sscanf(argv[1], \"%d\", &position) != 1) {\n"
"		    errorReport(\"Invalid value for step size\");\n"
"		    return TCL_ERROR;\n"
"		}\n"
"		$ref(stepSize) = $val(stepSizeLow)\n"
"		    + ($val(stepSizeHigh) - $val(stepSizeLow))\n"
"		    * (position/100.0);\n"
"\n"
"		/* set the step size display */\n"
"		sprintf(buf, \"%.4f\", $ref(stepSize));\n"
"		displaySliderValue(\"$starSymbol(.bar).low\",\n"
"				   \"$starSymbol(scale)\",\n"
"				   buf);\n"
"		return TCL_OK;\n"
"	    }\n");

CGCLMSTkPlot::CGCLMSTkPlot ()
{
	setDescriptor("Just like the LMS filter, but with an animated Tk display of\nthe taps, plus associated controls.");
	addState(stepSizeLow.setState("stepSizeLow",this,"0.0","Low end of the step size scale"));
	addState(stepSizeHigh.setState("stepSizeHigh",this,"0.1","High end of the step size scale"));
	addState(fullScale.setState("fullScale",this,"1.0","Full scale on the tap display",
# line 36 "CGCLMSTkPlot.pl"
A_GLOBAL));
	addState(geometry.setState("geometry",this,"+500+000","Specified the location and/or size of the window"));
	addState(width.setState("width",this,"10.0","Width of the bar chart display, in centimeters"));
	addState(height.setState("height",this,"5.0","Height of the bar chart display, in centimeters"));
	addState(identifier.setState("identifier",this,"LMS filter taps","The string to identify the run-time display."));
	addState(updateInterval.setState("updateInterval",this,"10","Number of invocations between display updates."));


}

void CGCLMSTkPlot::initCode() {
# line 74 "CGCLMSTkPlot.pl"
// definite prototypes for ptkMakeBarGraph and ptkSetBarGraph
	    addInclude("\"ptkBarGraph.h\"");

	    addGlobal("int $starSymbol(invCount);");
	    addGlobal("int $starSymbol(ids)[$val(tapSize)];");

	    // define a pointer to the taps, for compatibility with
	    // the bar chart routines
	    addGlobal("double* $starSymbol(taps_ptr);");
	    addGlobal("int* $starSymbol(ids_ptr);");
	    addCode("$starSymbol(taps_ptr) = $ref(taps);","tkSetup");
	    addCode("$starSymbol(ids_ptr) = $starSymbol(ids);","tkSetup");

	    // initialize backup values to equal taps initial values.
	    addGlobal("double $starSymbol(backup)[$val(tapSize)] = { ");
	    StringList initvalues;
	    for (int i = 0; i < taps.size()-1; i++) {
		initvalues << taps[i] << ", ";
	    }
	    initvalues << taps[taps.size()-1] << "};";
	    addGlobal(initvalues);
	    addCode(makeGraph,"tkSetup");
	    addCode(makeControls,"tkSetup");
	    addCode(procDefs,"procedure");
	    CGCLMS :: initCode();
	    addCode(copyTaps);
}

void CGCLMSTkPlot::setup() {
# line 69 "CGCLMSTkPlot.pl"
taps.setAttributes(A_GLOBAL);
	    stepSize.setAttributes(A_GLOBAL);
	    CGCLMS::setup();
}

void CGCLMSTkPlot::go() {
# line 102 "CGCLMSTkPlot.pl"
CGCLMS :: go();
	    addCode(updateDisplay);
}

// prototype instance for known block list
static CGCLMSTkPlot proto;
static RegisterBlock registerBlock(proto,"LMSTkPlot");
