static const char file_id[] = "CGCTclScript.pl";
// .cc file generated from CGCTclScript.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCTclScript.h"

const char *star_nm_CGCTclScript = "CGCTclScript";

const char* CGCTclScript :: className() const {return star_nm_CGCTclScript;}

ISA_FUNC(CGCTclScript,CGCStar);

Block* CGCTclScript :: makeNew() const { LOG_NEW; return new CGCTclScript;}

CodeBlock CGCTclScript :: setUniqueSymbol (
# line 206 "CGCTclScript.pl"
"	    if(Tcl_Eval(interp, \"global uniqueSymbol; set uniqueSymbol $starSymbol(tkScript)\")\n"
"		!= TCL_OK)\n"
"		errorReport(\"Error accessing tcl\");\n");

CodeBlock CGCTclScript :: declareSetOutputs (
# line 211 "CGCTclScript.pl"
"	    Tcl_CreateCommand(interp, \"$starSymbol(tkScript)setOutputs\",\n"
"		$starSymbol(setOutputs), (ClientData) 0, NULL);\n");

CodeBlock CGCTclScript :: declareGrabInputs (
# line 215 "CGCTclScript.pl"
"	    Tcl_CreateCommand(interp, \"$starSymbol(tkScript)grabInputs\",\n"
"		$starSymbol(grabInputs), (ClientData) 0, NULL);\n");

const char* CGCTclScript :: exportState(const char* name, const char* value) {
# line 219 "CGCTclScript.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	    if(Tcl_Eval(interp, \n"
"                \"set $starSymbol(tkScript)(" << (name) << ") {" << (value) << "}\") != TCL_OK)\n"
"		errorReport(\"Cannot initialize state " << (name) << "\");\n";
	return (const char*)_str_;
}

CodeBlock CGCTclScript :: sourceTclwEnv (
# line 224 "CGCTclScript.pl"
"	    if(Tcl_Eval(interp, \"source [expandEnvVars \\\\$val(tcl_file)]\")\n"
"		!= TCL_OK)\n"
"		errorReport(\"Cannot source tcl script for TclScript star\");\n");

CodeBlock CGCTclScript :: sourceTclwoEnv (
# line 229 "CGCTclScript.pl"
"	    if(Tcl_Eval(interp, \"source [expandEnvVars $val(tcl_file)]\")\n"
"		!= TCL_OK)\n"
"		errorReport(\"Cannot source tcl script for TclScript star\");\n");

CodeBlock CGCTclScript :: callTcl (
# line 234 "CGCTclScript.pl"
"	    if(Tcl_Eval(interp, \"$starSymbol(tkScript)callTcl\") != TCL_OK)\n"
"		errorReport(\"Error invoking callTcl\");\n");

CodeBlock CGCTclScript :: setOutputsDef (
# line 241 "CGCTclScript.pl"
"	    static int\n"
"            $starSymbol(setOutputs)(dummy, interp, argc, argv)\n"
"                ClientData dummy;                   /* Not used. */\n"
"                Tcl_Interp *interp;                 /* Current interpreter. */\n"
"                int argc;                           /* Number of arguments. */\n"
"                char **argv;                        /* Argument strings. */\n"
"            {\n"
"		int i;\n"
"		if(argc != $ref(numOutputs)+1) {\n"
"                    /* Ignore -- probably premature */\n"
"                    return TCL_OK;\n"
"		}\n"
"		for(i=0; i<$ref(numOutputs); i++) {\n"
"                    if(sscanf(argv[i+1], \"%f\", &$starSymbol(outs)[i]) != 1) {\n"
"                        errorReport(\"Invalid value\");\n"
"                        return TCL_ERROR;\n"
"                    }\n"
"		}\n"
"                return TCL_OK;\n"
"            }\n");

CodeBlock CGCTclScript :: grabInputsDef (
# line 266 "CGCTclScript.pl"
"	    static int\n"
"            $starSymbol(grabInputs)(dummy, interp, argc, argv)\n"
"                ClientData dummy;                   /* Not used. */\n"
"                Tcl_Interp *interp;                 /* Current interpreter. */\n"
"                int argc;                           /* Number of arguments. */\n"
"                char **argv;                        /* Argument strings. */\n"
"            {\n"
"		/* FIX ME: Is 32 always enough? */\n"
"		static char temp[32];\n"
"		int i;\n"
"		for(i=0; i<$val(numInputs); i++) {\n"
"                    sprintf(temp, \"%f\", $starSymbol(ins)[i]);\n"
"		    Tcl_AppendElement(interp,temp);\n"
"		}\n"
"                return TCL_OK;\n"
"            }\n");

CGCTclScript::CGCTclScript ()
{
	setDescriptor("Sends input values to a Tcl script.  Gets output values from a Tcl script.\nThe star can communicate with Tcl either synchronously or asynchronously.");
	addPort(output.setPort("output",this,FLOAT));
	addPort(input.setPort("input",this,FLOAT));
	addState(tcl_file.setState("tcl_file",this,"$PTOLEMY/src/domains/cgc/tcltk/stars/tkScript.tcl","The file from which to read the tcl script"));
	addState(synchronous.setState("synchronous",this,"TRUE","If TRUE, tcl procedure '${uniqueSymbol}callTcl' is called on every firing"));
	addState(numOutputs.setState("numOutputs",this,"0","numOutputs",
# line 108 "CGCTclScript.pl"
A_NONCONSTANT|A_NONSETTABLE|A_GLOBAL));
	addState(numInputs.setState("numInputs",this,"0","numInputs",
# line 114 "CGCTclScript.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(temp.setState("temp",this,"0","temp",
# line 120 "CGCTclScript.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void CGCTclScript::initCode() {
# line 123 "CGCTclScript.pl"
addCode(setUniqueSymbol,"tkSetup");

            // Export the environment variables
            BlockStateIter nextState(*this);
            State* state;
            while ((state = nextState++) !=NULL ) {
		// It would be good to be able to use the Tokenizer
		// class here - but we can because it strips out " characters
		// FIXME

		// We escape $ with $$ and " with \".
		// $ is escaped so that the expandMacro
		// code will ignore embedded $ in state values.
		// " is escaped so that we can embed the entire string
	        // in "" in CGCTclScript::exportState

                StringList currentValue;
		currentValue = state->currentValue();
		const char* p = currentValue;
		StringList escapedCurrentValue;
		while (*p) {
		    if (*p == '\"') escapedCurrentValue << '\\';
                    else if (*p == '$') escapedCurrentValue << '$';
                    escapedCurrentValue << *p;
                    p++;
                }

                addCode(exportState(state->name(),escapedCurrentValue),
                        "tkSetup");
            }

            // Create setOutputs tcl command
	    numOutputs = output.numberPorts();
	    if (numOutputs > 0) {
		addCode(declareSetOutputs,"tkSetup");
		addCode(setOutputsDef, "procedure");
	    }

            // Create setInputs tcl command
	    numInputs = input.numberPorts();
	    if (numInputs > 0) {
		addCode(declareGrabInputs,"tkSetup");
		addCode(grabInputsDef, "procedure");
	    }

            // Source the specified shell script
	    if(((const char*)tcl_file)[0] == '$') {
	        addCode(sourceTclwEnv, "tkSetup");
	    } else {
	        addCode(sourceTclwoEnv, "tkSetup");
	    }

	    StringList out;
	    if (int(numOutputs) > 0)
	        out << "\tfloat $starSymbol(outs)[" << int(numOutputs)
                    << "];\n";
	    if (int(numInputs) > 0)
	        out << "\tfloat $starSymbol(ins)[" << int(numInputs) << "];\n";
	    addGlobal((const char*) out);
	    if(!int(synchronous)) {
		addCode(setUniqueSymbol);
		addCode(callTcl);
	    }
}

void CGCTclScript::go() {
# line 188 "CGCTclScript.pl"
StringList out;
	    for (int i = 1; i <= input.numberPorts(); i++) {
		temp = i;
		out << "\t$starSymbol(ins)[" << i-1 << "] = $ref(input#temp);\n";
	        addCode((const char*) out);
		out.initialize();
	    }
	    if(int(synchronous)) {
		addCode(setUniqueSymbol);
		addCode(callTcl);
	    }
	    for (i = 1; i <= output.numberPorts(); i++) {
		temp = i;
		out << "\t$ref(output#temp) = $starSymbol(outs)[" << i-1 << "];\n";
	        addCode((const char*) out);
		out.initialize();
	    }
}

// prototype instance for known block list
static CGCTclScript proto;
static RegisterBlock registerBlock(proto,"TclScript");
