static const char file_id[] = "CGCTkImpulse.pl";
// .cc file generated from CGCTkImpulse.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCTkImpulse.h"

const char *star_nm_CGCTkImpulse = "CGCTkImpulse";

const char* CGCTkImpulse :: className() const {return star_nm_CGCTkImpulse;}

ISA_FUNC(CGCTkImpulse,CGCStar);

Block* CGCTkImpulse :: makeNew() const { LOG_NEW; return new CGCTkImpulse;}

CodeBlock CGCTkImpulse :: nosync (
# line 50 "CGCTkImpulse.pl"
"	    $ref(output) = $ref(level);\n"
"	    $ref(level) = 0.0;\n");

CodeBlock CGCTkImpulse :: sync (
# line 54 "CGCTkImpulse.pl"
"	    while ($ref(level) != $val(level)) {\n"
"	      /* The following will sleep until there is an event to process */\n"
"	      Tk_DoOneEvent(0);\n"
"	    }\n"
"	    $ref(output) = $ref(level);\n"
"	    /* Use level as a flag to */\n"
"	    $ref(level) = $val(level) - 1.0;\n");

CodeBlock CGCTkImpulse :: tkSetup (
# line 64 "CGCTkImpulse.pl"
"	    /* Establish the Tk button */\n"
"	    makeButton(\".middle\",	/* location in the control panel */\n"
"		       \"$starSymbol(button)\",	/* name of the button */\n"
"		       \"$val(identifier)\",	/* label on the button */\n"
"		       $starSymbol(pulse));	/* callback procedure */\n");

CodeBlock CGCTkImpulse :: pulseDef (
# line 71 "CGCTkImpulse.pl"
"	    static int\n"
"	    $starSymbol(pulse)(dummy, interp, argc, argv)\n"
"                ClientData dummy;                   /* Not used. */\n"
"                Tcl_Interp *interp;                 /* Current interpreter. */\n"
"                int argc;                           /* Number of arguments. */\n"
"                char **argv;                        /* Argument strings. */\n"
"            {\n"
"                $ref(level) = $val(level);\n"
"                return TCL_OK;\n"
"            }\n");

CGCTkImpulse::CGCTkImpulse ()
{
	setDescriptor("Output a specified value when a button is pushed.\nOptionally synchronize by halting until the button is pushed.");
	addPort(output.setPort("output",this,FLOAT));
	addState(level.setState("level",this,"1.0","The height of the impulse.",
# line 26 "CGCTkImpulse.pl"
A_GLOBAL));
	addState(identifier.setState("identifier",this,"Impulse","The string to identify the slider in the control panel."));
	addState(synchronize.setState("synchronize",this,"NO","Halt until the user presses the button."));


}

void CGCTkImpulse::initCode() {
# line 42 "CGCTkImpulse.pl"
addCode(tkSetup,"tkSetup");
	    addCode(pulseDef, "procedure");
	    addCode("$ref(level) = 0.0;");
}

void CGCTkImpulse::go() {
# line 47 "CGCTkImpulse.pl"
if (int(synchronize)) addCode(sync);
	  else addCode(nosync);
}

// prototype instance for known block list
static CGCTkImpulse proto;
static RegisterBlock registerBlock(proto,"TkImpulse");
