static const char file_id[] = "CGCTkPlot.pl";
// .cc file generated from CGCTkPlot.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCTkPlot.h"

const char *star_nm_CGCTkPlot = "CGCTkPlot";

const char* CGCTkPlot :: className() const {return star_nm_CGCTkPlot;}

ISA_FUNC(CGCTkPlot,CGCTkXYPlot);

Block* CGCTkPlot :: makeNew() const { LOG_NEW; return new CGCTkPlot;}

const char* CGCTkPlot :: updateDisplay(int setnum) {
# line 75 "CGCTkPlot.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	  if (ptkPlotPoint(interp, &$starSymbol(plotwin), " << (setnum) << ",\n"
"			   $starSymbol(sampleCount), $ref(Y#" << (setnum) << ")) == 0) {\n"
"	    errorReport(\"in TkPlot, error plotting data point\");\n"
"	  }\n";
	return (const char*)_str_;
}

const char* CGCTkPlot :: breakLine(int setnum) {
# line 81 "CGCTkPlot.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	  ptkPlotBreak(interp, &$starSymbol(plotwin), " << (setnum) << ");\n";
	return (const char*)_str_;
}

CGCTkPlot::CGCTkPlot ()
{
	setDescriptor("Plot Y input(s) vs. time with dynamic updating.\nTwo styles are currently supported: \"dot\" causes\nindividual points to be plotted, whereas \"connect\" causes\nconnected lines to be plotted. Drawing a box in the plot\nwill reset the plot area to that outlined by the box.\nThere are also buttons for zooming in and out, and for\nresizing the box to just fit the data in view.");
	addState(repeat_border_points.setState("repeat_border_points",this,"YES","For better visual continuity, rightmost events are repeated on the left"));

# line 41 "CGCTkPlot.pl"
// Change default parameter values
	  label.setInitValue("Tk Plot");
	  xTitle.setInitValue("n");
	  xRange.setInitValue("0 100");
	  style.setInitValue("connect");
	  X.setAttributes(P_HIDDEN);
}

void CGCTkPlot::initCode() {
# line 49 "CGCTkPlot.pl"
addDeclaration("double $starSymbol(sampleCount);");
	  CGCTkXYPlot::initCode();
	  addCode("$starSymbol(sampleCount) = $starSymbol(xMin);");
}

void CGCTkPlot::go() {
# line 54 "CGCTkPlot.pl"
int i;
	  for (i = 0; i < Y.numberPorts(); i++) {
	    addCode(updateDisplay(i+1));
	  }
	  addCode("$starSymbol(sampleCount) += 1.0;");
	  addCode("if ($starSymbol(sampleCount) > $starSymbol(xMax)) {");
	  addCode("$starSymbol(sampleCount) = $starSymbol(xMin);");
	  // Plot points all over again for continuity
	  for (i = 0; i < Y.numberPorts(); i++) {
	    addCode(breakLine(i+1));
	    if ((int)repeat_border_points) {
	      addCode(updateDisplay(i+1));
	    }
	  }
          if ((int)repeat_border_points) {
	      addCode("$starSymbol(sampleCount) += 1.0; }");
	  }
	  else {
	      addCode("}");
	  }
}

// prototype instance for known block list
static CGCTkPlot proto;
static RegisterBlock registerBlock(proto,"TkPlot");
