static const char file_id[] = "CGCTkSlider.pl";
// .cc file generated from CGCTkSlider.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCTkSlider.h"

const char *star_nm_CGCTkSlider = "CGCTkSlider";

const char* CGCTkSlider :: className() const {return star_nm_CGCTkSlider;}

ISA_FUNC(CGCTkSlider,CGCStar);

Block* CGCTkSlider :: makeNew() const { LOG_NEW; return new CGCTkSlider;}

CodeBlock CGCTkSlider :: tkSetup (
# line 52 "CGCTkSlider.pl"
"	    /* Establish the Tk window for setting the value */\n"
"	    {\n"
"	    int position;\n"
"\n"
"	    /* compute the initial position of the slider */\n"
"	    position = 0.5 + 100*($val(value)\n"
"			- $val(low))/($val(high) - $val(low));\n"
"\n"
"	    makeScale(\".low\",			/* position in control panel */\n"
"	              \"$starSymbol(scale)\",	/* name of the scale pane */\n"
"		      \"$val(identifier)\",	/* text identifying the pane */\n"
"		      position,			/* initial position */\n"
"		      $starSymbol(setValue));	/* callback procedure */\n"
"	    }\n"
"\n"
"	    /* set the initial value display */\n"
"	    displaySliderValue(\".low\", \"$starSymbol(scale)\", \"$val(value)\");\n");

CodeBlock CGCTkSlider :: setValueDef (
# line 75 "CGCTkSlider.pl"
"	    static int\n"
"	    $starSymbol(setValue)(dummy, interp, argc, argv)\n"
"                ClientData dummy;                   /* Not used. */\n"
"                Tcl_Interp *interp;                 /* Current interpreter. */\n"
"                int argc;                           /* Number of arguments. */\n"
"                char **argv;                        /* Argument strings. */\n"
"            {\n"
"		int position;\n"
"		static char buf[20];\n"
"                if(sscanf(argv[1], \"%d\", &position) != 1) {\n"
"                    errorReport(\"Invalid value\");\n"
"                    return TCL_ERROR;\n"
"                }\n"
"		$ref(value) = $val(low) + ($val(high) - $val(low))*(position/100.0);\n"
"		/* set the value display */\n"
"		sprintf(buf, \"%.4f\", $ref(value));\n"
"		displaySliderValue(\".low\", \"$starSymbol(scale)\", buf);\n"
"                return TCL_OK;\n"
"            }\n");

CGCTkSlider::CGCTkSlider ()
{
	setDescriptor("Output a value determined by a Tk scale slider.");
	addPort(output.setPort("output",this,FLOAT));
	addState(low.setState("low",this,"0.0","The low end of the scale."));
	addState(high.setState("high",this,"1.0","The high end of the scale."));
	addState(value.setState("value",this,"0.0","The value to send to the output.",
# line 35 "CGCTkSlider.pl"
A_GLOBAL));
	addState(identifier.setState("identifier",this,"Scale","The string to identify the slider in the control panel."));


}

void CGCTkSlider::initCode() {
# line 44 "CGCTkSlider.pl"
addCode(tkSetup,"tkSetup");
	    addCode(setValueDef, "procedure");
}

void CGCTkSlider::go() {
# line 48 "CGCTkSlider.pl"
addCode("\t$ref(output) = $ref(value);\n");
}

// prototype instance for known block list
static CGCTkSlider proto;
static RegisterBlock registerBlock(proto,"TkSlider");
