static const char file_id[] = "CGCTkXYPlot.pl";
// .cc file generated from CGCTkXYPlot.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCTkXYPlot.h"

const char *star_nm_CGCTkXYPlot = "CGCTkXYPlot";

const char* CGCTkXYPlot :: className() const {return star_nm_CGCTkXYPlot;}

ISA_FUNC(CGCTkXYPlot,CGCStar);

Block* CGCTkXYPlot :: makeNew() const { LOG_NEW; return new CGCTkXYPlot;}

CodeBlock CGCTkXYPlot :: srcTclFile (
# line 123 "CGCTkXYPlot.pl"
"	  {\n"
"	    /* This ridiculosity is required because Tcl scribbles on strings */\n"
"	    static char temp[100];\n"
"	    sprintf(temp,\"source $$env(PTOLEMY)/src/ptklib/ptkPlot.tcl\");\n"
"	    if(Tcl_Eval(interp, temp) != TCL_OK)\n"
"		 errorReport(\"Cannot source tcl script for TkXYPlot star\");\n"
"	  }\n");

const char* CGCTkXYPlot :: createPlot(double xMin, double xMax, double yMin, double yMax, int numsets, int plotstyle) {
# line 133 "CGCTkXYPlot.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	  ptkInitPlot(&$starSymbol(plotwin));\n"
"	  $starSymbol(xMin) = " << (xMin) << ";\n"
"	  $starSymbol(xMax) = " << (xMax) << ";\n"
"	  if(ptkCreatePlot(interp,\n"
"			   &$starSymbol(plotwin),\n"
"			   &w,\n"
"			   \".$starSymbol(win)\",\n"
"			   \"$val(label)\",\n"
"			   \"$val(geometry)\",\n"
"			   \"$val(xTitle)\",\n"
"			   \"$val(yTitle)\",\n"
"			   " << (xMin) << "," << (xMax) << ", " << (yMin) << "," << (yMax) << ",\n"
"			   " << (numsets) << ",\n"
"			   $val(updateSize),\n"
"			   " << (plotstyle) << ",\n"
"			   $val(persistence)) == 0) {\n"
"	    errorReport(ptkPlotErrorMsg());\n"
"	  }\n";
	return (const char*)_str_;
}

const char* CGCTkXYPlot :: updateDisplay(int setnum) {
# line 153 "CGCTkXYPlot.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	  if (ptkPlotPoint(interp, &$starSymbol(plotwin), " << (setnum) << ",\n"
"			   $ref(X#" << (setnum) << "), $ref(Y#" << (setnum) << ")) == 0) {\n"
"	    errorReport(ptkPlotErrorMsg());\n"
"	  }\n";
	return (const char*)_str_;
}

CGCTkXYPlot::CGCTkXYPlot ()
{
	setDescriptor("Plot Y input(s) vs. X input(s) with dynamic updating.\nTwo styles are currently supported: \"dot\" causes\npoints to be plotted, whereas \"connect\" causes connected\nlines to be plotted. Drawing a box in the plot will\nreset the plot area to that outlined by the box.\nThere are also buttons for zooming in and out, and for\nresizing the box to just fit the data in view.\nGenerate an animated X-Y plot in a Tk window.");
	addState(label.setState("label",this,"Tk XY Plot","The label used for the icon and title names"));
	addState(geometry.setState("geometry",this,"600x400+0+0","Specified the location and/or size of the window"));
	addState(xTitle.setState("xTitle",this,"x","The x-axis label"));
	addState(yTitle.setState("yTitle",this,"y","The y-axis label"));
	addState(xRange.setState("xRange",this,"-1.5 1.5","The range of x-coordinate values"));
	addState(yRange.setState("yRange",this,"-1.5 1.5","The range of x-coordinate values"));
	addState(persistence.setState("persistence",this,"100","The number of points displayed at any one time"));
	addState(style.setState("style",this,"dot","Plot style is dot or connect"));
	addState(updateSize.setState("updateSize",this,"10","The number of points drawn simulataneously. Higher numbers make the response faster."));
	addPort(X.setPort("X",this,FLOAT));
	addPort(Y.setPort("Y",this,FLOAT));


}

void CGCTkXYPlot::initCode() {
# line 88 "CGCTkXYPlot.pl"
if (int(persistence) <= 0) {
	    Error::abortRun(*this, "invalid persistence");
	    return;
	  }
	  // Store xMin and xMax for the benefit of the line style in TkPlot
	  addGlobal("double $starSymbol(xMin);");
	  addGlobal("double $starSymbol(xMax);");

	  
	  if ((xRange.size() != 2) || (xRange[0] >= xRange[1])) {
	    Error::abortRun(*this,"xRange parameter values are invalid");
	  }
	  if ((yRange.size() != 2) || (yRange[0] >= yRange[1])) {
	    Error::abortRun(*this,"yRange parameter values are invalid");
	  }
	  addInclude("\"ptkPlot_defs.h\"");
	  addInclude("\"ptkPlot.h\"");
	  addGlobal("ptkPlotWin $starSymbol(plotwin);");
	  addGlobal("ptkPlotDataset $starSymbol(plotdataset);");

	  // This is sourced multiple times if there are multiple
	  // instances of the star.  Should this be fixed?
	  addCode(srcTclFile,"tkSetup");

	  int plotstyle = 0;
	  if (strcmp(style,"connect") == 0) plotstyle = 1;
	  addCode(createPlot(xRange[0],xRange[1],yRange[0],yRange[1],
			     Y.numberPorts(),plotstyle),
		  "tkSetup");
}

void CGCTkXYPlot::go() {
# line 119 "CGCTkXYPlot.pl"
for (int i = 0; i < X.numberPorts(); i++) {
	    addCode(updateDisplay(i+1));
	  }
}

// prototype instance for known block list
static CGCTkXYPlot proto;
static RegisterBlock registerBlock(proto,"TkXYPlot");
