.EQ
delim off
.EN
.\" documentation file generated from DDFSelf.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Self"
.SD
This is a first exploration of recursion and higher-order functions
expanded while the system is running.  This is in contrast to the
higher-order function stars like HOFChain, HOFMap, and HOFMapGr that
expand the system during compilation and incur no run-time penalty.
The DDFSelf star is still experimental, so do not expect it to be
either efficient or bug-free.

The star "represents" the galaxy given by the parameter "recurGal",
which must be above it in the hierarchy.  That is, when the Self
star fires, it actually invokes the galaxy that it represents.
Since that galaxy is above the Self star in the hierarchy, it
contains the Self star somewhere within it.  Thus, this star
implements recursion.  Since the Self star takes an argument
("recurGal") that specifies the function to invoke, it is itself
a higher-order function.

The instance of the "recurGal" galaxy is not created until it is
actually needed, so the number of instances (the depth of the
recursion) does not need to be known a-priori.  If the parameter
"reinitialize" is FALSE, then the instance of the galaxy is created
the first time it fires and reused on subsequent firings.
If "reinitialize" is TRUE, then the galaxy is created on every firing
and destroyed after the firing.  Inputs are sent to the instance
of the galaxy and outputs are retrieved from it.  The inputs of the
named galaxy must be named "input#?" and the outputs must be named
"output#?", where "?" is replaced with an integer starting with zero.
This allows the inputs and outputs of this star to be matched
unambiguously with the inputs and outputs of the referenced galaxy.
.SE
.LO "DDF library"
.DM DDF DDFStar
.SV 2.27 "3/6/96"
.AL "Soonhoi Ha and Edward A. Lee"
.IH
.NE
\fIinput\fR (multiple), (ANYTYPE): Inputs to match with galaxy ports named input#?
.PE
.OH
.NE
\fIoutput\fR (multiple), (ANYTYPE): Outputs to match with galaxy ports named input#?
.PE
.SH
.NE
\fIrecurGal\fR (StringState): Name of galaxy to be invoked.
.DF ""
.NE
\fIreinitialize\fR (IntState): Initialize the galaxy on each firing
.DF "NO"
.ET
.EQ
delim $$
.EN
.LD
Each input must have exactly one token for the star to fire.
The number of outputs produced can depend on the internal galaxy.
.pp
Creating a new instance of the galaxy is quite an expensive operation,
so setting \fIreinitialize\fR to TRUE will cause dramatically slower
execution.  Thus this should not be used unless it is absolutely necessary.
.SA
fibonnacci,
HOFChain,
HOFMap and
HOFMapGr.
.ES
