static const char file_id[] = "DDFCase.pl";
// .cc file generated from DDFCase.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DDFCase.h"

const char *star_nm_DDFCase = "DDFCase";

const char* DDFCase :: className() const {return star_nm_DDFCase;}

ISA_FUNC(DDFCase,DDFStar);

Block* DDFCase :: makeNew() const { LOG_NEW; return new DDFCase;}

DDFCase::DDFCase ()
{
	setDescriptor("Route an input particle to one of the outputs depending on the \ncontrol particle.  The control particle should have value between\nzero and N-1, inclusive, where N is the number of outputs.  It\ncan be used with EndCase to implement an if ... then construct.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE,0));
	output.inheritTypeFrom(input);


}

void DDFCase::go() {
# line 35 "DDFCase.pl"
// get Particles from Geodesic
		control.receiveData();
		input.receiveData();

		// test the current value of the control signal
		int outputNum = int(control%0);
		if ( outputNum < 0 ) {
		    Error::abortRun(*this, "control value is negative");
		    return;
		}
		else if ( outputNum >= output.numberPorts() ) {
		    Error::abortRun(*this, "control value too large");
		    return;
		}

		// read control value, and route input
		// to output depending on it.
		MPHIter nexti(output);
		for (int i = 0; i < outputNum; i++) {
		    nexti++;
		}
		OutDDFPort& oport = *(OutDDFPort *)nexti++;
		oport%0 = input%0;
		oport.sendData();
}

// prototype instance for known block list
static DDFCase proto;
static RegisterBlock registerBlock(proto,"Case");
