static const char file_id[] = "DDFEndCase.pl";
// .cc file generated from DDFEndCase.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DDFEndCase.h"

const char *star_nm_DDFEndCase = "DDFEndCase";

const char* DDFEndCase :: className() const {return star_nm_DDFEndCase;}

ISA_FUNC(DDFEndCase,DDFStar);

Block* DDFEndCase :: makeNew() const { LOG_NEW; return new DDFEndCase;}

DDFEndCase::DDFEndCase ()
{
	setDescriptor("Depending on the \"control\" particle, consume a particle from one of\nthe data inputs and send it to the output.  The control particle\nshould have value between zero and N-1, inclusive, where N is the\nnumber of data inputs.  It can be used with Case to implement an\nif ... then construct.");
	addPort(input.setPort("input",this,ANYTYPE,0));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));

# line 38 "DDFEndCase.pl"
input.inheritTypeFrom(output);
}

void DDFEndCase::setup() {
# line 41 "DDFEndCase.pl"
waitFor(control);
		readyToGo = FALSE;
}

void DDFEndCase::go() {
# line 45 "DDFEndCase.pl"
// get control Particles from Geodesic
		if (!readyToGo) control.receiveData();	

		// test value of control string
		int inputNum = int(control%0);
		if ( inputNum < 0 ) {
			Error::abortRun(*this, "control value is negative");
			return;
		}
		else if ( inputNum >= input.numberPorts() ) {
			Error::abortRun(*this, "control value is too large");
			return;
		}

		InDDFMPHIter nexti(input);
		for (int i = 0; i < inputNum; i++) {
			nexti++;
		}
		InDDFPort& iport = *(InDDFPort *)nexti++;
		if (iport.numTokens() >= iport.numXfer()) {
			iport.receiveData();
			output%0 = iport%0;
			output.sendData();
			waitFor(control);
			readyToGo = FALSE;
		}
		else {
			waitFor(iport);
			readyToGo = TRUE;
		}
}

// prototype instance for known block list
static DDFEndCase proto;
static RegisterBlock registerBlock(proto,"EndCase");
