static const char file_id[] = "DDFLastOfN.pl";
// .cc file generated from DDFLastOfN.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DDFLastOfN.h"

const char *star_nm_DDFLastOfN = "DDFLastOfN";

const char* DDFLastOfN :: className() const {return star_nm_DDFLastOfN;}

ISA_FUNC(DDFLastOfN,DDFStar);

Block* DDFLastOfN :: makeNew() const { LOG_NEW; return new DDFLastOfN;}

DDFLastOfN::DDFLastOfN ()
{
	setDescriptor("Given a control input with integer value N,\nconsume N particles from the data input and\nproduce only the last of these at the output.");
	addPort(input.setPort("input",this,ANYTYPE,0));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));

# line 35 "DDFLastOfN.pl"
output.inheritTypeFrom(input);
}

void DDFLastOfN::setup() {
# line 38 "DDFLastOfN.pl"
waitFor(control);
		readyToGo = FALSE;
}

void DDFLastOfN::go() {
# line 42 "DDFLastOfN.pl"
// get control Particles from "control" porthole
		if (!readyToGo) {
			control.receiveData();	
		}
		int num = int(control%0);
		if (input.numTokens() >= num) {
			// skip the num-1 inputs
			for (int i = num; i > 0; i--) {
				input.receiveData();
			}

			// prepare for the next round.
			waitFor(control);
			readyToGo = FALSE;

			// copy last input to output
			if (num < 1) return;
			output%0 = input%0;

			// generate output, and get ready for next firing
			output.sendData();
		} else {
			waitFor(input, num);
			readyToGo = TRUE;
		}
}

// prototype instance for known block list
static DDFLastOfN proto;
static RegisterBlock registerBlock(proto,"LastOfN");
