static const char file_id[] = "DDFThresh.pl";
// .cc file generated from DDFThresh.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.

Richard Stevens and Christopher Scannell are employees of the
U.S. Government whose contributions to this computer program fall
within the scope of 17 U.S.C. A7 105.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DDFThresh.h"

const char *star_nm_DDFThresh = "DDFThresh";

const char* DDFThresh :: className() const {return star_nm_DDFThresh;}

ISA_FUNC(DDFThresh,DDFStar);

Block* DDFThresh :: makeNew() const { LOG_NEW; return new DDFThresh;}

DDFThresh::DDFThresh ()
{
	setDescriptor("This star has only a single input, and it is dynamic.\nIt behaves like an SDF star, except that it has a threshold\nin addition to the number of tokens consumed.  The number of\ninputs available on the input arc must equal the threshold.\nTHIS STAR IS MEANT FOR TESTING SCHEDULERS ONLY. OTHERWISE,\nIT SERVES NO USEFUL FUNCTION.");
	addPort(input.setPort("input",this,ANYTYPE,0));
	addPort(output.setPort("output",this,ANYTYPE));
	addState(threshold.setState("threshold",this,"1","number of tokens needed at the input to fire."));
	addState(numconsumed.setState("numconsumed",this,"1","number of tokens consumed when star fires."));

# line 53 "DDFThresh.pl"
output.inheritTypeFrom(input);
}

void DDFThresh::begin() {
# line 68 "DDFThresh.pl"
waitFor(input, int(threshold));
}

void DDFThresh::setup() {
# line 56 "DDFThresh.pl"
if ( int(numconsumed) <= 0 ) {
			StringList msg = "Number of tokens consumed must be ";
			msg << "positive, instead of " << int(numconsumed);
			Error::abortRun(*this, msg);
		}
		if ( int(threshold) <= 0 ) {
			StringList msg = "Threshold must be ";
			msg << "positive, instead of " << int(threshold);
			Error::abortRun(*this, msg);
		}
}

void DDFThresh::go() {
# line 71 "DDFThresh.pl"
for (int i = int(numconsumed); i > 0; i--) {
			input.receiveData();
		}

		// copy last input to output
		output%0 = input%0;

		// generate output, and get ready for next firing
		output.sendData();

		waitFor(input, int(threshold));
}


const char * DDFThresh::readTypeName ()
{
# line 50 "DDFThresh.pl"
return "DownSample";
}


// prototype instance for known block list
static DDFThresh proto;
static RegisterBlock registerBlock(proto,"Thresh");
