.EQ
delim off
.EN
.\" documentation file generated from DEVoiceSrc.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "VoiceSrc"
.SD
Generates a voice process for a single caller and recognizes
.c VoiceData
prompts to begin and cease packet transmission.
.SE
.LO "DE ATM library"
.DM DE DERepeatStar
.SV 1.8 "10/23/95"
.AL "Allen Y. Lao"
.IH
.NE
\fIinput\fR (message)
.PE
.OH
.NE
\fIoutput\fR (message)
.PE
.SH
.NE
\fIpackPeriod\fR (FloatState): Voice packetization period
.DF ".016"
.NE
\fIsilenceExpMean\fR (FloatState): Exp. mean for a silence period in seconds
.DF ".650"
.NE
\fImeanPacketsSpurt\fR (IntState): Mean no. of packets per talkspurt
.DF "22"
.ET
.EQ
delim $$
.EN
.LD
This star produces dummy voice packet outputs modeling a voice process
where silence periods are exponentially distributed in length
with mean \fIsilenceExpMean\fR.  The talkspurts are geometrically
distributed with the mean number of packets per talkspurt set by the
state \fImeanPacketsSpurt\fR.  Then there is a state for the packetization
period called \fIpackPeriod\fR. Naturally, one can figure the mean duration
of a talkspurt from the \fImeanPacketsSpurt\fR and \fIpackPeriod\fR states.
Also, the packet is time-stamped and identified by connection.

It recognizes
.c VoiceData 
type input prompts: Transmit Packets
and StopTransmitPackets. Transmit packets send as info. incoming VPI,
source VCI number, and destination VCI number.  Preceding a transmission
is a Start-of-Transmission packet (SOT), and after a transmission has
been completed, an End-of-Transmission (EOT) packet is sent.
.ES
