static const char file_id[] = "DEInputSynch.pl";
// .cc file generated from DEInputSynch.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEInputSynch.h"

const char *star_nm_DEInputSynch = "DEInputSynch";

const char* DEInputSynch :: className() const {return star_nm_DEInputSynch;}

ISA_FUNC(DEInputSynch,DEStar);

Block* DEInputSynch :: makeNew() const { LOG_NEW; return new DEInputSynch;}

DEInputSynch::DEInputSynch ()
{
	setDescriptor("Synchronizes\n.c VoiceData\nmessages from input MPH to output MPH to allow\ninterfacing of a DE star to SDF-in-DE wormhole.");
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(data.setPort("data",this,MESSAGE));
	addPort(output.setPort("output",this,MESSAGE));
	addState(delay.setState("delay",this,"0.0","Delay from input to output"));

# line 59 "DEInputSynch.pl"
delayType = TRUE;
              data.triggers();
              data.before(demand);
}

void DEInputSynch::setup() {
# line 69 "DEInputSynch.pl"
Envelope  dumEnv(*new VoiceData());
	  nEnv = dumEnv;

          if (data.numberPorts() != output.numberPorts())
              Error::abortRun(*this, "Inconsistent number of i/p o/p ports");
}

void DEInputSynch::go() {
# line 78 "DEInputSynch.pl"
completionTime = arrivalTime + double(delay);
       
             InDEMPHIter nextp(data);
             InDEPort *iport;
             OutDEMPHIter nextq(output);
             OutDEPort *oport;
      
	     int  anyNewData;
	     anyNewData = FALSE;

             // if new packet arrives, then go ahead and iterate
             // through inputs and output nulls for  

             if (demand.dataNew) {

                 demand.dataNew = FALSE;

                 //  check to see if any new incoming data, if none no
	         //  need to enter the next while loop

		 while ((iport = nextp++) != 0) {
		     if (iport->dataNew)  {
			 anyNewData = TRUE;
                     }
                 }

                 if (anyNewData)  {
                     nextp.reset();

                     while ((oport = nextq++) != 0) {
                        iport = nextp++;
                        if (iport->dataNew) {
			  // pass through the waiting packet
                          oport->put(completionTime)=iport->get();
                        }
                        else {
			  // no new packet, pass through a null
                          oport->put(completionTime) << nEnv;
                        }
                     } // end while
                 }

             } // end "demand" dataNew if
}

// prototype instance for known block list
static DEInputSynch proto;
static RegisterBlock registerBlock(proto,"InputSynch");
