static const char file_id[] = "DELatency.pl";
// .cc file generated from DELatency.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

# line 3 "DELatency.pl"
#define NUMPORTS 64
#include "DELatency.h"

const char *star_nm_DELatency = "DELatency";

const char* DELatency :: className() const {return star_nm_DELatency;}

ISA_FUNC(DELatency,DEStar);

Block* DELatency :: makeNew() const { LOG_NEW; return new DELatency;}

# line 81 "DELatency.pl"
extern int voiceCheck (Envelope&, NamedObj&);

DELatency::DELatency ()
{
	setDescriptor("Measures packet traversal-time statistics for a set of traffic-\nloaded trunk lines.");
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(input.setPort("input",this,MESSAGE));
	addPort(avgLatencyAll.setPort("avgLatencyAll",this,FLOAT));
	addPort(avgLatencyIndiv.setPort("avgLatencyIndiv",this,FLOAT));
	addPort(latency.setPort("latency",this,FLOAT));
	addPort(output.setPort("output",this,MESSAGE));

# line 67 "DELatency.pl"
input.triggers(output);
	      input.triggers(latency);
	      demand.triggers(avgLatencyAll);
	      demand.triggers(avgLatencyIndiv);
	      input.before(demand);
}

void DELatency::setup() {
# line 85 "DELatency.pl"
if (input.numberPorts() != output.numberPorts()) {
              Error::abortRun(*this, "Inconsistent number of i/o ports");
	      return;
          }

          if (input.numberPorts() != latency.numberPorts()) {
              Error::abortRun(*this, "Inconsistent number of i/l ports");
	      return;
          }

          if (input.numberPorts() != avgLatencyIndiv.numberPorts()) {
              Error::abortRun(*this, "Inconsistent number of i/avg ports");
	      return;
          }

          numPorts = input.numberPorts();

          // initialize packet counts to zero for all lines
	  for (int i = 0; i < numPorts; i++) {
	      delay[i] = 0.0;
	      totalPackets[i] = 0;
          }
}

void DELatency::go() {
# line 111 "DELatency.pl"
completionTime = arrivalTime;
       
             InDEMPHIter nexti(input);
             InDEPort *iport;

             OutDEMPHIter nexto(output);
             OutDEPort *oport;

	     OutDEMPHIter nextlat(latency);
	     OutDEPort *latport;

	     OutDEMPHIter nextavg(avgLatencyIndiv);
	     OutDEPort *avgport;

	     Envelope  inEnv;
	     const VoiceData*  v;
      
	     float  del, delayTotal;
	     int  count, countTotal;
	     count = 0;
	     countTotal = 0;
	     delayTotal = 0.0;

             while ((oport = nexto++) != 0) {

                latport = nextlat++;
                iport = nexti++;

		if (iport->dataNew) {

		    // get input packet
	            iport->get().getMessage(inEnv);
		    if (!voiceCheck(inEnv,*this)) return;
		    v = (const VoiceData*) inEnv.myData();

		    // calculate latency for this packet
		    del = arrivalTime - (v->retStamp());

		    // update statistics
		    delay[count] = delay[count] + del;
		    totalPackets[count]++;

		    // output some stuff
		    latport->put(completionTime) << del;
		    oport->put(completionTime) << inEnv;
                }

		count++;
             }

	     if (demand.dataNew) {

		for (int i = 0; i < numPorts; i++) {

		    avgport = nextavg++;
		    countTotal += totalPackets[i];
		    delayTotal += delay[i];

		    avgport -> put(completionTime) << 
			(double(delay[i])) / (double(totalPackets[i]));

                }

		avgLatencyAll.put(completionTime) << 
			(double(delayTotal)) / (double(countTotal));

             }
}

// prototype instance for known block list
static DELatency proto;
static RegisterBlock registerBlock(proto,"Latency");
