static const char file_id[] = "DENullRemove.pl";
// .cc file generated from DENullRemove.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DENullRemove.h"
#include "VoiceData.h"

const char *star_nm_DENullRemove = "DENullRemove";

const char* DENullRemove :: className() const {return star_nm_DENullRemove;}

ISA_FUNC(DENullRemove,DEStar);

Block* DENullRemove :: makeNew() const { LOG_NEW; return new DENullRemove;}

# line 48 "DENullRemove.pl"
extern int voiceCheck (Envelope&, NamedObj&);

DENullRemove::DENullRemove ()
{
	setDescriptor("Removes null\n.c VoiceData\nmessages");
	addPort(data.setPort("data",this,MESSAGE));
	addPort(output.setPort("output",this,MESSAGE));

# line 44 "DENullRemove.pl"
data.triggers();
}

void DENullRemove::setup() {
# line 52 "DENullRemove.pl"
if (data.numberPorts() != output.numberPorts())
              Error::abortRun(*this, "Inconsistent number of i/p o/p ports");
}

void DENullRemove::go() {
# line 58 "DENullRemove.pl"
Envelope  inEnv;
             completionTime = arrivalTime;
       
             InDEMPHIter nextp(data);
             InDEPort *iport;
             OutDEMPHIter nextq(output);
             OutDEPort *oport;
             
             while ((oport = nextq++) != 0) {
                  iport = nextp++;
                  if (iport->dataNew)  {
                    iport->get().getMessage(inEnv);
		    if (!voiceCheck(inEnv,*this)) return;
                    const VoiceData*  v = (const VoiceData*) inEnv.myData();
                    if (! v->nulltestMessage())
                       oport->put(completionTime) << inEnv;
                  }
             } //while
}

// prototype instance for known block list
static DENullRemove proto;
static RegisterBlock registerBlock(proto,"NullRemove");
