static const char file_id[] = "DEProgress.pl";
// .cc file generated from DEProgress.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEProgress.h"
#include <stream.h>

const char *star_nm_DEProgress = "DEProgress";

const char* DEProgress :: className() const {return star_nm_DEProgress;}

ISA_FUNC(DEProgress,DEStar);

Block* DEProgress :: makeNew() const { LOG_NEW; return new DEProgress;}

DEProgress::DEProgress ()
{
	setDescriptor("Periodically print to <stdout> current time of simulation");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(update.setState("update",this,"1.0","Step size to print system time progress"));


}

void DEProgress::setup() {
# line 51 "DEProgress.pl"
// The first time to reach
          timeToReach = double(update);
}

void DEProgress::go() {
# line 57 "DEProgress.pl"
completionTime = arrivalTime;
	  // pass the particle through
	  output.put(completionTime) = input.get();

          if (arrivalTime >= timeToReach)  {
            cout << "Simulation time: " << arrivalTime << "\n";
            // set the next time to reach
            timeToReach = timeToReach + double(update);
          }
}

// prototype instance for known block list
static DEProgress proto;
static RegisterBlock registerBlock(proto,"Progress");
