static const char file_id[] = "DEThroughput.pl";
// .cc file generated from DEThroughput.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

# line 3 "DEThroughput.pl"
#define  MAXPORTS 64
#include "DEThroughput.h"
#include "VoiceData.h"

const char *star_nm_DEThroughput = "DEThroughput";

const char* DEThroughput :: className() const {return star_nm_DEThroughput;}

ISA_FUNC(DEThroughput,DEStar);

Block* DEThroughput :: makeNew() const { LOG_NEW; return new DEThroughput;}

DEThroughput::DEThroughput ()
{
	setDescriptor("Measures throughput of a set of traffic-loaded trunk lines.");
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(input.setPort("input",this,MESSAGE));
	addPort(avgThroughput.setPort("avgThroughput",this,FLOAT));
	addPort(throughput.setPort("throughput",this,FLOAT));
	addPort(output.setPort("output",this,MESSAGE));

# line 66 "DEThroughput.pl"
input.triggers(output);
	      demand.triggers(avgThroughput);
	      demand.triggers(throughput);
	      input.before(demand);
}

void DEThroughput::setup() {
# line 79 "DEThroughput.pl"
if (input.numberPorts() != output.numberPorts()) {
              Error::abortRun(*this, "Inconsistent number of i/o ports");
	      return;
          }

          if (input.numberPorts() != throughput.numberPorts()) {
              Error::abortRun(*this, "Inconsistent number of i/t ports");
	      return;
          }

          numPorts = input.numberPorts();

          // initialize packet counts to zero for all lines
	  for (int i = 0; i < numPorts; i++) {
	      realPackets[i] = 0;
	      nullPackets[i] = 0;
          }
}

void DEThroughput::go() {
# line 100 "DEThroughput.pl"
completionTime = arrivalTime;
       
             InDEMPHIter nextp(input);
             InDEPort *iport;
             OutDEMPHIter nextq(output);
             OutDEPort *oport;
	     OutDEMPHIter nextr(throughput);
	     OutDEPort *rport;

	     Envelope  inEnv;
	     const VoiceData*  v;
      
	     int  countReal, countNull, count;
	     countReal = countNull = count = 0;

             while ((oport = nextq++) != 0) {
                iport = nextp++;

		if (iport->dataNew) {
		    iport->get().getMessage(inEnv);
		    v = (const VoiceData*) inEnv.myData();

		    // update totals as appropriate depending on whether this
		    // packet is null or not
			
		    if (v -> nulltestMessage()) {
			nullPackets[count]++;
                    }
		    else {
			realPackets[count]++;
                    }

		    oport->put(completionTime) << inEnv;
                }

		count++;
             }  // end while

	     if (demand.dataNew) {

		for (int i = 0; i < numPorts; i++) {
		    rport = nextr++;

		    countReal += realPackets[i];
		    countNull += nullPackets[i];

		    // send out Tput for each channel resp.
         	    rport -> put(completionTime) << 
			(double(realPackets[i])) /
			(double(realPackets[i] + nullPackets[i]));  
                }

		// output overall throughput
	        avgThroughput.put(completionTime) << 
		    (double (countReal)) /
		    (double (countReal + countNull)); 

             }
}

// prototype instance for known block list
static DEThroughput proto;
static RegisterBlock registerBlock(proto,"Throughput");
