static const char file_id[] = "DEVoiceFl.pl";
// .cc file generated from DEVoiceFl.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEVoiceFl.h"
#include "VoiceData.h"

const char *star_nm_DEVoiceFl = "DEVoiceFl";

const char* DEVoiceFl :: className() const {return star_nm_DEVoiceFl;}

ISA_FUNC(DEVoiceFl,DEStar);

Block* DEVoiceFl :: makeNew() const { LOG_NEW; return new DEVoiceFl;}

# line 49 "DEVoiceFl.pl"
extern int voiceCheck (Envelope&, NamedObj&);

DEVoiceFl::DEVoiceFl ()
{
	setDescriptor("Reads in voice packet and sends out its destination VCI number");
	addPort(input.setPort("input",this,MESSAGE));
	addPort(output.setPort("output",this,FLOAT));
	addState(field.setState("field",this,"2","Field of\n.c VoiceData\npackets to output"));


}

void DEVoiceFl::go() {
# line 53 "DEVoiceFl.pl"
Envelope  inEnv;
                input.get().getMessage(inEnv);
                if (!voiceCheck (inEnv, *this)) return;
                const VoiceData*  v = (const VoiceData*) inEnv.myData();
                completionTime = arrivalTime;

		// Send out data if not start-of-transmission nor end-of-
		// transmission message

		if (!v->isitSOTMessage() && !v->isitEOTMessage()) {
                    unsigned char* ptr = v->asVoice();
                    int  i0 = ptr[int(field)];
                    output.put(completionTime) << double(i0);
                }
}

// prototype instance for known block list
static DEVoiceFl proto;
static RegisterBlock registerBlock(proto,"VoiceFl");
