.EQ
delim off
.EN
.\" documentation file generated from DEEtherSend.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "EtherSend"
.SD
This star can transmit particles of any type to any or all receivers
that have the same value for the "medium" parameter.  The receiver
address is given by the "address" input, and it must be an integer.
If the integer is negative, then copies of the particle are sent
to all receivers that use the same medium.

The transmitter "occupies" the medium for the specified duration.
A collision occurs if the medium is occupied when a transmission is
requested.  In this case,
the data to be transmitted is sent to the "collision" output.
.SE
.LO "DE main library"
.DM DE DEEther
.SV 1.6 "10/23/95"
.AL "Edward A. Lee and Tom M. Parks"
.IH
.NE
\fIaddress\fR (int): Address of the receiver. Negative for broadcast.
.NE
\fIsendData\fR (anytype): Data to transmit.
.NE
\fIduration\fR (float): Time delay to receiver, and time occupying the medium.
.PE
.OH
.NE
\fIcollision\fR (ANYTYPE): Indicate the medium is occupied.
.PE
.EQ
delim $$
.EN
.LD
This star is derived from
.c Ether.
Please see the manual entry for that star for a basic introduction.
.pp
This star implements a transmitter for a shared medium.
Any type of
.c Particle
can be transmitted.
If the "address" input is a non-negative integer, then the transmitter
looks for a receiver that shares the medium that has a matching address.
If it is found, a copy of the Particle is sent to the receiver.
The receiver is told to output that particle after a certain
elapsed time, given by the most recent value that arrived on
the "duration" input.
If no such particle has arrived, a duration of zero is used.
If the address is a negative integer, then the data particle
is broadcast to all receivers on the medium.
.ES
