.EQ
delim off
.EN
.\" documentation file generated from DETkStripChart.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "TkStripChart"
.SD
Display events in time, recording the entire history.
The supported styles are 'hold' for zero-order hold,
'connect' for connected dots, and 'dot' for unconnected dots.
An interactive help window describes other options for the plot.
.SE
.LO "DE Tcl/Tk library"
.DM DE DETclScript
.SV 1.5 "10/23/95"
.AL "Eduardo N. Spring, Jose Luis Pino, and Edward A. Lee"
.SH
.NE
\fItitle\fR (StringState): A title to put on the display
.DF "Ptolemy Strip Chart"
.NE
\fIsignalLabels\fR (StringArrayState): Label(s) for each plot. If 'default', use port names.
.DF "default"
.NE
\fIyRange\fR (ComplexArrayState): The vertical range(s) of the plot
.DF "(-1,1)"
.NE
\fITimeWindow\fR (FloatState): The time represented by one window width
.DF "25"
.NE
\fIyRangeList\fR (StringState)

.NE
\fIstyle\fR (StringArrayState): Plot styles are hold, connect, or dot.
.DF "hold"
.NE
\fIposition\fR (StringState): Location of the window in standard X format
.DF "+0+0"
.NE
\fIwidth_cm\fR (StringState): Width of each plot in centimeters
.DF "25"
.NE
\fIheight_cm\fR (StringState): Height of each plot in centimeters
.DF "5"
.ET
.EQ
delim $$
.EN
.LD
This star is derived from DETclScript, and does little more than
document the functionality of the script and specify the script file
to be loaded.
.pp
The \fIyRange\fR parameter specifies the vertical range of each plot.
Each range is specified as a pair of number in the form (low,high).
If only one range is specified, then it applied to all plots.  If more
than one range is specified, then one range should be specified for each 
input.  I.e., then number of ranges specified should equal the number of 
inputs.
.pp
The \fITimeWindow\fR parameter specifies the amount of simulated time
that can be viewed at one time in the window.  In other words, it is
the time represented by the width of the plot window.
.pp
The \fIPlotStyle\fR parameter determines the plotting style.
There are currently three styles: zero order hold,
connected lines, and unconnected dots.
These are specified by the strings "hold", "dot", or "connect".
The PlotStyle can be different for each input porthole.
.pp
The \fIPlotLabels\fR parameter specifies labels for each plot.
It can take any of three forms.  If it is empty, or has just the single 
string "default", then it uses the name of the porthole connected to the
corresponding input.  Alternatively, it can specify one label for each 
input, with the labels separated by spaces.
.ES
