.EQ
delim off
.EN
.\" documentation file generated from DEWaveForm.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "WaveForm"
.SD
Upon receiving an input event, output the next value specified by the
array parameter "value" (default "1 -1"). This array can periodically
repeat with any period, and you can halt a simulation when the end of
the array is reached. The following table summarizes the capabilities:
.nf
haltAtEnd   periodic   period    operation
-----------------------------------------------------------------------
NO          YES        0         The period is the length of the array
NO          YES        N>0       The period is N
NO          NO         anything  Output the array once, then zeros
YES         anything   anything  Stop after outputting the array once
.fi
The first line of the table gives the default settings.
The array may be read from a file by simply setting value to something
of the form "< filename".
.SE
.LO "SDF main library"
.DM DE DEStar
.SV 1.4 "3/2/95"
.AL "E. A. Lee"
.IH
.NE
\fItrigger\fR (anytype): An event here triggers the next output.
.PE
.OH
.NE
\fIoutput\fR (float)
.PE
.SH
.NE
\fIvalue\fR (FloatArrayState): One period of the output waveform.
.DF "1 -1"
.NE
\fIhaltAtEnd\fR (IntState): Halt the run at the end of the given data.
.DF "NO"
.NE
\fIperiodic\fR (IntState): Output is periodic if "YES" (nonzero).
.DF "YES"
.NE
\fIperiod\fR (IntState): If greater than zero, gives the period of the waveform.
.DF "0"
.ET
.EQ
delim $$
.EN
.LD
This star may be used to read a file by simply setting "value" to
something of the form "< filename".  The file will be read completely
and its contents stored in an array.  The size of the array is currently
limited to 20,000 samples.
.Id "file read"
.Id "waveform from file"
.Id "reading from a file"
.Ir "halting a simulation"
.Ir "simulation, halting"
.ES
