static const char file_id[] = "DEArbitrate.pl";
// .cc file generated from DEArbitrate.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEArbitrate.h"

const char *star_nm_DEArbitrate = "DEArbitrate";

const char* DEArbitrate :: className() const {return star_nm_DEArbitrate;}

ISA_FUNC(DEArbitrate,DEStar);

Block* DEArbitrate :: makeNew() const { LOG_NEW; return new DEArbitrate;}

DEArbitrate::DEArbitrate ()
{
	setDescriptor("This star acts as a non-preemptive arbitrator, granting requests for\nexclusive control.  If simultaneous requests arrive, priority is\ngiven to port A.  When control is released, any pending requests on\nthe other port will be serviced.  The \"requestOut\" and \"grantIn\"\nconnections allow interconnection of multiple arbitration stars for\nmore intricate control structures.");
	addPort(requestA.setPort("requestA",this,INT));
	addPort(requestB.setPort("requestB",this,INT));
	addPort(requestOut.setPort("requestOut",this,INT));
	addPort(grantA.setPort("grantA",this,INT));
	addPort(grantB.setPort("grantB",this,INT));
	addPort(grantIn.setPort("grantIn",this,INT));

# line 71 "DEArbitrate.pl"
requestA.triggers(requestOut);
	requestB.triggers(requestOut);
	grantIn.triggers(grantA);
	grantIn.triggers(grantB);
	grantIn.before(requestA);
}

void DEArbitrate::setup() {
# line 79 "DEArbitrate.pl"
idle = TRUE;
	req = rel = FALSE;
}

void DEArbitrate::go() {
# line 86 "DEArbitrate.pl"
if (grantIn.dataNew)	// response to earlier "requestOut" output
	{
	    if (req && int(grantIn.get()))	// grant request
	    {
		req = FALSE;
		grant->put(arrivalTime) << TRUE;
	    }
	    if (rel && !int(grantIn.get()))	// grant release
	    {
		rel = FALSE;
		idle = TRUE;
		grant->put(arrivalTime) << FALSE;
		request->dataNew = FALSE;	// give other port a chance
	    }
	}

	if ((requestA.dataNew || requestB.dataNew) && idle)	// new request
	{
	    if (requestA.dataNew)	// assign port A
	    {
		request = &requestA;
		grant = &grantA;
	    }
	    else			// assign port B
	    {
		request = &requestB;
		grant = &grantB;
	    }

	    if (int(request->get()))	// generate request
	    {
		idle = FALSE;
		req = TRUE;
		requestOut.put(arrivalTime) << TRUE;
	    }
	}

	if (request->dataNew && !idle && !req && !rel)	// new release
	{
	    if (!int(request->get()))	// generate release
	    {
		rel = TRUE;
		requestOut.put(arrivalTime) << FALSE;
	    }
	}
}

// prototype instance for known block list
static DEArbitrate proto;
static RegisterBlock registerBlock(proto,"Arbitrate");
