static const char file_id[] = "DEBarGraph.pl";
// .cc file generated from DEBarGraph.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEBarGraph.h"

const char *star_nm_DEBarGraph = "DEBarGraph";

const char* DEBarGraph :: className() const {return star_nm_DEBarGraph;}

ISA_FUNC(DEBarGraph,DEStar);

Block* DEBarGraph :: makeNew() const { LOG_NEW; return new DEBarGraph;}

DEBarGraph::DEBarGraph ()
{
	setDescriptor("Generate a plot with the pxgraph program that uses\na zero-order hold to interpolate between event values.\nTwo points are plotted for each event, one when the event\nfirst occurs, and the second when the event is supplanted\nby a new event.  A horizontal line then connects the two points.\nIf \"draw_line_to_base\" is YES then a vertical line to the base\nof the bar graph is also drawn for each event occurrence.");
	addPort(input.setPort("input",this,ANYTYPE));
	addState(title.setState("title",this,"X Graph Bar Chart","Graph title."));
	addState(saveFile.setState("saveFile",this,"","File to save pxgraph input."));
	addState(draw_line_to_base.setState("draw_line_to_base",this,"NO","Specifies vertical line to base."));
	addState(base.setState("base",this,"0.0","Base of the bar graph."));
	addState(options.setState("options",this,"-bb -lw 3 -zg black -x time -0 input","Command line options for a bar graph in pxgraph."));

# line 65 "DEBarGraph.pl"
lastDataValues = 0;
		firstPointFlags = 0;
}

void DEBarGraph::wrapup() {
# line 103 "DEBarGraph.pl"
for ( int port = 1; port <= numports; port++ )
		  graph.addPoint(port, arrivalTime, lastDataValues[port]);
		graph.terminate();
}

DEBarGraph::~DEBarGraph() {
# line 108 "DEBarGraph.pl"
LOG_DEL; delete [] lastDataValues;
		LOG_DEL; delete [] firstPointFlags;
}

void DEBarGraph::setup() {
# line 69 "DEBarGraph.pl"
LOG_DEL; delete [] lastDataValues;
		LOG_DEL; delete [] firstPointFlags;
		numports = input.numberPorts();
		LOG_NEW; lastDataValues = new float[ numports + 1 ];
		LOG_NEW; firstPointFlags = new int[ numports + 1];
		for ( int port = 1; port <= numports; port++ ) {
	 	  lastDataValues[port] = base;
		  firstPointFlags[port] = TRUE;
		}
		graph.initialize(this,
				 input.numberPorts(),
				 (const char*) options,
				 (const char*) title,
				 (const char*) saveFile);
}

void DEBarGraph::go() {
# line 85 "DEBarGraph.pl"
InDEMPHIter nextp(input);
		for ( int port = 1; port <= numports; port++ ) {
		  InDEPort *iportp = nextp++;
		  if ( iportp->dataNew ) {
		    float data = float(iportp->get());
		    if ( firstPointFlags[port] )
		      firstPointFlags[port] = FALSE;
		    else
		      graph.addPoint(port, arrivalTime, lastDataValues[port]);
		    if (int(draw_line_to_base))
		      graph.addPoint(port, arrivalTime, base);
		    graph.addPoint(port, arrivalTime, data);
		    lastDataValues[port] = data;
		  }
		  iportp->dataNew = FALSE;
		}
}

// prototype instance for known block list
static DEBarGraph proto;
static RegisterBlock registerBlock(proto,"BarGraph");
