static const char file_id[] = "DEBusFork.pl";
// .cc file generated from DEBusFork.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEBusFork.h"

const char *star_nm_DEBusFork = "DEBusFork";

const char* DEBusFork :: className() const {return star_nm_DEBusFork;}

ISA_FUNC(DEBusFork,DEStar);

Block* DEBusFork :: makeNew() const { LOG_NEW; return new DEBusFork;}

DEBusFork::DEBusFork ()
{
	setDescriptor("Replicate events from an input bus to each output bus with zero delay.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(outputA.setPort("outputA",this,ANYTYPE));
	outputA.inheritTypeFrom(input);
	addPort(outputB.setPort("outputB",this,ANYTYPE));
	outputB.inheritTypeFrom(input);


}

void DEBusFork::begin() {
# line 29 "DEBusFork.pl"
if (input.numberPorts() != outputA.numberPorts() ||
	      input.numberPorts() != outputB.numberPorts()) {
	    Error::abortRun(*this, "Bus widths don't match");
	    return;
	  }
}

void DEBusFork::go() {
# line 36 "DEBusFork.pl"
completionTime = arrivalTime;
	  InDEMPHIter nextin(input);
	  OutDEMPHIter nextoutA(outputA), nextoutB(outputB);
	  InDEPort *in;
	  OutDEPort *outA = (OutDEPort *)NULL, *outB = (OutDEPort *)NULL;
	  while (((in = nextin++) != 0) &&
		 ((outA = nextoutA++) != 0) &&
		 ((outB = nextoutB++) != 0)) {
	    if (in->dataNew) {
	      Particle& pp = in->get();
	      outA->put(completionTime) = pp;
	      outB->put(completionTime) = pp;
	    }
	  }
}

// prototype instance for known block list
static DEBusFork proto;
static RegisterBlock registerBlock(proto,"BusFork");
