static const char file_id[] = "DECase.pl";
// .cc file generated from DECase.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DECase.h"

const char *star_nm_DECase = "DECase";

const char* DECase :: className() const {return star_nm_DECase;}

ISA_FUNC(DECase,DEStar);

Block* DECase :: makeNew() const { LOG_NEW; return new DECase;}

DECase::DECase ()
{
	setDescriptor("Switch input events to one of N outputs,\nas determined by the last received control input.\nThe value of the control input must be between\n0 and N-1, inclusive, or an error is flagged.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);

# line 32 "DECase.pl"
control.triggers();
		control.before(input);
}

void DECase::go() {
# line 36 "DECase.pl"
if (input.dataNew) {
	    if (int(control%0) < 0) {
	      Error::abortRun(*this,"negative control value received");
	      return;
	    }
	    MPHIter nexto(output);
	    OutDEPort* p = 0;
	    for (int i = int(control%0); i >=0; i--) {
	      // Apologies for this cast.
	      p = (OutDEPort*)nexto++;
	      if (!p) {
	        Error::abortRun(*this,"control value out of range");
	        return;
	      }
	    }
	    completionTime = arrivalTime;
	    Particle& pp = input.get();
            p->put(completionTime) = pp;
	  }
}

// prototype instance for known block list
static DECase proto;
static RegisterBlock registerBlock(proto,"Case");
