static const char file_id[] = "DECellLoad.pl";
// .cc file generated from DECellLoad.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DECellLoad.h"

const char *star_nm_DECellLoad = "DECellLoad";

const char* DECellLoad :: className() const {return star_nm_DECellLoad;}

ISA_FUNC(DECellLoad,DEStar);

Block* DECellLoad :: makeNew() const { LOG_NEW; return new DECellLoad;}

DECellLoad::DECellLoad ()
{
	setDescriptor("Read in an Envelope, extract its Message, and\noutput that Message in a NetworkCell.");
	addPort(input.setPort("input",this,MESSAGE));
	addPort(output.setPort("output",this,MESSAGE));
	addState(mssgSize.setState("mssgSize",this,"384","size of message loaded into NetworkCell"));
	addState(destination.setState("destination",this,"1","destination address"));
	addState(priority.setState("priority",this,"1","1: high, 0: low"));


}

void DECellLoad::go() {
# line 49 "DECellLoad.pl"
if (input.dataNew) {
			completionTime = arrivalTime;
			Envelope inEnvlp;
			input.get().getMessage(inEnvlp);
			Message* toLoad = inEnvlp.writableCopy();
			LOG_NEW; NetworkCell* shipItOut = new NetworkCell(
					*toLoad, int( priority ), int( destination ),
					int( mssgSize ), 0,
					float( completionTime), 0 );
			Envelope outEnvlp( *shipItOut );
			output.put( completionTime ) << outEnvlp;
		} // end if
}

// prototype instance for known block list
static DECellLoad proto;
static RegisterBlock registerBlock(proto,"CellLoad");
