static const char file_id[] = "DECellRoute.pl";
// .cc file generated from DECellRoute.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DECellRoute.h"

const char *star_nm_DECellRoute = "DECellRoute";

const char* DECellRoute :: className() const {return star_nm_DECellRoute;}

ISA_FUNC(DECellRoute,DEStar);

Block* DECellRoute :: makeNew() const { LOG_NEW; return new DECellRoute;}

DECellRoute::DECellRoute ()
{
	setDescriptor("This star reads in input NetworkCells from multiple input\nsources and routes them to the appropriate output.");
	addPort(input.setPort("input",this,MESSAGE));
	addPort(output.setPort("output",this,MESSAGE));
	addState(RoutingTable.setState("RoutingTable",this,"0 1 2 3","Cell destination address to output port number map."));


}

void DECellRoute::setup() {
# line 30 "DECellRoute.pl"
for (int i = 0; i < RoutingTable.size(); i++) {
			if ((RoutingTable[i] < 0) ||
					(RoutingTable[i] >= output.numberPorts())) {
				Error::abortRun(*this,
						"Routing table entry out of legal range.");
				return;
		}	}
}

void DECellRoute::go() {
# line 41 "DECellRoute.pl"
completionTime = arrivalTime;

// INPUT
		InDEMPHIter inIter(input);
		InDEPort* inPtr;
		while ((inPtr = inIter++) != 0) {
			while (inPtr->dataNew) {
				Envelope theEnvp;
				inPtr->get().getMessage(theEnvp);
				TYPE_CHECK(theEnvp, "NetworkCell");
				const NetworkCell* cellPtr = (const NetworkCell*)
						theEnvp.myData();
				const int dest = cellPtr->dest();
				if ((dest < 0) || (dest >= RoutingTable.size())) {
					Error::abortRun(*this,
							"Cell with illegal destination.");
					return;
				}
				const int port = RoutingTable[dest];

// OUTPUT
				OutDEMPHIter outIter(output);
				OutDEPort* outPtr = outIter++;
				for(int i = port; i > 0; i--) { outPtr = outIter++; }

				outPtr->put(completionTime) << theEnvp;

				inPtr->getSimulEvent();
		}	}
}

// prototype instance for known block list
static DECellRoute proto;
static RegisterBlock registerBlock(proto,"CellRoute");
