static const char file_id[] = "DEClock.pl";
// .cc file generated from DEClock.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEClock.h"

const char *star_nm_DEClock = "DEClock";

const char* DEClock :: className() const {return star_nm_DEClock;}

ISA_FUNC(DEClock,DERepeatStar);

Block* DEClock :: makeNew() const { LOG_NEW; return new DEClock;}

DEClock::DEClock ()
{
	setDescriptor("Generate events at regular intervals, starting at time zero.");
	addPort(output.setPort("output",this,FLOAT));
	addState(interval.setState("interval",this,"1.0","The interval of events."));
	addState(magnitude.setState("magnitude",this,"1.0","The value of the output particles generated."));


}

void DEClock::go() {
# line 34 "DEClock.pl"
// Generate the output event
	   // (Recall that the first event comes out at time 0).
	   output.put(completionTime) << double(magnitude);

	   // and schedule the next firing
	   refireAtTime(completionTime);

	   // Increment the completion time
	   completionTime += double(interval);
}

// prototype instance for known block list
static DEClock proto;
static RegisterBlock registerBlock(proto,"Clock");
