static const char file_id[] = "DEDiscard.pl";
// .cc file generated from DEDiscard.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEDiscard.h"

const char *star_nm_DEDiscard = "DEDiscard";

const char* DEDiscard :: className() const {return star_nm_DEDiscard;}

ISA_FUNC(DEDiscard,DEStar);

Block* DEDiscard :: makeNew() const { LOG_NEW; return new DEDiscard;}

DEDiscard::DEDiscard ()
{
	setDescriptor("This star discards input events that occur before the threshold time.\nEvents after the threshold time are passed immediately to the output.\nIt is useful for removing transients and studying steady-state effects.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(threshold.setState("threshold",this,"0.0","All events before this time are discarded."));


}

void DEDiscard::go() {
# line 34 "DEDiscard.pl"
completionTime = arrivalTime;
	   Particle& pp = input.get();
	   if (arrivalTime >= double(threshold)) {
           	output.put(completionTime) = pp;
	   }
}

// prototype instance for known block list
static DEDiscard proto;
static RegisterBlock registerBlock(proto,"Discard");
