static const char file_id[] = "DEEndCase.pl";
// .cc file generated from DEEndCase.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEEndCase.h"

const char *star_nm_DEEndCase = "DEEndCase";

const char* DEEndCase :: className() const {return star_nm_DEEndCase;}

ISA_FUNC(DEEndCase,DEStar);

Block* DEEndCase :: makeNew() const { LOG_NEW; return new DEEndCase;}

DEEndCase::DEEndCase ()
{
	setDescriptor("Select an input event from one of N inputs,\nas specified by the last received control input.\nThe value of the control input must be between\n0 and N-1 inclusive, or an error is flagged.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);

# line 32 "DEEndCase.pl"
control.triggers();
		control.before(input);
}

void DEEndCase::go() {
# line 36 "DEEndCase.pl"
if (int(control%0) < 0) {
	      Error::abortRun(*this,"negative control value received");
	      return;
	  }
	  MPHIter nexti(input);
	  InDEPort* p = 0;
	  for (int i = int(control%0); i >=0; i--) {
	    // Apologies for this cast.
	    p = (InDEPort*)nexti++;
	    if (!p) {
	      Error::abortRun(*this,"control value out of range");
	      return;
	    }
	  }

	  if (p->dataNew) {
	    completionTime = arrivalTime;
	    Particle& pp = p->get();
            output.put(completionTime) = pp;
	  }
}

// prototype instance for known block list
static DEEndCase proto;
static RegisterBlock registerBlock(proto,"EndCase");
