static const char file_id[] = "DEEther.pl";
// .cc file generated from DEEther.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEEther.h"

const char *star_nm_DEEther = "DEEther";

const char* DEEther :: className() const {return star_nm_DEEther;}

ISA_FUNC(DEEther,DERepeatStar);

Block* DEEther :: makeNew() const { LOG_NEW; return new DEEther;}

# line 137 "DEEther.pl"
int Medium::registerReceiver(const char* recName, DEEtherRec* rec)
	    {
		// For now, allow only one receiver with each unique name.
		// May want to allow multiple receivers with the same name.
		if (receivers.hasKey(recName)) {
		    return FALSE;
		}
		receivers.insert(recName, rec);
		return TRUE;
	    }
	    DEEtherRec* Medium::findReceiver(const char* recName) {
		return (DEEtherRec*)(receivers.lookup(recName));
	    }

	    // Instantiate the static members of the DEEther star
	    HashTable DEEther::medList;

DEEther::DEEther ()
{
	setDescriptor("This is the base class for transmitter and receiver\nstars that communicate over a shared medium.\nEach transmitter can communicate with any or all receivers\nthat have the same value for the \"medium\" parameter.\nThe communication is accomplished without graphical connections,\nand the communication topology can be continually changing.\nThis base class implements the data structures that are shared\nbetween the transmitters and receivers.");
	addState(medium.setState("medium",this,"radio900MHz","The name of the medium to share."));


}

void DEEther::wrapup() {
# line 198 "DEEther.pl"
// Indicate that receivers should be reinitialized on the
	    // next run.
	    // Note that this does not get invoked if an error occurs.
	    // Thus, if an error occurs, the star should be destroyed
	    // and recreated.  Pigi takes care of this automatically,
	    // but if the star is run under ptcl, then it is up to the
	    // user to do this.
	    med->receiversInitialized = 0;
}

void DEEther::begin() {
# line 175 "DEEther.pl"
if (medList.hasKey(medium)) {
		// Medium already exists
		med = (Medium*)medList.lookup(medium);
	    } else {
		// Need to create a new medium
		LOG_NEW; med = new Medium;
		medList.insert(medium, med);
	    }
	    (med->starCount)++;

	    if(!(med->receiversInitialized)) {
		med->initialize();
		med->occupyUntil(0.0);
		med->receiversInitialized = 1;
	    }
}

DEEther::~DEEther() {
# line 208 "DEEther.pl"
if (med) {
		med->starCount--;
		if (med->starCount == 0) {
		   medList.remove(medium);
		   LOG_DEL; delete med;
		}
	    }
}

void DEEther::setup() {
# line 192 "DEEther.pl"
DERepeatStar :: setup ();

	    // This initialization is required by the base class RepeatStar
	    completionTime = 0;
}


int DEEther::registerReceiver (const char* name, DEEtherRec* receiver)
{
# line 166 "DEEther.pl"
if (med) {
		    return med->registerReceiver(name, receiver);
		} else {
		    Error::abortRun(*this,"No medium!");
		    return 0;
		}
}


// prototype instance for known block list
static DEEther proto;
static RegisterBlock registerBlock(proto,"Ether");
