#ifndef _DEEther_h
#define _DEEther_h 1
// header file generated from DEEther.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */
#include "DERepeatStar.h"
#include "HashTable.h"
#include "StringState.h"
# line 104 "DEEther.pl"
class DEEtherRec;

	    // Define a class that represents a particular medium
	    // and keeps track of whether it is occupied.
	    class Medium {
	    public:
		Medium() : starCount(0), receiversInitialized(0) {}

		// Count the number of stars using this medium
		int starCount;

		// Flag indicating whether the receiver list has been init'd
		int receiversInitialized;

		int occupiedAt(double curTime) { return (curTime < freeTime); }
		void occupyUntil(double time) { freeTime = time; }
		void initialize() { receivers.clear(); }

		// Register a new receiver for the medium.  If a receiver
		// with the specified name was already registered, then
		// this new receiver will be ignored.
		int registerReceiver(const char* recName, DEEtherRec* rec);

		// Return a pointer to a receiver with a specified name.
		// If no such receiver has been registered, return 0.
		DEEtherRec* findReceiver(const char* recName);

		HashTable receivers;
	    private:
		double freeTime;
	    };

class DEEther : public DERepeatStar
{
public:
	DEEther();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ void wrapup();
	/* virtual */ void begin();
	/* virtual */ ~DEEther();
protected:
	/* virtual */ void setup();
	StringState medium;
# line 156 "DEEther.pl"
// List of media, indexed by name
	    static HashTable medList;
	    Medium* med;
	int registerReceiver (const char* name, DEEtherRec* receiver);

};
#endif
