static const char file_id[] = "DEEtherRec.pl";
// .cc file generated from DEEtherRec.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEEtherRec.h"

const char *star_nm_DEEtherRec = "DEEtherRec";

const char* DEEtherRec :: className() const {return star_nm_DEEtherRec;}

ISA_FUNC(DEEtherRec,DEEther);

Block* DEEtherRec :: makeNew() const { LOG_NEW; return new DEEtherRec;}

DEEtherRec::DEEtherRec ()
{
	setDescriptor("This star receives floating-point particles transmitted to it by\nan EtherSend star.  The particle is produced at the output after\nsome duration of transmission specified at the transmitter.");
	addPort(recData.setPort("recData",this,FLOAT));
	addState(recName.setState("recName",this,"0","Unique name of the receiver."));


}

void DEEtherRec::begin() {
# line 82 "DEEtherRec.pl"
DEEther::begin();

	    firstFiring = 1;

	    if(!registerReceiver(recName, this)) {
		Error::warn(*this,
	"Additional receivers with the same name will be ignored. Name is ",
                        recName);
	    }

	    // Initialize the local flag to indicate that we don't now have
	    // valid data pending output.
	    dataValid = 0;
}

void DEEtherRec::go() {
# line 97 "DEEtherRec.pl"
if (dataValid) {
		// Output the stored data
		recData.put(arrivalTime) = *recdData;

		// Release the particle
		recdData->die();

		// Mark that we no longer have valid data waiting for output
		dataValid = 0;
	    }
}


void DEEtherRec::schedReception (Particle& data, double firingTime)
{
# line 73 "DEEtherRec.pl"
if (dataValid)
		    Error::warn(*this,"Overwriting previously received data");
		recdData = data.clone();
		refireAtTime(firingTime);
		feedbackOut->sendData();
		dataValid = 1;
}


// prototype instance for known block list
static DEEtherRec proto;
static RegisterBlock registerBlock(proto,"EtherRec");
