static const char file_id[] = "DEEtherSend.pl";
// .cc file generated from DEEtherSend.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEEtherSend.h"
#include "DEEtherRec.h"

const char *star_nm_DEEtherSend = "DEEtherSend";

const char* DEEtherSend :: className() const {return star_nm_DEEtherSend;}

ISA_FUNC(DEEtherSend,DEEther);

Block* DEEtherSend :: makeNew() const { LOG_NEW; return new DEEtherSend;}

DEEtherSend::DEEtherSend ()
{
	setDescriptor("This star can transmit particles of any type to any or all receivers\nthat have the same value for the \"medium\" parameter.  The receiver\naddress is given by the \"address\" input, and it must be an integer.\nIf the integer is negative, then copies of the particle are sent\nto all receivers that use the same medium.\n\nThe transmitter \"occupies\" the medium for the specified duration.\nA collision occurs if the medium is occupied when a transmission is\nrequested.  In this case,\nthe data to be transmitted is sent to the \"collision\" output.");
	addPort(address.setPort("address",this,INT));
	addPort(sendData.setPort("sendData",this,ANYTYPE));
	addPort(duration.setPort("duration",this,FLOAT));
	addPort(collision.setPort("collision",this,ANYTYPE));
	collision.inheritTypeFrom(sendData);


}

void DEEtherSend::begin() {
# line 76 "DEEtherSend.pl"
DEEther::begin();
	    broadcast = 0;
	    latestDuration = 0.0;
}

void DEEtherSend::go() {
# line 81 "DEEtherSend.pl"
if (duration.dataNew) {
		latestDuration = double(duration.get());
	    }
	    if (address.dataNew) {
		Particle& adp = address.get();
		if (int(adp) < 0) broadcast = 1;
		else broadcast = 0;
		latestAddress = (address.get()).print();
	    }
	    if (sendData.dataNew) {
		Particle& pp = sendData.get();
		if (med->occupiedAt(arrivalTime)) {
		    collision.put(arrivalTime) = pp;
		} else {
		    if (!broadcast) {
			DEEtherRec* receiveStar =
				med->findReceiver(latestAddress);
			if (receiveStar == 0) {
			    Error::warn(*this,
			    "Attempt to transmit to non-existant receiver ",
			    latestAddress);
			    return;
			}
			receiveStar->schedReception(pp,
				arrivalTime + latestDuration);
		    } else {
		        // handle broadcast case
			HashTableIter stars(med->receivers);
			HashEntry* starEntry;
			while ((starEntry = stars++) != 0) {
			    DEEtherRec* receiveStar =
				(DEEtherRec*)(starEntry->value());
			    receiveStar->schedReception(pp,
				arrivalTime + latestDuration);
			}
		    }
		    med->occupyUntil(arrivalTime + latestDuration);
		}
	    }
}

// prototype instance for known block list
static DEEtherSend proto;
static RegisterBlock registerBlock(proto,"EtherSend");
