static const char file_id[] = "DEFIFOQueue.pl";
// .cc file generated from DEFIFOQueue.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEFIFOQueue.h"
#include "DataStruct.h"

const char *star_nm_DEFIFOQueue = "DEFIFOQueue";

const char* DEFIFOQueue :: className() const {return star_nm_DEFIFOQueue;}

ISA_FUNC(DEFIFOQueue,DEQueueBase);

Block* DEFIFOQueue :: makeNew() const { LOG_NEW; return new DEFIFOQueue;}

DEFIFOQueue::DEFIFOQueue ()
{
	setDescriptor("This star is a first-in first-out (FIFO) queue with finite or infinite length.\nEvents on the \"demand\" input trigger a dequeue on the \"outData\"  port\nif the queue is not empty. If the queue is empty, then a \"demand\" event\nenables the next future \"inData\" particle to pass immediately to \"outData\".\nThe first particle to arrive at \"inData\" is always passed directly\nto the output, unless \"numDemandsPending\" is initialized to 0.\nIf \"consolidateDemands\" is set to TRUE (the default), then \"numDemandsPending\"\nis not permitted to rise above unity. The size of the queue is sent to the\n\"size\" output whenever an \"inData\" or \"demand\" event is processed.\nInput data that doesn't fit in the queue is sent to the \"overflow\" output.");


}

DEFIFOQueue::~DEFIFOQueue() {
# line 162 "DEFIFOQueue.pl"
zapQueue();
}

void DEFIFOQueue::setup() {
# line 158 "DEFIFOQueue.pl"
DEQueueBase::setup();
		zapQueue();
}


void DEFIFOQueue::enqueue ()
{
# line 109 "DEFIFOQueue.pl"
if (Qsize() == 0 && int(numDemandsPending) > 0) {
			outData.put(completionTime) = inData.get();
			numDemandsPending = int(numDemandsPending) - 1;
		    } else if (infinite || Qsize() < int(capacity)) {
			queue.put(inData.get().clone());
		    } else {
			// Data is lost
			overflow.put(completionTime) = inData.get();
		    }
}


Pointer DEFIFOQueue::dequeue ()
{
# line 126 "DEFIFOQueue.pl"
return queue.get();
}


void DEFIFOQueue::handleOverflow ()
{
# line 135 "DEFIFOQueue.pl"
// Nothing to do
}


int DEFIFOQueue::Qsize ()
{
# line 144 "DEFIFOQueue.pl"
return queue.length();
}


void DEFIFOQueue::zapQueue ()
{
# line 150 "DEFIFOQueue.pl"
while (Qsize() > 0) {
				Particle* pp = (Particle*) queue.get();
				pp->die();
			}
			queue.initialize();
}


// prototype instance for known block list
static DEFIFOQueue proto;
static RegisterBlock registerBlock(proto,"FIFOQueue");
