static const char file_id[] = "DEFilter.pl";
// .cc file generated from DEFilter.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEFilter.h"

const char *star_nm_DEFilter = "DEFilter";

const char* DEFilter :: className() const {return star_nm_DEFilter;}

ISA_FUNC(DEFilter,DEStar);

Block* DEFilter :: makeNew() const { LOG_NEW; return new DEFilter;}

DEFilter::DEFilter ()
{
	setDescriptor("This star filters the input signal with a first-order, AR impulse response.\nThe data input is interpreted as weighted impulses (Dirac delta functions).\nAn output is triggered by a clock input.");
	addPort(clock.setPort("clock",this,ANYTYPE));
	addPort(data.setPort("data",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(decay.setState("decay",this,"0.9","Exponential decay parameter."));
	addState(tau.setState("tau",this,"0.0","Time of the latest data input event."));
	addState(state.setState("state",this,"0.0","State of the filter as of the latest input event."));

# line 66 "DEFilter.pl"
// data input does not produce an immediate output
		data.triggers();
		data.before(clock);
}

void DEFilter::go() {
# line 71 "DEFilter.pl"
// If the data input is new, update the state.
	   if (data.dataNew) {
		state = double(data.get()) + double(state) *
		   pow(double(decay),(arrivalTime-double(tau)));
		tau = arrivalTime;
	   }
	   // Produce an output only if the clock input is new.
	   if (clock.dataNew) {
		double t = double(state) *
			pow(double(decay),(arrivalTime-double(tau)));
		completionTime = arrivalTime;
		output.put(completionTime) << t;
		clock.dataNew = FALSE;
	   }
}

// prototype instance for known block list
static DEFilter proto;
static RegisterBlock registerBlock(proto,"Filter");
