static const char file_id[] = "DEHandShake.pl";
// .cc file generated from DEHandShake.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEHandShake.h"

const char *star_nm_DEHandShake = "DEHandShake";

const char* DEHandShake :: className() const {return star_nm_DEHandShake;}

ISA_FUNC(DEHandShake,DEStar);

Block* DEHandShake :: makeNew() const { LOG_NEW; return new DEHandShake;}

DEHandShake::DEHandShake ()
{
	setDescriptor("Cooperate with a (possibly preemptive) arbitrator through the\n\"request\" and \"grant\" controls.  \"Input\" particles are passed to\n\"output\", and an \"ackIn\" particle must be received before the next\n\"output\" can be sent.  This response is made available on \"ackOut\".");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addPort(ackIn.setPort("ackIn",this,ANYTYPE));
	addPort(ackOut.setPort("ackOut",this,ANYTYPE));
	ackOut.inheritTypeFrom(ackIn);
	addPort(request.setPort("request",this,INT));
	addPort(grant.setPort("grant",this,INT));

# line 90 "DEHandShake.pl"
input.triggers(request);
	input.before(ackIn);
	ackIn.triggers(output);
	ackIn.triggers(ackOut);
	grant.triggers();
	grant.before(ackIn);
}

void DEHandShake::setup() {
# line 100 "DEHandShake.pl"
idle = TRUE;
	req = rel = open = wait = FALSE;
}

void DEHandShake::go() {
# line 106 "DEHandShake.pl"
if (grant.dataNew)	// new control received
	{
	    open = int(grant.get());	// enable or disable output
	    if (req && open)		// request acknowledged
	    {
		req = FALSE;
	    }
	    else if (rel && !open)	// release acknowledged
	    {
		rel = FALSE;
		idle = TRUE;
	    }
	}

	if (ackIn.dataNew && wait)	// acknowledge received
	{
	    wait = FALSE;
	    ackOut.put(arrivalTime) = ackIn.get();
	    if (!input.dataNew)		// generate release
	    {
		rel = TRUE;
		request.put(arrivalTime) << FALSE;
	    }
	}

	if (input.dataNew)	// new data available
	{
	    if (idle)		// generate request
	    {
		idle = FALSE;
		req = TRUE;
		request.put(arrivalTime) << TRUE;
	    }
	    else if (open && !req && !rel && !wait)	// send data
	    {
		wait = TRUE;
		output.put(arrivalTime) = input.get();
		ackIn.dataNew = FALSE;	// discard any old particle
	    }
	}
}

// prototype instance for known block list
static DEHandShake proto;
static RegisterBlock registerBlock(proto,"HandShake");
