static const char file_id[] = "DEImageToCell.pl";
// .cc file generated from DEImageToCell.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEImageToCell.h"

const char *star_nm_DEImageToCell = "DEImageToCell";

const char* DEImageToCell :: className() const {return star_nm_DEImageToCell;}

ISA_FUNC(DEImageToCell,DEStar);

Block* DEImageToCell :: makeNew() const { LOG_NEW; return new DEImageToCell;}

DEImageToCell::DEImageToCell ()
{
	setDescriptor("This star packetizes an image. Each image is divided up into chunks\nno larger than \"CellSize\". Each cell is delayed from its\npredecessor by \"TimePerCell\". If a new input arrives while an\nolder one is being processed, the new input is queued.");
	addPort(input.setPort("input",this,MESSAGE));
	addPort(output.setPort("output",this,MESSAGE));
	addState(Priority.setState("Priority",this,"0","Priority level for outgoing cells."));
	addState(CellSize.setState("CellSize",this,"256","Cell size in bytes."));
	addState(TimePerCell.setState("TimePerCell",this,"0.005","Time to process one cell."));
	addState(destination.setState("destination",this,"0","Destination addresses."));


}

void DEImageToCell::go() {
# line 51 "DEImageToCell.pl"
completionTime = max(completionTime, arrivalTime);

// Read input image.
		Envelope inEnvp;
		input.get().getMessage(inEnvp);
		TYPE_CHECK(inEnvp, "BaseImage");
		const BaseImage* image = (const BaseImage*) inEnvp.myData();

// Do something.
		int counter = 0;
		BaseImage* imagePtr = image->fragment(int(CellSize), counter++);
		while (imagePtr != (BaseImage*) NULL) {
			completionTime += double(TimePerCell);

			LOG_NEW; NetworkCell* cell = new NetworkCell(*imagePtr,
					int(Priority), int(destination),
					int(imagePtr->retSize()));
			Envelope outEnvp(*cell);
			output.put(completionTime) << outEnvp;

			imagePtr = image->fragment(int(CellSize), counter++);
		}
}

// prototype instance for known block list
static DEImageToCell proto;
static RegisterBlock registerBlock(proto,"ImageToCell");
