static const char file_id[] = "DEImageToMx.pl";
// .cc file generated from DEImageToMx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEImageToMx.h"
#include "GrayImage.h"
#include "Matrix.h"

const char *star_nm_DEImageToMx = "DEImageToMx";

const char* DEImageToMx :: className() const {return star_nm_DEImageToMx;}

ISA_FUNC(DEImageToMx,DEStar);

Block* DEImageToMx :: makeNew() const { LOG_NEW; return new DEImageToMx;}

DEImageToMx::DEImageToMx ()
{
	setDescriptor("Accept a black-and-white image from an input image packet, and copy\nthe individual pixels to a FloatMatrix.  Note that even thought the\nGrayImage input contains all integer values, we convert to a FloatMatrix\nto allow easier manipulation.");
	addPort(input.setPort("input",this,MESSAGE));
	addPort(dataOutput.setPort("dataOutput",this,FLOAT_MATRIX_ENV));
	addPort(frameIdOutput.setPort("frameIdOutput",this,INT));


}

void DEImageToMx::go() {
# line 34 "DEImageToMx.pl"
completionTime = arrivalTime;

	  Envelope envp;
	  input.get().getMessage(envp);
	  TYPE_CHECK(envp, "GrayImage");
	  const GrayImage* imD = (const GrayImage*) envp.myData();

	  if (imD->fragmented() || imD->processed()) {
	    Error::abortRun(*this,
			    "Can't process fragmented or processed images.");
	    return;
	  }

	  int width = imD->retWidth();
	  int height = imD->retHeight();
	  unsigned const char* p = imD->constData();
	  FloatMatrix& matrix = *(new FloatMatrix(int(height),int(width)));

	  int np = int(width) * int(height);
	  for (int i = 0; i < np; i++)
	    matrix.entry(i) = double(int(*p++));
	  dataOutput.put(completionTime) << matrix;
	  frameIdOutput.put(completionTime) << imD->retId();
}

// prototype instance for known block list
static DEImageToMx proto;
static RegisterBlock registerBlock(proto,"ImageToMx");
