static const char file_id[] = "DEIntPacketize.pl";
// .cc file generated from DEIntPacketize.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEIntPacketize.h"
#include "IntVecData.h"

const char *star_nm_DEIntPacketize = "DEIntPacketize";

const char* DEIntPacketize :: className() const {return star_nm_DEIntPacketize;}

ISA_FUNC(DEIntPacketize,DEStar);

Block* DEIntPacketize :: makeNew() const { LOG_NEW; return new DEIntPacketize;}

DEIntPacketize::DEIntPacketize ()
{
	setDescriptor("Convert integer input data into a stream of packets.  A packet is produced\nwhen either an input appears on the demand input or when \"maxLength\" data\nvalues have arrived.  Note that this star produces a null packet\nif it receives a demand signal and there is no data.");
	addPort(data.setPort("data",this,INT));
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(output.setPort("output",this,MESSAGE));
	addState(maxLength.setState("maxLength",this,"50","Maximum packet length."));

# line 43 "DEIntPacketize.pl"
saveData = 0;
		data.triggers();
		data.before(demand);
}

DEIntPacketize::~DEIntPacketize() {
# line 66 "DEIntPacketize.pl"
LOG_DEL; delete [] saveData;
}

void DEIntPacketize::setup() {
# line 48 "DEIntPacketize.pl"
LOG_DEL; delete [] saveData;
		LOG_NEW; saveData = new int[int(maxLength)];
		idx = 0;
}

void DEIntPacketize::go() {
# line 53 "DEIntPacketize.pl"
if (data.dataNew)
			saveData[idx++] = data.get();
		if (demand.dataNew || idx == int(maxLength)) {
			demand.dataNew = FALSE;
			// create a IntVecData and embed it in an Envelope.
			LOG_NEW; IntVecData *p = new IntVecData(idx, saveData);
			Envelope env(*p);
			// copy the Envelope to the output
			output.put(arrivalTime) << env;
			idx = 0;
		}
}

// prototype instance for known block list
static DEIntPacketize proto;
static RegisterBlock registerBlock(proto,"IntPacketize");
