static const char file_id[] = "DEIntUnPacketize.pl";
// .cc file generated from DEIntUnPacketize.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEIntUnPacketize.h"

const char *star_nm_DEIntUnPacketize = "DEIntUnPacketize";

const char* DEIntUnPacketize :: className() const {return star_nm_DEIntUnPacketize;}

ISA_FUNC(DEIntUnPacketize,DEStar);

Block* DEIntUnPacketize :: makeNew() const { LOG_NEW; return new DEIntUnPacketize;}

DEIntUnPacketize::DEIntUnPacketize ()
{
	setDescriptor("Convert a stream of packets into integer output data.  The \"data\"\ninput feeds packets to the star.  Whenever a packet arrives, the\nprevious packet, if any, is discarded; any remaining contents are\nthrown away.  The \"demand\" input requests output data.  If there is no\ndata left in the current packet, the last output datum is repeated\n(zero is used if there has never been a packet).  Otherwise the next\ndata value from the current input packet is output.");
	addPort(data.setPort("data",this,MESSAGE));
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(output.setPort("output",this,INT));

# line 42 "DEIntUnPacketize.pl"
data.triggers();
		data.before(demand);
}

void DEIntUnPacketize::setup() {
# line 46 "DEIntUnPacketize.pl"
idx = 0;
		currentMessage = 0;
		lastOutput = 0;
}

void DEIntUnPacketize::go() {
# line 51 "DEIntUnPacketize.pl"
if (data.dataNew) {
			// a new message has arrived
			data.get().getMessage(env);
			idx = 0;
			TYPE_CHECK(env,"IntVecData");
			currentMessage = (const IntVecData*)env.myData();
		}
		if (demand.dataNew) {
			// need to write new output
			demand.dataNew = FALSE;
			if (currentMessage && idx < currentMessage->length())
				lastOutput = currentMessage->data[idx++];
			output.put(arrivalTime) << lastOutput;	
		}
}

// prototype instance for known block list
static DEIntUnPacketize proto;
static RegisterBlock registerBlock(proto,"IntUnPacketize");
