static const char file_id[] = "DELogic.pl";
// .cc file generated from DELogic.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DELogic.h"

const char *star_nm_DELogic = "DELogic";

const char* DELogic :: className() const {return star_nm_DELogic;}

ISA_FUNC(DELogic,DEStar);

Block* DELogic :: makeNew() const { LOG_NEW; return new DELogic;}

# line 51 "DELogic.pl"
#define NOTID 0
#define ANDID 1
#define NANDID 2
#define ORID 3
#define NORID 4
#define XORID 5
#define XNORID 6

DELogic::DELogic ()
{
	setDescriptor("This star applies a logical operation to any number of inputs.\nThe inputs are integers interpreted as Booleans,\nwhere zero is a FALSE and nonzero is a TRUE.\nThe logical operations supported are {NOT AND NAND OR NOR XOR XNOR}.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(logic.setState("logic",this,"AND","The test logic: one of NOT AND NAND OR NOR XOR or XNOR"));


}

void DELogic::setup() {
# line 63 "DELogic.pl"
const char* cn = logic;
		if ( strcasecmp ( cn, "NOT") == 0) {
		    test = NOTID;
		    if (input.numberPorts() > 1)
			Error::abortRun(*this,
			    "NOT operation can only have one input");
		}
		else if ( strcasecmp ( cn, "AND") == 0) test = ANDID;
		else if ( strcasecmp ( cn, "NAND") == 0) test = NANDID;
		else if ( strcasecmp ( cn, "OR") == 0) test = ORID;
		else if ( strcasecmp ( cn, "NOR") == 0) test = NORID;
		else if ( strcasecmp ( cn, "XOR") == 0) test = XORID;
		else if ( strcasecmp ( cn, "XNOR") == 0) test = XNORID;
		else Error::abortRun(*this,"Unrecognized test.");
}

void DELogic::go() {
# line 79 "DELogic.pl"
InDEMPHIter nexti(input);
	    InDEPort *p;
	    int result = 0;

	    switch( test ) {
		case NOTID:
		    p = nexti++;
		    result = !int(p->get());
		    break;
		case ANDID:
		case NANDID:
		    result = 1;
		    while ((p = nexti++) != 0)
			result = result && int(p->get());
		    if (test == NANDID) result = !result;
		    break;
		case ORID:
		case NORID:
		    result = 0;
		    while ((p = nexti++) != 0)
			result = result || int(p->get());
		    if (test == NORID) result = !result;
		    break;
		case XORID:
		case XNORID:
		    result = 0;
		    while ((p = nexti++) != 0)
			if (int(p->get())) result = !result;
		    if (test == XNORID) result = !result;
		    break;
	    }
	    output.put(arrivalTime) << result;
}

// prototype instance for known block list
static DELogic proto;
static RegisterBlock registerBlock(proto,"Logic");
