static const char file_id[] = "DEMeasureDelay.pl";
// .cc file generated from DEMeasureDelay.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEMeasureDelay.h"

const char *star_nm_DEMeasureDelay = "DEMeasureDelay";

const char* DEMeasureDelay :: className() const {return star_nm_DEMeasureDelay;}

ISA_FUNC(DEMeasureDelay,DEStar);

Block* DEMeasureDelay :: makeNew() const { LOG_NEW; return new DEMeasureDelay;}

DEMeasureDelay::DEMeasureDelay ()
{
	setDescriptor("Measure the time difference between the first arrival\nand the second arrival of an event with the same value.\nThe second arrival and the time difference are each sent to outputs.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(timeDiff.setPort("timeDiff",this,FLOAT));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);

# line 52 "DEMeasureDelay.pl"
input.triggers(output);
}

void DEMeasureDelay::wrapup() {
# line 87 "DEMeasureDelay.pl"
while (firstArrivalQ.length() > 0) {
			Particle* p = (Particle*)firstArrivalQ.getFirstElem();
			p->die();
		}
}

DEMeasureDelay::~DEMeasureDelay() {
# line 93 "DEMeasureDelay.pl"
wrapup();	// in case it was not called before
}

void DEMeasureDelay::setup() {
# line 55 "DEMeasureDelay.pl"
firstArrivalQ.initialize();
}

void DEMeasureDelay::go() {
# line 59 "DEMeasureDelay.pl"
// get input
		completionTime = arrivalTime;
		Particle& value = input%0;

		// go though the queue to check if it is a second arrival
		int len = firstArrivalQ.length();
		firstArrivalQ.reset();
		while (len > 0) {
			LevelLink* h = firstArrivalQ.next();
			if (value == *(Particle*)(h->e)) {
			   // yes, match! --> output
			   timeDiff.put(completionTime) <<
				   completionTime - h->level;
			   Particle* oldp = (Particle*) h->e;
			   output.put(completionTime) = *oldp;
			   oldp->die();
			   firstArrivalQ.extract(h);
			   return;
			}
			len--;
		}
		// no match, register the event into the queue
		Particle* newp = value.clone();
		firstArrivalQ.levelput(newp, arrivalTime);
}

// prototype instance for known block list
static DEMeasureDelay proto;
static RegisterBlock registerBlock(proto,"MeasureDelay");
