static const char file_id[] = "DEMxToImage.pl";
// .cc file generated from DEMxToImage.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEMxToImage.h"
#include "GrayImage.h"
#include "Matrix.h"

const char *star_nm_DEMxToImage = "DEMxToImage";

const char* DEMxToImage :: className() const {return star_nm_DEMxToImage;}

ISA_FUNC(DEMxToImage,DEStar);

Block* DEMxToImage :: makeNew() const { LOG_NEW; return new DEMxToImage;}

DEMxToImage::DEMxToImage ()
{
	setDescriptor("Accept FloatMatrix input and creates a GrayImage output.  Note that the\ndouble values of the FloatMatrix are converted to the integer values\nof the GrayImage representation.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(frameId.setPort("frameId",this,INT));
	addPort(output.setPort("output",this,MESSAGE));


}

void DEMxToImage::setup() {
# line 37 "DEMxToImage.pl"
}

void DEMxToImage::go() {
# line 39 "DEMxToImage.pl"
if (input.dataNew && frameId.dataNew) {
	    completionTime = arrivalTime;

	    Envelope pkt;
	    input.get().getMessage(pkt);
	    const FloatMatrix& matrix = *(const FloatMatrix*)pkt.myData();

	    int width = matrix.numCols();
	    int height = matrix.numRows();

	    int id = int(frameId.get());
	    LOG_NEW; GrayImage* imgData = new GrayImage(width, height, id);
	    unsigned char* d = imgData->retData();
	    
	    int	np = int(width)*int(height);
	    for (int i = 0; i < np; i++) {
	      if (matrix.entry(i) < 0)
		*d++ = 0;
	      else if(matrix.entry(i) > 255)
		*d++ = 255;
	      else *d++ = int(matrix.entry(i)); // convert to int
	    }
	    Envelope envp(*imgData);
	    output.put(completionTime) << envp;
	  }
}

// prototype instance for known block list
static DEMxToImage proto;
static RegisterBlock registerBlock(proto,"MxToImage");
