static const char file_id[] = "DEPacketize.pl";
// .cc file generated from DEPacketize.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEPacketize.h"
#include "FloatVecData.h"

const char *star_nm_DEPacketize = "DEPacketize";

const char* DEPacketize :: className() const {return star_nm_DEPacketize;}

ISA_FUNC(DEPacketize,DEStar);

Block* DEPacketize :: makeNew() const { LOG_NEW; return new DEPacketize;}

DEPacketize::DEPacketize ()
{
	setDescriptor("Convert floating-point input data into a stream of packets of type FloatVecData.\nA packet is produced when either an input appears on the demand input or when\n\"maxLength\" data values have arrived.  Note that a null packet is produced if\na demand signal arrives and there is no data.");
	addPort(data.setPort("data",this,FLOAT));
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(output.setPort("output",this,MESSAGE));
	addState(maxLength.setState("maxLength",this,"50","Maximum packet length"));

# line 43 "DEPacketize.pl"
saveData = 0;
		data.triggers();
		data.before(demand);
}

DEPacketize::~DEPacketize() {
# line 66 "DEPacketize.pl"
LOG_DEL; delete [] saveData;
}

void DEPacketize::setup() {
# line 48 "DEPacketize.pl"
LOG_DEL; delete [] saveData;
		LOG_NEW; saveData = new float[int(maxLength)];
		idx = 0;
}

void DEPacketize::go() {
# line 53 "DEPacketize.pl"
if (data.dataNew)
			saveData[idx++] = data.get();
		if (demand.dataNew || idx == int(maxLength)) {
			demand.dataNew = FALSE;
			// create a FloatVecData and imbed it in an Envelope
			LOG_NEW; FloatVecData *p = new FloatVecData(idx,saveData);
			Envelope env(*p);
			// copy the Envelope to the output
			output.put(arrivalTime) << env;
			idx = 0;
		}
}

// prototype instance for known block list
static DEPacketize proto;
static RegisterBlock registerBlock(proto,"Packetize");
