static const char file_id[] = "DEPassGate.pl";
// .cc file generated from DEPassGate.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEPassGate.h"

const char *star_nm_DEPassGate = "DEPassGate";

const char* DEPassGate :: className() const {return star_nm_DEPassGate;}

ISA_FUNC(DEPassGate,DEStar);

Block* DEPassGate :: makeNew() const { LOG_NEW; return new DEPassGate;}

DEPassGate::DEPassGate ()
{
	setDescriptor("If the gate is open, particles pass from \"input\" to \"output\".\nWhen the gate is closed, no outputs are produced.\nIf \"input\" particles arrive while the gate is closed, the most\nrecent one will be passed to \"output\" when the gate is re-opened.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(gateOpen.setState("gateOpen",this,"TRUE","Gate position."));

# line 39 "DEPassGate.pl"
control.triggers();
		// Hint to the scheduler that given a choice, stars feeding
		// the control input should fire before stars feeding the
		// "input" input.
		control.before(input);
}

void DEPassGate::go() {
# line 46 "DEPassGate.pl"
if (control.dataNew)
		    // Set gateOpen state equal to control input
		    gateOpen = int(control.get());

		// receive the normal input
		if (input.dataNew && int(gateOpen))
		    output.put(arrivalTime) = input.get();
}

// prototype instance for known block list
static DEPassGate proto;
static RegisterBlock registerBlock(proto,"PassGate");
