static const char file_id[] = "DEPoisson.pl";
// .cc file generated from DEPoisson.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEPoisson.h"
#include <ACG.h>

const char *star_nm_DEPoisson = "DEPoisson";

const char* DEPoisson :: className() const {return star_nm_DEPoisson;}

ISA_FUNC(DEPoisson,DERepeatStar);

Block* DEPoisson :: makeNew() const { LOG_NEW; return new DEPoisson;}

# line 41 "DEPoisson.pl"
extern ACG* gen;

DEPoisson::DEPoisson ()
{
	setDescriptor("Generate events according to a Poisson process. The first event comes out at time zero.\nThe mean inter-arrival time and magnitude of the events are given as parameters.");
	addPort(output.setPort("output",this,FLOAT));
	addState(meanTime.setState("meanTime",this,"1.0","The mean inter-arrival time."));
	addState(magnitude.setState("magnitude",this,"1.0","The magnitude of samples generated."));

# line 44 "DEPoisson.pl"
random = 0;
}

DEPoisson::~DEPoisson() {
# line 47 "DEPoisson.pl"
LOG_DEL; delete random;
}

void DEPoisson::setup() {
# line 50 "DEPoisson.pl"
LOG_DEL; delete random;
		LOG_NEW; random = new NegativeExpntl(double(meanTime),gen);
}

void DEPoisson::go() {
# line 54 "DEPoisson.pl"
// Generate the output event
	   // (Recall that the first event comes out at time 0).
	   output.put(completionTime) << double(magnitude);

	   // and schedule the next firing
	   refireAtTime(completionTime);

	   // Generate an exponential random variable.
	   double p = (*random)();

	   // Turn it into an exponential, and add to completionTime
	   completionTime += p;
}

// prototype instance for known block list
static DEPoisson proto;
static RegisterBlock registerBlock(proto,"Poisson");
