static const char file_id[] = "DEPrinter.pl";
// .cc file generated from DEPrinter.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEPrinter.h"

const char *star_nm_DEPrinter = "DEPrinter";

const char* DEPrinter :: className() const {return star_nm_DEPrinter;}

ISA_FUNC(DEPrinter,DEStar);

Block* DEPrinter :: makeNew() const { LOG_NEW; return new DEPrinter;}

DEPrinter::DEPrinter ()
{
	setDescriptor("Print the value of each arriving event, together with its time of arrival.\nThe \"fileName\" parameter specifies the file to be written;\nthe special names <stdout> and <cout> (specifying the standard output stream),\nand <stderr> and <cerr> specifying the standard error stream, are also supported.");
	addPort(input.setPort("input",this,ANYTYPE));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output"));

# line 41 "DEPrinter.pl"
p_out = 0;
}

DEPrinter::~DEPrinter() {
# line 44 "DEPrinter.pl"
LOG_DEL; delete p_out;
}

void DEPrinter::setup() {
# line 47 "DEPrinter.pl"
// in case file was open from previous run w/o wrapup call
		LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
}

void DEPrinter::go() {
# line 52 "DEPrinter.pl"
pt_ofstream& output = *p_out;
		// detect which input has an event and print out the
		// value and arrivalTime.
		InDEMPHIter nextp(input);
		int j = input.numberPorts();
		for(int i=1; i <= j; i++) {
			InDEPort& p = *nextp++;
			if (p.dataNew) {
				output << "(port#" << i << ") " <<
				"at time " << arrivalTime << " : value > "
				<< (p.get()).print() << "\n";
			}
		}
}

// prototype instance for known block list
static DEPrinter proto;
static RegisterBlock registerBlock(proto,"Printer");
