static const char file_id[] = "DEPriorityCheck.pl";
// .cc file generated from DEPriorityCheck.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEPriorityCheck.h"
#include "NetworkCell.h"

const char *star_nm_DEPriorityCheck = "DEPriorityCheck";

const char* DEPriorityCheck :: className() const {return star_nm_DEPriorityCheck;}

ISA_FUNC(DEPriorityCheck,DEStar);

Block* DEPriorityCheck :: makeNew() const { LOG_NEW; return new DEPriorityCheck;}

DEPriorityCheck::DEPriorityCheck ()
{
	setDescriptor("This star reads in input \"NetworkCell\" packets\nfrom multiple input sources. If the priority of an input NetworkCell\nis less than the most recent \"priority\" input, then the cell is\nsent to the \"discard\" output. Otherwise it is sent to the \"output\"\nport.");
	addPort(input.setPort("input",this,MESSAGE));
	addPort(priority.setPort("priority",this,INT));
	addPort(output.setPort("output",this,MESSAGE));
	addPort(discard.setPort("discard",this,MESSAGE));

# line 29 "DEPriorityCheck.pl"
input.before(priority);
		priority.triggers();
		input.triggers(output);
		input.triggers(discard);
}

void DEPriorityCheck::setup() {
# line 36 "DEPriorityCheck.pl"
cutLevel = 0;
}

void DEPriorityCheck::go() {
# line 39 "DEPriorityCheck.pl"
completionTime = arrivalTime;

		while (priority.dataNew) {
			cutLevel = priority.get();
			priority.getSimulEvent();
		}

		while (input.dataNew) {
			Envelope envp;
			input.get().getMessage(envp);
			TYPE_CHECK(envp, "NetworkCell");
			const NetworkCell* cell = (const NetworkCell*)
					envp.myData();
			if (int(*cell) >= cutLevel)
				output.put(completionTime) << envp;
			else
				discard.put(completionTime) << envp;
			input.getSimulEvent();
		}
}

// prototype instance for known block list
static DEPriorityCheck proto;
static RegisterBlock registerBlock(proto,"PriorityCheck");
