static const char file_id[] = "DEPulseGen.pl";
// .cc file generated from DEPulseGen.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEPulseGen.h"

const char *star_nm_DEPulseGen = "DEPulseGen";

const char* DEPulseGen :: className() const {return star_nm_DEPulseGen;}

ISA_FUNC(DEPulseGen,DERepeatStar);

Block* DEPulseGen :: makeNew() const { LOG_NEW; return new DEPulseGen;}

DEPulseGen::DEPulseGen ()
{
	setDescriptor("This star generates events with specified values at specified moments.\nThe events are specified in the \"value\" array, which consists of\ntime-value pairs, given in the syntax of complex numbers.");
	addPort(output.setPort("output",this,FLOAT));
	addState(value.setState("value",this,"(0,1) (1,0)","value"));


}

void DEPulseGen::setup() {
# line 34 "DEPulseGen.pl"
pos = 0;
}

void DEPulseGen::go() {
# line 37 "DEPulseGen.pl"
// first event comes at time 0
    // check whether the first event is too early
    if (arrivalTime >= real(value[pos]))
    {
      output.put(real(value[pos])) << double(imag(value[pos]));
      pos++;
    }
    if (pos < value.size())
    {
      refireAtTime(real(value[pos]));
    }
}

// prototype instance for known block list
static DEPulseGen proto;
static RegisterBlock registerBlock(proto,"PulseGen");
