static const char file_id[] = "DEQueueBase.pl";
// .cc file generated from DEQueueBase.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEQueueBase.h"

const char *star_nm_DEQueueBase = "DEQueueBase";

const char* DEQueueBase :: className() const {return star_nm_DEQueueBase;}

ISA_FUNC(DEQueueBase,DEStar);

DEQueueBase::DEQueueBase ()
{
	setDescriptor("This is the  base class for FIFO and LIFO queues.\nThis star is not intended to be used except to derive useful stars.\nAll inputs are simply routed to the \"overflow\" output.  None are stored.");
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(inData.setPort("inData",this,ANYTYPE));
	addPort(outData.setPort("outData",this,ANYTYPE));
	outData.inheritTypeFrom(inData);
	addPort(size.setPort("size",this,INT));
	addPort(overflow.setPort("overflow",this,ANYTYPE));
	overflow.inheritTypeFrom(inData);
	addState(capacity.setState("capacity",this,"-1","Maximum size of the queue. If <0, capacity is infinite."));
	addState(numDemandsPending.setState("numDemandsPending",this,"1","Number of demands that have not yet stimulated outputs."));
	addState(consolidateDemands.setState("consolidateDemands",this,"TRUE","If FALSE, every demand eventually stimulates an output."));

# line 66 "DEQueueBase.pl"
// Indicate to the scheduler that size outputs are triggered
		// by inData or demand inputs.
		inData.triggers(size);
		demand.triggers(size);
		inData.triggers(overflow);

		// simultaneous inData events should be available in the
		// same firing with demand events
		inData.before(demand);

		// Following the general rule that if an input can trigger
		// an output with the same time stamp, we should identify
		// a trigger relationship:
		demand.triggers(outData);
}

void DEQueueBase::setup() {
# line 82 "DEQueueBase.pl"
infinite = (int(capacity) < 0);
}

void DEQueueBase::go() {
# line 117 "DEQueueBase.pl"
completionTime = arrivalTime;

	    while (demand.dataNew) {
		if (int(consolidateDemands))
			numDemandsPending = 1;
		else
			numDemandsPending = int(numDemandsPending) + 1;
		// get any pending simultaneous demand inputs.
		demand.getSimulEvent();
	    }

	    // If the queue has data, and one or more demands are pending,
	    // produce output data
	    while (int(numDemandsPending) > 0 && Qsize() > 0 ) {
		Particle* pp = (Particle*) dequeue();
		outData.put(completionTime) = *pp;
		pp->die();
		numDemandsPending = int(numDemandsPending) - 1;
	    }

	    // If there is new inData, store it
	    while (inData.dataNew) {
		enqueue();
		inData.getSimulEvent();
	    }

	    // Handle overflow
	    handleOverflow();

	    // output the queue size
	    size.put(completionTime) << Qsize();
}


int DEQueueBase::Qsize ()
{
# line 112 "DEQueueBase.pl"
return 0;
}


// DEQueueBase is an abstract class: no KnownBlock entry
