static const char file_id[] = "DERamp.pl";
// .cc file generated from DERamp.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DERamp.h"

const char *star_nm_DERamp = "DERamp";

const char* DERamp :: className() const {return star_nm_DERamp;}

ISA_FUNC(DERamp,DEStar);

Block* DERamp :: makeNew() const { LOG_NEW; return new DERamp;}

DERamp::DERamp ()
{
	setDescriptor("Produce an output event with a monotic value when stimulated\nby an input event. The value of the output event starts at \"value\" and\nincreases by \"step\" each time the star fires. The value of the input is ignored.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,FLOAT));
	addState(value.setState("value",this,"0.0","Starting and current state of the ramp."));
	addState(step.setState("step",this,"1.0","Size of the ramp increments."));


}

void DERamp::go() {
# line 40 "DERamp.pl"
// if the star is triggered, generate ramp output (ignore input).
	   completionTime = arrivalTime;
	   double t = value;
           output.put(completionTime) << t;
           t += double(step);
           value = t;
}

// prototype instance for known block list
static DERamp proto;
static RegisterBlock registerBlock(proto,"Ramp");
