static const char file_id[] = "DERanGen.pl";
// .cc file generated from DERanGen.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DERanGen.h"
#include <ACG.h>
#include <Uniform.h>
#include <Normal.h>
#include <NegExp.h>

const char *star_nm_DERanGen = "DERanGen";

const char* DERanGen :: className() const {return star_nm_DERanGen;}

ISA_FUNC(DERanGen,DEStar);

Block* DERanGen :: makeNew() const { LOG_NEW; return new DERanGen;}

# line 52 "DERanGen.pl"
extern ACG* gen;

DERanGen::DERanGen ()
{
	setDescriptor("This is a parameterized random number generator.  Upon receiving an input event,\nit generates a random number with a uniform(u), exponential(e), or normal(n)\ndistribution, as determined by the \"distribution\" parameter.  Depending on\nthe distribution, parameters also specify either the mean and variance or\nthe lower and upper extent of the range.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,FLOAT));
	addState(distribution.setState("distribution",this,"uniform","Uniform(u;U), exponential(e;E), normal(n;N)."));
	addState(meanORupper.setState("meanORupper",this,"0.0","Mean value or upper value."));
	addState(varianceORlower.setState("varianceORlower",this,"0.0","Variance or lower value."));

# line 55 "DERanGen.pl"
random = 0;
}

DERanGen::~DERanGen() {
# line 58 "DERanGen.pl"
LOG_DEL; delete random;
}

void DERanGen::setup() {
# line 61 "DERanGen.pl"
LOG_DEL; delete random;

		// decide which distribution.
		const char* dist = distribution;
		char  c = dist[0];
		double mOru = double(meanORupper);	// mean or upper
		double vOrl = double(varianceORlower);	// variance or lower

		switch (c) {
			case 'u' :
			case 'U' : LOG_NEW; random = new Uniform(vOrl, mOru, gen);
			   	   break;
			case 'e' :
			case 'E' : LOG_NEW; random = new NegativeExpntl(mOru, gen);
			   	   break;
			case 'n' :
			case 'N' : LOG_NEW; random = new Normal(mOru, vOrl, gen);
			   	   break;
			default :
			  Error::abortRun(*this, "unknown distribution.");
			  break;
		}
}

void DERanGen::go() {
# line 85 "DERanGen.pl"
// generate a random number
		double p = (*random)();
		// output
		completionTime = arrivalTime;
		output.put(completionTime) << p;
}

// prototype instance for known block list
static DERanGen proto;
static RegisterBlock registerBlock(proto,"RanGen");
