static const char file_id[] = "DERouter.pl";
// .cc file generated from DERouter.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DERouter.h"
#include <ACG.h>

const char *star_nm_DERouter = "DERouter";

const char* DERouter :: className() const {return star_nm_DERouter;}

ISA_FUNC(DERouter,DEStar);

Block* DERouter :: makeNew() const { LOG_NEW; return new DERouter;}

# line 32 "DERouter.pl"
extern ACG* gen;

DERouter::DERouter ()
{
	setDescriptor("Randomly route an input event to one of its outputs.\nThe probability is equal for each output. The time delay is zero.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);

# line 35 "DERouter.pl"
random = NULL;
}

DERouter::~DERouter() {
# line 38 "DERouter.pl"
LOG_DEL; delete random;
}

void DERouter::setup() {
# line 41 "DERouter.pl"
LOG_DEL; delete random;
		LOG_NEW; random = new Uniform(0,double(output.numberPorts()),gen);
}

void DERouter::go() {
# line 46 "DERouter.pl"
completionTime = arrivalTime;
	   // choose a output port randomly
	   double p = (*random)();
	   OutDEMPHIter nextp(output);
	   OutDEPort* pp = nextp++;
	   for (int i = int(p); i > 0 ; i--) {
		pp = nextp++;
	   }

	   // route the data to the chosen port
	   Particle& ip = input.get();
	   pp->put(completionTime) = ip;
}

// prototype instance for known block list
static DERouter proto;
static RegisterBlock registerBlock(proto,"Router");
