static const char file_id[] = "DESampler.pl";
// .cc file generated from DESampler.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DESampler.h"

const char *star_nm_DESampler = "DESampler";

const char* DESampler :: className() const {return star_nm_DESampler;}

ISA_FUNC(DESampler,DEStar);

Block* DESampler :: makeNew() const { LOG_NEW; return new DESampler;}

DESampler::DESampler ()
{
	setDescriptor("Sample the input at the times given by events on the \"clock\" input.\nThe data value of the \"clock\" input is ignored.\nIf no input is available at the time of sampling, the latest input\nis used.  If there has been no input, then a \"zero\" particle is produced.\nThe exact meaning of this depends on the particle type.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(clock.setPort("clock",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);

# line 33 "DESampler.pl"
input.triggers();
		input.before(clock);
}

void DESampler::go() {
# line 37 "DESampler.pl"
// Check to see whether the star was triggered by a clock input
	   if (clock.dataNew) {
		completionTime = arrivalTime;
		output.put(completionTime) = input%0;
		clock.dataNew = FALSE;
	   }
}

// prototype instance for known block list
static DESampler proto;
static RegisterBlock registerBlock(proto,"Sampler");
