static const char file_id[] = "DESeqATMSub.pl";
// .cc file generated from DESeqATMSub.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DESeqATMSub.h"

const char *star_nm_DESeqATMSub = "DESeqATMSub";

const char* DESeqATMSub :: className() const {return star_nm_DESeqATMSub;}

ISA_FUNC(DESeqATMSub,DESeqATMZero);

Block* DESeqATMSub :: makeNew() const { LOG_NEW; return new DESeqATMSub;}

DESeqATMSub::DESeqATMSub ()
{
	setDescriptor("This star reads in a sequence of SeqATMCells. It will\ncheck sequence numbers, and if a SeqATMCell is found\nmissing, the information bits of the previously arrived\nSeqATMCell will be output in its place.\n\nThe information bits from each correctly received\nSeqATMCell are unloaded and sent to the output port.");


}

DESeqATMSub::~DESeqATMSub() {
# line 68 "DESeqATMSub.pl"
LOG_DEL; delete [] reserve;
}

void DESeqATMSub::setup() {
# line 27 "DESeqATMSub.pl"
LOG_NEW; reserve = new int[ int( numInfoBits ) ];
		for ( int i = 0; i < numInfoBits; i++ )
			reserve[ i ] = 0;
		DESeqATMZero::setup();
}

void DESeqATMSub::go() {
# line 34 "DESeqATMSub.pl"
if ( input.dataNew ) {
			Envelope inPkt;
			input.get().getMessage( inPkt );
			TYPE_CHECK( inPkt, "SeqATMCell" );
			count %= 8;
			const SeqATMCell* voiceCell = ( const SeqATMCell* )
					inPkt.myData();

			// if packet missing, output previous packet
			while( ( voiceCell->readSeq() ) != count ) {
				for ( int i = 0; i < numInfoBits; i++ )
					output.put( arrivalTime ) << reserve[ i ];
				count++;
				count %= 8;
			}

			// output current packet and store in reserver
			for ( int j = headerLength;
					j < int( headerLength + numInfoBits ); j++ ) {
				if ( voiceCell->isON( j ) ) {
					output.put( arrivalTime ) << 1;
					reserve[ j - headerLength ] = 1;
				}
				else {
					output.put( arrivalTime ) << 0;
					reserve[ j - headerLength ] = 0;
				} // end else
			} // end for

			// increment count to test next packet sequence number
			count++;
		} // end if
}

// prototype instance for known block list
static DESeqATMSub proto;
static RegisterBlock registerBlock(proto,"SeqATMSub");
