static const char file_id[] = "DESeqATMZero.pl";
// .cc file generated from DESeqATMZero.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DESeqATMZero.h"

const char *star_nm_DESeqATMZero = "DESeqATMZero";

const char* DESeqATMZero :: className() const {return star_nm_DESeqATMZero;}

ISA_FUNC(DESeqATMZero,DEStar);

Block* DESeqATMZero :: makeNew() const { LOG_NEW; return new DESeqATMZero;}

DESeqATMZero::DESeqATMZero ()
{
	setDescriptor("This star reads in a sequence of SeqATMCell objects.\nFor each object input correctly in sequence, 'headerLength'\nbits are skipped over and the next 'numInfoBits' bits in the\ncell are output.\n\nIf this star finds that a SeqATMCell is missing by checking sequence\nnumbers, it will substitute 'numInfoBits' 0-bits for the missing\nbits.");
	addPort(input.setPort("input",this,MESSAGE));
	addPort(output.setPort("output",this,INT));
	addState(numInfoBits.setState("numInfoBits",this,"384","number of information bits per cell"));
	addState(headerLength.setState("headerLength",this,"40","Number of bits per cell header."));


}

void DESeqATMZero::setup() {
# line 44 "DESeqATMZero.pl"
count = 0;
}

void DESeqATMZero::go() {
# line 47 "DESeqATMZero.pl"
if ( input.dataNew ) {
			Envelope inPkt;
			input.get().getMessage( inPkt );
			TYPE_CHECK( inPkt, "SeqATMCell" );
			count %= 8;
			const SeqATMCell* voiceCell = ( const SeqATMCell* )
					inPkt.myData();

			// if packet missing, fill in with all 0s
			while ( ( voiceCell->readSeq() ) != count ) {
				for ( int i = 0; i < numInfoBits; ++i )
					output.put( arrivalTime ) << 0;
				count++;
				count %= 8;
			}

			// output the arrived packet's bits
			for ( int j = headerLength;
					j < int( headerLength + numInfoBits ); ++j ) {
				if ( voiceCell->isON( j ) )
					output.put( arrivalTime ) << 1;
				else
					output.put( arrivalTime ) << 0;
			}

			count++;
		} // end if
}

// prototype instance for known block list
static DESeqATMZero proto;
static RegisterBlock registerBlock(proto,"SeqATMZero");
