static const char file_id[] = "DEStack.pl";
// .cc file generated from DEStack.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEStack.h"
#include "DataStruct.h"

const char *star_nm_DEStack = "DEStack";

const char* DEStack :: className() const {return star_nm_DEStack;}

ISA_FUNC(DEStack,DEQueueBase);

Block* DEStack :: makeNew() const { LOG_NEW; return new DEStack;}

DEStack::DEStack ()
{
	setDescriptor("A stack with finite or infinite length.\nEvents on the \"demand\" input pop data from the stack to \"outData\" if the\nstack is not empty.  If it is empty, then a \"demand\" event enables the\nnext future \"inData\" particle to pass immediately to \"outData\".\nBy default, \"numDemandsPending\" is initialized to 1, so the first\nparticle to arrive at \"inData\" is passed directly to the output.\nIf \"consolidateDemands\" is set to TRUE (the default), then \"numDemandsPending\"\nis not permitted to rise above unity.\nThe size of the stack is sent to the \"size\" output whenever an \"inData\"\nor \"demand\" event is processed.  Input data that doesn't fit on the stack\nis sent to the \"overflow\" output.");


}

DEStack::~DEStack() {
# line 167 "DEStack.pl"
zapStack();
}

void DEStack::setup() {
# line 163 "DEStack.pl"
DEQueueBase::setup();
		zapStack();
}


void DEStack::enqueue ()
{
# line 105 "DEStack.pl"
// Push new data, ignoring capacity limitations.
		    stack.pushTop(inData.get().clone());
}


Pointer DEStack::dequeue ()
{
# line 115 "DEStack.pl"
return stack.popTop();
}


void DEStack::handleOverflow ()
{
# line 124 "DEStack.pl"
// If any demands are pending, deal with them now
		    while (int(numDemandsPending) > 0 && Qsize() > 0 ) {
			Particle* p = (Particle*) dequeue();
			outData.put(completionTime) = *p;
			p->die();
			numDemandsPending = int(numDemandsPending) - 1;
		    }

		    // If capacity is finite, and stack is over full,
		    // pop until capacity
		    if (!infinite) {
			while (Qsize() > int(capacity)) {
			    Particle* pp = (Particle*) stack.popTop();
		    	    overflow.put(completionTime) = *pp;
			    pp->die();
			}
		    }
}


int DEStack::Qsize ()
{
# line 149 "DEStack.pl"
return stack.size();
}


void DEStack::zapStack ()
{
# line 155 "DEStack.pl"
while (Qsize() > 0) {
				Particle* pp = (Particle*) stack.popTop();
				pp->die();
			}
			stack.initialize();
}


// prototype instance for known block list
static DEStack proto;
static RegisterBlock registerBlock(proto,"Stack");
