static const char file_id[] = "DEStatistics.pl";
// .cc file generated from DEStatistics.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEStatistics.h"

const char *star_nm_DEStatistics = "DEStatistics";

const char* DEStatistics :: className() const {return star_nm_DEStatistics;}

ISA_FUNC(DEStatistics,DEStar);

Block* DEStatistics :: makeNew() const { LOG_NEW; return new DEStatistics;}

DEStatistics::DEStatistics ()
{
	setDescriptor("Calculate the average and variance of the\ninput values that have arrived since the last reset.\nAn output is generated when a \"demand\" input is received.\nWhen a \"reset\" input arrives, the calculations are restarted.\nWhen \"demand\" and \"reset\" particles arrive at the same time,\nan output is produced before the calculations are restarted.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(reset.setPort("reset",this,ANYTYPE));
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(average.setPort("average",this,FLOAT));
	addPort(variance.setPort("variance",this,FLOAT));

# line 60 "DEStatistics.pl"
input.triggers();
		reset.triggers();
		setMode(PHASE);
}

void DEStatistics::setup() {
# line 65 "DEStatistics.pl"
previous = 0;
		sum = 0;
		squareSum = 0;
		startTime = -1.0;
}

void DEStatistics::go() {
# line 71 "DEStatistics.pl"
int flag = 0;
		// on demand input
		if (demand.dataNew) {
			demand.dataNew = FALSE;
			if (startTime < 0 ) return;
			double leng = arrivalTime - startTime;
			double span = arrivalTime - completionTime;
			sum += previous * span;
			squareSum += previous*previous*span;
			flag = 1;
			// output
			if (leng) {
			   double t1 = sum/leng;
			   average.put(arrivalTime) << t1;
			   variance.put(arrivalTime) << squareSum/leng - t1*t1;
			}
		}
		// check reset input
		if (reset.dataNew) {
			reset.dataNew = FALSE;
			startTime = arrivalTime;
			sum = 0; squareSum = 0; previous = 0;
		}
		// on normal input
		while (input.dataNew) {
			if (startTime < 0) {
			      startTime = arrivalTime;
			} else if (!flag) {
			   	double span = arrivalTime - completionTime;
			 	sum += previous * span;
			     	squareSum += previous * previous * span;
			}
			previous = input.get();
			// renew the completionTime
			completionTime = arrivalTime;
		}
		// renew the completionTime
		completionTime = arrivalTime;
}

// prototype instance for known block list
static DEStatistics proto;
static RegisterBlock registerBlock(proto,"Statistics");
