static const char file_id[] = "DETest.pl";
// .cc file generated from DETest.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETest.h"

const char *star_nm_DETest = "DETest";

const char* DETest :: className() const {return star_nm_DETest;}

ISA_FUNC(DETest,DEStar);

Block* DETest :: makeNew() const { LOG_NEW; return new DETest;}

# line 67 "DETest.pl"
#define EQID 0
#define NEID 1
#define LTID 2
#define LEID 3
#define GTID 4
#define GEID 5

DETest::DETest ()
{
	setDescriptor("This star compares two inputs.  The test condition can be any of\n{EQ NE LT LE GT GE} or {== != < <= > >=}, resulting in equals,\nnot equals, less-than, less-than or equals, etc.\n\nIf \"crossingsOnly\" is TRUE, then an output event is generated only\nwhen the value of the output changes.  Hence the output events\nwill always alternate between true and false.");
	addPort(upper.setPort("upper",this,FLOAT));
	addPort(lower.setPort("lower",this,FLOAT));
	addPort(output.setPort("output",this,INT));
	addState(condition.setState("condition",this,"EQ","The test condition: one of EQ NE LT LE GT or GE"));
	addState(crossingsOnly.setState("crossingsOnly",this,"FALSE","If TRUE, outputs occur only when the sense of the output changes."));


}

void DETest::setup() {
# line 81 "DETest.pl"
// Initial value indicates that flag has not yet gotten the result of a test.
		// This ensures that the first test result will always be output.
		flag = -1;
		left = right = 0.0;

		const char* cn = condition;
		if ( strcasecmp ( cn, "EQ") == 0) test = EQID;
		else if ( strcasecmp ( cn, "NE") == 0) test = NEID;
		else if ( strcasecmp ( cn, "LT") == 0) test = LTID;
		else if ( strcasecmp ( cn, "LE") == 0) test = LEID;
		else if ( strcasecmp ( cn, "GT") == 0) test = GTID;
		else if ( strcasecmp ( cn, "GE") == 0) test = GEID;
		else if ( strcasecmp ( cn, "==") == 0) test = EQID;
		else if ( strcasecmp ( cn, "!=") == 0) test = NEID;
		else if ( strcasecmp ( cn, "<") == 0) test = LTID;
		else if ( strcasecmp ( cn, "<=") == 0) test = LEID;
		else if ( strcasecmp ( cn, ">") == 0) test = GTID;
		else if ( strcasecmp ( cn, ">=") == 0) test = GEID;
}

void DETest::go() {
# line 102 "DETest.pl"
int result=0;

		completionTime = arrivalTime;

		if (upper.dataNew) left = double(upper%0);
		if (lower.dataNew) right = double(lower%0);

		// compare the values
		switch( test ) {
			case EQID:  result  =  left == right;  break;
			case NEID:  result  =  left != right;  break;
			case LTID:  result  =  left <  right;  break;
			case LEID:  result  =  left <= right;  break;
			case GTID:  result  =  left >  right;  break;
			case GEID:  result  =  left >= right;  break;
		}
		if (int(crossingsOnly)) {
			if (flag != result) {
				output.put(completionTime) << result;
			} 
		} else output.put(completionTime) << result;
		flag = result;
}

// prototype instance for known block list
static DETest proto;
static RegisterBlock registerBlock(proto,"Test");
