static const char file_id[] = "DETestLevel.pl";
// .cc file generated from DETestLevel.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETestLevel.h"

const char *star_nm_DETestLevel = "DETestLevel";

const char* DETestLevel :: className() const {return star_nm_DETestLevel;}

ISA_FUNC(DETestLevel,DEStar);

Block* DETestLevel :: makeNew() const { LOG_NEW; return new DETestLevel;}

DETestLevel::DETestLevel ()
{
	setDescriptor(".pp\nThis star detects threshold crossings if \"crossingsOnly\" is TRUE.\nOtherwise, it simply compares the input against the \"threshold\".\n.lp\nIf \"crossingsOnly\" is TRUE, then: \n.ip 1)\nA TRUE is sent to \"output\" when the \"input\" particle exceeds or\nequals the \"threshold\" value, having been previously smaller.\n.ip 2)\n A FALSE is sent when the \"input\" particle is smaller than\n\"threshold\" having been previously larger.\n.lp\nOtherwise, no output is produced.\n.pp\nIf \"crossingsOnly\" is FALSE, then a TRUE is sent to \"output\"\nwhenever any \"input\" particle greater than or equal to \"threshold\"\nis received, and a FALSE is sent otherwise.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,INT));
	addState(threshold.setState("threshold",this,"10","The level for comparison against input particles."));
	addState(crossingsOnly.setState("crossingsOnly",this,"TRUE","If TRUE, outputs occur only on level crossings."));


}

void DETestLevel::setup() {
# line 66 "DETestLevel.pl"
flag = FALSE;
}

void DETestLevel::go() {
# line 70 "DETestLevel.pl"
completionTime = arrivalTime;

		// compare the input value with the "threshold"
		if (double(input%0) < double(threshold)) {
		   if (int(crossingsOnly)) {
			if (flag == TRUE) {
				flag = FALSE;
				// Indicate downward level crossing
				output.put(completionTime) << flag;
			} 
		   } else output.put(completionTime) << FALSE;
		} else {
		   if (int(crossingsOnly)) {
			if (flag == FALSE) {
				flag = TRUE;
				// send output
				output.put(completionTime) << flag;
			}
		   } else output.put(completionTime) << TRUE;
		}
}

// prototype instance for known block list
static DETestLevel proto;
static RegisterBlock registerBlock(proto,"TestLevel");
