static const char file_id[] = "DETimeout.pl";
// .cc file generated from DETimeout.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETimeout.h"

const char *star_nm_DETimeout = "DETimeout";

const char* DETimeout :: className() const {return star_nm_DETimeout;}

ISA_FUNC(DETimeout,DETimeoutStar);

Block* DETimeout :: makeNew() const { LOG_NEW; return new DETimeout;}

DETimeout::DETimeout ()
{
	setDescriptor("This star detects time-out conditions and generates an alarm if too\nmuch time elapses before resetting or stopping the timer.  Events\narriving on the \"Set\" input reset and start the timer.  Events arriving\non the \"Clear\" input stop the timer.  If no \"Set\" or \"Clear\" events\narrive within \"timeout\" time units of the most recent \"Set\", then that\n\"Set\" event is sent out the \"alarm\" output.");
	addPort(Set.setPort("Set",this,ANYTYPE));
	addPort(Clear.setPort("Clear",this,ANYTYPE));
	addPort(alarm.setPort("alarm",this,ANYTYPE));
	alarm.inheritTypeFrom(Set);


}

void DETimeout::go() {
# line 46 "DETimeout.pl"
if (Clear.dataNew) {
	    Clear.dataNew = FALSE;
	    clear();
	}

	if (Set.dataNew) {
	    Set.dataNew = FALSE;
	    set();
	}

	if (expired()) {
	    // Output the event which started the timer.
	    alarm.put(arrivalTime) = Set%0;
	}
}

// prototype instance for known block list
static DETimeout proto;
static RegisterBlock registerBlock(proto,"Timeout");
