static const char file_id[] = "DETimeoutStar.pl";
// .cc file generated from DETimeoutStar.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETimeoutStar.h"

const char *star_nm_DETimeoutStar = "DETimeoutStar";

const char* DETimeoutStar :: className() const {return star_nm_DETimeoutStar;}

ISA_FUNC(DETimeoutStar,DERepeatStar);

Block* DETimeoutStar :: makeNew() const { LOG_NEW; return new DETimeoutStar;}

DETimeoutStar::DETimeoutStar ()
{
	setDescriptor("This is the base class for stars that check time-out conditions.\nThe methods \"set\", \"clear\", and \"expired\" are provided for\nsetting and testing the timer.");
	addState(timeout.setState("timeout",this,"1.0","Duration of the timeout."));


}


void DETimeoutStar::set ()
{
# line 46 "DETimeoutStar.pl"
safe = FALSE;
	    expireFlag = FALSE;
	    deadline = arrivalTime + timeout;
	    refireAtTime(deadline);
}


void DETimeoutStar::clear ()
{
# line 57 "DETimeoutStar.pl"
safe = TRUE;
	    expireFlag = FALSE;
}


int DETimeoutStar::expired ()
{
# line 66 "DETimeoutStar.pl"
return expireFlag;
}


void DETimeoutStar::initialize ()
{
# line 75 "DETimeoutStar.pl"
clear();
	    DERepeatStar::initialize();
}


int DETimeoutStar::run ()
{
# line 85 "DETimeoutStar.pl"
if (canGetFired()) { 	// time-out event
		if (!safe && arrivalTime == deadline)
		    expireFlag = TRUE;
	    }
	    return DERepeatStar::run();
}


// prototype instance for known block list
static DETimeoutStar proto;
static RegisterBlock registerBlock(proto,"TimeoutStar");
