static const char file_id[] = "DETimer.pl";
// .cc file generated from DETimer.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETimer.h"

const char *star_nm_DETimer = "DETimer";

const char* DETimer :: className() const {return star_nm_DETimer;}

ISA_FUNC(DETimer,DEStar);

Block* DETimer :: makeNew() const { LOG_NEW; return new DETimer;}

DETimer::DETimer ()
{
	setDescriptor("Upon receiving a \"trigger\" input, output the elapsed real time\nin seconds, divided by \"timeScale\", since the last reset input,\nor since the start of the simulation if no reset has\nbeen received.  The time stamp on the output is the same as\nthat of the \"trigger\" input. The time in seconds is related to the\nscheduler time through the scaling factor \"timeScale\".");
	addState(timeScale.setState("timeScale",this,"1.0","Duration of a scheduler time unit in seconds."));
	addPort(trigger.setPort("trigger",this,ANYTYPE));
	addPort(reset.setPort("reset",this,ANYTYPE));
	addPort(elapsedTime.setPort("elapsedTime",this,FLOAT));


}

void DETimer::setup() {
# line 58 "DETimer.pl"
clock.reset();
}

void DETimer::go() {
# line 63 "DETimer.pl"
TimeVal now = clock.elapsedTime();

	if (trigger.dataNew)
	{
	    trigger.dataNew = FALSE;
	    if (reset.dataNew)
	    {
		elapsedTime.put(arrivalTime) << 0.0;
	    }
	    else
	    {
		elapsedTime.put(arrivalTime) << (now / timeScale);
	    }
	}
	if (reset.dataNew)
	{
	    reset.dataNew = FALSE;
	    clock.reset();
	}
}

// prototype instance for known block list
static DETimer proto;
static RegisterBlock registerBlock(proto,"Timer");
