static const char file_id[] = "DEUDCounter.pl";
// .cc file generated from DEUDCounter.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEUDCounter.h"

const char *star_nm_DEUDCounter = "DEUDCounter";

const char* DEUDCounter :: className() const {return star_nm_DEUDCounter;}

ISA_FUNC(DEUDCounter,DEStar);

Block* DEUDCounter :: makeNew() const { LOG_NEW; return new DEUDCounter;}

DEUDCounter::DEUDCounter ()
{
	setDescriptor("This is an up/down counter.\nThe processing order of the ports is: countUp -> countDown -> demand -> reset.\nSpecifically, all simultaneous \"countUp\" inputs are processed.\nThen all simultaneous \"countDown\" inputs are processed.\nIf there are multiple simultaneous \"demand\" inputs, all but the first\nare ignored.  Only one output will be produced.");
	addPort(countUp.setPort("countUp",this,ANYTYPE));
	addPort(countDown.setPort("countDown",this,ANYTYPE));
	addPort(reset.setPort("reset",this,ANYTYPE));
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(output.setPort("output",this,INT));
	addState(resetValue.setState("resetValue",this,"0","Initial value for the counter."));

# line 67 "DEUDCounter.pl"
countUp.triggers();
		countDown.triggers();
		reset.triggers();

		// The following statements hint to the scheduler that
		// if given a choice, stars feeding data to the countUp,
		// countDown, and reset inputs should fire before stars
		// feeding data to the demand input.
		countUp.before(demand);
		countDown.before(demand);
		reset.before(demand);
}

void DEUDCounter::setup() {
# line 80 "DEUDCounter.pl"
content = int(resetValue);
}

void DEUDCounter::go() {
# line 83 "DEUDCounter.pl"
completionTime = arrivalTime;

		// check the countUp/Down input to change the content.
		while (countUp.dataNew) {
			content++;
			countUp.getSimulEvent();
		}
		while (countDown.dataNew) {
			content--;
			countDown.getSimulEvent();
		}
		if (demand.dataNew) {
			output.put(completionTime) << content;
		}
		// swallow all demand inputs
		while (demand.dataNew) demand.getSimulEvent();

		while (reset.dataNew) {
			content = int(resetValue);
			reset.getSimulEvent();
		}
}

// prototype instance for known block list
static DEUDCounter proto;
static RegisterBlock registerBlock(proto,"UDCounter");
