static const char file_id[] = "DEUnPacketize.pl";
// .cc file generated from DEUnPacketize.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEUnPacketize.h"

const char *star_nm_DEUnPacketize = "DEUnPacketize";

const char* DEUnPacketize :: className() const {return star_nm_DEUnPacketize;}

ISA_FUNC(DEUnPacketize,DEStar);

Block* DEUnPacketize :: makeNew() const { LOG_NEW; return new DEUnPacketize;}

DEUnPacketize::DEUnPacketize ()
{
	setDescriptor("Convert a stream of packets of type FloatVecData into floating output data.\nThe \"data\" input feeds packets to the star.  Whenever a packet arrives, the\nprevious packet, if any, is discarded; any remaining contents are\ndiscarded.  The \"demand\" input requests output data.  If there is no\ndata left in the current packet, the last output datum is repeated\n(zero is used if there has never been a packet).  Otherwise the next\ndata value from the current input packet is output.");
	addPort(data.setPort("data",this,MESSAGE));
	addPort(demand.setPort("demand",this,ANYTYPE));
	addPort(output.setPort("output",this,FLOAT));

# line 42 "DEUnPacketize.pl"
data.triggers();
		data.before(demand);
}

void DEUnPacketize::setup() {
# line 46 "DEUnPacketize.pl"
idx = 0;
		currentMessage = 0;
		lastOutput = 0;
}

void DEUnPacketize::go() {
# line 51 "DEUnPacketize.pl"
if (data.dataNew) {
			// a new message has arrived
			data.get().getMessage(env);
			idx = 0;
			if (!env.typeCheck("FloatVecData")) {
				Error::abortRun(*this,
					env.typeError("FloatVecData"));
				return;
			}
			currentMessage = (const FloatVecData*)env.myData();
		}
		if (demand.dataNew) {
			// need to write new output
			demand.dataNew = FALSE;
			if (currentMessage && idx < currentMessage->length())
				lastOutput = currentMessage->data[idx++];
			output.put(arrivalTime) << lastOutput;	
		}
}

// prototype instance for known block list
static DEUnPacketize proto;
static RegisterBlock registerBlock(proto,"UnPacketize");
