static const char file_id[] = "DEWaveForm.pl";
// .cc file generated from DEWaveForm.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEWaveForm.h"
#include "SimControl.h"

const char *star_nm_DEWaveForm = "DEWaveForm";

const char* DEWaveForm :: className() const {return star_nm_DEWaveForm;}

ISA_FUNC(DEWaveForm,DEStar);

Block* DEWaveForm :: makeNew() const { LOG_NEW; return new DEWaveForm;}

DEWaveForm::DEWaveForm ()
{
	setDescriptor("Upon receiving an input event, output the next value specified by the\narray parameter \"value\" (default \"1 -1\"). This array can periodically\nrepeat with any period, and you can halt a simulation when the end of\nthe array is reached. The following table summarizes the capabilities:\n.nf\nhaltAtEnd   periodic   period    operation\n-----------------------------------------------------------------------\nNO          YES        0         The period is the length of the array\nNO          YES        N>0       The period is N\nNO          NO         anything  Output the array once, then zeros\nYES         anything   anything  Stop after outputting the array once\n.fi\nThe first line of the table gives the default settings.\nThe array may be read from a file by simply setting value to something\nof the form \"< filename\".");
	addPort(trigger.setPort("trigger",this,ANYTYPE));
	addPort(output.setPort("output",this,FLOAT));
	addState(value.setState("value",this,"1 -1","One period of the output waveform."));
	addState(haltAtEnd.setState("haltAtEnd",this,"NO","Halt the run at the end of the given data."));
	addState(periodic.setState("periodic",this,"YES","Output is periodic if \"YES\" (nonzero)."));
	addState(period.setState("period",this,"0","If greater than zero, gives the period of the waveform."));


}

void DEWaveForm::setup() {
# line 79 "DEWaveForm.pl"
pos = 0;
}

void DEWaveForm::go() {
# line 82 "DEWaveForm.pl"
completionTime = arrivalTime;
		if (int(haltAtEnd) && (pos >= value.size()))
			SimControl::requestHalt();
		if (pos >= value.size()) {
			output.put(completionTime) << 0.0;
			pos++;
		} else
			output.put(completionTime) << value[pos++];
		if (int(periodic))
		    if(int(period) <= 0 && pos >= value.size()) pos = 0;
		    else if (int(period) > 0 && pos >= int(period)) pos = 0;
}

// prototype instance for known block list
static DEWaveForm proto;
static RegisterBlock registerBlock(proto,"WaveForm");
