static const char file_id[] = "DEXMgraph.pl";
// .cc file generated from DEXMgraph.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEXMgraph.h"

const char *star_nm_DEXMgraph = "DEXMgraph";

const char* DEXMgraph :: className() const {return star_nm_DEXMgraph;}

ISA_FUNC(DEXMgraph,DEStar);

Block* DEXMgraph :: makeNew() const { LOG_NEW; return new DEXMgraph;}

DEXMgraph::DEXMgraph ()
{
	setDescriptor("Generate a plot with the pxgraph program with one point per event.\nAny number of event sequences can be plotted simultaneously, up\nto the limit determined by the XGraph class.\nBy default, a straight line is drawn between each pair of events.");
	addPort(input.setPort("input",this,FLOAT));
	addState(title.setState("title",this,"X graph","Graph title."));
	addState(saveFile.setState("saveFile",this,"","File to save the output to the pxgraph program."));
	addState(options.setState("options",this,"-bb -tk -P =800x400","Command line options for the pxgraph program."));


}

void DEXMgraph::wrapup() {
# line 65 "DEXMgraph.pl"
graph.terminate();
}

void DEXMgraph::setup() {
# line 47 "DEXMgraph.pl"
graph.initialize(this, input.numberPorts(),
				(const char*) options,
				(const char*) title,
				(const char*) saveFile);
}

void DEXMgraph::go() {
# line 54 "DEXMgraph.pl"
InDEMPHIter nextp(input);
	    for (int i = 1; i <= input.numberPorts(); i++) {
		InDEPort* p = nextp++;
	    	if(p->dataNew) {
		    graph.addPoint(i, arrivalTime, float(p->get()));
		}
		p->dataNew = FALSE;
	    }
}

// prototype instance for known block list
static DEXMgraph proto;
static RegisterBlock registerBlock(proto,"XMgraph");
