static const char file_id[] = "DEXhistogram.pl";
// .cc file generated from DEXhistogram.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEXhistogram.h"

const char *star_nm_DEXhistogram = "DEXhistogram";

const char* DEXhistogram :: className() const {return star_nm_DEXhistogram;}

ISA_FUNC(DEXhistogram,DEStar);

Block* DEXhistogram :: makeNew() const { LOG_NEW; return new DEXhistogram;}

DEXhistogram::DEXhistogram ()
{
	setDescriptor("Generate a histogram with the pxgraph program.  The parameter \"binWidth\" determines the\nwidth of a bin in the histogram.  The number of bins will depend on the range of\nvalues in the events that arrive. The time of arrival of events is ignored.\nThis star is identical to the SDF Xhistogram, but is used often enough in the\nDE domain that it is provided here for convenience.");
	addPort(input.setPort("input",this,ANYTYPE));
	addState(title.setState("title",this,"Xhistogram","Graph title."));
	addState(saveFile.setState("saveFile",this,"","File to save Xhistogram input."));
	addState(binWidth.setState("binWidth",this,"1.0","Width of bins for histogram."));
	addState(options.setState("options",this,"-bb =800x400","Command line options for pxgraph."));


}

void DEXhistogram::wrapup() {
# line 61 "DEXhistogram.pl"
his.terminate();
}

void DEXhistogram::setup() {
# line 54 "DEXhistogram.pl"
his.initialize(this,binWidth,options,title,saveFile);
}

void DEXhistogram::go() {
# line 57 "DEXhistogram.pl"
float data = float(input%0);
		his.addPoint(data);
}

// prototype instance for known block list
static DEXhistogram proto;
static RegisterBlock registerBlock(proto,"Xhistogram");
