static const char file_id[] = "DETclScript.pl";
// .cc file generated from DETclScript.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETclScript.h"
#include "ptk.h"
#include "Scheduler.h"

const char *star_nm_DETclScript = "DETclScript";

const char* DETclScript :: className() const {return star_nm_DETclScript;}

ISA_FUNC(DETclScript,DEStar);

Block* DETclScript :: makeNew() const { LOG_NEW; return new DETclScript;}

# line 124 "DETclScript.pl"
void TclStarIfcDE::setOneOutput (int outNum, double outValue) {
	    if ( outNum >= outputArraySize ) {
	      Error::warn(*myStar, "Too many outputs supplied by Tcl");
	    } else if ( outNum < 0 ) {
	      Error::warn(*myStar, "Negative output port number");
	      return;
	    } else {
	      // Is there a procedure to get the port by number?
	      OutDEMPHIter nextp(parent->output);
	      OutDEPort *oportp = nextp++;
	      for (int portnum=0; portnum < outNum; portnum++) oportp = nextp++;
	      oportp->put(parent->scheduler()->now()) << outValue;
	      oportp->sendData();
	    }
	  }

DETclScript::DETclScript ()
{
	setDescriptor("Invoke a Tcl script that can optionally define a procedure that is\ninvoked every time the star fires.");
	addPort(output.setPort("output",this,FLOAT));
	addPort(input.setPort("input",this,ANYTYPE));
	addState(tcl_file.setState("tcl_file",this,"$PTOLEMY/src/domains/sdf/tcltk/stars/tkScript.tcl","The file from which to read the Tcl script"));

# line 145 "DETclScript.pl"
tcl.setParent(this);
}

void DETclScript::wrapup() {
# line 191 "DETclScript.pl"
tcl.wrapup();
}

void DETclScript::begin() {
# line 148 "DETclScript.pl"
tcl.setup( this,
			   input.numberPorts(),
			   output.numberPorts(),
			   (const char*) tcl_file );
}

void DETclScript::go() {
# line 179 "DETclScript.pl"
completionTime = arrivalTime;
	   InfString time = arrivalTime;
	   Tcl_SetVar2(ptkInterp,tcl.id(),"arrivalTime",
		       (char*)time,TCL_GLOBAL_ONLY);
	   
	   // Process the inputs to see which ones are new
	   processInputs();

	   // Invoke the Tcl script (Tcl will call back to get input values)
	   tcl.go();
}


void DETclScript::processInputs ()
{
# line 159 "DETclScript.pl"
// Reset newInputFlags and newOutputFlags in the Tcl object
		  tcl.setAllNewInputFlags(FALSE);

		  // Check the input values to see which ones are new
		  // and set the flags for the affected output ports
		  InDEMPHIter nextp(input);
		  InDEPort* iportp;
		  int portnum = 0;
		  while ((iportp = nextp++) != 0) {
		    if (iportp->isItOutput()) continue;
		    if ( iportp->dataNew ) {
		      // set proper entry of newInputFlags of the Tcl object
			tcl.setOneNewInputFlag(portnum, TRUE);
			iportp->dataNew = FALSE;
		    }
		    portnum++;
		  }
}


// prototype instance for known block list
static DETclScript proto;
static RegisterBlock registerBlock(proto,"TclScript");
