static const char file_id[] = "DETkBarGraph.pl";
// .cc file generated from DETkBarGraph.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETkBarGraph.h"

const char *star_nm_DETkBarGraph = "DETkBarGraph";

const char* DETkBarGraph :: className() const {return star_nm_DETkBarGraph;}

ISA_FUNC(DETkBarGraph,DEStar);

Block* DETkBarGraph :: makeNew() const { LOG_NEW; return new DETkBarGraph;}

DETkBarGraph::DETkBarGraph ()
{
	setDescriptor("Takes any number of inputs and dynamically\ndisplays their values in bar-chart form.\nThe time stamp is ignored, so the bar chart\nonly indicates the order of occurrence of events.\nIf there is more than one input port, then\nbars for the two inputs will be plotted together\nonly if the events are simultaneous.");
	addPort(input.setPort("input",this,ANYTYPE));
	addState(label.setState("label",this,"bar chart display","A label to put on the display"));
	addState(top.setState("top",this,"1.0","Low end of the scale"));
	addState(bottom.setState("bottom",this,"-1.0","High end of the scale"));
	addState(number_of_bars.setState("number_of_bars",this,"16","Number of bars to display"));
	addState(bar_graph_height.setState("bar_graph_height",this,"5","Desired height of the bar graph in centimeters"));
	addState(bar_graph_width.setState("bar_graph_width",this,"10","Desired width of the bar graph in centimeters"));
	addState(position.setState("position",this,"+0+0","Width of the bar graph in centimeters"));


}

void DETkBarGraph::begin() {
# line 81 "DETkBarGraph.pl"
// Make non-const copies of label and position
	    InfString labCopy((const char*)label);
	    InfString posCopy((const char*)position);
	    bar.setup(this,
		(char*) labCopy,
		input.numberPorts(),
		(int) number_of_bars,
		(double) top,
		(double) bottom,
		(char*) posCopy,
		(double) bar_graph_width,
		(double) bar_graph_height);
	    count = 0;
}

void DETkBarGraph::setup() {
# line 76 "DETkBarGraph.pl"
if(double(top) <= double(bottom)) {
		Error::abortRun(*this, "invalid range for the scale");
	    }
}

void DETkBarGraph::go() {
# line 96 "DETkBarGraph.pl"
InDEMPHIter nextp(input);
	    InDEPort* p;
	    int i = 0;
	    while ((p = nextp++) != 0) {
		if ( p->dataNew ) {
		  if ( bar.update(i, count, p->get()) == FALSE ) {
		    Error::abortRun(*this, "failed to update bar chart");
		    return;
		  }
		} else {
		  if ( bar.update(i, count, 0.0) == FALSE ) {
		    Error::abortRun(*this, "failed to clear bar");
		    return;
		  }
		}
		i++;
	    }
	    count++;
	    if(count >= int(number_of_bars)) count=0;
}

// prototype instance for known block list
static DETkBarGraph proto;
static RegisterBlock registerBlock(proto,"TkBarGraph");
