static const char file_id[] = "DETkButtons.pl";
// .cc file generated from DETkButtons.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETkButtons.h"

const char *star_nm_DETkButtons = "DETkButtons";

const char* DETkButtons :: className() const {return star_nm_DETkButtons;}

ISA_FUNC(DETkButtons,DETclScript);

Block* DETkButtons :: makeNew() const { LOG_NEW; return new DETkButtons;}

DETkButtons::DETkButtons ()
{
	setDescriptor("Output the specified value when buttons are pushed.\nIf \"allow_simultaneous_events\" is yes, then output events are produced only when\nthe button labeled \"PUSH TO PRODUCE EVENTS\" is pushed.\nNote that the time stamps of the outputs are rather arbitrary.\nThe current time of the scheduler, whatever that happens to be\nwhen the buttons are pushed, is used.");
	addState(label.setState("label",this,"Buttons you can push:","Title for the set of buttons"));
	addState(identifiers.setState("identifiers",this,"BUTTON1","A list of strings that identify each button"));
	addState(value.setState("value",this,"0.0","The value produced when a button is pushed"));
	addState(allow_simultaneous_events.setState("allow_simultaneous_events",this,"NO","If YES, allow buttons to produce simultaneous events"));
	addState(put_in_control_panel.setState("put_in_control_panel",this,"YES","Specify to put slider in the control panel (vs. its own window)"));

# line 71 "DETkButtons.pl"
// Hide irrelevant outputs and states.
	    input.setAttributes(P_HIDDEN);
	    tcl_file.clearAttributes(A_SETTABLE);
}

void DETkButtons::begin() {
# line 64 "DETkButtons.pl"
// Set parameter values that are not user settable.
	    tcl_file =
		"$PTOLEMY/src/domains/de/tcltk/stars/tkButtons.tcl";

	    DETclScript::begin();
}

void DETkButtons::setup() {
# line 54 "DETkButtons.pl"
if (input.numberPorts() > 0) {
		Error::abortRun(*this, "Inputs not supported");
		return;
	    }
	    if (output.numberPorts() > identifiers.size()) {
		Error::abortRun(*this, "Need as many identifiers as outputs");
		return;
	    }
}

// prototype instance for known block list
static DETkButtons proto;
static RegisterBlock registerBlock(proto,"TkButtons");
