static const char file_id[] = "DETkLogicAnalyzer.pl";
// .cc file generated from DETkLogicAnalyzer.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETkLogicAnalyzer.h"

const char *star_nm_DETkLogicAnalyzer = "DETkLogicAnalyzer";

const char* DETkLogicAnalyzer :: className() const {return star_nm_DETkLogicAnalyzer;}

ISA_FUNC(DETkLogicAnalyzer,DETclScript);

Block* DETkLogicAnalyzer :: makeNew() const { LOG_NEW; return new DETkLogicAnalyzer;}

DETkLogicAnalyzer::DETkLogicAnalyzer ()
{
	setDescriptor("Display discrete dataflow over time, recording the entire history.\nThe values displayed are only 1 and 0.");
	addState(title.setState("title",this,"Ptolemy Logic Analyzer","A title to put on the display"));
	addState(signalLabels.setState("signalLabels",this,"default","Label(s) for each plot.  If 'default', use port names"));
	addState(TimeWindow.setState("TimeWindow",this,"20","The time represented by one window width"));
	addState(position.setState("position",this,"+0+0","Location of the window in standard X format"));
	addState(width_cm.setState("width_cm",this,"20","Width of each plot in centimeters"));
	addState(height_cm.setState("height_cm",this,"1","Height of each plot in centimeters"));

# line 115 "DETkLogicAnalyzer.pl"
// Hide irrelevant outputs and states.
	output.setAttributes(P_HIDDEN);
	tcl_file.clearAttributes(A_SETTABLE);
}

void DETkLogicAnalyzer::begin() {
# line 95 "DETkLogicAnalyzer.pl"
tcl_file = "$PTOLEMY/src/domains/de/tcltk/stars/tkLogicAnalyzer.itcl";

	if (signalLabels.size() < 1 ||
	    (strcmp(signalLabels[0],"default") ==0)) {
	    signalLabels.resize(input.numberPorts());
	    StringList names;
	    MPHIter next(input);
	    PortHole* port;
	    while ((port = next++) != 0) {
                GenericPort& p = port->far()->realPort();
		names << p.fullName() << " ";
            }
	    signalLabels.setCurrentValue(names);
	} else if (signalLabels.size() != input.numberPorts()) {
	    Error::abortRun(*this,"Number of signalLabels is not equal to the number of input ports");
	    return;
	}
	DETclScript::begin();
}

void DETkLogicAnalyzer::setup() {
# line 87 "DETkLogicAnalyzer.pl"
if (output.numberPorts() > 0) {
	    Error::abortRun(*this, "Outputs are not supported");
	    return;
	}
}

// prototype instance for known block list
static DETkLogicAnalyzer proto;
static RegisterBlock registerBlock(proto,"TkLogicAnalyzer");
