static const char file_id[] = "DETkPlot.pl";
// .cc file generated from DETkPlot.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETkPlot.h"

const char *star_nm_DETkPlot = "DETkPlot";

const char* DETkPlot :: className() const {return star_nm_DETkPlot;}

ISA_FUNC(DETkPlot,DETkXYPlot);

Block* DETkPlot :: makeNew() const { LOG_NEW; return new DETkPlot;}

DETkPlot::DETkPlot ()
{
	setDescriptor("Plot Y input(s) vs. time with dynamic updating.\nRetracing is done to overlay successive time intervals,\nas in an oscilloscope.\nTwo styles are currently supported: \"dot\" causes\nindividual points to be plotted, whereas \"connect\" causes\nconnected lines to be plotted. Drawing a box in the plot\nwill reset the plot area to that outlined by the box.\nThere are also buttons for zooming in and out, and for\nresizing the box to just fit the data in view.");
	addState(repeat_border_points.setState("repeat_border_points",this,"YES","For better visual continuity, rightmost events are repeated on the left"));

# line 49 "DETkPlot.pl"
// Change default parameter values
	  label.setInitValue("Tk Plot");
	  xTitle.setInitValue("time");
	  xRange.setInitValue("0 100");
	  style.setInitValue("connect");
	  X.setAttributes(P_HIDDEN);
	  prevValue = 0;
	  prevTime = 0;
	  prevXpos = 0;
	  prevValueSet = 0;
}

void DETkPlot::begin() {
# line 61 "DETkPlot.pl"
delete [] prevValue;
	  delete [] prevTime;
	  delete [] prevXpos;
	  delete [] prevValueSet;
	  prevValue = new double[Y.numberPorts()];
	  prevTime = new double[Y.numberPorts()];
	  prevXpos = new double[Y.numberPorts()];
	  prevValueSet = new int[Y.numberPorts()];
	  for (int i = 0; i < Y.numberPorts(); i++) {
	    prevValueSet[i] = 0;
	    prevTime[i] = 0.0;
	    prevXpos[i] = 0.0;
	  }
          DETkXYPlot::begin();
}

DETkPlot::~DETkPlot() {
# line 77 "DETkPlot.pl"
delete [] prevValue;
	  delete [] prevTime;
	  delete [] prevXpos;
	  delete [] prevValueSet;
}

void DETkPlot::go() {
# line 83 "DETkPlot.pl"
InDEMPHIter nexty(Y);
	  InDEPort *py;
	  // The trace number
	  int trace = 0;
	  while ((py = nexty++) != 0) {
	    if (py->dataNew) {
	      double xpos = prevXpos[trace] + arrivalTime - prevTime[trace];
	      if (xpos >= xMax) {
		if ((int)repeat_border_points) {
		  // Plot point off the right edge
		  xyplot.addPoint(xpos,(double)((*py)%0), trace+1);
		  if (prevValueSet[trace]) {
		    // Adjust time for previous point
		    while (prevXpos[trace] > xMin) {
		      prevXpos[trace] -= (xMax - xMin);
		    }
		    // Plot the point off the left edge
		    xyplot.breakPlot(trace+1);
		    xyplot.addPoint(prevXpos[trace],prevValue[trace], trace+1);
                  }
                } else {
		  xyplot.breakPlot(trace+1);
		}
	        while (xpos > xMax) {
		  xpos -= (xMax - xMin);
		}
	      }
	      xyplot.addPoint(xpos,(double)(py->get()), trace+1);
	      prevXpos[trace] = xpos;
	      prevTime[trace] = arrivalTime;
	      prevValue[trace] = (double)((*py)%0);
	      prevValueSet[trace] = 1;
	    }
	    trace++;
	  }
}

// prototype instance for known block list
static DETkPlot proto;
static RegisterBlock registerBlock(proto,"TkPlot");
