static const char file_id[] = "DETkStripChart.pl";
// .cc file generated from DETkStripChart.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETkStripChart.h"

const char *star_nm_DETkStripChart = "DETkStripChart";

const char* DETkStripChart :: className() const {return star_nm_DETkStripChart;}

ISA_FUNC(DETkStripChart,DETclScript);

Block* DETkStripChart :: makeNew() const { LOG_NEW; return new DETkStripChart;}

DETkStripChart::DETkStripChart ()
{
	setDescriptor("Display events in time, recording the entire history.\nThe supported styles are 'hold' for zero-order hold,\n'connect' for connected dots, and 'dot' for unconnected dots.\nAn interactive help window describes other options for the plot.");
	addState(title.setState("title",this,"Ptolemy Strip Chart","A title to put on the display"));
	addState(signalLabels.setState("signalLabels",this,"default","Label(s) for each plot. If 'default', use port names."));
	addState(yRange.setState("yRange",this,"(-1,1)","The vertical range(s) of the plot"));
	addState(TimeWindow.setState("TimeWindow",this,"25","The time represented by one window width"));
	addState(yRangeList.setState("yRangeList",this,"","yRangeList",
# line 77 "DETkStripChart.pl"
A_NONSETTABLE|A_CONSTANT));
	addState(style.setState("style",this,"hold","Plot styles are hold, connect, or dot."));
	addState(position.setState("position",this,"+0+0","Location of the window in standard X format"));
	addState(width_cm.setState("width_cm",this,"25","Width of each plot in centimeters"));
	addState(height_cm.setState("height_cm",this,"5","Height of each plot in centimeters"));

# line 167 "DETkStripChart.pl"
// Hide irrelevant outputs and states.
	output.setAttributes(P_HIDDEN);
	tcl_file.clearAttributes(A_SETTABLE);
}

void DETkStripChart::begin() {
# line 121 "DETkStripChart.pl"
int i; 
	tcl_file = "$PTOLEMY/src/domains/de/tcltk/stars/tkStripChart.tcl";

	if (signalLabels.size() < 1 ||
	    (strcmp(signalLabels[0],"default") ==0)) {
	    signalLabels.resize(input.numberPorts());
	    StringList names;
	    MPHIter next(input);
	    PortHole* port;
	    while ((port = next++) != 0) {
                GenericPort& p = port->far()->realPort();
		names << p.fullName() << " ";
            }
	    signalLabels.setCurrentValue(names);
	} else if (signalLabels.size() != input.numberPorts()) {
	    Error::abortRun(*this, "Number of signalLabels is not equal to the number of input ports");
	    return;
	}
	if (style.size() != input.numberPorts()) {
	    if (style.size() != 1) {
		Error::abortRun(*this,"Number of styles is not equal to the number of input ports");
		return;
	    }
	    StringList st = style[0];
	    st << "[" << input.numberPorts() << "]";
	    style.setCurrentValue(st);
	}
	if (yRange.size() != input.numberPorts()) {
	    if (yRange.size() != 1) {
		Error::abortRun(*this,"Number of yRange values is not equal to the number of input ports");
		return;
	    }
	    StringList st;
 	    st << yRange.currentValue();
	    st << "[" << input.numberPorts() << "]";
	    yRange.setCurrentValue(st);
	}
	// Parse the complex numbers into a form that is easier to Tcl.
        StringList range;
        for (i = 0; i < yRange.size() ; i++)
            range << yRange[i].real() << " " << yRange[i].imag() << " ";
        yRangeList.setCurrentValue(range);

	DETclScript::begin();
}

void DETkStripChart::setup() {
# line 104 "DETkStripChart.pl"
if (output.numberPorts() > 0) {
	    Error::abortRun(*this, "Outputs are not supported");
	    return;
	}
        for (int i = 0; i < style.size(); i++ ) {
            if (strcmp(style[i],"hold") &&
                strcmp(style[i],"dot")  &&
                strcmp(style[i],"connect")) {
                Error::abortRun(*this,
				"style must be one of hold, dot, or connect");
                return;
            }
        }
}

// prototype instance for known block list
static DETkStripChart proto;
static RegisterBlock registerBlock(proto,"TkStripChart");
