static const char file_id[] = "DETkXYPlot.pl";
// .cc file generated from DETkXYPlot.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETkXYPlot.h"

const char *star_nm_DETkXYPlot = "DETkXYPlot";

const char* DETkXYPlot :: className() const {return star_nm_DETkXYPlot;}

ISA_FUNC(DETkXYPlot,DEStar);

Block* DETkXYPlot :: makeNew() const { LOG_NEW; return new DETkXYPlot;}

DETkXYPlot::DETkXYPlot ()
{
	setDescriptor("Plot Y input(s) vs. X input(s) with dynamic updating.\nTime stamps are ignored.  If there is an event on only\none of a matching pair of X and Y inputs, then the previously\nreceived value (or zero if none) is used for the other.\nTwo styles are currently supported: \"dot\" causes\npoints to be plotted, whereas \"connect\" causes connected\nlines to be plotted. Drawing a box in the plot will\nreset the plot area to that outlined by the box.\nThere are also buttons for zooming in and out, and for\nresizing the box to just fit the data in view.");
	addState(label.setState("label",this,"Tk XY Plot","The title of the plot"));
	addState(geometry.setState("geometry",this,"600x400+0+0","Specified the location and/or size of the window"));
	addState(xTitle.setState("xTitle",this,"x","The x-axis label"));
	addState(yTitle.setState("yTitle",this,"y","The y-axis label"));
	addState(xRange.setState("xRange",this,"-1.5 1.5","The range of x-coordinate values"));
	addState(yRange.setState("yRange",this,"-1.5 1.5","The range of y-coordinate values"));
	addState(persistence.setState("persistence",this,"100","The number of points displayed at any one time"));
	addState(style.setState("style",this,"dot","Plot styles are dot or connect"));
	addState(updateSize.setState("updateSize",this,"10","The number of points drawn simultaneously. Higher numbers make the response faster."));
	addPort(X.setPort("X",this,FLOAT));
	addPort(Y.setPort("Y",this,FLOAT));


}

void DETkXYPlot::begin() {
# line 110 "DETkXYPlot.pl"
// Need to make non-const copies of  strings to
	  // avoid compilation warnings
	  labCopy = (const char*)label;
	  geoCopy = (const char*)geometry;
	  xtCopy = (const char*)xTitle;
	  ytCopy = (const char*)yTitle;

	  int plotstyle = 0;
	  if (strcmp(style,"connect") == 0) plotstyle = 1;

	  // create the XYplot window labeling, scaling,
	  // and ranging as specified by the parameters
	  xyplot.setup(this,	   
		       (char*)  labCopy,     // Label for the XY plot
		       (int)    persistence, // no. data points to retain
		       (int)    updateSize,  // no. data points between refreshes
		       (char*)  geoCopy,     // Geometry for the window
		       (char*)  xtCopy,      // Title for X-axis
		                xMin,        // minimum X range value
		                xMax,        // maximum X range value
		       (char*)  ytCopy,      // Title for Y-axis
		                yMin,	     // minimum Y range value
		                yMax,        // maximum Y range value
		                Y.numberPorts(),   // The number of data sets
		       (int)    plotstyle);  // the plot style to use
}

void DETkXYPlot::setup() {
# line 98 "DETkXYPlot.pl"
// parse the x and y ranges which are
	  // specified as strings for user convenience
	  if ((sscanf((const char *)xRange, "%lf %lf", &xMin, &xMax) != 2) ||
	      (xMax <= xMin)) {
	    Error::abortRun(*this, "xRange parameter values are invalid");
	  }
	  if ((sscanf((const char *)yRange, "%lf %lf", &yMin, &yMax) != 2) ||
	      (yMax <= yMin)) {
	    Error::abortRun(*this, "yRange parameter values are invalid");
	  }
}

void DETkXYPlot::go() {
# line 138 "DETkXYPlot.pl"
InDEMPHIter nextx(X), nexty(Y);
	  InDEPort *px, *py = (InDEPort*)NULL;
	  int set = 1;
	  while ((px = nextx++) != 0 && (py = nexty++) != 0) {
	    if (px->dataNew || py->dataNew) {
	      xyplot.addPoint((double)px->get(),(double)py->get(), set);
	    }
	    set++;
	  }
}

// prototype instance for known block list
static DETkXYPlot proto;
static RegisterBlock registerBlock(proto,"TkXYPlot");
