.EQ
delim off
.EN
.\" documentation file generated from HOFChain.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Chain"
.SD
Create one or more instances of the named block connected in a chain.
This is implemented by replacing the
.c Chain
star with instances of the named blocks at setup time.
The replacement block(s) are connected as specified by
fIinput_mapfR, fIinternal_mapfR, and fIoutput_mapfR.
Their parameters are determined by fIparameter_mapfR.
If fIpipelinefR is YES then a unit delay is put on all internal connections.
.SE
.LO "HOF main library"
.DM HOF HOFBaseHiOrdFn
.SV 1.6 "6/16/95"
.AL "E. A. Lee"
.IH
.NE
\fIinput\fR (multiple), (anytype): Whatever is connected to these inputs will  be connected
to the first named block inputs according to input_map.
.PE
.OH
.NE
\fIoutput\fR (multiple), (ANYTYPE): Whatever is connected to these outputs will be connected
to the last named block outputs according to output_map.
.PE
.SH
.NE
\fIchain_length\fR (IntState): The length of the chain
.DF "2"
.NE
\fIinput_map\fR (StringArrayState): The mapping of inputs
.DF "input"
.NE
\fIoutput_map\fR (StringArrayState): The mapping of outputs
.DF "output"
.NE
\fIinternal_map\fR (StringArrayState): The internal connections between blocks
.DF "output input"
.NE
\fIpipeline\fR (IntState): If YES, put a delay on each internal connection
.DF "NO"
.ET
.EQ
delim $$
.EN
.LD
This star is a higher-order function mechanism.
.IE "higher-order functions"
See the
.c Map
documentation for background information.
.UH "Number of replacement blocks"
.pp
The star is replaced by one or more instances of the block with name
given by \fIblockname\fR at setup time, before the scheduler is invoked.
The number of instances of the replacement block is given by the
\fIchain_length\fR parameter.
If the named block is not on the knownlist (e.g., it is not a built-in block),
then the \fIwhere_defined\fR parameter is taken to be the full path name and
filename of facet that should be compiled to define the block.
This path name may (and probably should) begin with the environment
.EQ
delim off
.EN
variable $PTOLEMY or ~username.
.EQ
delim $$
.EN
.UH "Connections"
.pp
The input and output connections specified by \fIinput_map\fR and
\fIoutput_map\fR are made to the first and last blocks in the chain.
The internal connections are made as specified by the \fIinternal_map\fR
parameter.
This parameter should consist of an alternating list of output names and
input names for the replacement block.
As with the
.c Map
star, if inputs or outputs are multiple, repeated names can be used.
.UH "Setting parameter values"
.pp
The \fIparameter_map\fR parameter can be used to set parameter values
for the replacement blocks.
The syntax is the same as in the
.c Map
star.
.UH "A note about data types"
.pp
The output data type is inherited from the input data type.
.ES
