.EQ
delim off
.EN
.\" documentation file generated from HOFIfElse.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "IfElse"
.SD
This star is just like Map, except that it creates one of two named blocks
to replace itself, instead of just one.
If the "condition" parameter is TRUE, then the "true_block" is used.
Otherwise, the "false_block" is used.
This can be used to parameterize the use of a given block, or, more
interestingly, for statically evaluated recursion.
.SE
.LO "HOF main library"
.DM HOF HOFMap
.SV 1.5 "6/16/95"
.AL "E. A. Lee"
.SH
.NE
\fIcondition\fR (IntState): Specifies whether to use the true or false block
.DF "TRUE"
.NE
\fItrue_block\fR (StringState): The name of the replacement block used if condition is non-zero
.DF "Gain"
.NE
\fIwhere_true_defined\fR (StringState): The full path and facet name for the definition of true_block.
.DF ""
.NE
\fItrue_input_map\fR (StringArrayState): The input mapping for the false block
.DF ""
.NE
\fItrue_output_map\fR (StringArrayState): The  output mapping for the false block
.DF ""
.NE
\fItrue_parameter_map\fR (StringArrayState): The parameter mapping for the false block
.DF ""
.NE
\fIfalse_block\fR (StringState): The name of the replacement block used if condition is zero
.DF ""
.NE
\fIwhere_false_defined\fR (StringState): The full path and facet name for the definition of false_block.
.DF ""
.NE
\fIfalse_input_map\fR (StringArrayState): The input mapping for the false block
.DF ""
.NE
\fIfalse_output_map\fR (StringArrayState): The  output mapping for the false block
.DF ""
.NE
\fIfalse_parameter_map\fR (StringArrayState): The parameter mapping for the false block
.DF ""
.ET
.EQ
delim $$
.EN
.LD
This star is derived from the
.c Map
star.
It is also a higher-order function mechanism.
.IE "higher-order functions"
See the
.c Map
documentation for background information.
The only difference is that instead of one named replacement block,
there are two.
The choice between them is determined by the \fIcondition\fR parameter.
.pp
An application for this block is in recursion.
A galaxy \fIX\fR can be created that has somewhere within it an
.c IfElse
block with \fIX\fR given as the replacement block.
To ensure that the recursion terminates, the parameter \fIuse_alt\fR
is computed from galaxy parameters, for example by subtracting one
from an initial integer value.
When this parameter reaches zero, an alternative block is used instead
of \fIX\fR, terminating the recursion.
.ES
