.EQ
delim off
.EN
.\" documentation file generated from HOFMap.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Map"
.SD
Map one or more instances of the named block to the input stream(s)
to produce the output stream(s).
This is implemented by replacing the Map star with the named block at
setup time.
The replacement block(s) are connected as specified by "input_map"
and "output_map", using the existing connections to the Map star.
Their parameters are determined by "parameter_map".
.SE
.LO "HOF library"
.DM HOF HOFBaseHiOrdFn
.SV 1.7 "6/16/95"
.AL "E. A. Lee"
.IH
.NE
\fIinput\fR (multiple), (anytype): Whatever is connected to these inputs will  be connected
to the named block inputs according to input_map.
.PE
.OH
.NE
\fIoutput\fR (multiple), (ANYTYPE): Whatever is connected to these outputs will be connected
to the named block outputs according to output_map.
.PE
.SH
.NE
\fIinput_map\fR (StringArrayState): The mapping of inputs
.DF "input"
.NE
\fIoutput_map\fR (StringArrayState): The mapping of outputs
.DF "output"
.ET
.EQ
delim $$
.EN
.LD
See the documentation for the
.c BaseHiOrdFn
star, from which this is derived, for background information.
The star is replaced by one or more instances of the block with
name given by \fIblockname\fR at setup time, before the scheduler is invoked.
.UH "Number of replacement blocks"
.pp
The number of instances of the replacement block
is determined by the number of input or
output connections that have been made to the
.c Map
star.
Suppose the
.c Map
star has $M sub I$ inputs and $M sub O$ outputs connected to it.
Suppose further that the replacement block has $B sub I$ input
ports and $B sub O$ output ports.
Then
.EQ
N ~=~ {M sub I} over {B sub I} ~=~ {M sub O} over {B sub O}
.EN
is the number of instances that will be created.
It is an error for this second equality not to be satisfied.
.UH "How the inputs and outputs are connected"
.pp
The first $B sub I$ connections to the
.c Map
star will be connected to the inputs of the first instance of the
replacement blocks.
The names of the inputs to the replacement block should be listed
in the \fIinput_map\fR parameter in the order in which they should
be connected.
There should be exactly $B sub I$ names in the \fIinput_map\fR list.
The next $B sub I$ connections will be connected to the next
replacement block, again using the ordering specified in \fIinput_map\fR.
Similarly for the outputs.
If there are no inputs at all, then the number of instances
is determined by the outputs, and vice versa.
.UH "Substituting blocks with multiple inputs or outputs"
.pp
When the replacement block has a multiple input port or a multiple
output port, the name given in the input_map parameter should be
the name of the multiple port, repeated for however many instances
of the port are desired.
For example, the
.c Add
block has a multiple input port named "input".
If we want the replacement block(s) to have two inputs,
then \fIinput_map\fR should be "input input".
If we want three inputs in each replacement block, then
\fIinput_map\fR should be "input input input".
.UH "A note about data types"
.pp
In this star, the output data type is ANYTYPE, and the type
will be derived from the type of the input(s).
This creates a problem when there are no inputs.
Thus, the zero-input version of this star is implemented as a
family of derived stars called
.c ParSource
stars, each with a particular type of output.
There are other problems as well with this mechanism, in that
when type resolution is done, before the block substitution occurs,
there is no information about the substitution block.
It is best, therefore, when using the
.c Map
star, to make all type conversions explicit.
.UH "Bugs"
.pp
Repeated names in the \fIinput_map\fR or \fIoutput_map\fR
for non-multiple inputs are an error.
However, this is not detected.
Results could be unexpected.
.ES
