static const char file_id[] = "HOFIfElse.pl";
// .cc file generated from HOFIfElse.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "HOFIfElse.h"

const char *star_nm_HOFIfElse = "HOFIfElse";

const char* HOFIfElse :: className() const {return star_nm_HOFIfElse;}

ISA_FUNC(HOFIfElse,HOFMap);

Block* HOFIfElse :: makeNew() const { LOG_NEW; return new HOFIfElse;}

HOFIfElse::HOFIfElse ()
{
	setDescriptor("This star is just like Map, except that it creates one of two named blocks\nto replace itself, instead of just one.\nIf the \"condition\" parameter is TRUE, then the \"true_block\" is used.\nOtherwise, the \"false_block\" is used.\nThis can be used to parameterize the use of a given block, or, more\ninterestingly, for statically evaluated recursion.");
	addState(condition.setState("condition",this,"TRUE","Specifies whether to use the true or false block"));
	addState(true_block.setState("true_block",this,"Gain","The name of the replacement block used if condition is non-zero"));
	addState(where_true_defined.setState("where_true_defined",this,"","The full path and facet name for the definition of true_block."));
	addState(true_input_map.setState("true_input_map",this,"","The input mapping for the false block"));
	addState(true_output_map.setState("true_output_map",this,"","The  output mapping for the false block"));
	addState(true_parameter_map.setState("true_parameter_map",this,"","The parameter mapping for the false block"));
	addState(false_block.setState("false_block",this,"","The name of the replacement block used if condition is zero"));
	addState(where_false_defined.setState("where_false_defined",this,"","The full path and facet name for the definition of false_block."));
	addState(false_input_map.setState("false_input_map",this,"","The input mapping for the false block"));
	addState(false_output_map.setState("false_output_map",this,"","The  output mapping for the false block"));
	addState(false_parameter_map.setState("false_parameter_map",this,"","The parameter mapping for the false block"));

# line 121 "HOFIfElse.pl"
// Hide all the parameters that are controlled internally
	  blockname.clearAttributes(A_SETTABLE);
	  where_defined.clearAttributes(A_SETTABLE);
	  input_map.clearAttributes(A_SETTABLE);
	  output_map.clearAttributes(A_SETTABLE);
	  parameter_map.clearAttributes(A_SETTABLE);
}

void HOFIfElse::setup() {
# line 129 "HOFIfElse.pl"
if ((int)condition) {
		blockname.setCurrentValue((const char*) true_block);
		where_defined.setCurrentValue((const char*) where_true_defined);
		StringList temp;
		temp = true_input_map.currentValue();
		input_map.setCurrentValue((const char*) temp);
		temp = true_output_map.currentValue();
		output_map.setCurrentValue((const char*) temp);
		temp = true_parameter_map.currentValue();
		parameter_map.setCurrentValue((const char*) temp);
	    } else {
		blockname.setCurrentValue((const char*) false_block);
		where_defined.setCurrentValue((const char*) where_false_defined);
		StringList temp;
		temp = false_input_map.currentValue();
		input_map.setCurrentValue((const char*) temp);
		temp = false_output_map.currentValue();
		output_map.setCurrentValue((const char*) temp);
		temp = false_parameter_map.currentValue();
		parameter_map.setCurrentValue((const char*) temp);
	    }
	    HOFMap::setup();
}

// prototype instance for known block list
static HOFIfElse proto;
static RegisterBlock registerBlock(proto,"IfElse");
