.EQ
delim off
.EN
.\" documentation file generated from MDSDFDB.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "DB"
.SD
Convert each entry of an input matrix to a decibels (dB) scale. 
Zero and negative values
are assigned the value "min" (default -100). The "inputIsPower"
parameter should be set to YES if the input signal is a power
measurement (vs. an amplitude measurement).
.SE
.LO "MDSDF library"
.DM MDSDF MDSDFStar
.SV 1.3 "3/2/95"
.AL "J. T. Buck, modified for MDSDF by Mike J. Chen"
.IH
.NE
\fIinput\fR (FLOAT_MATRIX)
.PE
.OH
.NE
\fIoutput\fR (FLOAT_MATRIX)
.PE
.SH
.NE
\fInumRows\fR (IntState): The number of rows in the matrix being converted.
.DF "2"
.NE
\fInumCols\fR (IntState): The number of columns in the matrix being converted.
.DF "2"
.NE
\fImin\fR (FloatState): Minimum output value.
.DF "-100"
.NE
\fIinputIsPower\fR (IntState): TRUE if input is a power measurement, FALSE if it's an amplitude measurement.
.DF "FALSE"
.ET
.EQ
delim $$
.EN
.LD
For inputs that are greater than zero, the output is either
$N log sub 10 (input)$ or \fImin\fR, whichever is larger, where
$N ~=~ 10$ if \fIinputIsPower\fR is TRUE, and $N ~=~ 20$ otherwise.
.Id "decibel"
The default is $N ~=~ 20$.
For inputs that are zero or negative, the output is \fImin\fR.
.ES
