.EQ
delim off
.EN
.\" documentation file generated from MDSDFFFTCx.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "FFTCx"
.SD
Compute the 2D discrete Fourier transform of a complex input using the
row-column decomposition with 1D fast Fourier transform (FFT) algorithm.
"rowOrder" (default 8) is the log base 2 of the row transform size.
"colOrder" (default 8) is the log base 2 of the column transform size.
"numRows" (default 256) is the number of rows in the input.
"numCols" (default 256) is the number of columns in the input.
.SE
.LO "MDSDF library"
.DM MDSDF MDSDFStar
.SV 1.3 "3/2/95"
.AL "J. T. Buck, modified for MDSDF by Mike J. Chen"
.IH
.NE
\fIinput\fR (COMPLEX_MATRIX)
.PE
.OH
.NE
\fIoutput\fR (COMPLEX_MATRIX)
.PE
.SH
.NE
\fIrowOrColumn\fR (IntState): Select a row or column FFT, 0 = row, 1 = col.
.DF "0"
.NE
\fIorder\fR (IntState): Log base 2 of the transform size.
.DF "8"
.NE
\fIsize\fR (IntState): The number of rows or columns in the input.
.DF "256"
.NE
\fIdirection\fR (IntState): Equals 1 for forward, or -1 for inverse, transform.
.DF "1"
.ET
.EQ
delim $$
.EN
.LD
A number of input samples given by the parameter \fIsize\fR will
be consumed at the input, zero-padded if necessary to make $2 sup order$
samples, and transformed using a fast Fourier transform algorithm.
.Id "FFT, complex"
.Id "fast Fourier transform, complex"
.Id "Fourier transform, fast, complex"
If \fIdirection\fR is 1, then the forward Fourier transform is computed.
If \fIdirection\fR is -1, then the inverse Fourier transform is computed.
.lp
Note a single firing of this star consumes \fIsize\fR inputs
and produces $2 sup order$ outputs.
This must be taken into account when determining for how many iterations
to run a universe.
For example, to compute just one FFT, only one iteration should be run.
.lp
\fBBugs\fR: the routine currently used (from Gabriel) recomputes trig
.Ir "Gabriel"
functions for each term, instead of using a table.
Instead, FFTCx::setup() should compute a table of appropriate size
in order to save time.
This approach does not offer any improvement, obviously, if only
one transform is performed.
.ID "Oppenheim, A. V."
.ID "Schafer, R. W."
.UH REFERENCES
.ip [1]
Jae S. Lim, \fITwo-Dimensional Signal and Image Processing\fR,
Prentice-Hall: Englewood Cliffs, NJ, 1990.
.ES
