.EQ
delim off
.EN
.\" documentation file generated from MDSDFFIR.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "FIR"
.SD
Two-dimensional finite impulse response (FIR) filter.  Taps should be
specified by the following five parameters:
1) firstRowIndex: index of the first row, negative for past rows;
2) lastRowIndex: index of the last row, 0 for the current, positive for
future rows;
3) firstColIndex: the index of the first column, negative for past columns;
4) lastColIndex: the index of the last column, 0 for the current, positive for
future columns; and
5) taps: an array of the tap values themselves, starting with the earliest
tap specified by (firstRowIndex,firstColIndex) and ending with the last tap
spcified by (lastRowIndex, lastColIndex).

The default parameters specify a normalized 3 x 3 lowpass filter.
.SE
.LO "MDSDF library"
.DM MDSDF MDSDFStar
.SV 1.4 "12/1/95"
.AL "Mike J. Chen"
.IH
.NE
\fIinput\fR (FLOAT_MATRIX)
.PE
.OH
.NE
\fIoutput\fR (FLOAT_MATRIX)
.PE
.SH
.NE
\fIfirstRowIndex\fR (IntState): The index of the first row of tap values
.DF "-1"
.NE
\fIlastRowIndex\fR (IntState): The index of the last row of tap values
.DF "1"
.NE
\fIfirstColIndex\fR (IntState): The index of the first column of tap values
.DF "-1"
.NE
\fIlastColIndex\fR (IntState): The index of the last column of tap values
.DF "1"
.NE
\fItaps\fR (FloatArrayState): The taps of the 2-D FIR filter.
.DF ".1 .1 .1 .1 .2 .1 .1 .1 .1"
.ET
.EQ
delim $$
.EN
.ES
