static const char file_id[] = "MDSDFAdd.pl";
// .cc file generated from MDSDFAdd.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFAdd.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFAdd = "MDSDFAdd";

const char* MDSDFAdd :: className() const {return star_nm_MDSDFAdd;}

ISA_FUNC(MDSDFAdd,MDSDFStar);

Block* MDSDFAdd :: makeNew() const { LOG_NEW; return new MDSDFAdd;}

MDSDFAdd::MDSDFAdd ()
{
	setDescriptor("Does a matrix addition of two input matrices A and B to produce matrix C.\nAll matrices must have the same dimensions.");
	addPort(Ainput.setPort("Ainput",this,FLOAT_MATRIX));
	addPort(Binput.setPort("Binput",this,FLOAT_MATRIX));
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input/output matricies."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input/output matricies."));


}

void MDSDFAdd::setup() {
# line 43 "MDSDFAdd.pl"
Ainput.setMDSDFParams(int(numRows), int(numCols));
	    Binput.setMDSDFParams(int(numRows), int(numCols));
	    output.setMDSDFParams(int(numRows), int(numCols));
}

void MDSDFAdd::go() {
# line 48 "MDSDFAdd.pl"
// get a SubMatrix from the buffer
            FloatSubMatrix& input1 = *(FloatSubMatrix*)(Ainput.getInput());
            FloatSubMatrix& input2 = *(FloatSubMatrix*)(Binput.getInput());
            FloatSubMatrix& result = *(FloatSubMatrix*)(output.getOutput());

            // compute product, putting result into output

            result = input1 + input2;
	    
	    delete &input1;
	    delete &input2;
	    delete &result;
}

// prototype instance for known block list
static MDSDFAdd proto;
static RegisterBlock registerBlock(proto,"Add");
