static const char file_id[] = "MDSDFCxMatrix.pl";
// .cc file generated from MDSDFCxMatrix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFCxMatrix.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFCxMatrix = "MDSDFCxMatrix";

const char* MDSDFCxMatrix :: className() const {return star_nm_MDSDFCxMatrix;}

ISA_FUNC(MDSDFCxMatrix,MDSDFStar);

Block* MDSDFCxMatrix :: makeNew() const { LOG_NEW; return new MDSDFCxMatrix;}

MDSDFCxMatrix::MDSDFCxMatrix ()
{
	setDescriptor("Produces ComplexMatrix data from state information.");
	addPort(output.setPort("output",this,COMPLEX_MATRIX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));
	addState(ComplexMatrixContents.setState("ComplexMatrixContents",this,"(1.0,-2.0) (-2.0,0.5) (2.0,0.0) (-2.0,-0.1)","The complex contents of the matrix."));


}

void MDSDFCxMatrix::setup() {
# line 38 "MDSDFCxMatrix.pl"
// set the dimensions of the porthole
    output.setMDSDFParams(int(numRows), int(numCols));
}

void MDSDFCxMatrix::go() {
# line 42 "MDSDFCxMatrix.pl"
// get a SubMatrix from the buffer
    ComplexSubMatrix *matrix = (ComplexSubMatrix*)output.getOutput();

    // initialize the subMatrix with values from the ComplexStateArray
    *matrix << ComplexMatrixContents;     

    delete matrix;
}

// prototype instance for known block list
static MDSDFCxMatrix proto;
static RegisterBlock registerBlock(proto,"CxMatrix");
