static const char file_id[] = "MDSDFCxToFloat.pl";
// .cc file generated from MDSDFCxToFloat.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFCxToFloat.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFCxToFloat = "MDSDFCxToFloat";

const char* MDSDFCxToFloat :: className() const {return star_nm_MDSDFCxToFloat;}

ISA_FUNC(MDSDFCxToFloat,MDSDFStar);

Block* MDSDFCxToFloat :: makeNew() const { LOG_NEW; return new MDSDFCxToFloat;}

MDSDFCxToFloat::MDSDFCxToFloat ()
{
	setDescriptor("Takes an input ComplexSubMatrix and converts it to a FloatSubMatrix.  This\nis done by using the cast conversion method of the FloatMatrix class.\nThe conversion results in a ComplexMatrix that has entries which have\nreal values that are the values of each corresponding entry of the \nFloatMatrix and 0 imaginary value.\nI.e. ComplexMatrix.entry(i) = FloatMatrix.entry(i).");
	addPort(input.setPort("input",this,COMPLEX_MATRIX));
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix being converted."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix being converted."));


}

void MDSDFCxToFloat::setup() {
# line 43 "MDSDFCxToFloat.pl"
input.setMDSDFParams(int(numRows),int(numCols));
    output.setMDSDFParams(int(numRows),int(numCols));
}

void MDSDFCxToFloat::go() {
# line 47 "MDSDFCxToFloat.pl"
// get input & output structures
    ComplexSubMatrix* data = (ComplexSubMatrix*)(input.getInput());
    FloatSubMatrix* result = (FloatSubMatrix*)(output.getOutput());

    // do conversion using copy constructor
    for(int row = 0; row < int(numRows); row++)
      for(int col = 0; col < int(numCols); col++)
        (*result)[row][col] = abs((*data)[row][col]);
 
    // delete i/o access structures
    delete data;
    delete result;
}

// prototype instance for known block list
static MDSDFCxToFloat proto;
static RegisterBlock registerBlock(proto,"CxToFloat");
