static const char file_id[] = "MDSDFDB.pl";
// .cc file generated from MDSDFDB.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFDB.h"

const char *star_nm_MDSDFDB = "MDSDFDB";

const char* MDSDFDB :: className() const {return star_nm_MDSDFDB;}

ISA_FUNC(MDSDFDB,MDSDFStar);

Block* MDSDFDB :: makeNew() const { LOG_NEW; return new MDSDFDB;}

MDSDFDB::MDSDFDB ()
{
	setDescriptor("Convert each entry of an input matrix to a decibels (dB) scale. \nZero and negative values\nare assigned the value \"min\" (default -100). The \"inputIsPower\"\nparameter should be set to YES if the input signal is a power\nmeasurement (vs. an amplitude measurement).");
	addPort(input.setPort("input",this,FLOAT_MATRIX));
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix being converted."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix being converted."));
	addState(min.setState("min",this,"-100","Minimum output value."));
	addState(inputIsPower.setState("inputIsPower",this,"FALSE","TRUE if input is a power measurement, FALSE if it's an amplitude measurement."));


}

void MDSDFDB::setup() {
# line 66 "MDSDFDB.pl"
input.setMDSDFParams(int(numRows), int(numCols));
                output.setMDSDFParams(int(numRows), int(numCols));
		if (int(inputIsPower)) gain=10.0;
		else gain = 20.0;
}

void MDSDFDB::go() {
# line 72 "MDSDFDB.pl"
FloatSubMatrix* data = (FloatSubMatrix*)(input.getInput());
                FloatSubMatrix* result = (FloatSubMatrix*)(output.getOutput());

                for(int i = 0; i < int(numRows)*int(numCols); i++) {
                  if(data->entry(i) <= 0.0) 
                    result->entry(i) = double(min);
                  else {
                    result->entry(i) = gain * log10(data->entry(i));
                    if(result->entry(i) < double(min))
                      result->entry(i) = double(min);
                  }
                }

                delete data;
                delete result;
}

// prototype instance for known block list
static MDSDFDB proto;
static RegisterBlock registerBlock(proto,"DB");
