static const char file_id[] = "MDSDFFIR.pl";
// .cc file generated from MDSDFFIR.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFFIR.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFFIR = "MDSDFFIR";

const char* MDSDFFIR :: className() const {return star_nm_MDSDFFIR;}

ISA_FUNC(MDSDFFIR,MDSDFStar);

Block* MDSDFFIR :: makeNew() const { LOG_NEW; return new MDSDFFIR;}

MDSDFFIR::MDSDFFIR ()
{
	setDescriptor("Two-dimensional finite impulse response (FIR) filter.  Taps should be\nspecified by the following five parameters:\n1) firstRowIndex: index of the first row, negative for past rows;\n2) lastRowIndex: index of the last row, 0 for the current, positive for\nfuture rows;\n3) firstColIndex: the index of the first column, negative for past columns;\n4) lastColIndex: the index of the last column, 0 for the current, positive for\nfuture columns; and\n5) taps: an array of the tap values themselves, starting with the earliest\ntap specified by (firstRowIndex,firstColIndex) and ending with the last tap\nspcified by (lastRowIndex, lastColIndex).\n\nThe default parameters specify a normalized 3 x 3 lowpass filter.");
	addPort(input.setPort("input",this,FLOAT_MATRIX));
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(firstRowIndex.setState("firstRowIndex",this,"-1","The index of the first row of tap values"));
	addState(lastRowIndex.setState("lastRowIndex",this,"1","The index of the last row of tap values"));
	addState(firstColIndex.setState("firstColIndex",this,"-1","The index of the first column of tap values"));
	addState(lastColIndex.setState("lastColIndex",this,"1","The index of the last column of tap values"));
	addState(taps.setState("taps",this,".1 .1 .1 .1 .2 .1 .1 .1 .1","The taps of the 2-D FIR filter."));


}

void MDSDFFIR::setup() {
# line 68 "MDSDFFIR.pl"
input.setMDSDFParams(1,1);
    output.setMDSDFParams(1,1);
}

void MDSDFFIR::go() {
# line 72 "MDSDFFIR.pl"
// get a SubMatrix from the buffer
    double& out = output.getFloatOutput();

    out = 0.0;
    int tap = 0;

    int lastrow = int(lastRowIndex);
    int lastcol = int(lastColIndex);

    for(int row = int(firstRowIndex); row <= lastrow; row++) {
      for(int col = int(firstColIndex); col <= lastcol; col++) {
	 out += input.getFloatInput(row,col) * taps[tap++];
      }
    }
}

// prototype instance for known block list
static MDSDFFIR proto;
static RegisterBlock registerBlock(proto,"FIR");
