static const char file_id[] = "MDSDFFloatMatrix.pl";
// .cc file generated from MDSDFFloatMatrix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFFloatMatrix.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFFloatMatrix = "MDSDFFloatMatrix";

const char* MDSDFFloatMatrix :: className() const {return star_nm_MDSDFFloatMatrix;}

ISA_FUNC(MDSDFFloatMatrix,MDSDFStar);

Block* MDSDFFloatMatrix :: makeNew() const { LOG_NEW; return new MDSDFFloatMatrix;}

MDSDFFloatMatrix::MDSDFFloatMatrix ()
{
	setDescriptor("Produces FloatMatrix data from state information.");
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));
	addState(FloatMatrixContents.setState("FloatMatrixContents",this,"1.0 -2.0 2.0 -2.0","The float contents of the matrix."));


}

void MDSDFFloatMatrix::setup() {
# line 38 "MDSDFFloatMatrix.pl"
// set the dimensions of the porthole
    output.setMDSDFParams(int(numRows), int(numCols));
}

void MDSDFFloatMatrix::go() {
# line 42 "MDSDFFloatMatrix.pl"
// get a SubMatrix from the buffer
    FloatSubMatrix *matrix = (FloatSubMatrix*)output.getOutput();

    // initialize the subMatrix with values from the FloatStateArray
    *matrix << FloatMatrixContents;     

    delete matrix;
}

// prototype instance for known block list
static MDSDFFloatMatrix proto;
static RegisterBlock registerBlock(proto,"FloatMatrix");
