static const char file_id[] = "MDSDFFloatToCx.pl";
// .cc file generated from MDSDFFloatToCx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFFloatToCx.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFFloatToCx = "MDSDFFloatToCx";

const char* MDSDFFloatToCx :: className() const {return star_nm_MDSDFFloatToCx;}

ISA_FUNC(MDSDFFloatToCx,MDSDFStar);

Block* MDSDFFloatToCx :: makeNew() const { LOG_NEW; return new MDSDFFloatToCx;}

MDSDFFloatToCx::MDSDFFloatToCx ()
{
	setDescriptor("Takes an input FloatMatrix and converts it to an ComplexMatrix.  This\nis done by using the cast conversion method of the FloatMatrix class.\nThe conversion results in a ComplexMatrix that has entries which have\nreal values that are the values of each corresponding entry of the \nFloatMatrix and 0 imaginary value.\nI.e. ComplexMatrix.entry(i) = FloatMatrix.entry(i).");
	addPort(input.setPort("input",this,FLOAT_MATRIX));
	addPort(output.setPort("output",this,COMPLEX_MATRIX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix being converted."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix being converted."));


}

void MDSDFFloatToCx::setup() {
# line 43 "MDSDFFloatToCx.pl"
input.setMDSDFParams(int(numRows),int(numCols));
    output.setMDSDFParams(int(numRows),int(numCols));
}

void MDSDFFloatToCx::go() {
# line 47 "MDSDFFloatToCx.pl"
// get input & output structures
    FloatSubMatrix* data = (FloatSubMatrix*)(input.getInput());
    ComplexSubMatrix* result = (ComplexSubMatrix*)(output.getOutput());

    // do conversion using copy constructor
    for(int row = 0; row < int(numRows); row++)
      for(int col = 0; col < int(numCols); col++)
        (*result)[row][col] = (Complex)((*data)[row][col]);
 
    // delete i/o access structures
    delete data;
    delete result;
}

// prototype instance for known block list
static MDSDFFloatToCx proto;
static RegisterBlock registerBlock(proto,"FloatToCx");
