static const char file_id[] = "MDSDFGain.pl";
// .cc file generated from MDSDFGain.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFGain.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFGain = "MDSDFGain";

const char* MDSDFGain :: className() const {return star_nm_MDSDFGain;}

ISA_FUNC(MDSDFGain,MDSDFStar);

Block* MDSDFGain :: makeNew() const { LOG_NEW; return new MDSDFGain;}

MDSDFGain::MDSDFGain ()
{
	setDescriptor("Multiply a floating-point matrix by a scalar gain value.");
	addPort(input.setPort("input",this,FLOAT_MATRIX));
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(numRows.setState("numRows",this,"2","Number of rows in the input block."));
	addState(numCols.setState("numCols",this,"2","Number of columns in the input block."));
	addState(gain.setState("gain",this,"1.0","Gain to be multiplied with the input matrix"));


}

void MDSDFGain::setup() {
# line 42 "MDSDFGain.pl"
input.setMDSDFParams(int(numRows),int(numCols));
    output.setMDSDFParams(int(numRows),int(numCols));
}

void MDSDFGain::go() {
# line 46 "MDSDFGain.pl"
// get a FloatSubMatrix access structure from the buffer
    FloatSubMatrix& in = *(FloatSubMatrix*)(input.getInput());
    FloatSubMatrix& out = *(FloatSubMatrix*)(output.getOutput());

    out = double(gain) * in;

    delete &in;
    delete &out;
}

// prototype instance for known block list
static MDSDFGain proto;
static RegisterBlock registerBlock(proto,"Gain");
