static const char file_id[] = "MDSDFIIDUniformMatrix.pl";
// .cc file generated from MDSDFIIDUniformMatrix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFIIDUniformMatrix.h"
#include <ACG.h>
#include "SubMatrix.h"

const char *star_nm_MDSDFIIDUniformMatrix = "MDSDFIIDUniformMatrix";

const char* MDSDFIIDUniformMatrix :: className() const {return star_nm_MDSDFIIDUniformMatrix;}

ISA_FUNC(MDSDFIIDUniformMatrix,MDSDFStar);

Block* MDSDFIIDUniformMatrix :: makeNew() const { LOG_NEW; return new MDSDFIIDUniformMatrix;}

# line 53 "MDSDFIIDUniformMatrix.pl"
extern ACG* gen;

MDSDFIIDUniformMatrix::MDSDFIIDUniformMatrix ()
{
	setDescriptor("Produces a FloatMatrix with IIDUniform entries.\nThis star uses the GNU library <Uniform.h>.");
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));
	addState(lower.setState("lower",this,"0.0","Lower limit."));
	addState(upper.setState("upper",this,"1.0","Upper limit."));

# line 56 "MDSDFIIDUniformMatrix.pl"
random = NULL;
}

MDSDFIIDUniformMatrix::~MDSDFIIDUniformMatrix() {
# line 59 "MDSDFIIDUniformMatrix.pl"
LOG_DEL; delete random;
}

void MDSDFIIDUniformMatrix::setup() {
# line 62 "MDSDFIIDUniformMatrix.pl"
// set the dimensions of the porthole
    output.setMDSDFParams(int(numRows), int(numCols));

    LOG_DEL; delete random;
    LOG_NEW; random = new Uniform(double(lower),double(upper),gen);
}

void MDSDFIIDUniformMatrix::go() {
# line 69 "MDSDFIIDUniformMatrix.pl"
// get a SubMatrix from the buffer
    FloatSubMatrix *matrix;

    matrix = (FloatSubMatrix*)output.getOutput();

    // initialize the subMatrix with values from the FloatStateArray
    for(int i = 0; i < int(numRows)*int(numCols); i++)
      matrix->entry(i) = (*random)();
    delete matrix;
}

// prototype instance for known block list
static MDSDFIIDUniformMatrix proto;
static RegisterBlock registerBlock(proto,"IIDUniformMatrix");
