static const char file_id[] = "MDSDFInverse.pl";
// .cc file generated from MDSDFInverse.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFInverse.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFInverse = "MDSDFInverse";

const char* MDSDFInverse :: className() const {return star_nm_MDSDFInverse;}

ISA_FUNC(MDSDFInverse,MDSDFStar);

Block* MDSDFInverse :: makeNew() const { LOG_NEW; return new MDSDFInverse;}

MDSDFInverse::MDSDFInverse ()
{
	setDescriptor("Invert a square floating-point matrix.");
	addPort(input.setPort("input",this,FLOAT_MATRIX));
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(rowsCols.setState("rowsCols",this,"2","The number of rows/columns of the input square matrix."));


}

void MDSDFInverse::setup() {
# line 30 "MDSDFInverse.pl"
input.setMDSDFParams(int(rowsCols),int(rowsCols));
		output.setMDSDFParams(int(rowsCols),int(rowsCols));
}

void MDSDFInverse::go() {
# line 35 "MDSDFInverse.pl"
FloatSubMatrix& matrix = *(FloatSubMatrix*)(input.getInput());
	  FloatSubMatrix& result = *(FloatSubMatrix*)(output.getOutput());
	  result = !matrix;              // invert the matrix
          delete &matrix;
	  delete &result;
}

// prototype instance for known block list
static MDSDFInverse proto;
static RegisterBlock registerBlock(proto,"Inverse");
