static const char file_id[] = "MDSDFMult.pl";
// .cc file generated from MDSDFMult.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFMult.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFMult = "MDSDFMult";

const char* MDSDFMult :: className() const {return star_nm_MDSDFMult;}

ISA_FUNC(MDSDFMult,MDSDFStar);

Block* MDSDFMult :: makeNew() const { LOG_NEW; return new MDSDFMult;}

MDSDFMult::MDSDFMult ()
{
	setDescriptor("Does a matrix multiplication of two input matrices A and B to produce matrix C.\nMatrix A has dimensions M x N, Matrix B has dimensions N x O, and Matrix C\nhas dimensions M x O.");
	addPort(Ainput.setPort("Ainput",this,FLOAT_MATRIX));
	addPort(Binput.setPort("Binput",this,FLOAT_MATRIX));
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(AinputRows.setState("AinputRows",this,"2","The number of rows in Matrix A"));
	addState(AinputColsBinputRows.setState("AinputColsBinputRows",this,"2","The number of columns in Matrix A = rows in Matrix B"));
	addState(BinputCols.setState("BinputCols",this,"2","The number of columns in Matrix B"));


}

void MDSDFMult::setup() {
# line 50 "MDSDFMult.pl"
Ainput.setMDSDFParams(int(AinputRows), int(AinputColsBinputRows));
	    Binput.setMDSDFParams(int(AinputColsBinputRows), int(BinputCols));
	    output.setMDSDFParams(int(AinputRows), int(BinputCols));
}

void MDSDFMult::go() {
# line 55 "MDSDFMult.pl"
// get a SubMatrix from the buffer
            FloatSubMatrix& input1 = *(FloatSubMatrix*)(Ainput.getInput());
            FloatSubMatrix& input2 = *(FloatSubMatrix*)(Binput.getInput());
            FloatSubMatrix& result = *(FloatSubMatrix*)(output.getOutput());

            // compute product, putting result into output
            result = input1 * input2;

            delete &input1;
            delete &input2;
            delete &result;
}

// prototype instance for known block list
static MDSDFMult proto;
static RegisterBlock registerBlock(proto,"Mult");
