static const char file_id[] = "MDSDFRepeat.pl";
// .cc file generated from MDSDFRepeat.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFRepeat.h"

const char *star_nm_MDSDFRepeat = "MDSDFRepeat";

const char* MDSDFRepeat :: className() const {return star_nm_MDSDFRepeat;}

ISA_FUNC(MDSDFRepeat,MDSDFStar);

Block* MDSDFRepeat :: makeNew() const { LOG_NEW; return new MDSDFRepeat;}

MDSDFRepeat::MDSDFRepeat ()
{
	setDescriptor("Output a constant matrix with the value given at the input.");
	addPort(input.setPort("input",this,FLOAT_MATRIX));
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(numInputRows.setState("numInputRows",this,"1","The number of rows in the input matrix."));
	addState(numInputCols.setState("numInputCols",this,"1","The number of columns in the input matrix."));
	addState(rowRepetitionFactor.setState("rowRepetitionFactor",this,"2","Duplication factor in the vertical direction"));
	addState(colRepetitionFactor.setState("colRepetitionFactor",this,"2","Duplication factor in the horizontal direction"));


}

void MDSDFRepeat::setup() {
# line 47 "MDSDFRepeat.pl"
// set dimensions of output matrix
            input.setMDSDFParams(int(numInputRows),int(numInputCols));
            output.setMDSDFParams(int(numInputRows)*int(rowRepetitionFactor),
				  int(numInputCols)*int(colRepetitionFactor));
}

void MDSDFRepeat::go() {
# line 53 "MDSDFRepeat.pl"
FloatSubMatrix& in = *(FloatSubMatrix*)(input.getInput());
                FloatSubMatrix& out = *(FloatSubMatrix*)(output.getOutput());
		for (int i = 0; i < int(rowRepetitionFactor); i++) {
		    for (int j = 0; j < int(colRepetitionFactor); j++) {
			// Create a submatrix of the output matrix
			FloatSubMatrix temp(out,
				i*int(numInputRows),	// starting row number
				j*int(numInputCols),	// starting col number
				int(numInputRows),	// number of rows
				int(numInputCols));	// number of cols
			temp = in;
		    }
		}
		delete &out;
		delete &in;
}

// prototype instance for known block list
static MDSDFRepeat proto;
static RegisterBlock registerBlock(proto,"Repeat");
