static const char file_id[] = "MDSDFTranspose.pl";
// .cc file generated from MDSDFTranspose.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFTranspose.h"
#include "SubMatrix.h"

const char *star_nm_MDSDFTranspose = "MDSDFTranspose";

const char* MDSDFTranspose :: className() const {return star_nm_MDSDFTranspose;}

ISA_FUNC(MDSDFTranspose,MDSDFStar);

Block* MDSDFTranspose :: makeNew() const { LOG_NEW; return new MDSDFTranspose;}

MDSDFTranspose::MDSDFTranspose ()
{
	setDescriptor("Transpose a floating-point matrix read as a single particle.");
	addPort(input.setPort("input",this,FLOAT_MATRIX));
	addPort(output.setPort("output",this,FLOAT_MATRIX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input matrix."));


}

void MDSDFTranspose::setup() {
# line 36 "MDSDFTranspose.pl"
input.setMDSDFParams(int(numRows),int(numCols));
    output.setMDSDFParams(int(numCols),int(numRows));
}

void MDSDFTranspose::go() {
# line 40 "MDSDFTranspose.pl"
FloatSubMatrix& matrix = *(FloatSubMatrix*)(input.getInput());
    FloatSubMatrix& result = *(FloatSubMatrix*)(output.getOutput());
    result = ~matrix;              // equivalent to matrix.transpose()
    delete &matrix;
    delete &result;
}

// prototype instance for known block list
static MDSDFTranspose proto;
static RegisterBlock registerBlock(proto,"Transpose");
