static const char file_id[] = "MDSDFXprism3.pl";
// .cc file generated from MDSDFXprism3.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFXprism3.h"

const char *star_nm_MDSDFXprism3 = "MDSDFXprism3";

const char* MDSDFXprism3 :: className() const {return star_nm_MDSDFXprism3;}

ISA_FUNC(MDSDFXprism3,MDSDFStar);

Block* MDSDFXprism3 :: makeNew() const { LOG_NEW; return new MDSDFXprism3;}

MDSDFXprism3::MDSDFXprism3 ()
{
	setDescriptor("Generate a plot of a two-dimensional signal with the xprism3 program.  Due\nto a bug in xprism3 reading raw files from the command line, we go through the\nintermediate step of converting the raw file to a Viff file using raw2viff.");
	addPort(input.setPort("input",this,FLOAT_MATRIX));
	addState(numRows.setState("numRows",this,"100","The number of rows in the input."));
	addState(numCols.setState("numCols",this,"100","The number of columns in the input."));
	addState(programName.setState("programName",this,"xprism3","File to save the input to the xgraph program."));
	addState(saveFile.setState("saveFile",this,"tmpFile","File to save the input to the xgraph program."));


}

void MDSDFXprism3::setup() {
# line 58 "MDSDFXprism3.pl"
input.setMDSDFParams(int(numRows),int(numCols));
}

void MDSDFXprism3::go() {
# line 61 "MDSDFXprism3.pl"
// read data from input
	  FloatSubMatrix* inputMatrix = (FloatSubMatrix*)(input.getInput());
	  int del = FALSE;

	  const char* iname = (const char*)saveFile;
	  char* nm = 0;
	  if (iname && *iname) {
	    nm = expandPathName(iname);
	    del = FALSE;
	  }
	  else {
	    nm = tempFileName();
	    del = TRUE;
	  }
	  StringList fileName = nm;
	  delete [] nm;

	  FILE *fp = fopen(fileName, "w");
	  if (fp == 0) {
	    delete inputMatrix;
	    Error::abortRun(*this, "cannot open '", fileName, "' for writing.");
	    return;
	  }

          // write out as float instead of double
          int size = int(numRows) * int(numCols);
	  float* buffer = new float[size];
	  float* p = buffer;
	  for(int i = 0; i < size; i++) {
	    *p++ = (float)inputMatrix->entry(i);
	  }
	  fwrite((char *)buffer, sizeof(float), size, fp);
	  fclose(fp);
	  delete [] buffer;

	  StringList tmpFileName = fileName;
	  tmpFileName << ".viff";

	  // first generate the command to run raw2viff
	  StringList cmd;
          cmd << "( raw2viff -i " << fileName << " -o " << tmpFileName;
	  cmd << " -t \"float\" -mt \"Local Machine\" -r ";
	  cmd << int(numRows) << " -c " << int(numCols) << ";";

          // next, add command to run xprism3
          cmd << programName << " -i11 " << tmpFileName;
	  if(del) {
            cmd << "; rm -f " << tmpFileName;
	    cmd << "; rm -f " << fileName;
	  }
          cmd << ")&";   // run command in the background
	  system(cmd);
}

// prototype instance for known block list
static MDSDFXprism3 proto;
static RegisterBlock registerBlock(proto,"Xprism3");
