static const char file_id[] = "MDSDFTclScript.pl";
// .cc file generated from MDSDFTclScript.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "MDSDFTclScript.h"

const char *star_nm_MDSDFTclScript = "MDSDFTclScript";

const char* MDSDFTclScript :: className() const {return star_nm_MDSDFTclScript;}

ISA_FUNC(MDSDFTclScript,MDSDFStar);

Block* MDSDFTclScript :: makeNew() const { LOG_NEW; return new MDSDFTclScript;}

MDSDFTclScript::MDSDFTclScript ()
{
	setDescriptor("Invoke a Tcl script that can optionally define a procedure that is\ninvoked every time the star fires.");
	addPort(output.setPort("output",this,FLOAT));
	addPort(input.setPort("input",this,ANYTYPE));
	addState(tcl_file.setState("tcl_file",this,"$PTOLEMY/src/domains/sdf/tcltk/stars/tkScript.tcl","The file from which to read the tcl script"));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));


}

void MDSDFTclScript::begin() {
# line 120 "MDSDFTclScript.pl"
tcl.setup(this,input.numberPorts(),
			output.numberPorts(), (const char*)tcl_file);
}

void MDSDFTclScript::setup() {
# line 113 "MDSDFTclScript.pl"
// set the dimensions of the porthole
            //  temporary, would prefer to define some kind of ANY_SIZE
            //  dimensionality
	    input.setMDSDFParams(int(numRows), int(numCols));
            output.setMDSDFParams(int(numRows), int(numCols));
}

void MDSDFTclScript::go() {
# line 124 "MDSDFTclScript.pl"
tcl.go();

	    // Send output values from the local buffer
	    MPHIter nexto(output);
	    PortHole *p;
	    int i = 0;
	    while ((p = nexto++) != 0) {
		(*p)%0 << tcl.outputValues[i++];
	    }
}

// prototype instance for known block list
static MDSDFTclScript proto;
static RegisterBlock registerBlock(proto,"TclScript");
