static const char file_id[] = "SDFController.pl";
// .cc file generated from SDFController.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFController.h"

const char *star_nm_SDFController = "SDFController";

const char* SDFController :: className() const {return star_nm_SDFController;}

ISA_FUNC(SDFController,SDFStar);

Block* SDFController :: makeNew() const { LOG_NEW; return new SDFController;}

# line 57 "SDFController.pl"
extern int voiceCheck (Envelope&, NamedObj&);
      extern ACG* gen;

SDFController::SDFController ()
{
	setDescriptor("Switch routing table");
	addPort(indata.setPort("indata",this,MESSAGE));
	addPort(tableupdate.setPort("tableupdate",this,MESSAGE));
	addPort(outdata.setPort("outdata",this,MESSAGE));
	addPort(ackmq.setPort("ackmq",this,MESSAGE));
	addState(numcpes.setState("numcpes",this,"12","Number of CPE's in simulation"));

# line 62 "SDFController.pl"
srttable = 0;
}

SDFController::~SDFController() {
# line 87 "SDFController.pl"
if ( srttable ) {
         for (int i = 0; i < int(numcpes); i++) {
            LOG_DEL; delete [] srttable[i];
         }
      }
      LOG_DEL; delete [] srttable;
}

void SDFController::setup() {
# line 66 "SDFController.pl"
Envelope dumEnv(*new VoiceData());
      nEnv = dumEnv;

      if ( srttable ) {
         for (int i = 0; i < int(numcpes); i++) {
           LOG_DEL; delete [] srttable[i];
         }
         LOG_DEL; delete [] srttable;
      }

      LOG_NEW; srttable = new int* [int(numcpes)];
      for (int i = 0; i < int(numcpes); i++) {
         LOG_NEW; srttable[i] = new int [indata.numberPorts()];
      }
      
      for (i = 0; i < int(numcpes); i++)
         for (int j = 0; j < indata.numberPorts(); j++)
            srttable[i][j] = 0;
}

void SDFController::go() {
# line 96 "SDFController.pl"
Envelope inEnv, updateEnv;
        int vci = 0, ivci = 0, ovci = 0, scpe = 0, dcpe = 0;
       
        (tableupdate%0).getMessage(updateEnv);
        if (!voiceCheck (updateEnv,*this)) return;
        const VoiceData * inVoice1 = (const VoiceData*) updateEnv.myData();
        unsigned char *ptr1 = inVoice1->asVoice();

        if (inVoice1->nulltestMessage()) { 
           ackmq%0 << nEnv;
        }
        else {
           // Do the update
           // Two updates must be performed
           ivci = (int) ptr1[0]; //obtain IVCI/VPI value
           ovci = (int) ptr1[1]; //obtain OVCI/VPI value
           scpe = (int) ptr1[2]; //obtain SCPE#
           dcpe = (int) ptr1[3]; //obtain DCPE#
  
           // make table updates
           srttable[scpe-1][ivci-1] = ovci; //process for outgoing pkts
           srttable[dcpe-1][ovci-1] = ivci; //process for incoming pkts

           // Now must send an ack packet to the MQcontroller
           LOG_NEW; VoiceData *op = new VoiceData("ACK");
           Envelope  oEnv(*op);
           ackmq%0 << oEnv;
        }

        MPHIter nexti(indata);
        MPHIter nexto(outdata);
        PortHole* p;

        while((p = nexti++) != 0) {

           //Read in data packet
           ((*p)%0).getMessage(inEnv);
           const VoiceData * inVoice2 = (const VoiceData*) inEnv.myData();

           // Check to see if input packet is null

           if (inVoice2->nulltestMessage()) { 
              // Assign null packet
              (*nexto++)%0 << nEnv;
              vci++;

           }
           else {

              VoiceData * inVoice3 = (VoiceData*) inEnv.writableCopy();
              unsigned char *ptr3 = inVoice3->asVoice();

              // Packet not null, so do reassignment
              // Locate value in srttable
              scpe = int(ptr3[2]);

              // Assign new value
              ptr3[0] = (unsigned char) (srttable[scpe-1][vci] - 1);

              // Send out the 
              Envelope  dEnv(*inVoice3);
              (*nexto++)%0 << dEnv;
              vci++;

           }  // end if

        }  // end while
}

// prototype instance for known block list
static SDFController proto;
static RegisterBlock registerBlock(proto,"Controller");
