static const char file_id[] = "SDFCfft.pl";
// .cc file generated from SDFCfft.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFCfft.h"

const char *star_nm_SDFCfft = "SDFCfft";

const char* SDFCfft :: className() const {return star_nm_SDFCfft;}

ISA_FUNC(SDFCfft,SDFStar);

Block* SDFCfft :: makeNew() const { LOG_NEW; return new SDFCfft;}

SDFCfft::SDFCfft ()
{
	setDescriptor("Compute the complex FFT.\n\fIInputSize\fR is number of input samples.\n\fIfftSize\fR is the size of FFT.\nZero padding is used if\nfftSize > InputSize\nInverse FFT is used if \fIInverse\fR is 1.\nUse Hamming window if \fIUseWindow\fR is true.");
	addPort(input.setPort("input",this,COMPLEX));
	addPort(output.setPort("output",this,COMPLEX));
	addState(InputSize.setState("InputSize",this,"256","Number of input samples to read."));
	addState(fftSize.setState("fftSize",this,"256","Size of the transform."));
	addState(Inverse.setState("Inverse",this,"0","Equals 1 for inverse."));
	addState(UseWindow.setState("UseWindow",this,"0","Equals 1 to use Hamming window"));

# line 59 "SDFCfft.pl"
Temp = 0;
    In = 0;
}

SDFCfft::~SDFCfft() {
# line 63 "SDFCfft.pl"
delete [] Temp;
    delete [] In;
}

void SDFCfft::setup() {
# line 67 "SDFCfft.pl"
delete [] Temp;
    Temp = new Complex[ int(fftSize) ];
    delete [] In;
    In = new Complex[ int(fftSize) ];
    input.setSDFParams( int(InputSize), int(InputSize)-1 );
    output.setSDFParams( int(fftSize), int(fftSize)-1 );
}

void SDFCfft::go() {
# line 85 "SDFCfft.pl"
int invflag = Inverse;
    int fftlength = fftSize;
    nb_fft F( invflag, fftlength );

    for (int i = 0; i < int(InputSize); i++ )
      In[ int(InputSize) - i - 1 ] = (input%i);
    for (i = int(InputSize); i < fftlength; i++ )
      In[ i ] = 0;

    double WinNorm = 1;
    if( int(UseWindow) ) {
      double Sum = 0;
      for( i = 0; i < fftlength; i++ ) {
	double TimeArg = ( double(i) / ( double(fftlength) - 1.0 ) ) - 0.5;
	double WV = WinVal( TimeArg );
	In[ i ] *= WV;
	Sum += WV;
      }
      // This is the 1/(DC gain) compared to rect. window
      WinNorm = fftlength / Sum;
    }

    Complex* Result = F.Compute( In, Temp );

    double Norm = int(Inverse) ? WinNorm : WinNorm / double(fftlength);
    for( i = 0; i < fftlength; i++ )
      Result[ i ] *= Norm;

    for ( i = 0; i < fftlength; i++ )
      (output%i) << Result[ fftlength - i - 1 ];
}

// prototype instance for known block list
static SDFCfft proto;
static RegisterBlock registerBlock(proto,"Cfft");
