static const char file_id[] = "SDFPipeOut.pl";
// .cc file generated from SDFPipeOut.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFPipeOut.h"

const char *star_nm_SDFPipeOut = "SDFPipeOut";

const char* SDFPipeOut :: className() const {return star_nm_SDFPipeOut;}

ISA_FUNC(SDFPipeOut,SDFStar);

Block* SDFPipeOut :: makeNew() const { LOG_NEW; return new SDFPipeOut;}

SDFPipeOut::SDFPipeOut ()
{
	setDescriptor("Pipe outputs to shell command");
	addPort(in.setPort("in",this,FLOAT));
	addState(XY.setState("XY",this,"NO","If YES output x, tab, y, return.\nIf no output y, return."));
	addState(command.setState("command",this,"","the command to run"));
	addState(Xinc.setState("Xinc",this,"1","increment to use for X when XY == YES"));
	addState(Xinit.setState("Xinit",this,"0","initial value for X when XY == YES"));


}

void SDFPipeOut::wrapup() {
# line 79 "SDFPipeOut.pl"
pclose( out );
}

void SDFPipeOut::setup() {
# line 50 "SDFPipeOut.pl"
const char *commandstr = command;
    out = popen( commandstr, "w" );
    x = Xinit;
    if( !out ) {
      Error::abortRun( *this, "Error opening pipe to command",
		       commandstr );
    }
}

void SDFPipeOut::go() {
# line 59 "SDFPipeOut.pl"
int count = 0;		// count how many fields have been output
    if( int(XY) ) {
      fprintf( out, "%g", x );
      x += Xinc;
      count++;
    }
    MPHIter nextp( in );
    PortHole* p;
    double value;
    while( (p = nextp++) ) {
      value = ((*p)%0);
      if( ! count )
	fprintf( out, "%g", value );
      else
	fprintf( out, "\t%g", value );
      count++;
    }
    fputs( "\n", out );
}

// prototype instance for known block list
static SDFPipeOut proto;
static RegisterBlock registerBlock(proto,"PipeOut");
