static const char file_id[] = "SDFPowerEst.pl";
// .cc file generated from SDFPowerEst.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFPowerEst.h"
#include <math.h>

const char *star_nm_SDFPowerEst = "SDFPowerEst";

const char* SDFPowerEst :: className() const {return star_nm_SDFPowerEst;}

ISA_FUNC(SDFPowerEst,SDFStar);

Block* SDFPowerEst :: makeNew() const { LOG_NEW; return new SDFPowerEst;}

# line 55 "SDFPowerEst.pl"
/* hppa.cfront has a sqr(double x) in math.h, so use mySqr */
    inline double mySqr( double x ) {
      return x * x;
    }
    inline double TodB( double x ) {
      return 10. * log10( x );
    }

SDFPowerEst::SDFPowerEst ()
{
	setDescriptor("Power Estimator");
	addState(TimeConstant.setState("TimeConstant",this,"100","Time constant in samples"));
	addState(dB.setState("dB",this,"YES","convert to dB if True"));
	addState(BlockSize.setState("BlockSize",this,"1","Read a block of this size at a time"));
	addPort(in.setPort("in",this,FLOAT));
	addPort(out.setPort("out",this,FLOAT));


}

void SDFPowerEst::setup() {
# line 49 "SDFPowerEst.pl"
Sum = 0;
    FeedbackGain = 1. - 1./double( TimeConstant );
    in.setSDFParams( int( BlockSize ), int( BlockSize ) - 1 );
}

void SDFPowerEst::go() {
# line 64 "SDFPowerEst.pl"
for( int i = int(BlockSize) - 1; i >= 0; i-- )
      Sum = Sum * FeedbackGain + mySqr(double(in%i));
    double output = Sum / double( TimeConstant );
    out%0 << ( int( dB ) ? TodB( output ) : output );
}

// prototype instance for known block list
static SDFPowerEst proto;
static RegisterBlock registerBlock(proto,"PowerEst");
