static const char file_id[] = "SDFPowerEstCx.pl";
// .cc file generated from SDFPowerEstCx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFPowerEstCx.h"
#include <math.h>

const char *star_nm_SDFPowerEstCx = "SDFPowerEstCx";

const char* SDFPowerEstCx :: className() const {return star_nm_SDFPowerEstCx;}

ISA_FUNC(SDFPowerEstCx,SDFStar);

Block* SDFPowerEstCx :: makeNew() const { LOG_NEW; return new SDFPowerEstCx;}

# line 54 "SDFPowerEstCx.pl"
inline double TodB( double x ) {
      return 10. * log10( x );
    }

SDFPowerEstCx::SDFPowerEstCx ()
{
	setDescriptor("Power Estimator");
	addState(TimeConstant.setState("TimeConstant",this,"100","Time constant in samples"));
	addState(dB.setState("dB",this,"YES","convert to dB if True"));
	addState(BlockSize.setState("BlockSize",this,"1","Read a block of this size at a time"));
	addPort(in.setPort("in",this,COMPLEX));
	addPort(out.setPort("out",this,FLOAT));


}

void SDFPowerEstCx::setup() {
# line 48 "SDFPowerEstCx.pl"
Sum = 0;
    FeedbackGain = 1. - 1./double( TimeConstant );
    in.setSDFParams( int( BlockSize ), int( BlockSize ) - 1 );
}

void SDFPowerEstCx::go() {
# line 59 "SDFPowerEstCx.pl"
for( int i = int(BlockSize) - 1; i >= 0; i-- )
      Sum = Sum * FeedbackGain + norm(Complex(in%i));
    double output = Sum / double( TimeConstant );
    out%0 << ( int( dB ) ? TodB( output ) : output );
}

// prototype instance for known block list
static SDFPowerEstCx proto;
static RegisterBlock registerBlock(proto,"PowerEstCx");
