static const char file_id[] = "SDFVariance.pl";
// .cc file generated from SDFVariance.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFVariance.h"

const char *star_nm_SDFVariance = "SDFVariance";

const char* SDFVariance :: className() const {return star_nm_SDFVariance;}

ISA_FUNC(SDFVariance,SDFStar);

Block* SDFVariance :: makeNew() const { LOG_NEW; return new SDFVariance;}

# line 52 "SDFVariance.pl"
inline double mySqr( double x ) {
	    return x * x;
	  }

SDFVariance::SDFVariance ()
{
	setDescriptor("Compute Mean and Variance");
	addPort(in.setPort("in",this,FLOAT));
	addState(skip.setState("skip",this,"0","number of tokens to ignore"));
	addState(block.setState("block",this,"1","process in blocks of this size"));
	addPort(mean.setPort("mean",this,FLOAT));
	addPort(variance.setPort("variance",this,FLOAT));


}

void SDFVariance::setup() {
# line 45 "SDFVariance.pl"
SumXsqr = 0;
	  SumX = 0;
	  count = 0;
	  skipcount = int(skip);
	  in.setSDFParams( int(block), int(block) - 1);
}

void SDFVariance::go() {
# line 57 "SDFVariance.pl"
for( int i = int(block) - 1; i >= 0; i-- ) {
	    if( skipcount )
	      skipcount--;
	    else {
	      count++;
	      float input = (float)(in%i);
	      SumX += input;
	      SumXsqr += mySqr( input );
	    }
	  }
	  if( count ) {
	    mean%0 << (SumX / count);
	    variance%0 << ( (SumXsqr/count) - mySqr( SumX/count ) );
	  }
	  else {
// have to output something
	    mean%0 << 0;
	    variance%0 << 0;
	  }
}

// prototype instance for known block list
static SDFVariance proto;
static RegisterBlock registerBlock(proto,"Variance");
