static const char file_id[] = "SDFWirelessChannel.pl";
// .cc file generated from SDFWirelessChannel.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFWirelessChannel.h"

const char *star_nm_SDFWirelessChannel = "SDFWirelessChannel";

const char* SDFWirelessChannel :: className() const {return star_nm_SDFWirelessChannel;}

ISA_FUNC(SDFWirelessChannel,SDFStar);

Block* SDFWirelessChannel :: makeNew() const { LOG_NEW; return new SDFWirelessChannel;}

SDFWirelessChannel::SDFWirelessChannel ()
{
	setDescriptor("Wireless Channel - Equivalent Complex Baseband Channel.\nThis model takes multipath propagation into account.");
	addPort(DataIn.setPort("DataIn",this,COMPLEX));
	addPort(DataOut.setPort("DataOut",this,COMPLEX));
	addState(CarrierFrequency.setState("CarrierFrequency",this,"1000.0","Carrier Frequency In MHz"));
	addState(SymbolRate.setState("SymbolRate",this,"1500.0","Symbol (Sample) Rate In MHz"));
	addState(RMSDelaySpread.setState("RMSDelaySpread",this,"40.0","Root Mean Square Delay Spread In Nanoseconds"));
	addState(DopplerSpread.setState("DopplerSpread",this,"4.0","Frequency Spreading In Hertz"));
	addState(PathLossRate.setState("PathLossRate",this,"2.18","Large Scale Signal Variation"));
	addState(ReferencePowerLoss.setState("ReferencePowerLoss",this,"55.0","The Power Loss At 1 Meter From Transmitter in dB.\n		       Note That The Default Is Based Upon Experiments \n		       In Room 550, Cory Hall (UC Berkeley) With Biconical \n		       Antenna And Carrier Frequency At 2.4 GHz."));
	addState(ChannelType.setState("ChannelType",this,"Indoor","Indoor(i;I), OutdoorMobile(o;O)"));
	addState(MeanSeparationDistance.setState("MeanSeparationDistance",this,"10.0","Mean Separation Distance Between Antennas In Meters"));


}

void SDFWirelessChannel::setup() {
# line 127 "SDFWirelessChannel.pl"
// Setup Channel Parameters
		params.wc = CarrierFrequency;
		params.Td = RMSDelaySpread;
		params.Ts = SymbolRate;
		params.Fd = DopplerSpread;
		params.loss_rate = PathLossRate;
		params.ref_power_loss = ReferencePowerLoss;
		params.mean_distance = MeanSeparationDistance;
		const char* type = ChannelType;
		params.channel_type = type[0];

		Channel.Setup(params);
}

void SDFWirelessChannel::go() {
# line 142 "SDFWirelessChannel.pl"
DataOut%0 << Channel.Input( Complex(DataIn%0) );
}

// prototype instance for known block list
static SDFWirelessChannel proto;
static RegisterBlock registerBlock(proto,"WirelessChannel");
