.EQ
delim off
.EN
.\" documentation file generated from SDFAdaptLinQuant.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "AdaptLinQuant"
.SD
Uniform linear quantizer symmetric about 0 with variable step size.
.SE
.DM SDF SDFStar
.SV 1.1 "11/15/95"
.AL "William Chen"
.IH
.NE
\fIinput\fR (float)
.NE
\fIinStep\fR (float)
.PE
.OH
.NE
\fIamplitude\fR (float)
.NE
\fIoutStep\fR (float)
.NE
\fIstepLevel\fR (int)
.PE
.SH
.NE
\fIbits\fR (IntState)

.ET
.EQ
delim $$
.EN
.LD
The input is quantized to the number of levels given by 2^\fIbits\fR.
The quantization levels are uniformly spaced at the step size given by
the \fIinStep\fR input value and are odd symmetric about zero.
Therefore, the "high" threshold is (2^\fIbits\fR - 1)*\fIinStep\fR/2, and
the "low" threshold is the negative of the "high" threshold.
Rounding down is performed, so that output level will equal "high" only
if the input level equals or exceeds "high".
If the input is below "low", then the quantized output will equal "low".
The quantized value is output on the \fIamplitude\fR port as a floating-point
value, the step size is output on the \fIoutStep\fR port as a floating-point
value, and the index of the quantization level on the \fIstepLevel\fR port
as a non-negative integer between 0 and 2^\fIbits\fR - 1, inclusive.
.ES
