.EQ
delim off
.EN
.\" documentation file generated from SDFDCTImgCde.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "DCTImgCde"
.SD
This star takes a Float Matrix which represents a DCT image, 
inserts "start of block" markers, run-length encodes it, 
and outputs the modified image. 
For the run-length encoding, all values with absolute value less than "Thresh"
are set to 0.0, to help improve compression.

Runlengths are coded with a "start of run" symbol and then an (integer) 
run-length.
"HiPri" DCT coefficients per block are sent to "hiport", the high-priority 
output. 
The remainder of the coefficients are sent to "loport", the low-priority 
output.
.SE
.LO "SDF image library"
.DM SDF SDFStar
.SV 1.21 "3/7/96"
.AL "Paul Haskell"
.IH
.NE
\fIinport\fR (FLOAT_MATRIX_ENV)
.PE
.OH
.NE
\fIhiport\fR (FLOAT_MATRIX_ENV)
.NE
\fIloport\fR (FLOAT_MATRIX_ENV)
.NE
\fIoriginalW\fR (int): The width of the original (input) image.
.NE
\fIoriginalH\fR (int): The height of the original (input) image.
.NE
\fIcompr\fR (float)
.PE
.SH
.NE
\fIBlockSize\fR (IntState): Block size of the input DCT transformed image.
.DF "8"
.NE
\fIThresh\fR (FloatState): Threshold for run-length coding.
.DF "12.0"
.NE
\fIHiPri\fR (IntState): Number of DCT coefficients per block sent to 'hiport'.
.DF "3"
.ET
.EQ
delim $$
.EN
.ES
