.EQ
delim off
.EN
.\" documentation file generated from SDFDTMFPostTest.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "DTMFPostTest"
.SD
Returns whether or not a valid dual-tone modulated-frequency has
been correctly detected based on the last three detection results.
.SE
.LO "SDF main library"
.DM SDF SDFStar
.SV 1.4 "2/3/96"
.AL "Brian L. Evans"
.IH
.NE
\fIinput\fR (int)
.NE
\fIvalid\fR (int)
.PE
.OH
.NE
\fIoutput\fR (int)
.PE
.SH
.NE
\fIinitialLastInput\fR (IntState): The value to assign to last and secondToLast internal states, which hold the
previous two valid inputs.  For the purposes of DTMF detection, it is
set to an integer that does not represent a DTMF digit.
.DF "-1"
.NE
\fIlast\fR (IntState): internal state to store the last valid integer
.DF "-1"
.NE
\fIsecondToLast\fR (IntState): internal state to store the second-to-last valid integer
.DF "-1"
.ET
.EQ
delim $$
.EN
.LD
The assumption is that the 100 msec DTMF interval has been split into
roughly four parts.  This star looks at the last three detection results,
which are represented as integers.  A new digit has been detected
if two consecutive detected digits are the same followed by a third
detected digit that is different.
.PP
This test is useful for two reasons.
First, it filters redundant hits so that only one is reported.
Second, it improves robustness against noisy DTMF signals and speech input.
.UH REFERENCES
.IP [1]
Pat Mock, "Add DTMF Generation and Decoding to DSP-uP Designs,"
Electronic Data News, March 21, 1985.  Reprinted in
\fIDigital Signal Processing Applications with the TMS320 Family\fR,
Texas Instruments, 1986.
.ES
