.EQ
delim off
.EN
.\" documentation file generated from SDFDirichlet.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Dirichlet"
.SD
This star computes the normalized Dirichlet kernel (also called the aliased
sinc function):

d(x) = sin(N x / 2) / (N sin(x/2))

The value of the normalized Dirichlet kernel at x = 0 is always 1, and the
normalized Dirichlet kernel oscillates between -1 and +1.
The normalized Dirichlet kernel is periodic in x with a period of either
2*pi when N is odd or 4*pi when N is even.
.SE
.LO "SDF dsp library"
.DM SDF SDFStar
.SV 1.10 "3/2/95"
.AL "Brian Evans"
.IH
.NE
\fIinput\fR (float): The input x to the Dirichlet kernel.
.PE
.OH
.NE
\fIoutput\fR (float): The output of the Dirichlet kernel.
.PE
.SH
.NE
\fIN\fR (IntState): Length of the Dirichlet kernel.
.DF "10"
.ET
.EQ
delim $$
.EN
.LD
The Dirichlet kernel (a.k.a. the aliased sinc function) is the
discrete-time Fourier transform (DTFT) of a sampled pulse function.
The parameter $N$ is the length of the pulse [1].
.ID "Oppenheim, A. V."
.ID "Schafer, R. W."
.UH REFERENCES
.ip [1]
A. V. Oppenheim and R. W. Schafer, \fIDiscrete-Time Signal Processing\fR,
Prentice-Hall: Englewood Cliffs, NJ, 1989.
.SA
Sinc.
.ES
