.EQ
delim off
.EN
.\" documentation file generated from SDFDisplayVideo.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "DisplayVideo"
.SD
Accept a stream of black-and-white images from input Float Matrix,
save the images to files, and display the resulting files as a
moving video sequence.
This star requires that programs from the "Utah Raster Toolkit"
be in your path.
Although this toolkit is not included with Ptolemy, it is available for free.
See this star's long description (with the "look-inside" or
"manual" commands in the Ptolemy menu) for information on how
to get the toolkit.

The user can set the root filename of the displayed images
(which probably will be printed in the display window titlebar)
with the ImageName parameter. If no filename is set, a default
will be chosen.

The Save parameter can be set to "YES" or "NO" to choose whether
the created image files should be saved or deleted. Each images
frame number is appended to the root filename to form the images
complete filename.

The ByFields parameter can be set to either "YES" or "NO" to choose
whether the input images should be treated as interlaced fields
that make up a frame or as entire frames.
If the inputs are fields, then the first field should contain
frame lines 1, 3, 5, etc. and the second field should contain
lines 0, 2, 4, 6, etc
.SE
.LO "SDF image library"
.DM SDF SDFStar
.SV 1.25 "3/7/96"
.AL "Paul Haskell"
.IH
.NE
\fIinData\fR (FLOAT_MATRIX_ENV)
.NE
\fIinFrameId\fR (int)
.PE
.SH
.NE
\fIImageName\fR (StringState): If non-null, name for run-length encoded file.
.DF ""
.NE
\fISave\fR (IntState): If true (YES), then save the file.
.DF "NO"
.NE
\fIByFields\fR (IntState): If true (YES), then inputs are interlaced fields.
.DF "NO"
.ET
.EQ
delim $$
.EN
.LD
At the end of a simulation this star pops up an X window and
loads in a sequence of video frames for display.
Pressing the left or right mouse buttons inside the window plays
the video sequence backwards or forwards.
The middle mouse button allows single-stepping through frames.
If you hold down the shift key while pressing the left mouse button,
you loop through the sequence.
The shift key and middle mouse button lets you alter the frame rate
of the displayed video.
The shift key and right mouse button loops through the video
sequence alternately forwards and backwards.
To end a loop playback, press any mouse button in the video window.
To close the window type "q" inside.
.pp
This star uses programs from the \fIUtah Raster Toolkit\fR
to display moving video in an X window.
The Utah Raster Toolkit is a collection of software tools from the
University of Utah.
These programs are available free via anonymous ftp.
To get the software:
.sp
unix> ftp cs.utah.edu
.sp
ftp name> anonymous
.br
ftp passwd> YOUR EMAIL ADDRESS
.br
ftp> binary
.br
ftp> cd pub
.br
ftp> get urt-3.0.tar.Z
.br
ftp> quit
.sp
unix> uncompress urt-3.0.tar.Z
.br
unix> tar xvf urt-3.0.tar
.sp
Then, change directories to the new urt_3.0 directory and build the
software.
To use the software, put the name of the directory with the URT
executable files into the definition of the \fIpath\fR variable
inside the .cshrc file in your home directory.
.pp
These instructions are appropriate as of December 1992 but 
may have changed.
.ES
