.EQ
delim off
.EN
.\" documentation file generated from SDFFFTCx.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "FFTCx"
.SD
Compute the discrete Fourier transform of a complex input using the
fast Fourier transform (FFT) algorithm.  The star reads "size" (default
256) complex samples, zero pads the data if necessary, and then takes an
FFT of length 2 ^ "order", where "size" <= 2 ^ "order".  (The default
value of "order" is 8.)  The parameter "direction" (default 1) is 1 for
the forward and -1 for the inverse FFT.
.SE
.LO "SDF dsp library"
.DM SDF SDFStar
.SV 1.21 "12/7/95"
.AL "J. T. Buck"
.IH
.NE
\fIinput\fR (complex)
.PE
.OH
.NE
\fIoutput\fR (complex)
.PE
.SH
.NE
\fIorder\fR (IntState): Log base 2 of the transform size.
.DF "8"
.NE
\fIsize\fR (IntState): Number of input samples to read.
.DF "256"
.NE
\fIdirection\fR (IntState): Equals 1 for forward, or -1 for inverse, transform.
.DF "1"
.ET
.EQ
delim $$
.EN
.LD
A number of input samples given by the parameter \fIsize\fR will
be consumed at the input, zero-padded if necessary to make $2 sup order$
samples, and transformed using a fast Fourier transform algorithm.
.Id "FFT, complex"
.Id "fast Fourier transform, complex"
.Id "Fourier transform, fast, complex"
If \fIdirection\fR is 1, then the forward Fourier transform is computed.
If \fIdirection\fR is -1, then the inverse Fourier transform is computed.
.lp
Note a single firing of this star consumes \fIsize\fR inputs
and produces $2 sup order$ outputs.
This must be taken into account when determining for how many iterations
to run a universe.
For example, to compute just one FFT, only one iteration should be run.
.lp
\fBBugs\fR: the routine currently used (from Gabriel) recomputes trig
.Ir "Gabriel"
functions for each term, instead of using a table.
Instead, FFTCx::setup() should compute a table of appropriate size
in order to save time.
This approach does not offer any improvement, obviously, if only
one transform is performed.
.ID "Oppenheim, A. V."
.ID "Schafer, R. W."
.UH REFERENCES
.ip [1]
A. V. Oppenheim and R. W. Schafer, \fIDiscrete-Time Signal Processing\fR,
Prentice-Hall: Englewood Cliffs, NJ, 1989.
.ES
