.EQ
delim off
.EN
.\" documentation file generated from SDFGLA.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "GLA"
.SD
Use the Generalized Lloyd Algorithm (GLA) to yield a codebook from input  
training vectors.  Note that each input matrix will be viewed as a
row vector in row by row. Each row of output matrix represent a
codeword of the codebook.
.SE
.LO "SDF dsp library"
.DM SDF SDFStar
.SV 1.10 "10/30/95"
.AL "Bilung Lee"
.IH
.NE
\fIinput\fR (FLOAT_MATRIX_ENV): Input matrix will be viewed as a row vector in row major ordering to
represent a training vector.
.PE
.OH
.NE
\fIoutput\fR (FLOAT_MATRIX_ENV): Output codebook, ie, (sizeCodebook)*(dimension) matrix.
.PE
.SH
.NE
\fIdimension\fR (IntState): The dimension for the input training vector.
.DF "16"
.NE
\fIsizeTrnSet\fR (IntState): The number of input training vectors for yielding the codebook.
.DF "1024"
.NE
\fIsizeCodebook\fR (IntState): The number of desired codewords for the codebook.
.DF "64"
.NE
\fIthresholdRatio\fR (FloatState): A number between 0 to 1. When equal to 0, the resulting codebook will satisfy the necessary conditions for optimality.
.DF "0"
.NE
\fImaxIteration\fR (IntState): The upper limit on the iterations in the Lloyd algorithm.
.DF "100"
.NE
\fIsaveFile\fR (StringState): File to save the final codebook.
.DF ""
.ET
.EQ
delim $$
.EN
.ES
