.EQ
delim off
.EN
.\" documentation file generated from SDFHilbert.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Hilbert"
.SD
Output the (approximate) Hilbert transform of the input signal.
This star approximates the Hilbert transform by using an FIR filter.
.SE
.LO "SDF dsp library"
.DM SDF SDFFIR
.SV 1.12 "3/2/95"
.AL "J. T. Buck"
.SH
.NE
\fIN\fR (IntState): Number of taps
.DF "64"
.ET
.EQ
delim $$
.EN
.LD
.Id "Hilbert filter"
.Id "filter, Hilbert"
The exact Hilbert transform cannot be realized; instead, we just truncate
the response symmetrically at $-N/2$ and $N/2$ [1].
This is accurate enough for some applications, but for high accuracy we
suggest the use of the Parks-McClellan algorithm [2] to design a Hilbert
transformer filter with the desired characteristics [1,3].
The "optfir" program supplied with Ptolemy can do this.
.Ir "optfir program"
.ID "Oppenheim, A. V."
.ID "Rabiner, L. R."
.ID "Schafer, R. W."
.ID "Parks, T. W."
.UH REFERENCES
.ip [1]
A. V. Oppenheim and R. W. Schafer, \fIDiscrete-Time Signal Processing\fR,
Prentice-Hall: Englewood Cliffs, NJ, 1989.
.ip [2]
T. W. Parks and J. H. McClellan,
``Chebyshev Approximation for Nonrecursive Digital Filters With Linear Phase,''
\fIIEEE Trans. on Circuit Theory\fR, vol. 19, no. 2, pp. 189-194, March 1972.
.ip [3]
L. R. Rabiner, J. H. McClellan, and T. W. Parks,
``FIR Digital Filter Design Techniques Using Weighted Chebyshev Approximation,''
\fIProc. of the IEEE\fR, vol. 63, no. 4, pp. 595-610, April 1975.
.ES
