.EQ
delim off
.EN
.\" documentation file generated from SDFKalman_M.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Kalman_M"
.SD
Implements the Kalman filter.
.SE
.LO "SDF dsp library"
.DM SDF SDFStar
.SV 1.8 "6/19/95"
.AL "Mike J. Chen"
.IH
.NE
\fIinput\fR (FLOAT_MATRIX_ENV)
.NE
\fIStateTransitionMatrixAtTimeN\fR (FLOAT_MATRIX_ENV)
.NE
\fIMeasurementMatrixAtTimeN\fR (FLOAT_MATRIX_ENV)
.NE
\fIProcessNoiseCorrMatrixAtTimeN\fR (FLOAT_MATRIX_ENV)
.NE
\fIMeasurementNoiseCorrMatrixAtTimeN\fR (FLOAT_MATRIX_ENV)
.PE
.OH
.NE
\fIoutput\fR (FLOAT_MATRIX_ENV)
.PE
.SH
.NE
\fIstateDimension\fR (IntState): The number of elements in the state vector.
.DF "5"
.NE
\fIinputDimension\fR (IntState): The number of elements in the observation vector.
.DF "1"
.NE
\fIInitialState\fR (FloatArrayState): The initial value of the state vector.
.DF "0.0 [5]"
.NE
\fIInitialCorrMatrix\fR (FloatArrayState): The initial value of the correlation matrix of the error.
.DF ".1 0 [5] .1 0 [5] .1 0 [5] .1 0 [5] .1"
.NE
\fIInitialStateTransitionMatrix\fR (FloatArrayState): The state transition matrix at time 0. PHI(1,0)
.DF "1 0 [5] 1 0 [5] 1 0 [5] 1 0 [5] 1"
.NE
\fIInitialProcessNoiseCorrMatrix\fR (FloatArrayState): Correlation matrix of process noise vector at time 0. Q(0)
.DF "0.0 [25]"
.ET
.EQ
delim $$
.EN
.LD
Initial values for the state transition matrix, state vector, correlation
matrix, and process noise correlation matrix are parameters to the star.
Also parameters are the number of elements in the observation vector and
the number of elements in the state vector.
Inputs are the current values of the state transition matrix, process
noise correlation matrix, measurement noise correlation matrix, 
measurement matrix, and the observation vector.
The single output is the state vector.
.UH REFERENCES
.ip [1]
R.E. Kalman, "A new approach to linear filtering and prediction problems",
\fITrans. ASME, J. Basic Eng., Ser 82D, pp. 35-45, March 1960.
.ip [2]
S. Haykin, \fIAdaptive Filter Theory\fR, Prentice-Hall, Inc., Englewood Cliffs,
N.J., 1986.
.ES
