.EQ
delim off
.EN
.\" documentation file generated from SDFLMSCx.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "LMSCx"
.SD
A complex adaptive filter using the LMS adaptation algorithm.
The initial coefficients are given by the "taps" parameter.
The default initial coefficients give an 8th order, linear phase
lowpass filter.  To read initial coefficients from a file,
replace the default coefficients with "< fileName",
preferably specifying a complete path.
This star supports decimation, but not interpolation.
.SE
.LO "SDF dsp library"
.DM SDF SDFFIRCx
.SV 1.11 "10/30/95"
.AL "J. T Buck, E. A. Lee"
.IH
.NE
\fIerror\fR (complex)
.PE
.SH
.NE
\fIstepSize\fR (FloatState): Adaptation step size.
.DF "0.01"
.NE
\fIerrorDelay\fR (IntState): Delay in the update loop.
.DF "1"
.NE
\fIsaveTapsFile\fR (StringState): File to save final tap values.
.DF ""
.ET
.EQ
delim $$
.EN
.LD
When correctly used, this filter will adapt to try to minimize
the mean-squared error of the signal at its \fIerror\fR input.
In order for this to be possible, the output of the filter should
be compared (subtracted from) some reference signal to produce
an error signal.
That error signal should be fed back to the \fIerror\fR input.
The \fIdelay\fR parameter must equal the total number of delays
in the path from the output of the filter back to the error input.
This ensures correct alignment of the adaptation algorithm.
The number of delays must be greater than zero or the dataflow
graph will deadlock.
The adaptation algorithm used is the well-known LMS, or stochastic-gradient
algorithm, generalized to use complex signals and filter taps.
.Id "adaptive filter, complex"
.Id "filter, adaptive, complex"
.Id "filter, LMS, complex"
.Id "LMS adaptive filter, complex"
.Ir "stochastic gradient algorithm"
.lp
If the \fIsaveTapsFile\fR string is non-null, a file will
be created by the name given by that string, and the final tap values
will be stored there after the run has completed.
.SA
FIRCx,
LMS,
adaptFilter,
LMSPlotCx and
LMSTkPlotCx.
.ES
