.EQ
delim off
.EN
.\" documentation file generated from SDFLMSLeak.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "LMSLeak"
.SD
An LMS adaptive filter in which the step size is input
(to the "step" input) every iteration. In addition,
the "mu" parameter specifies a leakage factor in the
updates of the filter coefficients.
.SE
.LO "SDF dsp library"
.DM SDF SDFLMS
.SV 1.7 "3/2/95"
.AL "E. A. Lee, Paul Haskell"
.IH
.NE
\fIstep\fR (float): Step-size for LMS algorithm.
.PE
.SH
.NE
\fImu\fR (FloatState): Leak factor for coefficient update.
.DF "0.0"
.ET
.EQ
delim $$
.EN
.LD
If two identical "LMSLeak" filters are used as an adaptive predictive
coder and decoder, then with "mu" nearly equal to but greater than 0.0,
the effects of channel errors between the coder and decoder will decay
away rather than accumulate. As "mu" increases, the effects of channel
errors decay away more quickly, but the size of the "error" input
increases also.
See pg 54 of [1].
.UH References
.ip [1]
W. Honig and D. G. Messerschmitt,
\fIAdaptive_Filters\fR, Kluwer Academic Publishers, Norwood MA, 1985.
.SA
LMS.
.ES
