.EQ
delim off
.EN
.\" documentation file generated from SDFLinQuantIdx.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "LinQuantIdx"
.SD
The input is quantized to the number of levels given by the "levels"
parameter plus 1.  The quantization levels are uniformly spaced between "low"
and "high" inclusive.  Rounding down is performed, so that output level
will equal "high" only if the input level equals or exceeds "high".
If the input is below "low", then the quantized output will equal "low".
The quantized value is output to the "amplitude" port, while the index
of the quantization level is output to the "stepNumber" port.  This
integer output is useful for stars that need an integer input, such as
Thor stars.
.SE
.DM SDF SDFStar
.SV 1.18 "2/25/96"
.AL "Asawaree Kalavade"
.IH
.NE
\fIinput\fR (float)
.PE
.OH
.NE
\fIamplitude\fR (float)
.NE
\fIstepNumber\fR (int)
.PE
.SH
.NE
\fIlevels\fR (IntState): number of levels to quantize to
.DF "128"
.NE
\fIlow\fR (FloatState): lower limit of signal excursion
.DF "-3.0"
.NE
\fIhigh\fR (FloatState): upper limit of signal excursion
.DF "3.0"
.NE
\fIheight\fR (FloatState): height of each quantization step, which is determined by the states
high, low, and levels.
.DF "1.0"
.ET
.EQ
delim $$
.EN
.ES
