.EQ
delim off
.EN
.\" documentation file generated from SDFMUSIC_M.pl by ptlang
.\" Copyright (c) 1993-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "MUSIC_M"
.SD
This star is used to estimate the frequencies of some specified number
of sinusoids in a signal. The output is the eigenspectrum of a signal
such that the locations of the peaks of the eigenspectrum correspond
to the frequencies of sinusoids in the signal.  The input is the right
singular vectors in the form generated by the SVD_M star.  The MUSIC
algorithm is used, where MUSIC stands for "multiple signal classification."
.SE
.LO "SDF dsp library"
.DM SDF SDFStar
.SV 1.16 "3/7/96"
.AL "Mike J. Chen"
.IH
.NE
\fIrsvec\fR (FLOAT_MATRIX_ENV): Right singular vectors.
.PE
.OH
.NE
\fIoutput\fR (float): S(w) eigenspectrum points.
.PE
.SH
.NE
\fInumRows\fR (IntState): The number of rows in the right singular matrix V.
.DF "4"
.NE
\fInumCols\fR (IntState): The number of columns in the right singular matrix V.
.DF "4"
.NE
\fInumSignals\fR (IntState): The number of unique signals we are trying to locate.
.DF "1"
.NE
\fIresolution\fR (IntState): The number of points in the frequency domain.
.DF "256"
.ET
.EQ
delim $$
.EN
.LD
The MUSIC algorithm is a general-purpose algorithm for estimating the
presence of sinusoids buried in white noise [1-2].
MUSIC provides high-resolution spectral estimates [3-4] which
can be used in source localization in spatial array processing [4-5].
Several derivatives of MUSIC exist such as root-MUSIC [6].
.Id "Dudgeon, D. E."
.Id "Friedlander, B."
.Id "Haykin, S."
.Id "Johnson, D. H."
.Id "Nehorai, A."
.Id "Stoica, P."
.Id "Soderstrom, B."
.Id "Weiss, A. J."
.UH REFERENCES
.ip [1]
S. Haykin, ed., \fIAdvances in Spectrum Analysis and Array Processing\fR,
vol. 2, Prentice-Hall: Englewood Cliffs, NJ, 1991.
.ip [2]
S. Haykin, \fIAdaptive Filter Theory\fR,
Prentice-Hall: Englewood Cliffs, NJ.  1991.  2nd ed.
.ip [3]
P. Stoica and A. Nehorai, ``MUSIC, Maximum Likelihood, and Cramer-Rao Bound:
Further Results and Comparisons,''
\fIIEEE Trans. on Acoustics, Speech, and Signal Processing\fR,
vol. 38, pp. 2140-2150, Dec. 1990.
.ip [4]
D. H. Johnson and D. E. Dudgeon, \fIArray Signal Processing\fR,
Prentice-Hall: Englewood Cliffs, NJ.  1993.
.ip [5]
P. Stoica and B. Soderstrom, ``Statistical Analysis of MUSIC and
Subspace Rotation Estimates of Sinusoidal Frequencies,''
\fIIEEE Trans. on Acoustics, Speech, and Signal Processing\fR,
vol. 39, pp. 1122-1135, Aug. 1991.
.ip [6]
B. Friedlander and A. J. Weiss,
``Direction Finding Using Spatial Smoothing With Interpolated Arrays,''
\fIIEEE Trans. on Aerospace and Electronic Systems\fR,
vol. 28, no. 2, pp. 574-587, April 1992.
.ES
