.EQ
delim off
.EN
.\" documentation file generated from SDFMuLaw.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "MuLaw"
.SD
This star encodes its input into an eight-bit representation
using the non-linear companding according to a mu law definition.
.SE
.DM SDF SDFStar
.SV 1.13 "2/12/96"
.AL "Asawaree Kalavade"
.IH
.NE
\fIinput\fR (float)
.PE
.OH
.NE
\fIoutput\fR (float)
.PE
.SH
.NE
\fIcompress\fR (IntState): NO, FALSE, or 0 turns off compression.
YES, TRUE, or a non-zero integer enables compression.
.DF "YES"
.NE
\fImu\fR (IntState): mu parameter, a positive integer
.DF "255"
.NE
\fIdenom\fR (FloatState): denominator of the mu-law definition
.DF "1.0"
.ET
.EQ
delim $$
.EN
.LD
.Id "Mu law compression"
.Id "compression, Mu law"
The conversion formula is
.EQ
y ~=~ log (1 + mu | x | ) / log( 1 ~+~ mu ) ~.
.EN
so this star always produces non-negative output.
.UH REFERENCES
.IP 1
Simon Haykin, \fICommunication Systems\fR, John Wiley Sons,
3rd ed., 1994, ISBN 0-471-57176-8, page 380.
.ES
