.EQ
delim off
.EN
.\" documentation file generated from SDFRGBToYUV.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "RGBToYUV"
.SD
Read three float matrices that describe a color image in Red-Green-Blue (RGB)
format and output three float matrices that describe an image in YUV format.
No downsampling is performed on the U and V signals.
.SE
.LO "SDF image library"
.DM SDF SDFStar
.SV 1.20 "3/7/96"
.AL "Sun-Inn Shih, Brian L. Evans, and T. J. Klausutis"
.IH
.NE
\fIinput1\fR (FLOAT_MATRIX_ENV)
.NE
\fIinput2\fR (FLOAT_MATRIX_ENV)
.NE
\fIinput3\fR (FLOAT_MATRIX_ENV)
.PE
.OH
.NE
\fIoutput1\fR (FLOAT_MATRIX_ENV)
.NE
\fIoutput2\fR (FLOAT_MATRIX_ENV)
.NE
\fIoutput3\fR (FLOAT_MATRIX_ENV)
.PE
.SH
.NE
\fICCIR_601\fR (IntState): TRUE means that the RGB space will be converted to shifted-and-scaled YUV
color space defined by the CCIR 601 standard, which is used in the MPEG
and H.261 standards; otherwise, the RGB space will be converted according
to the usual YUV definition.
.DF "YES"
.ET
.EQ
delim $$
.EN
.LD
The YUV format, which is a linear mapping of the RGB format, is used
in broadcast television to maintain compability between color and
black-and-white televisions [1].
Y is the luminance (intensity) of the image, and U and V represent the
chrominance (hue and saturation).
The YUV format is based on how the eyes perceive color.
The U axis has yellow at its minimum point and blue at its maximum point,
whereas the V axis has turquoise at its minimum point and red at its
maximum point.
In this implementation, each of the RGB values and each of the YUV values
are integer values in the range from 0 to 255 (inclusive).
.pp
This star supports two YUV formats--- the usual one [1] and
the CCIR 601 standard.
The usual YUV definition shifts the U and V values so that they fall in
the range from 0 to 255 (inclusive).
The CCIR 601 standard scales and then shifts the Y, U, and V values so that
Y falls in the range from 16 to 235 (inclusive) and U and V falls
in the range from 16 to 240 (inclusive).
The CCIR 601 standard was developed so that more of the YUV space maps into
the RGB space.
All RGB values, however, map into both YUV standards, so RGB to YUV conversion
followed by YUV to RGB conversion is nearly lossless.
The CCIR 601 standard is used in the MPEG and H.261 compression standards.
.Id "format conversion, RGB to YUV"
.Id "image format conversion, RGB to YUV"
.Ir "image format, red-green-blue (RGB)"
.Ir "image format, luminance-chrominance (YUV)"
.Id "CCIR 601 standard"
.Id "MPEG"
.Id "H.261"
.Id "Pratt, W."
.UH REFERENCES
.ip [1]
W. Pratt, \fIDigital Image Processing\fR,
Wiley & Sons: New York.  1991.  2nd ed.
.ES
