.EQ
delim off
.EN
.\" documentation file generated from SDFRampFix.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "RampFix"
.SD
Generate a fixed-point ramp signal, starting at "value" (default 0.0)
with step size "step" (default 1.0).
A precision and an initial value can be specified for a parameter by using
the notation ( <initial_value>, <precision> ).
.SE
.LO "SDF main library"
.DM SDF SDFFix
.SV 1.18 "2/12/96"
.AL "A. Khazeni"
.OH
.NE
\fIoutput\fR (fix)
.PE
.SH
.NE
\fIOutputPrecision\fR (PrecisionState): Precision of the output in bits and precision of the accumulation.
When the value of the accumulation extends outside of the precision,
the OverflowHandler will be called.
.DF "2.14"
.NE
\fIstep\fR (FixState): Increment from one sample to the next.
.DF "1.0"
.NE
\fIvalue\fR (FixState): Initial value output by the ramp.
During simulation, this parameter holds the current value output by the ramp.
The precision of this state is the precision of the accumulation.
.DF "0.0"
.ET
.EQ
delim $$
.EN
.LD
The value of the "step" and "value" parameters and their precision 
in bits can currently be specified using two different notations. 
Specifying only a value by itself in the dialog box would create a 
fixed-point number with the default precision, which has a total length
of 24 bits with the number of range bits set as required by the value
of the parameter.
For example, the default value 1.0 creates a fixed-point object with 
precision 2.22, and a value like 0.5 would create one with precision 1.23.
An alternate way of specifying the value and the precision of this parameter
is to use the parenthesis notation which will be interpreted as
(value, precision).
For example, filling the dialog box of this parameter by (2.546, 3.5) would
create a fixed-point object by casting the double-precision floating-point
number 2.546 to a fixed-point precision of 3.5.
.ES
