.EQ
delim off
.EN
.\" documentation file generated from SDFReciprocal.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Reciprocal"
.SD
Output the reciprocal of the input, with an optional magnitude limit.
If the magnitude limit is greater than zero, and the input value is zero,
then the output will equal the magnitude limit.
.SE
.LO "SDF main library"
.DM SDF SDFStar
.SV 1.8 "3/2/95"
.AL "E. A. Lee"
.IH
.NE
\fIinput\fR (float)
.PE
.OH
.NE
\fIoutput\fR (float)
.PE
.SH
.NE
\fImagLimit\fR (FloatState): If non-zero, limits the magnitude of the output.
.DF "0.0"
.ET
.EQ
delim $$
.EN
.LD
This star computes $1/x$, where $x$ is the input.
If the \fImagLimit\fR parameter is not 0.0, then the output is
$+- ~ max ( magLimit, ~ 1/x )$.  In this case, $x$ can be zero
without causing an floating exception.
The sign of the output is determined by the sign of the input.
.ES
