.EQ
delim off
.EN
.\" documentation file generated from SDFRectFix.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "RectFix"
.SD
Generate a fixed-point rectangular pulse of height "height" 
(default 1.0) and width "width" (default 8).
If "period" is greater than zero, then the pulse is repeated with the
given period.
.SE
.LO "SDF main library"
.DM SDF SDFFix
.SV 1.17 "2/12/96"
.AL "A. Khazeni"
.OH
.NE
\fIoutput\fR (fix)
.PE
.SH
.NE
\fIheight\fR (FixState): Height of the rectangular pulse.
.DF "1.0"
.NE
\fIwidth\fR (IntState): Width of the rectangular pulse.
.DF "8"
.NE
\fIperiod\fR (IntState): If greater than zero, the period of the pulse stream.
.DF "0"
.NE
\fIcount\fR (IntState): Internal counting state.
.DF "0"
.NE
\fIOutputPrecision\fR (PrecisionState): Precision of the output in bits.
The value of the "height" parameter is cast to this precision and then output.
If the value cannot be represented by this precision, then
the OverflowHandler will be called.
.DF "2.14"
.ET
.EQ
delim $$
.EN
.LD
The "OutputPrecision" is specified using an l.r format, where
l is the number of bits to the left of the decimal place
(including the sign bit) and r is the number of bits to the
right of the sign bit.
For example, the precision "2.22" would represent a 24-bit fixed-point
number with 1 sign bit, 1 integer bit, and 22 fractional bits.
.ES
