.EQ
delim off
.EN
.\" documentation file generated from SDFSVD_M.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "SVD_M"
.SD
Compute the singular-value decomposition (SVD) of a Toeplitz data matrix A
by decomposing A into A = UWV', where U and V are orthogonal matrices
and V' represents the transpose of V.
W is a diagonal matrix composed of the singular values of A, and
the columns of U and V are the left and right singular vectors of A.
.SE
.LO "SDF dsp library"
.DM SDF SDFStar
.SV 1.17 "10/16/95"
.AL "Mike J. Chen"
.IH
.NE
\fIinput\fR (FLOAT_MATRIX_ENV): Input stream.
.PE
.OH
.NE
\fIsvals\fR (FLOAT_MATRIX_ENV): The singular values of X.
.NE
\fIrsvec\fR (FLOAT_MATRIX_ENV): Right singular vectors of X.
.NE
\fIlsvec\fR (FLOAT_MATRIX_ENV): Left singular vectors of X.
.PE
.SH
.NE
\fIrows\fR (IntState): Number of rows in A.
.DF "2"
.NE
\fIcols\fR (IntState): Number of columns in A.
.DF "2"
.NE
\fIthreshold\fR (FloatState): Threshold for singularities.  Values less than threshold are
		  assumed equal to zero.
.DF "0.00000000000000001"
.NE
\fImax_iterations\fR (IntState): Maximum number of iterations for the SVD routine to converge.
.DF "30"
.NE
\fIgenerate_left\fR (IntState): Specify whether to generate U, the matrix of left singular vectors.
.DF "YES"
.NE
\fIgenerate_right\fR (IntState): Specify whether to generate V, the matrix of right singular vectors.
.DF "YES"
.ET
.EQ
delim $$
.EN
.LD
.pp
The singular-value decomposition is performed on a data matrix, which
is usually provided by the
.c
Data_M
star.
The dimensions of the input data matrix is given by the
\fIrows\fR and \fIcols\fR parameters to the star.
The outputs are the three matrices: the vector of singular values,
the matrix of right singular vectors, and the matrix of left singular vectors.
The terminals for each output is labeled on the star's icon as
S, R, and L respectively.
.pp
The \fIthreshold\fR parameter gives the smallest floating point number
that the algorithm will represent.
Anything smaller is considered zero.
The \fImax_iterations\fR parameter allows the user to control the number of
iterations that the SVD algorithm will be allowed to run before stopping.
Normally, the SVD algorithm should converge before this value but this
parameter is provided to prevent non-convergent matrices from causing
the star from running too long.
.pp
The user can also speed up the execution of the star by optionally
specifying that the matrices of the left and/or right singular vectors 
should not be generated.
Not generating those matrices will speed up the execution.
The vector of singular values is always generated.
.Id "Haykin, S."
.UH "References"
.ip [1]
S. Haykin, \fIModern Filters\fR, pp. 333-335,
Macmillan Publishing Company, New York, 1989.
.SA
Data_M
.ES
