.EQ
delim off
.EN
.\" documentation file generated from SDFSinc.pl by ptlang
.\" Copyright (c) 1990-1995 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Sinc"
.SD
This star computes the sinc of its input given in radians.
The sinc function is defined as sin(x)/x, with value 1.0 when x = 0.
.SE
.LO "SDF dsp library"
.DM SDF SDFStar
.SV 1.7 "3/2/95"
.AL "Brian L. Evans"
.IH
.NE
\fIinput\fR (float): The input x to the sinc function.
.PE
.OH
.NE
\fIoutput\fR (float): The output of the sinc function.
.PE
.EQ
delim $$
.EN
.LD
The discrete-time Fourier transform (DTFT) of a sampled sinc function is 
an ideal lowpass filter [1-2].
Modulating a sampled sinc function by a cosine function gives an
ideal bandpass signal.
This star defines the sinc function \fIwithout\fR using $pi$,
as is the convention in [2-3].
.ID "Bracewell, R. N."
.ID "Oppenheim, A. V."
.ID "Schafer, R. W."
.ID "Willsky, A."
.UH REFERENCES
.ip [1]
A. V. Oppenheim and R. W. Schafer, \fIDiscrete-Time Signal Processing\fR,
Prentice-Hall: Englewood Cliffs, NJ, 1989.
.ip [2]
A. V. Oppenheim and A. Willsky, \fISignals and Systems\fR,
Prentice-Hall: Englewood Cliffs, NJ, 1983.
.ip [3]
R. N. Bracewell, \fIThe Fourier Transform and Its Applications\fR,
McGraw-Hill: New York, 1986.
.SA
Dirichlet and
RaisedCos.
.ES
