.EQ
delim off
.EN
.\" documentation file generated from SDFTableInt_M.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "TableInt_M"
.SD
This star implements a lookup table indexed by an integer-valued input,
and the output will be a matrix.
The input must lie between 0 and N-1, inclusive, where N is the number
of matrices in the table.
The "intTable" parameter specifies the entries of matrices in the table.
Note that the entries of each matrix in the table should be given in row 
major ordering.
The first matrix in the table is indexed by a zero-valued input.
An error occurs if the input value is out of bounds.
.SE
.LO "SDF matrix library"
.DM SDF SDFStar
.SV 1.3 "11/22/95"
.AL "Bilung Lee"
.IH
.NE
\fIinput\fR (int): The index for table lookup
.PE
.OH
.NE
\fIoutput\fR (INT_MATRIX_ENV): The matrix in the table corresponding to the index.
.PE
.SH
.NE
\fInumRows\fR (IntState): The number of rows for each matrix in the table.
.DF "1"
.NE
\fInumCols\fR (IntState): The number of columns for each matrix in the table.
.DF "2"
.NE
\fIintTable\fR (IntArrayState): The table containing matrices. Each matrix with dimension numRows*numCols is given in row major ordering.
.DF "1 1   1 -1   -1 1   -1 -1"
.ET
.EQ
delim $$
.EN
.LD
.Id "table lookup"
.ES
