.EQ
delim off
.EN
.\" documentation file generated from SDFToeplitzCx_M.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "ToeplitzCx_M"
.SD
Put a sequence of complex-valued samples into a rectangular Toeplitz matrix.
.SE
.LO "SDF matrix library"
.DM SDF SDFStar
.SV 1.12 "11/22/95"
.AL "Mike J. Chen"
.IH
.NE
\fIinput\fR (complex): Input stream.
.PE
.OH
.NE
\fIoutput\fR (COMPLEX_MATRIX_ENV): Data matrix X.
.PE
.SH
.NE
\fInumRows\fR (IntState): Number of rows in X.
.DF "2"
.NE
\fInumCols\fR (IntState): Number of columns in X.
.DF "2"
.ET
.EQ
delim $$
.EN
.LD
.Ir "Toeplitz matrix"
Generate a complex data matrix X, with dimensions
\fInumRows\fR x \fInumCols\fR, from a stream of
\fInumRows\fR + \fInumCols\fR - 1 input particles.
The data matrix is a Toeplitz matrix such that the first row is
[ x(M-1) x(M-2) ... x(0) ], the second row is [ x(M) x(M-1) x(M-2) ... x(1) ],
and so forth until the last row, which is [ x(N-1) x(N-2) ... x(N-M) ], where
\fInumRows\fR = $N-M+1$ and \fInumCols\fR = $M$.
.Ir "singular-value decomposition"
This is the form of the matrix that is required by the singular-value
decomposition star
.c SVD_M ,
among others.
.ES
