.EQ
delim off
.EN
.\" documentation file generated from SDFWirelessChannel.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "WirelessChannel"
.SD
Wireless Channel - Equivalent Complex Baseband Channel.
This model takes multipath propagation into account.
.SE
.LO "SDF user contribution library"
.DM SDF SDFStar
.SV 1.4 "6/1/95"
.AL "John S. Davis, II"
.AC "Brian L. Evans"
.IH
.NE
\fIDataIn\fR (complex)
.PE
.OH
.NE
\fIDataOut\fR (complex)
.PE
.SH
.NE
\fICarrierFrequency\fR (FloatState): Carrier Frequency In MHz
.DF "1000.0"
.NE
\fISymbolRate\fR (FloatState): Symbol (Sample) Rate In MHz
.DF "1500.0"
.NE
\fIRMSDelaySpread\fR (FloatState): Root Mean Square Delay Spread In Nanoseconds
.DF "40.0"
.NE
\fIDopplerSpread\fR (FloatState): Frequency Spreading In Hertz
.DF "4.0"
.NE
\fIPathLossRate\fR (FloatState): Large Scale Signal Variation
.DF "2.18"
.NE
\fIReferencePowerLoss\fR (FloatState): The Power Loss At 1 Meter From Transmitter in dB.
		       Note That The Default Is Based Upon Experiments 
		       In Room 550, Cory Hall (UC Berkeley) With Biconical 
		       Antenna And Carrier Frequency At 2.4 GHz.
.DF "55.0"
.NE
\fIChannelType\fR (StringState): Indoor(i;I), OutdoorMobile(o;O)
.DF "Indoor"
.NE
\fIMeanSeparationDistance\fR (FloatState): Mean Separation Distance Between Antennas In Meters
.DF "10.0"
.ET
.EQ
delim $$
.EN
.LD
The Wireless Channel Star assumes complex baseband input.
The two "most" important parameters are \fIRMSDelaySpread\fR and
the \fISymbolRate\fR (sample rate).
Symbol \fIPeriods\fR (1/\fISymbolRate\fR) which are not significantly
less than the \fIRMSDelaySpread\fR will result in an environment
that is essentially not a multipath channel.

We make the following assumptions.
First, that the signal velocity is equal to the speed of light.
Second, the signal propagation distance varies about the
\fIMeanSeparationDistance\fR random phase variation.
Note that this Star does not consider shadowing effects.

This star is designed primarily for modeling indoor wireless 
channels but can be adapted to outdoor mobile communication
channels by changing the \fIChannelType\fR parameter from the 
default of "Indoor" to "Outdoor."
Given this change, the \fIDopplerSpread\fR (which is otherwise unused)
will be incorporated via the coherence bandwidth to model the degree
of time variation within the channel.
One problem with this scheme is that high symbol rates will require
very long simulations (millions of iterations with each iteration
representing perhaps millionths of a second) in order to see the
effects of the time variation.
.ES
