static const char file_id[] = "SDFAutocor.pl";
// .cc file generated from SDFAutocor.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFAutocor.h"

const char *star_nm_SDFAutocor = "SDFAutocor";

const char* SDFAutocor :: className() const {return star_nm_SDFAutocor;}

ISA_FUNC(SDFAutocor,SDFStar);

Block* SDFAutocor :: makeNew() const { LOG_NEW; return new SDFAutocor;}

SDFAutocor::SDFAutocor ()
{
	setDescriptor("Estimate an autocorrelation function by averaging input samples.\nBoth biased and unbiased estimates are supported.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(noInputsToAvg.setState("noInputsToAvg",this,"256","Number of input samples to average."));
	addState(noLags.setState("noLags",this,"64","Number of autocorrelation lags to output."));
	addState(unbiased.setState("unbiased",this,"YES","If YES, the estimate will be unbiased."));


}

void SDFAutocor::setup() {
# line 74 "SDFAutocor.pl"
if ( int(noInputsToAvg) <= int(noLags)) {
		Error::abortRun(*this,
			": noLags is larger than noInputsToAvg.");
		return;
	    }
	    input.setSDFParams(int(noInputsToAvg), int(noInputsToAvg)-1);
	    output.setSDFParams(2*int(noLags), 2*int(noLags));
}

void SDFAutocor::go() {
# line 83 "SDFAutocor.pl"
for(int i = int(noLags); i>=0; i--) {
		double sum = 0.0;
		for(int j = 0; j < (int(noInputsToAvg)-i); j++)
		   sum += double(input%j) * double(input%(j+i));
		if (unbiased)
		    output%(i+int(noLags)) << sum/(int(noInputsToAvg) -i);
		else
		    output%(i+int(noLags)) << sum/int(noInputsToAvg);
	    }
	    // Now output the second half, which by symmetry is just
	    // identical to what was just output.
	    for(i = int(noLags)-1; i >= 0; i--)
		output%i = output%(2*int(noLags) - i);
}

// prototype instance for known block list
static SDFAutocor proto;
static RegisterBlock registerBlock(proto,"Autocor");
