static const char file_id[] = "SDFBiquad.pl";
// .cc file generated from SDFBiquad.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFBiquad.h"

const char *star_nm_SDFBiquad = "SDFBiquad";

const char* SDFBiquad :: className() const {return star_nm_SDFBiquad;}

ISA_FUNC(SDFBiquad,SDFStar);

Block* SDFBiquad :: makeNew() const { LOG_NEW; return new SDFBiquad;}

SDFBiquad::SDFBiquad ()
{
	setDescriptor("A two-pole, two-zero digital IIR filter (a biquad).\nThe default is a Butterworth filter with a cutoff 0.1 times sampling frequency.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(d1.setState("d1",this,"-1.1430","d1"));
	addState(d2.setState("d2",this,"0.41280","d2"));
	addState(n0.setState("n0",this,"0.067455","n0"));
	addState(n1.setState("n1",this,"0.135","n1"));
	addState(n2.setState("n2",this,"0.067455","n2"));
	addState(state1.setState("state1",this,"0.0","internal state.",
# line 80 "SDFBiquad.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(state2.setState("state2",this,"0.0","internal state.",
# line 87 "SDFBiquad.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void SDFBiquad::go() {
# line 90 "SDFBiquad.pl"
double t = double(input%0) - double(d1) * double (state1) -
			double(d2) * double(state2);
		double o = t * double(n0) + double(state1) * double(n1) +
			double(state2) * double(n2);
		output%0 << o;
		state2 = double(state1);
		state1 = t;
}

// prototype instance for known block list
static SDFBiquad proto;
static RegisterBlock registerBlock(proto,"Biquad");
