static const char file_id[] = "SDFConvolCx.pl";
// .cc file generated from SDFConvolCx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFConvolCx.h"

const char *star_nm_SDFConvolCx = "SDFConvolCx";

const char* SDFConvolCx :: className() const {return star_nm_SDFConvolCx;}

ISA_FUNC(SDFConvolCx,SDFStar);

Block* SDFConvolCx :: makeNew() const { LOG_NEW; return new SDFConvolCx;}

SDFConvolCx::SDFConvolCx ()
{
	setDescriptor("Convolve two causal finite sequences.\nSet truncationDepth larger than the number of output samples of interest.");
	addPort(inA.setPort("inA",this,COMPLEX));
	addPort(inB.setPort("inB",this,COMPLEX));
	addPort(out.setPort("out",this,COMPLEX));
	addState(truncationDepth.setState("truncationDepth",this,"256","Maximum number of terms in convolution sum."));
	addState(iterationCount.setState("iterationCount",this,"0","Count current iteration.",
# line 48 "SDFConvolCx.pl"
A_NONCONSTANT | A_NONSETTABLE));


}

void SDFConvolCx::setup() {
# line 51 "SDFConvolCx.pl"
inA.setSDFParams(1, int(truncationDepth));
		inB.setSDFParams(1, int(truncationDepth));
}

void SDFConvolCx::go() {
# line 55 "SDFConvolCx.pl"
Complex sum =  Complex(0.0);
	    int c = int(iterationCount);
	    for (int k = 0; k < int(truncationDepth); k++) {
		int index = c-k;
		if (index < 0) index += int(truncationDepth);
		sum += Complex(inA%(index)) * Complex(conj(inB%(k)));
	    }
	    out%(0) << sum;
	    if (c >= int(truncationDepth) - 1) iterationCount = 0;
	    else iterationCount = c+1;
}

// prototype instance for known block list
static SDFConvolCx proto;
static RegisterBlock registerBlock(proto,"ConvolCx");
