static const char file_id[] = "SDFConvolve.pl";
// .cc file generated from SDFConvolve.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFConvolve.h"

const char *star_nm_SDFConvolve = "SDFConvolve";

const char* SDFConvolve :: className() const {return star_nm_SDFConvolve;}

ISA_FUNC(SDFConvolve,SDFStar);

Block* SDFConvolve :: makeNew() const { LOG_NEW; return new SDFConvolve;}

SDFConvolve::SDFConvolve ()
{
	setDescriptor("Convolve two causal finite sequences.\nSet truncationDepth larger than the number of output samples of interest.");
	addPort(inA.setPort("inA",this,FLOAT));
	addPort(inB.setPort("inB",this,FLOAT));
	addPort(out.setPort("out",this,FLOAT));
	addState(truncationDepth.setState("truncationDepth",this,"256","Maximum number of terms in convolution sum."));
	addState(iterationCount.setState("iterationCount",this,"0","Count current iteration.",
# line 48 "SDFConvolve.pl"
A_NONCONSTANT | A_NONSETTABLE));


}

void SDFConvolve::setup() {
# line 51 "SDFConvolve.pl"
inA.setSDFParams(1, int(truncationDepth));
		inB.setSDFParams(1, int(truncationDepth));
}

void SDFConvolve::go() {
# line 55 "SDFConvolve.pl"
double sum = 0;
	    int c = int(iterationCount);
	    for (int k = 0; k < int(truncationDepth); k++) {
		int index = c-k;
		if (index < 0) index += int(truncationDepth);
		sum += double(inA%(index))*double(inB%(k));
	    }
	    out%(0) << sum;
	    if (c >= int(truncationDepth) - 1) iterationCount = 0;
	    else iterationCount = c+1;
}

// prototype instance for known block list
static SDFConvolve proto;
static RegisterBlock registerBlock(proto,"Convolve");
