static const char file_id[] = "SDFDTFT.pl";
// .cc file generated from SDFDTFT.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFDTFT.h"
#include "ComplexSubset.h"

const char *star_nm_SDFDTFT = "SDFDTFT";

const char* SDFDTFT :: className() const {return star_nm_SDFDTFT;}

ISA_FUNC(SDFDTFT,SDFStar);

Block* SDFDTFT :: makeNew() const { LOG_NEW; return new SDFDTFT;}

SDFDTFT::SDFDTFT ()
{
	setDescriptor("Compute the discrete-time Fourier transform (DTFT)\nat frequency points specified on the \"omega\" input.");
	addPort(signal.setPort("signal",this,COMPLEX));
	addPort(omega.setPort("omega",this,FLOAT));
	addPort(dtft.setPort("dtft",this,COMPLEX));
	addState(length.setState("length",this,"8","The length of the input signal."));
	addState(numberOfSamples.setState("numberOfSamples",this,"128","The number of samples of the transform to output."));
	addState(timeBetweenSamples.setState("timeBetweenSamples",this,"1.0","The time between input samples (T)."));


}

void SDFDTFT::setup() {
# line 82 "SDFDTFT.pl"
signal.setSDFParams (int(length), int(length) - 1);
	    dtft.setSDFParams
		(int(numberOfSamples), int(numberOfSamples) - 1);
	    omega.setSDFParams
		(int(numberOfSamples), int(numberOfSamples) - 1);
}

void SDFDTFT::go() {
# line 89 "SDFDTFT.pl"
for (int n = int(numberOfSamples)-1; n>=0; n--) {
		Complex sum = Complex(0.0, 0.0);
		for (int i = 0;i < int(length); i++) {
		    sum += Complex(signal%(int(length)-i-1))
			* Complex(
			    cos(double(omega%n)*i*double(timeBetweenSamples)),
			    -sin(double(omega%n)*i*double(timeBetweenSamples)));
		}

		dtft%n << sum;
	    }
}

// prototype instance for known block list
static SDFDTFT proto;
static RegisterBlock registerBlock(proto,"DTFT");
