static const char file_id[] = "SDFDTMFPostTest.pl";
// .cc file generated from SDFDTMFPostTest.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFDTMFPostTest.h"

const char *star_nm_SDFDTMFPostTest = "SDFDTMFPostTest";

const char* SDFDTMFPostTest :: className() const {return star_nm_SDFDTMFPostTest;}

ISA_FUNC(SDFDTMFPostTest,SDFStar);

Block* SDFDTMFPostTest :: makeNew() const { LOG_NEW; return new SDFDTMFPostTest;}

SDFDTMFPostTest::SDFDTMFPostTest ()
{
	setDescriptor("Returns whether or not a valid dual-tone modulated-frequency has\nbeen correctly detected based on the last three detection results.");
	addPort(input.setPort("input",this,INT));
	addPort(valid.setPort("valid",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(initialLastInput.setState("initialLastInput",this,"-1","The value to assign to last and secondToLast internal states, which hold the\nprevious two valid inputs.  For the purposes of DTMF detection, it is\nset to an integer that does not represent a DTMF digit."));
	addState(last.setState("last",this,"-1","internal state to store the last valid integer",
# line 63 "SDFDTMFPostTest.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(secondToLast.setState("secondToLast",this,"-1","internal state to store the second-to-last valid integer",
# line 72 "SDFDTMFPostTest.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void SDFDTMFPostTest::setup() {
# line 75 "SDFDTMFPostTest.pl"
last = int(initialLastInput);
		secondToLast = int(initialLastInput);
}

void SDFDTMFPostTest::go() {
# line 79 "SDFDTMFPostTest.pl"
// If the current input is valid, then compare it
		// with the last and second-to-last valid inputs;
		// otherwise, return FALSE
		int retval = FALSE;
		int inputValue = int(initialLastInput);
		int lastValue = int(last);
		if ( int(valid%0) ) {
		  inputValue = int(input%0);
		  retval = ( inputValue == lastValue &&
		             lastValue != int(secondToLast) );
		}
		output%0 << retval;

		// Update the last and second-to-last input storage
		secondToLast = lastValue;
		last = inputValue;
}

// prototype instance for known block list
static SDFDTMFPostTest proto;
static RegisterBlock registerBlock(proto,"DTMFPostTest");
