#ifndef _SDFGAL_h
#define _SDFGAL_h 1
// header file generated from SDFGAL.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */
#include "SDFStar.h"
#include "IntState.h"
#include "FloatState.h"

class SDFGAL : public SDFStar
{
public:
	SDFGAL();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ ~SDFGAL();
	InSDFPort input;
	OutSDFPort residual;

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	IntState order;
	FloatState timeConstant;
# line 47 "SDFGAL.pl"
double* f;	// forward prediction errors
	double* b;	// backward predition errors
	double* k;	// reflection coefficients
	double* sigma;	// error power estimates
	double alpha;	// adaptation gain
	double beta;	// error filter parameter
	int previousOrder;

};
#endif
