static const char file_id[] = "SDFGGAL.pl";
// .cc file generated from SDFGGAL.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFGGAL.h"

const char *star_nm_SDFGGAL = "SDFGGAL";

const char* SDFGGAL :: className() const {return star_nm_SDFGGAL;}

ISA_FUNC(SDFGGAL,SDFGAL);

Block* SDFGGAL :: makeNew() const { LOG_NEW; return new SDFGGAL;}

SDFGGAL::SDFGGAL ()
{
	setDescriptor("Ganged Gradient Adaptive Lattice filters.");
	addPort(synthIn.setPort("synthIn",this,FLOAT));
	addPort(synthOut.setPort("synthOut",this,FLOAT));

# line 36 "SDFGGAL.pl"
b = NULL;
}

SDFGGAL::~SDFGGAL() {
# line 41 "SDFGGAL.pl"
LOG_DEL; delete [] b;
}

void SDFGGAL::setup() {
# line 46 "SDFGGAL.pl"
// Reallocate array only if size has changed.
	if (previousOrder != order)
	{
	    LOG_DEL; delete [] b;
	    LOG_NEW; b = new double[order+1];
	}

	// Zero out old values.
	for(int m = 0; m <= order; m++)
	{
	    b[m] = 0.0;
	}

	SDFGAL::setup();
}

void SDFGGAL::go() {
# line 64 "SDFGGAL.pl"
double f;
	f = synthIn%0;

	for(int m = order-1; m >= 0; m--)
	{
	    f += k[m+1]*b[m];
	    b[m+1] = b[m] - k[m+1]*f;
	}
	b[0] = f;

	synthOut%0 << f;

	// update reflection coefficients
	SDFGAL::go();
}

// prototype instance for known block list
static SDFGGAL proto;
static RegisterBlock registerBlock(proto,"GGAL");
