static const char file_id[] = "SDFGoertzel.pl";
// .cc file generated from SDFGoertzel.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFGoertzel.h"

const char *star_nm_SDFGoertzel = "SDFGoertzel";

const char* SDFGoertzel :: className() const {return star_nm_SDFGoertzel;}

ISA_FUNC(SDFGoertzel,SDFGoertzelBase);

Block* SDFGoertzel :: makeNew() const { LOG_NEW; return new SDFGoertzel;}

SDFGoertzel::SDFGoertzel ()
{
	setDescriptor("Second-order recursive computation of the kth coefficient of an\nN-point DFT using Goertzel's algorithm.");
	addPort(output.setPort("output",this,COMPLEX));
	addState(negWnReal.setState("negWnReal",this,"0.0","internal state for the storage of the negative of the real part of the\ntwiddle factor, which is a function of k and N",
# line 58 "SDFGoertzel.pl"
A_NONCONSTANT|A_NONSETTABLE));
	addState(negWnImag.setState("negWnImag",this,"0.0","internal state for the storage of the imaginary part of the twiddle factor,\nwhich is a function of k and N",
# line 68 "SDFGoertzel.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void SDFGoertzel::setup() {
# line 71 "SDFGoertzel.pl"
// check parameter values and compute theta
		SDFGoertzelBase::setup();

		negWnReal = -cos(theta);
		negWnImag = -sin(theta);
}

void SDFGoertzel::go() {
# line 78 "SDFGoertzel.pl"
// Discard all but the last sample
		SDFGoertzelBase::go();

		// Final value is function of the two real IIR state values
		double s1 = state1;
		double s2 = state2;
		Complex o(s1 + s2 * double(negWnReal), s2 * double(negWnImag));
		output%0 << o;
}

// prototype instance for known block list
static SDFGoertzel proto;
static RegisterBlock registerBlock(proto,"Goertzel");
