static const char file_id[] = "SDFGoertzelPower.pl";
// .cc file generated from SDFGoertzelPower.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFGoertzelPower.h"

const char *star_nm_SDFGoertzelPower = "SDFGoertzelPower";

const char* SDFGoertzelPower :: className() const {return star_nm_SDFGoertzelPower;}

ISA_FUNC(SDFGoertzelPower,SDFGoertzelBase);

Block* SDFGoertzelPower :: makeNew() const { LOG_NEW; return new SDFGoertzelPower;}

SDFGoertzelPower::SDFGoertzelPower ()
{
	setDescriptor("Second-order recursive computation of the power of the kth coefficient of\nan N-point DFT using Goertzel's algorithm.\nThis form is used in touchtone decoding.");
	addPort(output.setPort("output",this,FLOAT));


}

void SDFGoertzelPower::go() {
# line 55 "SDFGoertzelPower.pl"
// Run the Goertzel second-order IIR filter
		SDFGoertzelBase::go();

		// Compute the power of the kth DFT coefficient.
		// The output of the Goertzel filter is
		//   state1 - Wn*state2 =
		//       state1 - [state2*cos(theta) - j*state2*sin(theta)]
		// where Wn is the twiddle factor Wn = exp(-j theta), such
		// that theta = 2 pi k / N.
		// Power is complex number times its conjugate, z z*:
		//   z = state1 - [state2*cos(theta) - j*state2*sin(theta)]
		//   z = [state1 - state2*cos(theta)] - j [state2*sin(theta)]
		//   z z* = state1*state1 - 2*state1*state2*cos(theta) +
		//     state2*state2*cos^2(theta) + state2*state2*sin^2(theta)
		//   z z* = state1*state1 - state1*state2*2*cos(theta) +
		//          state2*state2
		// where 2*cos(theta) = d1, by definition in SDFGoertzelBase.
		double acc = double(state1)*double(state1) -
			     double(state1)*double(state2)*double(d1) +
		             double(state2)*double(state2);
		output%0 << acc;
}

// prototype instance for known block list
static SDFGoertzelPower proto;
static RegisterBlock registerBlock(proto,"GoertzelPower");
