static const char file_id[] = "SDFHilbert.pl";
// .cc file generated from SDFHilbert.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFHilbert.h"
#include <math.h>

const char *star_nm_SDFHilbert = "SDFHilbert";

const char* SDFHilbert :: className() const {return star_nm_SDFHilbert;}

ISA_FUNC(SDFHilbert,SDFFIR);

Block* SDFHilbert :: makeNew() const { LOG_NEW; return new SDFHilbert;}

SDFHilbert::SDFHilbert ()
{
	setDescriptor("Output the (approximate) Hilbert transform of the input signal.\nThis star approximates the Hilbert transform by using an FIR filter.");
	addState(N.setState("N",this,"64","Number of taps"));

# line 53 "SDFHilbert.pl"
// taps are no longer constant or settable
		taps.clearAttributes(A_CONSTANT|A_SETTABLE);
}

void SDFHilbert::setup() {
# line 57 "SDFHilbert.pl"
int len = int(N);
		int len2 = len / 2;
		int i, n;
		double k = 2.0 / M_PI;

		taps.resize(len);
		for (i = 0, n = -len2; i < len; i++, n++) {
			if ((n & 1) != 0)
				taps[i] = k / n;
			else
				taps[i] = 0.0;
		}
		SDFFIR :: setup();
}

// prototype instance for known block list
static SDFHilbert proto;
static RegisterBlock registerBlock(proto,"Hilbert");
