#ifndef _SDFKalman_M_h
#define _SDFKalman_M_h 1
// header file generated from SDFKalman_M.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */
#include "SDFStar.h"
#include <math.h>
#include "Matrix.h"
#include "IntState.h"
#include "FloatArrayState.h"

class SDFKalman_M : public SDFStar
{
public:
	SDFKalman_M();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ ~SDFKalman_M();
	InSDFPort input;
	InSDFPort StateTransitionMatrixAtTimeN;
	InSDFPort MeasurementMatrixAtTimeN;
	InSDFPort ProcessNoiseCorrMatrixAtTimeN;
	InSDFPort MeasurementNoiseCorrMatrixAtTimeN;
	OutSDFPort output;

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	IntState stateDimension;
	IntState inputDimension;
	FloatArrayState InitialState;
	FloatArrayState InitialCorrMatrix;
	FloatArrayState InitialStateTransitionMatrix;
	FloatArrayState InitialProcessNoiseCorrMatrix;
# line 93 "SDFKalman_M.pl"
int stateDim;
    int inputDim;

    // intermediate variables, part of the state
    FloatMatrix *stateVector;                        // x(n|y(n));
    FloatMatrix *gainMatrix;                         // G(n)
    FloatMatrix *innovationsVector;                  // alpha(n)
    FloatMatrix *innovationsCorrMatrix;              // sigma(n)
    FloatMatrix *predStateVector;                    // x(n+1|y(n));
    FloatMatrix *predStateErrCorrMatrix;             // K(n+1,n)
    FloatMatrix *presentErrCorrMatrix;               // K(n)

};
#endif
