static const char file_id[] = "SDFLMSLeak.pl";
// .cc file generated from SDFLMSLeak.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFLMSLeak.h"

const char *star_nm_SDFLMSLeak = "SDFLMSLeak";

const char* SDFLMSLeak :: className() const {return star_nm_SDFLMSLeak;}

ISA_FUNC(SDFLMSLeak,SDFLMS);

Block* SDFLMSLeak :: makeNew() const { LOG_NEW; return new SDFLMSLeak;}

SDFLMSLeak::SDFLMSLeak ()
{
	setDescriptor("An LMS adaptive filter in which the step size is input\n(to the \"step\" input) every iteration. In addition,\nthe \"mu\" parameter specifies a leakage factor in the\nupdates of the filter coefficients.");
	addPort(step.setPort("step",this,FLOAT));
	addState(mu.setState("mu",this,"0.0","Leak factor for coefficient update."));

# line 48 "SDFLMSLeak.pl"
stepSize.clearAttributes(A_SETTABLE);
}

void SDFLMSLeak::go() {
# line 51 "SDFLMSLeak.pl"
// Read a new step-size for the coefficient update formula.
		stepSize = double(step%0);

// Update the taps.
		int index = int(errorDelay) * int(decimation) +
				int(decimationPhase);

		for(int i = 0; i < taps.size(); i++) {
			taps[i] *= 1.0 - double(stepSize) * double(mu);
			taps[i] += double(error%0) * double(signalIn%index) *
					double(stepSize);
			index++;
		}

// Run the filter.
		SDFFIR :: go();
}

// prototype instance for known block list
static SDFLMSLeak proto;
static RegisterBlock registerBlock(proto,"LMSLeak");
