static const char file_id[] = "SDFLMSPlot.pl";
// .cc file generated from SDFLMSPlot.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFLMSPlot.h"

const char *star_nm_SDFLMSPlot = "SDFLMSPlot";

const char* SDFLMSPlot :: className() const {return star_nm_SDFLMSPlot;}

ISA_FUNC(SDFLMSPlot,SDFLMS);

Block* SDFLMSPlot :: makeNew() const { LOG_NEW; return new SDFLMSPlot;}

SDFLMSPlot::SDFLMSPlot ()
{
	setDescriptor("This star is exactly like the LMS star, except that, in addition\nto the functions of LMS, it makes a plot of the tap coefficients.\nIt can produce two types of plots: a plot of the final tap values\nor a plot that traces the time evolution of each tap value.\nThe time evolution is obtained if the value of the parameter \"trace\" is \"YES\".");
	addState(graphOptions.setState("graphOptions",this,"-0 taps","options for graph"));
	addState(graphTitle.setState("graphTitle",this,"LMS filter tap values","title for graph"));
	addState(trace.setState("trace",this,"NO","if YES, plot a trace of tap values as they adapt"));

# line 58 "SDFLMSPlot.pl"
// remove saveTapsFile as a settable param
		saveTapsFile.clearAttributes(A_SETTABLE);
}

void SDFLMSPlot::wrapup() {
# line 84 "SDFLMSPlot.pl"
// don't call SDFLMS::wrapup: no final file to write.
		if (!int(trace)) {
			// plot final taps
			for (int i = 0; i < taps.size(); i++)
				graph.addPoint (taps[i]);
		}
		// end the plot
		graph.terminate();
}

void SDFLMSPlot::setup() {
# line 62 "SDFLMSPlot.pl"
SDFLMS::setup();
		int nPlots = 1;
		if (int(trace)) {
			nPlots = taps.size();
			index = 0;
			if (nPlots > 64) {
				Error::abortRun(*this,
				     ": maximum of 64 taps for trace plot");
				return;
			}
		}
		graph.initialize(this,nPlots, graphOptions, graphTitle, "");
}

void SDFLMSPlot::go() {
# line 76 "SDFLMSPlot.pl"
SDFLMS::go();
		if (int(trace)) {
			for (int i = 0; i < taps.size(); i++)
				graph.addPoint(i+1, index, taps[i]);
			index++;
		}
}

// prototype instance for known block list
static SDFLMSPlot proto;
static RegisterBlock registerBlock(proto,"LMSPlot");
