static const char file_id[] = "SDFLattice.pl";
// .cc file generated from SDFLattice.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFLattice.h"

const char *star_nm_SDFLattice = "SDFLattice";

const char* SDFLattice :: className() const {return star_nm_SDFLattice;}

ISA_FUNC(SDFLattice,SDFStar);

Block* SDFLattice :: makeNew() const { LOG_NEW; return new SDFLattice;}

SDFLattice::SDFLattice ()
{
	setDescriptor("An FIR Lattice filter.\nThe default reflection coefficients form the optimal predictor for\na particular 4th-order AR random process.\nTo read other reflection coefficients from a file, replace the default\ncoefficients with \"< fileName\", preferably specifying a complete path.");
	addPort(signalIn.setPort("signalIn",this,FLOAT));
	addPort(signalOut.setPort("signalOut",this,FLOAT));
	addState(reflectionCoefs.setState("reflectionCoefs",this,"0.804534 -0.820577 0.521934 -0.205","Reflection or PARCOR coefficients."));

# line 86 "SDFLattice.pl"
b = 0; f = 0; M = -1;
}

SDFLattice::~SDFLattice() {
# line 89 "SDFLattice.pl"
LOG_DEL; delete [] b;
		LOG_DEL; delete [] f;
}

void SDFLattice::setup() {
# line 93 "SDFLattice.pl"
// reallocate arrays only if size has changed,
		// or this is the first run.
		if (M != reflectionCoefs.size()) {
			M = reflectionCoefs.size();
			LOG_DEL; delete [] b;
			LOG_NEW; b = new double[M];
			LOG_DEL; delete [] f;
			LOG_NEW; f = new double[M+1];
		}
		for (int i=0; i < M; i++)  b[i]=0.0 ;
}

void SDFLattice::go() {
# line 105 "SDFLattice.pl"
double k;
		
		// Forward prediction error
		f[0] = double (signalIn%0);   // f(0)=x(n)
		for (int i=1; i <= M; i++) {
			k = - reflectionCoefs[i-1];
			f[i] = k * b[i-1] + f[i-1];
		}
		signalOut%0 << f[M];

		// Backward:  Compute the w's for the next round
		for (i = M-1; i >0 ; i--) {
			k = - reflectionCoefs[i-1];
			b[i] = k * f[i-1] + b[i-1];	
		}
		b[0] = double (signalIn%0);   // b[0]=x[n]
}

// prototype instance for known block list
static SDFLattice proto;
static RegisterBlock registerBlock(proto,"Lattice");
