#ifndef _SDFMUSIC_M_h
#define _SDFMUSIC_M_h 1
// header file generated from SDFMUSIC_M.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

/*
Copyright (c) 1993-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */
#include "SDFStar.h"
#include <math.h>
#include "Matrix.h"
#include "IntState.h"

class SDFMUSIC_M : public SDFStar
{
public:
	SDFMUSIC_M();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ ~SDFMUSIC_M();
	InSDFPort rsvec;
	OutSDFPort output;

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	IntState numRows;
	IntState numCols;
	IntState numSignals;
	IntState resolution;
# line 97 "SDFMUSIC_M.pl"
ComplexMatrix *e;  // e(w) is the comple frequency search vector
    FloatMatrix   *Vn; // matrix of the right singular vectors of the noise
    FloatMatrix   *VnVnt;  // Matrix that is the product of Vn * transpose(Vn)
    int numNoise;    // Number of right singular vectors of the noise subspace
    int nrows;       // Number of rows in X
    int ncols;       // Number of columns in X
    ComplexMatrix *F;  // F(w) = eh(w)*VnVnt*e(w)
    double result;   // The final calculated value of the amplitude of S(w)

};
#endif
