static const char file_id[] = "SDFMuLaw.pl";
// .cc file generated from SDFMuLaw.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMuLaw.h"
#include <math.h>

const char *star_nm_SDFMuLaw = "SDFMuLaw";

const char* SDFMuLaw :: className() const {return star_nm_SDFMuLaw;}

ISA_FUNC(SDFMuLaw,SDFStar);

Block* SDFMuLaw :: makeNew() const { LOG_NEW; return new SDFMuLaw;}

SDFMuLaw::SDFMuLaw ()
{
	setDescriptor("This star encodes its input into an eight-bit representation\nusing the non-linear companding according to a mu law definition.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(compress.setState("compress",this,"YES","NO, FALSE, or 0 turns off compression.\nYES, TRUE, or a non-zero integer enables compression."));
	addState(mu.setState("mu",this,"255","mu parameter, a positive integer"));
	addState(denom.setState("denom",this,"1.0","denominator of the mu-law definition",
# line 60 "SDFMuLaw.pl"
A_NONCONSTANT|A_SETTABLE));


}

void SDFMuLaw::setup() {
# line 66 "SDFMuLaw.pl"
if ( int(mu) < 0 ) {
			Error::abortRun(*this,
					"Value for mu must be non-negative");
			return;
		}
		denom = log(1.0 + int(mu));
}

void SDFMuLaw::go() {
# line 75 "SDFMuLaw.pl"
double comp_value = double(input%0);

		// Compute the mu-law definition
		if (int(compress)) {
			if (comp_value < 0) comp_value = -comp_value;
			double numer = log(1.0 + int(mu) * comp_value);
			comp_value = numer / double(denom);	
		}

		output%0 << comp_value;
}

// prototype instance for known block list
static SDFMuLaw proto;
static RegisterBlock registerBlock(proto,"MuLaw");
