static const char file_id[] = "SDFPattMatch.pl";
// .cc file generated from SDFPattMatch.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFPattMatch.h"

const char *star_nm_SDFPattMatch = "SDFPattMatch";

const char* SDFPattMatch :: className() const {return star_nm_SDFPattMatch;}

ISA_FUNC(SDFPattMatch,SDFStar);

Block* SDFPattMatch :: makeNew() const { LOG_NEW; return new SDFPattMatch;}

SDFPattMatch::SDFPattMatch ()
{
	setDescriptor("This star accepts a template and a search window.  The template is slid\nover the window one sample at a time, and cross-correlations are calculated\nat each step.  The cross-correlations are output on the \"values\" output.\nThe \"index\" output is the value of the time shift which gives the largest\ncross-correlation.  This index refers to the position on the search window,\nbeginning with 0, that corresponds to the earliest sample in the search\nwindow that is part of the \"best match\" with the template.");
	addPort(templ.setPort("templ",this,FLOAT));
	addPort(window.setPort("window",this,FLOAT));
	addPort(index.setPort("index",this,INT));
	addPort(values.setPort("values",this,FLOAT));
	addState(tempSize.setState("tempSize",this,"32","number of samples in template"));
	addState(winSize.setState("winSize",this,"176","number of samples in search window"));


}

void SDFPattMatch::setup() {
# line 44 "SDFPattMatch.pl"
if ( winSize < tempSize )
			Error::abortRun( *this,
				"winSize must be >= tempSize" );
		N = winSize - tempSize + 1;
		templ.setSDFParams( tempSize, tempSize - 1 );
		window.setSDFParams( winSize, winSize - 1 );
		values.setSDFParams( N, N - 1 );
}

void SDFPattMatch::go() {
# line 54 "SDFPattMatch.pl"
float Cmax = 0, Cofn, top = 0, bottom = 0;
		int n, m, nmax = 0;

		for ( n = 0; n < N; n++ ) {
			top = bottom = 0;
			for ( m = 0; m < tempSize; m++ ) {
				float wval = window%( winSize - 1 - ( n + m ));
				top += float(templ%(tempSize - 1 - m)) * wval;
				bottom += wval * wval;
			}
			Cofn = top / bottom;
			values%( N - 1 - n ) << Cofn;
			if ( Cofn > Cmax ) {
				Cmax = Cofn;
				nmax = n;
			}
		}
		index%0 << nmax;
}

// prototype instance for known block list
static SDFPattMatch proto;
static RegisterBlock registerBlock(proto,"PattMatch");
