static const char file_id[] = "SDFRLattice.pl";
// .cc file generated from SDFRLattice.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFRLattice.h"

const char *star_nm_SDFRLattice = "SDFRLattice";

const char* SDFRLattice :: className() const {return star_nm_SDFRLattice;}

ISA_FUNC(SDFRLattice,SDFStar);

Block* SDFRLattice :: makeNew() const { LOG_NEW; return new SDFRLattice;}

SDFRLattice::SDFRLattice ()
{
	setDescriptor("A recursive (IIR) lattice filter.  The default coefficients\nimplement the synthesis filter for a particular 4th-order AR random process.\nTo read reflection coefficients from a file, replace the default\ncoefficients with \"<fileName\", preferably specifying a complete path.");
	addPort(signalIn.setPort("signalIn",this,FLOAT));
	addPort(signalOut.setPort("signalOut",this,FLOAT));
	addState(reflectionCoefs.setState("reflectionCoefs",this,"0.804534 -0.820577 0.521934 -0.205","Reflection or PARCOR coefficients."));

# line 107 "SDFRLattice.pl"
w = 0; y = 0; M = -1;
}

SDFRLattice::~SDFRLattice() {
# line 110 "SDFRLattice.pl"
LOG_DEL; delete [] w;
		LOG_DEL; delete [] y;
}

void SDFRLattice::setup() {
# line 114 "SDFRLattice.pl"
// reallocate arrays only if size has changed,
		// or this is the first run.
		if (M != reflectionCoefs.size()) {
			M = reflectionCoefs.size();
			LOG_DEL; delete [] w;
			LOG_NEW; w = new double[M+1];
			LOG_DEL; delete [] y;
			LOG_NEW; y = new double[M+1];
		}
		for (int i=0; i <= M; i++)  w[i]=0.0 ;
}

void SDFRLattice::go() {
# line 126 "SDFRLattice.pl"
double k;
		
		// Forward:  Compute each of the Y values
		y[0] = double (signalIn%0);   // y(0)=x(n)
		for (int i=1; i <= M; i++) {
			k = reflectionCoefs[M-i];
			y[i] = k * w[i] + y[i-1];
		}
		signalOut%0 << y[M];

		// Backward:  Compute the w's for the next round
		for (i = 1; i < M ; i++) {
			k = - reflectionCoefs[M-1-i];
			w[i] = w[i+1] + k*y[i+1];	
		}
		w[M] = y[M];
}

// prototype instance for known block list
static SDFRLattice proto;
static RegisterBlock registerBlock(proto,"RLattice");
