static const char file_id[] = "SDFSinc.pl";
// .cc file generated from SDFSinc.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFSinc.h"
#include <math.h>

const char *star_nm_SDFSinc = "SDFSinc";

const char* SDFSinc :: className() const {return star_nm_SDFSinc;}

ISA_FUNC(SDFSinc,SDFStar);

Block* SDFSinc :: makeNew() const { LOG_NEW; return new SDFSinc;}

SDFSinc::SDFSinc ()
{
	setDescriptor("This star computes the sinc of its input given in radians.\nThe sinc function is defined as sin(x)/x, with value 1.0 when x = 0.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));


}

void SDFSinc::go() {
# line 52 "SDFSinc.pl"
const double DELTA = 1.0e-9;	// Approximately zero
		double x = input%0;
		double sincValue;

		if ( ( -DELTA < x ) && ( x < DELTA ) )
		  sincValue = 1.0;
		else
		  sincValue = sin(x) / x;

		output%0 << sincValue;
}

// prototype instance for known block list
static SDFSinc proto;
static RegisterBlock registerBlock(proto,"Sinc");
