static const char file_id[] = "SDFUnwrap.pl";
// .cc file generated from SDFUnwrap.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFUnwrap.h"

const char *star_nm_SDFUnwrap = "SDFUnwrap";

const char* SDFUnwrap :: className() const {return star_nm_SDFUnwrap;}

ISA_FUNC(SDFUnwrap,SDFStar);

Block* SDFUnwrap :: makeNew() const { LOG_NEW; return new SDFUnwrap;}

SDFUnwrap::SDFUnwrap ()
{
	setDescriptor("Unwraps a phase plot, removing discontinuities of magnitude 2*PI.\nThe star assumes that the phase never changes by more than PI in one\nsample period. It also assumes that the input is in the [-PI,PI] range.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(outPhase.setState("outPhase",this,"0.0","Current phase of the star.",
# line 36 "SDFUnwrap.pl"
A_SETTABLE|A_NONCONSTANT));
	addState(prevPhase.setState("prevPhase",this,"0.0","Previous phase input value.",
# line 43 "SDFUnwrap.pl"
A_SETTABLE|A_NONCONSTANT));


}

void SDFUnwrap::go() {
# line 46 "SDFUnwrap.pl"
double newPhase = input%0;
		// compute the phase change and check for wraparound
		double phaseChange = newPhase - double(prevPhase);
		if (phaseChange < -M_PI) phaseChange += 2*M_PI;
		if (phaseChange > M_PI) phaseChange -= 2*M_PI;
		outPhase = double(outPhase) + phaseChange;
		output%0 << double(outPhase);
		prevPhase = newPhase;
}

// prototype instance for known block list
static SDFUnwrap proto;
static RegisterBlock registerBlock(proto,"Unwrap");
