static const char file_id[] = "SDFMedianImage.pl";
// .cc file generated from SDFMedianImage.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMedianImage.h"

const char *star_nm_SDFMedianImage = "SDFMedianImage";

const char* SDFMedianImage :: className() const {return star_nm_SDFMedianImage;}

ISA_FUNC(SDFMedianImage,SDFRankImage);

Block* SDFMedianImage :: makeNew() const { LOG_NEW; return new SDFMedianImage;}

SDFMedianImage::SDFMedianImage ()
{
	setDescriptor("Accept an input GrayImage, median filter the image, and send the result\nto the output.  Filter widths of 3, 5, and 7 work well.  Any length longer\nthan seven will take a long time to run.\n\nMedian filtering is useful for removing impulsive noise from images.\nIt also smooths out textures, so it is a useful pre-processing step\nbefore edge detection.  It removes inter-field flicker quite well\nwhen displaying single frames from a moving sequence.");

# line 33 "SDFMedianImage.pl"
RankOrder.clearAttributes(A_SETTABLE|A_CONSTANT);
}

void SDFMedianImage::setup() {
# line 37 "SDFMedianImage.pl"
// In a fwidth x fwidth neighborhood of pixels, data is
		// written into the one-dimensional buffer buf, which
		// is indexed from 0 ... (fwidth * fwidth - 1).
		// Median value at middle index, (fwidth * fwidth - 1)/2
		int fwidth = int(FilterWidth);
		RankOrder = (fwidth*fwidth - 1)/2;

		// Initialize data members
		SDFRankImage::setup();
}

// prototype instance for known block list
static SDFMedianImage proto;
static RegisterBlock registerBlock(proto,"MedianImage");
