#ifndef _SDFMotionCmpInv_h
#define _SDFMotionCmpInv_h 1
// header file generated from SDFMotionCmpInv.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */
#include "SDFStar.h"
#include "Matrix.h"
#include "Error.h"
#include "IntState.h"

class SDFMotionCmpInv : public SDFStar
{
public:
	SDFMotionCmpInv();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	InSDFPort diffIn;
	InSDFPort mvHorzIn;
	InSDFPort mvVertIn;
	InSDFPort pastIn;
	OutSDFPort output;

protected:
	/* virtual */ void go();
	IntState BlockSize;
	virtual int BlockIsLost (const FloatMatrix& ptr, const int ii, const int jj, const int blocksize, const int width);
	virtual void DoOneBlock (FloatMatrix& out, const FloatMatrix& prev, const FloatMatrix& diff, const char horz, const char vert, const int ii, const int jj, const int blocksize, const int width);
	virtual void DoLostBlock (FloatMatrix& out, const FloatMatrix& prev, const char horz, const char vert, const int ii, const int jj, const int blocksize, const int width);
	virtual unsigned char quant (const int i1, const int i2) {
# line 139 "SDFMotionCmpInv.pl"
int f = 2 * (i1 - 128) + i2;
			if (f < 0) { return ((unsigned char) 0); }
			else if (f > 254) { return ((unsigned char) 255); }
			else { return((unsigned char) f); }
	}

private:
	void doInvMC (FloatMatrix& out, const FloatMatrix& prev, const FloatMatrix& diff, const FloatMatrix& horzImg, const FloatMatrix& vertImg, const int width, const int height, const int blocksize);
	int sizesMatch (const FloatMatrix& im1, const FloatMatrix& im2, const FloatMatrix& mvH, const FloatMatrix& mvV);

};
#endif
