static const char file_id[] = "SDFRunLenImgInv.pl";
// .cc file generated from SDFRunLenImgInv.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFRunLenImgInv.h"

const char *star_nm_SDFRunLenImgInv = "SDFRunLenImgInv";

const char* SDFRunLenImgInv :: className() const {return star_nm_SDFRunLenImgInv;}

ISA_FUNC(SDFRunLenImgInv,SDFStar);

Block* SDFRunLenImgInv :: makeNew() const { LOG_NEW; return new SDFRunLenImgInv;}

SDFRunLenImgInv::SDFRunLenImgInv ()
{
	setDescriptor("Accept a Float Matrix and inverse run-length encode it.\nCheck to make sure we don't write past unallocated memory.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(originalW.setPort("originalW",this,INT));
	addPort(originalH.setPort("originalH",this,INT));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));
	addState(meanVal.setState("meanVal",this,"0","Center value for thresholding."));


}

void SDFRunLenImgInv::go() {
# line 98 "SDFRunLenImgInv.pl"
// Read input.
    Envelope inEnvp;
    (input%0).getMessage(inEnvp);
    const FloatMatrix& inData = *(const FloatMatrix *) inEnvp.myData();

    if (inEnvp.empty()) {
      Error::abortRun(*this, "Input is a dummyMessage.");
      return;
    }

    // Do processing and send out.
    FloatMatrix& outImg = invRunLen(inData,int(originalW%0),int(originalH%0));
    output%0 << outImg;
}


FloatMatrix& SDFRunLenImgInv::invRunLen (const FloatMatrix& inData,int outW, int outH)
{
# line 57 "SDFRunLenImgInv.pl"
// Do the run-length coding.
      const int size = inData.numRows() * inData.numCols();
      const int fullFrame = outW * outH;

      LOG_NEW; unsigned char* ptr2 = new unsigned char[fullFrame];

      int indx1 = 0, indx2 = 0, count;
      while ((indx1 < size) && (indx2 < fullFrame)) {
        // Do a zero-run.
	while ( (indx1 < size)  && 
                (inData.entry(indx1) == int(meanVal))  &&
	        (indx2 < fullFrame) ) {
	  indx1++; // Skip to run length.
	  for(count = 0; (count < int(inData.entry(indx1)))  &&
	      (indx2 < fullFrame); count++) {
            ptr2[indx2++] = (unsigned char) int(meanVal);
	  }
	  indx1++; // Skip past run length.
	}
        // Handle a non-zero run.
	while ((indx1 < size) && (inData.entry(indx1) != int(meanVal))
		&& (indx2 < fullFrame)) {
	  ptr2[indx2++] = (unsigned char)(inData.entry(indx1++));
	}
      }

      // Copy the data to return.
      LOG_NEW; FloatMatrix& outImage = *(new FloatMatrix(outH,outW));
      for(indx1 = 0; indx1 < indx2; indx1++) {
	outImage.entry(indx1) = ptr2[indx1];
      }
      for(; indx1 < fullFrame; indx1++) {
	outImage.entry(indx1) = (unsigned char) 0;
      }
      LOG_DEL; delete [] ptr2;

      return outImage;
}


// prototype instance for known block list
static SDFRunLenImgInv proto;
static RegisterBlock registerBlock(proto,"RunLenImgInv");
