static const char file_id[] = "SDFAbs_M.pl";
// .cc file generated from SDFAbs_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFAbs_M.h"
#include "Matrix.h"

const char *star_nm_SDFAbs_M = "SDFAbs_M";

const char* SDFAbs_M :: className() const {return star_nm_SDFAbs_M;}

ISA_FUNC(SDFAbs_M,SDFStar);

Block* SDFAbs_M :: makeNew() const { LOG_NEW; return new SDFAbs_M;}

SDFAbs_M::SDFAbs_M ()
{
	setDescriptor("Return the absolute value of each entry of the floating-point matrix.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input matrices"));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input matrices"));


}

void SDFAbs_M::go() {
# line 38 "SDFAbs_M.pl"
Envelope pkt;
          (input%0).getMessage(pkt);
          const FloatMatrix& matrix = *(const FloatMatrix *)pkt.myData();

          // check for "null" matrix inputs, caused by delays
          if(pkt.empty()) {
            // if input is empty, return a zero matrix with the given dimensions
            FloatMatrix& result = *(new FloatMatrix(int(numRows),int(numCols)));
            result = 0.0;
            output%0 << result;
          }
          else {
            if((matrix.numRows() != int(numRows)) ||
               (matrix.numCols() != int(numCols))) {
              Error::abortRun(*this,"Dimension size of FloatMatrix input does ",
                                    "not match the given state parameters.");
              return;
            }
            FloatMatrix& result = *(new FloatMatrix(int(numRows),int(numCols)));
	    for (int i=0; i<numRows*numCols; i++)
              result.entry(i) = fabs(matrix.entry(i)); // abs the matrix
            output%0 << result;
          }
}

// prototype instance for known block list
static SDFAbs_M proto;
static RegisterBlock registerBlock(proto,"Abs_M");
