static const char file_id[] = "SDFAddInt_M.pl";
// .cc file generated from SDFAddInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFAddInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFAddInt_M = "SDFAddInt_M";

const char* SDFAddInt_M :: className() const {return star_nm_SDFAddInt_M;}

ISA_FUNC(SDFAddInt_M,SDFStar);

Block* SDFAddInt_M :: makeNew() const { LOG_NEW; return new SDFAddInt_M;}

SDFAddInt_M::SDFAddInt_M ()
{
	setDescriptor("Add two integer matrices.");
	addPort(Ainput.setPort("Ainput",this,INT_MATRIX_ENV));
	addPort(Binput.setPort("Binput",this,INT_MATRIX_ENV));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input matrices."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input matrices."));


}

void SDFAddInt_M::go() {
# line 40 "SDFAddInt_M.pl"
// get inputs
    Envelope Apkt;
    (Ainput%0).getMessage(Apkt);
    const IntMatrix& Amatrix = *(const IntMatrix *)Apkt.myData();
    Envelope Bpkt;
    (Binput%0).getMessage(Bpkt);
    const IntMatrix& Bmatrix = *(const IntMatrix *)Bpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(Apkt.empty() && Bpkt.empty()) {
      // both empty, return a zero matrix with the given dimensions
      IntMatrix& result = *(new IntMatrix(int(numRows),int(numCols)));
      result = 0;
      output%0 << result;
    }
    else if(Apkt.empty()) {
      // Amatrix is empty but B is not, return just B
      // NOTE: must resend the Envelope and not an input matrix to keep
      // the reference count mechanism working
      output%0 << Bpkt;
    }
    else if(Bpkt.empty()) {
      // Bmatrix is empty but A is not, return just A
      // NOTE: must resend the Envelope and not an input matrix to keep
      // the reference count mechanism working
      output%0 << Apkt;
    }
    else {
      // Amatrix and Bmatrix both valid

      // just check that A's dimensions match the state info.
      // the operator + on matrices will check that A matches B
      if((Amatrix.numRows() != int(numRows)) ||
         (Amatrix.numCols() != int(numCols))) {
        Error::abortRun(*this,"Dimension size of IntMatrix inputs do ",
                              "not match the given state parameters.");
        return;
      }

      // do matrix addition
      IntMatrix& result = *(new IntMatrix(int(numRows),int(numCols)));
      result = Amatrix + Bmatrix;
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFAddInt_M proto;
static RegisterBlock registerBlock(proto,"AddInt_M");
