static const char file_id[] = "SDFConjugate_M.pl";
// .cc file generated from SDFConjugate_M.pl by ptlang
/*
Copyright (c) 1993-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFConjugate_M.h"
#include "Matrix.h"

const char *star_nm_SDFConjugate_M = "SDFConjugate_M";

const char* SDFConjugate_M :: className() const {return star_nm_SDFConjugate_M;}

ISA_FUNC(SDFConjugate_M,SDFStar);

Block* SDFConjugate_M :: makeNew() const { LOG_NEW; return new SDFConjugate_M;}

SDFConjugate_M::SDFConjugate_M ()
{
	setDescriptor("Conjugate a matrix.");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input matrix."));


}

void SDFConjugate_M::go() {
# line 36 "SDFConjugate_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // if input is empty, return a zero matrix with the given dimensions
      ComplexMatrix& result = *(new ComplexMatrix(int(numRows),int(numCols)));
      result = 0.0;
      output%0 << result;
    }
    else {
      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
        Error::abortRun(*this,"Dimension size of ComplexMatrix input does ",
                              "not match the given state parameters.");
        return;
      }
      ComplexMatrix& result = *(new ComplexMatrix(int(numCols),int(numRows)));
      result = matrix.conjugate();
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFConjugate_M proto;
static RegisterBlock registerBlock(proto,"Conjugate_M");
