static const char file_id[] = "SDFCxToFix_M.pl";
// .cc file generated from SDFCxToFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFCxToFix_M.h"
#include "Matrix.h"

const char *star_nm_SDFCxToFix_M = "SDFCxToFix_M";

const char* SDFCxToFix_M :: className() const {return star_nm_SDFCxToFix_M;}

ISA_FUNC(SDFCxToFix_M,SDFStar);

Block* SDFCxToFix_M :: makeNew() const { LOG_NEW; return new SDFCxToFix_M;}

SDFCxToFix_M::SDFCxToFix_M ()
{
	setDescriptor("Take an input ComplexMatrix and convert it to an FixMatrix.  This\nis done by constructing a new FixMatrix with the given precision.\nEach entry of the ComplexMatrix is cast using the given masking function\nand then copied to the new matrix.");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));
	addState(FixPrecision.setState("FixPrecision",this,"4.14","Precision of the entries in the FixMatrix.  The floating-point values\nof the ComplexMatrix are converted to this precision."));
	addState(masking.setState("masking",this,"truncate","Masking method.  This parameter is used to specify the way the floating-point\nnumber is masked for casting to the fixed-point notation.  The keywords are:\n\"truncate\" (default), \"round\"."));


}

void SDFCxToFix_M::setup() {
# line 52 "SDFCxToFix_M.pl"
Precision = FixPrecision;
    Masking = masking;
    intBits = Fix::get_intBits(FixPrecision);
    length = Fix::get_length(FixPrecision);
}

void SDFCxToFix_M::go() {
# line 58 "SDFCxToFix_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      if(strcmp(Masking, "truncate") == 0) {
        FixMatrix& result = *(new FixMatrix(matrix,length,intBits,Fix::mask_truncate));
        output%0 << result;
      }
      else if(strcmp(Masking, "round") == 0) {
        FixMatrix& result = *(new FixMatrix(matrix,length,intBits,Fix::mask_truncate_round));
        output%0 << result;
      }
      else
        Error::abortRun(*this, ": not a valid function for masking");
    }
}

// prototype instance for known block list
static SDFCxToFix_M proto;
static RegisterBlock registerBlock(proto,"CxToFix_M");
