static const char file_id[] = "SDFCxToFloat_M.pl";
// .cc file generated from SDFCxToFloat_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFCxToFloat_M.h"
#include "Matrix.h"

const char *star_nm_SDFCxToFloat_M = "SDFCxToFloat_M";

const char* SDFCxToFloat_M :: className() const {return star_nm_SDFCxToFloat_M;}

ISA_FUNC(SDFCxToFloat_M,SDFStar);

Block* SDFCxToFloat_M :: makeNew() const { LOG_NEW; return new SDFCxToFloat_M;}

SDFCxToFloat_M::SDFCxToFloat_M ()
{
	setDescriptor("Take an input ComplexMatrix and convert it to an FloatMatrix.  This\nis done by using the cast conversion method of the ComplexMatrix class.\nThe conversion results in an FloatMatrix that has entries which are the\nabsolute value of each corresponding entry of the ComplexMatrix being converted,\ni.e. FloatMatrix.entry(i) = abs(ComplexMatrix.entry(i)).");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));


}

void SDFCxToFloat_M::go() {
# line 30 "SDFCxToFloat_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      FloatMatrix& result = *(new FloatMatrix(FloatMatrix(matrix)));
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFCxToFloat_M proto;
static RegisterBlock registerBlock(proto,"CxToFloat_M");
