static const char file_id[] = "SDFCxToInt_M.pl";
// .cc file generated from SDFCxToInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFCxToInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFCxToInt_M = "SDFCxToInt_M";

const char* SDFCxToInt_M :: className() const {return star_nm_SDFCxToInt_M;}

ISA_FUNC(SDFCxToInt_M,SDFStar);

Block* SDFCxToInt_M :: makeNew() const { LOG_NEW; return new SDFCxToInt_M;}

SDFCxToInt_M::SDFCxToInt_M ()
{
	setDescriptor("Take an input ComplexMatrix and convert it to an IntMatrix.  This\nis done by using the cast conversion method of the ComplexMatrix class.\nThe conversion results in an IntMatrix that has entries which are the\nint of the absolute value of each corresponding entry of the \nComplexMatrix being converted.  \nI.e. IntMatrix.entry(i) = (int)abs(ComplexMatrix.entry(i))");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));


}

void SDFCxToInt_M::go() {
# line 31 "SDFCxToInt_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      IntMatrix& result = *(new IntMatrix(IntMatrix(matrix)));
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFCxToInt_M proto;
static RegisterBlock registerBlock(proto,"CxToInt_M");
