static const char file_id[] = "SDFFixToCx_M.pl";
// .cc file generated from SDFFixToCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFixToCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFFixToCx_M = "SDFFixToCx_M";

const char* SDFFixToCx_M :: className() const {return star_nm_SDFFixToCx_M;}

ISA_FUNC(SDFFixToCx_M,SDFStar);

Block* SDFFixToCx_M :: makeNew() const { LOG_NEW; return new SDFFixToCx_M;}

SDFFixToCx_M::SDFFixToCx_M ()
{
	setDescriptor("Take an input FixMatrix and convert it to an ComplexMatrix.  This\nis done by using the cast conversion method of the FixMatrix class.\nThe conversion results in a ComplexMatrix that has entries which have\nreal values which are the double-precision representation of each\ncorresponding entry of the FixMatrix, with 0 imaginary values.\nI.e. ComplexMatrix.entry(i) = double(FixMatrix.entry(i)).");
	addPort(input.setPort("input",this,FIX_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));


}

void SDFFixToCx_M::go() {
# line 31 "SDFFixToCx_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FixMatrix& matrix = *(const FixMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      ComplexMatrix& result = *(new ComplexMatrix(ComplexMatrix(matrix)));
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFFixToCx_M proto;
static RegisterBlock registerBlock(proto,"FixToCx_M");
