static const char file_id[] = "SDFFixToFloat_M.pl";
// .cc file generated from SDFFixToFloat_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFixToFloat_M.h"
#include "Matrix.h"

const char *star_nm_SDFFixToFloat_M = "SDFFixToFloat_M";

const char* SDFFixToFloat_M :: className() const {return star_nm_SDFFixToFloat_M;}

ISA_FUNC(SDFFixToFloat_M,SDFStar);

Block* SDFFixToFloat_M :: makeNew() const { LOG_NEW; return new SDFFixToFloat_M;}

SDFFixToFloat_M::SDFFixToFloat_M ()
{
	setDescriptor("Takes an input FixMatrix and converts it to an FloatMatrix.  This\nis done by using the cast conversion method of the FixMatrix class.\nThe conversion results in a FloatMatrix that has entries which are\nthe double-precision representation of each corresponding entry of\nthe FixMatrix.  I.e. FloatMatrix.entry(i) = double(FixMatrix.entry(i)).");
	addPort(input.setPort("input",this,FIX_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));


}

void SDFFixToFloat_M::go() {
# line 30 "SDFFixToFloat_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FixMatrix& matrix = *(const FixMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      FloatMatrix& result = *(new FloatMatrix(FloatMatrix(matrix)));
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFFixToFloat_M proto;
static RegisterBlock registerBlock(proto,"FixToFloat_M");
