static const char file_id[] = "SDFFixToInt_M.pl";
// .cc file generated from SDFFixToInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFixToInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFFixToInt_M = "SDFFixToInt_M";

const char* SDFFixToInt_M :: className() const {return star_nm_SDFFixToInt_M;}

ISA_FUNC(SDFFixToInt_M,SDFStar);

Block* SDFFixToInt_M :: makeNew() const { LOG_NEW; return new SDFFixToInt_M;}

SDFFixToInt_M::SDFFixToInt_M ()
{
	setDescriptor("Takes an input FixMatrix and converts it to an IntMatrix.  This\nis done by using the cast conversion method of the FixMatrix class.\nThe conversion results in a IntMatrix that has entries which are\nthe integer representation of each corresponding entry of the FixMatrix.\nI.e. IntMatrix.entry(i) = int(FixMatrix.entry(i))");
	addPort(input.setPort("input",this,FIX_MATRIX_ENV));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));


}

void SDFFixToInt_M::go() {
# line 30 "SDFFixToInt_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FixMatrix& matrix = *(const FixMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      IntMatrix& result = *(new IntMatrix(IntMatrix(matrix)));
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFFixToInt_M proto;
static RegisterBlock registerBlock(proto,"FixToInt_M");
