static const char file_id[] = "SDFFloatToCx_M.pl";
// .cc file generated from SDFFloatToCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFloatToCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFFloatToCx_M = "SDFFloatToCx_M";

const char* SDFFloatToCx_M :: className() const {return star_nm_SDFFloatToCx_M;}

ISA_FUNC(SDFFloatToCx_M,SDFStar);

Block* SDFFloatToCx_M :: makeNew() const { LOG_NEW; return new SDFFloatToCx_M;}

SDFFloatToCx_M::SDFFloatToCx_M ()
{
	setDescriptor("Takes an input FloatMatrix and converts it to an ComplexMatrix.  This\nis done by using the cast conversion method of the FloatMatrix class.\nThe conversion results in a ComplexMatrix that has entries which have\nreal values that are the values of each corresponding entry of the \nFloatMatrix and 0 imaginary value.\nI.e. ComplexMatrix.entry(i) = FloatMatrix.entry(i).");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));


}

void SDFFloatToCx_M::go() {
# line 31 "SDFFloatToCx_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FloatMatrix& matrix = *(const FloatMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      ComplexMatrix& result = *(new ComplexMatrix(ComplexMatrix(matrix)));
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFFloatToCx_M proto;
static RegisterBlock registerBlock(proto,"FloatToCx_M");
