static const char file_id[] = "SDFFloatToFix_M.pl";
// .cc file generated from SDFFloatToFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFloatToFix_M.h"
#include "Matrix.h"

const char *star_nm_SDFFloatToFix_M = "SDFFloatToFix_M";

const char* SDFFloatToFix_M :: className() const {return star_nm_SDFFloatToFix_M;}

ISA_FUNC(SDFFloatToFix_M,SDFStar);

Block* SDFFloatToFix_M :: makeNew() const { LOG_NEW; return new SDFFloatToFix_M;}

SDFFloatToFix_M::SDFFloatToFix_M ()
{
	setDescriptor("Take an input FloatMatrix and convert it to an FixMatrix.  This\nis done by constructing a new FixMatrix with the given precision.\nEach entry of the FloatMatrix is cast using the given masking function\nand then copied to the new matrix.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));
	addState(FixPrecision.setState("FixPrecision",this,"4.14","Precision of the entries in the FixMatrix.  The floating-point values\nof the FloatMatrix are converted to this precision."));
	addState(masking.setState("masking",this,"truncate","Masking method.  This parameter is used to specify the way the floating-point\nnumber is masked for casting to the fixed-point notation.  The keywords are:\n\"truncate\" (default), \"round\"."));


}

void SDFFloatToFix_M::setup() {
# line 52 "SDFFloatToFix_M.pl"
Precision = FixPrecision;
    Masking = masking;
    intBits = Fix::get_intBits(FixPrecision);
    length = Fix::get_length(FixPrecision);
}

void SDFFloatToFix_M::go() {
# line 58 "SDFFloatToFix_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FloatMatrix& matrix = *(const FloatMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      if(strcmp(Masking, "truncate") == 0) {
        FixMatrix& result = *(new FixMatrix(matrix,intBits,length,Fix::mask_truncate));
        output%0 << result;
      }
      else if(strcmp(Masking, "round") == 0) {
        FixMatrix& result = *(new FixMatrix(matrix,intBits,length,Fix::mask_truncate_round));
        output%0 << result;
      }
      else 
        Error::abortRun(*this, ": not a valid function for masking");
    }
}

// prototype instance for known block list
static SDFFloatToFix_M proto;
static RegisterBlock registerBlock(proto,"FloatToFix_M");
