static const char file_id[] = "SDFFloatToInt_M.pl";
// .cc file generated from SDFFloatToInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFloatToInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFFloatToInt_M = "SDFFloatToInt_M";

const char* SDFFloatToInt_M :: className() const {return star_nm_SDFFloatToInt_M;}

ISA_FUNC(SDFFloatToInt_M,SDFStar);

Block* SDFFloatToInt_M :: makeNew() const { LOG_NEW; return new SDFFloatToInt_M;}

SDFFloatToInt_M::SDFFloatToInt_M ()
{
	setDescriptor("Take an input FloatMatrix and convert it to an IntMatrix.  This\nis done by using the cast conversion method of the FloatMatrix class.\nThe conversion results in a IntMatrix that has entries which are\nthe int of each corresponding entry of the FloatMatrix.\nI.e. IntMatrix.entry(i) = int(FloatMatrix.entry(i))");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));


}

void SDFFloatToInt_M::go() {
# line 30 "SDFFloatToInt_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FloatMatrix& matrix = *(const FloatMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      IntMatrix& result = *(new IntMatrix(IntMatrix(matrix)));
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFFloatToInt_M proto;
static RegisterBlock registerBlock(proto,"FloatToInt_M");
