static const char file_id[] = "SDFGainCx_M.pl";
// .cc file generated from SDFGainCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFGainCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFGainCx_M = "SDFGainCx_M";

const char* SDFGainCx_M :: className() const {return star_nm_SDFGainCx_M;}

ISA_FUNC(SDFGainCx_M,SDFStar);

Block* SDFGainCx_M :: makeNew() const { LOG_NEW; return new SDFGainCx_M;}

SDFGainCx_M::SDFGainCx_M ()
{
	setDescriptor("Multiply a complex matrix by a complex scalar gain value.");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));
	addState(gain.setState("gain",this,"(1,0)","Gain to be multiplied with the input matrix"));


}

void SDFGainCx_M::go() {
# line 30 "SDFGainCx_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do scalar * matrix
      ComplexMatrix& result = *(new ComplexMatrix(matrix.numRows(),matrix.numCols()));
      result = Complex(gain) * matrix;
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFGainCx_M proto;
static RegisterBlock registerBlock(proto,"GainCx_M");
