static const char file_id[] = "SDFGainFix_M.pl";
// .cc file generated from SDFGainFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFGainFix_M.h"
#include "Matrix.h"

const char *star_nm_SDFGainFix_M = "SDFGainFix_M";

const char* SDFGainFix_M :: className() const {return star_nm_SDFGainFix_M;}

ISA_FUNC(SDFGainFix_M,SDFStar);

Block* SDFGainFix_M :: makeNew() const { LOG_NEW; return new SDFGainFix_M;}

SDFGainFix_M::SDFGainFix_M ()
{
	setDescriptor("Multiply a fixed-point matrix by a fixed-point scalar gain value.");
	addPort(input.setPort("input",this,FIX_MATRIX_ENV));
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));
	addState(gain.setState("gain",this,"1.0","Gain to be multiplied with the input matrix"));
	addState(UseArrivingPrecision.setState("UseArrivingPrecision",this,"YES","Flag indicated whether or not to use the arriving particles as they are:\nYES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"NewInputPrecision\"."));
	addState(NewInputPrecision.setState("NewInputPrecision",this,"2.14","New precision of the input in bits.  The input particles are only cast\nto this precision if the parameter \"UseArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.  This is the precision that will hold\nthe result of the arithmetic operation on the inputs."));
	addState(OverflowHandler.setState("OverflowHandler",this,"saturate","Overflow characteristic for the output.  If the result\nof the product cannot be fit into the precision of the output, overflow\noccurs and the overflow is taken care of by the method specified by this\nparameter.  The keywords for overflow handling methods are :\n\"saturate\"(default), \"zero_saturate\", \"wrapped\", \"warning\"."));


}

void SDFGainFix_M::setup() {
# line 74 "SDFGainFix_M.pl"
IP = NewInputPrecision;
    OP = OutputPrecision;
    OV = OverflowHandler;
    in_IntBits = Fix::get_intBits (IP);
    in_len = Fix::get_length (IP);
    out_IntBits = Fix::get_intBits (OP);
    out_len = Fix::get_length (OP);
}

void SDFGainFix_M::go() {
# line 84 "SDFGainFix_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FixMatrix& matrix = *(const FixMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      FixMatrix& result = *(new FixMatrix(matrix.numRows(),matrix.numCols(),
                                          out_len, out_IntBits));

      Fix fixIn;

      // do scalar * matrix
      for(int i = 0; i < (matrix.numRows() * matrix.numCols()); i++) {
        if(int(UseArrivingPrecision))
          fixIn = matrix.entry(i);
        else
          fixIn = Fix(in_len, in_IntBits, matrix.entry(i));
        result.entry(i).set_ovflow(OV);
        result.entry(i) = fixIn * Fix(gain);
      }

      output%0 << result;
    }
}

// prototype instance for known block list
static SDFGainFix_M proto;
static RegisterBlock registerBlock(proto,"GainFix_M");
