static const char file_id[] = "SDFGainInt_M.pl";
// .cc file generated from SDFGainInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFGainInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFGainInt_M = "SDFGainInt_M";

const char* SDFGainInt_M :: className() const {return star_nm_SDFGainInt_M;}

ISA_FUNC(SDFGainInt_M,SDFStar);

Block* SDFGainInt_M :: makeNew() const { LOG_NEW; return new SDFGainInt_M;}

SDFGainInt_M::SDFGainInt_M ()
{
	setDescriptor("Multiply an integer matrix by an integer scalar gain value.");
	addPort(input.setPort("input",this,INT_MATRIX_ENV));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));
	addState(gain.setState("gain",this,"1","Gain to be multiplied with the input matrix"));


}

void SDFGainInt_M::go() {
# line 30 "SDFGainInt_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const IntMatrix& matrix = *(const IntMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do scalar * matrix
      IntMatrix& result = *(new IntMatrix(matrix.numRows(),matrix.numCols()));
      result = int(gain) * matrix;
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFGainInt_M proto;
static RegisterBlock registerBlock(proto,"GainInt_M");
