static const char file_id[] = "SDFGain_M.pl";
// .cc file generated from SDFGain_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFGain_M.h"
#include "Matrix.h"

const char *star_nm_SDFGain_M = "SDFGain_M";

const char* SDFGain_M :: className() const {return star_nm_SDFGain_M;}

ISA_FUNC(SDFGain_M,SDFStar);

Block* SDFGain_M :: makeNew() const { LOG_NEW; return new SDFGain_M;}

SDFGain_M::SDFGain_M ()
{
	setDescriptor("Multiply a floating-point matrix by a scalar gain value.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));
	addState(gain.setState("gain",this,"1.0","Gain to be multiplied with the input matrix"));


}

void SDFGain_M::go() {
# line 30 "SDFGain_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FloatMatrix& matrix = *(const FloatMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do scalar * matrix
      FloatMatrix& result = *(new FloatMatrix(matrix.numRows(),matrix.numCols()));
      result = double(gain) * matrix;
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFGain_M proto;
static RegisterBlock registerBlock(proto,"Gain_M");
