static const char file_id[] = "SDFHermitian_M.pl";
// .cc file generated from SDFHermitian_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFHermitian_M.h"
#include "Matrix.h"

const char *star_nm_SDFHermitian_M = "SDFHermitian_M";

const char* SDFHermitian_M :: className() const {return star_nm_SDFHermitian_M;}

ISA_FUNC(SDFHermitian_M,SDFStar);

Block* SDFHermitian_M :: makeNew() const { LOG_NEW; return new SDFHermitian_M;}

SDFHermitian_M::SDFHermitian_M ()
{
	setDescriptor("Perform a Hermitian transpose (conjugate transpose) on the input matrix.");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input matrix."));


}

void SDFHermitian_M::go() {
# line 38 "SDFHermitian_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // input empty, send out a zero matrix with the dimensions transposed
      ComplexMatrix& result = *(new ComplexMatrix(int(numCols),int(numRows)));
      result = 0;
      output%0 << result;
    }
    else {
      // valid input matrix

      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
        Error::abortRun(*this,"Dimension size of ComplexMatrix input does ",
                              "not match the given state parameters.");
        return;
      }
      ComplexMatrix& result = *(new ComplexMatrix(int(numCols),int(numRows)));
      result = matrix.hermitian();
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFHermitian_M proto;
static RegisterBlock registerBlock(proto,"Hermitian_M");
