static const char file_id[] = "SDFIdentityFix_M.pl";
// .cc file generated from SDFIdentityFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFIdentityFix_M.h"
#include "Matrix.h"

const char *star_nm_SDFIdentityFix_M = "SDFIdentityFix_M";

const char* SDFIdentityFix_M :: className() const {return star_nm_SDFIdentityFix_M;}

ISA_FUNC(SDFIdentityFix_M,SDFStar);

Block* SDFIdentityFix_M :: makeNew() const { LOG_NEW; return new SDFIdentityFix_M;}

SDFIdentityFix_M::SDFIdentityFix_M ()
{
	setDescriptor("Output a fix-point identity matrix.");
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));
	addState(rowsCols.setState("rowsCols",this,"2","Number of rows and columns of the output square matrix."));
	addState(FixPrecision.setState("FixPrecision",this,"8.14","Precision of all entries in the matrix."));


}

void SDFIdentityFix_M::go() {
# line 38 "SDFIdentityFix_M.pl"
// parse precision value
    precision = FixPrecision;
    length = Fix::get_length(precision);
    intbits = Fix::get_intBits(precision);

    FixMatrix& result = *(new FixMatrix(int(rowsCols),int(rowsCols),
                                        length, intbits));
    result.identity();
    output%0 << result;
}

// prototype instance for known block list
static SDFIdentityFix_M proto;
static RegisterBlock registerBlock(proto,"IdentityFix_M");
