static const char file_id[] = "SDFIntToCx_M.pl";
// .cc file generated from SDFIntToCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFIntToCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFIntToCx_M = "SDFIntToCx_M";

const char* SDFIntToCx_M :: className() const {return star_nm_SDFIntToCx_M;}

ISA_FUNC(SDFIntToCx_M,SDFStar);

Block* SDFIntToCx_M :: makeNew() const { LOG_NEW; return new SDFIntToCx_M;}

SDFIntToCx_M::SDFIntToCx_M ()
{
	setDescriptor("Take an input IntMatrix and convert it to an ComplexMatrix.  This\nis done by using the cast conversion method of the IntMatrix class.\nThe conversion results in a ComplexMatrix that has entries which have\nreal values that are the double of each corresponding entry of the\nIntMatrix and 0 imaginary values.\nI.e. ComplexMatrix.entry(i) = double(IntMatrix.entry(i))");
	addPort(input.setPort("input",this,INT_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));


}

void SDFIntToCx_M::go() {
# line 31 "SDFIntToCx_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const IntMatrix& matrix = *(const IntMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      ComplexMatrix& result = *(new ComplexMatrix(ComplexMatrix(matrix)));
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFIntToCx_M proto;
static RegisterBlock registerBlock(proto,"IntToCx_M");
