static const char file_id[] = "SDFIntToFloat_M.pl";
// .cc file generated from SDFIntToFloat_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFIntToFloat_M.h"
#include "Matrix.h"

const char *star_nm_SDFIntToFloat_M = "SDFIntToFloat_M";

const char* SDFIntToFloat_M :: className() const {return star_nm_SDFIntToFloat_M;}

ISA_FUNC(SDFIntToFloat_M,SDFStar);

Block* SDFIntToFloat_M :: makeNew() const { LOG_NEW; return new SDFIntToFloat_M;}

SDFIntToFloat_M::SDFIntToFloat_M ()
{
	setDescriptor("Take an input IntMatrix and convert it to an FloatMatrix.  This\nis done by using the cast conversion method of the IntMatrix class.\nThe conversion results in an FloatMatrix that has entries which are the\ndouble of each corresponding entry of the IntMatrix being converted.  \nI.e. FloatMatrix.entry(i) = double(IntMatrix.entry(i))");
	addPort(input.setPort("input",this,INT_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));


}

void SDFIntToFloat_M::go() {
# line 30 "SDFIntToFloat_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const IntMatrix& matrix = *(const IntMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do conversion using copy constructor
      FloatMatrix& result = *(new FloatMatrix(FloatMatrix(matrix)));
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFIntToFloat_M proto;
static RegisterBlock registerBlock(proto,"IntToFloat_M");
