static const char file_id[] = "SDFInverseCx_M.pl";
// .cc file generated from SDFInverseCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFInverseCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFInverseCx_M = "SDFInverseCx_M";

const char* SDFInverseCx_M :: className() const {return star_nm_SDFInverseCx_M;}

ISA_FUNC(SDFInverseCx_M,SDFStar);

Block* SDFInverseCx_M :: makeNew() const { LOG_NEW; return new SDFInverseCx_M;}

SDFInverseCx_M::SDFInverseCx_M ()
{
	setDescriptor("Invert a square complex matrix.");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));
	addState(rowsCols.setState("rowsCols",this,"2","The number of rows/columns of the input square matrix."));


}

void SDFInverseCx_M::go() {
# line 30 "SDFInverseCx_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // if input is empty, return a zero matrix with the given dimensions
      ComplexMatrix& result = *(new ComplexMatrix(int(rowsCols),int(rowsCols)));
      result = 0.0;
      output%0 << result;
    }
    else {
      if((matrix.numRows() != int(rowsCols)) ||
         (matrix.numCols() != int(rowsCols))) {
        Error::abortRun(*this,"Dimension size of ComplexMatrix input does ",
                              "not match the given state parameters.");
        return;
      }
      ComplexMatrix& result = *(new ComplexMatrix(int(rowsCols),int(rowsCols)));
      result = !matrix;        // invert the matrix
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFInverseCx_M proto;
static RegisterBlock registerBlock(proto,"InverseCx_M");
