static const char file_id[] = "SDFInverseFix_M.pl";
// .cc file generated from SDFInverseFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFInverseFix_M.h"
#include "Matrix.h"

const char *star_nm_SDFInverseFix_M = "SDFInverseFix_M";

const char* SDFInverseFix_M :: className() const {return star_nm_SDFInverseFix_M;}

ISA_FUNC(SDFInverseFix_M,SDFStar);

Block* SDFInverseFix_M :: makeNew() const { LOG_NEW; return new SDFInverseFix_M;}

SDFInverseFix_M::SDFInverseFix_M ()
{
	setDescriptor("Invert a square fixed-point matrix.");
	addPort(input.setPort("input",this,FIX_MATRIX_ENV));
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));
	addState(rowsCols.setState("rowsCols",this,"2","The number of rows/columns of the input square matrix."));


}

void SDFInverseFix_M::go() {
# line 30 "SDFInverseFix_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const FixMatrix& matrix = *(const FixMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // if input is empty, return a zero matrix with the given dimensions
      FixMatrix& result = *(new FixMatrix(int(rowsCols),int(rowsCols)));
      result = 0.0;
      output%0 << result;
    }
    else {
      if((matrix.numRows() != int(rowsCols)) ||
         (matrix.numCols() != int(rowsCols))) {
        Error::abortRun(*this,"Dimension size of FixMatrix input does ",
                              "not match the given state parameters.");
        return;
      }
      FixMatrix& result = *(new FixMatrix(int(rowsCols),int(rowsCols)));
      result = !matrix;         // invert the matrix
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFInverseFix_M proto;
static RegisterBlock registerBlock(proto,"InverseFix_M");
