static const char file_id[] = "SDFInverseInt_M.pl";
// .cc file generated from SDFInverseInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFInverseInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFInverseInt_M = "SDFInverseInt_M";

const char* SDFInverseInt_M :: className() const {return star_nm_SDFInverseInt_M;}

ISA_FUNC(SDFInverseInt_M,SDFStar);

Block* SDFInverseInt_M :: makeNew() const { LOG_NEW; return new SDFInverseInt_M;}

SDFInverseInt_M::SDFInverseInt_M ()
{
	setDescriptor("Invert a square integer matrix, producing an integer matrix.\nNote: If A is the input Matrix and B is the inverse, then AB\nwill not necessarily be the identity matrix unless A has an\ninverse that can be represented as an integer matrix.\nUsually this is not the case!");
	addPort(input.setPort("input",this,INT_MATRIX_ENV));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));
	addState(rowsCols.setState("rowsCols",this,"2","The number of rows and columns of the input square matrix."));


}

void SDFInverseInt_M::go() {
# line 36 "SDFInverseInt_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const IntMatrix& matrix = *(const IntMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // if input is empty, return a zero matrix with the given dimensions
      IntMatrix& result = *(new IntMatrix(int(rowsCols),int(rowsCols)));
      result = 0;
      output%0 << result;
    }
    else {
      if((matrix.numRows() != int(rowsCols)) ||
         (matrix.numCols() != int(rowsCols))) {
        Error::abortRun(*this,"Dimension size of IntMatrix input does ",
                              "not match the given state parameters.");
        return;
      }
      IntMatrix& result = *(new IntMatrix(int(rowsCols),int(rowsCols)));
      result = !matrix;        // invert the matrix
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFInverseInt_M proto;
static RegisterBlock registerBlock(proto,"InverseInt_M");
