static const char file_id[] = "SDFInverse_M.pl";
// .cc file generated from SDFInverse_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFInverse_M.h"
#include "Matrix.h"

const char *star_nm_SDFInverse_M = "SDFInverse_M";

const char* SDFInverse_M :: className() const {return star_nm_SDFInverse_M;}

ISA_FUNC(SDFInverse_M,SDFStar);

Block* SDFInverse_M :: makeNew() const { LOG_NEW; return new SDFInverse_M;}

SDFInverse_M::SDFInverse_M ()
{
	setDescriptor("Invert a square floating-point matrix.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));
	addState(rowsCols.setState("rowsCols",this,"2","The number of rows/columns of the input square matrix."));


}

void SDFInverse_M::go() {
# line 30 "SDFInverse_M.pl"
Envelope pkt;
          (input%0).getMessage(pkt);
          const FloatMatrix& matrix = *(const FloatMatrix *)pkt.myData();

          // check for "null" matrix inputs, caused by delays
          if(pkt.empty()) {
            // if input is empty, return a zero matrix with the given dimensions
            FloatMatrix& result = *(new FloatMatrix(int(rowsCols),int(rowsCols)));
            result = 0.0;
            output%0 << result;
          }
          else {
            if((matrix.numRows() != int(rowsCols)) ||
               (matrix.numCols() != int(rowsCols))) {
              Error::abortRun(*this,"Dimension size of FloatMatrix input does ",
                                    "not match the given state parameters.");
              return;
            }
            FloatMatrix& result = *(new FloatMatrix(int(rowsCols),int(rowsCols)));
            result = !matrix;        // invert the matrix
            output%0 << result;
          }
}

// prototype instance for known block list
static SDFInverse_M proto;
static RegisterBlock registerBlock(proto,"Inverse_M");
