static const char file_id[] = "SDFMatrix.pl";
// .cc file generated from SDFMatrix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMatrix.h"
#include "Matrix.h"

const char *star_nm_SDFMatrix = "SDFMatrix";

const char* SDFMatrix :: className() const {return star_nm_SDFMatrix;}

ISA_FUNC(SDFMatrix,SDFStar);

Block* SDFMatrix :: makeNew() const { LOG_NEW; return new SDFMatrix;}

SDFMatrix::SDFMatrix ()
{
	setDescriptor("Produce a matrix with floating-point entries. The entries are\nread from the array parameter \"FloatMatrixContents\" in rasterized order:\ni.e. for a MxN matrix, the first row is filled from left to right\nusing the first N values from the array.");
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));
	addState(FloatMatrixContents.setState("FloatMatrixContents",this,"1.0 -2.0 2.0 -2.0","The float contents of the matrix."));


}

void SDFMatrix::go() {
# line 43 "SDFMatrix.pl"
// collect inputs and put into the matrix
    FloatMatrix& matrix = *(new FloatMatrix(int(numRows),int(numCols),
                                            FloatMatrixContents));
    output%0 << matrix;
}

// prototype instance for known block list
static SDFMatrix proto;
static RegisterBlock registerBlock(proto,"Matrix");
