static const char file_id[] = "SDFMatrixCx.pl";
// .cc file generated from SDFMatrixCx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMatrixCx.h"
#include "Matrix.h"

const char *star_nm_SDFMatrixCx = "SDFMatrixCx";

const char* SDFMatrixCx :: className() const {return star_nm_SDFMatrixCx;}

ISA_FUNC(SDFMatrixCx,SDFStar);

Block* SDFMatrixCx :: makeNew() const { LOG_NEW; return new SDFMatrixCx;}

SDFMatrixCx::SDFMatrixCx ()
{
	setDescriptor("Produces a matrix with complex entries. The entries are\nread from the array parameter \"ComplexMatrixContents\" in rasterized order:\ni.e. for a MxN matrix, the first row is filled from left to right\nusing the first N values from the array.");
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));
	addState(ComplexMatrixContents.setState("ComplexMatrixContents",this,"(1,0) (0,1) (-1,0) (0,-1)","The complex contents of the matrix."));


}

void SDFMatrixCx::go() {
# line 43 "SDFMatrixCx.pl"
// collect inputs and put into the matrix
    ComplexMatrix& matrix = *(new ComplexMatrix(int(numRows),int(numCols),
                                                ComplexMatrixContents));
    output%0 << matrix;
}

// prototype instance for known block list
static SDFMatrixCx proto;
static RegisterBlock registerBlock(proto,"MatrixCx");
