static const char file_id[] = "SDFMatrixFix.pl";
// .cc file generated from SDFMatrixFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMatrixFix.h"
#include "Matrix.h"

const char *star_nm_SDFMatrixFix = "SDFMatrixFix";

const char* SDFMatrixFix :: className() const {return star_nm_SDFMatrixFix;}

ISA_FUNC(SDFMatrixFix,SDFStar);

Block* SDFMatrixFix :: makeNew() const { LOG_NEW; return new SDFMatrixFix;}

SDFMatrixFix::SDFMatrixFix ()
{
	setDescriptor("Generate a matrix with fixed-point entries.");
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));
	addState(FixMatrixContents.setState("FixMatrixContents",this,"1 -2 2 -2","The Fix contents of the matrix."));
	addState(FixPrecision.setState("FixPrecision",this,"8.14","Precision of all entries in the matrix."));


}

void SDFMatrixFix::go() {
# line 59 "SDFMatrixFix.pl"
// parse precision value
    precision = FixPrecision;
    length = Fix::get_length(precision);
    intbits = Fix::get_intBits(precision);

    // collect inputs and put into the matrix

    FixMatrix& matrix = *(new FixMatrix(int(numRows), int(numCols),
                                        length, intbits, FixMatrixContents));
    output%0 << matrix;
}

// prototype instance for known block list
static SDFMatrixFix proto;
static RegisterBlock registerBlock(proto,"MatrixFix");
