static const char file_id[] = "SDFMatrixInt.pl";
// .cc file generated from SDFMatrixInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMatrixInt.h"
#include "Matrix.h"

const char *star_nm_SDFMatrixInt = "SDFMatrixInt";

const char* SDFMatrixInt :: className() const {return star_nm_SDFMatrixInt;}

ISA_FUNC(SDFMatrixInt,SDFStar);

Block* SDFMatrixInt :: makeNew() const { LOG_NEW; return new SDFMatrixInt;}

SDFMatrixInt::SDFMatrixInt ()
{
	setDescriptor("Produces a matrix with integer entries. The entries are\nread from the array parameter \"IntMatrixContents\" in rasterized order:\ni.e. for a MxN matrix, the first row is filled from left to right\nusing the first N values from the array.");
	addPort(output.setPort("output",this,INT_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));
	addState(IntMatrixContents.setState("IntMatrixContents",this,"1 -2 2 -2","The integer contents of the matrix."));


}

void SDFMatrixInt::go() {
# line 43 "SDFMatrixInt.pl"
// collect inputs and put into the matrix
    IntMatrix& matrix = *(new IntMatrix(int(numRows),int(numCols),
                                        IntMatrixContents));
    output%0 << matrix;
}

// prototype instance for known block list
static SDFMatrixInt proto;
static RegisterBlock registerBlock(proto,"MatrixInt");
