static const char file_id[] = "SDFMpyScalarCx_M.pl";
// .cc file generated from SDFMpyScalarCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMpyScalarCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFMpyScalarCx_M = "SDFMpyScalarCx_M";

const char* SDFMpyScalarCx_M :: className() const {return star_nm_SDFMpyScalarCx_M;}

ISA_FUNC(SDFMpyScalarCx_M,SDFStar);

Block* SDFMpyScalarCx_M :: makeNew() const { LOG_NEW; return new SDFMpyScalarCx_M;}

SDFMpyScalarCx_M::SDFMpyScalarCx_M ()
{
	setDescriptor("Multiply a complex input matrix by a scalar input gain value.");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(gain.setPort("gain",this,COMPLEX));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));


}

void SDFMpyScalarCx_M::go() {
# line 29 "SDFMpyScalarCx_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do scalar * matrix
      ComplexMatrix& result = *(new ComplexMatrix(matrix.numRows(),matrix.numCols()));
      result = Complex(gain%0) * matrix;
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFMpyScalarCx_M proto;
static RegisterBlock registerBlock(proto,"MpyScalarCx_M");
