static const char file_id[] = "SDFMpyScalarFix_M.pl";
// .cc file generated from SDFMpyScalarFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMpyScalarFix_M.h"
#include "Matrix.h"

const char *star_nm_SDFMpyScalarFix_M = "SDFMpyScalarFix_M";

const char* SDFMpyScalarFix_M :: className() const {return star_nm_SDFMpyScalarFix_M;}

ISA_FUNC(SDFMpyScalarFix_M,SDFStar);

Block* SDFMpyScalarFix_M :: makeNew() const { LOG_NEW; return new SDFMpyScalarFix_M;}

SDFMpyScalarFix_M::SDFMpyScalarFix_M ()
{
	setDescriptor("Multiply a fixed-point matrix by a scalar input gain value.");
	addPort(input.setPort("input",this,FIX_MATRIX_ENV));
	addPort(gain.setPort("gain",this,FIX));
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));
	addState(UseArrivingPrecision.setState("UseArrivingPrecision",this,"YES","Flag indicated whether or not to use the arriving particles as they are:\nYES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"NewInputPrecision\"."));
	addState(NewInputPrecision.setState("NewInputPrecision",this,"2.14","New precision of the input in bits.  The input particles are only cast\nto this precision if the parameter \"UseArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.  This is the precision that will hold\nthe result of the arithmetic operation on the inputs."));
	addState(OverflowHandler.setState("OverflowHandler",this,"saturate","Overflow characteristic for the output.  If the result\nof the product cannot be fit into the precision of the output, overflow\noccurs and the overflow is taken care of by the method specified by this\nparameter.  The keywords for overflow handling methods are :\n\"saturate\"(default), \"zero_saturate\", \"wrapped\", \"warning\"."));


}

void SDFMpyScalarFix_M::setup() {
# line 73 "SDFMpyScalarFix_M.pl"
IP = NewInputPrecision;
    OP = OutputPrecision;
    OV = OverflowHandler;
    in_IntBits = Fix::get_intBits (IP);
    in_len = Fix::get_length (IP);
    out_IntBits = Fix::get_intBits (OP);
    out_len = Fix::get_length (OP);
}

void SDFMpyScalarFix_M::go() {
# line 83 "SDFMpyScalarFix_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FixMatrix& matrix = *(const FixMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      FixMatrix& result = *(new FixMatrix(matrix.numRows(),matrix.numCols(),
                                          out_len, out_IntBits));

      Fix fixIn;

      // do scalar * matrix
      for(int i = 0; i < (matrix.numRows() * matrix.numCols()); i++) {
        if(int(UseArrivingPrecision))
          fixIn = matrix.entry(i);
        else
          fixIn = Fix(in_len, in_IntBits, matrix.entry(i));
        result.entry(i).set_ovflow(OV);
        result.entry(i) = fixIn * Fix(gain%0);
      }

      output%0 << result;
    }
}

// prototype instance for known block list
static SDFMpyScalarFix_M proto;
static RegisterBlock registerBlock(proto,"MpyScalarFix_M");
