static const char file_id[] = "SDFMpyScalarInt_M.pl";
// .cc file generated from SDFMpyScalarInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMpyScalarInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFMpyScalarInt_M = "SDFMpyScalarInt_M";

const char* SDFMpyScalarInt_M :: className() const {return star_nm_SDFMpyScalarInt_M;}

ISA_FUNC(SDFMpyScalarInt_M,SDFStar);

Block* SDFMpyScalarInt_M :: makeNew() const { LOG_NEW; return new SDFMpyScalarInt_M;}

SDFMpyScalarInt_M::SDFMpyScalarInt_M ()
{
	setDescriptor("Multiply a integer input matrix by a scalar input gain value.");
	addPort(input.setPort("input",this,INT_MATRIX_ENV));
	addPort(gain.setPort("gain",this,INT));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));


}

void SDFMpyScalarInt_M::go() {
# line 29 "SDFMpyScalarInt_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const IntMatrix& matrix = *(const IntMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do scalar * matrix
      IntMatrix& result = *(new IntMatrix(matrix.numRows(),matrix.numCols()));
      result = int(gain%0) * matrix;
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFMpyScalarInt_M proto;
static RegisterBlock registerBlock(proto,"MpyScalarInt_M");
