static const char file_id[] = "SDFMpyScalar_M.pl";
// .cc file generated from SDFMpyScalar_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMpyScalar_M.h"
#include "Matrix.h"

const char *star_nm_SDFMpyScalar_M = "SDFMpyScalar_M";

const char* SDFMpyScalar_M :: className() const {return star_nm_SDFMpyScalar_M;}

ISA_FUNC(SDFMpyScalar_M,SDFStar);

Block* SDFMpyScalar_M :: makeNew() const { LOG_NEW; return new SDFMpyScalar_M;}

SDFMpyScalar_M::SDFMpyScalar_M ()
{
	setDescriptor("Multiply a floating-point input matrix by a scalar input gain value.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(gain.setPort("gain",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));


}

void SDFMpyScalar_M::go() {
# line 29 "SDFMpyScalar_M.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FloatMatrix& matrix = *(const FloatMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send it back out
      output%0 << inpkt;
    }
    else {
      // valid input matrix

      // do scalar * matrix
      FloatMatrix& result = *(new FloatMatrix(matrix.numRows(),matrix.numCols()));
      result = double(gain%0) * matrix;
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFMpyScalar_M proto;
static RegisterBlock registerBlock(proto,"MpyScalar_M");
