static const char file_id[] = "SDFPackCx_M.pl";
// .cc file generated from SDFPackCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFPackCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFPackCx_M = "SDFPackCx_M";

const char* SDFPackCx_M :: className() const {return star_nm_SDFPackCx_M;}

ISA_FUNC(SDFPackCx_M,SDFStar);

Block* SDFPackCx_M :: makeNew() const { LOG_NEW; return new SDFPackCx_M;}

SDFPackCx_M::SDFPackCx_M ()
{
	setDescriptor("Produces a matrix with complex value entries. The entries are\nread in from values in a sequence of complex valued particles\nin rasterized order, e.g. for a MxN matrix, the first row is \nfilled from left to right using the first N values from the \nfirst N particles.");
	addPort(input.setPort("input",this,COMPLEX));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));


}

void SDFPackCx_M::setup() {
# line 42 "SDFPackCx_M.pl"
input.setSDFParams(int(numRows)*int(numCols));
}

void SDFPackCx_M::go() {
# line 45 "SDFPackCx_M.pl"
// collect inputs and put into the matrix
    ComplexMatrix& matrix = *(new ComplexMatrix(int(numRows),int(numCols),input));
    output%0 << matrix;
}

// prototype instance for known block list
static SDFPackCx_M proto;
static RegisterBlock registerBlock(proto,"PackCx_M");
