static const char file_id[] = "SDFPackFix_M.pl";
// .cc file generated from SDFPackFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFPackFix_M.h"
#include "Matrix.h"

const char *star_nm_SDFPackFix_M = "SDFPackFix_M";

const char* SDFPackFix_M :: className() const {return star_nm_SDFPackFix_M;}

ISA_FUNC(SDFPackFix_M,SDFStar);

Block* SDFPackFix_M :: makeNew() const { LOG_NEW; return new SDFPackFix_M;}

SDFPackFix_M::SDFPackFix_M ()
{
	setDescriptor("Produces a matrix with fixed-point entries. The entries are\nread in from values in a sequence of fixed-point particles\nin rasterized order, e.g. for a MxN matrix, the first row is \nfilled from left to right using the first N values from the \nfirst N particles.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));


}

void SDFPackFix_M::setup() {
# line 42 "SDFPackFix_M.pl"
input.setSDFParams(int(numRows)*int(numCols));
}

void SDFPackFix_M::go() {
# line 45 "SDFPackFix_M.pl"
// collect inputs and put into the matrix
    FixMatrix& matrix = *(new FixMatrix(int(numRows),int(numCols),input));
    output%0 << matrix;
}

// prototype instance for known block list
static SDFPackFix_M proto;
static RegisterBlock registerBlock(proto,"PackFix_M");
