static const char file_id[] = "SDFPackInt_M.pl";
// .cc file generated from SDFPackInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFPackInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFPackInt_M = "SDFPackInt_M";

const char* SDFPackInt_M :: className() const {return star_nm_SDFPackInt_M;}

ISA_FUNC(SDFPackInt_M,SDFStar);

Block* SDFPackInt_M :: makeNew() const { LOG_NEW; return new SDFPackInt_M;}

SDFPackInt_M::SDFPackInt_M ()
{
	setDescriptor("Produces a matrix with integer value entries. The entries are\nread in from values in a sequence of integer particles\nin rasterized order, e.g. for a MxN matrix, the first row is \nfilled from left to right using the first N values from the\nfirst N particles.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));


}

void SDFPackInt_M::setup() {
# line 42 "SDFPackInt_M.pl"
input.setSDFParams(int(numRows)*int(numCols));
}

void SDFPackInt_M::go() {
# line 45 "SDFPackInt_M.pl"
// collect inputs and put into the matrix
    IntMatrix& matrix = *(new IntMatrix(int(numRows),int(numCols),input));
    output%0 << matrix;
}

// prototype instance for known block list
static SDFPackInt_M proto;
static RegisterBlock registerBlock(proto,"PackInt_M");
