static const char file_id[] = "SDFPack_M.pl";
// .cc file generated from SDFPack_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFPack_M.h"
#include "Matrix.h"

const char *star_nm_SDFPack_M = "SDFPack_M";

const char* SDFPack_M :: className() const {return star_nm_SDFPack_M;}

ISA_FUNC(SDFPack_M,SDFStar);

Block* SDFPack_M :: makeNew() const { LOG_NEW; return new SDFPack_M;}

SDFPack_M::SDFPack_M ()
{
	setDescriptor("Produce a matrix with floating-point entries constructed from\nfloating-point input values.  The inputs are put in the matrix\nin rasterized order, e.g. for a MxN matrix, the first row is \nfilled from left to right using the first N input values.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));


}

void SDFPack_M::setup() {
# line 41 "SDFPack_M.pl"
input.setSDFParams(int(numRows)*int(numCols));
}

void SDFPack_M::go() {
# line 44 "SDFPack_M.pl"
// collect inputs and put into the matrix
    FloatMatrix& matrix = *(new FloatMatrix(int(numRows),int(numCols),input));
    output%0 << matrix;
}

// prototype instance for known block list
static SDFPack_M proto;
static RegisterBlock registerBlock(proto,"Pack_M");
