static const char file_id[] = "SDFSampleMean.pl";
// .cc file generated from SDFSampleMean.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFSampleMean.h"
#include "Matrix.h"

const char *star_nm_SDFSampleMean = "SDFSampleMean";

const char* SDFSampleMean :: className() const {return star_nm_SDFSampleMean;}

ISA_FUNC(SDFSampleMean,SDFStar);

Block* SDFSampleMean :: makeNew() const { LOG_NEW; return new SDFSampleMean;}

SDFSampleMean::SDFSampleMean ()
{
	setDescriptor("Find the average amplitude of the components of the input matrix.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT));


}

void SDFSampleMean::go() {
# line 24 "SDFSampleMean.pl"
// get input
    Envelope inpkt;
    (input%0).getMessage(inpkt);
    const FloatMatrix& matrix = *(const FloatMatrix *)inpkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(inpkt.empty()) {
      // input empty, just send a zero out
      output%0 << 0;
    }
    else {
      // valid input matrix
      int dimension = matrix.numRows()*matrix.numCols();
      double result = 0;
      for (int i=0; i<dimension; i++) 
	result += matrix.entry(i);
      result /= dimension;
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFSampleMean proto;
static RegisterBlock registerBlock(proto,"SampleMean");
