static const char file_id[] = "SDFSubMxCx_M.pl";
// .cc file generated from SDFSubMxCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFSubMxCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFSubMxCx_M = "SDFSubMxCx_M";

const char* SDFSubMxCx_M :: className() const {return star_nm_SDFSubMxCx_M;}

ISA_FUNC(SDFSubMxCx_M,SDFStar);

Block* SDFSubMxCx_M :: makeNew() const { LOG_NEW; return new SDFSubMxCx_M;}

SDFSubMxCx_M::SDFSubMxCx_M ()
{
	setDescriptor("Find a submatrix of the input matrix.");
	addState(startRow.setState("startRow",this,"0","Starting row of the input matrix"));
	addState(startCol.setState("startCol",this,"0","Starting column of the input matrix"));
	addState(numRows.setState("numRows",this,"1","The number of rows for the desired submatrix"));
	addState(numCols.setState("numCols",this,"1","The number of columns for the desired submatrix"));
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));


}

void SDFSubMxCx_M::go() {
# line 48 "SDFSubMxCx_M.pl"
Envelope pkt;
		(input%0).getMessage(pkt);
		const ComplexMatrix& matrix = *(const ComplexMatrix*)pkt.myData();

                if ( int(startRow)+int(numRows) > matrix.numRows() ) {
                  Error::abortRun(*this, "Submatrix rows extend beyond ",
				  "the rows of input matrix.");
                  return;
                }
                if ( int(startCol)+int(numCols) > matrix.numCols() ) {
                  Error::abortRun(*this, "Submatrix columns extend beyond ",
                                  "the columns of input matrix.");
                  return;
                }

		// check for "null" matrix inputs, caused by delays
		if (pkt.empty()) {
		  // input empty, send out a zero matrix 
		  ComplexMatrix& result = *(new ComplexMatrix(int(numRows),int(numCols)));
		  Complex zero(0,0);
		  result = zero;
		  output%0 << result;
    		}
		else {
		  ComplexMatrix& result = *(new ComplexMatrix(int(numRows),int(numCols)));
		  for (int i=0; i<int(numRows);i++)
		    for (int j=0; j<int(numCols);j++)
                      result[i][j] = matrix[int(startRow)+i][int(startCol)+j];
		  output%0 << result;
		}
}

// prototype instance for known block list
static SDFSubMxCx_M proto;
static RegisterBlock registerBlock(proto,"SubMxCx_M");
