static const char file_id[] = "SDFSubMx_M.pl";
// .cc file generated from SDFSubMx_M.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFSubMx_M.h"
#include "Matrix.h"

const char *star_nm_SDFSubMx_M = "SDFSubMx_M";

const char* SDFSubMx_M :: className() const {return star_nm_SDFSubMx_M;}

ISA_FUNC(SDFSubMx_M,SDFStar);

Block* SDFSubMx_M :: makeNew() const { LOG_NEW; return new SDFSubMx_M;}

SDFSubMx_M::SDFSubMx_M ()
{
	setDescriptor("Find a submatrix of the input matrix.");
	addState(startRow.setState("startRow",this,"0","Starting row of the input matrix"));
	addState(startCol.setState("startCol",this,"0","Starting column of the input matrix"));
	addState(numRows.setState("numRows",this,"1","The number of rows for the desired submatrix"));
	addState(numCols.setState("numCols",this,"1","The number of columns for the desired submatrix"));
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));


}

void SDFSubMx_M::go() {
# line 48 "SDFSubMx_M.pl"
Envelope pkt;
		(input%0).getMessage(pkt);
		const FloatMatrix& matrix = *(const FloatMatrix*)pkt.myData();

                if ( int(startRow)+int(numRows) > matrix.numRows() ) {
		  Error::abortRun(*this,"Submatrix rows extend beyond "
					,"the rows of input matrix.");
		  return;
		}
                if ( int(startCol)+int(numCols) > matrix.numCols() ) {
                  Error::abortRun(*this,"Submatrix columns extend beyond "
                                        ,"the columns of input matrix.");
                  return;
                }

		// check for "null" matrix inputs, caused by delays
		if (pkt.empty()) {
		  // input empty, send out a zero matrix 
		  FloatMatrix& result = *(new FloatMatrix(int(numRows),int(numCols)));
		  result = 0;
		  output%0 << result;
    		}
		else {
		  FloatMatrix& result = *(new FloatMatrix(int(numRows),int(numCols)));
		  for (int i=0; i<int(numRows);i++)
		    for (int j=0; j<int(numCols);j++)
		      result[i][j] = matrix[int(startRow)+i][int(startCol)+j];
		  output%0 << result;
		}
}

// prototype instance for known block list
static SDFSubMx_M proto;
static RegisterBlock registerBlock(proto,"SubMx_M");
