static const char file_id[] = "SDFToeplitzCx_M.pl";
// .cc file generated from SDFToeplitzCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFToeplitzCx_M.h"

const char *star_nm_SDFToeplitzCx_M = "SDFToeplitzCx_M";

const char* SDFToeplitzCx_M :: className() const {return star_nm_SDFToeplitzCx_M;}

ISA_FUNC(SDFToeplitzCx_M,SDFStar);

Block* SDFToeplitzCx_M :: makeNew() const { LOG_NEW; return new SDFToeplitzCx_M;}

SDFToeplitzCx_M::SDFToeplitzCx_M ()
{
	setDescriptor("Put a sequence of complex-valued samples into a rectangular Toeplitz matrix.");
	addState(numRows.setState("numRows",this,"2","Number of rows in X."));
	addState(numCols.setState("numCols",this,"2","Number of columns in X."));
	addPort(input.setPort("input",this,COMPLEX));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));


}

void SDFToeplitzCx_M::setup() {
# line 54 "SDFToeplitzCx_M.pl"
input.setSDFParams(int(numRows) + int(numCols) - 1);
}

void SDFToeplitzCx_M::go() {
# line 58 "SDFToeplitzCx_M.pl"
int numrows = int(numRows);
	int numcols = int(numCols);

        // collect inputs and put into the matrix
        ComplexMatrix& X = *(new ComplexMatrix(numrows, numcols));

	for (int i = 0; i < numrows; i++) {
            int k = numrows - i - 1;
	    for (int j = 0; j < numcols; j++, k++)
		X[i][j] = Complex(input%k);
        }

	// Output X
        output%0 << X;
}

// prototype instance for known block list
static SDFToeplitzCx_M proto;
static RegisterBlock registerBlock(proto,"ToeplitzCx_M");
