static const char file_id[] = "SDFToeplitzFix_M.pl";
// .cc file generated from SDFToeplitzFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFToeplitzFix_M.h"

const char *star_nm_SDFToeplitzFix_M = "SDFToeplitzFix_M";

const char* SDFToeplitzFix_M :: className() const {return star_nm_SDFToeplitzFix_M;}

ISA_FUNC(SDFToeplitzFix_M,SDFStar);

Block* SDFToeplitzFix_M :: makeNew() const { LOG_NEW; return new SDFToeplitzFix_M;}

SDFToeplitzFix_M::SDFToeplitzFix_M ()
{
	setDescriptor("Put a sequence of fixed-point samples into a rectangular Toeplitz matrix.");
	addState(numRows.setState("numRows",this,"2","Number of rows in X."));
	addState(numCols.setState("numCols",this,"2","Number of columns in X."));
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));


}

void SDFToeplitzFix_M::setup() {
# line 54 "SDFToeplitzFix_M.pl"
input.setSDFParams(int(numRows)+int(numCols)-1);
}

void SDFToeplitzFix_M::go() {
# line 58 "SDFToeplitzFix_M.pl"
int numrows = int(numRows);
	int numcols = int(numCols);

        // collect inputs and put into the matrix
        FixMatrix& X = *(new FixMatrix(numrows, numcols));

	for (int i = 0; i < numrows; i++) {
            int k = numrows - i - 1;
	    for (int j = 0; j < numcols; j++, k++)
		X[i][j] = Fix(input%k);
        }

	// Output X
        output%0 << X;
}

// prototype instance for known block list
static SDFToeplitzFix_M proto;
static RegisterBlock registerBlock(proto,"ToeplitzFix_M");
