static const char file_id[] = "SDFToeplitzInt_M.pl";
// .cc file generated from SDFToeplitzInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFToeplitzInt_M.h"

const char *star_nm_SDFToeplitzInt_M = "SDFToeplitzInt_M";

const char* SDFToeplitzInt_M :: className() const {return star_nm_SDFToeplitzInt_M;}

ISA_FUNC(SDFToeplitzInt_M,SDFStar);

Block* SDFToeplitzInt_M :: makeNew() const { LOG_NEW; return new SDFToeplitzInt_M;}

SDFToeplitzInt_M::SDFToeplitzInt_M ()
{
	setDescriptor("Put a sequence of integer-valued samples into a rectangular Toeplitz matrix.");
	addState(numRows.setState("numRows",this,"2","Number of rows in X."));
	addState(numCols.setState("numCols",this,"2","Number of columns in X."));
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));


}

void SDFToeplitzInt_M::setup() {
# line 54 "SDFToeplitzInt_M.pl"
input.setSDFParams(int(numRows)+int(numCols)-1);
}

void SDFToeplitzInt_M::go() {
# line 58 "SDFToeplitzInt_M.pl"
int numrows = int(numRows);
	int numcols = int(numCols);

        // collect inputs and put into the matrix
        IntMatrix& X = *(new IntMatrix(numrows, numcols));

	for (int i = 0; i < numrows; i++) {
            int k = numrows - i - 1;
	    for (int j = 0; j < numcols; j++, k++)
		X[i][j] = input%k;
        }

	// Output X
        output%0 << X;
}

// prototype instance for known block list
static SDFToeplitzInt_M proto;
static RegisterBlock registerBlock(proto,"ToeplitzInt_M");
