static const char file_id[] = "SDFToeplitz_M.pl";
// .cc file generated from SDFToeplitz_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFToeplitz_M.h"

const char *star_nm_SDFToeplitz_M = "SDFToeplitz_M";

const char* SDFToeplitz_M :: className() const {return star_nm_SDFToeplitz_M;}

ISA_FUNC(SDFToeplitz_M,SDFStar);

Block* SDFToeplitz_M :: makeNew() const { LOG_NEW; return new SDFToeplitz_M;}

SDFToeplitz_M::SDFToeplitz_M ()
{
	setDescriptor("Put a sequence of real-valued samples into a rectangular Toeplitz matrix.");
	addState(numRows.setState("numRows",this,"2","Number of rows in X."));
	addState(numCols.setState("numCols",this,"2","Number of columns in X."));
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));


}

void SDFToeplitz_M::setup() {
# line 54 "SDFToeplitz_M.pl"
input.setSDFParams(int(numRows)+int(numCols)-1);
}

void SDFToeplitz_M::go() {
# line 58 "SDFToeplitz_M.pl"
int numrows = int(numRows);
	int numcols = int(numCols);

        // collect inputs and put into the matrix
        FloatMatrix& X = *(new FloatMatrix(numrows, numcols));

	for (int i = 0; i < numrows; i++) {
            int k = numrows - i - 1;
	    for (int j = 0; j < numcols; j++, k++)
		X[i][j] = input%k;
        }

	// Output X
        output%0 << X;
}

// prototype instance for known block list
static SDFToeplitz_M proto;
static RegisterBlock registerBlock(proto,"Toeplitz_M");
