static const char file_id[] = "SDFTransposeCx_M.pl";
// .cc file generated from SDFTransposeCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTransposeCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFTransposeCx_M = "SDFTransposeCx_M";

const char* SDFTransposeCx_M :: className() const {return star_nm_SDFTransposeCx_M;}

ISA_FUNC(SDFTransposeCx_M,SDFStar);

Block* SDFTransposeCx_M :: makeNew() const { LOG_NEW; return new SDFTransposeCx_M;}

SDFTransposeCx_M::SDFTransposeCx_M ()
{
	setDescriptor("Transpose a complex matrix read as a single particle.");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input matrix."));


}

void SDFTransposeCx_M::go() {
# line 36 "SDFTransposeCx_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // input empty, send out a zero matrix with the dimensions transposed
      ComplexMatrix& result = *(new ComplexMatrix(int(numCols),int(numRows)));
      result = Complex(0.0,0.0);
      output%0 << result;
    }
    else {
      // valid input matrix

      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
        Error::abortRun(*this,"Dimension size of ComplexMatrix input does ",
                              "not match the given state parameters.");
        return;
      }
      ComplexMatrix& result = *(new ComplexMatrix(int(numCols),int(numRows)));
      result = ~matrix;           // equivalent to matrix.transpose()
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFTransposeCx_M proto;
static RegisterBlock registerBlock(proto,"TransposeCx_M");
