static const char file_id[] = "SDFTransposeFix_M.pl";
// .cc file generated from SDFTransposeFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTransposeFix_M.h"
#include "Matrix.h"

const char *star_nm_SDFTransposeFix_M = "SDFTransposeFix_M";

const char* SDFTransposeFix_M :: className() const {return star_nm_SDFTransposeFix_M;}

ISA_FUNC(SDFTransposeFix_M,SDFStar);

Block* SDFTransposeFix_M :: makeNew() const { LOG_NEW; return new SDFTransposeFix_M;}

SDFTransposeFix_M::SDFTransposeFix_M ()
{
	setDescriptor("Transpose a fixed-point matrix read as a single particle.");
	addPort(input.setPort("input",this,FIX_MATRIX_ENV));
	addPort(output.setPort("output",this,FIX_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input matrix."));


}

void SDFTransposeFix_M::go() {
# line 36 "SDFTransposeFix_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const FixMatrix& matrix = *(const FixMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // input empty, send out a zero matrix with the dimensions transposed
      FixMatrix& result = *(new FixMatrix(int(numCols),int(numRows)));
      result = Fix(double(0));
      output%0 << result;
    }
    else {
      // valid input matrix

      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
        Error::abortRun(*this,"Dimension size of FixMatrix input does ",
                              "not match the given state parameters.");
        return;
      }
      FixMatrix& result = *(new FixMatrix(int(numCols),int(numRows)));
      result = ~matrix;             // equivalent to matrix.transpose()
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFTransposeFix_M proto;
static RegisterBlock registerBlock(proto,"TransposeFix_M");
