static const char file_id[] = "SDFTransposeInt_M.pl";
// .cc file generated from SDFTransposeInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTransposeInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFTransposeInt_M = "SDFTransposeInt_M";

const char* SDFTransposeInt_M :: className() const {return star_nm_SDFTransposeInt_M;}

ISA_FUNC(SDFTransposeInt_M,SDFStar);

Block* SDFTransposeInt_M :: makeNew() const { LOG_NEW; return new SDFTransposeInt_M;}

SDFTransposeInt_M::SDFTransposeInt_M ()
{
	setDescriptor("Transpose an integer matrix read as a single particle.");
	addPort(input.setPort("input",this,INT_MATRIX_ENV));
	addPort(output.setPort("output",this,INT_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input matrix."));


}

void SDFTransposeInt_M::go() {
# line 36 "SDFTransposeInt_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const IntMatrix& matrix = *(const IntMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // input empty, send out a zero matrix with the dimensions transposed
      IntMatrix& result = *(new IntMatrix(int(numCols),int(numRows)));
      result = 0;
      output%0 << result;
    }
    else {
      // valid input matrix

      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
        Error::abortRun(*this,"Dimension size of IntMatrix input does ",
                              "not match the given state parameters.");
        return;
      }
      IntMatrix& result = *(new IntMatrix(int(numCols),int(numRows)));
      result = ~matrix;           // equivalent to matrix.transpose()
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFTransposeInt_M proto;
static RegisterBlock registerBlock(proto,"TransposeInt_M");
