static const char file_id[] = "SDFTranspose_M.pl";
// .cc file generated from SDFTranspose_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTranspose_M.h"
#include "Matrix.h"

const char *star_nm_SDFTranspose_M = "SDFTranspose_M";

const char* SDFTranspose_M :: className() const {return star_nm_SDFTranspose_M;}

ISA_FUNC(SDFTranspose_M,SDFStar);

Block* SDFTranspose_M :: makeNew() const { LOG_NEW; return new SDFTranspose_M;}

SDFTranspose_M::SDFTranspose_M ()
{
	setDescriptor("Transpose a floating-point matrix read as a single particle.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT_MATRIX_ENV));
	addState(numRows.setState("numRows",this,"2","The number of rows in the input matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the input matrix."));


}

void SDFTranspose_M::go() {
# line 36 "SDFTranspose_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const FloatMatrix& matrix = *(const FloatMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // input empty, send out a zero matrix with the dimensions transposed
      FloatMatrix& result = *(new FloatMatrix(int(numCols),int(numRows)));
      result = 0;
      output%0 << result;
    }
    else {
      // valid input matrix

      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
        Error::abortRun(*this,"Dimension size of FloatMatrix input does ",
                              "not match the given state parameters.");
        return;
      }
      FloatMatrix& result = *(new FloatMatrix(int(numCols),int(numRows)));
      result = ~matrix;              // equivalent to matrix.transpose()
      output%0 << result;
    }
}

// prototype instance for known block list
static SDFTranspose_M proto;
static RegisterBlock registerBlock(proto,"Transpose_M");
