static const char file_id[] = "SDFUnPkCx_M.pl";
// .cc file generated from SDFUnPkCx_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFUnPkCx_M.h"
#include "Matrix.h"

const char *star_nm_SDFUnPkCx_M = "SDFUnPkCx_M";

const char* SDFUnPkCx_M :: className() const {return star_nm_SDFUnPkCx_M;}

ISA_FUNC(SDFUnPkCx_M,SDFStar);

Block* SDFUnPkCx_M :: makeNew() const { LOG_NEW; return new SDFUnPkCx_M;}

SDFUnPkCx_M::SDFUnPkCx_M ()
{
	setDescriptor("Read a complex matrix and output its elements, row by row.");
	addPort(input.setPort("input",this,COMPLEX_MATRIX_ENV));
	addPort(output.setPort("output",this,COMPLEX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));


}

void SDFUnPkCx_M::setup() {
# line 39 "SDFUnPkCx_M.pl"
size = int(numRows)*int(numCols);
    output.setSDFParams(size);
}

void SDFUnPkCx_M::go() {
# line 43 "SDFUnPkCx_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const ComplexMatrix& matrix = *(const ComplexMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // input empty, just send a stream of (numRows*numCols) zeros
      for(int i = 0; i < int(numRows)*int(numCols); i++)
        output%i << Complex(0,0);
    }
    else {
      // valid input matrix

      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
          Error::abortRun(*this,"Dimension of ComplexMatrix received does ",
                                "not match the given state parameters.");
          return;
      }
      for(int i = 0; i < size; i++)
        output%(size - i - 1) << matrix.entry(i);
    }
}

// prototype instance for known block list
static SDFUnPkCx_M proto;
static RegisterBlock registerBlock(proto,"UnPkCx_M");
