static const char file_id[] = "SDFUnPkFix_M.pl";
// .cc file generated from SDFUnPkFix_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFUnPkFix_M.h"
#include "Matrix.h"

const char *star_nm_SDFUnPkFix_M = "SDFUnPkFix_M";

const char* SDFUnPkFix_M :: className() const {return star_nm_SDFUnPkFix_M;}

ISA_FUNC(SDFUnPkFix_M,SDFStar);

Block* SDFUnPkFix_M :: makeNew() const { LOG_NEW; return new SDFUnPkFix_M;}

SDFUnPkFix_M::SDFUnPkFix_M ()
{
	setDescriptor("Read a fixed-point matrix and output its elements, row by row.");
	addPort(input.setPort("input",this,FIX_MATRIX_ENV));
	addPort(output.setPort("output",this,FIX));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));


}

void SDFUnPkFix_M::setup() {
# line 39 "SDFUnPkFix_M.pl"
size = int(numRows)*int(numCols);
    output.setSDFParams(size);
}

void SDFUnPkFix_M::go() {
# line 43 "SDFUnPkFix_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const FixMatrix& matrix = *(const FixMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // input empty, just send a stream of (numRows*numCols) zeros
      for(int i = 0; i < int(numRows)*int(numCols); i++)
        output%i << Fix(double(0));
    }
    else {
      // valid input matrix

      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
          Error::abortRun(*this,"Dimension size of FixMatrix received does ",
                                "not match the given state parameters.");
          return;
      }
      for(int i = 0; i < size; i++)
        output%(size - i - 1) << matrix.entry(i);
    }
}

// prototype instance for known block list
static SDFUnPkFix_M proto;
static RegisterBlock registerBlock(proto,"UnPkFix_M");
