static const char file_id[] = "SDFUnPkInt_M.pl";
// .cc file generated from SDFUnPkInt_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFUnPkInt_M.h"
#include "Matrix.h"

const char *star_nm_SDFUnPkInt_M = "SDFUnPkInt_M";

const char* SDFUnPkInt_M :: className() const {return star_nm_SDFUnPkInt_M;}

ISA_FUNC(SDFUnPkInt_M,SDFStar);

Block* SDFUnPkInt_M :: makeNew() const { LOG_NEW; return new SDFUnPkInt_M;}

SDFUnPkInt_M::SDFUnPkInt_M ()
{
	setDescriptor("Read an integer matrix and output its elements, row by row.");
	addPort(input.setPort("input",this,INT_MATRIX_ENV));
	addPort(output.setPort("output",this,INT));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));


}

void SDFUnPkInt_M::setup() {
# line 39 "SDFUnPkInt_M.pl"
size = int(numRows)*int(numCols);
    output.setSDFParams(size);
}

void SDFUnPkInt_M::go() {
# line 43 "SDFUnPkInt_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const IntMatrix& matrix = *(const IntMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // input empty, just send a stream of (numRows*numCols) zeros
      for(int i = 0; i < int(numRows)*int(numCols); i++)
        output%i << 0;
    }
    else {
      // valid input matrix

      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
          Error::abortRun(*this,"Dimension size of IntMatrix received does ",
                                "not match the given state parameters.");
          return;
      }
      for(int i = 0; i < size; i++)
        output%(size - i - 1) << matrix.entry(i);
    }
}

// prototype instance for known block list
static SDFUnPkInt_M proto;
static RegisterBlock registerBlock(proto,"UnPkInt_M");
