static const char file_id[] = "SDFUnPk_M.pl";
// .cc file generated from SDFUnPk_M.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFUnPk_M.h"
#include "Matrix.h"

const char *star_nm_SDFUnPk_M = "SDFUnPk_M";

const char* SDFUnPk_M :: className() const {return star_nm_SDFUnPk_M;}

ISA_FUNC(SDFUnPk_M,SDFStar);

Block* SDFUnPk_M :: makeNew() const { LOG_NEW; return new SDFUnPk_M;}

SDFUnPk_M::SDFUnPk_M ()
{
	setDescriptor("Read a floating-point matrix and output its elements, row by row.");
	addPort(input.setPort("input",this,FLOAT_MATRIX_ENV));
	addPort(output.setPort("output",this,FLOAT));
	addState(numRows.setState("numRows",this,"2","The number of rows in the matrix."));
	addState(numCols.setState("numCols",this,"2","The number of columns in the matrix."));


}

void SDFUnPk_M::setup() {
# line 39 "SDFUnPk_M.pl"
size = int(numRows)*int(numCols);
    output.setSDFParams(size);
}

void SDFUnPk_M::go() {
# line 43 "SDFUnPk_M.pl"
Envelope pkt;
    (input%0).getMessage(pkt);
    const FloatMatrix& matrix = *(const FloatMatrix *)pkt.myData();

    // check for "null" matrix inputs, caused by delays
    if(pkt.empty()) {
      // input empty, just send a stream of (numRows*numCols) zeros
      for(int i = 0; i < int(numRows)*int(numCols); i++)
        output%i << 0.0;
    }
    else {
      // valid input matrix

      if((matrix.numRows() != int(numRows)) ||
         (matrix.numCols() != int(numCols))) {
        Error::abortRun(*this,"Dimension size of FloatMatrix received does ",
                              "not match the given state parameters.");
        return;
      }
      for(int i = 0; i < size; i++)
        output%(size - i - 1) << matrix.entry(i);
    }
}

// prototype instance for known block list
static SDFUnPk_M proto;
static RegisterBlock registerBlock(proto,"UnPk_M");
