static const char file_id[] = "SDFAdaptLinQuant.pl";
// .cc file generated from SDFAdaptLinQuant.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFAdaptLinQuant.h"

const char *star_nm_SDFAdaptLinQuant = "SDFAdaptLinQuant";

const char* SDFAdaptLinQuant :: className() const {return star_nm_SDFAdaptLinQuant;}

ISA_FUNC(SDFAdaptLinQuant,SDFStar);

Block* SDFAdaptLinQuant :: makeNew() const { LOG_NEW; return new SDFAdaptLinQuant;}

SDFAdaptLinQuant::SDFAdaptLinQuant ()
{
	setDescriptor("Uniform linear quantizer symmetric about 0 with variable step size.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(inStep.setPort("inStep",this,FLOAT));
	addPort(amplitude.setPort("amplitude",this,FLOAT));
	addPort(outStep.setPort("outStep",this,FLOAT));
	addPort(stepLevel.setPort("stepLevel",this,INT));
	addState(bits.setState("bits",this,"","bits"));


}

void SDFAdaptLinQuant::go() {
# line 54 "SDFAdaptLinQuant.pl"
// check the current value of the stepsize
		double stepsize = double(inStep%0);
		if ( stepsize <= 0.0 ) {
			Error::abortRun(*this, "Non-positive step size");
		}

		// high threshold is ((2^B - 1)/2) * stepsize; low = -high
		// where B is the number of bits
		int numbits = int(bits);
		int twoPowerB = (1 << numbits);
		double high = double(twoPowerB - 1) * stepsize / 2.0;
		double low = -high;

		// compute the quantized output
	    	double in = input%0;
		int quantlevel = 0;
	    	if ( in >= high ) {
			quantlevel = twoPowerB - 1;
			amplitude%0 << high;
		}
		else if (in <= low) {
			quantlevel = 0;
			amplitude%0 << low;
		}
		else {
			quantlevel = int((in-low)/stepsize + 0.5);
        		amplitude%0 << double(low + quantlevel*stepsize);
		}

		outStep%0 << stepsize;
		stepLevel%0 << quantlevel;
}

// prototype instance for known block list
static SDFAdaptLinQuant proto;
static RegisterBlock registerBlock(proto,"AdaptLinQuant");
