static const char file_id[] = "SDFAddFix.pl";
// .cc file generated from SDFAddFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFAddFix.h"

const char *star_nm_SDFAddFix = "SDFAddFix";

const char* SDFAddFix :: className() const {return star_nm_SDFAddFix;}

ISA_FUNC(SDFAddFix,SDFFix);

Block* SDFAddFix :: makeNew() const { LOG_NEW; return new SDFAddFix;}

SDFAddFix::SDFAddFix ()
{
	setDescriptor("Output the sum of the fixed-point inputs as a fixed-point value.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag that indicates whether or not to keep the precision of the arriving\nparticles as is:  YES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the input in bits.\nThe input particles are only cast to this precision if the\nparameter \"ArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits and precision of the accumulation.\nWhen the value of the accumulation extends outside of the precision,\nthe OverflowHandler will be called."));


}

void SDFAddFix::setup() {
# line 58 "SDFAddFix.pl"
SDFFix::setup();

                if ( ! int(ArrivingPrecision) ) {
		  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );

		sum = Fix( ((const char *) OutputPrecision) );
		if ( sum.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
		sum.set_ovflow( ((const char *) OverflowHandler) );
		if ( sum.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		sum.set_rounding( int(RoundFix) );
}

void SDFAddFix::go() {
# line 76 "SDFAddFix.pl"
MPHIter nexti(input);
                PortHole *p;

		// Fixed-point class in Ptolemy 0.5 can always represent 0.0
		sum.setToZero();	// set to zero and clear error bits
                while ((p = nexti++) != 0) {
                  if ( int(ArrivingPrecision) )
                    sum += (Fix)((*p)%0);
		  else {
                    fixIn = (Fix)((*p)%0);
                    sum += fixIn;
		  }
		  checkOverflow(sum);
		}
                output%0 << sum;
}

// prototype instance for known block list
static SDFAddFix proto;
static RegisterBlock registerBlock(proto,"AddFix");
