static const char file_id[] = "SDFAverage.pl";
// .cc file generated from SDFAverage.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFAverage.h"

const char *star_nm_SDFAverage = "SDFAverage";

const char* SDFAverage :: className() const {return star_nm_SDFAverage;}

ISA_FUNC(SDFAverage,SDFStar);

Block* SDFAverage :: makeNew() const { LOG_NEW; return new SDFAverage;}

SDFAverage::SDFAverage ()
{
	setDescriptor("Average some number of input samples or blocks of input samples.\nBlocks of successive input samples are treated as vectors.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(numInputsToAverage.setState("numInputsToAverage",this,"8","The number of input samples or blocks to average."));
	addState(blockSize.setState("blockSize",this,"1","Input blocks of this size will be averaged to produce an output block."));


}

void SDFAverage::setup() {
# line 40 "SDFAverage.pl"
input.setSDFParams(int(blockSize)*int(numInputsToAverage),
			int(blockSize)*int(numInputsToAverage)-1);
		output.setSDFParams(int(blockSize), int(blockSize)-1);
}

void SDFAverage::go() {
# line 45 "SDFAverage.pl"
for(int i=int(blockSize)-1; i >= 0; i-- ) {
		double avg = 0.0;
		for(int j=int(numInputsToAverage)-1; j >= 0; j-- ) {
		    avg += double(input%(j*int(blockSize)+i));
		}
		output%i << avg/int(numInputsToAverage);
	    }
}

// prototype instance for known block list
static SDFAverage proto;
static RegisterBlock registerBlock(proto,"Average");
