static const char file_id[] = "SDFAverageCx.pl";
// .cc file generated from SDFAverageCx.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFAverageCx.h"

const char *star_nm_SDFAverageCx = "SDFAverageCx";

const char* SDFAverageCx :: className() const {return star_nm_SDFAverageCx;}

ISA_FUNC(SDFAverageCx,SDFStar);

Block* SDFAverageCx :: makeNew() const { LOG_NEW; return new SDFAverageCx;}

SDFAverageCx::SDFAverageCx ()
{
	setDescriptor("Average some number of complex input samples or blocks of complex\ninput samples. Blocks of successive input samples are treated as vectors.");
	addPort(input.setPort("input",this,COMPLEX));
	addPort(output.setPort("output",this,COMPLEX));
	addState(numInputsToAverage.setState("numInputsToAverage",this,"8","The number of input samples or blocks to average."));
	addState(blockSize.setState("blockSize",this,"1","Input blocks of this size will be averaged to produce an output block."));


}

void SDFAverageCx::setup() {
# line 40 "SDFAverageCx.pl"
input.setSDFParams(int(blockSize)*int(numInputsToAverage),
			int(blockSize)*int(numInputsToAverage)-1);
		output.setSDFParams(int(blockSize), int(blockSize)-1);
}

void SDFAverageCx::go() {
# line 45 "SDFAverageCx.pl"
for(int i=int(blockSize)-1; i >= 0; i-- ) {
		Complex avg = Complex(0.0);
		for(int j=int(numInputsToAverage)-1; j >= 0; j-- ) {
		    avg += Complex(input%(j*int(blockSize)+i));
		}
		output%i << Complex(real(avg)/int(numInputsToAverage),
				    imag(avg)/int(numInputsToAverage));
	    }
}

// prototype instance for known block list
static SDFAverageCx proto;
static RegisterBlock registerBlock(proto,"AverageCx");
