static const char file_id[] = "SDFBitsToInt.pl";
// .cc file generated from SDFBitsToInt.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFBitsToInt.h"

const char *star_nm_SDFBitsToInt = "SDFBitsToInt";

const char* SDFBitsToInt :: className() const {return star_nm_SDFBitsToInt;}

ISA_FUNC(SDFBitsToInt,SDFStar);

Block* SDFBitsToInt :: makeNew() const { LOG_NEW; return new SDFBitsToInt;}

SDFBitsToInt::SDFBitsToInt ()
{
	setDescriptor("The integer input sequence is interpreted as a bit stream in which any nonzero\nvalue is interpreted as to mean a \"one\" bit.\nThis star consumes \"nBits\" successive bits from the input,\npacks them into an integer, and outputs the resulting integer.\nThe first received bit becomes the most significant bit of the output.\nIf \"nBits\" is larger than the integer word size, then the first bits\nreceived will be lost.\nIf \"nBits\" is smaller than the wordsize minus one, then the\noutput integer will always be non-negative.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(nBits.setState("nBits",this,"4","number of bits read per execution"));


}

void SDFBitsToInt::setup() {
# line 39 "SDFBitsToInt.pl"
if (int(nBits) < 0) {
			Error::abortRun(*this, "nBits must be positive");
			return;
		}
		input.setSDFParams(int(nBits),int(nBits)-1);
}

void SDFBitsToInt::go() {
# line 46 "SDFBitsToInt.pl"
int o = 0;
		for (int i = int(nBits) - 1; i >= 0; i--) {
			// shift new bits into the "shift register"
			o <<= 1;
			int b = int(input%i) ? 1 : 0;
			o += b;
		}
		output%0 << o;
}

// prototype instance for known block list
static SDFBitsToInt proto;
static RegisterBlock registerBlock(proto,"BitsToInt");
