static const char file_id[] = "SDFBusToNum.pl";
// .cc file generated from SDFBusToNum.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFBusToNum.h"

const char *star_nm_SDFBusToNum = "SDFBusToNum";

const char* SDFBusToNum :: className() const {return star_nm_SDFBusToNum;}

ISA_FUNC(SDFBusToNum,SDFStar);

Block* SDFBusToNum :: makeNew() const { LOG_NEW; return new SDFBusToNum;}

SDFBusToNum::SDFBusToNum ()
{
	setDescriptor("This star accepts a number of input bit streams, where this number should not\nexceed the wordsize of an integer.  Each bit stream has integer particles with\nvalues 0, 3, or anything else.  These are interpreted as binary 0, tri-state,\nor 1, respectively.  When the star fires, it reads one input bit from each \ninput.\nIf any of the input bits is tri-stated, the output will be the previous output\n(or the initial value of the \"previous\" parameter if the firing is the first \none).\nOtherwise, the bits are assembled into an integer word, assuming two's \ncomplement encoding, and sign extended.  The resulting signed integer is sent \nto the output.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(previous.setState("previous",this,"0","previous value of output"));

# line 44 "SDFBusToNum.pl"
bits = 0;
		binary = 0;
}

SDFBusToNum::~SDFBusToNum() {
# line 48 "SDFBusToNum.pl"
delete [] binary;
}

void SDFBusToNum::setup() {
# line 51 "SDFBusToNum.pl"
bits = input.numberPorts();	
		delete [] binary;
		binary = new int[bits];
}

void SDFBusToNum::go() {
# line 56 "SDFBusToNum.pl"
MPHIter nexti(input);

		for (int i = 0; i < bits; i++) {
			binary[i]= (*nexti++)%0;
		}

		for (i = 0; i < bits; i++) {
			// The following is a Thor-specific condition check
			// where we do not want the number to be latched in
			// if the bus is tristate (value 3)
			if ( binary[i] == 3 ) {
				output%0 << int(previous); 
				return; 
			}
		}

		int number = binary[bits-1] ? -1 : 0;
		for(i = bits - 2; i >= 0; i--) {
			number <<= 1;
			int d = binary[i] ? 1 : 0;
			number += d;
		}

		previous = number;
		output%0 << number;
}

// prototype instance for known block list
static SDFBusToNum proto;
static RegisterBlock registerBlock(proto,"BusToNum");
