static const char file_id[] = "SDFCommutator.pl";
// .cc file generated from SDFCommutator.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFCommutator.h"

const char *star_nm_SDFCommutator = "SDFCommutator";

const char* SDFCommutator :: className() const {return star_nm_SDFCommutator;}

ISA_FUNC(SDFCommutator,SDFStar);

Block* SDFCommutator :: makeNew() const { LOG_NEW; return new SDFCommutator;}

SDFCommutator::SDFCommutator ()
{
	setDescriptor("Takes N input streams (where N is the number of inputs) and\nsynchronously combines them into one output stream.\nIt consumes B input particles from each\ninput (where B is the blockSize), and produces N*B particles on the\noutput.\nThe first B particles on the output come from the first input,\nthe next B particles from the next input, etc.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));


}

void SDFCommutator::setup() {
# line 37 "SDFCommutator.pl"
int n = input.numberPorts();
		input.setSDFParams(int(blockSize),int(blockSize)-1);
		output.setSDFParams(n*int(blockSize),n*int(blockSize)-1);
}

void SDFCommutator::go() {
# line 42 "SDFCommutator.pl"
MPHIter nexti(input);
		PortHole* p;
		for (int i = input.numberPorts()-1; i >= 0; i--) {
		    p = nexti++;
		    for (int j = int(blockSize)-1; j >= 0; j--)
			output%(j+i*int(blockSize)) = (*p)%j;
		    }
}

// prototype instance for known block list
static SDFCommutator proto;
static RegisterBlock registerBlock(proto,"Commutator");
