static const char file_id[] = "SDFCxToFix.pl";
// .cc file generated from SDFCxToFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFCxToFix.h"

const char *star_nm_SDFCxToFix = "SDFCxToFix";

const char* SDFCxToFix :: className() const {return star_nm_SDFCxToFix;}

ISA_FUNC(SDFCxToFix,SDFFix);

Block* SDFCxToFix :: makeNew() const { LOG_NEW; return new SDFCxToFix;}

SDFCxToFix::SDFCxToFix ()
{
	setDescriptor("Convert a complex input to a fixed-point output.");
	addPort(input.setPort("input",this,COMPLEX));
	addPort(output.setPort("output",this,FIX));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output, in bits.\nThe complex number is cast to a double and then converted to this precision.\nIf the value of the double cannot be represented by the number of bits\nspecified in the precision parameter, then a error message is given."));


}

void SDFCxToFix::setup() {
# line 40 "SDFCxToFix.pl"
SDFFix::setup();

		out = Fix( ((const char *) OutputPrecision) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
		out.set_ovflow( ((const char *) OverflowHandler) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		out.set_rounding( int(RoundFix) );
}

void SDFCxToFix::go() {
# line 51 "SDFCxToFix.pl"
out = double(input%0);
		checkOverflow(out);
		output%0 << out;
}

// prototype instance for known block list
static SDFCxToFix proto;
static RegisterBlock registerBlock(proto,"CxToFix");
