static const char file_id[] = "SDFDB.pl";
// .cc file generated from SDFDB.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFDB.h"

const char *star_nm_SDFDB = "SDFDB";

const char* SDFDB :: className() const {return star_nm_SDFDB;}

ISA_FUNC(SDFDB,SDFStar);

Block* SDFDB :: makeNew() const { LOG_NEW; return new SDFDB;}

SDFDB::SDFDB ()
{
	setDescriptor("Convert input to a decibels (dB) scale.\nZero and negative values are assigned the value \"min\" (default -100).\nThe \"inputIsPower\" parameter should be set to YES if the input signal\nis a power measurement (vs. an amplitude measurement).");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(min.setState("min",this,"-100","Minimum output value."));
	addState(inputIsPower.setState("inputIsPower",this,"FALSE","TRUE if input is a power measurement, FALSE if it's an amplitude measurement."));


}

void SDFDB::setup() {
# line 53 "SDFDB.pl"
if (int(inputIsPower)) gain=10.0;
		else gain = 20.0;
}

void SDFDB::go() {
# line 57 "SDFDB.pl"
double f = input%0;
		if (f <= 0.0)
			output%0 << double(min);
		else {
			f = gain * log10 (f);
			if (f < double(min)) f = double(min);
			output%0 << f;
		}
}

// prototype instance for known block list
static SDFDB proto;
static RegisterBlock registerBlock(proto,"DB");
