static const char file_id[] = "SDFDeMux.pl";
// .cc file generated from SDFDeMux.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFDeMux.h"

const char *star_nm_SDFDeMux = "SDFDeMux";

const char* SDFDeMux :: className() const {return star_nm_SDFDeMux;}

ISA_FUNC(SDFDeMux,SDFStar);

Block* SDFDeMux :: makeNew() const { LOG_NEW; return new SDFDeMux;}

SDFDeMux::SDFDeMux ()
{
	setDescriptor("Demultiplexes one input onto any number of output streams.\nThe star consumes B particles from the input, where B is the blockSize.\nThese B particles are copied to exactly one output,\ndetermined by the \"control\" input.  The other outputs get a zero of the\nappropriate type.\n\nIntegers from 0 through N-1 are accepted at the \"control\"\ninput, where N is the number of outputs.  If the control input is\noutside this range, all outputs get zero.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));


}

void SDFDeMux::setup() {
# line 46 "SDFDeMux.pl"
input.setSDFParams(int(blockSize),int(blockSize)-1);
		output.setSDFParams(int(blockSize),int(blockSize)-1);
}

void SDFDeMux::go() {
# line 50 "SDFDeMux.pl"
int n = int(control%0);
	    MPHIter nexto(output);
	    PortHole* p;
	    for (int i = 0; i < output.numberPorts(); i++) {
		p = nexto++;
		int j;
		if (i == n)
		    for (j = int(blockSize)-1; j >= 0; j--)
		        (*p)%j = input%j;
		else
		    for (j = int(blockSize)-1; j >= 0; j--)
			((*p)%j).initialize();
	    }
}

// prototype instance for known block list
static SDFDeMux proto;
static RegisterBlock registerBlock(proto,"DeMux");
