static const char file_id[] = "SDFDistributor.pl";
// .cc file generated from SDFDistributor.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFDistributor.h"

const char *star_nm_SDFDistributor = "SDFDistributor";

const char* SDFDistributor :: className() const {return star_nm_SDFDistributor;}

ISA_FUNC(SDFDistributor,SDFStar);

Block* SDFDistributor :: makeNew() const { LOG_NEW; return new SDFDistributor;}

SDFDistributor::SDFDistributor ()
{
	setDescriptor("Takes one input stream and synchronously splits it into N output streams,\nwhere N is the number of outputs.  It consumes N*B input particles,\nwhere B = blockSize, and sends the first B particles to the first output,\nthe next B particles to the next output, etc.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));


}

void SDFDistributor::setup() {
# line 34 "SDFDistributor.pl"
int n = output.numberPorts();
		input.setSDFParams(n*int(blockSize),n*int(blockSize)-1);
		output.setSDFParams(int(blockSize),int(blockSize)-1);
}

void SDFDistributor::go() {
# line 40 "SDFDistributor.pl"
MPHIter nexto(output);
		PortHole* p;
		for (int i = output.numberPorts() - 1; i >= 0; i--) {
		   p = nexto++;
		   for (int j = int(blockSize)-1; j >= 0; j--)
			(*p)%j = input%(j+i*int(blockSize));
		   }
}

// prototype instance for known block list
static SDFDistributor proto;
static RegisterBlock registerBlock(proto,"Distributor");
