static const char file_id[] = "SDFDownSample.pl";
// .cc file generated from SDFDownSample.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFDownSample.h"

const char *star_nm_SDFDownSample = "SDFDownSample";

const char* SDFDownSample :: className() const {return star_nm_SDFDownSample;}

ISA_FUNC(SDFDownSample,SDFStar);

Block* SDFDownSample :: makeNew() const { LOG_NEW; return new SDFDownSample;}

SDFDownSample::SDFDownSample ()
{
	setDescriptor("A decimator by a given \"factor\" (default 2).\nThe \"phase\" tells which sample to output.\nIf phase = 0, the most recent sample is the output,\nwhile if phase = factor-1 the oldest sample is the output.\nPhase = 0 is the default.  Note that \"phase\" has the opposite\nsense of the phase parameter in the UpSample star, but the\nsame sense as the phase parameter in the FIR star.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(factor.setState("factor",this,"2","Downsample factor."));
	addState(phase.setState("phase",this,"0","Downsample phase."));


}

void SDFDownSample::setup() {
# line 46 "SDFDownSample.pl"
input.setSDFParams(int(factor),int(factor)-1);
		if (int(phase) >= int(factor))
			Error::abortRun(*this, ": phase must be < factor");
}

void SDFDownSample::go() {
# line 51 "SDFDownSample.pl"
output%0 = input%int(phase);
}

// prototype instance for known block list
static SDFDownSample proto;
static RegisterBlock registerBlock(proto,"DownSample");
