static const char file_id[] = "SDFFix.pl";
// .cc file generated from SDFFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFix.h"

const char *star_nm_SDFFix = "SDFFix";

const char* SDFFix :: className() const {return star_nm_SDFFix;}

ISA_FUNC(SDFFix,SDFStar);

Block* SDFFix :: makeNew() const { LOG_NEW; return new SDFFix;}

SDFFix::SDFFix ()
{
	setDescriptor("Base star for the fixed-point stars in the SDF domain.");
	addState(OverflowHandler.setState("OverflowHandler",this,"saturate","Overflow characteristic for the output.\nIf the result of the sum cannot be fit into the precision of the output,\nthen overflow occurs and the overflow is taken care of by the method\nspecified by this parameter.\nThe keywords for overflow handling methods are:\n\"saturate\" (the default), \"zero_saturate\", \"wrapped\", and \"warning\".\nThe \"warning\" option will generate a warning message whenever overflow occurs."));
	addState(ReportOverflow.setState("ReportOverflow",this,"YES","If non-zero, e.g. YES or TRUE, then after a simulation has finished,\nthe star will report the number of overflow errors if any occurred\nduring the simulation."));
	addState(RoundFix.setState("RoundFix",this,"YES","If YES or TRUE, then all fixed-point computations, assignments, and\ndata type conversions will be rounded.\nOtherwise, truncation will be used."));


}

void SDFFix::wrapup() {
# line 75 "SDFFix.pl"
if ( int(ReportOverflow) && ( overflows > 0 ) ) {
		  StringList msg;
		  char percentageStr[24];      // must be at least 6 chars
		  double percentage = 0.0;
		  if ( totalChecks > 0 )
		    percentage = (100.0*overflows)/totalChecks;
		  // truncate percentage to one decimal place
		  sprintf(percentageStr, "%.1f", percentage);
		  msg << " experienced overflow in " << overflows 
		      << " out of " << totalChecks
		      << " fixed-point calculations checked ("
		      << percentageStr << "%)";
		  Error::warn( *this, msg );
		}
}

void SDFFix::setup() {
# line 69 "SDFFix.pl"
overflows = 0;
		totalChecks = 0;
}


int SDFFix::checkOverflow (Fix& fix)
{
# line 59 "SDFFix.pl"
int overflag = fix.ovf_occurred();
			totalChecks++;
			if ( overflag ) {
			  overflows++;
			  fix.clear_errors();
			}
			return overflag;
}


// prototype instance for known block list
static SDFFix proto;
static RegisterBlock registerBlock(proto,"Fix");
