static const char file_id[] = "SDFFloatToFix.pl";
// .cc file generated from SDFFloatToFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFloatToFix.h"

const char *star_nm_SDFFloatToFix = "SDFFloatToFix";

const char* SDFFloatToFix :: className() const {return star_nm_SDFFloatToFix;}

ISA_FUNC(SDFFloatToFix,SDFFix);

Block* SDFFloatToFix :: makeNew() const { LOG_NEW; return new SDFFloatToFix;}

SDFFloatToFix::SDFFloatToFix ()
{
	setDescriptor("Convert a floating-point input to an fixed-point output.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FIX));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nIf the value of the double cannot be represented by the number of bits\nspecified in the precision parameter, then a error message is given."));


}

void SDFFloatToFix::setup() {
# line 39 "SDFFloatToFix.pl"
SDFFix::setup();

                out = Fix( ((const char *) OutputPrecision) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
		out.set_ovflow( ((const char *) OverflowHandler) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		out.set_rounding( int(RoundFix) );
}

void SDFFloatToFix::go() {
# line 50 "SDFFloatToFix.pl"
out = double(input%0);
		checkOverflow(out);
                output%0 << out;
}

// prototype instance for known block list
static SDFFloatToFix proto;
static RegisterBlock registerBlock(proto,"FloatToFix");
