static const char file_id[] = "SDFGainFix.pl";
// .cc file generated from SDFGainFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFGainFix.h"

const char *star_nm_SDFGainFix = "SDFGainFix";

const char* SDFGainFix :: className() const {return star_nm_SDFGainFix;}

ISA_FUNC(SDFGainFix,SDFFix);

Block* SDFGainFix :: makeNew() const { LOG_NEW; return new SDFGainFix;}

SDFGainFix::SDFGainFix ()
{
	setDescriptor("This is an amplifier; the fixed-point output is the fixed-point input\nmultiplied by the \"gain\" (default 1.0).\nThe precision of \"gain\", the input, and the output can be specified in bits.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(gain.setState("gain",this,"1.0","Gain of the star."));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag indicated whether or not to use the arriving particles as they are:\nYES keeps the same precision, and NO casts them to the\nprecision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the input in bits.  The input particles are only cast\nto this precision if the parameter \"ArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the arithmetic operation\non the inputs.\nWhen the value of the product extends outside of the precision,\nthe OverflowHandler will be called."));


}

void SDFGainFix::setup() {
# line 81 "SDFGainFix.pl"
SDFFix::setup();

                if ( ! int(ArrivingPrecision) ) {
                  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );

                out = Fix( ((const char *) OutputPrecision) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
                out.set_ovflow( ((const char *) OverflowHandler) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		out.set_rounding( int(RoundFix) );
}

void SDFGainFix::go() {
# line 99 "SDFGainFix.pl"
// all computations should be performed with out since that
		// is the Fix variable with the desired overflow handler
		out = Fix(gain);
		if ( int(ArrivingPrecision) ) {
                  out *= Fix(input%0);
		}
		else {
                  fixIn = Fix(input%0);
                  out *= fixIn;
		}
		checkOverflow(out);
		output%0 << out;
}

// prototype instance for known block list
static SDFGainFix proto;
static RegisterBlock registerBlock(proto,"GainFix");
