static const char file_id[] = "SDFIIDGaussian.pl";
// .cc file generated from SDFIIDGaussian.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFIIDGaussian.h"
#include <ACG.h>

const char *star_nm_SDFIIDGaussian = "SDFIIDGaussian";

const char* SDFIIDGaussian :: className() const {return star_nm_SDFIIDGaussian;}

ISA_FUNC(SDFIIDGaussian,SDFStar);

Block* SDFIIDGaussian :: makeNew() const { LOG_NEW; return new SDFIIDGaussian;}

# line 45 "SDFIIDGaussian.pl"
extern ACG* gen;

SDFIIDGaussian::SDFIIDGaussian ()
{
	setDescriptor("Generate a white Gaussian pseudo-random process with mean\n\"mean\" (default 0) and variance \"variance\" (default 1).");
	addPort(output.setPort("output",this,FLOAT));
	addState(mean.setState("mean",this,"0.0","Mean of distribution."));
	addState(variance.setState("variance",this,"1.0","Variance of distribution."));

# line 48 "SDFIIDGaussian.pl"
random = NULL;
}

SDFIIDGaussian::~SDFIIDGaussian() {
# line 51 "SDFIIDGaussian.pl"
LOG_DEL; delete random;
}

void SDFIIDGaussian::setup() {
# line 54 "SDFIIDGaussian.pl"
LOG_DEL; delete random;
		LOG_NEW; random = new Normal(double(mean),double(variance),gen);
}

void SDFIIDGaussian::go() {
# line 58 "SDFIIDGaussian.pl"
output%0 << (*random)();
}

// prototype instance for known block list
static SDFIIDGaussian proto;
static RegisterBlock registerBlock(proto,"IIDGaussian");
