static const char file_id[] = "SDFImpulse.pl";
// .cc file generated from SDFImpulse.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFImpulse.h"

const char *star_nm_SDFImpulse = "SDFImpulse";

const char* SDFImpulse :: className() const {return star_nm_SDFImpulse;}

ISA_FUNC(SDFImpulse,SDFStar);

Block* SDFImpulse :: makeNew() const { LOG_NEW; return new SDFImpulse;}

SDFImpulse::SDFImpulse ()
{
	setDescriptor("Generate a stream of impulses of size \"level\" (default 1.0).\nThe period is given by \"period\" (default 0).\nIf period = 0 then only one impulse is generated.");
	addPort(output.setPort("output",this,FLOAT));
	addState(level.setState("level",this,"1.0","The height of the impulse."));
	addState(period.setState("period",this,"0","The period of the impulse train, 0 = aperiodic."));
	addState(count.setState("count",this,"0","An internal state.",
# line 39 "SDFImpulse.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void SDFImpulse::go() {
# line 42 "SDFImpulse.pl"
double t = 0.0;
		if (int(count) == 0) t = level;
		count = int(count) + 1;
		if (int(period) > 0 && int(count) >= int(period))
			count = 0;
		output%0 << t;
}

// prototype instance for known block list
static SDFImpulse proto;
static RegisterBlock registerBlock(proto,"Impulse");
