static const char file_id[] = "SDFIntToFix.pl";
// .cc file generated from SDFIntToFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFIntToFix.h"

const char *star_nm_SDFIntToFix = "SDFIntToFix";

const char* SDFIntToFix :: className() const {return star_nm_SDFIntToFix;}

ISA_FUNC(SDFIntToFix,SDFFix);

Block* SDFIntToFix :: makeNew() const { LOG_NEW; return new SDFIntToFix;}

SDFIntToFix::SDFIntToFix ()
{
	setDescriptor("Convert an integer input to a fixed-point output.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,FIX));
	addState(OutputPrecision.setState("OutputPrecision",this,"16.0","Precision of the output in bits.\nThe integer number is cast to a double and then converted to this precision.\nIf the value of the double cannot be represented by the number of bits\nspecified in the precision parameter, then the OverflowHandler will be called."));


}

void SDFIntToFix::setup() {
# line 40 "SDFIntToFix.pl"
SDFFix::setup();

                out = Fix( ((const char *) OutputPrecision) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
		out.set_ovflow( ((const char *) OverflowHandler) );
		if ( out.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		out.set_rounding( int(RoundFix) );
}

void SDFIntToFix::go() {
# line 51 "SDFIntToFix.pl"
out = double(int(input%0));
		checkOverflow(out);
                output%0 << out;
}

// prototype instance for known block list
static SDFIntToFix proto;
static RegisterBlock registerBlock(proto,"IntToFix");
