static const char file_id[] = "SDFLogic.pl";
// .cc file generated from SDFLogic.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFLogic.h"

const char *star_nm_SDFLogic = "SDFLogic";

const char* SDFLogic :: className() const {return star_nm_SDFLogic;}

ISA_FUNC(SDFLogic,SDFStar);

Block* SDFLogic :: makeNew() const { LOG_NEW; return new SDFLogic;}

# line 55 "SDFLogic.pl"
#define NOTID 0
#define ANDID 1
#define NANDID 2
#define ORID 3
#define NORID 4
#define XORID 5
#define XNORID 6

SDFLogic::SDFLogic ()
{
	setDescriptor("This star applies a logical operation to any number of inputs.\nThe inputs are integers interpreted as Boolean values,\nwhere zero means FALSE and a nonzero value means TRUE.\nThe logical operations supported are {NOT AND NAND OR NOR XOR XNOR}.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(logic.setState("logic",this,"AND","The test logic: one of NOT AND NAND OR NOR XOR or XNOR."));


}

void SDFLogic::setup() {
# line 67 "SDFLogic.pl"
const char* cn = logic;
		if ( strcasecmp(cn, "NOT") == 0) {
		    test = NOTID;
		    if (input.numberPorts() > 1)
			Error::abortRun(*this,
			    "NOT operation can only have one input");
		}
		else if ( strcasecmp(cn, "AND") == 0 ) test = ANDID;
		else if ( strcasecmp(cn, "NAND") == 0 ) test = NANDID;
		else if ( strcasecmp(cn, "OR") == 0 ) test = ORID;
		else if ( strcasecmp(cn, "NOR") == 0 ) test = NORID;
		else if ( strcasecmp(cn, "XOR") == 0 ) test = XORID;
		else if ( strcasecmp(cn, "XNOR") == 0 ) test = XNORID;
		else Error::abortRun(*this,"Unrecognized test.");
}

void SDFLogic::go() {
# line 83 "SDFLogic.pl"
MPHIter nexti(input);
	    PortHole* p = 0;
	    int result = 0;

	    switch( test ) {
		case NOTID:
		    p = nexti++;
		    result = ! int((*p)%0);
		    break;
		case ANDID:
		case NANDID:
		    result = 1;
		    while ((p = nexti++) != 0)
			result = result && int((*p)%0);
		    if (test == NANDID) result = !result;
		    break;
		case ORID:
		case NORID:
		    result = 0;
		    while ((p = nexti++) != 0)
			result = result || int((*p)%0);
		    if (test == NORID) result = !result;
		    break;
		case XORID:
		case XNORID:
		    result = 0;
		    while ((p = nexti++) != 0)
			if (int((*p)%0)) result = !result;
		    if (test == XNORID) result = !result;
		    break;
	    }
	    output%0 << result;
}

// prototype instance for known block list
static SDFLogic proto;
static RegisterBlock registerBlock(proto,"Logic");
