static const char file_id[] = "SDFMpyFix.pl";
// .cc file generated from SDFMpyFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMpyFix.h"

const char *star_nm_SDFMpyFix = "SDFMpyFix";

const char* SDFMpyFix :: className() const {return star_nm_SDFMpyFix;}

ISA_FUNC(SDFMpyFix,SDFFix);

Block* SDFMpyFix :: makeNew() const { LOG_NEW; return new SDFMpyFix;}

SDFMpyFix::SDFMpyFix ()
{
	setDescriptor("Output the product of the inputs, as a fixed-point value.");
	addPort(input.setPort("input",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Indicates whether or not to keep the precision of the arriving particles\nas they are:  YES keeps the same precision, and NO casts the inputs\nto the precision specified by the parameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Sets the precision of the input in bits.\nThe input particles are only cast to this precision if the\nparameter \"ArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Sets the precision of the output in bits.\nThis is the precision that will hold the result of the product of the inputs.\nWhen the value of the product extends outside of the precision,\nthe OverflowHandler will be called."));


}

void SDFMpyFix::setup() {
# line 58 "SDFMpyFix.pl"
SDFFix::setup();

		if ( ! int(ArrivingPrecision) ) {
		  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );

	        product = Fix( ((const char *) OutputPrecision) );
		if ( product.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
	        product.set_ovflow( ((const char *) OverflowHandler) );
		if ( product.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		product.set_rounding( int(RoundFix) );
}

void SDFMpyFix::go() {
# line 76 "SDFMpyFix.pl"
MPHIter nexti(input);
	        PortHole *p;

		// initialize product as the value on the first input port
		// (if it exists) and then compute the product
		p = nexti++;
		if ( p != 0 ) {
	          fixIn = (Fix)((*p)%0);
	          product = fixIn;
		  checkOverflow(product);
	          while ((p = nexti++) != 0) {
		    if ( int(ArrivingPrecision) )
		      product *= (Fix)((*p)%0);
		    else {
	              fixIn = (Fix)((*p)%0);
		      product *= fixIn;
		    }
		    checkOverflow(product);
		  }
		}
		else {
		  product = 1.0;	   // 1.0 will overflow if the fixed-
		  checkOverflow(product);  // representation has 0 integer bits
		}
	        output%0 << product;
}

// prototype instance for known block list
static SDFMpyFix proto;
static RegisterBlock registerBlock(proto,"MpyFix");
