static const char file_id[] = "SDFMux.pl";
// .cc file generated from SDFMux.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMux.h"

const char *star_nm_SDFMux = "SDFMux";

const char* SDFMux :: className() const {return star_nm_SDFMux;}

ISA_FUNC(SDFMux,SDFStar);

Block* SDFMux :: makeNew() const { LOG_NEW; return new SDFMux;}

SDFMux::SDFMux ()
{
	setDescriptor("Multiplex any number of inputs onto one output stream.\nB particles are consumed on each input, where B is the blockSize.\nBut only one of these blocks of particles is copied to the output.\nThe one copied is determined by the \"control\" input.\nIntegers from 0 through N-1 are accepted at the \"control\" input,\nwhere N is the number of inputs.  If the control input is outside\nthis range, an error is signaled.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(control.setPort("control",this,INT));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));


}

void SDFMux::setup() {
# line 44 "SDFMux.pl"
output.setSDFParams(int(blockSize),int(blockSize)-1);
		input.setSDFParams(int(blockSize),int(blockSize)-1);
}

void SDFMux::go() {
# line 48 "SDFMux.pl"
int n = int(control%0);
	    MPHIter nexti(input);
	    PortHole* p;
	    for (int i = 0; i < input.numberPorts(); i++) {
		p = nexti++;
		if (i == n) {
		    for (int j = int(blockSize)-1; j >= 0; j--)
		        output%j = (*p)%j;
		    return;
		}
	    }
	    Error::abortRun(*this,
		"Invalid control input to Mux - out of range");
}

// prototype instance for known block list
static SDFMux proto;
static RegisterBlock registerBlock(proto,"Mux");
