static const char file_id[] = "SDFNumToBus.pl";
// .cc file generated from SDFNumToBus.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFNumToBus.h"

const char *star_nm_SDFNumToBus = "SDFNumToBus";

const char* SDFNumToBus :: className() const {return star_nm_SDFNumToBus;}

ISA_FUNC(SDFNumToBus,SDFStar);

Block* SDFNumToBus :: makeNew() const { LOG_NEW; return new SDFNumToBus;}

SDFNumToBus::SDFNumToBus ()
{
	setDescriptor("This star accepts an integer and outputs the low-order bits that\nmake up the integer on a number of outputs, one bit per output.\nThe number of outputs should not exceed the wordsize of an integer.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));

# line 30 "SDFNumToBus.pl"
bits = 0;
                binary = 0;
}

SDFNumToBus::~SDFNumToBus() {
# line 34 "SDFNumToBus.pl"
delete [] binary;
}

void SDFNumToBus::setup() {
# line 37 "SDFNumToBus.pl"
bits = output.numberPorts();
                delete [] binary;
                binary = new int[bits];
}

void SDFNumToBus::go() {
# line 42 "SDFNumToBus.pl"
int in = int(input%0);

		// convert the integer to binary and store it into an array
		// to be output on the bus, msb is the sign bit

		if (in < 0) {
			binary[bits-1] = 1;
			in += 2 << (bits-1);
		}
		else {
			binary[bits-1] = 0;
		}

		for (int i = 0; i < bits - 1; i++) {
 	     		binary[i] = in & 0x1;
			in >>= 1;
		}

		MPHIter nextp(output);
		PortHole* p;
		int j = 0;
		while ((p = nextp++) != 0) {
			(*p)%0 << binary[j++];
		}
}

// prototype instance for known block list
static SDFNumToBus proto;
static RegisterBlock registerBlock(proto,"NumToBus");
