static const char file_id[] = "SDFPrinter.pl";
// .cc file generated from SDFPrinter.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFPrinter.h"

const char *star_nm_SDFPrinter = "SDFPrinter";

const char* SDFPrinter :: className() const {return star_nm_SDFPrinter;}

ISA_FUNC(SDFPrinter,SDFStar);

Block* SDFPrinter :: makeNew() const { LOG_NEW; return new SDFPrinter;}

SDFPrinter::SDFPrinter ()
{
	setDescriptor("Print out one sample from each input port per line.\nThe \"fileName\" state specifies the file to be written; the special names\n<stdout> and <cout>, which specify the standard output stream, and\n<stderr> and <cerr>, which specify the standard error stream,\nare also supported.");
	addPort(input.setPort("input",this,ANYTYPE));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output."));

# line 45 "SDFPrinter.pl"
p_out = 0;
}

void SDFPrinter::wrapup() {
# line 61 "SDFPrinter.pl"
LOG_DEL; delete p_out;		// flush output
		p_out = 0;
}

SDFPrinter::~SDFPrinter() {
# line 65 "SDFPrinter.pl"
LOG_DEL; delete p_out;		// flush output
}

void SDFPrinter::setup() {
# line 48 "SDFPrinter.pl"
// in case file was open from previous run w/o wrapup call
		LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
}

void SDFPrinter::go() {
# line 53 "SDFPrinter.pl"
pt_ofstream& output = *p_out;
		MPHIter nexti(input);
		PortHole* p;
		while ((p = nexti++) != 0)
		 	output << ((*p)%0).print() << "\t";
		output << "\n";
}

// prototype instance for known block list
static SDFPrinter proto;
static RegisterBlock registerBlock(proto,"Printer");
