static const char file_id[] = "SDFQuantizer.pl";
// .cc file generated from SDFQuantizer.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFQuantizer.h"

const char *star_nm_SDFQuantizer = "SDFQuantizer";

const char* SDFQuantizer :: className() const {return star_nm_SDFQuantizer;}

ISA_FUNC(SDFQuantizer,SDFStar);

Block* SDFQuantizer :: makeNew() const { LOG_NEW; return new SDFQuantizer;}

SDFQuantizer::SDFQuantizer ()
{
	setDescriptor("This star quantizes the input value to the nearest output value\nin the given codebook.  The nearest value is found by a full search\nof the codebook, so the star will be significantly slower than\neither Quant or LinQuantIdx.  The absolute value of the difference\nis used as a distance measure.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addPort(outIndex.setPort("outIndex",this,INT));
	addState(floatCodebook.setState("floatCodebook",this,"0.0 1.0 2.0 3.0 4.0 5.0 6.0 7.0 8.0 9.0","Possible output values"));


}

void SDFQuantizer::go() {
# line 41 "SDFQuantizer.pl"
double in = double(input%0);
    int size = floatCodebook.size();

    int index = 0;
    double distance = fabs(in-floatCodebook[0]);

    double sum = 0;
    for (int i=1; i<size; i++) {
      sum = fabs(in-floatCodebook[i]);
      if (sum < distance) {
	index = i;
	distance =sum;
      }
    } 

    output%0 << floatCodebook[index];
    outIndex%0 << index;
}

// prototype instance for known block list
static SDFQuantizer proto;
static RegisterBlock registerBlock(proto,"Quantizer");
