static const char file_id[] = "SDFRampFix.pl";
// .cc file generated from SDFRampFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFRampFix.h"

const char *star_nm_SDFRampFix = "SDFRampFix";

const char* SDFRampFix :: className() const {return star_nm_SDFRampFix;}

ISA_FUNC(SDFRampFix,SDFFix);

Block* SDFRampFix :: makeNew() const { LOG_NEW; return new SDFRampFix;}

SDFRampFix::SDFRampFix ()
{
	setDescriptor("Generate a fixed-point ramp signal, starting at \"value\" (default 0.0)\nwith step size \"step\" (default 1.0).\nA precision and an initial value can be specified for a parameter by using\nthe notation ( <initial_value>, <precision> ).");
	addPort(output.setPort("output",this,FIX));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits and precision of the accumulation.\nWhen the value of the accumulation extends outside of the precision,\nthe OverflowHandler will be called."));
	addState(step.setState("step",this,"1.0","Increment from one sample to the next."));
	addState(value.setState("value",this,"0.0","Initial value output by the ramp.\nDuring simulation, this parameter holds the current value output by the ramp.\nThe precision of this state is the precision of the accumulation.",
# line 65 "SDFRampFix.pl"
A_SETTABLE|A_NONCONSTANT));


}

void SDFRampFix::setup() {
# line 71 "SDFRampFix.pl"
SDFFix::setup();

		t = Fix( ((const char *) OutputPrecision) );
		if ( t.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
                t.set_ovflow( ((const char *) OverflowHandler) );
		if ( t.invalid() )
		   Error::abortRun( *this, "Invalid OverflowHandler" );
		t.set_rounding( int(RoundFix) );
}

void SDFRampFix::go() {
# line 82 "SDFRampFix.pl"
// operator Fix() when applied to a FixState performs a cast
		t = Fix(value);
                output%0 << t;
                t += Fix(step);
		checkOverflow(t);
                value = t;
}

// prototype instance for known block list
static SDFRampFix proto;
static RegisterBlock registerBlock(proto,"RampFix");
