static const char file_id[] = "SDFReadFile.pl";
// .cc file generated from SDFReadFile.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFReadFile.h"
#include "SimControl.h"

const char *star_nm_SDFReadFile = "SDFReadFile";

const char* SDFReadFile :: className() const {return star_nm_SDFReadFile;}

ISA_FUNC(SDFReadFile,SDFStar);

Block* SDFReadFile :: makeNew() const { LOG_NEW; return new SDFReadFile;}

SDFReadFile::SDFReadFile ()
{
	setDescriptor("Read ASCII data from a file.  The simulation can be halted\non end-of-file, or the file contents can be periodically\nrepeated, or the file contents can be padded with zeros.");
	addPort(output.setPort("output",this,FLOAT));
	addState(fileName.setState("fileName",this,"/dev/null","Input file."));
	addState(haltAtEnd.setState("haltAtEnd",this,"NO","Halt the run at the end of the input file."));
	addState(periodic.setState("periodic",this,"YES","Make output periodic or zero-padded."));

# line 54 "SDFReadFile.pl"
input = 0;
	expandedFileName = 0;
}

SDFReadFile::~SDFReadFile() {
# line 96 "SDFReadFile.pl"
LOG_DEL; delete input;
	delete [] expandedFileName;
}

void SDFReadFile::setup() {
# line 59 "SDFReadFile.pl"
// open input file
	LOG_DEL; delete input;
	delete [] expandedFileName;
	expandedFileName = expandPathName(fileName);
	LOG_NEW; input = new ifstream(expandedFileName);
	if (!(*input))
		Error::abortRun(*this, "can't open file ", fileName);
}

void SDFReadFile::go() {
# line 69 "SDFReadFile.pl"
double x = 0.0;

	if (input->eof())
	{
	    if (haltAtEnd)		// halt the run
		SimControl::requestHalt();
	    else if (periodic)		// close and re-open file
	    {
		LOG_DEL; delete input;
                LOG_NEW; input = new ifstream(expandedFileName);
         	if (!(*input)) {
		    Error::abortRun(*this, "cannot re-open file ", fileName);
		    return;
		}
		(*input) >> x;		// get next value
		ws(*input);
	    }
	}
	else			// get next value
	{
	    (*input) >> x;
	    ws(*input);
	}
	output%0 << x;
}

// prototype instance for known block list
static SDFReadFile proto;
static RegisterBlock registerBlock(proto,"ReadFile");
