static const char file_id[] = "SDFReadVar.pl";
// .cc file generated from SDFReadVar.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFReadVar.h"

const char *star_nm_SDFReadVar = "SDFReadVar";

const char* SDFReadVar :: className() const {return star_nm_SDFReadVar;}

ISA_FUNC(SDFReadVar,SDFSharedMem);

Block* SDFReadVar :: makeNew() const { LOG_NEW; return new SDFReadVar;}

SDFReadVar::SDFReadVar ()
{
	setDescriptor("Output the value of a double-precision floating variable from a shared memory.\nUse the WriteVar star to write values into the shared memory.\n\nWARNING: This star may produce unpredictable results, since the results\nwill depend on the precedences in the block diagram in which it appears\nas well as the scheduler (target) used.");
	addPort(out.setPort("out",this,FLOAT));
	addState(name.setState("name",this,"0","Name of the register"));
	addState(initial.setState("initial",this,"0","Default value for output"));


}

void SDFReadVar::go() {
# line 43 "SDFReadVar.pl"
double val = 0.0;			// quiet the cfront C++ compiler

    // method ReadVar() sets the value of val (passed by reference)
    if ( !SDFSharedMem::ReadVar(name, &val) ) {
	val = initial;
    }

    out%0 << val;
}

// prototype instance for known block list
static SDFReadVar proto;
static RegisterBlock registerBlock(proto,"ReadVar");
