static const char file_id[] = "SDFReciprocal.pl";
// .cc file generated from SDFReciprocal.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFReciprocal.h"

const char *star_nm_SDFReciprocal = "SDFReciprocal";

const char* SDFReciprocal :: className() const {return star_nm_SDFReciprocal;}

ISA_FUNC(SDFReciprocal,SDFStar);

Block* SDFReciprocal :: makeNew() const { LOG_NEW; return new SDFReciprocal;}

SDFReciprocal::SDFReciprocal ()
{
	setDescriptor("Output the reciprocal of the input, with an optional magnitude limit.\nIf the magnitude limit is greater than zero, and the input value is zero,\nthen the output will equal the magnitude limit.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(magLimit.setState("magLimit",this,"0.0","If non-zero, limits the magnitude of the output."));


}

void SDFReciprocal::go() {
# line 40 "SDFReciprocal.pl"
if(double(magLimit) == 0.0)
		output%0 << 1/double(input%0);
	   else
		if(double(input%0) == 0.0)
		    output%0 << double(magLimit);
		else {
		    double t = 1/double(input%0);
		    if (t>double(magLimit))
			output%0 << double(magLimit);
		    else if (t < - double(magLimit))
			output%0 << - double(magLimit);
		    else
			output%0 << t;
		}
}

// prototype instance for known block list
static SDFReciprocal proto;
static RegisterBlock registerBlock(proto,"Reciprocal");
