static const char file_id[] = "SDFRect.pl";
// .cc file generated from SDFRect.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFRect.h"

const char *star_nm_SDFRect = "SDFRect";

const char* SDFRect :: className() const {return star_nm_SDFRect;}

ISA_FUNC(SDFRect,SDFStar);

Block* SDFRect :: makeNew() const { LOG_NEW; return new SDFRect;}

SDFRect::SDFRect ()
{
	setDescriptor("Generate a rectangular pulse of height \"height\" (default 1.0).\nand width \"width\" (default 8).  If \"period\" is greater than zero,\nthen the pulse is repeated with the given period.");
	addPort(output.setPort("output",this,FLOAT));
	addState(height.setState("height",this,"1.0","Height of the rectangular pulse."));
	addState(width.setState("width",this,"8","Width of the rectangular pulse."));
	addState(period.setState("period",this,"0","If greater than zero, the period of the pulse stream."));
	addState(count.setState("count",this,"0","Internal counting state.",
# line 45 "SDFRect.pl"
A_NONSETTABLE|A_NONCONSTANT));


}

void SDFRect::go() {
# line 48 "SDFRect.pl"
double t = 0.0;
		if (int(count) < int(width)) t = height;
		output%0 << t;
		count = int(count) + 1;
		if (int(period) > 0 && int(count) >= int(period)) count = 0;
}

// prototype instance for known block list
static SDFRect proto;
static RegisterBlock registerBlock(proto,"Rect");
