static const char file_id[] = "SDFRectFix.pl";
// .cc file generated from SDFRectFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFRectFix.h"

const char *star_nm_SDFRectFix = "SDFRectFix";

const char* SDFRectFix :: className() const {return star_nm_SDFRectFix;}

ISA_FUNC(SDFRectFix,SDFFix);

Block* SDFRectFix :: makeNew() const { LOG_NEW; return new SDFRectFix;}

SDFRectFix::SDFRectFix ()
{
	setDescriptor("Generate a fixed-point rectangular pulse of height \"height\" \n(default 1.0) and width \"width\" (default 8).\nIf \"period\" is greater than zero, then the pulse is repeated with the\ngiven period.");
	addPort(output.setPort("output",this,FIX));
	addState(height.setState("height",this,"1.0","Height of the rectangular pulse."));
	addState(width.setState("width",this,"8","Width of the rectangular pulse."));
	addState(period.setState("period",this,"0","If greater than zero, the period of the pulse stream."));
	addState(count.setState("count",this,"0","Internal counting state.",
# line 55 "SDFRectFix.pl"
A_NONSETTABLE|A_NONCONSTANT));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThe value of the \"height\" parameter is cast to this precision and then output.\nIf the value cannot be represented by this precision, then\nthe OverflowHandler will be called."));


}

void SDFRectFix::setup() {
# line 72 "SDFRectFix.pl"
SDFFix::setup();

                out = Fix( ((const char *) OutputPrecision) );
		if ( out.invalid() )
		   Error::abortRun( *this, "Invalid OutputPrecision" );
		out.set_ovflow( ((const char *) OverflowHandler) );
		if ( out.invalid() )
		   Error::abortRun( *this, "Invalid OverflowHandler" );
		out.set_rounding( int(RoundFix) );
}

void SDFRectFix::go() {
# line 83 "SDFRectFix.pl"
out = 0.0;
		if ( int(count) < int(width) ) {
		  out = Fix(height);
		  checkOverflow(out);
		}
		output%0 << out;
		count = int(count) + 1;
		if ( int(period) > 0 && int(count) >= int(period) ) count = 0;
}

// prototype instance for known block list
static SDFRectFix proto;
static RegisterBlock registerBlock(proto,"RectFix");
