static const char file_id[] = "SDFRectToPolar.pl";
// .cc file generated from SDFRectToPolar.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFRectToPolar.h"

const char *star_nm_SDFRectToPolar = "SDFRectToPolar";

const char* SDFRectToPolar :: className() const {return star_nm_SDFRectToPolar;}

ISA_FUNC(SDFRectToPolar,SDFStar);

Block* SDFRectToPolar :: makeNew() const { LOG_NEW; return new SDFRectToPolar;}

SDFRectToPolar::SDFRectToPolar ()
{
	setDescriptor("Converts the complex number x + j y, for inputs \"x\" and \"y\",\ninto magnitude and phase form.\nThe phase output is in the range -PI to PI.");
	addPort(x.setPort("x",this,FLOAT));
	addPort(y.setPort("y",this,FLOAT));
	addPort(magnitude.setPort("magnitude",this,FLOAT));
	addPort(phase.setPort("phase",this,FLOAT));


}

void SDFRectToPolar::go() {
# line 43 "SDFRectToPolar.pl"
double xpart = x%0;
		double ypart = y%0;
		double m = sqrt(xpart*xpart + ypart*ypart);
		magnitude%0 << m;
		if (m == 0)
		   phase%0 << 0.0;
		else	
		   phase%0 << atan2(ypart,xpart);
}

// prototype instance for known block list
static SDFRectToPolar proto;
static RegisterBlock registerBlock(proto,"RectToPolar");
