static const char file_id[] = "SDFRepeat.pl";
// .cc file generated from SDFRepeat.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFRepeat.h"

const char *star_nm_SDFRepeat = "SDFRepeat";

const char* SDFRepeat :: className() const {return star_nm_SDFRepeat;}

ISA_FUNC(SDFRepeat,SDFStar);

Block* SDFRepeat :: makeNew() const { LOG_NEW; return new SDFRepeat;}

SDFRepeat::SDFRepeat ()
{
	setDescriptor("Repeat each input sample a specified number of times.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(numTimes.setState("numTimes",this,"2","Repetition factor."));
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));


}

void SDFRepeat::setup() {
# line 41 "SDFRepeat.pl"
input.setSDFParams(int(blockSize), int(blockSize)-1);
		output.setSDFParams(int(numTimes)*int(blockSize),
			int(numTimes)*int(blockSize)-1);
}

void SDFRepeat::go() {
# line 46 "SDFRepeat.pl"
for (int i = 0; i < int(numTimes); i++) {
		for (int j = int(blockSize)-1; j >= 0; j--)
		    output%(j+i*int(blockSize)) = input%j;
	    }
}

// prototype instance for known block list
static SDFRepeat proto;
static RegisterBlock registerBlock(proto,"Repeat");
