static const char file_id[] = "SDFReverse.pl";
// .cc file generated from SDFReverse.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFReverse.h"

const char *star_nm_SDFReverse = "SDFReverse";

const char* SDFReverse :: className() const {return star_nm_SDFReverse;}

ISA_FUNC(SDFReverse,SDFStar);

Block* SDFReverse :: makeNew() const { LOG_NEW; return new SDFReverse;}

SDFReverse::SDFReverse ()
{
	setDescriptor("On each execution, read a block of \"N\" samples (default 64)\nand write them out backwards.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(N.setState("N",this,"64","Number of particles read and written."));


}

void SDFReverse::setup() {
# line 32 "SDFReverse.pl"
input.setSDFParams(int(N),int(N)-1);
		output.setSDFParams(int(N),int(N)-1);
}

void SDFReverse::go() {
# line 36 "SDFReverse.pl"
int i, j;
		for (i = 0, j = int(N) - 1; j >= 0; i++, j--)
			output%i = input%j;
}

// prototype instance for known block list
static SDFReverse proto;
static RegisterBlock registerBlock(proto,"Reverse");
