static const char file_id[] = "SDFSpheToCart.pl";
// .cc file generated from SDFSpheToCart.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFSpheToCart.h"
#include <math.h>

const char *star_nm_SDFSpheToCart = "SDFSpheToCart";

const char* SDFSpheToCart :: className() const {return star_nm_SDFSpheToCart;}

ISA_FUNC(SDFSpheToCart,SDFStar);

Block* SDFSpheToCart :: makeNew() const { LOG_NEW; return new SDFSpheToCart;}

SDFSpheToCart::SDFSpheToCart ()
{
	setDescriptor("Convert magnitude and phase to rectangular form.");
	addPort(x.setPort("x",this,FLOAT));
	addState(magnitude.setState("magnitude",this,"1.0","Magnitude of vector U."));
	addState(site.setState("site",this,"1.0","elevation of vector U."));
	addState(gise.setState("gise",this,"1.0","azimuth of vector U."));
	addState(Rx.setState("Rx",this,"1.0","First component of vector R."));
	addState(Ry.setState("Ry",this,"1.0","Second component of vector R."));
	addState(Rz.setState("Rz",this,"1.0","Third component of vector R."));


}

void SDFSpheToCart::go() {
# line 65 "SDFSpheToCart.pl"
// Line originally was:
// x%0 << magnitude * 
//        (cos(site)*sin(gise)*Rx + sin(site)*Ry+ cos(site)*cos(gise)*Rz) ;
// But sol2.cfront barfs with:
// line 63: Error: Overloading ambiguity between
// operator*(const Complex&, double) and FloatState::operator double().
//
// Now, we use casts whenever a state is referenced

	double sited = double(site);
	double gised = double(gise);

	x%0 << (double(magnitude) * (cos(sited)*sin(gised)*double(Rx) +
                                     sin(sited)*double(Ry) +
 				     cos(sited)*cos(gised)*double(Rz)));
}

// prototype instance for known block list
static SDFSpheToCart proto;
static RegisterBlock registerBlock(proto,"SpheToCart");
