static const char file_id[] = "SDFSubFix.pl";
// .cc file generated from SDFSubFix.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFSubFix.h"

const char *star_nm_SDFSubFix = "SDFSubFix";

const char* SDFSubFix :: className() const {return star_nm_SDFSubFix;}

ISA_FUNC(SDFSubFix,SDFFix);

Block* SDFSubFix :: makeNew() const { LOG_NEW; return new SDFSubFix;}

SDFSubFix::SDFSubFix ()
{
	setDescriptor("Output as a fixed-point number the \"pos\" input minus all \"neg\" inputs.");
	addPort(pos.setPort("pos",this,FIX));
	addPort(neg.setPort("neg",this,FIX));
	addPort(output.setPort("output",this,FIX));
	addState(ArrivingPrecision.setState("ArrivingPrecision",this,"YES","Flag indicating whether or not to use the precision of the arriving particles\n(the \"pos\" input and the \"neg\" inputs) as they are:  YES processes them\nunaltered, and NO casts them to the precision specified by the\nparameter \"InputPrecision\"."));
	addState(InputPrecision.setState("InputPrecision",this,"2.14","Precision of the \"neg\" input in bits.\nThe input particles are only cast to this precision if the\nparameter \"ArrivingPrecision\" is set to NO."));
	addState(OutputPrecision.setState("OutputPrecision",this,"2.14","Precision of the output in bits.\nThis is the precision that will hold the result of the difference\nof the inputs.\nWhen the value of the accumulation extends outside of the precision,\nthe OverflowHandler will be called."));


}

void SDFSubFix::setup() {
# line 66 "SDFSubFix.pl"
SDFFix::setup();

                if ( ! int(ArrivingPrecision) ) {
                  fixIn = Fix( ((const char *) InputPrecision) );
		  if ( fixIn.invalid() )
		    Error::abortRun( *this, "Invalid InputPrecision" );
		}
		fixIn.set_rounding( int(RoundFix) );

                diff = Fix( ((const char *) OutputPrecision) );
		if ( diff.invalid() )
		  Error::abortRun( *this, "Invalid OutputPrecision" );
                diff.set_ovflow( ((const char *) OverflowHandler) );
		if ( diff.invalid() )
		  Error::abortRun( *this, "Invalid OverflowHandler" );
		diff.set_rounding( int(RoundFix) );
}

void SDFSubFix::go() {
# line 84 "SDFSubFix.pl"
MPHIter nexti(neg);
                PortHole *p;

                if ( int(ArrivingPrecision) ) {
		  diff = Fix(pos%0);
                  while ((p = nexti++) != 0) {
                    diff -= (Fix)((*p)%0);
		    checkOverflow(diff);
		  }
		}
		else {
		  fixIn = Fix(pos%0);
		  diff = fixIn;
                  while ((p = nexti++) != 0) {
		    fixIn = (Fix)((*p)%0);
                    diff -= fixIn;
		    checkOverflow(diff);
		  }
		}
                output%0 << diff;
}

// prototype instance for known block list
static SDFSubFix proto;
static RegisterBlock registerBlock(proto,"SubFix");
