static const char file_id[] = "SDFTable.pl";
// .cc file generated from SDFTable.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTable.h"
#include "StringList.h"

const char *star_nm_SDFTable = "SDFTable";

const char* SDFTable :: className() const {return star_nm_SDFTable;}

ISA_FUNC(SDFTable,SDFStar);

Block* SDFTable :: makeNew() const { LOG_NEW; return new SDFTable;}

SDFTable::SDFTable ()
{
	setDescriptor("This star implements a real-valued lookup table indexed by an\ninteger-valued input.  The input must lie between 0 and N-1,\ninclusive, where N is the size of the table.  The \"values\"\nparameter (an array) specifies the entries in the table.  Its\nfirst element is indexed by a zero-valued input.  An error occurs\nif the input value is out of bounds.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,FLOAT));
	addState(values.setState("values",this,"-1 1","\"table of values to output\""));


}

void SDFTable::go() {
# line 40 "SDFTable.pl"
int i = int(input%0);
		if (i < 0 || i >= values.size()) {
			StringList msg = "input index  ";
			msg << i << " is out of bounds for the table";
			Error::abortRun(*this, msg);
			return;
		}
		output%0 << values[i];
}

// prototype instance for known block list
static SDFTable proto;
static RegisterBlock registerBlock(proto,"Table");
