static const char file_id[] = "SDFTableInt.pl";
// .cc file generated from SDFTableInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTableInt.h"

const char *star_nm_SDFTableInt = "SDFTableInt";

const char* SDFTableInt :: className() const {return star_nm_SDFTableInt;}

ISA_FUNC(SDFTableInt,SDFStar);

Block* SDFTableInt :: makeNew() const { LOG_NEW; return new SDFTableInt;}

SDFTableInt::SDFTableInt ()
{
	setDescriptor("This star implements a integer-valued lookup table indexed by an\ninteger-valued input.  The input must lie between 0 and N-1,\ninclusive, where N is the size of the table.  The \"values\" parameter\nspecifies the table.  Its first element is indexed by a zero-valued\ninput. An error occurs if the input value is out of bounds.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(values.setState("values",this,"-1 1","\"table of values to output\""));


}

void SDFTableInt::go() {
# line 38 "SDFTableInt.pl"
int i = int(input%0);
		if (i < 0 || i >= values.size()) {
			StringList msg = "input index  ";
			msg << i << " is out of bounds for the table";
			Error::abortRun(*this, msg);
			return;
		}
		output%0 << values[i];
}

// prototype instance for known block list
static SDFTableInt proto;
static RegisterBlock registerBlock(proto,"TableInt");
