static const char file_id[] = "SDFTest.pl";
// .cc file generated from SDFTest.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTest.h"

const char *star_nm_SDFTest = "SDFTest";

const char* SDFTest :: className() const {return star_nm_SDFTest;}

ISA_FUNC(SDFTest,SDFStar);

Block* SDFTest :: makeNew() const { LOG_NEW; return new SDFTest;}

# line 64 "SDFTest.pl"
#define EQID 0
#define NEID 1
#define GTID 2
#define GEID 3

SDFTest::SDFTest ()
{
	setDescriptor("This star compares its two inputs \"upper\" and \"lower\".\nThe test \"condition\" can be any one of {EQ NE GT GE},\nor equivalently any one of {== != > >=},\nwhose elements represent the binary operations of equals, not equals,\ngreater than, and greater than or equals, respectively.\n\nIf the \"crossingsOnly\" parameter is TRUE, then the output is TRUE only\nwhen the outcome of the test changes from TRUE to FALSE\nor FALSE to TRUE.\nIn this case, the first output is always TRUE.");
	addPort(upper.setPort("upper",this,FLOAT));
	addPort(lower.setPort("lower",this,FLOAT));
	addPort(output.setPort("output",this,INT));
	addState(condition.setState("condition",this,"EQ","The test condition, i.e, one of EQ, NE, LT, or LE."));
	addState(crossingsOnly.setState("crossingsOnly",this,"FALSE","If TRUE, outputs are TRUE only when the sense of the test changes."));


}

void SDFTest::setup() {
# line 74 "SDFTest.pl"
// Initial value indicates that prevResult has not yet
		// gotten the result of a test.
		// This ensures that the first test result will
		// always be TRUE.
		prevResult = -1;

		const char* cn = condition;
		if ( strcasecmp ( cn, "EQ") == 0) test = EQID;
		else if ( strcasecmp ( cn, "NE") == 0) test = NEID;
		else if ( strcasecmp ( cn, "GT") == 0) test = GTID;
		else if ( strcasecmp ( cn, "GE") == 0) test = GEID;
		else if ( strcasecmp ( cn, "==") == 0) test = EQID;
		else if ( strcasecmp ( cn, "!=") == 0) test = NEID;
		else if ( strcasecmp ( cn, ">") == 0) test = GTID;
		else if ( strcasecmp ( cn, ">=") == 0) test = GEID;
		else Error::abortRun(*this,"Unrecognized test.");
}

void SDFTest::go() {
# line 92 "SDFTest.pl"
int result = 0;
		double left = double(upper%0);
		double right = double(lower%0);

		// compare the values
		switch( test ) {
			case EQID:  result  =  left == right;  break;
			case NEID:  result  =  left != right;  break;
			case GTID:  result  =  left >  right;  break;
			case GEID:  result  =  left >= right;  break;
		}
		if (int(crossingsOnly)) {
			if (prevResult != result)
				output%0 << 1;
			else
				output%0 << 0;
		} else output%0 << result;
		prevResult = result;
}

// prototype instance for known block list
static SDFTest proto;
static RegisterBlock registerBlock(proto,"Test");
