static const char file_id[] = "SDFTestMultirate.pl";
// .cc file generated from SDFTestMultirate.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.

Richard Stevens and Christopher Scannell are employees of the
U.S. Government whose contributions to this computer program fall
within the scope of 17 U.S.C. A7 105
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTestMultirate.h"

const char *star_nm_SDFTestMultirate = "SDFTestMultirate";

const char* SDFTestMultirate :: className() const {return star_nm_SDFTestMultirate;}

ISA_FUNC(SDFTestMultirate,SDFStar);

Block* SDFTestMultirate :: makeNew() const { LOG_NEW; return new SDFTestMultirate;}

SDFTestMultirate::SDFTestMultirate ()
{
	setDescriptor("This star consumes and produces any fixed number of tokens\non any number of inputs and outputs.  The output value is always\nzero.  IT IS INTENDED FOR TESTING SCHEDULERS ONLY.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(consume.setState("consume",this,"1","number of inputs consumed for each port"));
	addState(produce.setState("produce",this,"1","number of tokens produced on each output"));


}

void SDFTestMultirate::setup() {
# line 43 "SDFTestMultirate.pl"
if ((input.numberPorts() != consume.size()) ||
	      (output.numberPorts() != produce.size())) {
	    Error::abortRun(*this,
              "list of number of tokens consumed or produced does not match"
	      " the actual number of inputs or outputs.");
	    return;
	  }
	  MPHIter nexti(input);
	  DFPortHole *p;
	  int i = 0;
	  while ((p = (DFPortHole*)nexti++) != 0) {
	    p->setSDFParams(consume[i],1);
	    i++;
	  }
	  MPHIter nexto(output);
	  i = 0;
	  while ((p = (DFPortHole*)nexto++) != 0) {
	    p->setSDFParams(produce[i],1);
	    i++;
	  }
}

void SDFTestMultirate::go() {
# line 65 "SDFTestMultirate.pl"
printf("Running %s\n", name());

	  // Don't need to read each input port: SDF scheduler handles it
	  // because we set setSDFParams for input ports in the setup method

	  // Output the right number of zeroes on each output port
	  MPHIter nexto(output);
	  DFPortHole *p;
	  int j = 0;
	  while ((p = (DFPortHole*)nexto++) != 0) {
	    for (int i = 0; i < produce[j]; i++) {
	      (*p)%i << 0.0;
	    }
	    j++;
	  }
}

// prototype instance for known block list
static SDFTestMultirate proto;
static RegisterBlock registerBlock(proto,"TestMultirate");
