static const char file_id[] = "SDFTrainer.pl";
// .cc file generated from SDFTrainer.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTrainer.h"

const char *star_nm_SDFTrainer = "SDFTrainer";

const char* SDFTrainer :: className() const {return star_nm_SDFTrainer;}

ISA_FUNC(SDFTrainer,SDFStar);

Block* SDFTrainer :: makeNew() const { LOG_NEW; return new SDFTrainer;}

SDFTrainer::SDFTrainer ()
{
	setDescriptor("Pass the value of the \"train\" input to the output for the first \"trainLength\" samples,\nthen pass the \"decision\" input to the output. This star is designed for use with\nadaptive equalizers that require a training sequence at startup, but it can be\nused whenever one sequence is used during a startup phase, and another sequence\nafter that.");
	addState(trainLength.setState("trainLength",this,"100","Number of training samples to use"));
	addPort(train.setPort("train",this,ANYTYPE));
	addPort(decision.setPort("decision",this,ANYTYPE));
	decision.inheritTypeFrom(train);
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(train);


}

void SDFTrainer::setup() {
# line 49 "SDFTrainer.pl"
count = 0;
}

void SDFTrainer::go() {
# line 52 "SDFTrainer.pl"
if (count < int(trainLength)) {
			output%0 = train%0;
			count++;
		}
		else {
			output%0 = decision%0;
		}
}

// prototype instance for known block list
static SDFTrainer proto;
static RegisterBlock registerBlock(proto,"Trainer");
