static const char file_id[] = "SDFTranspose.pl";
// .cc file generated from SDFTranspose.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTranspose.h"

const char *star_nm_SDFTranspose = "SDFTranspose";

const char* SDFTranspose :: className() const {return star_nm_SDFTranspose;}

ISA_FUNC(SDFTranspose,SDFStar);

Block* SDFTranspose :: makeNew() const { LOG_NEW; return new SDFTranspose;}

SDFTranspose::SDFTranspose ()
{
	setDescriptor("Transpose a rasterized matrix (one that is read as a sequence\nof particles, row by row, and written in the same form).\nThe number of particles produced and consumed equals the product\nof \"samplesInaRow\" and \"numberOfRows\".");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(samplesInaRow.setState("samplesInaRow",this,"8","The number of input samples constituting a row."));
	addState(numberOfRows.setState("numberOfRows",this,"8","The number of rows in the input matrix."));


}

void SDFTranspose::setup() {
# line 43 "SDFTranspose.pl"
size = int(samplesInaRow)*int(numberOfRows);
		input.setSDFParams(size, size-1);
		output.setSDFParams(size, size-1);
}

void SDFTranspose::go() {
# line 48 "SDFTranspose.pl"
for(int i=int(samplesInaRow)-1; i >= 0; i-- ) {
		for(int j=int(numberOfRows)-1; j >= 0; j-- ) {
		    output%(j+i*int(numberOfRows)) =
			input%(i+j*int(samplesInaRow));
		}
	    }
}

// prototype instance for known block list
static SDFTranspose proto;
static RegisterBlock registerBlock(proto,"Transpose");
