static const char file_id[] = "SDFUpSample.pl";
// .cc file generated from SDFUpSample.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFUpSample.h"

const char *star_nm_SDFUpSample = "SDFUpSample";

const char* SDFUpSample :: className() const {return star_nm_SDFUpSample;}

ISA_FUNC(SDFUpSample,SDFStar);

Block* SDFUpSample :: makeNew() const { LOG_NEW; return new SDFUpSample;}

SDFUpSample::SDFUpSample ()
{
	setDescriptor("Upsample by a given \"factor\" (default 2), filling with \"fill\" (default 0.0).\nThe \"phase\" parameter tells where to put the sample in an output block.\nThe default is to output it first (phase = 0). The maximum phase is \"factor\" - 1.\nAlthough the \"fill\" parameter is a floating-point number, if the input is of\nsome other type, such as complex, the fill particle will be obtained by casting\n\"fill\" to the appropriate type.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(factor.setState("factor",this,"2","Number of samples produced."));
	addState(phase.setState("phase",this,"0","Where to put the input in the output block."));
	addState(fill.setState("fill",this,"0.0","Value to fill the output block."));


}

void SDFUpSample::setup() {
# line 48 "SDFUpSample.pl"
output.setSDFParams(int(factor),int(factor)-1);
		if (int(phase) >= int(factor))
			Error::abortRun(*this, ": phase must be < factor");
}

void SDFUpSample::go() {
# line 53 "SDFUpSample.pl"
int i, match = int(factor)-int(phase)-1;
		for (i = 0; i < int(factor); i++)
			if (i == match)
				output%i = input%0;
			else
				output%i << double(fill);
		// yes, the previous statement really does work correctly
		// even if the type of the output is resolved to COMPLEX
		// or INT.  The appropriate conversion is performed.
}

// prototype instance for known block list
static SDFUpSample proto;
static RegisterBlock registerBlock(proto,"UpSample");
