static const char file_id[] = "SDFWaveForm.pl";
// .cc file generated from SDFWaveForm.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFWaveForm.h"
#include "SimControl.h"

const char *star_nm_SDFWaveForm = "SDFWaveForm";

const char* SDFWaveForm :: className() const {return star_nm_SDFWaveForm;}

ISA_FUNC(SDFWaveForm,SDFStar);

Block* SDFWaveForm :: makeNew() const { LOG_NEW; return new SDFWaveForm;}

SDFWaveForm::SDFWaveForm ()
{
	setDescriptor("Output a waveform as specified by the array state \"value\" (default \"1 -1\").\nYou can get periodic signals with any period, and can halt a simulation\nat the end of the given waveform.  The following table summarizes the\ncapabilities:\n.nf\nhaltAtEnd   periodic   period    operation\n-----------------------------------------------------------------------\nNO          YES        0         The period is the length of the waveform\nNO          YES        N>0       The period is N\nNO          NO         anything  Output the waveform once, then zeros\nYES         anything   anything  Stop after outputting the waveform once\n.fi\nThe first line of the table gives the default settings.\nThis star may be used to read a file by simply setting\n\"value\" to something of the form \"< filename\".");
	addPort(output.setPort("output",this,FLOAT));
	addState(value.setState("value",this,"1 -1","One period of the output waveform."));
	addState(haltAtEnd.setState("haltAtEnd",this,"NO","Halt the run at the end of the given data."));
	addState(periodic.setState("periodic",this,"YES","Output is periodic if \"YES\" (nonzero)."));
	addState(period.setState("period",this,"0","If greater than zero, gives the period of the waveform."));


}

void SDFWaveForm::setup() {
# line 77 "SDFWaveForm.pl"
pos = 0;
}

void SDFWaveForm::go() {
# line 80 "SDFWaveForm.pl"
if (int(haltAtEnd) && (pos >= value.size()))
			SimControl::requestHalt();
		if (pos >= value.size()) {
			output%0 << 0.0;
			pos++;
		} else
			output%0 << value[pos++];
		if (int(periodic))
		    if(int(period) <= 0 && pos >= value.size()) pos = 0;
		    else if (int(period) > 0 && pos >= int(period)) pos = 0;
}

// prototype instance for known block list
static SDFWaveForm proto;
static RegisterBlock registerBlock(proto,"WaveForm");
