static const char file_id[] = "SDFWaveFormCx.pl";
// .cc file generated from SDFWaveFormCx.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFWaveFormCx.h"
#include "SimControl.h"

const char *star_nm_SDFWaveFormCx = "SDFWaveFormCx";

const char* SDFWaveFormCx :: className() const {return star_nm_SDFWaveFormCx;}

ISA_FUNC(SDFWaveFormCx,SDFStar);

Block* SDFWaveFormCx :: makeNew() const { LOG_NEW; return new SDFWaveFormCx;}

SDFWaveFormCx::SDFWaveFormCx ()
{
	setDescriptor("Output a complex waveform as specified by the array state \"value\"\n(default \"(1,0) (-1,0)\").\nThe parameters work the same way as in the WaveForm star.\nThis star may be used to read a file by simply setting \"value\" to\nsomething of the form \"< filename\".");
	addPort(output.setPort("output",this,COMPLEX));
	addState(value.setState("value",this,"(1,0) (-1,0)","One period of the output waveform."));
	addState(haltAtEnd.setState("haltAtEnd",this,"NO","Halt the run at the end of the given data."));
	addState(periodic.setState("periodic",this,"YES","Output is periodic if \"YES\" (nonzero)."));


}

void SDFWaveFormCx::setup() {
# line 55 "SDFWaveFormCx.pl"
pos = 0;
}

void SDFWaveFormCx::go() {
# line 58 "SDFWaveFormCx.pl"
if (int(haltAtEnd) && (pos >= value.size()))
			SimControl::requestHalt();
		if (pos >= value.size())
			output%0 << Complex(0.0,0.0);
		else
			output%0 << Complex(value[pos++]);
		if (int(periodic) && pos >= value.size()) pos = 0;
}

// prototype instance for known block list
static SDFWaveFormCx proto;
static RegisterBlock registerBlock(proto,"WaveFormCx");
