static const char file_id[] = "SDFWriteVar.pl";
// .cc file generated from SDFWriteVar.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFWriteVar.h"

const char *star_nm_SDFWriteVar = "SDFWriteVar";

const char* SDFWriteVar :: className() const {return star_nm_SDFWriteVar;}

ISA_FUNC(SDFWriteVar,SDFSharedMem);

Block* SDFWriteVar :: makeNew() const { LOG_NEW; return new SDFWriteVar;}

SDFWriteVar::SDFWriteVar ()
{
	setDescriptor("Write the value of the input to a double-precision floating-point variable\nin shared memory.  Use the ReadVar star to read values from the shared memory.\n\nWARNING: This star may produce unpredictable results, since the results\nwill depend on the precedences in the block diagram in which it appears\nas well as the scheduler (target) used.");
	addPort(in.setPort("in",this,FLOAT));
	addState(name.setState("name",this,"0","Name of the register"));

# line 39 "SDFWriteVar.pl"
lastname = 0;
}

SDFWriteVar::~SDFWriteVar() {
# line 43 "SDFWriteVar.pl"
if (lastname) {
      SDFSharedMem::RemoveVar(lastname);
    }
    delete [] lastname;
}

void SDFWriteVar::setup() {
# line 49 "SDFWriteVar.pl"
const char* namestring = name;
    if (lastname) {
      SDFSharedMem::RemoveVar(lastname);
      delete [] lastname;
    }
    lastname = savestring(namestring);
}

void SDFWriteVar::go() {
# line 58 "SDFWriteVar.pl"
double val = double(in%0);

    // Write val to register 'name' and create 'name' if it doesn't exist
    SDFSharedMem::WriteVar(name, val);
}

// prototype instance for known block list
static SDFWriteVar proto;
static RegisterBlock registerBlock(proto,"WriteVar");
