static const char file_id[] = "SDFXMgraph.pl";
// .cc file generated from SDFXMgraph.pl by ptlang
/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFXMgraph.h"

const char *star_nm_SDFXMgraph = "SDFXMgraph";

const char* SDFXMgraph :: className() const {return star_nm_SDFXMgraph;}

ISA_FUNC(SDFXMgraph,SDFStar);

Block* SDFXMgraph :: makeNew() const { LOG_NEW; return new SDFXMgraph;}

SDFXMgraph::SDFXMgraph ()
{
	setDescriptor("Generate a multi-signal plot with the xgraph program.\nThis program has many options; see the User's manual\nof The Almagest.");
	addPort(input.setPort("input",this,FLOAT));
	addState(title.setState("title",this,"Ptolemy Xgraph","Title for the plot."));
	addState(saveFile.setState("saveFile",this,"","File name for saving plottable data."));
	addState(options.setState("options",this,"-bb -tk =800x400","Command line options for the xgraph program."));
	addState(ignore.setState("ignore",this,"0","Number of initial values to ignore."));
	addState(xUnits.setState("xUnits",this,"1.0","For labeling, horizontal increment between samples."));
	addState(xInit.setState("xInit",this,"0.0","For labeling, horizontal value of the first sample."));


}

void SDFXMgraph::wrapup() {
# line 92 "SDFXMgraph.pl"
graph.terminate();
}

void SDFXMgraph::setup() {
# line 79 "SDFXMgraph.pl"
graph.initialize(this, input.numberPorts(),
			options, title, saveFile, ignore);
		index = xInit;
}

void SDFXMgraph::go() {
# line 85 "SDFXMgraph.pl"
MPHIter nexti(input);
		for (int i = 1; i <= input.numberPorts(); i++) {
			graph.addPoint(i, index, float((*nexti++)%0));
		}
		index += double(xUnits);
}

// prototype instance for known block list
static SDFXMgraph proto;
static RegisterBlock registerBlock(proto,"XMgraph");
