static const char file_id[] = "SDFLMSCxTkPlot.pl";
// .cc file generated from SDFLMSCxTkPlot.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFLMSCxTkPlot.h"

const char *star_nm_SDFLMSCxTkPlot = "SDFLMSCxTkPlot";

const char* SDFLMSCxTkPlot :: className() const {return star_nm_SDFLMSCxTkPlot;}

ISA_FUNC(SDFLMSCxTkPlot,SDFLMSCx);

Block* SDFLMSCxTkPlot :: makeNew() const { LOG_NEW; return new SDFLMSCxTkPlot;}

# line 241 "SDFLMSCxTkPlot.pl"
static int
	    reset(ClientData star, Tcl_Interp*, int, char*[])
	    {
		((SDFLMSCxTkPlot*)star)->resetTaps();
		return TCL_OK;
	    }
	    static int
	    setStep(ClientData star, Tcl_Interp*, int, char *argv[])
	    {
		((SDFLMSCxTkPlot*)star)->setStepSize(argv[1]);
		return TCL_OK;
	    }

	    // The following line initializes the member "instCount"
	    // when the .o file is loaded.
	    int SDFLMSCxTkPlot::instCount = 0;

SDFLMSCxTkPlot::SDFLMSCxTkPlot ()
{
	setDescriptor("This is just like the LMSCx star, but with an animated\nTk display of the taps, plus associated controls.");
	addState(stepSizeLow.setState("stepSizeLow",this,"0.0","Low end of the step size scale"));
	addState(stepSizeHigh.setState("stepSizeHigh",this,"0.1","High end of the step size scale"));
	addState(fullScale.setState("fullScale",this,"1.0","Full scale on the tap display"));
	addState(geometry.setState("geometry",this,"+500+000","Specified the location and/or size of the window"));
	addState(width.setState("width",this,"10.0","Width of the bar chart display, in centimeters"));
	addState(height.setState("height",this,"5.0","Height of the bar chart display, in centimeters"));
	addState(identifier.setState("identifier",this,"LMSCx filter taps: Real (red) & Imag (blue)","The string to identify the run-time display."));
	addState(updateInterval.setState("updateInterval",this,"10","Number of invocations between display updates."));

# line 87 "SDFLMSCxTkPlot.pl"
// Name of the reset button
	    myInst = instCount++;
	    butName = "sdfLMSCxTkPlotreset";
	    butName += myInst;
	    sliderName = "sdfLMSCxTkPlotscale";
	    sliderName += myInst;
	    position = 0;
}

void SDFLMSCxTkPlot::begin() {
# line 125 "SDFLMSCxTkPlot.pl"
InfString idCopy((const char*)identifier);
	    InfString geoCopy((const char*)geometry);
	    if ( bg.setup(this,(char*)idCopy,2,taps.size(),
			  double(fullScale), - double(fullScale),
			  (char*)geoCopy, double(width),
			  double(height)) == 0 ) {
		Error::abortRun(*this, "Cannot create bar chart");
		return;
	    }

	    // Register the callback functions with Tcl
	    command = sliderName;
	    Tcl_CreateCommand(ptkInterp, (char*)command, setStep,
			      (ClientData)this, NULL);
	    command = butName;
	    Tcl_CreateCommand(ptkInterp, (char*)command, reset,
			      (ClientData)this, NULL);

	    // Put controls entries into the window
	    // First, a button to reset the taps
	    command = "ptkMakeButton ";
	    command += bg.winName;
	    command += ".middle ";
	    command += butName;
	    command += " {Reset taps} ";
	    command += butName;
	    Tcl_GlobalEval(ptkInterp, (char*)command);
	    	
	    // Next, a slider to control the step size
	    command = "ptkMakeScale ";
	    command += bg.winName;
	    command += ".low ";
	    command += sliderName;
	    command += " {step size} ";
	    command += position;
	    command += " ";
	    command += sliderName;
	    if ( Tcl_GlobalEval(ptkInterp, (char*)command) != TCL_OK )
		Error::warn(*this,"Cannot make step size control");

	    // display the slider value
	    command = bg.winName;
	    command += ".low.";
	    command += sliderName;
	    command += ".value configure -text {";
	    command += double(stepSize);
	    command += "}";
	    if ( Tcl_GlobalEval(ptkInterp, (char*)command) != TCL_OK )
		Error::warn(*this,"Cannot update step size display");

	    // set the scale position
	    command = bg.winName;
	    command += ".low.";
	    command += sliderName;
	    command += ".scale set ";
	    command += position;
	    if ( Tcl_GlobalEval(ptkInterp, (char*)command) != TCL_OK )
		Error::warn(*this,"Cannot set step size slider position");

	    SDFLMSCx :: begin();
}

SDFLMSCxTkPlot::~SDFLMSCxTkPlot() {
# line 96 "SDFLMSCxTkPlot.pl"
// exit if no interpreter
	    if (!ptkInterp) return;

	    // Remove Tcl commands
	    command = butName;
	    Tcl_DeleteCommand (ptkInterp, (char*)command);

	    command = sliderName;
	    Tcl_DeleteCommand(ptkInterp, (char*)command);
}

void SDFLMSCxTkPlot::setup() {
# line 107 "SDFLMSCxTkPlot.pl"
// Initialize iteration count
	    invCount = 0;
    
	    // Compute slider position from parameters
	    position = int(0.5 + 100*(double(stepSize)
			    - double(stepSizeLow))/(double(stepSizeHigh)
			    - double(stepSizeLow)));

	    // Check that the slider position is in the range of 0 to 100
	    if ((position < 0) || (position > 100)) {
        	    Error::abortRun(*this,
			"Step size is out of range of control");
        	    return;
	    }

	    SDFLMSCx :: setup();
}

void SDFLMSCxTkPlot::go() {
# line 187 "SDFLMSCxTkPlot.pl"
SDFLMSCx :: go();
	    if (invCount++ >= int(updateInterval)) {
		invCount = 0;
		redrawTaps();
	    }
}


void SDFLMSCxTkPlot::resetTaps ()
{
# line 199 "SDFLMSCxTkPlot.pl"
taps.initialize();
		redrawTaps();
}


void SDFLMSCxTkPlot::redrawTaps ()
{
# line 209 "SDFLMSCxTkPlot.pl"
for(int i=0; i < taps.size(); i++)
		    if ( (bg.update(1,i,imag(taps[i])) == 0) ||
		         (bg.update(0,i,real(taps[i])) == 0) )
			Error::abortRun(*this,"Cannot update bar graph.");
}


void SDFLMSCxTkPlot::setStepSize (char *newValue)
{
# line 221 "SDFLMSCxTkPlot.pl"
int position;
		if (sscanf(newValue, "%d", &position) != 1) {
		    Error::abortRun(*this,"Invalid value for step size");
		    return;
		}
		stepSize = double(stepSizeLow)
		    + (double(stepSizeHigh) - double(stepSizeLow))
		    * (position/100.0);
		// display the slider value
		command = bg.winName;
		command += ".low.";
		command += sliderName;
		command += ".value configure -text {";
		command += double(stepSize);
		command += "}";
		if ( Tcl_GlobalEval(ptkInterp, (char*)command) != TCL_OK )
		    Error::abortRun(*this,"Cannot update step size display");
}


// prototype instance for known block list
static SDFLMSCxTkPlot proto;
static RegisterBlock registerBlock(proto,"LMSCxTkPlot");
