static const char file_id[] = "SDFTkBarGraph.pl";
// .cc file generated from SDFTkBarGraph.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTkBarGraph.h"

const char *star_nm_SDFTkBarGraph = "SDFTkBarGraph";

const char* SDFTkBarGraph :: className() const {return star_nm_SDFTkBarGraph;}

ISA_FUNC(SDFTkBarGraph,SDFStar);

Block* SDFTkBarGraph :: makeNew() const { LOG_NEW; return new SDFTkBarGraph;}

SDFTkBarGraph::SDFTkBarGraph ()
{
	setDescriptor("Dynamically display the value of any number of input signals in bar-chart form.\nThe first 12 input signals will be assigned distinct colors. After that,\nthe colors are repeated. The colors can be controlled using X resources.");
	addPort(input.setPort("input",this,ANYTYPE));
	addState(label.setState("label",this,"bar chart display","A label to put on the display"));
	addState(top.setState("top",this,"1.0","Low end of the scale"));
	addState(bottom.setState("bottom",this,"-1.0","High end of the scale"));
	addState(number_of_bars.setState("number_of_bars",this,"16","Number of bars to display"));
	addState(bar_graph_height.setState("bar_graph_height",this,"5","Desired height of the bar graph in centimeters"));
	addState(bar_graph_width.setState("bar_graph_width",this,"10","Desired width of the bar graph in centimeters"));
	addState(position.setState("position",this,"+0+0","Width of the bar graph in centimeters"));
	addState(updateSize.setState("updateSize",this,"1","To speed up the display, this many bars are updated at once"));

# line 82 "SDFTkBarGraph.pl"
labCopy = posCopy = 0;
}

void SDFTkBarGraph::begin() {
# line 95 "SDFTkBarGraph.pl"
// Need to make non-const copies of "position" and "label"
	    delete [] posCopy;
	    posCopy = savestring((const char*)position);
	    delete [] labCopy;
	    labCopy = savestring((const char*)label);
	    bar.setup(this,
		labCopy,
		input.numberPorts(),
		(int) number_of_bars,
		(double) top,
		(double) bottom,
		posCopy,
		(double) bar_graph_width,
		(double) bar_graph_height);
	    count = batchCount = 0;
}

SDFTkBarGraph::~SDFTkBarGraph() {
# line 85 "SDFTkBarGraph.pl"
delete [] labCopy;
	    delete [] posCopy;
}

void SDFTkBarGraph::setup() {
# line 89 "SDFTkBarGraph.pl"
if(double(top) <= double(bottom)) {
		Error::abortRun(*this, "invalid range for the scale");
	    }
	    input.setSDFParams(1, int(updateSize) - 1);
}

void SDFTkBarGraph::go() {
# line 112 "SDFTkBarGraph.pl"
if (++batchCount == (int)updateSize) {
	    batchCount = 0;
	    MPHIter nexti(input);
	    PortHole *p;
	    // Iterate over the number of points to be plotted at once.
	    for (int j = (int)updateSize-1; j >= 0; j--) {
	      int i=0;
	      while ((p = nexti++) != 0) {
		if(bar.update(i++,count,(*p)%j) == FALSE) {
		  Error::abortRun(*this, "failed to update bar chart");
		  return;
		}
	      }
	      nexti.reset();
	      count++;
	      if(count >= int(number_of_bars)) count=0;
	    }
	  }
}

// prototype instance for known block list
static SDFTkBarGraph proto;
static RegisterBlock registerBlock(proto,"TkBarGraph");
