static const char file_id[] = "SDFTkButtons.pl";
// .cc file generated from SDFTkButtons.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTkButtons.h"

const char *star_nm_SDFTkButtons = "SDFTkButtons";

const char* SDFTkButtons :: className() const {return star_nm_SDFTkButtons;}

ISA_FUNC(SDFTkButtons,SDFTclScript);

Block* SDFTkButtons :: makeNew() const { LOG_NEW; return new SDFTkButtons;}

SDFTkButtons::SDFTkButtons ()
{
	setDescriptor("This star outputs the value 0.0 on all outputs unless the correspoding\nbutton is pushed.  When the button is pused, the output takes the value\ngiven by the parameter \"value\".  If \"synchronous\" is YES, then outputs\nare produced only when some button is pushed.  I.e., the star waits for\na button to be pushed before its go method returns.\nIf \"allow_simultaneous_events\" is yes, then buttons pushed are registered\nonly when the button labeled \"PUSH TO PRODUCE OUTPUTS\" is pushed.\nNote that if \"synchronous\" is NO, this star is nondeterminate.");
	addState(label.setState("label",this,"Buttons you can push:","Title for the set of buttons"));
	addState(identifiers.setState("identifiers",this,"BUTTON1","A list of strings that identify each button"));
	addState(value.setState("value",this,"1.0","The value produced when a button is pushed"));
	addState(allow_simultaneous_events.setState("allow_simultaneous_events",this,"NO","If YES, allow buttons to produce simultaneous output values"));
	addState(synchronous.setState("synchronous",this,"NO","If YES, wait until a button is pushed before returning from the go method"));
	addState(put_in_control_panel.setState("put_in_control_panel",this,"YES","Specify to put slider in the control panel (vs. its own window)"));

# line 79 "SDFTkButtons.pl"
// Hide irrelevant outputs and states.
	    input.setAttributes(P_HIDDEN);
	    tcl_file.clearAttributes(A_SETTABLE);
}

void SDFTkButtons::begin() {
# line 72 "SDFTkButtons.pl"
// Set parameter values that are not user settable.
	    tcl_file =
		"$PTOLEMY/src/domains/sdf/tcltk/stars/tkButtons.tcl";

	    SDFTclScript::begin();
}

void SDFTkButtons::setup() {
# line 62 "SDFTkButtons.pl"
if (input.numberPorts() > 0) {
		Error::abortRun(*this, "Inputs not supported");
		return;
	    }
	    if (output.numberPorts() > identifiers.size()) {
		Error::abortRun(*this, "Need as many identifiers as outputs");
		return;
	    }
}

void SDFTkButtons::go() {
# line 84 "SDFTkButtons.pl"
// First, call the go method in the parent.
	  // This produces all the outputs with the current value of the
	  // output array.
	  SDFTclScript::go();

	  // Next, reset the output array so that the values are not reused
	  // next time the star fires.
	  for (int i=0; i < output.numberPorts(); i++) {
	    tcl.setOneOutput(i, 0.0);
	  }
}

// prototype instance for known block list
static SDFTkButtons proto;
static RegisterBlock registerBlock(proto,"TkButtons");
