static const char file_id[] = "SDFTkPlot.pl";
// .cc file generated from SDFTkPlot.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTkPlot.h"

const char *star_nm_SDFTkPlot = "SDFTkPlot";

const char* SDFTkPlot :: className() const {return star_nm_SDFTkPlot;}

ISA_FUNC(SDFTkPlot,SDFTkXYPlot);

Block* SDFTkPlot :: makeNew() const { LOG_NEW; return new SDFTkPlot;}

SDFTkPlot::SDFTkPlot ()
{
	setDescriptor("Plot Y input(s) vs. time with dynamic updating.\nTwo styles are currently supported: \"dot\" causes\nindividual points to be plotted, whereas \"connect\" causes\nconnected lines to be plotted. Drawing a box in the plot\nwill reset the plot area to that outlined by the box.\nThere are also buttons for zooming in and out, and for\nresizing the box to just fit the data in view.");
	addState(repeat_border_points.setState("repeat_border_points",this,"YES","For better visual continuity, rightmost events are repeated on the left"));

# line 41 "SDFTkPlot.pl"
// Change default parameter values
	  label.setInitValue("Tk Plot");
	  xTitle.setInitValue("n");
	  xRange.setInitValue("0 100");
	  style.setInitValue("connect");
	  X.setAttributes(P_HIDDEN);
}

void SDFTkPlot::setup() {
# line 52 "SDFTkPlot.pl"
sampleCount = 0;
}

void SDFTkPlot::go() {
# line 55 "SDFTkPlot.pl"
MPHIter nexty(Y);
	  PortHole *py;
	  int set = 1;
	  while ((py = nexty++) != 0) {
	    xyplot.addPoint(sampleCount,(double)((*py)%0), set++);
	  }
	  sampleCount += 1;
	  if (sampleCount > int(xRange[1])) {
	    sampleCount = int(xRange[0]);
	    // Plot the points all over again for continuity
	    nexty.reset();
	    set = 1;
	    while ((py = nexty++) != 0) {
	      xyplot.breakPlot(set);
	      if ((int)repeat_border_points) {
		xyplot.addPoint(sampleCount,(double)((*py)%0), set);
	      }
	      set++;
	    }
	    if ((int)repeat_border_points) sampleCount += 1;
	  }
}

// prototype instance for known block list
static SDFTkPlot proto;
static RegisterBlock registerBlock(proto,"TkPlot");
