static const char file_id[] = "SDFTkXYPlot.pl";
// .cc file generated from SDFTkXYPlot.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFTkXYPlot.h"

const char *star_nm_SDFTkXYPlot = "SDFTkXYPlot";

const char* SDFTkXYPlot :: className() const {return star_nm_SDFTkXYPlot;}

ISA_FUNC(SDFTkXYPlot,SDFStar);

Block* SDFTkXYPlot :: makeNew() const { LOG_NEW; return new SDFTkXYPlot;}

SDFTkXYPlot::SDFTkXYPlot ()
{
	setDescriptor("Plot Y input(s) vs. X input(s) with dynamic updating.\nTwo styles are currently supported: \"dot\" causes\npoints to be plotted, whereas \"connect\" causes connected\nlines to be plotted. Drawing a box in the plot will\nreset the plot area to that outlined by the box.\nThere are also buttons for zooming in and out, and for\nresizing the box to just fit the data in view.");
	addState(label.setState("label",this,"Tk XY Plot","The title of the plot"));
	addState(geometry.setState("geometry",this,"720x400+0+0","Specified the location and/or size of the window"));
	addState(xTitle.setState("xTitle",this,"x","The x-axis label"));
	addState(yTitle.setState("yTitle",this,"y","The y-axis label"));
	addState(xRange.setState("xRange",this,"-1.5 1.5","The range of x-coordinate values"));
	addState(yRange.setState("yRange",this,"-1.5 1.5","The range of y-coordinate values"));
	addState(persistence.setState("persistence",this,"100","The number of points displayed at any one time"));
	addState(style.setState("style",this,"dot","Plot styles are dot or connect"));
	addState(updateSize.setState("updateSize",this,"10","The number of points drawn simulataneously. Higher numbers make the response faster."));
	addPort(X.setPort("X",this,FLOAT));
	addPort(Y.setPort("Y",this,FLOAT));

# line 135 "SDFTkXYPlot.pl"
labCopy = geoCopy = xtCopy = ytCopy = 0;
}

void SDFTkXYPlot::begin() {
# line 154 "SDFTkXYPlot.pl"
// Need to make non-const copies of strings to
	  // avoid compilation warnings
	  delete [] labCopy;
	  labCopy = savestring( (const char*)label );
	  delete [] geoCopy;
	  geoCopy = savestring( (const char*)geometry );
	  delete [] xtCopy;
	  xtCopy = savestring( (const char*)xTitle );
	  delete [] ytCopy;
	  ytCopy = savestring( (const char*)yTitle );

	  int plotstyle = 0;
	  if (strcmp(style, "connect") == 0) plotstyle = 1;

	  // create the XYplot window labeling, scaling,
	  // and ranging as specified by the parameters
	  xyplot.setup(		this,
		       		labCopy,     // label for XY plot
			(int)	persistence, // number data points to retain
			(int)	updateSize,  // number data points between refreshes
				geoCopy,     // geometry for the window
				xtCopy,      // title for X-axis
				xRange[0],   // minimum X range value
				xRange[1],   // maximum X range value
				ytCopy,      // title for Y-axis
				yRange[0],   // minimum Y range value
				yRange[1],   // maximum Y range value
				Y.numberPorts(),   // number of data sets
			(int)	plotstyle);  // plot style to use
}

SDFTkXYPlot::~SDFTkXYPlot() {
# line 147 "SDFTkXYPlot.pl"
delete [] labCopy;
	  delete [] geoCopy;
	  delete [] xtCopy;
	  delete [] ytCopy;
}

void SDFTkXYPlot::setup() {
# line 139 "SDFTkXYPlot.pl"
// Check for valid x and y ranges.  They should each be a
	  // float array with the two elements, with the first element
	  // being less than the second.
	  if (!validRange(xRange)) return;
	  if (!validRange(yRange)) return;
}

void SDFTkXYPlot::go() {
# line 186 "SDFTkXYPlot.pl"
MPHIter nextx(X), nexty(Y);
	  PortHole *px, *py = (PortHole *)NULL;
	  int set = 1;
	  while ((px = nextx++) != 0 && (py = nexty++) != 0) {
	    xyplot.addPoint((double)((*px)%0),(double)((*py)%0), set++);
	  }
}


int SDFTkXYPlot::validRange (FloatArrayState& range)
{
# line 113 "SDFTkXYPlot.pl"
if (range.size() != 2) {
	      StringList msg;
	      msg << "State \"" << range.name() << "\" should be a float "
	        << "array with two elements, but it has " << range.size() 
		<< " elements.";
	      Error::abortRun(*this, msg);
	      return FALSE;
	    }
	    if (range[0] >= range[1]) {
	      StringList msg;
	      msg << "The first number in the float array state \""
	          << range.name() << "\" should be less than the second, "
		  << "but they are " << range[0] << " and " << range[1]
	          << ", respectively."; 
	      Error::abortRun(*this, msg);
	      return FALSE;
	    }
	    return TRUE;  // the float array "range" is valid
}


// prototype instance for known block list
static SDFTkXYPlot proto;
static RegisterBlock registerBlock(proto,"TkXYPlot");
