.EQ
delim off
.EN
.\" documentation file generated from VHDLWindow.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "Window"
.SD
Generate standard window functions or periodic repetitions of standard
window functions.
The possible functions are: Rectangle, Bartlett, Hanning, Hamming,
Blackman, Kaiser, and SteepBlackman.
One period of samples is produced at each firing.
.SE
.LO "VHDL main library"
.DM VHDL VHDLStar
.SV 1.3 "3/11/96"
.AL "Michael C. Williamson, Kennard White"
.AC "William Chen"
.OH
.NE
\fIoutput\fR (float)
.PE
.SH
.NE
\fIname\fR (StringState): Name of the window function to generate:
Rectangle, Bartlett, Hanning, Hamming, Blackman, SteepBlackman, or Kaiser.
.DF "Hanning"
.NE
\fIlength\fR (IntState): Length of the window function to produce.
.DF "256"
.NE
\fIperiod\fR (IntState): Period of the output. Period 0 implies "length" period, and
a negative period is non-periodic (single cycle).
.DF "0"
.NE
\fIWindowParameters\fR (FloatArrayState): An array of numeric parameters for the window.
For the Kaiser window, the first entry in this state is taken as the
beta parameter which is proportional to the stopband attenuation of
the window.
.DF "0"
.NE
\fIWindowValues\fR (FloatArrayState): An array of numeric values for the window.
The values to be output will be calculated and
stored in this array in preparation for output.
.DF "0"
.ET
.EQ
delim $$
.EN
.LD
.lp
This star produces on its output values that are samples of a standard
windowing function.
The windowing function is determined by the \fIname\fR string parameter.
Possible values are: \fBRectangle\fR, \fBBartlett\fR, \fBHanning\fR,
\fBHamming\fR, \fBBlackman\fR, \fBKaiser\fR and \fBSteepBlackman\fR.
Upper- and lower-case characters in the names are equivalent.
.lp
The parameter \fIlength\fR is the length of the window to produce.
Note that most window functions have a zero value at the first and last sample.
The parameter \fIperiod\fR specifies the period of the output signal:
the window will be zero-padded if required.
A \fIperiod\fR of 0 means a period equal to \fIlength\fR.
A negative period will produce only one window, and then output zero
for all later samples.
A period of less than the window length will be equivalent to a period of
the window length (i.e., \fIperiod\fR = 0).
.UH REFERENCES
.ip [1]
Leland Jackson, Digital Filters and Signal Processing, 2nd ed.,
Kluwer Academic Publishers, ISBN 0-89838-276-9, 1989.
.ES
