static const char file_id[] = "VHDLAverage.pl";
// .cc file generated from VHDLAverage.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
      All rights reserved.
      See the file $PTOLEMY/copyright for copyright notice,
      limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLAverage.h"

const char *star_nm_VHDLAverage = "VHDLAverage";

const char* VHDLAverage :: className() const {return star_nm_VHDLAverage;}

ISA_FUNC(VHDLAverage,VHDLStar);

Block* VHDLAverage :: makeNew() const { LOG_NEW; return new VHDLAverage;}

VHDLAverage::VHDLAverage ()
{
	setDescriptor("Average some number of input samples or blocks of input samples.\n      Blocks of successive input samples are treated as vectors.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(numInputsToAverage.setState("numInputsToAverage",this,"8","The number of input samples or blocks to average."));
	addState(blockSize.setState("blockSize",this,"1","Input blocks of this size will be averaged to produce an output block."));


}

void VHDLAverage::setup() {
# line 40 "VHDLAverage.pl"
input.setSDFParams(int(blockSize)*int(numInputsToAverage),
		       int(blockSize)*int(numInputsToAverage)-1);
    output.setSDFParams(int(blockSize), int(blockSize)-1);
}

void VHDLAverage::go() {
# line 45 "VHDLAverage.pl"
StringList out;
    for(int i=int(blockSize)-1; i >= 0; i-- ) {
      out << "$temp(avg,float) := 0.0;\n";
      for(int j=int(numInputsToAverage)-1; j >= 0; j-- ) {
	out << "$temp(avg,float) := $temp(avg,float) + ";
	out << "$ref(input, ";
	out << -j*int(blockSize)+i;
	out << ");\n";
      }
      out << "$ref(output, ";
      out << -i;
      out << ") $assign(output) $temp(avg,float) / ";
      // Cast to float indirectly to satisfy VHDL compiler.
      int numInt = int(numInputsToAverage);
      float numFloat = numInt;
      out << numFloat;
      out << ";\n";
    }

    addCode(out);
    out.initialize();
}

// prototype instance for known block list
static VHDLAverage proto;
static RegisterBlock registerBlock(proto,"Average");
