static const char file_id[] = "VHDLDistributor.pl";
// .cc file generated from VHDLDistributor.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLDistributor.h"

const char *star_nm_VHDLDistributor = "VHDLDistributor";

const char* VHDLDistributor :: className() const {return star_nm_VHDLDistributor;}

ISA_FUNC(VHDLDistributor,VHDLStar);

Block* VHDLDistributor :: makeNew() const { LOG_NEW; return new VHDLDistributor;}

VHDLDistributor::VHDLDistributor ()
{
	setDescriptor("Takes one input stream and synchronously splits it into N output streams,\nwhere N is the number of outputs.  It consumes N*B input particles,\nwhere B = blockSize, and sends the first B particles to the first output,\nthe next B particles to the next output, etc.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(blockSize.setState("blockSize",this,"1","Number of particles in a block."));


}

void VHDLDistributor::setup() {
# line 34 "VHDLDistributor.pl"
int n = output.numberPorts();
		input.setSDFParams(n*int(blockSize),n*int(blockSize)-1);
		output.setSDFParams(int(blockSize),int(blockSize)-1);
}

void VHDLDistributor::go() {
# line 40 "VHDLDistributor.pl"
StringList out;

	  if (strcmp(input.resolvedType(), "COMPLEX") == 0) {
	    for (int i = output.numberPorts() -1 ; i >= 0 ; i--) {
	      for (int j = int(blockSize)-1 ; j >= 0 ; j--) {
		out << "$refCx(output#";
		out << i+1;
		out << ", ";
		out << -j;
		out << ", real) $assign(output) $refCx(input, ";
		out << -(j+i*int(blockSize));
		out << ", real);\n";

		out << "$refCx(output#";
		out << i+1;
		out << ", ";
		out << -j;
		out << ", imag) $assign(output) ";
		out << double(0.0);
		out << ";\n";
	      }
	    }
	  }
	  else {
	    for (int i = output.numberPorts() -1 ; i >= 0 ; i--) {
	      for (int j = int(blockSize)-1 ; j >= 0 ; j--) {
		out << "$ref(output#";
		out << i+1;
		out << ", ";
		out << -j;
		out << ") $assign(output) $ref(input, ";
		out << -(j+i*int(blockSize));
		out << ");\n";
	      }
	    }
	  }

	  addCode(out);
	  out.initialize();
}

// prototype instance for known block list
static VHDLDistributor proto;
static RegisterBlock registerBlock(proto,"Distributor");
