static const char file_id[] = "VHDLDownSample.pl";
// .cc file generated from VHDLDownSample.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLDownSample.h"

const char *star_nm_VHDLDownSample = "VHDLDownSample";

const char* VHDLDownSample :: className() const {return star_nm_VHDLDownSample;}

ISA_FUNC(VHDLDownSample,VHDLStar);

Block* VHDLDownSample :: makeNew() const { LOG_NEW; return new VHDLDownSample;}

VHDLDownSample::VHDLDownSample ()
{
	setDescriptor("A decimator by a given \"factor\" (default 2).\nThe \"phase\" tells which sample to output.\nIf phase = 0, the most recent sample is the output,\nwhile if phase = factor-1 the oldest sample is the output.\nPhase = 0 is the default.  Note that \"phase\" has the opposite\nsense of the phase parameter in the UpSample star, but the\nsame sense as the phase parameter in the FIR star.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(factor.setState("factor",this,"2","Downsample factor."));
	addState(phase.setState("phase",this,"0","Downsample phase."));


}

void VHDLDownSample::setup() {
# line 46 "VHDLDownSample.pl"
input.setSDFParams(int(factor),int(factor)-1);
		if (int(phase) >= int(factor))
			Error::abortRun(*this, ": phase must be < factor");
}

void VHDLDownSample::go() {
# line 51 "VHDLDownSample.pl"
StringList out;
	  out << "$ref(output, 0) $assign(output) ";
	  out << "$ref(input, " << - int(phase) << ")";
	  out << ";\n";
	  addCode(out);
}

// prototype instance for known block list
static VHDLDownSample proto;
static RegisterBlock registerBlock(proto,"DownSample");
