static const char file_id[] = "VHDLFIR.pl";
// .cc file generated from VHDLFIR.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLFIR.h"

const char *star_nm_VHDLFIR = "VHDLFIR";

const char* VHDLFIR :: className() const {return star_nm_VHDLFIR;}

ISA_FUNC(VHDLFIR,VHDLStar);

Block* VHDLFIR :: makeNew() const { LOG_NEW; return new VHDLFIR;}

VHDLFIR::VHDLFIR ()
{
	setDescriptor("A Finite Impulse Response (FIR) filter.\nCoefficients are in the \"taps\" state variable.\nDefault coefficients give an 8th order, linear phase lowpass\nfilter. To read coefficients from a file, replace the default\ncoefficients with \"<fileName\".");
	addPort(signalIn.setPort("signalIn",this,FLOAT));
	addPort(signalOut.setPort("signalOut",this,FLOAT));
	addState(taps.setState("taps",this,"-.040609 -.001628 .17853 .37665 .37665 .17853 -.001628 -.040609","Filter tap values."));


}

void VHDLFIR::go() {
# line 89 "VHDLFIR.pl"
StringList out;
	  int tapSize = taps.size();
	  // Perform calculation.
	  for (int i=0; i<int(tapSize); i++) {
	      if (i%10 == 0) {
		 if (i!=0) out << ";\n";
		 out <<  "$ref(signalOut) $assign(signalOut) "
		     << (i != 0 ? "$ref(signalOut) + " : "") 
		     << "$ref(signalIn," << i << ")*$ref(taps," << i << ")";
	     }
	      else {
		  out << "+ $ref(signalIn," << i << ")*$ref(taps," 
		      << i << ")";
	      }
	  }
	  out << ";\n";
	  addCode(out);
	  out.initialize();
/*
  	  StringList out;
	  int tapSize = taps.size();
	  // Perform calculation.
	  out << "$ref(signalOut) $assign(signalOut) ";
	  out << "$ref(signalIn,0)*$ref(taps,0)";
	  for (int i=1; i<int(tapSize); i++) {
	    out << " + $ref(signalIn,";
	    out << i;
	    out << ")*$ref(taps,";
	    out << i;
	    out << ")";
	  }
	  out << ";\n";
	  addCode(out);
	  out.initialize();
	  */
}

// prototype instance for known block list
static VHDLFIR proto;
static RegisterBlock registerBlock(proto,"FIR");
