static const char file_id[] = "VHDLFIRInt.pl";
// .cc file generated from VHDLFIRInt.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLFIRInt.h"

const char *star_nm_VHDLFIRInt = "VHDLFIRInt";

const char* VHDLFIRInt :: className() const {return star_nm_VHDLFIRInt;}

ISA_FUNC(VHDLFIRInt,VHDLStar);

Block* VHDLFIRInt :: makeNew() const { LOG_NEW; return new VHDLFIRInt;}

VHDLFIRInt::VHDLFIRInt ()
{
	setDescriptor("A Finite Impulse Response (FIR) filter.\nCoefficients are in the \"taps\" state variable.\nDefault coefficients give an 8th order, linear phase lowpass\nfilter. To read coefficients from a file, replace the default\ncoefficients with \"<fileName\".");
	addPort(signalIn.setPort("signalIn",this,INT));
	addPort(signalOut.setPort("signalOut",this,INT));
	addState(taps.setState("taps",this,"9 8 3 5 5 3 8 9","Filter tap values."));


}

void VHDLFIRInt::go() {
# line 89 "VHDLFIRInt.pl"
StringList out;
	  int tapSize = taps.size();
	  // Perform calculation.
	  for (int i=0; i<int(tapSize); i++) {
	      if (i%10 == 0) {
		 if (i!=0) out << ";\n";
		 out <<  "$ref(signalOut) $assign(signalOut) "
		     << (i != 0 ? "$ref(signalOut) + " : "")
		     << "$ref(signalIn," << i << ")*$ref(taps," << i << ")";
	     }
	      else {
		  out << "+ $ref(signalIn," << i << ")*$ref(taps," 
		      << i << ")";
	      }
	  }
	  out << ";\n";
	  addCode(out);
	  out.initialize();
}

// prototype instance for known block list
static VHDLFIRInt proto;
static RegisterBlock registerBlock(proto,"FIRInt");
