static const char file_id[] = "VHDLFloatToCx.pl";
// .cc file generated from VHDLFloatToCx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLFloatToCx.h"

const char *star_nm_VHDLFloatToCx = "VHDLFloatToCx";

const char* VHDLFloatToCx :: className() const {return star_nm_VHDLFloatToCx;}

ISA_FUNC(VHDLFloatToCx,VHDLStar);

Block* VHDLFloatToCx :: makeNew() const { LOG_NEW; return new VHDLFloatToCx;}

VHDLFloatToCx::VHDLFloatToCx ()
{
	setDescriptor("type conversion from float/int to complex");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,COMPLEX));
	addState(numSample.setState("numSample",this,"1","number of samples to be converted"));

# line 29 "VHDLFloatToCx.pl"
noInternalState();
}

void VHDLFloatToCx::initCode() {
# line 38 "VHDLFloatToCx.pl"
numSample = output.numXfer();
}

void VHDLFloatToCx::setup() {
# line 32 "VHDLFloatToCx.pl"
if (int(numSample) > 1) {
			input.setSDFParams(int(numSample));
			output.setSDFParams(int(numSample));
		}
}

void VHDLFloatToCx::go() {
# line 41 "VHDLFloatToCx.pl"
StringList out;
	  for (int i = 0; i < int(numSample); i++) {
	    out << "$refCx(output, ";
	    out << -i;
	    out << ", real) $assign(output) $ref(input, ";
	    out << -i;
	    out << ");\n";
	    out << "$refCx(output, ";
	    out << -i;
	    out << ", imag) $assign(output) 0.0;\n";
	  }
	  addCode(out);
	  out.initialize();
}

// prototype instance for known block list
static VHDLFloatToCx proto;
static RegisterBlock registerBlock(proto,"FloatToCx");
