static const char file_id[] = "VHDLImpulse.pl";
// .cc file generated from VHDLImpulse.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLImpulse.h"

const char *star_nm_VHDLImpulse = "VHDLImpulse";

const char* VHDLImpulse :: className() const {return star_nm_VHDLImpulse;}

ISA_FUNC(VHDLImpulse,VHDLStar);

Block* VHDLImpulse :: makeNew() const { LOG_NEW; return new VHDLImpulse;}

CodeBlock VHDLImpulse :: std (
# line 41 "VHDLImpulse.pl"
"if $ref(count) = 0\n"
"  $ref(output) $assign(output) $val(value);\n"
"else\n"
"  $ref(output) $assign(output) 0;\n"
"end if;\n"
"$ref(count) $assign(count) $ref(count) + 1;\n");

CodeBlock VHDLImpulse :: periodic (
# line 49 "VHDLImpulse.pl"
"if $ref(count) >= $val(period)\n"
"  $ref(count) $assign(count) 0;\n"
"end if;\n");

VHDLImpulse::VHDLImpulse ()
{
	setDescriptor("Generate a stream of impulses of size \"level\" (default 1.0).\nThe period is given by \"period\" (default 0).\nIf period = 0 then only one impulse is generated.");
	addPort(output.setPort("output",this,FLOAT));
	addState(level.setState("level",this,"1.0","The height of the impulse."));
	addState(period.setState("period",this,"0","The period of the impulse train, 0 = aperiodic."));
	addState(count.setState("count",this,"0","An internal state.",
# line 39 "VHDLImpulse.pl"
A_NONCONSTANT|A_NONSETTABLE));


}

void VHDLImpulse::go() {
# line 55 "VHDLImpulse.pl"
addCode(std);
	  if (period == 0) {
	    addCode(periodic);
	  }
}

// prototype instance for known block list
static VHDLImpulse proto;
static RegisterBlock registerBlock(proto,"Impulse");
