static const char file_id[] = "VHDLLMS.pl";
// .cc file generated from VHDLLMS.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLLMS.h"

const char *star_nm_VHDLLMS = "VHDLLMS";

const char* VHDLLMS :: className() const {return star_nm_VHDLLMS;}

ISA_FUNC(VHDLLMS,VHDLStar);

Block* VHDLLMS :: makeNew() const { LOG_NEW; return new VHDLLMS;}

CodeBlock VHDLLMS :: std (
# line 77 "VHDLLMS.pl"
"$ref(signalOut) $assign(signalOut) $ref(signalIn) * $ref(tap0) + $ref(delay1) *\n"
"  $ref(tap1) + $ref(delay2) * $ref(tap2) + $ref(delay3) * $ref(tap3);\n"
"$ref(delay3) $assign(delay3) $ref(delay2);\n"
"$ref(delay2) $assign(delay2) $ref(delay1);\n"
"$ref(delay1) $assign(delay1) $ref(signalIn);\n"
"$ref(tap0) $assign(tap0) $ref(tap0) + $val(stepSize) * $ref(error) * $ref(signalIn);\n"
"$ref(tap1) $assign(tap1) $ref(tap1) + $val(stepSize) * $ref(error) * $ref(delay1);\n"
"$ref(tap2) $assign(tap2) $ref(tap2) + $val(stepSize) * $ref(error) * $ref(delay2);\n"
"$ref(tap3) $assign(tap3) $ref(tap3) + $val(stepSize) * $ref(error) * $ref(delay3);\n");

VHDLLMS::VHDLLMS ()
{
	setDescriptor("Adaptive filter using LMS adaptation algorithm.");
	addPort(signalIn.setPort("signalIn",this,INT));
	addPort(error.setPort("error",this,INT));
	addPort(signalOut.setPort("signalOut",this,INT));
	addState(delay1.setState("delay1",this,"0","Input stream delayed by 1."));
	addState(delay2.setState("delay2",this,"0","Input stream delayed by 2."));
	addState(delay3.setState("delay3",this,"0","Input stream delayed by 3."));
	addState(tap0.setState("tap0",this,"1","filter tap 0"));
	addState(tap1.setState("tap1",this,"1","filter tap 1"));
	addState(tap2.setState("tap2",this,"1","filter tap 2"));
	addState(tap3.setState("tap3",this,"1","filter tap 3"));
	addState(stepSize.setState("stepSize",this,"0.01","Adaptation step size."));


}

void VHDLLMS::go() {
# line 89 "VHDLLMS.pl"
addCode(std);
}

// prototype instance for known block list
static VHDLLMS proto;
static RegisterBlock registerBlock(proto,"LMS");
