static const char file_id[] = "VHDLRect.pl";
// .cc file generated from VHDLRect.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLRect.h"

const char *star_nm_VHDLRect = "VHDLRect";

const char* VHDLRect :: className() const {return star_nm_VHDLRect;}

ISA_FUNC(VHDLRect,VHDLStar);

Block* VHDLRect :: makeNew() const { LOG_NEW; return new VHDLRect;}

CodeBlock VHDLRect :: std (
# line 47 "VHDLRect.pl"
"if $ref(count) < $val(width)\n"
"  $ref(output) $assign(output) $val(height);\n"
"else\n"
"  $ref(output) $assign(output) 0;\n"
"end if;\n"
"$ref(count) $assign(count) $ref(count) + 1;\n");

CodeBlock VHDLRect :: periodic (
# line 55 "VHDLRect.pl"
"if $ref(count) >= $val(period)\n"
"  $ref(count) $assign(count) 0;\n"
"end if;\n");

VHDLRect::VHDLRect ()
{
	setDescriptor("Generate a rectangular pulse of height \"height\" (default 1.0).\nand width \"width\" (default 8).  If \"period\" is greater than zero,\nthen the pulse is repeated with the given period.");
	addPort(output.setPort("output",this,FLOAT));
	addState(height.setState("height",this,"1.0","Height of the rectangular pulse."));
	addState(width.setState("width",this,"8","Width of the rectangular pulse."));
	addState(period.setState("period",this,"0","The period of the pulse stream, 0 = aperiodic."));
	addState(count.setState("count",this,"0","Internal counting state.",
# line 45 "VHDLRect.pl"
A_NONSETTABLE|A_NONCONSTANT));


}

void VHDLRect::go() {
# line 61 "VHDLRect.pl"
addCode(std);
	  if (period == 0) {
	    addCode(periodic);
	  }
}

// prototype instance for known block list
static VHDLRect proto;
static RegisterBlock registerBlock(proto,"Rect");
