static const char file_id[] = "VHDLRectToPolar.pl";
// .cc file generated from VHDLRectToPolar.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLRectToPolar.h"

const char *star_nm_VHDLRectToPolar = "VHDLRectToPolar";

const char* VHDLRectToPolar :: className() const {return star_nm_VHDLRectToPolar;}

ISA_FUNC(VHDLRectToPolar,VHDLStar);

Block* VHDLRectToPolar :: makeNew() const { LOG_NEW; return new VHDLRectToPolar;}

const char* VHDLRectToPolar :: init(const char* X, const char* Y, const char* Phi) {
# line 48 "VHDLRectToPolar.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	  if $ref(y) >= 0.0 then\n"
"	    $temp(" << (X) << "_0,float) := $ref(y);\n"
"	    $temp(" << (Y) << "_0,float) := -$ref(x);\n"
"	    $temp(" << (Phi) << "_0,float) := $define(Angle90, float, 0.5);\n"
"	  else\n"
"	    $temp(" << (X) << "_0,float) := -$ref(y);\n"
"  	    $temp(" << (Y) << "_0,float) := $ref(x);\n"
"	    $temp(" << (Phi) << "_0,float) := -$define(Angle90, float, 0.5);\n"
"	  end if;\n"
"	  \n";
	return (const char*)_str_;
}

const char* VHDLRectToPolar :: body(const char* i, const char* i1, const char* X, const char* Y, const char* Phi) {
# line 62 "VHDLRectToPolar.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	  if $temp(" << (Y) << "_" << (i1) << ",float) >= 0.0 then\n"
"	    $temp(" << (X) << "_" << (i) << ",float) := $temp(" << (X) << "_" << (i1) << ",float) + ($temp(" << (Y) << "_" << (i1) << ",float) / (2.0**" << (i1) << "));\n"
"	    $temp(" << (Y) << "_" << (i) << ",float) := $temp(" << (Y) << "_" << (i1) << ",float) - ($temp(" << (X) << "_" << (i1) << ",float) / (2.0**" << (i1) << "));\n"
"	    $temp(" << (Phi) << "_" << (i) << ",float) := $temp(" << (Phi) << "_" << (i1) << ",float) + $ref(CorAngles," << (i1) << ");\n"
"	  else\n"
"	    $temp(" << (X) << "_" << (i) << ",float) := $temp(" << (X) << "_" << (i1) << ",float) - ($temp(" << (Y) << "_" << (i1) << ",float) / (2.0**" << (i1) << "));\n"
"	    $temp(" << (Y) << "_" << (i) << ",float) := $temp(" << (Y) << "_" << (i1) << ",float) + ($temp(" << (X) << "_" << (i1) << ",float) / (2.0**" << (i1) << "));\n"
"	    $temp(" << (Phi) << "_" << (i) << ",float) := $temp(" << (Phi) << "_" << (i1) << ",float) - $ref(CorAngles," << (i1) << ");\n"
"	  end if;\n"
"	  \n";
	return (const char*)_str_;
}

const char* VHDLRectToPolar :: equate(const char* N1, const char* X, const char* /*Y*/, const char* Phi) {
# line 76 "VHDLRectToPolar.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	  $ref(magnitude) $assign(magnitude) $temp(" << (X) << "_" << (N1) << ",float) * $define(Corrector, float, 0.60725285);\n"
"	  $ref(phase) $assign(phase) $temp(" << (Phi) << "_" << (N1) << ",float) * 3.141592654;\n";
	return (const char*)_str_;
}

VHDLRectToPolar::VHDLRectToPolar ()
{
	setDescriptor("CORDIC algorithm performs Cartesian to polar conversion");
	addPort(x.setPort("x",this,FLOAT));
	addPort(y.setPort("y",this,FLOAT));
	addPort(magnitude.setPort("magnitude",this,FLOAT));
	addPort(phase.setPort("phase",this,FLOAT));
	addState(CorAngles.setState("CorAngles",this,"0.25 \
0.147583618 0.077979130 0.039583424 0.019868524 \
0.009943948 0.004973187 0.002486745 0.001243392 \
0.000621698 0.000310849 0.000155425 0.000077712 \
0.000038856 0.000019428 0.000009714 0.000004857 \
0.000002429 0.000001214 0.000000607","Angles for the CORDIC algorithm."));


}

void VHDLRectToPolar::go() {
# line 83 "VHDLRectToPolar.pl"
StringList X,Y,Phi,N1,p;
//		X = "$starSymbol(X)";
//		Y = "$starSymbol(Y)";
//		Phi = "$starSymbol(Phi)";
		X = "X";
		Y = "Y";
		Phi = "Phi";
		p = CorAngles.size() - 1;
		N1 = hashstring(p);
		addCode(init((const char*)X, (const char*)Y,
			     (const char*)Phi));
		
		for(int j=1; j< CorAngles.size(); j++)
		{
			StringList i,i1;	
			i = j; i1 = j-1;
			addCode(body((const char*)i, (const char*)i1,
				     (const char*)X, (const char*)Y,
				     (const char*)Phi));
		}

		addCode(equate((const char*)N1, (const char*)X, (const char*)Y,
			       (const char*)Phi));
}

// prototype instance for known block list
static VHDLRectToPolar proto;
static RegisterBlock registerBlock(proto,"RectToPolar");
