static const char file_id[] = "VHDLUpSample.pl";
// .cc file generated from VHDLUpSample.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLUpSample.h"

const char *star_nm_VHDLUpSample = "VHDLUpSample";

const char* VHDLUpSample :: className() const {return star_nm_VHDLUpSample;}

ISA_FUNC(VHDLUpSample,VHDLStar);

Block* VHDLUpSample :: makeNew() const { LOG_NEW; return new VHDLUpSample;}

VHDLUpSample::VHDLUpSample ()
{
	setDescriptor("Upsample by a given \"factor\" (default 2), filling with \"fill\" (default 0.0).\nThe \"phase\" parameter tells where to put the sample in an output block.\nThe default is to output it first (phase = 0). The maximum phase is \"factor\" - 1.\nAlthough the \"fill\" parameter is a floating-point number, if the input is of\nsome other type, such as complex, the fill particle will be obtained by casting\n\"fill\" to the appropriate type.");
	addPort(input.setPort("input",this,ANYTYPE));
	addPort(output.setPort("output",this,ANYTYPE));
	output.inheritTypeFrom(input);
	addState(factor.setState("factor",this,"2","Number of samples produced."));
	addState(phase.setState("phase",this,"0","Where to put the input in the output block."));
	addState(fill.setState("fill",this,"0.0","Value to fill the output block."));


}

void VHDLUpSample::setup() {
# line 48 "VHDLUpSample.pl"
output.setSDFParams(int(factor),int(factor)-1);
		if (int(phase) >= int(factor))
			Error::abortRun(*this, ": phase must be < factor");
}

void VHDLUpSample::go() {
# line 53 "VHDLUpSample.pl"
StringList out;
	  for (int i = 0; i < int(factor); i++) {
	    // FIXME: Will not work for COMPLEX type
	    out << "$ref(output, ";
	    out << -i;
	    out << ") $assign(output) ";
	    if (i == int(phase)) {
	      out << "$ref(input, 0)";
	    }
	    else {
	      float fillFloat = double(fill);
	      int fillInt = (int) fillFloat;
	      out << (strcmp(input.resolvedType(),INT)==0?
		      fillInt:fillFloat);
	      // yes, the previous statement really does work correctly
	      // even if the type of the output is resolved to COMPLEX
	      // or INT.  The appropriate conversion is performed.
	    }
	    out << ";\n";
	  }
	  addCode(out);
}

// prototype instance for known block list
static VHDLUpSample proto;
static RegisterBlock registerBlock(proto,"UpSample");
