static const char file_id[] = "VHDLWaveForm.pl";
// .cc file generated from VHDLWaveForm.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLWaveForm.h"

const char *star_nm_VHDLWaveForm = "VHDLWaveForm";

const char* VHDLWaveForm :: className() const {return star_nm_VHDLWaveForm;}

ISA_FUNC(VHDLWaveForm,VHDLStar);

Block* VHDLWaveForm :: makeNew() const { LOG_NEW; return new VHDLWaveForm;}

CodeBlock VHDLWaveForm :: body (
# line 80 "VHDLWaveForm.pl"
"if ($ref(pos) >= $val(size))\n"
"  $ref(output) $assign(output) 0.0;\n"
"  $ref(pos) $assign(pos) $ref(pos) + 1;\n"
"else\n"
"  $ref(output) = $ref(value,pos);\n"
"  $ref(pos) $assign(pos) + 1;\n"
"end if;\n"
"if ($val(periodic) /= 0)\n"
"  if(($val(period) <= 0) and ($ref(pos) >= $val(size))) \n"
"    $ref(pos) $assign(pos) 0;\n"
"  else if (($val(period) > 0) and ($ref(pos) >= $val(period))) \n"
"    $ref(pos) $assign(pos) 0;\n"
"  end if;\n"
"end if;\n");

VHDLWaveForm::VHDLWaveForm ()
{
	setDescriptor("Output a waveform as specified by the array state \"value\" (default \"1 -1\").\nYou can get periodic signals with any period, and can halt a simulation\nat the end of the given waveform.  The following table summarizes the\ncapabilities:\n\n haltAtEnd   periodic   period    operation\n ------------------------------------------------------------------------\n NO          YES        0         The period is the length of the waveform\n NO          YES        N>0       The period is N\n NO          NO         anything  Output the waveform once, then zeros\n\n*** NOTE:\n The following behavior is not implemented in the VHDL version of this star:\n YES         anything   anything  Stop after outputting the waveform once\n\nThe first line of the table gives the default settings.");
	addPort(output.setPort("output",this,FLOAT));
	addState(value.setState("value",this,"1 -1","One period of the output waveform."));
	addState(haltAtEnd.setState("haltAtEnd",this,"NO","NOT IMPLEMENTED\n		  	Halt the run at the end of the given data."));
	addState(periodic.setState("periodic",this,"YES","Output is periodic if \"YES\" (nonzero)."));
	addState(period.setState("period",this,"0","If greater than zero, gives the period of the waveform."));
	addState(pos.setState("pos",this,"0","pos",
# line 68 "VHDLWaveForm.pl"
A_NONSETTABLE));
	addState(size.setState("size",this,"0","size",
# line 74 "VHDLWaveForm.pl"
A_NONSETTABLE));


}

void VHDLWaveForm::setup() {
# line 77 "VHDLWaveForm.pl"
pos = 0;
		size = value.size();
}

void VHDLWaveForm::go() {
# line 97 "VHDLWaveForm.pl"
addCode(body);
}

// prototype instance for known block list
static VHDLWaveForm proto;
static RegisterBlock registerBlock(proto,"WaveForm");
