static const char file_id[] = "VHDLWaveFormCx.pl";
// .cc file generated from VHDLWaveFormCx.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLWaveFormCx.h"

const char *star_nm_VHDLWaveFormCx = "VHDLWaveFormCx";

const char* VHDLWaveFormCx :: className() const {return star_nm_VHDLWaveFormCx;}

ISA_FUNC(VHDLWaveFormCx,VHDLStar);

Block* VHDLWaveFormCx :: makeNew() const { LOG_NEW; return new VHDLWaveFormCx;}

CodeBlock VHDLWaveFormCx :: body (
# line 67 "VHDLWaveFormCx.pl"
"if ($ref(pos) >= $val(size))\n"
"  $refCx(output,real) $assign(output) 0.0;\n"
"  $refCx(output,imag) $assign(output) 0.0;\n"
"  $ref(pos) $assign(pos) $ref(pos) + 1;\n"
"else\n"
"  $refCx(output,real) = $refCx(value,pos,real);\n"
"  $refCx(output,real) = $refCx(value,pos,real);\n"
"  $ref(pos) $assign(pos) + 1;\n"
"end if;\n"
"if ($val(periodic) /= 0)\n"
"  if(($val(period) <= 0) and ($ref(pos) >= $val(size))) \n"
"    $ref(pos) $assign(pos) 0;\n"
"  else if (($val(period) > 0) and ($ref(pos) >= $val(period))) \n"
"    $ref(pos) $assign(pos) 0;\n"
"  end if;\n"
"end if;\n");

VHDLWaveFormCx::VHDLWaveFormCx ()
{
	setDescriptor("This star works the same way as the VHDLWaveForm star,\nonly using complex types instead of float types.");
	addPort(output.setPort("output",this,COMPLEX));
	addState(value.setState("value",this,"(1.0,0.0) (-1.0,0.0)","One period of the output waveform."));
	addState(haltAtEnd.setState("haltAtEnd",this,"NO","NOT IMPLEMENTED\n		  	Halt the run at the end of the given data."));
	addState(periodic.setState("periodic",this,"YES","Output is periodic if \"YES\" (nonzero)."));
	addState(period.setState("period",this,"0","If greater than zero, gives the period of the waveform."));
	addState(pos.setState("pos",this,"0","pos",
# line 55 "VHDLWaveFormCx.pl"
A_NONSETTABLE));
	addState(size.setState("size",this,"0","size",
# line 61 "VHDLWaveFormCx.pl"
A_NONSETTABLE));


}

void VHDLWaveFormCx::setup() {
# line 64 "VHDLWaveFormCx.pl"
pos = 0;
		size = value.size();
}

void VHDLWaveFormCx::go() {
# line 86 "VHDLWaveFormCx.pl"
addCode(body);
}

// prototype instance for known block list
static VHDLWaveFormCx proto;
static RegisterBlock registerBlock(proto,"WaveFormCx");
