static const char file_id[] = "VHDLXMgraph.pl";
// .cc file generated from VHDLXMgraph.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLXMgraph.h"

const char *star_nm_VHDLXMgraph = "VHDLXMgraph";

const char* VHDLXMgraph :: className() const {return star_nm_VHDLXMgraph;}

ISA_FUNC(VHDLXMgraph,VHDLStar);

Block* VHDLXMgraph :: makeNew() const { LOG_NEW; return new VHDLXMgraph;}

CodeBlock VHDLXMgraph :: uses (
# line 37 "VHDLXMgraph.pl"
"use std.Textio.all;\n");

CodeBlock VHDLXMgraph :: init (
# line 40 "VHDLXMgraph.pl"
"variable $starSymbol(space): character := ' ';\n"
"variable $starSymbol(aline): line;\n"
"variable $starSymbol(icount): integer := 0;\n");

CodeBlock VHDLXMgraph :: std (
# line 45 "VHDLXMgraph.pl"
"$starSymbol(icount) := $starSymbol(icount) + 1;\n");

CodeBlock VHDLXMgraph :: graph (
# line 48 "VHDLXMgraph.pl"
"(pxgraph -t \"$val(title)\" $val(options) $starSymbol(xgraph).dat ; rm -f $starSymbol(xgraph).dat) &\n");

VHDLXMgraph::VHDLXMgraph ()
{
	setDescriptor("Graph the input data.");
	addPort(input.setPort("input",this,FLOAT));
	addState(title.setState("title",this,"Ptolemy Xgraph","Title for the plot."));
	addState(options.setState("options",this,"-bb -tk =800x400","Command line options for the xgraph program."));

# line 35 "VHDLXMgraph.pl"
noInternalState();
}

int VHDLXMgraph::myExecTime() {
# line 105 "VHDLXMgraph.pl"
return 0;
}

void VHDLXMgraph::initCode() {
# line 52 "VHDLXMgraph.pl"
addCode(uses, "useLibs", "textio");
	  StringList filedecl = "";
	  for (int i = 1 ; i <= input.numberPorts() ; i++) {
	    filedecl << "file $starSymbol(fileout";
	    filedecl << i;
	    filedecl << "): text is out \"$starSymbol(xgraph";
	    filedecl << i;
	    filedecl << ").dat\";";
	    filedecl << "\n";
	  }
	  addCode(filedecl, "mainDecls");
	  addCode(init, "mainDecls");
	  StringList cmd = "";
	  cmd << "/bin/rm -f ";
	  cmd << "$starSymbol(xgraph)";
	  cmd << ".dat";
	  cmd << "; ";
	  for (int j = 1 ; j <= input.numberPorts() ; j++) {
	    cmd << "/bin/cat ";
	    cmd << "$starSymbol(xgraph";
	    cmd << j << ").dat";
	    cmd << " >> ";
	    cmd << "$starSymbol(xgraph)";
	    cmd << ".dat";
	    cmd << "; ";
	    cmd << "/bin/echo \"\" >> ";
	    cmd << "$starSymbol(xgraph)";
	    cmd << ".dat";
	    cmd << "; ";
	    cmd << "/bin/rm -f ";
	    cmd << "$starSymbol(xgraph";
	    cmd << j << ").dat";
	    cmd << "; ";
	  }
	  addCode(cmd, "sysWrapup");
	  addCode(graph, "sysWrapup");
}

void VHDLXMgraph::go() {
# line 90 "VHDLXMgraph.pl"
StringList dataout = "";
	  for (int k = 1 ; k <= input.numberPorts() ; k++) {
	    dataout << "write($starSymbol(aline), $starSymbol(icount));\n";
	    dataout << "write($starSymbol(aline), $starSymbol(space));\n";
	    dataout << "write($starSymbol(aline), $ref(input#";
	    dataout << k;
	    dataout << "));\n";
	    dataout << "writeline($starSymbol(fileout";
	    dataout << k;
	    dataout << "), $starSymbol(aline));\n";
	  }
	  addCode(dataout);
	  addCode(std);
}

// prototype instance for known block list
static VHDLXMgraph proto;
static RegisterBlock registerBlock(proto,"XMgraph");
