static const char file_id[] = "CGCVReceive.pl";
// .cc file generated from CGCVReceive.pl by ptlang
/*
Copyright (c) 1993-1996 The Regents of the University of California.
      All rights reserved.
      See the file $PTOLEMY/copyright for copyright notice,
      limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCVReceive.h"

const char *star_nm_CGCVReceive = "CGCVReceive";

const char* CGCVReceive :: className() const {return star_nm_CGCVReceive;}

ISA_FUNC(CGCVReceive,CGCVSynchComm);

Block* CGCVReceive :: makeNew() const { LOG_NEW; return new CGCVReceive;}

CGCVReceive::CGCVReceive ()
{
	setDescriptor("Receive data synchronously from VHDL to CGC");
	addPort(output.setPort("output",this,ANYTYPE));


}

void CGCVReceive::setup() {
# line 22 "CGCVReceive.pl"
classname = "CGCVReceive";
    sndrcv = "rcv";

    if (strcmp(output.resolvedType(), "INT") == 0) 
      format = "%d";
    else if (strcmp(output.resolvedType(), "FLOAT") == 0) 
/*
  Note: using %f in sscanf() seems to mess up.
      format = "%f";
*/
      format = "%lf";
    else
      Error::abortRun(*this, output.resolvedType(), ": type not supported");

    numXfer = output.numXfer();
    CGCVSynchComm::setup();
}

void CGCVReceive::go() {
# line 41 "CGCVReceive.pl"
StringList transfer;
    for (int i = numXfer-1 ; i >= 0 ; i--) {
      if (i > 0) transfer << "\n";
      transfer << "\n";
      transfer << "  /* Go */\n";
      transfer << "  $starSymbol(intptr) = 0;\n";
      transfer << "  $starSymbol(status) = 0;\n";
      transfer << "  if($starSymbol(status) >= 0) {\n";
      transfer << "    $starSymbol(status) = read($starSymbol(xmitsock), $starSymbol(buffer), $starSymbol(nbytes));\n";
      transfer << "    while($starSymbol(status) == 0) {\n";
      transfer << "      $starSymbol(status) = read($starSymbol(xmitsock), $starSymbol(buffer), $starSymbol(nbytes));\n";
      transfer << "    }\n";
      transfer << "    if($starSymbol(status) < 0) {\n";
      transfer << "      perror($starSymbol(dummy));\n";
      transfer << "    }\n";
      transfer << "    else {\n";
      
      StringList oneline = "      (void) sscanf($starSymbol(buffer), \"";
      oneline << format;
      oneline << "\", &$ref(output,";
      oneline << i;
      oneline << "));";
      transfer << oneline;

      transfer << "    }\n";
      transfer << "  }\n";
    }
    addCode(transfer);
}

// prototype instance for known block list
static CGCVReceive proto;
static RegisterBlock registerBlock(proto,"VReceive");
