static const char file_id[] = "CGCVSynchComm.pl";
// .cc file generated from CGCVSynchComm.pl by ptlang
/*
Copyright (c) 1993-1996 The Regents of the University of California.
      All rights reserved.
      See the file $PTOLEMY/copyright for copyright notice,
      limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCVSynchComm.h"

const char *star_nm_CGCVSynchComm = "CGCVSynchComm";

const char* CGCVSynchComm :: className() const {return star_nm_CGCVSynchComm;}

ISA_FUNC(CGCVSynchComm,CGCStar);

Block* CGCVSynchComm :: makeNew() const { LOG_NEW; return new CGCVSynchComm;}

CodeBlock CGCVSynchComm :: firstDecl (
# line 52 "CGCVSynchComm.pl"
"  /* Decls */\n"
"  int $starSymbol(count);\n"
"  int $starSymbol(intptr);\n"
"  int $starSymbol(nbytes);\n"
"  int $starSymbol(nearsock), $starSymbol(xmitsock), $starSymbol(status);\n"
"  char $starSymbol(buffer)[BUFFSIZE];\n"
"  char *$starSymbol(dummy);\n"
"  char *$starSymbol(nearstring);\n");

CodeBlock CGCVSynchComm :: secondDecl (
# line 63 "CGCVSynchComm.pl"
"  struct sockaddr $starSymbol(nearaddr), $starSymbol(xmitaddr);\n"
"  int $starSymbol(nearnamelen);\n"
"  int $starSymbol(xmitaddrlen);\n"
"  int $starSymbol(nearaddrlen);\n"
"  int $starSymbol(i);\n");

CodeBlock CGCVSynchComm :: genInit (
# line 71 "CGCVSynchComm.pl"
"  /* Init */\n"
"  $starSymbol(count) = 0;\n"
"  $starSymbol(intptr) = 0;\n"
"  $starSymbol(nbytes) = 12;\n");

CodeBlock CGCVSynchComm :: body (
# line 78 "CGCVSynchComm.pl"
"  $starSymbol(nearnamelen) = strlen($starSymbol(nearstring));\n"
"  $starSymbol(xmitaddrlen) = sizeof($starSymbol(xmitaddr));\n"
"  $starSymbol(nearaddrlen) = sizeof($starSymbol(nearaddr));\n"
"\n"
"  for ($starSymbol(i)=0 ; $starSymbol(i) < BUFFSIZE ; $starSymbol(i)++) {\n"
"    $starSymbol(buffer)[$starSymbol(i)] = (char) 0;\n"
"  }\n"
"  $starSymbol(nearsock) = socket(AF_UNIX, SOCK_STREAM, 0);\n"
"  if ($starSymbol(nearsock) == -1) {\n"
"    perror($starSymbol(dummy));\n"
"  }\n"
"  $starSymbol(nearaddr).sa_family = AF_UNIX;\n"
"  (void) strncpy($starSymbol(nearaddr).sa_data, $starSymbol(nearstring), $starSymbol(nearnamelen)+1);\n"
"  (void) unlink($starSymbol(nearaddr).sa_data);\n"
"  if(bind($starSymbol(nearsock), &$starSymbol(nearaddr), $starSymbol(nearaddrlen)) == -1) {\n"
"    perror($starSymbol(dummy));\n"
"  }\n"
"  if(listen($starSymbol(nearsock), 5) == -1) {\n"
"    perror($starSymbol(dummy));\n"
"  }\n"
"  $starSymbol(xmitsock) = accept($starSymbol(nearsock), &$starSymbol(xmitaddr), &$starSymbol(xmitaddrlen));\n"
"  if($starSymbol(xmitsock) < 0) {\n"
"    perror($starSymbol(dummy));\n"
"  }\n");

CodeBlock CGCVSynchComm :: wrap (
# line 105 "CGCVSynchComm.pl"
"  /* Wrapup */\n"
"  (void) shutdown($starSymbol(xmitsock),2);\n"
"  (void) close($starSymbol(xmitsock));\n"
"  (void) unlink($starSymbol(xmitaddr).sa_data);\n"
"  (void) shutdown($starSymbol(nearsock),2);\n"
"  (void) close($starSymbol(nearsock));\n"
"  (void) unlink($starSymbol(nearaddr).sa_data);\n");

CGCVSynchComm::CGCVSynchComm ()
{
	setDescriptor("Base class for CGC-VHDL synchronous communication");
	addState(pairNumber.setState("pairNumber",this,"0","pairNumber"));
	addState(destDir.setState("destDir",this,"~/PTOLEMY_SYSTEMS","destDir"));
	addState(filePre.setState("filePre",this,"CGCVHDL","filePre"));
	addState(classname.setState("classname",this,"CGCVSynchComm","classname"));
	addState(sndrcv.setState("sndrcv",this,"sndrcv","sndrcv"));
	addState(format.setState("format",this,"%","format"));


}

void CGCVSynchComm::wrapup() {
# line 163 "CGCVSynchComm.pl"
addCode(wrap);
}

void CGCVSynchComm::initCode() {
# line 116 "CGCVSynchComm.pl"
CodeStream *compileOptions, *linkOptions;
    if ((compileOptions = getStream("compileOptions")) == FALSE)
      return;
    if ((linkOptions = getStream("linkOptions")) == FALSE)
      return;
    linkOptions->put("-lsocket -lnsl","socket Link");
    addInclude("<stdio.h>");
    addInclude("<string.h>");
    addInclude("<unistd.h>");
    addInclude("<sys/types.h>");
    addInclude("<sys/socket.h>");
    addInclude("<sys/un.h>");
    addGlobal("#define BUFFSIZE 32", "buffer");
    addDeclaration(firstDecl);
    addDeclaration(secondDecl);

// This must be the first call to add code to mainInit.
    StringList command = "";
    command << "cd " << (const char*) destDir;
    command << " ; ";
    command << "ptvhdlsim -nc -i " << filePre << ".com " << "parts";

    StringList startvss = "";
    startvss << "\n";
    startvss << "  /* Start VSS Simulator */\n";
    startvss << "  system(\"";
    startvss << command << "&";
    startvss << "\");\n";
    addCode(startvss, "mainInit", "startVSS");
    addCode(genInit);
    
    StringList oneLine;

    oneLine = "  $starSymbol(dummy) = \"  ";
    oneLine << classname;
    oneLine << " socket error\";";
    addCode(oneLine);

    oneLine = "  $starSymbol(nearstring) = \"/tmp/";
    oneLine << sndrcv;
    oneLine << "$val(pairNumber)\\0\";";
    addCode(oneLine);

    addCode(body);
}

void CGCVSynchComm::setup() {
# line 50 "CGCVSynchComm.pl"
}

// prototype instance for known block list
static CGCVSynchComm proto;
static RegisterBlock registerBlock(proto,"VSynchComm");
