static const char file_id[] = "VHDLCReceive.pl";
// .cc file generated from VHDLCReceive.pl by ptlang
/*
Copyright (c) 1993-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLCReceive.h"

const char *star_nm_VHDLCReceive = "VHDLCReceive";

const char* VHDLCReceive :: className() const {return star_nm_VHDLCReceive;}

ISA_FUNC(VHDLCReceive,VHDLCSynchComm);

Block* VHDLCReceive :: makeNew() const { LOG_NEW; return new VHDLCReceive;}

CodeBlock VHDLCReceive :: C2Vinteger (
# line 32 "VHDLCReceive.pl"
"--C2Vinteger.vhdl\n"
"\n"
"library SYNOPSYS,IEEE;\n"
"use SYNOPSYS.ATTRIBUTES.all;\n"
"use IEEE.STD_LOGIC_1164.all;\n"
"\n"
"entity C2Vinteger is\n"
"	generic ( pairid	: INTEGER	;\n"
"		  numxfer	: INTEGER	);\n"
"	port	( go		: in STD_LOGIC	;\n"
"		  data		: out INTEGER	;\n"
"		  done		: out STD_LOGIC	);\n"
"end C2Vinteger;\n"
"\n"
"architecture CLI of C2Vinteger is\n"
"\n"
"	attribute FOREIGN of CLI : architecture is \"Synopsys:CLI\";\n"
"\n"
"	attribute CLI_ELABORATE	of CLI	: architecture is \"c2vinteger_open\";\n"
"	attribute CLI_EVALUATE	of CLI	: architecture is \"c2vinteger_eval\";\n"
"	attribute CLI_ERROR	of CLI	: architecture is \"c2vinteger_error\";\n"
"	attribute CLI_CLOSE	of CLI	: architecture is \"c2vinteger_close\";\n"
"\n"
"	attribute CLI_PIN	of go	: signal is CLI_ACTIVE;\n"
"\n"
"begin\n"
"end;\n");

CodeBlock VHDLCReceive :: C2Vreal (
# line 62 "VHDLCReceive.pl"
"--C2Vreal.vhdl\n"
"\n"
"library SYNOPSYS,IEEE;\n"
"use SYNOPSYS.ATTRIBUTES.all;\n"
"use IEEE.STD_LOGIC_1164.all;\n"
"\n"
"entity C2Vreal is\n"
"	generic ( pairid	: INTEGER	;\n"
"		  numxfer	: INTEGER	);\n"
"	port	( go		: in STD_LOGIC	;\n"
"		  data		: out REAL	;\n"
"		  done		: out STD_LOGIC	);\n"
"end C2Vreal;\n"
"\n"
"architecture CLI of C2Vreal is\n"
"\n"
"	attribute FOREIGN of CLI : architecture is \"Synopsys:CLI\";\n"
"\n"
"	attribute CLI_ELABORATE	of CLI	: architecture is \"c2vreal_open\";\n"
"	attribute CLI_EVALUATE	of CLI	: architecture is \"c2vreal_eval\";\n"
"	attribute CLI_ERROR	of CLI	: architecture is \"c2vreal_error\";\n"
"	attribute CLI_CLOSE	of CLI	: architecture is \"c2vreal_close\";\n"
"\n"
"	attribute CLI_PIN	of go	: signal is CLI_ACTIVE;\n"
"\n"
"begin\n"
"end;\n");

CodeBlock VHDLCReceive :: C2VintegerComp (
# line 92 "VHDLCReceive.pl"
"component C2Vinteger\n"
"  generic ( pairid  : INTEGER ;\n"
"	    numxfer : INTEGER );\n"
"  port ( go   : in  STD_LOGIC ;\n"
"	 data : out INTEGER   ;\n"
"	 done : out STD_LOGIC );\n"
"end component;\n");

CodeBlock VHDLCReceive :: C2VrealComp (
# line 102 "VHDLCReceive.pl"
"component C2Vreal\n"
"  generic ( pairid  : INTEGER ;\n"
"	    numxfer : INTEGER );\n"
"  port ( go   : in  STD_LOGIC ;\n"
"	 data : out REAL      ;\n"
"	 done : out STD_LOGIC );\n"
"end component;\n");

CodeBlock VHDLCReceive :: C2VintegerConfig (
# line 112 "VHDLCReceive.pl"
"for all:C2Vinteger use entity work.C2Vinteger(CLI); end for;\n");

CodeBlock VHDLCReceive :: C2VrealConfig (
# line 116 "VHDLCReceive.pl"
"for all:C2Vreal use entity work.C2Vreal(CLI); end for;\n");

VHDLCReceive::VHDLCReceive ()
{
	setDescriptor("CGC to VHDL Receive star");
	addPort(output.setPort("output",this,ANYTYPE));


}

void VHDLCReceive::begin() {
# line 122 "VHDLCReceive.pl"
//    printf("VHDLCReceive.pl begin method called!!\n");
    // Call method to wire up a C2V VHDL entity
    targ()->registerC2V(int(pairNumber), numXfer, output.resolvedType());

    if (strcmp(output.resolvedType(), "INT") == 0) {
      addCode(C2Vinteger, "cli_models", "c2vint");
      addCode(C2VintegerComp, "cli_comps", "c2vintcomp");
      addCode(C2VintegerConfig, "cli_configs", "c2vintconfig");
    }
    else if (strcmp(output.resolvedType(), "FLOAT") == 0) {
      addCode(C2Vreal, "cli_models", "c2vreal");
      addCode(C2VrealComp, "cli_comps", "c2vrealcomp");
      addCode(C2VrealConfig, "cli_configs", "c2vrealconfig");
    }
    else
      Error::abortRun(*this, output.resolvedType(), ": type not supported");
}

void VHDLCReceive::setup() {
# line 21 "VHDLCReceive.pl"
if (strcmp(output.resolvedType(), "INT") == 0) 
      rtype = "integer";
    else if (strcmp(output.resolvedType(), "FLOAT") == 0) 
      rtype = "real";
    else
      Error::abortRun(*this, output.resolvedType(), ": type not supported");

    numXfer = output.numXfer();     
    VHDLCSynchComm::setup();
}

void VHDLCReceive::go() {
# line 141 "VHDLCReceive.pl"
// Add code to synch at beginning of main.
    StringList preSynch;
    for (int i = 0 ; i < numXfer ; i++) {
      preSynch << "C2V" << rtype << int(pairNumber) << "_go" << " <= '0';\n";
      preSynch << "wait on " << "C2V" << rtype << int(pairNumber) << "_done" << "'transaction;\n";
      preSynch << "$ref(output,";
      preSynch << -i;
      preSynch << ")" << " := " << "C2V" << rtype << int(pairNumber) << "_data;\n";
    }
    
    addCode(preSynch);
}

// prototype instance for known block list
static VHDLCReceive proto;
static RegisterBlock registerBlock(proto,"CReceive");
