static const char file_id[] = "VHDLCSend.pl";
// .cc file generated from VHDLCSend.pl by ptlang
/*
Copyright (c) 1993-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright	for copyright notice,
limitation of liability, and disclaimer	of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLCSend.h"

const char *star_nm_VHDLCSend = "VHDLCSend";

const char* VHDLCSend :: className() const {return star_nm_VHDLCSend;}

ISA_FUNC(VHDLCSend,VHDLCSynchComm);

Block* VHDLCSend :: makeNew() const { LOG_NEW; return new VHDLCSend;}

CodeBlock VHDLCSend :: V2Cinteger (
# line 32 "VHDLCSend.pl"
"--V2Cinteger.vhdl\n"
"\n"
"library SYNOPSYS,IEEE;\n"
"use SYNOPSYS.ATTRIBUTES.all;\n"
"use IEEE.STD_LOGIC_1164.all;\n"
"\n"
"entity V2Cinteger is\n"
"	generic ( pairid	: INTEGER	;\n"
"		  numxfer	: INTEGER	);\n"
"	port	( go		: in STD_LOGIC	;\n"
"		  data		: in INTEGER	;\n"
"		  done		: out STD_LOGIC	);\n"
"end V2Cinteger;\n"
"\n"
"architecture CLI of V2Cinteger is\n"
"\n"
"	attribute FOREIGN of CLI : architecture is \"Synopsys:CLI\";\n"
"\n"
"	attribute CLI_ELABORATE	of CLI	: architecture is \"v2cinteger_open\";\n"
"	attribute CLI_EVALUATE	of CLI	: architecture is \"v2cinteger_eval\";\n"
"	attribute CLI_ERROR	of CLI	: architecture is \"v2cinteger_error\";\n"
"	attribute CLI_CLOSE	of CLI	: architecture is \"v2cinteger_close\";\n"
"\n"
"	attribute CLI_PIN	of go	: signal is CLI_ACTIVE;\n"
"	attribute CLI_PIN	of data	: signal is CLI_PASSIVE;\n"
"\n"
"begin\n"
"end;\n");

CodeBlock VHDLCSend :: V2Creal (
# line 63 "VHDLCSend.pl"
"--V2Creal.vhdl\n"
"\n"
"library SYNOPSYS,IEEE;\n"
"use SYNOPSYS.ATTRIBUTES.all;\n"
"use IEEE.STD_LOGIC_1164.all;\n"
"\n"
"entity V2Creal is\n"
"	generic ( pairid	: INTEGER	;\n"
"		  numxfer	: INTEGER	);\n"
"	port	( go		: in STD_LOGIC	;\n"
"		  data		: in REAL	;\n"
"		  done		: out STD_LOGIC	);\n"
"end V2Creal;\n"
"\n"
"architecture CLI of V2Creal is\n"
"\n"
"	attribute FOREIGN of CLI : architecture is \"Synopsys:CLI\";\n"
"\n"
"	attribute CLI_ELABORATE	of CLI	: architecture is \"v2creal_open\";\n"
"	attribute CLI_EVALUATE	of CLI	: architecture is \"v2creal_eval\";\n"
"	attribute CLI_ERROR	of CLI	: architecture is \"v2creal_error\";\n"
"	attribute CLI_CLOSE	of CLI	: architecture is \"v2creal_close\";\n"
"\n"
"	attribute CLI_PIN	of go	: signal is CLI_ACTIVE;\n"
"	attribute CLI_PIN	of data	: signal is CLI_PASSIVE;\n"
"\n"
"begin\n"
"end;\n");

CodeBlock VHDLCSend :: V2CintegerComp (
# line 94 "VHDLCSend.pl"
"component V2Cinteger\n"
"  generic ( pairid  : INTEGER ;\n"
"	    numxfer : INTEGER );\n"
"  port ( go   : in  STD_LOGIC ;\n"
"	 data : in  INTEGER   ;\n"
"	 done : out STD_LOGIC );\n"
"end component;\n");

CodeBlock VHDLCSend :: V2CrealComp (
# line 104 "VHDLCSend.pl"
"component V2Creal\n"
"  generic ( pairid  : INTEGER ;\n"
"	    numxfer : INTEGER );\n"
"  port ( go   : in  STD_LOGIC ;\n"
"	 data : in  REAL      ;\n"
"	 done : out STD_LOGIC );\n"
"end component;\n");

CodeBlock VHDLCSend :: V2CintegerConfig (
# line 114 "VHDLCSend.pl"
"for all:V2Cinteger use entity work.V2Cinteger(CLI); end for;\n");

CodeBlock VHDLCSend :: V2CrealConfig (
# line 118 "VHDLCSend.pl"
"for all:V2Creal use entity work.V2Creal(CLI); end for;\n");

VHDLCSend::VHDLCSend ()
{
	setDescriptor("VHDL to CGC synchronous send star");
	addPort(input.setPort("input",this,ANYTYPE));


}

void VHDLCSend::begin() {
# line 124 "VHDLCSend.pl"
//    printf("VHDLCSend.pl begin method called!!\n");
    // Call method to wire up a V2C VHDL entity
    targ()->registerV2C(int(pairNumber), numXfer, input.resolvedType());

    if (strcmp(input.resolvedType(), "INT") == 0) {
      addCode(V2Cinteger, "cli_models", "v2cint");
      addCode(V2CintegerComp, "cli_comps", "v2cintcomp");
      addCode(V2CintegerConfig, "cli_configs", "v2cintconfig");
    }
    else if (strcmp(input.resolvedType(), "FLOAT") == 0) {
      addCode(V2Creal, "cli_models", "v2creal");
      addCode(V2CrealComp, "cli_comps", "v2crealcomp");
      addCode(V2CrealConfig, "cli_configs", "v2crealconfig");
    }
    else
      Error::abortRun(*this, input.resolvedType(), ": type not supported");
}

void VHDLCSend::setup() {
# line 21 "VHDLCSend.pl"
if (strcmp(input.resolvedType(), "INT") == 0) 
      rtype = "integer";
    else if (strcmp(input.resolvedType(), "FLOAT") == 0) 
      rtype = "real";
    else
      Error::abortRun(*this, input.resolvedType(), ": type not supported");

    numXfer = input.numXfer();
    VHDLCSynchComm::setup();
}

void VHDLCSend::go() {
# line 143 "VHDLCSend.pl"
// Add code to synch at end of main.
    StringList postSynch;
    for (int i = 0 ; i < numXfer ; i++) {
      postSynch << "V2C" << rtype << int(pairNumber) << "_data" << " <= " << "$ref(input,";
      postSynch << -i;
      postSynch << ")" << ";\n";
      postSynch << "V2C" << rtype << int(pairNumber) << "_go" << " <= " << "'0';\n";
      postSynch << "wait on " << "V2C" << rtype << int(pairNumber) << "_done" << "'transaction;\n";
    }
    
    addCode(postSynch);
}

// prototype instance for known block list
static VHDLCSend proto;
static RegisterBlock registerBlock(proto,"CSend");
