.EQ
delim off
.EN
.\" documentation file generated from VHDLBALU.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "ALU"
.SD
A simple ALU.
.SE
.LO "New_Stars directory"
.DM VHDLB VHDLBStar
.AL "Wei-Lun Tsai"
.IH
.NE
\fIclock\fR (int)
.NE
\fIinputa\fR (multiple), (int)
.NE
\fIinputb\fR (multiple), (int)
.NE
\fIsel\fR (multiple), (int)
.PE
.OH
.NE
\fIoutput\fR (multiple), (int)
.PE
.SH
.NE
\fIdelay\fR (IntState): internal delay in nanoseconds
.DF "10"
.ET
.EQ
delim $$
.EN
.LD
This is a simple ALU that has several arithmetic (addition, subtraction) and
bitwise logical (shift, logic) operations.  The 4-bit wide "sel" input deter-
mines the function performed by the ALU.  Inputs are sampled and outputs are
calculated at the rising edges of the clock after an user-specified internal
delay.  Note that the input and output buses should have the same bus width
or error messages are printed.

The following is a table listing the functions provided by this ALU:

sel = "0000"  :   Output = A + B
      "0001"  :   Output = A - B

      "0010"  :   Output = A << B,  zeros are used to pad
      "0011"  :   Output = A >> B,  zeros are used to pad
      "0100"  :   Output = A >> B,  sign bit is used to pad

      "0101"  :   Output = A and B
      "0110"  :   Output = A nand B
      "0111"  :   Output = A or B
      "1000"  :   Output = A nor B
      "1001"  :   Output = A xor B
      "1010"  :   Output = not A
.ES
