.EQ
delim off
.EN
.\" documentation file generated from VHDLBBusToNum.pl by ptlang
.\" Copyright (c) 1990-1996 The Regents of the University of California.
.\" All rights reserved.
.\" See the file $PTOLEMY/copyright for copyright notice,
.\" limitation of liability, and disclaimer of warranty provisions.
.NA "BusToNum"
.SD
This star accepts a variable-width input array of bits representing an 
integer (MSB is sign bit, but not 2's complement) and outputs this integer.
If any of the input bits is tri-state (value 3), then the previous value is
sent to the output.
.SE
.LO "New_Stars directory"
.DM VHDLB VHDLBStar
.AL "Wei-Lun Tsai"
.IH
.NE
\fIinput\fR (multiple), (int)
.PE
.OH
.NE
\fIoutput\fR (int)
.PE
.SH
.NE
\fIprevious\fR (IntState): previous value of output
.DF "0"
.ET
.EQ
delim $$
.EN
.LD
Sometimes it is necessary to convert the data representation in a digital
circuit (a value on a bus) to a number that can be used by components at
a more abstract level.  This star allows the user to convert a bus value
(which may be received from a digital circuit) to an equivalent integer which
can be used by other processing stars which simply expects abstract values
at their input ports.  The MSB (most significant bit) is the sign bit.  Note
that this star will not understand 2`s-complement inputs.  This star is the
counter-part of the "NumToBus" star in the VHDLF domain.
.ES
