static const char file_id[] = "VHDLBALU.pl";
// .cc file generated from VHDLBALU.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLBALU.h"

const char *star_nm_VHDLBALU = "VHDLBALU";

const char* VHDLBALU :: className() const {return star_nm_VHDLBALU;}

ISA_FUNC(VHDLBALU,VHDLBStar);

Block* VHDLBALU :: makeNew() const { LOG_NEW; return new VHDLBALU;}

VHDLBALU::VHDLBALU ()
{
	setDescriptor("A simple ALU.");
	addState(delay.setState("delay",this,"10","internal delay in nanoseconds"));
	addPort(clock.setPort("clock",this,INT));
	addPort(inputa.setPort("inputa",this,INT));
	addPort(inputb.setPort("inputb",this,INT));
	addPort(sel.setPort("sel",this,INT));
	addPort(output.setPort("output",this,INT));


}

void VHDLBALU::setup() {
# line 90 "VHDLBALU.pl"
int a_width = 0;  // Input A's bus width
		int b_width = 0;  // Input B's bus width
		int o_width = 0;  // Output's bus width
		int s_width = 0;  // Selector's bus width

		CBlockMPHIter starMPHIter(*this);
		const MultiVHDLBPort* mph;

		while((mph = (const MultiVHDLBPort*) starMPHIter++) != 0) {
		  if( !strcmp(mph->name(),"inputa") )
		    a_width = mph->numberPorts();
		  else if( !strcmp(mph->name(),"inputb") )
                    b_width = mph->numberPorts();
		  else if( !strcmp(mph->name(),"output") )
                    o_width = mph->numberPorts();
		  else if( !strcmp(mph->name(),"sel") )
                    s_width = mph->numberPorts();
		}

		if( a_width != b_width )
                  Error::abortRun(*this, "Mismatched input bus widths in ALU");

		if( s_width != 4 )
		  Error::abortRun(*this, "Selector bus width must be 4");

		if( o_width != a_width )
		  Error::abortRun(*this, "Wrong output bus width in ALU");
}

void VHDLBALU::go() {
# line 119 "VHDLBALU.pl"
}


const char* VHDLBALU::portWidthName (const MultiVHDLBPort* pp)
{
# line 70 "VHDLBALU.pl"
if(!strcmp(pp->name(),"inputa")) {
			  return((const char*) "A_WIDTH");
			}
			else if(!strcmp(pp->name(),"inputb")) {
			  return((const char*) "B_WIDTH");
			}
			else if(!strcmp(pp->name(),"output")) {
			  return((const char*) "O_WIDTH");
			}
			else if(!strcmp(pp->name(),"sel")) {
			  return((const char*) "S_WIDTH");
			}
                        else {
			  Error::abortRun(*this, "No MultiVHDLBPort named",
					  pp->name(), "in star");
			  return((const char*) "ERROR");
			}
}


// prototype instance for known block list
static VHDLBALU proto;
static RegisterBlock registerBlock(proto,"ALU");
