static const char file_id[] = "VHDLBBFork.pl";
// .cc file generated from VHDLBBFork.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLBBFork.h"

const char *star_nm_VHDLBBFork = "VHDLBBFork";

const char* VHDLBBFork :: className() const {return star_nm_VHDLBBFork;}

ISA_FUNC(VHDLBBFork,VHDLBStar);

Block* VHDLBBFork :: makeNew() const { LOG_NEW; return new VHDLBBFork;}

VHDLBBFork::VHDLBBFork ()
{
	setDescriptor("Makes two copies of a bus, since Ptolemy doesn't allow multiple connections\nfrom a bus.");
	addPort(input.setPort("input",this,INT));
	addPort(outputa.setPort("outputa",this,INT));
	addPort(outputb.setPort("outputb",this,INT));


}

void VHDLBBFork::setup() {
# line 59 "VHDLBBFork.pl"
int i_width = 0;  // Input bus width
		int a_width = 0;  // Output A width
		int b_width = 0;  // Output B width

                CBlockMPHIter starMPHIter(*this);
                const MultiVHDLBPort* mph;

                while((mph = (const MultiVHDLBPort*) starMPHIter++) != 0) {
                  if( !strcmp(mph->name(),"input") )
                    i_width = mph->numberPorts();
		  else if( !strcmp(mph->name(),"outputa") )
		    a_width = mph->numberPorts();
		  else if( !strcmp(mph->name(),"outputb") )
		    b_width = mph->numberPorts();
                }

		if( a_width != b_width )
		  Error::abortRun(*this, "Output bus widths are inconsistent!");

                if( i_width != a_width )
                  Error::abortRun(*this, "Output bus widths are inconsistent!");
}

void VHDLBBFork::go() {
# line 82 "VHDLBBFork.pl"
}


const char* VHDLBBFork::portWidthName (const MultiVHDLBPort* pp)
{
# line 42 "VHDLBBFork.pl"
if(!strcmp(pp->name(),"input")) {
                          return((const char*) "I_WIDTH");
                        }
			else if(!strcmp(pp->name(),"outputa")) {
			  return((const char*) "A_WIDTH");
			}
			else if(!strcmp(pp->name(),"outputb")) {
			  return((const char*) "B_WIDTH");
			}
                        else {
                          Error::abortRun(*this, "No MultiVHDLBPort named",
                                          pp->name(), "in star");
                          return((const char*) "ERROR");
                        }
}


// prototype instance for known block list
static VHDLBBFork proto;
static RegisterBlock registerBlock(proto,"BFork");
