static const char file_id[] = "VHDLBBSplit.pl";
// .cc file generated from VHDLBBSplit.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLBBSplit.h"

const char *star_nm_VHDLBBSplit = "VHDLBBSplit";

const char* VHDLBBSplit :: className() const {return star_nm_VHDLBBSplit;}

ISA_FUNC(VHDLBBSplit,VHDLBStar);

Block* VHDLBBSplit :: makeNew() const { LOG_NEW; return new VHDLBBSplit;}

VHDLBBSplit::VHDLBBSplit ()
{
	setDescriptor("Splits a bus into two parts.  Note that the total output widths must add up to\nthe input width.");
	addPort(input.setPort("input",this,INT));
	addPort(top.setPort("top",this,INT));
	addPort(bottom.setPort("bottom",this,INT));


}

void VHDLBBSplit::setup() {
# line 59 "VHDLBBSplit.pl"
int i_width = 0;  // Input bus width
		int a_width = 0;  // Output A width
		int b_width = 0;  // Output B width

                CBlockMPHIter starMPHIter(*this);
                const MultiVHDLBPort* mph;

                while((mph = (const MultiVHDLBPort*) starMPHIter++) != 0) {
                  if( !strcmp(mph->name(),"input") )
                    i_width = mph->numberPorts();
		  else if( !strcmp(mph->name(),"top") )
		    a_width = mph->numberPorts();
		  else if( !strcmp(mph->name(),"bottom") )
		    b_width = mph->numberPorts();
                }

                if( i_width != (a_width + b_width) )
                  Error::abortRun(*this, "Output bus widths are inconsistent!");
}

void VHDLBBSplit::go() {
# line 79 "VHDLBBSplit.pl"
}


const char* VHDLBBSplit::portWidthName (const MultiVHDLBPort* pp)
{
# line 42 "VHDLBBSplit.pl"
if(!strcmp(pp->name(),"input")) {
                          return((const char*) "I_WIDTH");
                        }
			else if(!strcmp(pp->name(),"top")) {
			  return((const char*) "A_WIDTH");
			}
			else if(!strcmp(pp->name(),"bottom")) {
			  return((const char*) "B_WIDTH");
			}
                        else {
                          Error::abortRun(*this, "No MultiVHDLBPort named",
                                          pp->name(), "in star");
                          return((const char*) "ERROR");
                        }
}


// prototype instance for known block list
static VHDLBBSplit proto;
static RegisterBlock registerBlock(proto,"BSplit");
