static const char file_id[] = "VHDLBBusToNum.pl";
// .cc file generated from VHDLBBusToNum.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLBBusToNum.h"

const char *star_nm_VHDLBBusToNum = "VHDLBBusToNum";

const char* VHDLBBusToNum :: className() const {return star_nm_VHDLBBusToNum;}

ISA_FUNC(VHDLBBusToNum,VHDLBStar);

Block* VHDLBBusToNum :: makeNew() const { LOG_NEW; return new VHDLBBusToNum;}

VHDLBBusToNum::VHDLBBusToNum ()
{
	setDescriptor("This star accepts a variable-width input array of bits representing an \ninteger (MSB is sign bit, but not 2's complement) and outputs this integer.\nIf any of the input bits is tri-state (value 3), then the previous value is\nsent to the output.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(previous.setState("previous",this,"0","previous value of output"));


}

void VHDLBBusToNum::setup() {
# line 60 "VHDLBBusToNum.pl"
int i_width = 0;  // Input's bus width

                CBlockMPHIter starMPHIter(*this);
                const MultiVHDLBPort* mph;

                while((mph = (const MultiVHDLBPort*) starMPHIter++) != 0) {
                  if( !strcmp(mph->name(),"input") )
                    i_width = mph->numberPorts();
                }

                if( i_width > 32 )
                  Error::abortRun(*this, "Input exceeds proper integer word length of 32!");
}

void VHDLBBusToNum::go() {
# line 74 "VHDLBBusToNum.pl"
}


const char* VHDLBBusToNum::portWidthName (const MultiVHDLBPort* pp)
{
# line 49 "VHDLBBusToNum.pl"
if(!strcmp(pp->name(),"input")) {
                          return((const char*) "I_WIDTH");
                        }
                        else {
                          Error::abortRun(*this, "No MultiVHDLBPort named",
                                          pp->name(), "in star");
                          return((const char*) "ERROR");
                        }
}


// prototype instance for known block list
static VHDLBBusToNum proto;
static RegisterBlock registerBlock(proto,"BusToNum");
