static const char file_id[] = "VHDLBComparator.pl";
// .cc file generated from VHDLBComparator.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLBComparator.h"

const char *star_nm_VHDLBComparator = "VHDLBComparator";

const char* VHDLBComparator :: className() const {return star_nm_VHDLBComparator;}

ISA_FUNC(VHDLBComparator,VHDLBStar);

Block* VHDLBComparator :: makeNew() const { LOG_NEW; return new VHDLBComparator;}

VHDLBComparator::VHDLBComparator ()
{
	setDescriptor("Compares two inputs and generates an 1-bit output.  hi = equal, lo = unequal.");
	addState(delay.setState("delay",this,"1","Propagation delay in nanoseconds"));
	addPort(inputa.setPort("inputa",this,INT));
	addPort(inputb.setPort("inputb",this,INT));
	addPort(output.setPort("output",this,INT));


}

void VHDLBComparator::setup() {
# line 60 "VHDLBComparator.pl"
int a_width = 0;  // Input A's bus width
		int b_width = 0;  // Input B's bus width

		CBlockMPHIter starMPHIter(*this);
		const MultiVHDLBPort* mph;

		while((mph = (const MultiVHDLBPort*) starMPHIter++) != 0) {
		  if( !strcmp(mph->name(),"inputa") )
		    a_width = mph->numberPorts();
		  else if( !strcmp(mph->name(),"inputb") )
                    b_width = mph->numberPorts();
		}

		if( a_width != b_width )
                  Error::abortRun(*this, "Mismatched input bus widths in comparator");
}

void VHDLBComparator::go() {
# line 77 "VHDLBComparator.pl"
}


const char* VHDLBComparator::portWidthName (const MultiVHDLBPort* pp)
{
# line 46 "VHDLBComparator.pl"
if(!strcmp(pp->name(),"inputa")) {
			  return((const char*) "A_WIDTH");
			}
			else if(!strcmp(pp->name(),"inputb")) {
			  return((const char*) "B_WIDTH");
			}
                        else {
			  Error::abortRun(*this, "No MultiVHDLBPort named",
					  pp->name(), "in star");
			  return((const char*) "ERROR");
			}
}


// prototype instance for known block list
static VHDLBComparator proto;
static RegisterBlock registerBlock(proto,"Comparator");
