static const char file_id[] = "VHDLBCounter.pl";
// .cc file generated from VHDLBCounter.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLBCounter.h"

const char *star_nm_VHDLBCounter = "VHDLBCounter";

const char* VHDLBCounter :: className() const {return star_nm_VHDLBCounter;}

ISA_FUNC(VHDLBCounter,VHDLBStar);

Block* VHDLBCounter :: makeNew() const { LOG_NEW; return new VHDLBCounter;}

VHDLBCounter::VHDLBCounter ()
{
	setDescriptor("This is a simple up-down 8-bit counter.");
	addState(delay.setState("delay",this,"1","internal delay in nanoseconds"));
	addPort(clock.setPort("clock",this,INT));
	addPort(enable.setPort("enable",this,INT));
	addPort(reset.setPort("reset",this,INT));
	addPort(up_down.setPort("up_down",this,INT));
	addPort(output.setPort("output",this,INT));


}

void VHDLBCounter::setup() {
# line 74 "VHDLBCounter.pl"
int o_width = 0;  // Output's bus width (has to be 8)

		CBlockMPHIter starMPHIter(*this);
		const MultiVHDLBPort* mph;

		while((mph = (const MultiVHDLBPort*) starMPHIter++) != 0) {
		  if( !strcmp(mph->name(),"output") )
		    o_width = mph->numberPorts();
		}

		if( o_width != 8 )
		  Error::abortRun(*this, "Wrong output bus width in counter");
}

void VHDLBCounter::go() {
# line 88 "VHDLBCounter.pl"
}


const char* VHDLBCounter::portWidthName (const MultiVHDLBPort* pp)
{
# line 63 "VHDLBCounter.pl"
if(!strcmp(pp->name(),"output")) {
			  return((const char*) "O_WIDTH");
			}
                        else {
			  Error::abortRun(*this, "No MultiVHDLBPort named",
					  pp->name(), "in star");
			  return((const char*) "ERROR");
			}
}


// prototype instance for known block list
static VHDLBCounter proto;
static RegisterBlock registerBlock(proto,"Counter");
