static const char file_id[] = "VHDLBDirichlet.pl";
// .cc file generated from VHDLBDirichlet.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLBDirichlet.h"

const char *star_nm_VHDLBDirichlet = "VHDLBDirichlet";

const char* VHDLBDirichlet :: className() const {return star_nm_VHDLBDirichlet;}

ISA_FUNC(VHDLBDirichlet,VHDLBStar);

Block* VHDLBDirichlet :: makeNew() const { LOG_NEW; return new VHDLBDirichlet;}

VHDLBDirichlet::VHDLBDirichlet ()
{
	setDescriptor("This star computes the normalized Dirichlet kernel (also called the aliased\nsinc function):\n\nd(x) = sin(N x / 2) / (N sin(x/2))\n\nThe value of the normalized Dirichlet kernel at x = 0 is always 1, and the\nnormalized Dirichlet kernel oscillates between -1 and +1.\nThe normalized Dirichlet kernel is periodic in x with a period of either\n2*pi when N is odd or 4*pi when N is even.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,FLOAT));
	addState(N.setState("N",this,"10","Length of the Dirichlet kernel"));


}

void VHDLBDirichlet::go() {
# line 48 "VHDLBDirichlet.pl"
}

// prototype instance for known block list
static VHDLBDirichlet proto;
static RegisterBlock registerBlock(proto,"Dirichlet");
