static const char file_id[] = "VHDLBNumToBus.pl";
// .cc file generated from VHDLBNumToBus.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "VHDLBNumToBus.h"

const char *star_nm_VHDLBNumToBus = "VHDLBNumToBus";

const char* VHDLBNumToBus :: className() const {return star_nm_VHDLBNumToBus;}

ISA_FUNC(VHDLBNumToBus,VHDLBStar);

Block* VHDLBNumToBus :: makeNew() const { LOG_NEW; return new VHDLBNumToBus;}

VHDLBNumToBus::VHDLBNumToBus ()
{
	setDescriptor("This star accepts an integer and outputs either a 32-bit, 16-bit, or 8-bit\nwide array which represents the integer, with the MSB being the sign bit.\nMay need additional bus-splits at the output to extract individual bits.");
	addPort(input.setPort("input",this,INT));
	addPort(output.setPort("output",this,INT));
	addState(width.setState("width",this,"32","Maybe either 32, 16, or 8 bits wide"));


}

void VHDLBNumToBus::setup() {
# line 58 "VHDLBNumToBus.pl"
if( width != 8 ) {
		  if( width != 16 ) {
		    if( width != 32 )
                      Error::abortRun(*this, "Output bus width in num_to_bus must be either 16 or 32");
		  }
		}

                int o_width = 0;  // Output's bus width

                CBlockMPHIter starMPHIter(*this);
                const MultiVHDLBPort* mph;

                while((mph = (const MultiVHDLBPort*) starMPHIter++) != 0) {
                  if( !strcmp(mph->name(),"output") )
                    o_width = mph->numberPorts();
                }

                if( o_width != width )
                  Error::abortRun(*this, "Wrong output bus width in num_to_bus conversion");
}

void VHDLBNumToBus::go() {
# line 79 "VHDLBNumToBus.pl"
}


const char* VHDLBNumToBus::portWidthName (const MultiVHDLBPort* pp)
{
# line 47 "VHDLBNumToBus.pl"
if(!strcmp(pp->name(),"output")) {
                          return((const char*) "O_WIDTH");
                        }
                        else {
                          Error::abortRun(*this, "No MultiVHDLBPort named",
                                          pp->name(), "in star");
                          return((const char*) "ERROR");
                        }
}


// prototype instance for known block list
static VHDLBNumToBus proto;
static RegisterBlock registerBlock(proto,"NumToBus");
